/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/base/common/types","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/platform","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/base/common/map","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function(B){for(var i=[],D=0,b=B.length;D<b;D++)i[D]=Q[B[D]];return i};define(Q[68],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.assertNever=i.ok=void 0;function D(w,O){if(!w)throw new Error(O?`Assertion failed (${O})`:"Assertion Failed")}i.ok=D;function b(w,O="Unreachable"){throw new Error(O)}i.assertNever=b}),define(Q[49],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function D(L){return(p,c,d)=>{let C=null,E=null;if(typeof d.value=="function"?(C="value",E=d.value):typeof d.get=="function"&&(C="get",E=d.get),!E)throw new Error("not supported");d[C]=L(E,c)}}i.createDecorator=D;function b(L,p,c){let d=null,C=null;if(typeof c.value=="function"?(d="value",C=c.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(d="get",C=c.get),!C)throw new Error("not supported");const E=`$memoize$${p}`;c[d]=function(...h){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,h)}),this[E]}}i.memoize=b;function w(L,p,c){return D((d,C)=>{const E=`$debounce$${C}`,h=`$debounce$result$${C}`;return function(...v){this[h]||(this[h]=c?c():void 0),clearTimeout(this[E]),p&&(this[h]=p(this[h],...v),v=[this[h]]),this[E]=setTimeout(()=>{d.apply(this,v),this[h]=c?c():void 0},L)}})}i.debounce=w;function O(L,p,c){return D((d,C)=>{const E=`$throttle$timer$${C}`,h=`$throttle$result$${C}`,v=`$throttle$lastRun$${C}`,f=`$throttle$pending$${C}`;return function(...m){if(this[h]||(this[h]=c?c():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),p&&(this[h]=p(this[h],...m)),this[f])return;const y=this[v]+L;y<=Date.now()?(this[v]=Date.now(),d.apply(this,[this[h]]),this[h]=c?c():void 0):(this[f]=!0,this[E]=setTimeout(()=>{this[f]=!1,this[v]=Date.now(),d.apply(this,[this[h]]),this[h]=c?c():void 0},y-Date.now()))}})}i.throttle=O}),define(Q[50],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var D;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(D=i.ScanError||(i.ScanError={}));var b;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(b=i.SyntaxKind||(i.SyntaxKind={}));var w;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(w=i.ParseErrorCode||(i.ParseErrorCode={}));var O;(function(e){e.DEFAULT={allowTrailingComma:!0}})(O=i.ParseOptions||(i.ParseOptions={}));function L(e,n=!1){let t=0;const r=e.length;let o="",S=0,P=16,I=0;function k(ne){let fe=0,le=0;for(;fe<ne;){const ie=e.charCodeAt(t);if(ie>=48&&ie<=57)le=le*16+ie-48;else if(ie>=65&&ie<=70)le=le*16+ie-65+10;else if(ie>=97&&ie<=102)le=le*16+ie-97+10;else break;t++,fe++}return fe<ne&&(le=-1),le}function V(ne){t=ne,o="",S=0,P=16,I=0}function G(){const ne=t;if(e.charCodeAt(t)===48)t++;else for(t++;t<e.length&&d(e.charCodeAt(t));)t++;if(t<e.length&&e.charCodeAt(t)===46)if(t++,t<e.length&&d(e.charCodeAt(t)))for(t++;t<e.length&&d(e.charCodeAt(t));)t++;else return I=3,e.substring(ne,t);let fe=t;if(t<e.length&&(e.charCodeAt(t)===69||e.charCodeAt(t)===101))if(t++,(t<e.length&&e.charCodeAt(t)===43||e.charCodeAt(t)===45)&&t++,t<e.length&&d(e.charCodeAt(t))){for(t++;t<e.length&&d(e.charCodeAt(t));)t++;fe=t}else I=3;return e.substring(ne,fe)}function Y(){let ne="",fe=t;for(;;){if(t>=r){ne+=e.substring(fe,t),I=2;break}const le=e.charCodeAt(t);if(le===34){ne+=e.substring(fe,t),t++;break}if(le===92){if(ne+=e.substring(fe,t),t++,t>=r){I=2;break}switch(e.charCodeAt(t++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const W=k(4);W>=0?ne+=String.fromCharCode(W):I=4;break}default:I=5}fe=t;continue}if(le>=0&&le<=31)if(c(le)){ne+=e.substring(fe,t),I=2;break}else I=6;t++}return ne}function X(){if(o="",I=0,S=t,t>=r)return S=r,P=17;let ne=e.charCodeAt(t);if(p(ne)){do t++,o+=String.fromCharCode(ne),ne=e.charCodeAt(t);while(p(ne));return P=15}if(c(ne))return t++,o+=String.fromCharCode(ne),ne===13&&e.charCodeAt(t)===10&&(t++,o+=`
`),P=14;switch(ne){case 123:return t++,P=1;case 125:return t++,P=2;case 91:return t++,P=3;case 93:return t++,P=4;case 58:return t++,P=6;case 44:return t++,P=5;case 34:return t++,o=Y(),P=10;case 47:{const fe=t-1;if(e.charCodeAt(t+1)===47){for(t+=2;t<r&&!c(e.charCodeAt(t));)t++;return o=e.substring(fe,t),P=12}if(e.charCodeAt(t+1)===42){t+=2;const le=r-1;let ie=!1;for(;t<le;){if(e.charCodeAt(t)===42&&e.charCodeAt(t+1)===47){t+=2,ie=!0;break}t++}return ie||(t++,I=1),o=e.substring(fe,t),P=13}return o+=String.fromCharCode(ne),t++,P=16}case 45:if(o+=String.fromCharCode(ne),t++,t===r||!d(e.charCodeAt(t)))return P=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=G(),P=11;default:for(;t<r&&se(ne);)t++,ne=e.charCodeAt(t);if(S!==t){switch(o=e.substring(S,t),o){case"true":return P=8;case"false":return P=9;case"null":return P=7}return P=16}return o+=String.fromCharCode(ne),t++,P=16}}function se(ne){if(p(ne)||c(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let ne;do ne=X();while(ne>=12&&ne<=15);return ne}return{setPosition:V,getPosition:()=>t,scan:n?oe:X,getToken:()=>P,getTokenValue:()=>o,getTokenOffset:()=>S,getTokenLength:()=>t-S,getTokenError:()=>I}}i.createScanner=L;function p(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function c(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var C;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(C||(C={}));function E(e,n){const t=[],r=new Object;let o;const S={value:{},offset:0,length:0,type:"object",parent:void 0};let P=!1;function I(k,V,G,Y){S.value=k,S.offset=V,S.length=G,S.type=Y,S.colonOffset=void 0,o=S}try{g(e,{onObjectBegin:(k,V)=>{if(n<=k)throw r;o=void 0,P=n>k,t.push("")},onObjectProperty:(k,V,G)=>{if(n<V||(I(k,V,G,"property"),t[t.length-1]=k,n<=V+G))throw r},onObjectEnd:(k,V)=>{if(n<=k)throw r;o=void 0,t.pop()},onArrayBegin:(k,V)=>{if(n<=k)throw r;o=void 0,t.push(0)},onArrayEnd:(k,V)=>{if(n<=k)throw r;o=void 0,t.pop()},onLiteralValue:(k,V,G)=>{if(n<V||(I(k,V,G,s(k)),n<=V+G))throw r},onSeparator:(k,V,G)=>{if(n<=V)throw r;if(k===":"&&o&&o.type==="property")o.colonOffset=V,P=!1,o=void 0;else if(k===","){const Y=t[t.length-1];typeof Y=="number"?t[t.length-1]=Y+1:(P=!0,t[t.length-1]=""),o=void 0}}})}catch(k){if(k!==r)throw k}return{path:t,previousNode:o,isAtPropertyKey:P,matches:k=>{let V=0;for(let G=0;V<k.length&&G<t.length;G++)if(k[V]===t[G]||k[V]==="*")V++;else if(k[V]!=="**")return!1;return V===k.length}}}i.getLocation=E;function h(e,n=[],t=O.DEFAULT){let r=null,o=[];const S=[];function P(k){Array.isArray(o)?o.push(k):r!==null&&(o[r]=k)}return g(e,{onObjectBegin:()=>{const k={};P(k),S.push(o),o=k,r=null},onObjectProperty:k=>{r=k},onObjectEnd:()=>{o=S.pop()},onArrayBegin:()=>{const k=[];P(k),S.push(o),o=k,r=null},onArrayEnd:()=>{o=S.pop()},onLiteralValue:P,onError:(k,V,G)=>{n.push({error:k,offset:V,length:G})}},t),o[0]}i.parse=h;function v(e,n=[],t=O.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(k){r.type==="property"&&(r.length=k-r.offset,r=r.parent)}function S(k){return r.children.push(k),k}g(e,{onObjectBegin:k=>{r=S({type:"object",offset:k,length:-1,parent:r,children:[]})},onObjectProperty:(k,V,G)=>{r=S({type:"property",offset:V,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:k,offset:V,length:G,parent:r})},onObjectEnd:(k,V)=>{r.length=k+V-r.offset,r=r.parent,o(k+V)},onArrayBegin:(k,V)=>{r=S({type:"array",offset:k,length:-1,parent:r,children:[]})},onArrayEnd:(k,V)=>{r.length=k+V-r.offset,r=r.parent,o(k+V)},onLiteralValue:(k,V,G)=>{S({type:s(k),offset:V,length:G,parent:r,value:k}),o(V+G)},onSeparator:(k,V,G)=>{r.type==="property"&&(k===":"?r.colonOffset=V:k===","&&o(V))},onError:(k,V,G)=>{n.push({error:k,offset:V,length:G})}},t);const I=r.children[0];return I&&delete I.parent,I}i.parseTree=v;function f(e,n){if(!e)return;let t=e;for(const r of n)if(typeof r=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const S of t.children)if(Array.isArray(S.children)&&S.children[0].value===r){t=S.children[1],o=!0;break}if(!o)return}else{const o=r;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}i.findNodeAtLocation=f;function m(e){if(!e.parent||!e.parent.children)return[];const n=m(e.parent);if(e.parent.type==="property"){const t=e.parent.children[0].value;n.push(t)}else if(e.parent.type==="array"){const t=e.parent.children.indexOf(e);t!==-1&&n.push(t)}return n}i.getNodePath=m;function y(e){switch(e.type){case"array":return e.children.map(y);case"object":{const n=Object.create(null);for(const t of e.children){const r=t.children[1];r&&(n[t.children[0].value]=y(r))}return n}case"null":case"string":case"number":case"boolean":return e.value;default:return}}i.getNodeValue=y;function l(e,n,t=!1){return n>=e.offset&&n<e.offset+e.length||t&&n===e.offset+e.length}i.contains=l;function u(e,n,t=!1){if(l(e,n,t)){const r=e.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const S=u(r[o],n,t);if(S)return S}return e}}i.findNodeAtOffset=u;function g(e,n,t=O.DEFAULT){const r=L(e,!1);function o(A){return A?()=>A(r.getTokenOffset(),r.getTokenLength()):()=>!0}function S(A){return A?U=>A(U,r.getTokenOffset(),r.getTokenLength()):()=>!0}const P=o(n.onObjectBegin),I=S(n.onObjectProperty),k=o(n.onObjectEnd),V=o(n.onArrayBegin),G=o(n.onArrayEnd),Y=S(n.onLiteralValue),X=S(n.onSeparator),se=o(n.onComment),oe=S(n.onError),ne=t&&t.disallowComments,fe=t&&t.allowTrailingComma;function le(){for(;;){const A=r.scan();switch(r.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:ne||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(A){case 12:case 13:ne?ie(10):se();break;case 16:ie(1);break;case 15:case 14:break;default:return A}}}function ie(A,U=[],R=[]){if(oe(A),U.length+R.length>0){let T=r.getToken();for(;T!==17;){if(U.indexOf(T)!==-1){le();break}else if(R.indexOf(T)!==-1)break;T=le()}}}function W(A){const U=r.getTokenValue();return A?Y(U):I(U),le(),!0}function N(){switch(r.getToken()){case 11:{let A=0;try{A=JSON.parse(r.getTokenValue()),typeof A!="number"&&(ie(2),A=0)}catch{ie(2)}Y(A);break}case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return le(),!0}function F(){return r.getToken()!==10?(ie(3,[],[2,5]),!1):(W(!1),r.getToken()===6?(X(":"),le(),J()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function z(){P(),le();let A=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(A||ie(4,[],[]),X(","),le(),r.getToken()===2&&fe)break}else A&&ie(6,[],[]);F()||ie(4,[],[2,5]),A=!0}return k(),r.getToken()!==2?ie(7,[2],[]):le(),!0}function $(){V(),le();let A=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(A||ie(4,[],[]),X(","),le(),r.getToken()===4&&fe)break}else A&&ie(6,[],[]);J()||ie(4,[],[4,5]),A=!0}return G(),r.getToken()!==4?ie(8,[4],[]):le(),!0}function J(){switch(r.getToken()){case 3:return $();case 1:return z();case 10:return W(!0);default:return N()}}return le(),r.getToken()===17?t.allowEmptyContent?!0:(ie(4,[],[]),!1):J()?(r.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}i.visit=g;function a(e,n){const t=L(e),r=[];let o,S=0,P;do switch(P=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:S!==P&&r.push(e.substring(S,P)),n!==void 0&&r.push(t.getTokenValue().replace(/[^\r\n]/g,n)),S=t.getPosition();break}while(o!==17);return r.join("")}i.stripComments=a;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=s}),function(){function B(w){const O=[];typeof w=="number"&&O.push("code/timeOrigin",w);function L(c){O.push(c,Date.now())}function p(){const c=[];for(let d=0;d<O.length;d+=2)c.push({name:O[d],startTime:O[d+1]});return c}return{mark:L,getMarks:p}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?B():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const L of performance.getEntriesByType("mark"))O.push({name:L.name,startTime:Math.round(w+L.startTime)});return O}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return B(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),B()}function D(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=i()),w.MonacoPerformanceMarks}var b;typeof global=="object"?b=global:typeof self=="object"?b=self:b={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(b)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(b):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),b.perf=D(b))}(),function(B,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var D=i();for(var b in D)(typeof exports=="object"?exports:B)[b]=D[b]}}(typeof self<"u"?self:this,function(){return function(B){var i={};function D(b){if(i[b])return i[b].exports;var w=i[b]={i:b,l:!1,exports:{}};return B[b].call(w.exports,w,w.exports,D),w.l=!0,w.exports}return D.m=B,D.c=i,D.d=function(b,w,O){D.o(b,w)||Object.defineProperty(b,w,{enumerable:!0,get:O})},D.r=function(b){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(b,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(b,"__esModule",{value:!0})},D.t=function(b,w){if(1&w&&(b=D(b)),8&w||4&w&&typeof b=="object"&&b&&b.__esModule)return b;var O=Object.create(null);if(D.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:b}),2&w&&typeof b!="string")for(var L in b)D.d(O,L,function(p){return b[p]}.bind(null,L));return O},D.n=function(b){var w=b&&b.__esModule?function(){return b.default}:function(){return b};return D.d(w,"a",w),w},D.o=function(b,w){return Object.prototype.hasOwnProperty.call(b,w)},D.p="",D(D.s=0)}([function(B,i,D){(function(b){var w;i=B.exports=R,w=typeof b=="object"&&b.env&&b.env.NODE_DEBUG&&/\bsemver\b/i.test(b.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var O=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,p=i.re=[],c=i.src=[],d=0,C=d++;c[C]="0|[1-9]\\d*";var E=d++;c[E]="[0-9]+";var h=d++;c[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=d++;c[v]="("+c[C]+")\\.("+c[C]+")\\.("+c[C]+")";var f=d++;c[f]="("+c[E]+")\\.("+c[E]+")\\.("+c[E]+")";var m=d++;c[m]="(?:"+c[C]+"|"+c[h]+")";var y=d++;c[y]="(?:"+c[E]+"|"+c[h]+")";var l=d++;c[l]="(?:-("+c[m]+"(?:\\."+c[m]+")*))";var u=d++;c[u]="(?:-?("+c[y]+"(?:\\."+c[y]+")*))";var g=d++;c[g]="[0-9A-Za-z-]+";var a=d++;c[a]="(?:\\+("+c[g]+"(?:\\."+c[g]+")*))";var s=d++,e="v?"+c[v]+c[l]+"?"+c[a]+"?";c[s]="^"+e+"$";var n="[v=\\s]*"+c[f]+c[u]+"?"+c[a]+"?",t=d++;c[t]="^"+n+"$";var r=d++;c[r]="((?:<|>)?=?)";var o=d++;c[o]=c[E]+"|x|X|\\*";var S=d++;c[S]=c[C]+"|x|X|\\*";var P=d++;c[P]="[v=\\s]*("+c[S]+")(?:\\.("+c[S]+")(?:\\.("+c[S]+")(?:"+c[l]+")?"+c[a]+"?)?)?";var I=d++;c[I]="[v=\\s]*("+c[o]+")(?:\\.("+c[o]+")(?:\\.("+c[o]+")(?:"+c[u]+")?"+c[a]+"?)?)?";var k=d++;c[k]="^"+c[r]+"\\s*"+c[P]+"$";var V=d++;c[V]="^"+c[r]+"\\s*"+c[I]+"$";var G=d++;c[G]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var Y=d++;c[Y]="(?:~>?)";var X=d++;c[X]="(\\s*)"+c[Y]+"\\s+",p[X]=new RegExp(c[X],"g");var se=d++;c[se]="^"+c[Y]+c[P]+"$";var oe=d++;c[oe]="^"+c[Y]+c[I]+"$";var ne=d++;c[ne]="(?:\\^)";var fe=d++;c[fe]="(\\s*)"+c[ne]+"\\s+",p[fe]=new RegExp(c[fe],"g");var le=d++;c[le]="^"+c[ne]+c[P]+"$";var ie=d++;c[ie]="^"+c[ne]+c[I]+"$";var W=d++;c[W]="^"+c[r]+"\\s*("+n+")$|^$";var N=d++;c[N]="^"+c[r]+"\\s*("+e+")$|^$";var F=d++;c[F]="(\\s*)"+c[r]+"\\s*("+n+"|"+c[P]+")",p[F]=new RegExp(c[F],"g");var z=d++;c[z]="^\\s*("+c[P]+")\\s+-\\s+("+c[P]+")\\s*$";var $=d++;c[$]="^\\s*("+c[I]+")\\s+-\\s+("+c[I]+")\\s*$";var J=d++;c[J]="(<|>)?=?\\s*\\*";for(var A=0;A<35;A++)w(A,c[A]),p[A]||(p[A]=new RegExp(c[A]));function U(x,q){if(x instanceof R)return x;if(typeof x!="string"||x.length>O||!(q?p[t]:p[s]).test(x))return null;try{return new R(x,q)}catch{return null}}function R(x,q){if(x instanceof R){if(x.loose===q)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof R))return new R(x,q);w("SemVer",x,q),this.loose=q;var K=x.trim().match(q?p[t]:p[s]);if(!K)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(ue){if(/^[0-9]+$/.test(ue)){var me=+ue;if(me>=0&&me<L)return me}return ue}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}i.parse=U,i.valid=function(x,q){var K=U(x,q);return K?K.version:null},i.clean=function(x,q){var K=U(x.trim().replace(/^[=v]+/,""),q);return K?K.version:null},i.SemVer=R,R.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},R.prototype.toString=function(){return this.version},R.prototype.compare=function(x){return w("SemVer.compare",this.version,this.loose,x),x instanceof R||(x=new R(x,this.loose)),this.compareMain(x)||this.comparePre(x)},R.prototype.compareMain=function(x){return x instanceof R||(x=new R(x,this.loose)),M(this.major,x.major)||M(this.minor,x.minor)||M(this.patch,x.patch)},R.prototype.comparePre=function(x){if(x instanceof R||(x=new R(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var q=0;do{var K=this.prerelease[q],ue=x.prerelease[q];if(w("prerelease compare",q,K,ue),K===void 0&&ue===void 0)return 0;if(ue===void 0)return 1;if(K===void 0)return-1;if(K!==ue)return M(K,ue)}while(++q)},R.prototype.inc=function(x,q){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",q),this.inc("pre",q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",q),this.inc("pre",q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}q&&(this.prerelease[0]===q?isNaN(this.prerelease[1])&&(this.prerelease=[q,0]):this.prerelease=[q,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},i.inc=function(x,q,K,ue){typeof K=="string"&&(ue=K,K=void 0);try{return new R(x,K).inc(q,ue).version}catch{return null}},i.diff=function(x,q){if(ae(x,q))return null;var K=U(x),ue=U(q);if(K.prerelease.length||ue.prerelease.length){for(var me in K)if((me==="major"||me==="minor"||me==="patch")&&K[me]!==ue[me])return"pre"+me;return"prerelease"}for(var me in K)if((me==="major"||me==="minor"||me==="patch")&&K[me]!==ue[me])return me},i.compareIdentifiers=M;var T=/^[0-9]+$/;function M(x,q){var K=T.test(x),ue=T.test(q);return K&&ue&&(x=+x,q=+q),K&&!ue?-1:ue&&!K?1:x<q?-1:x>q?1:0}function j(x,q,K){return new R(x,K).compare(new R(q,K))}function _(x,q,K){return j(x,q,K)>0}function H(x,q,K){return j(x,q,K)<0}function ae(x,q,K){return j(x,q,K)===0}function ce(x,q,K){return j(x,q,K)!==0}function pe(x,q,K){return j(x,q,K)>=0}function ve(x,q,K){return j(x,q,K)<=0}function te(x,q,K,ue){var me;switch(q){case"===":typeof x=="object"&&(x=x.version),typeof K=="object"&&(K=K.version),me=x===K;break;case"!==":typeof x=="object"&&(x=x.version),typeof K=="object"&&(K=K.version),me=x!==K;break;case"":case"=":case"==":me=ae(x,K,ue);break;case"!=":me=ce(x,K,ue);break;case">":me=_(x,K,ue);break;case">=":me=pe(x,K,ue);break;case"<":me=H(x,K,ue);break;case"<=":me=ve(x,K,ue);break;default:throw new TypeError("Invalid operator: "+q)}return me}function re(x,q){if(x instanceof re){if(x.loose===q)return x;x=x.value}if(!(this instanceof re))return new re(x,q);w("comparator",x,q),this.loose=q,this.parse(x),this.semver===de?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}i.rcompareIdentifiers=function(x,q){return M(q,x)},i.major=function(x,q){return new R(x,q).major},i.minor=function(x,q){return new R(x,q).minor},i.patch=function(x,q){return new R(x,q).patch},i.compare=j,i.compareLoose=function(x,q){return j(x,q,!0)},i.rcompare=function(x,q,K){return j(q,x,K)},i.sort=function(x,q){return x.sort(function(K,ue){return i.compare(K,ue,q)})},i.rsort=function(x,q){return x.sort(function(K,ue){return i.rcompare(K,ue,q)})},i.gt=_,i.lt=H,i.eq=ae,i.neq=ce,i.gte=pe,i.lte=ve,i.cmp=te,i.Comparator=re;var de={};function ge(x,q){if(x instanceof ge)return x.loose===q?x:new ge(x.raw,q);if(x instanceof re)return new ge(x.value,q);if(!(this instanceof ge))return new ge(x,q);if(this.loose=q,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Se(x){return!x||x.toLowerCase()==="x"||x==="*"}function Te(x,q,K,ue,me,Ce,we,Le,be,De,Me,Re,Oe){return((q=Se(K)?"":Se(ue)?">="+K+".0.0":Se(me)?">="+K+"."+ue+".0":">="+q)+" "+(Le=Se(be)?"":Se(De)?"<"+(+be+1)+".0.0":Se(Me)?"<"+be+"."+(+De+1)+".0":Re?"<="+be+"."+De+"."+Me+"-"+Re:"<="+Le)).trim()}function Fe(x,q){for(var K=0;K<x.length;K++)if(!x[K].test(q))return!1;if(q.prerelease.length){for(K=0;K<x.length;K++)if(w(x[K].semver),x[K].semver!==de&&x[K].semver.prerelease.length>0){var ue=x[K].semver;if(ue.major===q.major&&ue.minor===q.minor&&ue.patch===q.patch)return!0}return!1}return!0}function Ue(x,q,K){try{q=new ge(q,K)}catch{return!1}return q.test(x)}function xe(x,q,K,ue){var me,Ce,we,Le,be;switch(x=new R(x,ue),q=new ge(q,ue),K){case">":me=_,Ce=ve,we=H,Le=">",be=">=";break;case"<":me=H,Ce=pe,we=_,Le="<",be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(x,q,ue))return!1;for(var De=0;De<q.set.length;++De){var Me=q.set[De],Re=null,Oe=null;if(Me.forEach(function(Ae){Ae.semver===de&&(Ae=new re(">=0.0.0")),Re=Re||Ae,Oe=Oe||Ae,me(Ae.semver,Re.semver,ue)?Re=Ae:we(Ae.semver,Oe.semver,ue)&&(Oe=Ae)}),Re.operator===Le||Re.operator===be||(!Oe.operator||Oe.operator===Le)&&Ce(x,Oe.semver)||Oe.operator===be&&we(x,Oe.semver))return!1}return!0}re.prototype.parse=function(x){var q=this.loose?p[W]:p[N],K=x.match(q);if(!K)throw new TypeError("Invalid comparator: "+x);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new R(K[2],this.loose):this.semver=de},re.prototype.toString=function(){return this.value},re.prototype.test=function(x){return w("Comparator.test",x,this.loose),this.semver===de||(typeof x=="string"&&(x=new R(x,this.loose)),te(x,this.operator,this.semver,this.loose))},re.prototype.intersects=function(x,q){if(!(x instanceof re))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new ge(x.value,q),Ue(this.value,K,q);if(x.operator==="")return K=new ge(this.value,q),Ue(x.semver,K,q);var ue=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Ce=this.semver.version===x.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Le=te(this.semver,"<",x.semver,q)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),be=te(this.semver,">",x.semver,q)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ue||me||Ce&&we||Le||be},i.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(x){var q=this.loose;x=x.trim(),w("range",x,q);var K=q?p[$]:p[z];x=x.replace(K,Te),w("hyphen replace",x),x=x.replace(p[F],"$1$2$3"),w("comparator trim",x,p[F]),x=(x=(x=x.replace(p[X],"$1~")).replace(p[fe],"$1^")).split(/\s+/).join(" ");var ue=q?p[W]:p[N],me=x.split(" ").map(function(Ce){return function(we,Le){return w("comp",we),we=function(be,De){return be.trim().split(/\s+/).map(function(Me){return function(Re,Oe){w("caret",Re,Oe);var Ae=Oe?p[ie]:p[le];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var ke;return w("caret",Re,Ne,ye,Ee,Pe,Ie),Se(ye)?ke="":Se(Ee)?ke=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(Pe)?ke=ye==="0"?">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+".0 <"+(+ye+1)+".0.0":Ie?(w("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),ke=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+Ie+" <"+(+ye+1)+".0.0"):(w("no pr"),ke=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+" <"+(+ye+1)+".0.0"),w("caret return",ke),ke})}(Me,De)}).join(" ")}(we,Le),w("caret",we),we=function(be,De){return be.trim().split(/\s+/).map(function(Me){return function(Re,Oe){var Ae=Oe?p[oe]:p[se];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var ke;return w("tilde",Re,Ne,ye,Ee,Pe,Ie),Se(ye)?ke="":Se(Ee)?ke=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(Pe)?ke=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":Ie?(w("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),ke=">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0"):ke=">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0",w("tilde return",ke),ke})}(Me,De)}).join(" ")}(we,Le),w("tildes",we),we=function(be,De){return w("replaceXRanges",be,De),be.split(/\s+/).map(function(Me){return function(Re,Oe){Re=Re.trim();var Ae=Oe?p[V]:p[k];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie,ke){w("xRange",Re,Ne,ye,Ee,Pe,Ie,ke);var We=Se(Ee),ze=We||Se(Pe),je=ze||Se(Ie);return ye==="="&&je&&(ye=""),We?Ne=ye===">"||ye==="<"?"<0.0.0":"*":ye&&je?(ze&&(Pe=0),je&&(Ie=0),ye===">"?(ye=">=",ze?(Ee=+Ee+1,Pe=0,Ie=0):je&&(Pe=+Pe+1,Ie=0)):ye==="<="&&(ye="<",ze?Ee=+Ee+1:Pe=+Pe+1),Ne=ye+Ee+"."+Pe+"."+Ie):ze?Ne=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":je&&(Ne=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),w("xRange return",Ne),Ne})}(Me,De)}).join(" ")}(we,Le),w("xrange",we),we=function(be,De){return w("replaceStars",be,De),be.trim().replace(p[J],"")}(we,Le),w("stars",we),we}(Ce,q)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Ce){return!!Ce.match(ue)})),me=me.map(function(Ce){return new re(Ce,q)})},ge.prototype.intersects=function(x,q){if(!(x instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(ue){return x.set.some(function(me){return me.every(function(Ce){return ue.intersects(Ce,q)})})})})},i.toComparators=function(x,q){return new ge(x,q).set.map(function(K){return K.map(function(ue){return ue.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new R(x,this.loose));for(var q=0;q<this.set.length;q++)if(Fe(this.set[q],x))return!0;return!1},i.satisfies=Ue,i.maxSatisfying=function(x,q,K){var ue=null,me=null;try{var Ce=new ge(q,K)}catch{return null}return x.forEach(function(we){Ce.test(we)&&(ue&&me.compare(we)!==-1||(me=new R(ue=we,K)))}),ue},i.minSatisfying=function(x,q,K){var ue=null,me=null;try{var Ce=new ge(q,K)}catch{return null}return x.forEach(function(we){Ce.test(we)&&(ue&&me.compare(we)!==1||(me=new R(ue=we,K)))}),ue},i.validRange=function(x,q){try{return new ge(x,q).range||"*"}catch{return null}},i.ltr=function(x,q,K){return xe(x,q,"<",K)},i.gtr=function(x,q,K){return xe(x,q,">",K)},i.outside=xe,i.prerelease=function(x,q){var K=U(x,q);return K&&K.prerelease.length?K.prerelease:null},i.intersects=function(x,q,K){return x=new ge(x,K),q=new ge(q,K),x.intersects(q)},i.coerce=function(x){if(x instanceof R)return x;if(typeof x!="string")return null;var q=x.match(p[G]);return q==null?null:U((q[1]||"0")+"."+(q[2]||"0")+"."+(q[3]||"0"))}}).call(this,D(1))},function(B,i){var D,b,w=B.exports={};function O(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function p(y){if(D===setTimeout)return setTimeout(y,0);if((D===O||!D)&&setTimeout)return D=setTimeout,setTimeout(y,0);try{return D(y,0)}catch{try{return D.call(null,y,0)}catch{return D.call(this,y,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:O}catch{D=O}try{b=typeof clearTimeout=="function"?clearTimeout:L}catch{b=L}})();var c,d=[],C=!1,E=-1;function h(){C&&c&&(C=!1,c.length?d=c.concat(d):E=-1,d.length&&v())}function v(){if(!C){var y=p(h);C=!0;for(var l=d.length;l;){for(c=d,d=[];++E<l;)c&&c[E].run();E=-1,l=d.length}c=null,C=!1,function(u){if(b===clearTimeout)return clearTimeout(u);if((b===L||!b)&&clearTimeout)return b=clearTimeout,clearTimeout(u);try{b(u)}catch{try{return b.call(null,u)}catch{return b.call(this,u)}}}(y)}}function f(y,l){this.fun=y,this.array=l}function m(){}w.nextTick=function(y){var l=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)l[u-1]=arguments[u];d.push(new f(y,l)),d.length!==1||C||p(v)},f.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=m,w.addListener=m,w.once=m,w.off=m,w.removeListener=m,w.removeAllListeners=m,w.emit=m,w.prependListener=m,w.prependOnceListener=m,w.listeners=function(y){return[]},w.binding=function(y){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(y){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(Q[69],Z([0,1]),function(B,i){"use strict";var D;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class b{constructor(p,c,d){this.level=p,this.key=c,this.value=d,this.forward=[]}}const w=void 0;class O{constructor(p,c=2**16){this.comparator=p,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(c)|0),this._header=new b(this._maxLevel,w,w)}get size(){return this._size}clear(){this._header=new b(this._maxLevel,w,w)}has(p){return Boolean(O._search(this,p,this.comparator))}get(p){return O._search(this,p,this.comparator)?.value}set(p,c){return O._insert(this,p,c,this.comparator)&&(this._size+=1),this}delete(p){const c=O._delete(this,p,this.comparator);return c&&(this._size-=1),c}forEach(p,c){let d=this._header.forward[0];for(;d;)p.call(c,d.value,d.key,this),d=d.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let p=this._header.forward[0];for(;p;)yield[p.key,p.value],p=p.forward[0]}*keys(){let p=this._header.forward[0];for(;p;)yield p.key,p=p.forward[0]}*values(){let p=this._header.forward[0];for(;p;)yield p.value,p=p.forward[0]}toString(){let p="[SkipList]:",c=this._header.forward[0];for(;c;)p+=`node(${c.key}, ${c.value}, lvl:${c.level})`,c=c.forward[0];return p}static _search(p,c,d){let C=p._header;for(let E=p._level-1;E>=0;E--)for(;C.forward[E]&&d(C.forward[E].key,c)<0;)C=C.forward[E];if(C=C.forward[0],C&&d(C.key,c)===0)return C}static _insert(p,c,d,C){const E=[];let h=p._header;for(let v=p._level-1;v>=0;v--){for(;h.forward[v]&&C(h.forward[v].key,c)<0;)h=h.forward[v];E[v]=h}if(h=h.forward[0],h&&C(h.key,c)===0)return h.value=d,!1;{const v=O._randomLevel(p);if(v>p._level){for(let f=p._level;f<v;f++)E[f]=p._header;p._level=v}h=new b(v,c,d);for(let f=0;f<v;f++)h.forward[f]=E[f].forward[f],E[f].forward[f]=h;return!0}}static _randomLevel(p,c=.5){let d=1;for(;Math.random()<c&&d<p._maxLevel;)d+=1;return d}static _delete(p,c,d){const C=[];let E=p._header;for(let h=p._level-1;h>=0;h--){for(;E.forward[h]&&d(E.forward[h].key,c)<0;)E=E.forward[h];C[h]=E}if(E=E.forward[0],!E||d(E.key,c)!==0)return!1;for(let h=0;h<p._level&&C[h].forward[h]===E;h++)C[h].forward[h]=E.forward[h];for(;p._level>0&&p._header.forward[p._level-1]===w;)p._level-=1;return!0}}i.SkipList=O}),define(Q[43],Z([0,1,12,2]),function(B,i,D,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=i.isReadable=void 0;function w(a){const s=a;return s?typeof s.read=="function":!1}i.isReadable=w;function O(a){const s=a;return s?[s.on,s.pause,s.resume,s.destroy].every(e=>typeof e=="function"):!1}i.isReadableStream=O;function L(a){const s=a;return s?O(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}i.isReadableBufferedStream=L;function p(a,s){return new c(a,s)}i.newWriteableStream=p;class c{constructor(s,e){this.reducer=s,this.options=e,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s<"u"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(e=>e(s))}emitError(s){this.listeners.error.length===0?(0,D.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(e=>e(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,e){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(e),this.resume();break;case"end":this.listeners.end.push(e),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(e),this.state.flowing&&this.flowErrors();break}}removeListener(s,e){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const t=n.indexOf(e);t>=0&&n.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const e=[...this.pendingWritePromises];this.pendingWritePromises.length=0,e.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(a,s){const e=[];let n;for(;(n=a.read())!==null;)e.push(n);return s(e)}i.consumeReadable=d;function C(a,s,e){const n=[];let t;for(;(t=a.read())!==null&&n.length<e;)n.push(t);return t===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof t<"u"){const r=t;return t=void 0,r}return a.read()}}}i.peekReadable=C;function E(a,s){return new Promise((e,n)=>{const t=[];h(a,{onData:r=>{s&&t.push(r)},onError:r=>{s?n(r):e(void 0)},onEnd:()=>{e(s?s(t):void 0)}})})}i.consumeStream=E;function h(a,s){let e=!1;return a.on("error",n=>{e||s.onError(n)}),a.on("end",()=>{e||s.onEnd()}),a.on("data",n=>{e||s.onData(n)}),(0,b.toDisposable)(()=>e=!0)}i.listenStream=h;function v(a,s){return new Promise((e,n)=>{const t=new b.DisposableStore,r=[],o=I=>{if(r.push(I),r.length>s)return t.dispose(),a.pause(),e({stream:a,buffer:r,ended:!1})},S=I=>n(I),P=()=>e({stream:a,buffer:r,ended:!0});t.add((0,b.toDisposable)(()=>a.removeListener("error",S))),a.on("error",S),t.add((0,b.toDisposable)(()=>a.removeListener("end",P))),a.on("end",P),t.add((0,b.toDisposable)(()=>a.removeListener("data",o))),a.on("data",o)})}i.peekStream=v;function f(a,s){const e=p(s);return e.end(a),e}i.toStream=f;function m(){const a=p(()=>{throw new Error("not supported")});return a.end(),a}i.emptyStream=m;function y(a){let s=!1;return{read:()=>s?null:(s=!0,a)}}i.toReadable=y;function l(a,s,e){const n=p(e);return h(a,{onData:t=>n.write(s.data(t)),onError:t=>n.error(s.error?s.error(t):t),onEnd:()=>n.end()}),n}i.transform=l;function u(a,s,e){let n=!1;return{read:()=>{const t=s.read();return n?t:(n=!0,t!==null?e([a,t]):a)}}}i.prefixedReadable=u;function g(a,s,e){let n=!1;const t=p(e);return h(s,{onData:r=>n?t.write(r):(n=!0,t.write(e([a,r]))),onError:r=>t.error(r),onEnd:()=>{n||(n=!0,t.write(a)),t.end()}}),t}i.prefixedStream=g}),define(Q[15],Z([0,1,43]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.encodeBase64=i.decodeBase64=i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const b=typeof Buffer<"u";let w,O;class L{constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}static alloc(I){return b?new L(Buffer.allocUnsafe(I)):new L(new Uint8Array(I))}static wrap(I){return b&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new L(I)}static fromString(I,k){return!(k?.dontUseNodeBuffer||!1)&&b?new L(Buffer.from(I)):(w||(w=new TextEncoder),new L(w.encode(I)))}static fromByteArray(I){const k=L.alloc(I.length);for(let V=0,G=I.length;V<G;V++)k.buffer[V]=I[V];return k}static concat(I,k){if(typeof k>"u"){k=0;for(let Y=0,X=I.length;Y<X;Y++)k+=I[Y].byteLength}const V=L.alloc(k);let G=0;for(let Y=0,X=I.length;Y<X;Y++){const se=I[Y];V.set(se,G),G+=se.byteLength}return V}clone(){const I=L.alloc(this.byteLength);return I.set(this),I}toString(){return b?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(I,k){return new L(this.buffer.subarray(I,k))}set(I,k){if(I instanceof L)this.buffer.set(I.buffer,k);else if(I instanceof Uint8Array)this.buffer.set(I,k);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),k);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),k);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return d(this.buffer,I)}writeUInt32BE(I,k){C(this.buffer,I,k)}readUInt32LE(I){return E(this.buffer,I)}writeUInt32LE(I,k){h(this.buffer,I,k)}readUInt8(I){return v(this.buffer,I)}writeUInt8(I,k){f(this.buffer,I,k)}}i.VSBuffer=L;function p(P,I){return P[I+0]<<0>>>0|P[I+1]<<8>>>0}i.readUInt16LE=p;function c(P,I,k){P[k+0]=I&255,I=I>>>8,P[k+1]=I&255}i.writeUInt16LE=c;function d(P,I){return P[I]*2**24+P[I+1]*2**16+P[I+2]*2**8+P[I+3]}i.readUInt32BE=d;function C(P,I,k){P[k+3]=I,I=I>>>8,P[k+2]=I,I=I>>>8,P[k+1]=I,I=I>>>8,P[k]=I}i.writeUInt32BE=C;function E(P,I){return P[I+0]<<0>>>0|P[I+1]<<8>>>0|P[I+2]<<16>>>0|P[I+3]<<24>>>0}i.readUInt32LE=E;function h(P,I,k){P[k+0]=I&255,I=I>>>8,P[k+1]=I&255,I=I>>>8,P[k+2]=I&255,I=I>>>8,P[k+3]=I&255}i.writeUInt32LE=h;function v(P,I){return P[I]}i.readUInt8=v;function f(P,I,k){P[k]=I}i.writeUInt8=f;function m(P){return D.consumeReadable(P,I=>L.concat(I))}i.readableToBuffer=m;function y(P){return D.toReadable(P)}i.bufferToReadable=y;function l(P){return D.consumeStream(P,I=>L.concat(I))}i.streamToBuffer=l;async function u(P){return P.ended?L.concat(P.buffer):L.concat([...P.buffer,await l(P.stream)])}i.bufferedStreamToBuffer=u;function g(P){return D.toStream(P,I=>L.concat(I))}i.bufferToStream=g;function a(P){return D.transform(P,{data:I=>typeof I=="string"?L.fromString(I):L.wrap(I)},I=>L.concat(I))}i.streamToBufferReadableStream=a;function s(P){return D.newWriteableStream(I=>L.concat(I),P)}i.newWriteableBufferStream=s;function e(P,I){return D.prefixedReadable(P,I,k=>L.concat(k))}i.prefixedBufferReadable=e;function n(P,I){return D.prefixedStream(P,I,k=>L.concat(k))}i.prefixedBufferStream=n;function t(P){let I=0,k=0,V=0;const G=new Uint8Array(Math.floor(P.length/4*3)),Y=se=>{switch(k){case 3:G[V++]=I|se,k=0;break;case 2:G[V++]=I|se>>>2,I=se<<6,k=3;break;case 1:G[V++]=I|se>>>4,I=se<<4,k=2;break;default:I=se<<2,k=1}};for(let se=0;se<P.length;se++){const oe=P.charCodeAt(se);if(oe>=65&&oe<=90)Y(oe-65);else if(oe>=97&&oe<=122)Y(oe-97+26);else if(oe>=48&&oe<=57)Y(oe-48+52);else if(oe===43||oe===45)Y(62);else if(oe===47||oe===95)Y(63);else{if(oe===61)break;throw new SyntaxError(`Unexpected base64 character ${P[se]}`)}}const X=V;for(;k>0;)Y(0);return L.wrap(G).slice(0,X)}i.decodeBase64=t;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:P},I=!0,k=!1){const V=k?o:r;let G="";const Y=P.byteLength%3;let X=0;for(;X<P.byteLength-Y;X+=3){const se=P[X+0],oe=P[X+1],ne=P[X+2];G+=V[se>>>2],G+=V[(se<<4|oe>>>4)&63],G+=V[(oe<<2|ne>>>6)&63],G+=V[ne&63]}if(Y===1){const se=P[X+0];G+=V[se>>>2],G+=V[se<<4&63],I&&(G+="==")}else if(Y===2){const se=P[X+0],oe=P[X+1];G+=V[se>>>2],G+=V[(se<<4|oe>>>4)&63],G+=V[oe<<2&63],I&&(G+="=")}return G}i.encodeBase64=S}),define(Q[26],Z([0,1,5]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createProxyObject=i.getAllMethodNames=i.getAllPropertyNames=i.filter=i.getCaseInsensitive=i.distinct=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function b(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.keys(l).forEach(g=>{l[g]&&typeof l[g]=="object"?u[g]=b(l[g]):u[g]=l[g]}),u}i.deepClone=b;function w(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const g=u.shift();Object.freeze(g);for(const a in g)if(O.call(g,a)){const s=g[a];typeof s=="object"&&!Object.isFrozen(s)&&!(0,D.isTypedArray)(s)&&u.push(s)}}return l}i.deepFreeze=w;const O=Object.prototype.hasOwnProperty;function L(l,u){return p(l,u,new Set)}i.cloneAndChange=L;function p(l,u,g){if((0,D.isUndefinedOrNull)(l))return l;const a=u(l);if(typeof a<"u")return a;if(Array.isArray(l)){const s=[];for(const e of l)s.push(p(e,u,g));return s}if((0,D.isObject)(l)){if(g.has(l))throw new Error("Cannot clone recursive data-structure");g.add(l);const s={};for(const e in l)O.call(l,e)&&(s[e]=p(l[e],u,g));return g.delete(l),s}return l}function c(l,u,g=!0){return(0,D.isObject)(l)?((0,D.isObject)(u)&&Object.keys(u).forEach(a=>{a in l?g&&((0,D.isObject)(l[a])&&(0,D.isObject)(u[a])?c(l[a],u[a],g):l[a]=u[a]):l[a]=u[a]}),l):u}i.mixin=c;function d(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let g,a;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(g=0;g<l.length;g++)if(!d(l[g],u[g]))return!1}else{const s=[];for(a in l)s.push(a);s.sort();const e=[];for(a in u)e.push(a);if(e.sort(),!d(s,e))return!1;for(g=0;g<s.length;g++)if(!d(l[s[g]],u[s[g]]))return!1}return!0}i.equals=d;function C(l){const u=new Set;return JSON.stringify(l,(g,a)=>{if((0,D.isObject)(a)||Array.isArray(a)){if(u.has(a))return"[Circular]";u.add(a)}return a})}i.safeStringify=C;function E(l,u){const g=Object.create(null);return!l||!u||Object.keys(u).forEach(s=>{const e=l[s],n=u[s];d(e,n)||(g[s]=n)}),g}i.distinct=E;function h(l,u){const g=u.toLowerCase(),a=Object.keys(l).find(s=>s.toLowerCase()===g);return a?l[a]:l[u]}i.getCaseInsensitive=h;function v(l,u){const g=Object.create(null);for(const[a,s]of Object.entries(l))u(a,s)&&(g[a]=s);return g}i.filter=v;function f(l){let u=[],g=Object.getPrototypeOf(l);for(;Object.prototype!==g;)u=u.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return u}i.getAllPropertyNames=f;function m(l){const u=[];for(const g of f(l))typeof l[g]=="function"&&u.push(g);return u}i.getAllMethodNames=m;function y(l,u){const g=s=>function(){const e=Array.prototype.slice.call(arguments,0);return u(s,e)},a={};for(const s of l)a[s]=g(s);return a}i.createProxyObject=y}),define(Q[30],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function b(w){return D.test(w)}i.isUUID=b,i.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let w;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?w=crypto.getRandomValues.bind(crypto):w=function(p){for(let c=0;c<p.length;c++)p[c]=Math.floor(Math.random()*256);return p};const O=new Uint8Array(16),L=[];for(let p=0;p<256;p++)L.push(p.toString(16).padStart(2,"0"));return function(){w(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let c=0,d="";return d+=L[O[c++]],d+=L[O[c++]],d+=L[O[c++]],d+=L[O[c++]],d+="-",d+=L[O[c++]],d+=L[O[c++]],d+="-",d+=L[O[c++]],d+=L[O[c++]],d+="-",d+=L[O[c++]],d+=L[O[c++]],d+="-",d+=L[O[c++]],d+=L[O[c++]],d+=L[O[c++]],d+=L[O[c++]],d+=L[O[c++]],d+=L[O[c++]],d}}()}),define(Q[70],Z([6,7]),function(B,i){return B.create("vs/base/common/date",i)}),define(Q[71],Z([0,1,70]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const b=60,w=b*60,O=w*24,L=O*7,p=O*30,c=O*365;function d(E,h,v){typeof E!="number"&&(E=E.getTime());const f=Math.round((new Date().getTime()-E)/1e3);if(f<-30)return(0,D.localize)(0,null,d(new Date().getTime()+f*1e3,!1));if(f<30)return(0,D.localize)(1,null);let m;return f<b?(m=f,h?m===1?v?(0,D.localize)(2,null,m):(0,D.localize)(3,null,m):v?(0,D.localize)(4,null,m):(0,D.localize)(5,null,m):m===1?v?(0,D.localize)(6,null,m):(0,D.localize)(7,null,m):v?(0,D.localize)(8,null,m):(0,D.localize)(9,null,m)):f<w?(m=Math.floor(f/b),h?m===1?v?(0,D.localize)(10,null,m):(0,D.localize)(11,null,m):v?(0,D.localize)(12,null,m):(0,D.localize)(13,null,m):m===1?v?(0,D.localize)(14,null,m):(0,D.localize)(15,null,m):v?(0,D.localize)(16,null,m):(0,D.localize)(17,null,m)):f<O?(m=Math.floor(f/w),h?m===1?v?(0,D.localize)(18,null,m):(0,D.localize)(19,null,m):v?(0,D.localize)(20,null,m):(0,D.localize)(21,null,m):m===1?v?(0,D.localize)(22,null,m):(0,D.localize)(23,null,m):v?(0,D.localize)(24,null,m):(0,D.localize)(25,null,m)):f<L?(m=Math.floor(f/O),h?m===1?(0,D.localize)(26,null,m):(0,D.localize)(27,null,m):m===1?(0,D.localize)(28,null,m):(0,D.localize)(29,null,m)):f<p?(m=Math.floor(f/L),h?m===1?v?(0,D.localize)(30,null,m):(0,D.localize)(31,null,m):v?(0,D.localize)(32,null,m):(0,D.localize)(33,null,m):m===1?v?(0,D.localize)(34,null,m):(0,D.localize)(35,null,m):v?(0,D.localize)(36,null,m):(0,D.localize)(37,null,m)):f<c?(m=Math.floor(f/p),h?m===1?v?(0,D.localize)(38,null,m):(0,D.localize)(39,null,m):v?(0,D.localize)(40,null,m):(0,D.localize)(41,null,m):m===1?v?(0,D.localize)(42,null,m):(0,D.localize)(43,null,m):v?(0,D.localize)(44,null,m):(0,D.localize)(45,null,m)):(m=Math.floor(f/c),h?m===1?v?(0,D.localize)(46,null,m):(0,D.localize)(47,null,m):v?(0,D.localize)(48,null,m):(0,D.localize)(49,null,m):m===1?v?(0,D.localize)(50,null,m):(0,D.localize)(51,null,m):v?(0,D.localize)(52,null,m):(0,D.localize)(53,null,m))}i.fromNow=d;function C(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=C}),define(Q[72],Z([6,7]),function(B,i){return B.create("vs/base/common/errorMessage",i)}),define(Q[31],Z([0,1,19,5,72]),function(B,i,D,b,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.createErrorWithActions=i.isErrorWithActions=i.toErrorMessage=void 0;function O(E,h){return h&&(E.stack||E.stacktrace)?w.localize(0,null,p(E),L(E.stack)||L(E.stacktrace)):p(E)}function L(E){return Array.isArray(E)?E.join(`
`):E}function p(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?w.localize(1,null,E.message):E.message||w.localize(2,null)}function c(E=null,h=!1){if(!E)return w.localize(3,null);if(Array.isArray(E)){const v=D.coalesce(E),f=c(v[0],h);return v.length>1?w.localize(4,null,f,v.length):f}if(b.isString(E))return E;if(E.detail){const v=E.detail;if(v.error)return O(v.error,h);if(v.exception)return O(v.exception,h)}return E.stack?O(E,h):E.message?E.message:w.localize(5,null)}i.toErrorMessage=c;function d(E){const h=E;return h instanceof Error&&Array.isArray(h.actions)}i.isErrorWithActions=d;function C(E,h){let v;return typeof E=="string"?v=new Error(E):v=E,v.actions=h,v}i.createErrorWithActions=C}),define(Q[73],Z([6,7]),function(B,i){return B.create("vs/base/common/jsonErrorMessages",i)}),define(Q[74],Z([0,1,73]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getParseErrorMessage=void 0;function b(w){switch(w){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}i.getParseErrorMessage=b}),define(Q[51],Z([0,1,13]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.removeDangerousEnvVariables=i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var b;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(b=i.Source||(i.Source={}));var w;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(w=i.TerminateResponseCode||(i.TerminateResponseCode={}));function O(p,...c){const d=c.reduce((h,v)=>(h[v]=!0,h),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(h=>!d[h]).forEach(h=>{for(let v=0;v<C.length;v++)if(h.search(C[v])!==-1){delete p[h];break}})}i.sanitizeProcessEnvironment=O;function L(p){!p||(delete p.DEBUG,D.isMacintosh&&delete p.DYLD_LIBRARY_PATH,D.isLinux&&delete p.LD_PRELOAD)}i.removeDangerousEnvVariables=L}),define(Q[52],Z([0,1,4,2]),function(B,i,D,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MutableObservableValue=i.staticObservableValue=void 0;const w=L=>({onDidChange:D.Event.None,value:L});i.staticObservableValue=w;class O extends b.Disposable{constructor(p){super(),this._value=p,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(p){p!==this._value&&(this._value=p,this.changeEmitter.fire(p))}}i.MutableObservableValue=O}),define(Q[53],Z([0,1,27]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StringSHA1=i.toHexString=i.Hasher=i.stringHash=i.numberHash=i.doHash=i.hash=void 0;function b(l){return w(l,0)}i.hash=b;function w(l,u){switch(typeof l){case"object":return l===null?O(349,u):Array.isArray(l)?c(l,u):d(l,u);case"string":return p(l,u);case"boolean":return L(l,u);case"number":return O(l,u);case"undefined":return O(937,u);default:return O(617,u)}}i.doHash=w;function O(l,u){return(u<<5)-u+l|0}i.numberHash=O;function L(l,u){return O(l?433:863,u)}function p(l,u){u=O(149417,u);for(let g=0,a=l.length;g<a;g++)u=O(l.charCodeAt(g),u);return u}i.stringHash=p;function c(l,u){return u=O(104579,u),l.reduce((g,a)=>w(a,g),u)}function d(l,u){return u=O(181387,u),Object.keys(l).sort().reduce((g,a)=>(g=p(a,g),w(l[a],g)),u)}class C{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=w(u,this._value),this._value}}i.Hasher=C;var E;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function h(l,u,g=32){const a=g-u,s=~((1<<a)-1);return(l<<u|(s&l)>>>a)>>>0}function v(l,u=0,g=l.byteLength,a=0){for(let s=0;s<g;s++)l[u+s]=a}function f(l,u,g="0"){for(;l.length<u;)l=g+l;return l}function m(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(g=>g.toString(16).padStart(2,"0")).join(""):f((l>>>0).toString(16),u/4)}i.toHexString=m;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const g=u.length;if(g===0)return;const a=this._buff;let s=this._buffLen,e=this._leftoverHighSurrogate,n,t;for(e!==0?(n=e,t=-1,e=0):(n=u.charCodeAt(0),t=0);;){let r=n;if(D.isHighSurrogate(n))if(t+1<g){const o=u.charCodeAt(t+1);D.isLowSurrogate(o)?(t++,r=D.computeCodePoint(n,o)):r=65533}else{e=n;break}else D.isLowSurrogate(n)&&(r=65533);if(s=this._push(a,s,r),t++,t<g)n=u.charCodeAt(t);else break}this._buffLen=s,this._leftoverHighSurrogate=e}_push(u,g,a){return a<128?u[g++]=a:a<2048?(u[g++]=192|(a&1984)>>>6,u[g++]=128|(a&63)>>>0):a<65536?(u[g++]=224|(a&61440)>>>12,u[g++]=128|(a&4032)>>>6,u[g++]=128|(a&63)>>>0):(u[g++]=240|(a&1835008)>>>18,u[g++]=128|(a&258048)>>>12,u[g++]=128|(a&4032)>>>6,u[g++]=128|(a&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=y._bigBlock32,g=this._buffDV;for(let P=0;P<64;P+=4)u.setUint32(P,g.getUint32(P,!1),!1);for(let P=64;P<320;P+=4)u.setUint32(P,h(u.getUint32(P-12,!1)^u.getUint32(P-32,!1)^u.getUint32(P-56,!1)^u.getUint32(P-64,!1),1),!1);let a=this._h0,s=this._h1,e=this._h2,n=this._h3,t=this._h4,r,o,S;for(let P=0;P<80;P++)P<20?(r=s&e|~s&n,o=1518500249):P<40?(r=s^e^n,o=1859775393):P<60?(r=s&e|s&n|e&n,o=2400959708):(r=s^e^n,o=3395469782),S=h(a,5)+r+t+o+u.getUint32(P*4,!1)&4294967295,t=n,n=e,e=h(s,30),s=a,a=S;this._h0=this._h0+a&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+e&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+t&4294967295}}i.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[54],Z([0,1,27]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0});var b;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(b||(b={})),function(w){const O="error",L="warning",p="warn",c="info",d="ignore";function C(h){return h?D.equalsIgnoreCase(O,h)?w.Error:D.equalsIgnoreCase(L,h)||D.equalsIgnoreCase(p,h)?w.Warning:D.equalsIgnoreCase(c,h)?w.Info:w.Ignore:w.Ignore}w.fromValue=C;function E(h){switch(h){case w.Error:return O;case w.Warning:return L;case w.Info:return c;default:return d}}w.toString=E}(b||(b={})),i.default=b}),define(Q[75],Z([0,1,10]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function b(d){const C=d;return C&&typeof C.type=="string"&&typeof C.severity=="string"}i.isRemoteConsoleLog=b;function w(d){const C=[];let E;try{const h=JSON.parse(d.arguments),v=h[h.length-1];v&&v.__$stack&&(h.pop(),E=v.__$stack),C.push(...h)}catch{C.push("Unable to log remote console arguments",d.arguments)}return{args:C,stack:E}}i.parse=w;function O(d){if(typeof d!="string")return O(w(d).stack);const C=d;if(C){const E=L(C),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(h&&h.length===4)return{uri:D.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}i.getFirstFrame=O;function L(d){if(!d)return d;const C=d.indexOf(`
`);return C===-1?d:d.substring(0,C)}function p(d,C){const{args:E,stack:h}=w(d),v=typeof E[0]=="string"&&E.length===1;let f=L(h);f&&(f=`(${f.trim()})`);let m=[];if(typeof E[0]=="string"?f&&v?m=[`%c[${C}] %c${E[0]} %c${f}`,c("blue"),c(""),c("grey")]:m=[`%c[${C}] %c${E[0]}`,c("blue"),c(""),...E.slice(1)]:m=[`%c[${C}]%`,c("blue"),...E],f&&!v&&m.push(f),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,m)}i.log=p;function c(d){return`color: ${d}`}}),define(Q[44],Z([0,1,15,27,10]),function(B,i,D,b,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.parse=i.stringify=void 0;function O(d){return JSON.stringify(d,p)}i.stringify=O;function L(d){let C=JSON.parse(d);return C=c(C),C}i.parse=L;function p(d,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,b.regExpFlags)(C)}:C}function c(d,C=0){if(!d||C>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return w.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 14:return new Date(d.source)}if(d instanceof D.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let E=0;E<d.length;++E)d[E]=c(d[E],C+1);else for(const E in d)Object.hasOwnProperty.call(d,E)&&(d[E]=c(d[E],C+1))}return d}i.revive=c}),define(Q[76],Z([0,1,38,14,20]),function(B,i,D,b,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const O=/^\d+$/,L=/^Microsoft.PowerShell_.*/,p=/^Microsoft.PowerShellPreview_.*/;var c;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(c||(c={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class E{constructor(s,e,n){this.exePath=s,this.displayName=e,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:a=!1}={}){return a?d===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:a=!1,findPreview:s=!1}={}){const e=h({useAlternateBitness:a});if(!e)return null;const n=b.join(e,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(n))return null;let t=-1,r=null;for(const P of await w.Promises.readdir(n)){let I=-1;if(s){const V=P.indexOf("-");if(V<0)continue;const G=P.substring(0,V);if(!O.test(G)||P.substring(V+1)!=="preview")continue;I=parseInt(G,10)}else{if(!O.test(P))continue;I=parseInt(P,10)}if(I<=t)continue;const k=b.join(n,P,"pwsh.exe");!await w.SymlinkSupport.existsFile(k)||(r=k,t=I)}if(!r)return null;const o=e.includes("x86")?" (x86)":"",S=s?" Preview":"";return new E(r,`PowerShell${S}${o}`,!0)}async function f({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const s=b.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:n}=a?{pwshMsixDirRegex:p,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const t of await w.Promises.readdir(s))if(e.test(t)){const r=b.join(s,t,"pwsh.exe");return new E(r,n)}return null}function m(){const a=b.join(D.homedir(),".dotnet","tools","pwsh.exe");return new E(a,".NET Core PowerShell Global Tool")}function y(){const a=b.join(process.env.windir,d===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(a,"Windows PowerShell",!0)}async function*l(){let a=await v();a&&(yield a),a=await v({useAlternateBitness:!0}),a&&(yield a),a=await f(),a&&(yield a),a=m(),a&&(yield a),a=await v({findPreview:!0}),a&&(yield a),a=await f({findPreview:!0}),a&&(yield a),a=await v({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=y(),a&&(yield a)}async function*u(){for await(const a of l())await a.exists()&&(yield a)}i.enumeratePowerShellInstallations=u;async function g(){for await(const a of u())return a;return null}i.getFirstAvailablePowerShellInstallation=g}),define(Q[55],Z([0,1,14,13,32,51,5,20]),function(B,i,D,b,w,O,L,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.getWindowsShell=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function c(E=w.env){return E.comspec||"cmd.exe"}i.getWindowsShell=c;function d(E){let h=[],v=!1;const f=function(m){if(v){h.push(m);return}(!E.send(m,l=>{if(l&&console.error(l),v=!1,h.length>0){const u=h.slice(0);h=[],u.forEach(g=>f(g))}})||b.isWindows)&&(v=!0)};return{send:f}}i.createQueuedSender=d;var C;(function(E){async function h(v,f,m){if(D.isAbsolute(v))return v;if(f===void 0&&(f=w.cwd()),D.dirname(v)!=="."||(m===void 0&&L.isString(w.env.PATH)&&(m=w.env.PATH.split(D.delimiter)),m===void 0||m.length===0))return D.join(f,v);async function l(u){if(await p.Promises.exists(u)){let g;try{g=await p.Promises.stat(u)}catch(a){a.message.startsWith("EACCES")&&(g=await p.Promises.lstat(u))}return g?!g.isDirectory():!1}return!1}for(const u of m){let g;if(D.isAbsolute(u)?g=D.join(u,v):g=D.join(f,u,v),await l(g))return g;let a=g+".com";if(await l(a)||(a=g+".exe",await l(a)))return a}return D.join(f,v)}E.findExecutable=h})(C=i.win32||(i.win32={}))}),define(Q[77],Z([0,1,38,13,76,55]),function(B,i,D,b,w,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function L(v,f){return v===1?b.isWindows?E():O.getWindowsShell(f):d(v,f)}i.getSystemShell=L;function p(v,f){return v===1?b.isWindows?h(f):O.getWindowsShell(f):d(v,f)}i.getSystemShellSync=p;let c=null;function d(v,f){if(b.isLinux&&v===2||b.isMacintosh&&v===3)return"/bin/bash";if(!c){let m;if(b.isWindows)m="/bin/bash";else{if(m=f.SHELL,!m)try{m=(0,D.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}c=m}return c}let C=null;async function E(){return C||(C=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),C}function h(v){if(C)return C;const f=b.isWindows&&parseFloat((0,D.release)())>=10,m=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${v.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?y:O.getWindowsShell(v)}});var he=this&&this.__decorate||function(B,i,D,b){var w=arguments.length,O=w<3?i:b===null?b=Object.getOwnPropertyDescriptor(i,D):b,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(B,i,D,b);else for(var p=B.length-1;p>=0;p--)(L=B[p])&&(O=(w<3?L(O):w>3?L(i,D,O):L(i,D))||O);return w>3&&O&&Object.defineProperty(i,D,O),O};define(Q[56],Z([0,1,19,3,15,24,49,12,4,2,44,27,5]),function(B,i,D,b,w,O,L,p,c,d,C,E,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var v;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(v=i.RequestType||(i.RequestType={}));function f(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(m=i.ResponseType||(i.ResponseType={}));function y(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(l||(l={}));class u{constructor(F){this.buffer=F,this.pos=0}read(F){const z=this.buffer.slice(this.pos,this.pos+F);return this.pos+=z.byteLength,z}}class g{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var a;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(a||(a={}));function s(N){const F=w.VSBuffer.alloc(4);return F.writeUInt32BE(N,0),F}function e(N){return N.read(4).readUInt32BE(0)}function n(N){const F=w.VSBuffer.alloc(1);return F.writeUInt8(N,0),F}const t={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object)},r=typeof Buffer<"u";function o(N,F){if(typeof F>"u")N.write(t.Undefined);else if(typeof F=="string"){const z=w.VSBuffer.fromString(F);N.write(t.String),N.write(s(z.byteLength)),N.write(z)}else if(r&&Buffer.isBuffer(F)){const z=w.VSBuffer.wrap(F);N.write(t.Buffer),N.write(s(z.byteLength)),N.write(z)}else if(F instanceof w.VSBuffer)N.write(t.VSBuffer),N.write(s(F.byteLength)),N.write(F);else if(Array.isArray(F)){N.write(t.Array),N.write(s(F.length));for(const z of F)o(N,z)}else{const z=w.VSBuffer.fromString(JSON.stringify(F));N.write(t.Object),N.write(s(z.byteLength)),N.write(z)}}function S(N){switch(N.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return N.read(e(N)).toString();case a.Buffer:return N.read(e(N)).buffer;case a.VSBuffer:return N.read(e(N));case a.Array:{const z=e(N),$=[];for(let J=0;J<z;J++)$.push(S(N));return $}case a.Object:return JSON.parse(N.read(e(N)).toString())}}class P{constructor(F,z,$=null,J=1e3){this.protocol=F,this.ctx=z,this.logger=$,this.timeoutDelay=J,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(A=>this.onRawMessage(A)),this.sendResponse({type:200})}registerChannel(F,z){this.channels.set(F,z),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const z=this.send([F.type]);this.logger?.logOutgoing(z,0,1,y(F.type));return}case 201:case 202:case 204:case 203:{const z=this.send([F.type,F.id],F.data);this.logger?.logOutgoing(z,F.id,1,y(F.type),F.data);return}}}send(F,z=void 0){const $=new g;return o($,F),o($,z),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const z=new u(F),$=S(z),J=S(z),A=$[0];switch(A){case 100:return this.logger?.logIncoming(F.byteLength,$[1],1,`${f(A)}: ${$[2]}.${$[3]}`,J),this.onPromise({type:A,id:$[1],channelName:$[2],name:$[3],arg:J});case 102:return this.logger?.logIncoming(F.byteLength,$[1],1,`${f(A)}: ${$[2]}.${$[3]}`,J),this.onEventListen({type:A,id:$[1],channelName:$[2],name:$[3],arg:J});case 101:return this.logger?.logIncoming(F.byteLength,$[1],1,`${f(A)}`),this.disposeActiveRequest({type:A,id:$[1]});case 103:return this.logger?.logIncoming(F.byteLength,$[1],1,`${f(A)}`),this.disposeActiveRequest({type:A,id:$[1]})}}onPromise(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const $=new O.CancellationTokenSource;let J;try{J=z.call(this.ctx,F.name,F.arg,$.token)}catch(R){J=Promise.reject(R)}const A=F.id;J.then(R=>{this.sendResponse({id:A,data:R,type:201}),this.activeRequests.delete(F.id)},R=>{R instanceof Error?this.sendResponse({id:A,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.sendResponse({id:A,data:R,type:203}),this.activeRequests.delete(F.id)});const U=(0,d.toDisposable)(()=>$.cancel());this.activeRequests.set(F.id,U)}onEventListen(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const $=F.id,A=z.listen(this.ctx,F.name,F.arg)(U=>this.sendResponse({id:$,data:U,type:204}));this.activeRequests.set(F.id,A)}disposeActiveRequest(F){const z=this.activeRequests.get(F.id);z&&(z.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let z=this.pendingRequests.get(F.channelName);z||(z=[],this.pendingRequests.set(F.channelName,z));const $=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:F,timeoutTimer:$})}flushPendingRequests(F){const z=this.pendingRequests.get(F);if(z){for(const $ of z)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}i.ChannelServer=P;var I;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(I=i.RequestInitiator||(i.RequestInitiator={}));class k{constructor(F,z=null){this.protocol=F,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=z}getChannel(F){const z=this;return{call($,J,A){return z.isDisposed?Promise.reject(new p.CancellationError):z.requestPromise(F,$,J,A)},listen($,J){return z.isDisposed?c.Event.None:z.requestEvent(F,$,J)}}}requestPromise(F,z,$,J=O.CancellationToken.None){const A=this.lastRequestId++,R={id:A,type:100,channelName:F,name:z,arg:$};if(J.isCancellationRequested)return Promise.reject(new p.CancellationError);let T;return new Promise((j,_)=>{if(J.isCancellationRequested)return _(new p.CancellationError);const H=()=>{const ve=te=>{switch(te.type){case 201:this.handlers.delete(A),j(te.data);break;case 202:{this.handlers.delete(A);const re=new Error(te.data.message);re.stack=te.data.stack,re.name=te.data.name,_(re);break}case 203:this.handlers.delete(A),_(te.data);break}};this.handlers.set(A,ve),this.sendRequest(R)};let ae=null;this.state===l.Idle?H():(ae=(0,b.createCancelablePromise)(ve=>this.whenInitialized()),ae.then(()=>{ae=null,H()}));const ce=()=>{ae?(ae.cancel(),ae=null):this.sendRequest({id:A,type:101}),_(new p.CancellationError)},pe=J.onCancellationRequested(ce);T=(0,d.combinedDisposable)((0,d.toDisposable)(ce),pe),this.activeRequests.add(T)}).finally(()=>{this.activeRequests.delete(T)})}requestEvent(F,z,$){const J=this.lastRequestId++,U={id:J,type:102,channelName:F,name:z,arg:$};let R=null;const T=new c.Emitter({onFirstListenerAdd:()=>{R=(0,b.createCancelablePromise)(j=>this.whenInitialized()),R.then(()=>{R=null,this.activeRequests.add(T),this.sendRequest(U)})},onLastListenerRemove:()=>{R?(R.cancel(),R=null):(this.activeRequests.delete(T),this.sendRequest({id:J,type:103}))}}),M=j=>T.fire(j.data);return this.handlers.set(J,M),T.event}sendRequest(F){switch(F.type){case 100:case 102:{const z=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger?.logOutgoing(z,F.id,0,`${f(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const z=this.send([F.type,F.id]);this.logger?.logOutgoing(z,F.id,0,f(F.type));return}}}send(F,z=void 0){const $=new g;return o($,F),o($,z),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const z=new u(F),$=S(z),J=S(z),A=$[0];switch(A){case 200:return this.logger?.logIncoming(F.byteLength,0,0,y(A)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(F.byteLength,$[1],0,y(A),J),this.onResponse({type:$[0],id:$[1],data:J})}}onResponse(F){if(F.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}this.handlers.get(F.id)?.(F)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}he([L.memoize],k.prototype,"onDidInitializePromise",null),i.ChannelClient=k;class V{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:z,onDidClientDisconnect:$})=>{c.Event.once(z.onMessage)(A=>{const U=new u(A),R=S(U),T=new P(z,R),M=new k(z);this.channels.forEach((_,H)=>T.registerChannel(H,_));const j={channelServer:T,channelClient:M,ctx:R};this._connections.add(j),this._onDidAddConnection.fire(j),$(()=>{T.dispose(),M.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const F=[];return this._connections.forEach(z=>F.push(z)),F}getChannel(F,z){const $=this;return{call(J,A,U){let R;if((0,h.isFunction)(z)){const M=(0,D.getRandomElement)($.connections.filter(z));R=M?Promise.resolve(M):c.Event.toPromise(c.Event.filter($.onDidAddConnection,z))}else R=z.routeCall($,J,A);const T=R.then(M=>M.channelClient.getChannel(F));return Y(T).call(J,A,U)},listen(J,A){if((0,h.isFunction)(z))return $.getMulticastEvent(F,z,J,A);const U=z.routeEvent($,J,A).then(R=>R.channelClient.getChannel(F));return Y(U).listen(J,A)}}}getMulticastEvent(F,z,$,J){const A=this;let U=new d.DisposableStore;const R=new c.Emitter({onFirstListenerAdd:()=>{U=new d.DisposableStore;const T=new c.EventMultiplexer,M=new Map,j=H=>{const ce=H.channelClient.getChannel(F).listen($,J),pe=T.add(ce);M.set(H,pe)},_=H=>{const ae=M.get(H);!ae||(ae.dispose(),M.delete(H))};A.connections.filter(z).forEach(j),c.Event.filter(A.onDidAddConnection,z)(j,void 0,U),A.onDidRemoveConnection(_,void 0,U),T.event(R.fire,R,U),U.add(T)},onLastListenerRemove:()=>{U.dispose()}});return R.event}registerChannel(F,z){this.channels.set(F,z),this._connections.forEach($=>{$.channelServer.registerChannel(F,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=V;class G{constructor(F,z,$=null){const J=new g;o(J,z),F.send(J.buffer),this.channelClient=new k(F,$),this.channelServer=new P(F,z,$)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,z){this.channelServer.registerChannel(F,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=G;function Y(N){return{call(F,z,$){return N.then(J=>J.call(F,z,$))},listen(F,z){const $=new c.Relay;return N.then(J=>$.input=J.listen(F,z)),$.event}}}i.getDelayedChannel=Y;function X(N){let F=!1;return{call(z,$,J){return F?N.call(z,$,J):(0,b.timeout)(0).then(()=>F=!0).then(()=>N.call(z,$,J))},listen(z,$){if(F)return N.listen(z,$);const J=new c.Relay;return(0,b.timeout)(0).then(()=>F=!0).then(()=>J.input=N.listen(z,$)),J.event}}}i.getNextTickChannel=X;class se{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const z of F.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await c.Event.toPromise(F.onDidAddConnection),await this.route(F)}}i.StaticRouter=se;var oe;(function(N){function F(A,U){const R=A,T=U&&U.disableMarshalling,M=new Map;for(const j in R)$(j)&&M.set(j,c.Event.buffer(R[j],!0));return new class{listen(j,_,H){const ae=M.get(_);if(ae)return ae;if(J(_)){const ce=R[_];if(typeof ce=="function")return ce.call(R,H)}throw new Error(`Event not found: ${_}`)}call(j,_,H){const ae=R[_];if(typeof ae=="function"){if(!T&&Array.isArray(H))for(let ce=0;ce<H.length;ce++)H[ce]=(0,C.revive)(H[ce]);return ae.apply(R,H)}throw new Error(`Method not found: ${_}`)}}}N.fromService=F;function z(A,U){const R=U&&U.disableMarshalling;return new Proxy({},{get(T,M){if(typeof M=="string")return U?.properties?.has(M)?U.properties.get(M):J(M)?function(j){return A.listen(M,j)}:$(M)?A.listen(M):async function(...j){let _;U&&!(0,h.isUndefinedOrNull)(U.context)?_=[U.context,...j]:_=j;const H=await A.call(M,_);return R?H:(0,C.revive)(H)};throw new Error(`Property not found: ${String(M)}`)}})}N.toService=z;function $(A){return A[0]==="o"&&A[1]==="n"&&E.isUpperAsciiLetter(A.charCodeAt(2))}function J(A){return/^onDynamic/.test(A)&&E.isUpperAsciiLetter(A.charCodeAt(9))}})(oe=i.ProxyChannel||(i.ProxyChannel={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){const F=N.toString();if(F!=="[object Object]")return F}return N}function le(N){return Array.isArray(N)?N.map(fe):fe(N)}function ie(N,F,z,$,J,A,U){U=le(U);const R=ne[J],T=R[$%R.length];let M=[`%c[${N}]%c[${String(F).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String($).padStart(5," ")} - ${A}`,"color: darkgreen","color: grey","color: grey",`color: ${T}`];/\($/.test(A)?(M=M.concat(U),M.push(")")):M.push(U),console.log.apply(console,M)}i.logWithColors=ie;class W{constructor(F,z){this._outgoingPrefix=F,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,z,$,J,A){this._totalOutgoing+=F,ie(this._outgoingPrefix,this._totalOutgoing,F,z,$,J,A)}logIncoming(F,z,$,J,A){this._totalIncoming+=F,ie(this._incomingPrefix,this._totalIncoming,F,z,$,J,A)}}i.IPCLogger=W}),define(Q[78],Z([0,1,57,3,15,24,75,12,4,2,26,55,51,56]),function(B,i,D,b,w,O,L,p,c,d,C,E,h,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class f extends v.ChannelServer{constructor(l){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:c.Event.fromNodeEventEmitter(process,"message",u=>w.VSBuffer.wrap(Buffer.from(u,"base64")))},l),process.once("disconnect",()=>this.dispose())}}i.Server=f;class m{constructor(l,u){this.modulePath=l,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new b.Delayer(g),this.child=null,this._client=null}getChannel(l){const u=this;return{call(g,a,s){return u.requestPromise(l,g,a,s)},listen(g,a){return u.requestEvent(l,g,a)}}}requestPromise(l,u,g,a=O.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(p.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(l),e=(0,b.createCancelablePromise)(r=>s.call(u,g,r)),n=a.onCancellationRequested(()=>e.cancel()),t=(0,d.toDisposable)(()=>e.cancel());return this.activeRequests.add(t),e.finally(()=>{n.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(l,u,g){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let a;const s=new c.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(l).listen(u,g)(s.fire,s),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,h.removeDangerousEnvVariables)(u.env),this.child=(0,D.fork)(this.modulePath,l,u);const g=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,L.isRemoteConsoleLog)(o)){(0,L.log)(o,`IPC Library: ${this.options.serverName}`);return}g.fire(w.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,e=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),n=g.event,t={send:e,onMessage:n};this._client=new v.ChannelClient(t);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,S)=>{process.removeListener("exit",r),this.activeRequests.forEach(P=>(0,d.dispose)(P)),this.activeRequests.clear(),o!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+S),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:S})})}return this._client}getCachedChannel(l){let u=this.channels.get(l);return u||(u=this.client.getChannel(l),this.channels.set(l,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=m}),define(Q[79],Z([0,1,3,4,2,5]),function(B,i,D,b,w,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.StorageState=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var L;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=i.StorageHint||(i.StorageHint={}));function p(E){const h=E;return h?.changed instanceof Map||h?.deleted instanceof Set}i.isStorageItemsChangeEvent=p;var c;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(c=i.StorageState||(i.StorageState={}));class d extends w.Disposable{constructor(h,v=Object.create(null)){super(),this.database=h,this.options=v,this._onDidChangeStorage=this._register(new b.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((v,f)=>this.accept(f,v)),h.deleted?.forEach(v=>this.accept(v,void 0))}accept(h,v){if(this.state===c.Closed)return;let f=!1;(0,O.isUndefinedOrNull)(v)?f=this.cache.delete(h):this.cache.get(h)!==v&&(this.cache.set(h,v),f=!0),f&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,v){const f=this.cache.get(h);return(0,O.isUndefinedOrNull)(f)?v:f}getBoolean(h,v){const f=this.get(h);return(0,O.isUndefinedOrNull)(f)?v:f==="true"}getNumber(h,v){const f=this.get(h);return(0,O.isUndefinedOrNull)(f)?v:parseInt(f,10)}async set(h,v){if(this.state===c.Closed)return;if((0,O.isUndefinedOrNull)(v))return this.delete(h);const f=String(v);if(this.cache.get(h)!==f)return this.cache.set(h,f),this.pendingInserts.set(h,f),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async delete(h){if(!(this.state===c.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(!!this.hasPending)return this.doFlush(h)}async doFlush(h){return this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=b.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert?.forEach((v,f)=>this.items.set(f,v)),h.delete?.forEach(v=>this.items.delete(v))}async close(){}}i.InMemoryStorageDatabase=C}),define(Q[80],Z([6,7]),function(B,i){return B.create("vs/base/node/zip",i)}),define(Q[81],Z([6,7]),function(B,i){return B.create("vs/platform/configuration/common/configurationRegistry",i)}),define(Q[82],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(Q[83],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(Q[84],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(Q[85],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionNls",i)}),define(Q[86],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/common/extensionsScannerService",i)}),define(Q[87],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(Q[88],Z([6,7]),function(B,i){return B.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(Q[89],Z([6,7]),function(B,i){return B.create("vs/platform/extensions/common/extensionValidator",i)}),define(Q[90],Z([6,7]),function(B,i){return B.create("vs/platform/files/common/fileService",i)}),define(Q[91],Z([6,7]),function(B,i){return B.create("vs/platform/files/common/io",i)}),define(Q[92],Z([6,7]),function(B,i){return B.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(Q[93],Z([6,7]),function(B,i){return B.create("vs/platform/languagePacks/common/languagePacks",i)}),define(Q[94],Z([6,7]),function(B,i){return B.create("vs/platform/request/common/request",i)}),define(Q[95],Z([6,7]),function(B,i){return B.create("vs/platform/shell/node/shellEnv",i)}),define(Q[96],Z([6,7]),function(B,i){return B.create("vs/platform/telemetry/common/telemetryService",i)}),define(Q[97],Z([6,7]),function(B,i){return B.create("vs/platform/userDataProfile/common/userDataProfile",i)}),define(Q[98],Z([6,7]),function(B,i){return B.create("vs/platform/workspace/common/workspace",i)}),define(Q[99],Z([0,1,71,49,16,14,32,17,10]),function(B,i,D,b,w,O,L,p,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class d{constructor(m,y,l){this._args=m,this.paths=y,this.productService=l,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,O.dirname)(w.FileAccess.asFileUri("",B).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,O.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get cacheHome(){return c.URI.file(this.userDataPath)}get stateResource(){return(0,p.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,p.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,O.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return c.URI.file((0,O.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,p.joinPath)(c.URI.file((0,O.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,p.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,p.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,p.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=L.env.VSCODE_PORTABLE;return m?c.URI.file((0,O.join)(m,"argv.json")):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,O.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,O.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,O.resolve)(m):(0,O.normalize)((0,O.join)(w.FileAccess.asFileUri("",B).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=this.args["extensions-download-dir"];return m?(0,O.resolve)(m):(0,O.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,O.resolve)(m);const y=L.env.VSCODE_EXTENSIONS;if(y)return y;const l=L.env.VSCODE_PORTABLE;return l?(0,O.join)(l,"extensions"):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(y=>/^[^:/?#]+?:\/\//.test(y)?c.URI.parse(y):c.URI.file((0,O.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?c.URI.parse(m):c.URI.file((0,O.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,p.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return c.URI.file((0,O.join)(this.logsPath,"telemetry.log"))}get extensionTelemetryLogResource(){return c.URI.file((0,O.join)(this.logsPath,"extensionTelemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=L.env.VSCODE_PORTABLE;return m?c.URI.file((0,O.join)(m,"policy.json")):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}he([b.memoize],d.prototype,"appRoot",null),he([b.memoize],d.prototype,"userHome",null),he([b.memoize],d.prototype,"userDataPath",null),he([b.memoize],d.prototype,"appSettingsHome",null),he([b.memoize],d.prototype,"tmpDir",null),he([b.memoize],d.prototype,"cacheHome",null),he([b.memoize],d.prototype,"stateResource",null),he([b.memoize],d.prototype,"userRoamingDataHome",null),he([b.memoize],d.prototype,"userDataSyncHome",null),he([b.memoize],d.prototype,"userDataSyncLogResource",null),he([b.memoize],d.prototype,"editSessionsLogResource",null),he([b.memoize],d.prototype,"sync",null),he([b.memoize],d.prototype,"machineSettingsResource",null),he([b.memoize],d.prototype,"workspaceStorageHome",null),he([b.memoize],d.prototype,"localHistoryHome",null),he([b.memoize],d.prototype,"keyboardLayoutResource",null),he([b.memoize],d.prototype,"argvResource",null),he([b.memoize],d.prototype,"isExtensionDevelopment",null),he([b.memoize],d.prototype,"untitledWorkspacesHome",null),he([b.memoize],d.prototype,"installSourcePath",null),he([b.memoize],d.prototype,"builtinExtensionsPath",null),he([b.memoize],d.prototype,"extensionsPath",null),he([b.memoize],d.prototype,"extensionDevelopmentLocationURI",null),he([b.memoize],d.prototype,"extensionDevelopmentKind",null),he([b.memoize],d.prototype,"extensionTestsLocationURI",null),he([b.memoize],d.prototype,"debugExtensionHost",null),he([b.memoize],d.prototype,"serviceMachineIdResource",null),he([b.memoize],d.prototype,"telemetryLogResource",null),he([b.memoize],d.prototype,"disableWorkspaceTrust",null),he([b.memoize],d.prototype,"policyFile",null),i.AbstractNativeEnvironmentService=d;function C(f,m){return v(f["inspect-extensions"],f["inspect-brk-extensions"],5870,m,f.debugId,f.extensionEnvironment)}i.parseExtensionHostPort=C;function E(f,m){return v(f["inspect-search"],f["inspect-brk-search"],5876,m,f.extensionEnvironment)}i.parseSearchPort=E;function h(f,m){return v(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,m,f.extensionEnvironment)}i.parsePtyHostPort=h;function v(f,m,y,l,u,g){const s=Number(m||f)||(l?null:y),e=s?Boolean(!!m):!1;let n;if(g)try{n=JSON.parse(g)}catch{}return{port:s,break:e,debugId:u,env:n}}}),function(){"use strict";function B(i,D,b,w){function O(p){const c=L(p),d=[c];return i.isAbsolute(c)||d.unshift(w),i.resolve(...d)}function L(p){const c=process.env.VSCODE_PORTABLE;if(c)return i.join(c,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return i.join(d,b);const C=p["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=i.join(E,"AppData","Roaming")}break;case"darwin":d=i.join(D.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||i.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(d,b)}return{getUserDataPath:O}}if(typeof define=="function")define(Q[100],Z([0,149,38,16,17,32]),function(i,D,b,w,O,L){const p=O.dirname(w.FileAccess.asFileUri("",i)),c=i.__$__nodeRequire(O.joinPath(p,"package.json").fsPath);return B(D,b,c.name,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),D=require("path"),b=require("os");module.exports=B(D,b,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[101],Z([0,1,38,99,100]),function(B,i,D,b,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class O extends b.AbstractNativeEnvironmentService{constructor(p,c){super(p,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,w.getUserDataPath)(p)},c)}}i.NativeEnvironmentService=O}),define(Q[102],Z([0,1,5,85]),function(B,i,D,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;function w(L,p,c){try{O(L,p,c)}catch{}return L}i.localizeManifest=w;function O(L,p,c){const d=(C,E,h)=>{const v=C[E];if((0,D.isString)(v)){const f=v,m=f.length;if(m>1&&f[0]==="%"&&f[m-1]==="%"){const y=f.substr(1,m-2);let l=p[y];l===void 0&&c&&(l=c[y]);const u=typeof l=="string"?l:l.message;if(u!==void 0){const g=c?.[y],a=typeof g=="string"?g:g?.message;if(h&&(E==="title"||E==="category")&&a&&a!==u){const s={value:u,original:a};C[E]=s}else C[E]=u}else console.warn(`[${L.name}]: ${(0,b.localize)(0,null,y)}`)}}else if((0,D.isObject)(v))for(const f in v)v.hasOwnProperty(f)&&(f==="commands"?d(v,f,!0):d(v,f,h));else if(Array.isArray(v))for(let f=0;f<v.length;f++)d(v,f,h)};for(const C in L)L.hasOwnProperty(C)&&d(L,C)}}),define(Q[45],Z([0,1,17,54,89,39]),function(B,i,D,b,w,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.validateExtensionManifest=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function c(l){return l=l.trim(),l==="*"||L.test(l)}i.isValidVersionStr=c;function d(l){if(!c(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=l.match(L);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}i.parseVersion=d;function C(l){if(!l)return null;const u=l.majorBase,g=l.majorMustEqual,a=l.minorBase;let s=l.minorMustEqual;const e=l.patchBase;let n=l.patchMustEqual;l.hasCaret&&(u===0||(s=!1),n=!1);let t=0;if(l.preRelease){const r=p.exec(l.preRelease);if(r){const[,o,S,P]=r;t=Date.UTC(Number(o),Number(S)-1,Number(P))}}return{majorBase:u,majorMustEqual:g,minorBase:a,minorMustEqual:s,patchBase:e,patchMustEqual:n,isMinimum:l.hasGreaterEquals,notBefore:t}}i.normalizeVersion=C;function E(l,u,g){let a;typeof l=="string"?a=C(d(l)):a=l;let s;u instanceof Date?s=u.getTime():typeof u=="string"&&(s=new Date(u).getTime());let e;if(typeof g=="string"?e=C(d(g)):e=g,!a||!e)return!1;const n=a.majorBase,t=a.minorBase,r=a.patchBase;let o=e.majorBase,S=e.minorBase,P=e.patchBase;const I=e.notBefore;let k=e.majorMustEqual,V=e.minorMustEqual,G=e.patchMustEqual;return e.isMinimum?n>o?!0:n<o?!1:t>S?!0:t<S||s&&s<I?!1:r>=P:(n===1&&o===0&&(!k||!V||!G)&&(o=1,S=0,P=0,k=!0,V=!1,G=!1),n<o?!1:n>o?!k:t<S?!1:t>S?!V:r<P?!1:r>P?!G:!(s&&s<I))}i.isValidVersion=E;function h(l,u,g,a,s){const e=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return e.push([b.default.Error,w.localize(0,null)]),e;if(typeof a.name!="string")return e.push([b.default.Error,w.localize(1,null,"name")]),e;if(typeof a.version!="string")return e.push([b.default.Error,w.localize(2,null,"version")]),e;if(!a.engines)return e.push([b.default.Error,w.localize(3,null,"engines")]),e;if(typeof a.engines.vscode!="string")return e.push([b.default.Error,w.localize(4,null,"engines.vscode")]),e;if(typeof a.extensionDependencies<"u"&&!y(a.extensionDependencies))return e.push([b.default.Error,w.localize(5,null,"extensionDependencies")]),e;if(typeof a.activationEvents<"u"){if(!y(a.activationEvents))return e.push([b.default.Error,w.localize(6,null,"activationEvents")]),e;if(typeof a.main>"u"&&typeof a.browser>"u")return e.push([b.default.Error,w.localize(7,null,"activationEvents","main")]),e}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&e.push([b.default.Warning,w.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return e.push([b.default.Error,w.localize(9,null,"main")]),e;{const r=(0,D.joinPath)(g,a.main);(0,D.isEqualOrParent)(r,g)||e.push([b.default.Warning,w.localize(10,null,r.path,g.path)])}if(typeof a.activationEvents>"u")return e.push([b.default.Error,w.localize(11,null,"activationEvents","main")]),e}if(typeof a.browser<"u"){if(typeof a.browser!="string")return e.push([b.default.Error,w.localize(12,null,"browser")]),e;{const r=(0,D.joinPath)(g,a.browser);(0,D.isEqualOrParent)(r,g)||e.push([b.default.Warning,w.localize(13,null,r.path,g.path)])}if(typeof a.activationEvents>"u")return e.push([b.default.Error,w.localize(14,null,"activationEvents","browser")]),e}if(!O.valid(a.version))return e.push([b.default.Error,w.localize(15,null)]),e;const n=[];if(!v(l,u,a,s,n))for(const r of n)e.push([b.default.Error,r]);return e}i.validateExtensionManifest=h;function v(l,u,g,a,s){return a||typeof g.main>"u"&&typeof g.browser>"u"?!0:m(l,u,g.engines.vscode,s)}i.isValidExtensionVersion=v;function f(l,u,g){return l==="*"||m(u,g,l)}i.isEngineValid=f;function m(l,u,g,a=[]){const s=C(d(g));if(!s)return a.push(w.localize(16,null,g)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return a.push(w.localize(17,null,g)),!1}else if(!s.majorMustEqual)return a.push(w.localize(18,null,g)),!1;return E(l,u,s)?!0:(a.push(w.localize(19,null,l,g)),!1)}function y(l){if(!Array.isArray(l))return!1;for(let u=0,g=l.length;u<g;u++)if(typeof l[u]!="string")return!1;return!0}}),define(Q[103],Z([0,1,15,30]),function(B,i,D,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function w(O,L,p){let c=p&&p.get("storage.serviceMachineId",-1)||null;if(c)return c;try{const C=(await L.readFile(O.serviceMachineIdResource)).value.toString();c=(0,b.isUUID)(C)?C:null}catch{c=null}if(!c){c=(0,b.generateUuid)();try{await L.writeFile(O.serviceMachineIdResource,D.VSBuffer.fromString(c))}catch{}}return p?.store("storage.serviceMachineId",c,-1,1),c}i.getServiceMachineId=w}),define(Q[46],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class D{constructor(w,O=[],L=!1){this.ctor=w,this.staticArguments=O,this.supportsDelayedInstantiation=L}}i.SyncDescriptor=D}),define(Q[104],Z([0,1,46]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const b=[];function w(L,p,c){p instanceof D.SyncDescriptor||(p=new D.SyncDescriptor(p,[],c)),b.push([L,p])}i.registerSingleton=w;function O(){return b}i.getSingletonServiceDescriptors=O}),define(Q[105],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class D{constructor(O,L){this.key=O,this.data=L,this.incoming=new Map,this.outgoing=new Map}}i.Node=D;class b{constructor(O){this._hashFn=O,this._nodes=new Map}roots(){const O=[];for(const L of this._nodes.values())L.outgoing.size===0&&O.push(L);return O}insertEdge(O,L){const p=this.lookupOrInsertNode(O),c=this.lookupOrInsertNode(L);p.outgoing.set(c.key,c),c.incoming.set(p.key,p)}removeNode(O){const L=this._hashFn(O);this._nodes.delete(L);for(const p of this._nodes.values())p.outgoing.delete(L),p.incoming.delete(L)}lookupOrInsertNode(O){const L=this._hashFn(O);let p=this._nodes.get(L);return p||(p=new D(L,O),this._nodes.set(L,p)),p}lookup(O){return this._nodes.get(this._hashFn(O))}isEmpty(){return this._nodes.size===0}toString(){const O=[];for(const[L,p]of this._nodes)O.push(`${L}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,L]of this._nodes){const p=new Set([O]),c=this._findCycle(L,p);if(c)return c}}_findCycle(O,L){for(const[p,c]of O.outgoing){if(L.has(p))return[...L,p].join(" -> ");L.add(p);const d=this._findCycle(c,L);if(d)return d;L.delete(p)}}}i.Graph=b}),define(Q[21],Z([0,1,5,10,8]),function(B,i,D,b,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getLanguageTagSettingPlainKey=i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,w.createDecorator)("configurationService");function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof b.URI)}i.isConfigurationOverrides=O;function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof b.URI)}i.isConfigurationUpdateOverrides=L;var p;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(p=i.ConfigurationTarget||(i.ConfigurationTarget={}));function c(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}i.ConfigurationTargetToString=c;function d(l,u){const g=Object.create(null);for(const a in l)C(g,a,l[a],u);return g}i.toValuesTree=d;function C(l,u,g,a){const s=u.split("."),e=s.pop();let n=l;for(let t=0;t<s.length;t++){const r=s[t];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:a(`Ignoring ${u} as ${s.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[e]=g}catch{a(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(n)}`)}else a(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(n)}`)}i.addToValueTree=C;function E(l,u){const g=u.split(".");h(l,g)}i.removeFromValueTree=E;function h(l,u){const g=u.shift();if(u.length===0){delete l[g];return}if(Object.keys(l).indexOf(g)!==-1){const a=l[g];typeof a=="object"&&!Array.isArray(a)&&(h(a,u),Object.keys(a).length===0&&delete l[g])}}function v(l,u,g){function a(n,t){let r=n;for(const o of t){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=u.split("."),e=a(l,s);return typeof e>"u"?g:e}i.getConfigurationValue=v;function f(l,u,g){Object.keys(u).forEach(a=>{a!=="__proto__"&&(a in l?D.isObject(l[a])&&D.isObject(u[a])?f(l[a],u[a],g):g&&(l[a]=u[a]):l[a]=u[a])})}i.merge=f;function m(l,u,g){const a=l.inspect(u),s=l.inspect(g);return typeof a.userValue<"u"||typeof a.workspaceValue<"u"||typeof a.workspaceFolderValue<"u"?a.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:a.defaultValue}i.getMigratedSettingValue=m;function y(l){return l.replace(/[\[\]]/g,"")}i.getLanguageTagSettingPlainKey=y}),define(Q[58],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,D.createDecorator)("downloadService")}),define(Q[18],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,D.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,D.refineServiceDecorator)(i.IEnvironmentService)}),define(Q[22],Z([0,1,83,8]),function(B,i,D,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IServerExtensionManagementService=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";function w(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=w;function O(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=O;function L(l,u){switch(l){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=L;function p(l,u){return u==="web"&&!l.includes("web")}i.isNotWebExtensionInWebTargetPlatform=p;function c(l,u,g){return p(u,g)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===g?!0:d(g).includes(l)}i.isTargetPlatformCompatible=c;function d(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=d;function C(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}i.isIExtensionIdentifier=C;var E;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(E=i.SortBy||(i.SortBy={}));var h;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(h=i.SortOrder||(i.SortOrder={}));var v;(function(l){l.Install="install",l.Uninstall="uninstall"})(v=i.StatisticType||(i.StatisticType={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,b.createDecorator)("extensionGalleryService");var m;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal"})(m=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class y extends Error{constructor(u,g){super(u),this.code=g,this.name=g}}i.ExtensionManagementError=y,i.IExtensionManagementService=(0,b.createDecorator)("extensionManagementService"),i.IServerExtensionManagementService=(0,b.refineServiceDecorator)(i.IExtensionManagementService),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,b.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,b.createDecorator)("IExtensionTipsService"),i.ExtensionsLabel=(0,D.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,D.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,b.createDecorator)("IExtensionManagementCLIService")}),define(Q[59],Z([0,1,15,12,91,11]),function(B,i,D,b,w,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function L(C,E,h,v,f,m){let y;try{await p(C,E,h,v,f,m)}catch(l){y=l}finally{y&&f.errorTransformer&&(y=f.errorTransformer(y)),typeof y<"u"&&h.error(y),h.end()}}i.readFileIntoStream=L;async function p(C,E,h,v,f,m){c(m);const y=await C.open(E,{create:!1});try{c(m);let l=0,u=0,g=f&&typeof f.length=="number"?f.length:void 0,a=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof g=="number"?g:f.bufferSize)),s=f&&typeof f.position=="number"?f.position:0,e=0;do u=await C.read(y,s,a.buffer,e,a.byteLength-e),s+=u,e+=u,l+=u,typeof g=="number"&&(g-=u),e===a.byteLength&&(await h.write(v(a)),a=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof g=="number"?g:f.bufferSize)),e=0);while(u>0&&(typeof g!="number"||g>0)&&c(m)&&d(l,f));if(e>0){let n=e;typeof g=="number"&&(n=Math.min(e,g)),h.write(v(a.slice(0,n)))}}catch(l){throw(0,O.ensureFileSystemProviderError)(l)}finally{await C.close(y)}}function c(C){if(C.isCancellationRequested)throw(0,b.canceled)();return!0}function d(C,E){if(E?.limits){if(typeof E.limits.memory=="number"&&C>E.limits.memory)throw(0,O.createFileSystemProviderError)((0,w.localize)(0,null),O.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&C>E.limits.size)throw(0,O.createFileSystemProviderError)((0,w.localize)(1,null),O.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[106],Z([0,1,4,150,2,13,151]),function(B,i,D,b,w,O,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcher=void 0;class p extends w.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(d){const C=this.normalizeRequests(d),E=C.filter(v=>{const f=this.watchers.get(v.path);return f?!(0,b.patternsEquals)(f.request.excludes,v.excludes)||!(0,b.patternsEquals)(f.request.includes,v.includes):!0}),h=Array.from(this.watchers.values()).filter(({request:v})=>!C.find(f=>f.path===v.path&&(0,b.patternsEquals)(f.excludes,v.excludes)&&(0,b.patternsEquals)(f.includes,v.includes))).map(({request:v})=>v.path);E.length&&this.trace(`Request to start watching: ${E.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),h.length&&this.trace(`Request to stop watching: ${h.join(",")}`);for(const v of h)this.stopWatching(v);for(const v of E)this.startWatching(v)}startWatching(d){const C=new L.NodeJSFileWatcherLibrary(d,h=>this._onDidChangeFile.fire(h),h=>this._onDidLogMessage.fire(h),this.verboseLogging),E={request:d,instance:C};this.watchers.set(d.path,E)}async stop(){for(const[d]of this.watchers)this.stopWatching(d);this.watchers.clear()}stopWatching(d){const C=this.watchers.get(d);C&&(this.watchers.delete(d),C.instance.dispose())}normalizeRequests(d){const C=new Map;for(const E of d){const h=O.isLinux?E.path:E.path.toLowerCase();C.set(h,E)}return Array.from(C.values())}async setVerboseLogging(d){this.verboseLogging=d;for(const[,C]of this.watchers)C.instance.setVerboseLogging(d)}trace(d){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(d)})}toMessage(d,C){return C?`[File Watcher (node.js)] ${d} (path: ${C.request.path})`:`[File Watcher (node.js)] ${d}`}}i.NodeJSWatcher=p}),define(Q[107],Z([0,1,60,106]),function(B,i,D,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NodeJSWatcherClient=void 0;class w extends D.AbstractNonRecursiveWatcherClient{constructor(L,p,c){super(L,p,c),this.init()}createWatcher(){return new b.NodeJSWatcher}}i.NodeJSWatcherClient=w}),define(Q[108],Z([0,1,16,56,78,60]),function(B,i,D,b,w,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UniversalWatcherClient=void 0;class L extends O.AbstractUniversalWatcherClient{constructor(c,d,C){super(c,d,C),this.init()}createWatcher(c){const d=c.add(new w.Client(D.FileAccess.asFileUri("bootstrap-fork",B).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return c.add(d.onDidProcessExit(({code:C,signal:E})=>this.onError(`terminated by itself with code ${C}, signal: ${E}`))),b.ProxyChannel.toService((0,b.getNextTickChannel)(d.getChannel("watcher")))}}i.UniversalWatcherClient=L}),define(Q[61],Z([0,1]),function(B,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class D{constructor(...w){this._entries=new Map;for(const[O,L]of w)this.set(O,L)}set(w,O){const L=this._entries.get(w);return this._entries.set(w,O),L}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}i.ServiceCollection=D}),define(Q[109],Z([0,1,3,12,46,105,8,61]),function(B,i,D,b,w,O,L,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Trace=i.InstantiationService=void 0;const c=!1;class d extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class C{constructor(f=new p.ServiceCollection,m=!1,y){this._activeInstantiations=new Set,this._services=f,this._strict=m,this._parent=y,this._services.set(L.IInstantiationService,this)}createChild(f){return new C(f,this._strict,this)}invokeFunction(f,...m){const y=h.traceInvocation(f);let l=!1;try{return f({get:g=>{if(l)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(g,y);if(!a)throw new Error(`[invokeFunction] unknown service '${g}'`);return a}},...m)}finally{l=!0,y.stop()}}createInstance(f,...m){let y,l;return f instanceof w.SyncDescriptor?(y=h.traceCreation(f.ctor),l=this._createInstance(f.ctor,f.staticArguments.concat(m),y)):(y=h.traceCreation(f),l=this._createInstance(f,m,y)),y.stop(),l}_createInstance(f,m=[],y){const l=L._util.getServiceDependencies(f).sort((a,s)=>a.index-s.index),u=[];for(const a of l){const s=this._getOrCreateServiceInstance(a.id,y);s||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${a.id}.`,!1),u.push(s)}const g=l.length>0?l[0].index:m.length;if(m.length!==g){console.trace(`[createInstance] First service dependency of ${f.name} at position ${g+1} conflicts with ${m.length} static arguments`);const a=g-m.length;a>0?m=m.concat(new Array(a)):m=m.slice(0,g)}return new f(...m,...u)}_setServiceInstance(f,m){if(this._services.get(f)instanceof w.SyncDescriptor)this._services.set(f,m);else if(this._parent)this._parent._setServiceInstance(f,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const m=this._services.get(f);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):m}_getOrCreateServiceInstance(f,m){const y=this._getServiceInstanceOrDescriptor(f);return y instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,y,m.branch(f,!0)):(m.branch(f,!1),y)}_safeCreateAndCacheServiceInstance(f,m,y){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,m,y)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,m,y){const l=new O.Graph(a=>a.id.toString());let u=0;const g=[{id:f,desc:m,_trace:y}];for(;g.length;){const a=g.pop();if(l.lookupOrInsertNode(a),u++>1e3)throw new d(l);for(const s of L._util.getServiceDependencies(a.desc.ctor)){const e=this._getServiceInstanceOrDescriptor(s.id);if(e||this._throwIfStrict(`[createInstance] ${f} depends on ${s.id} which is NOT registered.`,!0),e instanceof w.SyncDescriptor){const n={id:s.id,desc:e,_trace:a._trace.branch(s.id,!0)};l.insertEdge(a,n),g.push(n)}}}for(;;){const a=l.roots();if(a.length===0){if(!l.isEmpty())throw new d(l);break}for(const{data:s}of a){if(this._getServiceInstanceOrDescriptor(s.id)instanceof w.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}l.removeNode(s)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,m,y=[],l,u){if(this._services.get(f)instanceof w.SyncDescriptor)return this._createServiceInstance(m,y,l,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,m,y,l,u);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(f,m=[],y,l){if(y){const u=new D.IdleValue(()=>this._createInstance(f,m,l));return new Proxy(Object.create(null),{get(g,a){if(a in g)return g[a];const s=u.value;let e=s[a];return typeof e!="function"||(e=e.bind(s),g[a]=e),e},set(g,a,s){return u.value[a]=s,!0}})}else return this._createInstance(f,m,l)}_throwIfStrict(f,m){if(m&&console.warn(f),this._strict)throw new Error(f)}}i.InstantiationService=C;var E;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(E||(E={}));class h{constructor(f,m){this.type=f,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return c?new h(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(f){return c?new h(0,f.name):h._None}branch(f,m){const y=new h(2,f.toString());return this._dep.push([f,m,y]),y}stop(){const f=Date.now()-this._start;h._totals+=f;let m=!1;function y(u,g){const a=[],s=new Array(u+1).join("	");for(const[e,n,t]of g._dep)if(n&&t){m=!0,a.push(`${s}CREATES -> ${e}`);const r=y(u+1,t);r&&a.push(r)}else a.push(`${s}uses -> ${e}`);return a.join(`
`)}const l=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(f>2||m)&&console.log(l.join(`
`))}}i.Trace=h,h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0});var ee=this&&this.__param||function(B,i){return function(D,b){i(D,b,B)}};define(Q[62],Z([0,1,24,2,13,93,22,8]),function(B,i,D,b,w,O,L,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LanguagePackBaseService=i.ILanguagePackService=void 0,i.ILanguagePackService=(0,p.createDecorator)("languagePackService");let c=class extends b.Disposable{constructor(C){super(),this.extensionGalleryService=C}async getAvailableLanguages(){const C=new D.CancellationTokenSource;setTimeout(()=>C.cancel(),1e3);let E;try{E=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},C.token)}catch{return[]}const v=E.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(m=>m.startsWith("lp-"))).map(f=>{const m=f.properties.localizedLanguages?.[0],y=this.getLocale(f);return{...this.createQuickPickItem(y,m,f),extensionId:f.identifier.id,galleryExtension:f}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(C){return C.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(C,E,h){const v=E??C;let f;if(v!==C&&(f=`(${C})`),C.toLowerCase()===w.language.toLowerCase()&&(f??="",f+=(0,O.localize)(0,null)),h?.installCount){f??="";const m=h.installCount;let y;m>1e6?y=`${Math.floor(m/1e5)/10}M`:m>1e3?y=`${Math.floor(m/1e3)}K`:y=String(m),f+=` $(cloud-download) ${y}`}return{id:C,label:v,description:f}}};c=he([ee(0,L.IExtensionGalleryService)],c),i.LanguagePackBaseService=c}),define(Q[9],Z([0,1,31,4,2,13,8]),function(B,i,D,b,w,O,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,L.createDecorator)("logService"),i.ILoggerService=(0,L.createDecorator)("loggerService");function p(){return new Date().toISOString()}var c;(function(n){n[n.Trace=0]="Trace",n[n.Debug=1]="Debug",n[n.Info=2]="Info",n[n.Warning=3]="Warning",n[n.Error=4]="Error",n[n.Critical=5]="Critical",n[n.Off=6]="Off"})(c=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=c.Info;function d(n,t,r){switch(t){case c.Trace:n.trace(r);break;case c.Debug:n.debug(r);break;case c.Info:n.info(r);break;case c.Warning:n.warn(r);break;case c.Error:n.error(r);break;case c.Critical:n.critical(r);break;default:throw new Error("Invalid log level")}}i.log=d;function C(n){let t="";for(let r=0;r<n.length;r++){let o=n[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}t+=(r>0?" ":"")+o}return t}i.format=C;class E extends w.Disposable{constructor(){super(...arguments),this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=E;class h extends E{constructor(t){super(),this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(c.Trace)&&this.log(c.Trace,C([t,...r]))}debug(t,...r){this.checkLogLevel(c.Debug)&&this.log(c.Debug,C([t,...r]))}info(t,...r){this.checkLogLevel(c.Info)&&this.log(c.Info,C([t,...r]))}warn(t,...r){this.checkLogLevel(c.Warning)&&this.log(c.Warning,C([t,...r]))}error(t,...r){if(this.checkLogLevel(c.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(c.Error,C(o))}else this.log(c.Error,C([t,...r]))}critical(t,...r){this.checkLogLevel(c.Critical)&&this.log(c.Critical,C([t,...r]))}flush(){}}i.AbstractMessageLogger=h;class v extends E{constructor(t=i.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.useColors=!O.isWindows}trace(t,...r){this.getLevel()<=c.Trace&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,t,...r):console.log(`[main ${p()}]`,t,...r))}debug(t,...r){this.getLevel()<=c.Debug&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,t,...r):console.log(`[main ${p()}]`,t,...r))}info(t,...r){this.getLevel()<=c.Info&&(this.useColors?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,t,...r):console.log(`[main ${p()}]`,t,...r))}warn(t,...r){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,t,...r):console.warn(`[main ${p()}]`,t,...r))}error(t,...r){this.getLevel()<=c.Error&&(this.useColors?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,t,...r):console.error(`[main ${p()}]`,t,...r))}critical(t,...r){this.getLevel()<=c.Critical&&(this.useColors?console.error(`\x1B[90m[main ${p()}]\x1B[0m`,t,...r):console.error(`[main ${p()}]`,t,...r))}dispose(){}flush(){}}i.ConsoleMainLogger=v;class f extends E{constructor(t=i.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...r){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}i.ConsoleLogger=f;class m extends E{constructor(t,r=i.DEFAULT_LOG_LEVEL){super(),this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=c.Trace)}dispose(){}flush(){}}i.AdapterLogger=m;class y extends E{constructor(t){super(),this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const o of this.logServices)o.trace(t,...r)}debug(t,...r){for(const o of this.logServices)o.debug(t,...r)}info(t,...r){for(const o of this.logServices)o.info(t,...r)}warn(t,...r){for(const o of this.logServices)o.warn(t,...r)}error(t,...r){for(const o of this.logServices)o.error(t,...r)}critical(t,...r){for(const o of this.logServices)o.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}i.MultiplexLogService=y;class l extends w.Disposable{constructor(t){super(),this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}i.LogService=l;class u extends w.Disposable{constructor(t,r){super(),this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(S=>S.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,r){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,r?.always?c.Trace:this.logLevel,r),this.loggers.set(t.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=u;class g{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(t){}getLevel(){return c.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}i.NullLogService=g;function a(n){if(n.verbose)return c.Trace;if(typeof n.logLevel=="string"){const t=s(n.logLevel.toLowerCase());if(t!==void 0)return t}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=a;function s(n){switch(n){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}i.parseLogLevel=s;function e(n){switch(n){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}i.LogLevelToString=e}),define(Q[110],Z([0,1,19,3,12,4,2,14,60,9]),function(B,i,D,b,w,O,L,p,c,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class C extends L.Disposable{constructor(h,v){super(),this.logService=h,this.options=v,this._onDidChangeFile=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new b.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new b.ThrottledDelayer(0))}watch(h,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(h,v):this.watchNonRecursive(h,v)}watchUniversal(h,v){const f={path:this.toFilePath(h),excludes:v.excludes,includes:v.includes,recursive:v.recursive},m=(0,D.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(h=>(0,w.onUnexpectedError)(h))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,c.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)})));const h=this.options?.watcher?.recursive?.usePolling;if(h===!0)for(const v of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const v of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(v)&&h.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(h,v){const f={path:this.toFilePath(h),excludes:v.excludes,includes:v.includes,recursive:!1},m=(0,D.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(h=>(0,w.onUnexpectedError)(h))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(h=>this._onDidChangeFile.fire((0,c.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(h){h.type==="error"&&this._onDidWatchError.fire(h.message),this.logService[h.type](h.message)}toFilePath(h){return(0,p.normalize)(h.fsPath)}}i.AbstractDiskFileSystemProvider=C}),define(Q[111],Z([0,1,19,3,15,24,4,53,63,2,36,16,112,17,43,90,11,59,9]),function(B,i,D,b,w,O,L,p,c,d,C,E,h,v,f,m,y,l,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let g=class extends d.Disposable{constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(s,e){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${s}`);const n=new d.DisposableStore;return this.provider.set(s,e),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:e}),n.add(e.onDidChangeFile(t=>this._onDidFilesChange.fire(new y.FileChangesEvent(t,!this.isPathCaseSensitive(e))))),typeof e.onDidWatchError=="function"&&n.add(e.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),n.add(e.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:e,scheme:s}))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:e}),this.provider.delete(s),(0,d.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const e=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){e.push(n)}}),!this.provider.has(s)&&await b.Promises.settled(e)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,e){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&e)}listCapabilities(){return c.Iterable.map(this.provider,([s,e])=>({scheme:s,capabilities:e.capabilities}))}async withProvider(s){if(!(0,v.isAbsolutePath)(s))throw new y.FileOperationError((0,m.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const e=this.provider.get(s.scheme);if(!e){const n=new Error;throw n.name="ENOPRO",n.message=(0,m.localize)(1,null,s.toString()),n}return e}async withReadProvider(s){const e=await this.withProvider(s);if((0,y.hasOpenReadWriteCloseCapability)(e)||(0,y.hasReadWriteCapability)(e)||(0,y.hasFileReadStreamCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const e=await this.withProvider(s);if((0,y.hasOpenReadWriteCloseCapability)(e)||(0,y.hasReadWriteCapability)(e))return e;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,e){try{return await this.doResolveFile(s,e)}catch(n){throw(0,y.toFileSystemProviderErrorCode)(n)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,m.localize)(2,null,this.resourceForError(s)),1):(0,y.ensureFileSystemProviderError)(n)}}async doResolveFile(s,e){const n=await this.withProvider(s),t=this.isPathCaseSensitive(n),r=e?.resolveTo,o=e?.resolveSingleChildDescendants,S=e?.resolveMetadata,P=await n.stat(s);let I;return this.toFileStat(n,s,P,void 0,!!S,(k,V)=>(I||(I=C.TernarySearchTree.forUris(()=>!t),I.set(s,!0),r&&I.fill(!0,r)),I.get(k.resource)||I.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&o?V===1:!1))}async toFileStat(s,e,n,t,r,o){const{providerExtUri:S}=this.getExtUri(s),P={resource:e,name:S.basename(e),isFile:(n.type&y.FileType.File)!==0,isDirectory:(n.type&y.FileType.Directory)!==0,isSymbolicLink:(n.type&y.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&y.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,y.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(P.isDirectory&&o(P,t)){try{const I=await s.readdir(e),k=await b.Promises.settled(I.map(async([V,G])=>{try{const Y=S.joinPath(e,V),X=r?await s.stat(Y):{type:G};return await this.toFileStat(s,Y,X,I.length,r,o)}catch(Y){return this.logService.trace(Y),null}}));P.children=(0,D.coalesce)(k)}catch(I){this.logService.trace(I),P.children=[]}return P}return P}async resolveAll(s){return b.Promises.settled(s.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const e=await this.withProvider(s),n=await e.stat(s);return this.toFileStat(e,s,n,void 0,!0,()=>!1)}async exists(s){const e=await this.withProvider(s);try{return!!await e.stat(s)}catch{return!1}}async canCreateFile(s,e){try{await this.doValidateCreateFile(s,e)}catch(n){return n}return!0}async doValidateCreateFile(s,e){if(!e?.overwrite&&await this.exists(s))throw new y.FileOperationError((0,m.localize)(3,null,this.resourceForError(s)),3,e)}async createFile(s,e=w.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const t=await this.writeFile(s,e);return this._onDidRunOperation.fire(new y.FileOperationEvent(s,0,t)),t}async writeFile(s,e,n){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:r}=this.getExtUri(t);try{await this.validateWriteFile(t,s,n)||await this.mkdirp(t,r.dirname(s));let S;if((0,y.hasReadWriteCapability)(t)&&!(e instanceof w.VSBuffer))if((0,f.isReadableStream)(e)){const P=await(0,f.peekStream)(e,3);P.ended?S=w.VSBuffer.concat(P.buffer):S=P}else S=(0,f.peekReadable)(e,P=>w.VSBuffer.concat(P),3);else S=e;!(0,y.hasOpenReadWriteCloseCapability)(t)||(0,y.hasReadWriteCapability)(t)&&S instanceof w.VSBuffer?await this.doWriteUnbuffered(t,s,n,S):await this.doWriteBuffered(t,s,n,S instanceof w.VSBuffer?(0,w.bufferToReadable)(S):S),this._onDidRunOperation.fire(new y.FileOperationEvent(s,4))}catch(o){throw new y.FileOperationError((0,m.localize)(4,null,this.resourceForError(s),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,e,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(e)));let r;try{r=await s.stat(e)}catch{return}if((r.type&y.FileType.Directory)!==0)throw new y.FileOperationError((0,m.localize)(6,null,this.resourceForError(e)),0,n);if(this.throwIfFileIsReadonly(e,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==y.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,y.etag)({mtime:n.mtime,size:r.size}))throw new y.FileOperationError((0,m.localize)(7,null),3,n);return r}async readFile(s,e,n){const t=await this.withReadProvider(s);return e?.atomic?this.doReadFileAtomic(t,s,e,n):this.doReadFile(t,s,e,n)}async doReadFileAtomic(s,e,n,t){return new Promise((r,o)=>{this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{try{const S=await this.doReadFile(s,e,n,t);r(S)}catch(S){o(S)}})})}async doReadFile(s,e,n,t){const r=await this.doReadFileStream(s,e,{...n,preferUnbuffered:!0},t);return{...r,value:await(0,w.streamToBuffer)(r.value)}}async readFileStream(s,e,n){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,e,n)}async doReadFileStream(s,e,n,t){const r=new O.CancellationTokenSource(t),o=this.validateReadFile(e,n).then(P=>P,P=>{throw r.cancel(),P});let S;try{return typeof n?.etag=="string"&&n.etag!==y.ETAG_DISABLED&&await o,n?.atomic&&(0,y.hasFileAtomicReadCapability)(s)||!((0,y.hasOpenReadWriteCloseCapability)(s)||(0,y.hasFileReadStreamCapability)(s))||(0,y.hasReadWriteCapability)(s)&&n?.preferUnbuffered?S=this.readFileUnbuffered(s,e,n):(0,y.hasFileReadStreamCapability)(s)?S=this.readFileStreamed(s,e,r.token,n):S=this.readFileBuffered(s,e,r.token,n),{...await o,value:S}}catch(P){S&&await(0,f.consumeStream)(S);const I=(0,m.localize)(8,null,this.resourceForError(e),(0,y.ensureFileSystemProviderError)(P).toString());throw P instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(I,P.stat,n):new y.FileOperationError(I,(0,y.toFileOperationResult)(P),n)}}readFileStreamed(s,e,n,t=Object.create(null)){const r=s.readFileStream(e,t,n);return(0,f.transform)(r,{data:o=>o instanceof w.VSBuffer?o:w.VSBuffer.wrap(o),error:o=>new y.FileOperationError((0,m.localize)(9,null,this.resourceForError(e),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),t)},o=>w.VSBuffer.concat(o))}readFileBuffered(s,e,n,t=Object.create(null)){const r=(0,w.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,e,r,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new y.FileOperationError((0,m.localize)(10,null,this.resourceForError(e),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),t)},n),r}readFileUnbuffered(s,e,n){const t=(0,f.newWriteableStream)(r=>w.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,y.hasFileAtomicReadCapability)(s)?r=await s.readFile(e,{atomic:!0}):r=await s.readFile(e),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(e,r.byteLength,n),t.end(w.VSBuffer.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async validateReadFile(s,e){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new y.FileOperationError((0,m.localize)(11,null,this.resourceForError(s)),0,e);if(typeof e?.etag=="string"&&e.etag!==y.ETAG_DISABLED&&e.etag===n.etag)throw new y.NotModifiedSinceFileOperationError((0,m.localize)(12,null),n,e);return this.validateReadFileLimits(s,n.size,e),n}validateReadFileLimits(s,e,n){if(n?.limits){let t;if(typeof n.limits.memory=="number"&&e>n.limits.memory&&(t=9),typeof n.limits.size=="number"&&e>n.limits.size&&(t=7),typeof t=="number")throw new y.FileOperationError((0,m.localize)(13,null,this.resourceForError(s)),t)}}async canMove(s,e,n){return this.doCanMoveCopy(s,e,"move",n)}async canCopy(s,e,n){return this.doCanMoveCopy(s,e,"copy",n)}async doCanMoveCopy(s,e,n,t){if(s.toString()!==e.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);await this.doValidateMoveCopy(r,s,o,e,n,t)}catch(r){return r}return!0}async move(s,e,n){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(t,s,r,e,"move",!!n),S=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,o==="move"?2:3,S)),S}async copy(s,e,n){const t=await this.withReadProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),o=await this.doMoveCopy(t,s,r,e,"copy",!!n),S=await this.resolve(e,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,o==="copy"?3:2,S)),S}async doMoveCopy(s,e,n,t,r,o){if(e.toString()===t.toString())return r;const{exists:S,isSameResourceWithDifferentPathCase:P}=await this.doValidateMoveCopy(s,e,n,t,r,o);if(S&&!P&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(t)),r==="copy"){if(s===n&&(0,y.hasFileFolderCopyCapability)(s))await s.copy(e,t,{overwrite:o});else{const I=await this.resolve(e);I.isDirectory?await this.doCopyFolder(s,I,n,t):await this.doCopyFile(s,e,n,t)}return r}else return s===n?(await s.rename(e,t,{overwrite:o}),r):(await this.doMoveCopy(s,e,n,t,"copy",o),await this.del(e,{recursive:!0}),"copy")}async doCopyFile(s,e,n,t){if((0,y.hasOpenReadWriteCloseCapability)(s)&&(0,y.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,e,n,t);if((0,y.hasOpenReadWriteCloseCapability)(s)&&(0,y.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,e,n,t);if((0,y.hasReadWriteCapability)(s)&&(0,y.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,e,n,t);if((0,y.hasReadWriteCapability)(s)&&(0,y.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,e,n,t)}async doCopyFolder(s,e,n,t){await n.mkdir(t),Array.isArray(e.children)&&await b.Promises.settled(e.children.map(async r=>{const o=this.getExtUri(n).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.doCopyFolder(s,await this.resolve(r.resource),n,o):this.doCopyFile(s,r.resource,n,o)}))}async doValidateMoveCopy(s,e,n,t,r,o){let S=!1;if(s===n){const{providerExtUri:I,isPathCaseSensitive:k}=this.getExtUri(s);if(k||(S=I.isEqual(e,t)),S&&r==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(e),this.resourceForError(t)));if(!S&&I.isEqualOrParent(t,e))throw new Error((0,m.localize)(15,null,this.resourceForError(e),this.resourceForError(t)))}const P=await this.exists(t);if(P&&!S){if(!o)throw new y.FileOperationError((0,m.localize)(16,null,this.resourceForError(e),this.resourceForError(t)),4);if(s===n){const{providerExtUri:I}=this.getExtUri(s);if(I.isEqualOrParent(e,t))throw new Error((0,m.localize)(17,null,this.resourceForError(e),this.resourceForError(t)))}}return{exists:P,isSameResourceWithDifferentPathCase:S}}getExtUri(s){const e=this.isPathCaseSensitive(s);return{providerExtUri:e?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:e}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(e,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,0,n)),n}async mkdirp(s,e){const n=[],{providerExtUri:t}=this.getExtUri(s);for(;!t.isEqual(e,t.dirname(e));)try{if(((await s.stat(e)).type&y.FileType.Directory)===0)throw new Error((0,m.localize)(18,null,this.resourceForError(e)));break}catch(r){if((0,y.toFileSystemProviderErrorCode)(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(t.basename(e)),e=t.dirname(e)}for(let r=n.length-1;r>=0;r--){e=t.joinPath(e,n[r]);try{await s.mkdir(e)}catch(o){if((0,y.toFileSystemProviderErrorCode)(o)!==y.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,e){try{await this.doValidateDelete(s,e)}catch(n){return n}return!0}async doValidateDelete(s,e){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!e?.useTrash&&!(n.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.throwIfFileIsReadonly(s,r);else throw new y.FileOperationError((0,m.localize)(20,null,this.resourceForError(s)),1);if(!!!e?.recursive){const S=await this.resolve(s);if(S.isDirectory&&Array.isArray(S.children)&&S.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(s)))}return n}async del(s,e){const n=await this.doValidateDelete(s,e),t=!!e?.useTrash,r=!!e?.recursive;await n.delete(s,{recursive:r,useTrash:t}),this._onDidRunOperation.fire(new y.FileOperationEvent(s,1))}async cloneFile(s,e){const n=await this.withProvider(s),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);if(n===t&&this.getExtUri(n).providerExtUri.isEqual(s,e))return;if(n===t&&(0,y.hasFileCloneCapability)(n))return n.cloneFile(s,e);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(e));const r=this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri);return n===t&&(0,y.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,e,{overwrite:!0})):r.queue(()=>this.doCopyFile(n,s,t,e))}watch(s,e={recursive:!1,excludes:[]}){const n=new d.DisposableStore;let t=!1,r=()=>{t=!0};return n.add((0,d.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(s,e);t?(0,d.dispose)(o):r=()=>(0,d.dispose)(o)}catch(o){this.logService.error(o)}})(),n}async doWatch(s,e){const n=await this.withProvider(s),t=(0,p.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(s),e]);let r=this.activeWatchers.get(t);return r||(r={count:0,disposable:n.watch(s,e)},this.activeWatchers.set(t,r)),r.count+=1,(0,d.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,d.dispose)(r.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,d.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,e,n,t){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(async()=>{const r=await s.open(e,{create:!0,unlock:n?.unlock??!1});try{(0,f.isReadableStream)(t)||(0,f.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(s,r,t):await this.doWriteReadableBufferedQueued(s,r,t)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async doWriteStreamBufferedQueued(s,e,n){let t=0,r;if((0,f.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=w.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,e,o,o.byteLength,t,0),t+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,S)=>{(0,f.listenStream)(r,{onData:async P=>{r.pause();try{await this.doWriteBuffer(s,e,P,P.byteLength,t,0)}catch(I){return S(I)}t+=P.byteLength,setTimeout(()=>r.resume())},onError:P=>S(P),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,e,n){let t=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(s,e,r,r.byteLength,t,0),t+=r.byteLength}async doWriteBuffer(s,e,n,t,r,o){let S=0;for(;S<t;)S+=await s.write(e,r+S,n.buffer,o+S,t-S)}async doWriteUnbuffered(s,e,n,t){return this.writeQueue.queueFor(e,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,e,n,t))}async doWriteUnbufferedQueued(s,e,n,t){let r;t instanceof w.VSBuffer?r=t:(0,f.isReadableStream)(t)?r=await(0,w.streamToBuffer)(t):(0,f.isReadableBufferedStream)(t)?r=await(0,w.bufferedStreamToBuffer)(t):r=(0,w.readableToBuffer)(t),await s.writeFile(e,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(s,e,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,e,n,t))}async doPipeBufferedQueued(s,e,n,t){let r,o;try{r=await s.open(e,{create:!1}),o=await n.open(t,{create:!0,unlock:!1});const S=w.VSBuffer.alloc(this.BUFFER_SIZE);let P=0,I=0,k=0;do k=await s.read(r,P,S.buffer,I,S.byteLength-I),await this.doWriteBuffer(n,o,S,k,P,I),P+=k,I+=k,I===S.byteLength&&(I=0);while(k>0)}catch(S){throw(0,y.ensureFileSystemProviderError)(S)}finally{await b.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,e,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,e,n,t))}async doPipeUnbufferedQueued(s,e,n,t){return n.writeFile(t,await s.readFile(e),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,e,n,t){return this.writeQueue.queueFor(t,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,e,n,t))}async doPipeUnbufferedToBufferedQueued(s,e,n,t){const r=await n.open(t,{create:!0,unlock:!1});try{const o=await s.readFile(e);await this.doWriteBuffer(n,r,w.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(s,e,n,t){const r=await(0,w.streamToBuffer)(this.readFileBuffered(s,e,O.CancellationToken.None));await this.doWriteUnbuffered(n,t,void 0,r)}throwIfFileSystemIsReadonly(s,e){if(s.capabilities&2048)throw new y.FileOperationError((0,m.localize)(22,null,this.resourceForError(e)),6);return s}throwIfFileIsReadonly(s,e){if((e.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,m.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===E.Schemas.file?s.fsPath:s.toString(!0)}};g=he([ee(0,u.ILogService)],g),i.FileService=g}),define(Q[113],Z([0,1,114,152,3,36,15,4,153,2,14,13,17,43,20,92,11,59,110,31,108,107]),function(B,i,D,b,w,O,L,p,c,d,C,E,h,v,f,m,y,l,u,g,a,s){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,b.gracefulify)(D)}catch(n){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(n)}`)}})();class e extends u.AbstractDiskFileSystemProvider{constructor(t,r){super(t,r),this.onDidChangeCapabilities=p.Event.None,this.resourceLocks=new O.ResourceMap(o=>h.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:r,symbolicLink:o}=await f.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(t){try{const r=await f.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async S=>{try{let P;S.isSymbolicLink()?P=(await this.stat((0,h.joinPath)(t,S.name))).type:P=this.toType(S),o.push([S.name,P])}catch(P){this.logService.trace(P)}})),o}catch(r){throw this.toFileSystemProviderError(r)}}toType(t,r){let o;return r?.dangling?o=y.FileType.Unknown:t.isFile()?o=y.FileType.File:t.isDirectory()?o=y.FileType.Directory:o=y.FileType.Unknown,r&&(o|=y.FileType.SymbolicLink),o}async createResourceLock(t){const r=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const S=new w.Barrier;return this.resourceLocks.set(t,S),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,d.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(t)===S&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),S.open()})}async readFile(t,r){let o;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const S=this.toFilePath(t);return await f.Promises.readFile(S)}catch(S){throw this.toFileSystemProviderError(S)}finally{o?.dispose()}}readFileStream(t,r,o){const S=(0,v.newWriteableStream)(P=>L.VSBuffer.concat(P.map(I=>L.VSBuffer.wrap(I))).buffer);return(0,l.readFileIntoStream)(this,t,S,P=>P.buffer,{...r,bufferSize:256*1024},o),S}async writeFile(t,r,o){let S;try{const P=this.toFilePath(t);if(!o.create||!o.overwrite){if(await f.Promises.exists(P)){if(!o.overwrite)throw(0,y.createFileSystemProviderError)((0,m.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,y.createFileSystemProviderError)((0,m.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(S,0,r,0,r.byteLength)}catch(P){throw await this.toFileSystemProviderWriteError(t,P)}finally{typeof S=="number"&&await this.close(S)}}static configureFlushOnWrite(t){e.canFlush=t}async open(t,r){const o=this.toFilePath(t);let S;(0,y.isFileOpenForWriteOptions)(r)&&(S=await this.createResourceLock(t));let P;try{if((0,y.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:k}=await f.SymlinkSupport.stat(o);k.mode&128||await f.Promises.chmod(o,k.mode|128)}catch(k){this.logService.trace(k)}let I;if((0,y.isFileOpenForWriteOptions)(r)){if(E.isWindows)try{await f.Promises.truncate(o,0),I="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}I||(I="w")}else I="r";P=await f.Promises.open(o,I)}catch(I){throw S?.dispose(),(0,y.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(t,I):this.toFileSystemProviderError(I)}if(this.mapHandleToPos.set(P,0),(0,y.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(P,t),S){const I=this.mapHandleToLock.get(P);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${o})`),this.mapHandleToLock.set(P,S),I&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${o})`),I.dispose())}return P}async close(t){const r=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&e.canFlush)try{await f.Promises.fdatasync(t)}catch(o){e.configureFlushOnWrite(!1),this.logService.error(o)}return await f.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{r&&(this.mapHandleToLock.get(t)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),r.dispose())}}async read(t,r,o,S,P){const I=this.normalizePos(t,r);let k=null;try{k=(await f.Promises.read(t,o,S,P,I)).bytesRead}catch(V){throw this.toFileSystemProviderError(V)}finally{this.updatePos(t,I,k)}return k}normalizePos(t,r){return r===this.mapHandleToPos.get(t)?null:r}updatePos(t,r,o){const S=this.mapHandleToPos.get(t);typeof S=="number"&&(typeof r=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,S+o):this.mapHandleToPos.delete(t)))}async write(t,r,o,S,P){return(0,w.retry)(()=>this.doWrite(t,r,o,S,P),100,3)}async doWrite(t,r,o,S,P){const I=this.normalizePos(t,r);let k=null;try{k=(await f.Promises.write(t,o,S,P,I)).bytesWritten}catch(V){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),V)}finally{this.updatePos(t,I,k)}return k}async mkdir(t){try{await f.Promises.mkdir(this.toFilePath(t))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(t,r){try{const o=this.toFilePath(t);r.recursive?await f.Promises.rm(o,f.RimRafMode.MOVE):await f.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,r,o){const S=this.toFilePath(t),P=this.toFilePath(r);if(S!==P)try{await this.validateTargetDeleted(t,r,"move",o.overwrite),await f.Promises.move(S,P)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,m.localize)(2,null,(0,C.basename)(S),(0,C.basename)((0,C.dirname)(P)),I.toString()))),this.toFileSystemProviderError(I)}}async copy(t,r,o){const S=this.toFilePath(t),P=this.toFilePath(r);if(S!==P)try{await this.validateTargetDeleted(t,r,"copy",o.overwrite),await f.Promises.copy(S,P,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,m.localize)(3,null,(0,C.basename)(S),(0,C.basename)((0,C.dirname)(P)),I.toString()))),this.toFileSystemProviderError(I)}}async validateTargetDeleted(t,r,o,S){const P=this.toFilePath(t),I=this.toFilePath(r);let k=!1;if(!!(this.capabilities&1024)||(k=(0,c.isEqual)(P,I,!0)),k&&o==="copy")throw(0,y.createFileSystemProviderError)((0,m.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!k&&await f.Promises.exists(I)){if(!S)throw(0,y.createFileSystemProviderError)((0,m.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(t,r){return this.doCloneFile(t,r,!1)}async doCloneFile(t,r,o){const S=this.toFilePath(t),P=this.toFilePath(r),I=!!(this.capabilities&1024);if((0,c.isEqual)(S,P,!I))return;const k=new d.DisposableStore;try{const[V,G]=await Promise.all([this.createResourceLock(t),this.createResourceLock(r)]);k.add(V),k.add(G),o&&await f.Promises.mkdir((0,C.dirname)(P),{recursive:!0}),await f.Promises.copyFile(S,P)}catch(V){if(V.code==="ENOENT"&&!o)return this.doCloneFile(t,r,!0);throw this.toFileSystemProviderError(V)}finally{k.dispose()}}createUniversalWatcher(t,r,o){return new a.UniversalWatcherClient(S=>t(S),S=>r(S),o)}createNonRecursiveWatcher(t,r,o){return new s.NodeJSWatcherClient(S=>t(S),S=>r(S),o)}toFileSystemProviderError(t){if(t instanceof y.FileSystemProviderError)return t;let r;switch(t.code){case"ENOENT":r=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=y.FileSystemProviderErrorCode.NoPermissions;break;default:r=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(t,r)}async toFileSystemProviderWriteError(t,r){let o=this.toFileSystemProviderError(r);if(t&&o.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:S}=await f.SymlinkSupport.stat(this.toFilePath(t));S.mode&128||(o=(0,y.createFileSystemProviderError)(r,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(S){this.logService.trace(S)}return o}}i.DiskFileSystemProvider=e,e.canFlush=!0}),define(Q[115],Z([0,1,11,9]),function(B,i,D,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function w(p,c,d,C,E){try{const h=await new Promise((f,m)=>{B(["spdlog"],f,m)});h.setFlushOn(b.LogLevel.Trace);const v=await h.createAsyncRotatingLogger(p,c,d,C);return E&&v.clearFormatters(),v}catch(h){console.error(h)}return null}function O(p,c,d){switch(c){case b.LogLevel.Trace:p.trace(d);break;case b.LogLevel.Debug:p.debug(d);break;case b.LogLevel.Info:p.info(d);break;case b.LogLevel.Warning:p.warn(d);break;case b.LogLevel.Error:p.error(d);break;case b.LogLevel.Critical:p.critical(d);break;default:throw new Error("Invalid log level")}}class L extends b.AbstractMessageLogger{constructor(c,d,C,E,h){super(),this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(c,d,C,E),this._register(this.onDidChangeLogLevel(v=>{this._logger?.setLevel(v)}))}async _createSpdLogLogger(c,d,C,E){const h=C?6:1,v=30/h*D.ByteSize.MB,f=await w(c,d,v,h,E);if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:m,message:y}of this.buffer)O(this._logger,m,y);this.buffer=[]}}log(c,d){this._logger?O(this._logger,c,d):this.getLevel()<=c&&this.buffer.push({level:c,message:d})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=L}),define(Q[37],Z([0,1,4,63,2,8]),function(B,i,D,b,w,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NullPolicyService=i.AbstractPolicyService=i.IPolicyService=void 0,i.IPolicyService=(0,O.createDecorator)("policy");class L extends w.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(d){const C=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...d,...this.policyDefinitions},C!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(d),b.Iterable.reduce(this.policies.entries(),(E,[h,v])=>({...E,[h]:v}),{})}getPolicyValue(d){return this.policies.get(d)}serialize(){return b.Iterable.reduce(Object.entries(this.policyDefinitions),(d,[C,E])=>({...d,[C]:{definition:E,value:this.policies.get(C)}}),{})}}i.AbstractPolicyService=L;class p{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}i.NullPolicyService=p}),define(Q[116],Z([0,1,3,4,63,5,11,9,37]),function(B,i,D,b,w,O,L,p,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FilePolicyService=void 0;function d(E,h){const v=[];for(const f of w.Iterable.concat(E.keys(),h.keys()))E.get(f)!==h.get(f)&&v.push(f);return v}let C=class extends c.AbstractPolicyService{constructor(h,v,f){super(),this.file=h,this.fileService=v,this.logService=f,this.throttledDelayer=this._register(new D.ThrottledDelayer(500));const m=b.Event.filter(v.onDidFilesChange,y=>y.affects(h));this._register(v.watch(h)),this._register(m(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(h){await this.refresh()}async read(){const h=new Map;try{const v=await this.fileService.readFile(this.file),f=JSON.parse(v.value.toString());if(!(0,O.isObject)(f))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(f))this.policyDefinitions[m]&&h.set(m,f[m])}catch(v){v.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",v)}return h}async refresh(){const h=await this.read(),v=d(this.policies,h);this.policies=h,v.length>0&&this._onDidChange.fire(v)}};C=he([ee(1,L.IFileService),ee(2,p.ILogService)],C),i.FilePolicyService=C}),define(Q[28],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.productSchemaId=i.IProductService=void 0,i.IProductService=(0,D.createDecorator)("productService"),i.productSchemaId="vscode://schemas/vscode-product"}),define(Q[33],Z([0,1,68,5]),function(B,i,D,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class w{constructor(){this.data=new Map}add(L,p){D.ok(b.isString(L)),D.ok(b.isObject(p)),D.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,p)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}i.Registry=new w}),define(Q[117],Z([0,1,4,33]),function(B,i,D,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function w(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class O{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,d){this.schemasById[w(c)]=d,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new O;b.Registry.add(i.Extensions.JSONContribution,L)}),define(Q[40],Z([0,1,19,4,5,81,21,117,33]),function(B,i,D,b,w,O,L,p,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var d;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(d=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var C;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=c.Registry.as(p.Extensions.JSONContribution);class h{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new b.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new b.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},E.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(e,n=!0){this.registerConfigurations([e],n)}registerConfigurations(e,n=!0){const t=this.doRegisterConfigurations(e,n);E.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(e){const n=this.doDeregisterConfigurations(e);E.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:e,remove:n}){const t=[];t.push(...this.doDeregisterConfigurations(n)),t.push(...this.doRegisterConfigurations(e,!1)),E.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(t)})}registerDefaultConfigurations(e){const n=[],t=[];for(const{overrides:r,source:o}of e)for(const S in r)if(n.push(S),i.OVERRIDE_PROPERTY_REGEX.test(S)){const P=this.configurationDefaultsOverrides.get(S),I=P?.valuesSources??new Map;if(o)for(const Y of Object.keys(r[S]))I.set(Y,o);const k={...P?.value||{},...r[S]};this.configurationDefaultsOverrides.set(S,{source:o,value:k,valuesSources:I});const V=(0,L.getLanguageTagSettingPlainKey)(S),G={type:"object",default:k,description:O.localize(1,null,V),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:k,source:w.isString(o)?void 0:o,defaultValueSource:o};t.push(...m(S)),this.configurationProperties[S]=G,this.defaultLanguageConfigurationOverridesNode.properties[S]=G}else{this.configurationDefaultsOverrides.set(S,{value:r[S],source:o});const P=this.configurationProperties[S];P&&(this.updatePropertyDefaultValue(S,P),this.updateSchema(S,P))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(e){const n=[];for(const{overrides:t,source:r}of e)for(const o in t){const S=this.configurationDefaultsOverrides.get(o),P=w.isString(r)?r:r?.id,I=w.isString(S?.source)?S?.source:S?.source?.id;if(P===I)if(n.push(o),this.configurationDefaultsOverrides.delete(o),i.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const k=this.configurationProperties[o];k&&(this.updatePropertyDefaultValue(o,k),this.updateSchema(o,k))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...e){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(e){for(const n of e)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(e,n){const t=[];return e.forEach(r=>{t.push(...this.validateAndRegisterProperties(r,n,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),t}doDeregisterConfigurations(e){const n=[],t=r=>{if(r.properties)for(const o in r.properties){n.push(o);const S=this.configurationProperties[o];S?.policy?.name&&this.policyConfigurations.delete(S.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf?.forEach(o=>t(o))};for(const r of e){t(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}return n}validateAndRegisterProperties(e,n=!0,t,r,o=3){o=w.isUndefinedOrNull(e.scope)?o:e.scope;const S=[],P=e.properties;if(P)for(const k in P){const V=P[k];if(n&&g(k,V)){delete P[k];continue}if(V.source=t,V.defaultDefaultValue=P[k].default,this.updatePropertyDefaultValue(k,V),i.OVERRIDE_PROPERTY_REGEX.test(k)?V.scope=void 0:(V.scope=w.isUndefinedOrNull(V.scope)?o:V.scope,V.restricted=w.isUndefinedOrNull(V.restricted)?!!r?.includes(k):V.restricted),P[k].hasOwnProperty("included")&&!P[k].included){this.excludedConfigurationProperties[k]=P[k],delete P[k];continue}else this.configurationProperties[k]=P[k],P[k].policy?.name&&this.policyConfigurations.set(P[k].policy.name,k);!P[k].deprecationMessage&&P[k].markdownDeprecationMessage&&(P[k].deprecationMessage=P[k].markdownDeprecationMessage),S.push(k)}const I=e.allOf;if(I)for(const k of I)S.push(...this.validateAndRegisterProperties(k,n,t,r,o));return S}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(e){const n=t=>{const r=t.properties;if(r)for(const S in r)this.updateSchema(S,r[S]);t.allOf?.forEach(n)};n(e)}updateSchema(e,n){switch(i.allSettings.properties[e]=n,n.scope){case 1:i.applicationSettings.properties[e]=n;break;case 2:i.machineSettings.properties[e]=n;break;case 6:i.machineOverridableSettings.properties[e]=n;break;case 3:i.windowSettings.properties[e]=n;break;case 4:i.resourceSettings.properties[e]=n;break;case 5:i.resourceSettings.properties[e]=n,this.resourceLanguageSettingsSchema.properties[e]=n;break}}removeFromSchema(e,n){switch(delete i.allSettings.properties[e],n.scope){case 1:delete i.applicationSettings.properties[e];break;case 2:delete i.machineSettings.properties[e];break;case 6:delete i.machineOverridableSettings.properties[e];break;case 3:delete i.windowSettings.properties[e];break;case 4:case 5:delete i.resourceSettings.properties[e],delete this.resourceLanguageSettingsSchema.properties[e];break}}updateOverridePropertyPatternKey(){for(const e of this.overrideIdentifiers.values()){const n=`[${e}]`,t={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,t),i.allSettings.properties[n]=t,i.applicationSettings.properties[n]=t,i.machineSettings.properties[n]=t,i.machineOverridableSettings.properties[n]=t,i.windowSettings.properties[n]=t,i.resourceSettings.properties[n]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const e={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=e,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(e,n){const t=this.configurationDefaultsOverrides.get(e);let r=t?.value,o=t?.source;w.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),w.isUndefined(r)&&(r=l(n.type)),n.default=r,n.defaultValueSource=o}}const v="\\[([^\\]]+)\\]",f=new RegExp(v,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function m(s){const e=[];if(i.OVERRIDE_PROPERTY_REGEX.test(s)){let n=f.exec(s);for(;n?.length;){const t=n[1].trim();t&&e.push(t),n=f.exec(s)}}return(0,D.distinct)(e)}i.overrideIdentifiersFromKey=m;function y(s){return s.reduce((e,n)=>`${e}[${n}]`,"")}i.keyFromOverrideIdentifiers=y;function l(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=l;const u=new h;c.Registry.add(i.Extensions.Configuration,u);function g(s,e){return s.trim()?i.OVERRIDE_PROPERTY_REGEX.test(s)?O.localize(7,null,s):u.getConfigurationProperties()[s]!==void 0?O.localize(8,null,s):e.policy?.name&&u.getPolicyConfigurations().get(e.policy?.name)!==void 0?O.localize(9,null,s,e.policy?.name,u.getPolicyConfigurations().get(e.policy?.name)):null:O.localize(6,null)}i.validateProperty=g;function a(){const s=[],e=u.getConfigurationProperties();for(const n of Object.keys(e))s.push([n,e[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}i.getScopes=a}),define(Q[64],Z([0,1,19,4,50,2,36,26,5,10,21,40,33]),function(B,i,D,b,w,O,L,p,c,d,C,E,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.ConfigurationModel=void 0;class v{constructor(e={},n=[],t=[]){this._contents=e,this._keys=n,this._overrides=t,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(e){return e?(0,C.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const t=this.getContentsForOverrideIdentifer(n);return t?e?(0,C.getConfigurationValue)(t,e):t:void 0}getKeysForOverrideIdentifier(e){const n=[];for(const t of this.overrides)t.identifiers.includes(e)&&n.push(...t.keys);return D.distinct(n)}getAllOverrideIdentifiers(){const e=[];for(const n of this.overrides)e.push(...n.identifiers);return D.distinct(e)}override(e){let n=this.overrideConfigurations.get(e);return n||(n=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,n)),n}merge(...e){const n=p.deepClone(this.contents),t=p.deepClone(this.overrides),r=[...this.keys];for(const o of e)if(!o.isEmpty()){this.mergeContents(n,o.contents);for(const S of o.overrides){const[P]=t.filter(I=>D.equals(I.identifiers,S.identifiers));P?(this.mergeContents(P.contents,S.contents),P.keys.push(...S.keys),P.keys=D.distinct(P.keys)):t.push(p.deepClone(S))}for(const S of o.keys)r.indexOf(S)===-1&&r.push(S)}return new v(n,r,t)}freeze(){return this.frozen=!0,this}clone(){return new v(p.deepClone(this.contents),[...this.keys],p.deepClone(this.overrides))}createOverrideConfigurationModel(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const t={};for(const r of D.distinct([...Object.keys(this.contents),...Object.keys(n)])){let o=this.contents[r];const S=n[r];S&&(typeof o=="object"&&typeof S=="object"?(o=p.deepClone(o),this.mergeContents(o,S)):o=S),t[r]=o}return new v(t,this.keys,this.overrides)}mergeContents(e,n){for(const t of Object.keys(n)){if(t in e&&c.isObject(e[t])&&c.isObject(n[t])){this.mergeContents(e[t],n[t]);continue}e[t]=p.deepClone(n[t])}}checkAndFreeze(e){return this.frozen&&!Object.isFrozen(e)?p.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let n=null,t=null;const r=o=>{o&&(t?this.mergeContents(t,o):t=p.deepClone(o))};for(const o of this.overrides)D.equals(o.identifiers,[e])?n=o.contents:o.identifiers.includes(e)&&r(o.contents);return r(n),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,C.addToValueTree)(this.contents,e,n,t=>{throw new Error(t)})}removeValue(e){this.removeKey(e)&&(0,C.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let t=0;t<n;t++)e.indexOf(this.keys[t])===0&&(n=t);this.keys.splice(n,1,e)}removeKey(e){const n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}i.ConfigurationModel=v;class f{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!c.isUndefinedOrNull(e)){const t=this.doParseContent(e);this.parseRaw(t,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:t,keys:r,overrides:o,restricted:S}=this.doParseRaw(e,n);this._configurationModel=new v(t,r,o),this._restrictedConfigurations=S||[]}doParseContent(e){let n={},t=null,r=[];const o=[],S=[];function P(k){Array.isArray(r)?r.push(k):t!==null&&(r[t]=k)}const I={onObjectBegin:()=>{const k={};P(k),o.push(r),r=k,t=null},onObjectProperty:k=>{t=k},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const k=[];P(k),o.push(r),r=k,t=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:P,onError:(k,V,G)=>{S.push({error:k,offset:V,length:G})}};if(e)try{w.visit(e,I),n=r[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return n}doParseRaw(e,n){const t=h.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,t,!0,n);e=r.raw;const o=(0,C.toValuesTree)(e,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),S=Object.keys(e),P=this.toOverrides(e,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:o,keys:S,overrides:P,restricted:r.restricted}}filter(e,n,t,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const o={},S=[];for(const P in e)if(E.OVERRIDE_PROPERTY_REGEX.test(P)&&t){const I=this.filter(e[P],n,!1,r);o[P]=I.raw,S.push(...I.restricted)}else{const I=n[P],k=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&S.push(P),(k===void 0||r.scopes===void 0||r.scopes.includes(k))&&(r.skipRestricted&&I?.restricted||(o[P]=e[P]))}return{raw:o,restricted:S}}toOverrides(e,n){const t=[];for(const r of Object.keys(e))if(E.OVERRIDE_PROPERTY_REGEX.test(r)){const o={};for(const S in e[r])o[S]=e[r][S];t.push({identifiers:(0,E.overrideIdentifiersFromKey)(r),keys:Object.keys(o),contents:(0,C.toValuesTree)(o,n)})}return t}}i.ConfigurationModelParser=f;class m extends O.Disposable{constructor(e,n,t,r){super(),this.userSettingsResource=e,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(t.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.any(b.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource)),b.Event.filter(this.fileService.onDidRunOperation,o=>(o.isOperation(0)||o.isOperation(3)||o.isOperation(1)||o.isOperation(4))&&t.isEqual(o.resource,e)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=m;class y{constructor(e,n,t,r,o=new v,S=new v,P=new L.ResourceMap,I=new v,k=new L.ResourceMap,V=!0){this._defaultConfiguration=e,this._policyConfiguration=n,this._applicationConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=S,this._folderConfigurations=P,this._memoryConfiguration=I,this._memoryConfigurationByResource=k,this._freeze=V,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(e,n,t){return this.getConsolidatedConfigurationModel(e,n,t).getValue(e)}updateValue(e,n,t={}){let r;t.resource?(r=this._memoryConfigurationByResource.get(t.resource),r||(r=new v,this._memoryConfigurationByResource.set(t.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(e):r.setValue(e,n),t.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,t){const r=this.getConsolidatedConfigurationModel(e,n,t),o=this.getFolderConfigurationModelForResource(n.resource,t),S=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,P=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),I=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(e),k=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(e),V=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),G=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),Y=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),X=t?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,se=o?n.overrideIdentifier?o.freeze().override(n.overrideIdentifier).getValue(e):o.freeze().getValue(e):void 0,oe=n.overrideIdentifier?S.override(n.overrideIdentifier).getValue(e):S.getValue(e),ne=r.getValue(e),fe=D.distinct(r.overrides.map(le=>le.identifiers).flat()).filter(le=>r.getOverrideValue(e,le)!==void 0);return{defaultValue:P,policyValue:I,applicationValue:k,userValue:V,userLocalValue:G,userRemoteValue:Y,workspaceValue:X,workspaceFolderValue:se,memoryValue:oe,value:ne,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,policy:I!==void 0?{value:I}:void 0,application:k!==void 0?{value:k,override:n.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:V!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:G!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:Y!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:X!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:se!==void 0?{value:o?.freeze().getValue(e),override:n.overrideIdentifier?o?.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:oe!==void 0?{value:S.getValue(e),override:n.overrideIdentifier?S.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:fe.length?fe:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(e){this._policyConfiguration=e}updateApplicationConfiguration(e){this._applicationConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,n){const t=[];if(!n){const{added:r,updated:o,removed:S}=g(this._defaultConfiguration,e);n=[...r,...o,...S]}for(const r of n)for(const o of(0,E.overrideIdentifiersFromKey)(r)){const S=this._defaultConfiguration.getKeysForOverrideIdentifier(o),P=e.getKeysForOverrideIdentifier(o),I=[...P.filter(k=>S.indexOf(k)===-1),...S.filter(k=>P.indexOf(k)===-1),...S.filter(k=>!p.equals(this._defaultConfiguration.override(o).getValue(k),e.override(o).getValue(k)))];t.push([o,I])}return this.updateDefaultConfiguration(e),{keys:n,overrides:t}}compareAndUpdatePolicyConfiguration(e){const{added:n,updated:t,removed:r}=g(this._policyConfiguration,e),o=[...n,...t,...r];return o.length&&this.updatePolicyConfiguration(e),{keys:o,overrides:[]}}compareAndUpdateApplicationConfiguration(e){const{added:n,updated:t,removed:r,overrides:o}=g(this.applicationConfiguration,e),S=[...n,...t,...r];return S.length&&this.updateApplicationConfiguration(e),{keys:S,overrides:o}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:t,removed:r,overrides:o}=g(this.localUserConfiguration,e),S=[...n,...t,...r];return S.length&&this.updateLocalUserConfiguration(e),{keys:S,overrides:o}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:t,removed:r,overrides:o}=g(this.remoteUserConfiguration,e),S=[...n,...t,...r];return S.length&&this.updateRemoteUserConfiguration(e),{keys:S,overrides:o}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:t,removed:r,overrides:o}=g(this.workspaceConfiguration,e),S=[...n,...t,...r];return S.length&&this.updateWorkspaceConfiguration(e),{keys:S,overrides:o}}compareAndUpdateFolderConfiguration(e,n){const t=this.folderConfigurations.get(e),{added:r,updated:o,removed:S,overrides:P}=g(t,n),I=[...r,...o,...S];return(I.length||!t)&&this.updateFolderConfiguration(e,n),{keys:I,overrides:P}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:t,updated:r,removed:o,overrides:S}=g(n,void 0);return{keys:[...t,...r,...o],overrides:S}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(e,n,t){let r=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(e)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:e},n){let t=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const r=n.getFolder(e);r&&(t=this.getFolderConsolidatedConfiguration(r.uri)||t);const o=this._memoryConfigurationByResource.get(e);o&&(t=t.merge(o))}return t}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const t=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(n=t.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=t}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const t=n.getFolder(e);if(t)return this._folderConfigurations.get(t.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:t,overrides:r,keys:o}=this._folderConfigurations.get(n);return e.push([n,{contents:t,overrides:r,keys:o}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(t=>e.add(t))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>n.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>n.add(t)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),t=this.parseConfigurationModel(e.policy),r=this.parseConfigurationModel(e.application),o=this.parseConfigurationModel(e.user),S=this.parseConfigurationModel(e.workspace),P=e.folders.reduce((I,k)=>(I.set(d.URI.revive(k[0]),this.parseConfigurationModel(k[1])),I),new L.ResourceMap);return new y(n,t,r,o,new v,S,P,new v,new L.ResourceMap,!1)}static parseConfigurationModel(e){return new v(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=y;function l(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,n=new Map;for(const r of s)r.keys.forEach(o=>e.add(o)),r.overrides.forEach(([o,S])=>{const P=(0,L.getOrSet)(n,o,new Set);S.forEach(I=>P.add(I))});const t=[];return n.forEach((r,o)=>t.push([o,[...r.values()]])),{keys:[...e.values()],overrides:t}}i.mergeChanges=l;class u{constructor(e,n,t,r){this.change=e,this.previous=n,this.currentConfiguraiton=t,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;e.keys.forEach(P=>o.add(P)),e.overrides.forEach(([,P])=>P.forEach(I=>o.add(I))),this.affectedKeys=[...o.values()];const S=new v;this.affectedKeys.forEach(P=>S.setValue(P,{})),this.affectedKeysTree=S.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const t=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!p.equals(t,r)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let t=(0,C.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof t=="object"&&(r=Object.keys(t)[0]);){if(e=e[r],!e)return!1;t=t[r]}return!0}}i.ConfigurationChangeEvent=u;function g(s,e){const{added:n,removed:t,updated:r}=a(e,s),o=[],S=s?.getAllOverrideIdentifiers()||[],P=e?.getAllOverrideIdentifiers()||[];if(e){const I=P.filter(k=>!S.includes(k));for(const k of I)o.push([k,e.getKeysForOverrideIdentifier(k)])}if(s){const I=S.filter(k=>!P.includes(k));for(const k of I)o.push([k,s.getKeysForOverrideIdentifier(k)])}if(e&&s){for(const I of S)if(P.includes(I)){const k=a({contents:s.getOverrideValue(void 0,I)||{},keys:s.getKeysForOverrideIdentifier(I)},{contents:e.getOverrideValue(void 0,I)||{},keys:e.getKeysForOverrideIdentifier(I)});o.push([I,[...k.added,...k.removed,...k.updated]])}}return{added:n,removed:t,updated:r,overrides:o}}function a(s,e){const n=s?e?s.keys.filter(o=>e.keys.indexOf(o)===-1):[...s.keys]:[],t=e?s?e.keys.filter(o=>s.keys.indexOf(o)===-1):[...e.keys]:[],r=[];if(s&&e){for(const o of e.keys)if(s.keys.indexOf(o)!==-1){const S=(0,C.getConfigurationValue)(e.contents,o),P=(0,C.getConfigurationValue)(s.contents,o);p.equals(S,P)||r.push(o)}}return{added:n,removed:t,updated:r}}}),define(Q[118],Z([0,1,19,4,2,26,5,21,64,40,9,37,33]),function(B,i,D,b,w,O,L,p,c,d,C,E,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.PolicyConfiguration=i.NullPolicyConfiguration=i.DefaultConfigurationModel=i.DefaultConfiguration=void 0;class v extends w.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new b.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new f(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(h.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:g})=>this.onDidUpdateConfiguration(u,g))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(u,g){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:u})}getConfigurationDefaultOverrides(){return{}}}i.DefaultConfiguration=v;class f extends c.ConfigurationModel{constructor(u={}){const g=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(g),s=Object.create(null),e=[];for(const n in g){const t=u[n],r=t!==void 0?t:g[n].default;(0,p.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))d.OVERRIDE_PROPERTY_REGEX.test(n)&&e.push({identifiers:(0,d.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,p.toValuesTree)(s[n],t=>console.error(`Conflict in default settings file: ${t}`))});super(s,a,e)}}i.DefaultConfigurationModel=f;class m{constructor(){this.onDidChangeConfiguration=b.Event.None,this.configurationModel=new c.ConfigurationModel}async initialize(){return this.configurationModel}}i.NullPolicyConfiguration=m;let y=class extends w.Disposable{constructor(u,g,a){super(),this.defaultConfiguration=u,this.policyService=g,this.logService=a,this._onDidChangeConfiguration=this._register(new b.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new c.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(u=>this.onDidChangePolicies(u))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:u})=>this.update(await this.registerPolicyDefinitions(u),!0))),this._configurationModel}async registerPolicyDefinitions(u){const g={},a=[],s=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties();for(const e of u){const n=s[e];if(!n){a.push(e);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}a.push(e),g[n.policy.name]={type:n.type}}}return(0,L.isEmptyObject)(g)||await this.policyService.registerPolicyDefinitions(g),a}onDidChangePolicies(u){const g=h.Registry.as(d.Extensions.Configuration).getPolicyConfigurations(),a=(0,D.coalesce)(u.map(s=>g.get(s)));this.update(a,!0)}update(u,g){const a=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),s=[],e=this._configurationModel.isEmpty();for(const n of u){const t=a[n]?.policy?.name;if(t){const r=this.policyService.getPolicyValue(t);(e?r!==void 0:!(0,O.equals)(this._configurationModel.getValue(n),r))&&s.push([n,r])}else this._configurationModel.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this._configurationModel;this._configurationModel=new c.ConfigurationModel;for(const t of n.keys)this._configurationModel.setValue(t,n.getValue(t));for(const[t,r]of s)r===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,r);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};y=he([ee(1,E.IPolicyService),ee(2,C.ILogService)],y),i.PolicyConfiguration=y}),define(Q[119],Z([0,1,3,4,2,17,21,64,118,37]),function(B,i,D,b,w,O,L,p,c,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class C extends w.Disposable{constructor(h,v,f,m){super(),this.settingsResource=h,this._onDidChangeConfiguration=this._register(new b.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new c.DefaultConfiguration),this.policyConfiguration=f instanceof d.NullPolicyService?new c.NullPolicyConfiguration:this._register(new c.PolicyConfiguration(this.defaultConfiguration,f,m)),this.userConfiguration=this._register(new p.UserSettings(this.settingsResource,void 0,O.extUriBiasedIgnorePathCase,v)),this.configuration=new p.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new p.ConfigurationModel,new p.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:y,properties:l})=>this.onDidDefaultConfigurationChange(y,l))),this._register(this.policyConfiguration.onDidChangeConfiguration(y=>this.onDidPolicyConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[h,v,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new p.Configuration(h,v,new p.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(h,v){const f=typeof h=="string"?h:void 0,m=(0,L.isConfigurationOverrides)(h)?h:(0,L.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(f,m,void 0)}updateValue(h,v,f,m){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const v=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(f,v,2)}onDidDefaultConfigurationChange(h,v){const f=this.configuration.toData(),m=this.configuration.compareAndUpdateDefaultConfiguration(h,v);this.trigger(m,f,7)}onDidPolicyConfigurationChange(h){const v=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(h);this.trigger(f,v,7)}trigger(h,v,f){const m=new p.ConfigurationChangeEvent(h,{data:v},this.configuration);m.source=f,m.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(h){switch(h){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=C}),define(Q[120],Z([0,1,16]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parseAuthorityWithOptionalPort=i.parseAuthorityWithPort=i.getRemoteServerRootPath=i.getRemoteName=i.getRemoteAuthority=void 0;function b(d){return d.scheme===D.Schemas.vscodeRemote?d.authority:void 0}i.getRemoteAuthority=b;function w(d){if(!d)return;const C=d.indexOf("+");return C<0?d:d.substr(0,C)}i.getRemoteName=w;function O(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}i.getRemoteServerRootPath=O;function L(d){const{host:C,port:E}=c(d);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:E}}i.parseAuthorityWithPort=L;function p(d,C){let{host:E,port:h}=c(d);return typeof h>"u"&&(h=C),{host:E,port:h}}i.parseAuthorityWithOptionalPort=p;function c(d){const C=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const E=d.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const h=d.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:d,port:void 0}}}),define(Q[34],Z([0,1,27,8,120]),function(B,i,D,b,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.isApplicationScopedExtension=i.ExtensionIdentifier=i.TargetPlatform=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.UNDEFINED_PUBLISHER=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.UNDEFINED_PUBLISHER="undefined_publisher",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}i.getWorkspaceSupportTypeMessage=O;function L(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}i.isIExtensionIdentifier=L,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var p;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(p=i.ExtensionType||(i.ExtensionType={}));var c;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(c=i.TargetPlatform||(i.TargetPlatform={}));class d{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,y){if(typeof m>"u"||m===null)return typeof y>"u"||y===null;if(typeof y>"u"||y===null)return!1;if(typeof m=="string"||typeof y=="string"){const l=typeof m=="string"?m:m.value,u=typeof y=="string"?y:y.value;return D.equalsIgnoreCase(l,u)}return m._lower===y._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}i.ExtensionIdentifier=d;function C(f){return E(f)}i.isApplicationScopedExtension=C;function E(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}i.isLanguagePackExtension=E;function h(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=h;function v(f,m){if(m){const y=`onResolveRemoteAuthority:${(0,w.getRemoteName)(m)}`;return f.activationEvents?.indexOf(y)!==-1}return!1}i.isResolverExtension=v,i.IBuiltinExtensionsScannerService=(0,b.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[23],Z([0,1,27,22,34,13,10,12,32]),function(B,i,D,b,w,O,L,p,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.computeTargetPlatform=i.isAlpineLinux=i.getExtensionDependencies=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.getIdAndVersion=i.ExtensionKey=i.areSameExtensions=void 0;function d(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,D.compareIgnoreCase)(n.id,t.id)===0}i.areSameExtensions=d;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{constructor(t,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=t.id}static create(t){const r=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new E(t.identifier,r,o)}static parse(t){const r=C.exec(t);return r&&r[1]&&r[2]?new E({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof E?d(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}i.ExtensionKey=E;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(n){const t=h.exec(n);return t&&t[1]?[m(t[1]),t[2]]:[m(n),void 0]}i.getIdAndVersion=v;function f(n,t){return`${n}.${t}`}i.getExtensionId=f;function m(n){return n.toLocaleLowerCase()}i.adoptToGalleryExtensionId=m;function y(n,t){return m(f(n,t))}i.getGalleryExtensionId=y;function l(n,t){const r=[],o=S=>{for(const P of r)if(P.some(I=>d(t(I),t(S))))return P;return null};for(const S of n){const P=o(S);P?P.push(S):r.push([S])}return r}i.groupByExtension=l;function u(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=u;function g(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),...n.telemetryData}}i.getGalleryExtensionTelemetryData=g,i.BetterMergeId=new w.ExtensionIdentifier("pprice.better-merge");function a(n,t){const r=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const S=o.shift();if(S&&r.every(P=>!d(P.identifier,{id:S}))){const P=n.filter(I=>d(I.identifier,{id:S}));P.length===1&&(r.push(P[0]),o.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}i.getExtensionDependencies=a;async function s(n,t){if(!O.isLinux)return!1;let r;try{r=(await n.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){t.debug("Error while getting the os-release file.",(0,p.getErrorMessage)(S))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}i.isAlpineLinux=s;async function e(n,t){const r=await s(n,t),o=(0,b.getTargetPlatform)(r?"alpine":O.platform,c.arch);return t.debug("ComputeTargetPlatform:",o),o}i.computeTargetPlatform=e}),define(Q[121],Z([0,1,24,12,16,17,39,10,84,22,23,34]),function(B,i,D,b,w,O,L,p,c,d,C,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=void 0;const h=y=>(0,c.localize)(0,null,y),v=(0,c.localize)(1,null,"ms-dotnettools.csharp");function f(y,l){return l?`${y.publisher}.${y.name}@${y.version}`:`${y.publisher}.${y.name}`}let m=class{constructor(l,u){this.extensionManagementService=l,this.extensionGalleryService=u}get location(){}async listExtensions(l,u,g=console){let a=await this.extensionManagementService.getInstalled(1);const s=E.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(u&&u!==""){if(s.indexOf(u.toLowerCase())<0){g.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}a=a.filter(n=>n.manifest.categories?n.manifest.categories.map(r=>r.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){g.log("Possible Categories: "),s.forEach(n=>{g.log(n)});return}this.location&&g.log((0,c.localize)(2,null,this.location)),a=a.sort((n,t)=>n.identifier.id.localeCompare(t.identifier.id));let e;for(const n of a)e!==n.identifier.id&&(e=n.identifier.id,g.log(f(n.manifest,l)))}async installExtensions(l,u,g,a,s=console){const e=[],n=[];l.length&&s.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const t=await this.extensionManagementService.getInstalled(1),r=(I,k)=>{const V=t.find(G=>(0,C.areSameExtensions)(G.identifier,{id:I}));if(V){if(!a&&(!k||k==="prerelease"&&V.preRelease))return s.log((0,c.localize)(5,null,I,V.manifest.version,I)),!1;if(k&&V.manifest.version===k)return s.log((0,c.localize)(6,null,`${I}@${k}`)),!1}return!0},o=(I,k,V)=>{P.push({id:I,version:k!=="prerelease"?k:void 0,installOptions:{...g,isBuiltin:V,installPreReleaseVersion:k==="prerelease"||g.installPreReleaseVersion}})},S=[],P=[];for(const I of l)if(I instanceof p.URI)S.push(I);else{const[k,V]=(0,C.getIdAndVersion)(I);r(k,V)&&o(k,V,!1)}for(const I of u){const[k,V]=(0,C.getIdAndVersion)(I);r(k,V)&&o(k,V,!0)}if(S.length&&await Promise.all(S.map(async I=>{try{const k=await this.installVSIX(I,{...g,isBuiltin:!1},a,s);k&&n.push(k)}catch(k){s.error(k.message||k.stack||k),e.push(I.toString())}})),P.length){const I=await this.getGalleryExtensions(P);await Promise.all(P.map(async k=>{const V=I.get(k.id.toLowerCase());if(V)try{const G=await this.installFromGallery(k,V,t,a,s);G&&n.push(G)}catch(G){s.error(G.message||G.stack||G),e.push(k.id)}else s.error(`${h(k.version?`${k.id}@${k.version}`:k.id)}
${v}`),e.push(k.id)}))}if(e.length)throw new Error((0,c.localize)(7,null,e.join(", ")))}async installVSIX(l,u,g,a){const s=await this.extensionManagementService.getManifest(l);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,g,a))try{return await this.extensionManagementService.install(l,u),a.log((0,c.localize)(8,null,(0,O.basename)(l))),s}catch(n){if((0,b.isCancellationError)(n))return a.log((0,c.localize)(9,null,(0,O.basename)(l))),null;throw n}return null}async getGalleryExtensions(l){const u=new Map,g=l.some(s=>s.installOptions.installPreReleaseVersion),a=await this.extensionGalleryService.getExtensions(l.map(s=>({...s,preRelease:g})),D.CancellationToken.None);for(const s of a)u.set(s.identifier.id.toLowerCase(),s);return u}async installFromGallery({id:l,version:u,installOptions:g},a,s,e,n){const t=await this.extensionGalleryService.getManifest(a,D.CancellationToken.None);if(t&&!this.validateExtensionKind(t,n))return null;const r=s.find(o=>(0,C.areSameExtensions)(o.identifier,a.identifier));if(r){if(a.version===r.manifest.version)return n.log((0,c.localize)(10,null,u?`${l}@${u}`:l)),null;n.log((0,c.localize)(11,null,l,a.version))}try{g.isBuiltin?n.log(u?(0,c.localize)(12,null,l,u):(0,c.localize)(13,null,l)):n.log(u?(0,c.localize)(14,null,l,u):(0,c.localize)(15,null,l));const o=await this.extensionManagementService.installFromGallery(a,{...g,installGivenVersion:!!u});return n.log((0,c.localize)(16,null,l,o.manifest.version)),t}catch(o){if((0,b.isCancellationError)(o))return n.log((0,c.localize)(17,null,l)),null;throw o}}validateExtensionKind(l,u){return!0}async validateVSIX(l,u,g){const a={id:(0,C.getGalleryExtensionId)(l.publisher,l.name)},e=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,C.areSameExtensions)(a,n.identifier)&&(0,L.gt)(n.manifest.version,l.version));return e&&!u?(g.log((0,c.localize)(18,null,e.identifier.id,e.manifest.version,l.version)),!1):this.validateExtensionKind(l,g)}async uninstallExtensions(l,u,g=console){const a=async e=>{if(e instanceof p.URI){const n=await this.extensionManagementService.getManifest(e);return f(n)}return e},s=[];for(const e of l){const n=await a(e),r=(await this.extensionManagementService.getInstalled()).filter(o=>(0,C.areSameExtensions)(o.identifier,{id:n}));if(!r.length)throw new Error(`${this.notInstalled(n)}
${v}`);if(r.some(o=>o.type===0)){g.log((0,c.localize)(19,null,n));return}if(!u&&r.some(o=>o.isBuiltin)){g.log((0,c.localize)(20,null,n));return}g.log((0,c.localize)(21,null,n));for(const o of r)await this.extensionManagementService.uninstall(o),s.push(o);this.location?g.log((0,c.localize)(22,null,n,this.location)):g.log((0,c.localize)(23,null,n))}}async locateExtension(l,u=console){const g=await this.extensionManagementService.getInstalled();l.forEach(a=>{g.forEach(s=>{if(s.identifier.id===a&&s.location.scheme===w.Schemas.file){u.log(s.location.fsPath);return}})})}notInstalled(l){return this.location?(0,c.localize)(24,null,l,this.location):(0,c.localize)(25,null,l)}};m=he([ee(0,d.IExtensionManagementService),ee(1,d.IExtensionGalleryService)],m),i.ExtensionManagementCLIService=m}),define(Q[41],Z([0,1,3,15,2,36,10,23,11,8,9]),function(B,i,D,b,w,O,L,p,c,d,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsProfileScannerService=i.IExtensionsProfileScannerService=void 0,i.IExtensionsProfileScannerService=(0,d.createDecorator)("IExtensionsProfileScannerService");let E=class extends w.Disposable{constructor(v,f){super(),this.fileService=v,this.logService=f,this.resourcesAccessQueueMap=new O.ResourceMap}scanProfileExtensions(v){return this.withProfileExtensions(v)}addExtensionsToProfile(v,f){return this.withProfileExtensions(f,m=>(m=m.filter(y=>v.some(([l])=>!(0,p.areSameExtensions)(y.identifier,l.identifier))),m.push(...v.map(([y,l])=>({identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:l}))),m))}removeExtensionFromProfile(v,f){return this.withProfileExtensions(f,m=>m.filter(y=>!(0,p.areSameExtensions)(y.identifier,v)))}async withProfileExtensions(v,f){return this.getResourceAccessQueue(v).queue(async()=>{let m=[];try{const y=await this.fileService.readFile(v),l=JSON.parse(y.value.toString());for(const u of l){if(!u.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",u);continue}if(!u.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",u);continue}if(!u.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",u);continue}m.push({identifier:u.identifier,location:L.URI.revive(u.location),version:u.version,metadata:u.metadata})}}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}if(f){m=f(m);const y=m.map(l=>({identifier:l.identifier,version:l.version,location:l.location.toJSON(),metadata:l.metadata}));await this.fileService.writeFile(v,b.VSBuffer.fromString(JSON.stringify(y)))}return m})}getResourceAccessQueue(v){let f=this.resourcesAccessQueueMap.get(v);return f||(f=new D.Queue,this.resourcesAccessQueueMap.set(v,f)),f}};E=he([ee(0,c.IFileService),ee(1,C.ILogService)],E),i.ExtensionsProfileScannerService=E}),define(Q[122],Z([0,1,3,12,2,13,17,39,10,30,20,18,22,23,11,9]),function(B,i,D,b,w,O,L,p,c,d,C,E,h,v,f,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;let y=class extends w.Disposable{constructor(u,g,a,s){super(),this.fileService=g,this.extensionGalleryService=a,this.logService=s,this.extensionsDownloadDir=c.URI.file(u.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(u,g){await this.cleanUpPromise;const a=this.getName(u),s=(0,L.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(s)){const e=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(e)||await this.extensionGalleryService.download(u,e,g);try{await this.rename(e,s,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(e)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",u.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,e.path),n}}return s}async delete(u){await this.cleanUpPromise,await this.fileService.del(u)}async rename(u,g,a){try{await C.Promises.rename(u.fsPath,g.fsPath)}catch(s){if(O.isWindows&&s&&s.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${u} to ${g} with 'EPERM' error. Trying again...`),this.rename(u,g,a);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const u=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(u.children){const g=[],a=[];for(const n of u.children){const t=v.ExtensionKey.parse(n.name);t&&a.push([t,n])}const s=(0,v.groupByExtension)(a,([n])=>n),e=[];for(const n of s)n.sort((t,r)=>p.rcompare(t[0].version,r[0].version)),g.push(...n.slice(1).map(t=>t[1].resource)),e.push(n[0][1]);e.sort((n,t)=>n.mtime-t.mtime),g.push(...e.slice(0,Math.max(0,e.length-this.cache)).map(n=>n.resource)),await D.Promises.settled(g.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(u){this.logService.error(u)}}getName(u){return this.cache?v.ExtensionKey.create(u).toString().toLowerCase():(0,d.generateUuid)()}};y=he([ee(0,E.INativeEnvironmentService),ee(1,f.IFileService),ee(2,h.IExtensionGalleryService),ee(3,m.ILogService)],y),i.ExtensionsDownloader=y}),define(Q[123],Z([0,1,2,14,20,34]),function(B,i,D,b,w,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class L extends D.Disposable{constructor(c,d){super(),this.environmentService=c,this.extensionsManifestCache=(0,b.join)(this.environmentService.userDataPath,O.MANIFEST_CACHE_FOLDER,O.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(d.onDidUninstallExtension(C=>this.onDidUnInstallExtension(C)))}onDidInstallExtensions(c){c.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){w.Promises.rm(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=L}),define(Q[124],Z([0,1,154,19,3,2,16,14,20,18,22,23,9,62]),function(B,i,D,b,w,O,L,p,c,d,C,E,h,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeLanguagePackService=void 0;let f=class extends v.LanguagePackBaseService{constructor(u,g,a,s){super(a),this.extensionManagementService=u,this.logService=s,this.cache=this._register(new m(g,s)),this.extensionManagementService.registerParticipant({postInstall:async e=>this.postInstallExtension(e),postUninstall:async e=>this.postUninstallExtension(e)})}async getInstalledLanguages(){const u=await this.cache.getLanguagePacks(),g=Object.keys(u).map(a=>{const s=u[a];return{...this.createQuickPickItem(a,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return g.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),g.sort((a,s)=>a.label.localeCompare(s.label)),g}async postInstallExtension(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",u.identifier.id),await this.update())}async postUninstallExtension(u){const g=await this.cache.getLanguagePacks();Object.keys(g).some(a=>g[a]&&g[a].extensions.some(s=>(0,E.areSameExtensions)(s.extensionIdentifier,u.identifier)))&&(this.logService.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,g]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),a=await this.cache.update(g);return!(0,b.equals)(Object.keys(u),Object.keys(a))}};f=he([ee(0,C.IExtensionManagementService),ee(1,d.INativeEnvironmentService),ee(2,C.IExtensionGalleryService),ee(3,h.ILogService)],f),i.NativeLanguagePackService=f;let m=class extends O.Disposable{constructor(u,g){super(),this.logService=g,this.languagePacks={},this.languagePacksFilePath=(0,p.join)(u.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(u){return this.withLanguagePacks(g=>{Object.keys(g).forEach(a=>delete g[a]),this.createLanguagePacksFromExtensions(g,...u)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(u,...g){for(const a of g)a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(u,a);Object.keys(u).forEach(a=>this.updateHash(u[a]))}createLanguagePacksFromExtension(u,g){const a=g.identifier,s=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const e of s)if(g.location.scheme===L.Schemas.file&&y(e)){let n=u[e.languageId];n||(n={hash:"",extensions:[],translations:{},label:e.localizedLanguageName??e.languageName},u[e.languageId]=n);const t=n.extensions.filter(r=>(0,E.areSameExtensions)(r.extensionIdentifier,a))[0];t?t.version=g.manifest.version:n.extensions.push({extensionIdentifier:a,version:g.manifest.version});for(const r of e.translations)n.translations[r.id]=(0,p.join)(g.location.fsPath,r.path)}}updateHash(u){if(u){const g=(0,D.createHash)("md5");for(const a of u.extensions)g.update(a.extensionIdentifier.uuid||a.extensionIdentifier.id).update(a.version);u.hash=g.digest("hex")}}withLanguagePacks(u=()=>null){return this.languagePacksFileLimiter.queue(()=>{let g=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,a=>a.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(a)).then(a=>{try{return JSON.parse(a)}catch{return{}}}).then(a=>(g=u(a),a)).then(a=>{for(const e of Object.keys(a))a[e]||delete a[e];this.languagePacks=a,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),c.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>g,a=>this.logService.error(a))})}};m=he([ee(0,d.INativeEnvironmentService),ee(1,h.ILogService)],m);function y(l){if(typeof l.languageId!="string"||!Array.isArray(l.translations)||l.translations.length===0)return!1;for(const u of l.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(l.languageName&&typeof l.languageName!="string"||l.localizedLanguageName&&typeof l.localizedLanguageName!="string")}}),define(Q[47],Z([0,1,15,94,40,8,33]),function(B,i,D,b,w,O,L){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asTextOrError=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,O.createDecorator)("requestService");function p(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}i.isSuccess=p;function c(m){return m.res.statusCode===204}async function d(m){return c(m)?null:(await(0,D.streamToBuffer)(m.stream)).toString()}i.asText=d;async function C(m){if(!p(m))throw new Error("Server returned "+m.res.statusCode);return d(m)}i.asTextOrError=C;async function E(m){if(!p(m))throw new Error("Server returned "+m.res.statusCode);if(c(m))return null;const l=(await(0,D.streamToBuffer)(m.stream)).toString();try{return JSON.parse(l)}catch(u){throw u.message+=`:
`+l,u}}i.asJson=E;function h(m){f(m)}i.updateProxyConfigurationsScope=h;let v;function f(m){const y=L.Registry.as(w.Extensions.Configuration),l=v;v={id:"http",order:15,title:(0,b.localize)(0,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,b.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,b.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,b.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,b.localize)(4,null),(0,b.localize)(5,null),(0,b.localize)(6,null),(0,b.localize)(7,null)],default:"override",description:(0,b.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,b.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[v],remove:l?[l]:[]})}f(2)}),define(Q[125],Z([0,1,24,16,11,47]),function(B,i,D,b,w,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let L=class{constructor(c,d){this.requestService=c,this.fileService=d}async download(c,d,C=D.CancellationToken.None){if(c.scheme===b.Schemas.file||c.scheme===b.Schemas.vscodeRemote){await this.fileService.copy(c,d);return}const E={type:"GET",url:c.toString(!0)},h=await this.requestService.request(E,C);if(h.res.statusCode===200)await this.fileService.writeFile(d,h.stream);else{const v=await(0,O.asTextOrError)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${v}`)}}};L=he([ee(0,O.IRequestService),ee(1,w.IFileService)],L),i.DownloadService=L}),define(Q[126],Z([0,1,127,5]),function(B,i,D,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function w(L,p){return L.protocol==="http:"?p.HTTP_PROXY||p.http_proxy||null:L.protocol==="https:"&&(p.HTTPS_PROXY||p.https_proxy||p.HTTP_PROXY||p.http_proxy)||null}async function O(L,p,c={}){const d=(0,D.parse)(L),C=c.proxyUrl||w(d,p);if(!C)return null;const E=(0,D.parse)(C);if(!/^https?:$/.test(E.protocol||""))return null;const h={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,b.isBoolean)(c.strictSSL)?c.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((v,f)=>{B(["http-proxy-agent"],v,f)}))(h):new(await new Promise((v,f)=>{B(["https-proxy-agent"],v,f)}))(h)}i.getProxyAgent=O}),define(Q[128],Z([0,1,57,14,95,24,31,12,13,30,77,155,3]),function(B,i,D,b,w,O,L,p,c,d,C,E,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const v=1e4;let f;async function m(l,u,g){return u["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):c.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(g)&&!u["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(g)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=h.Promises.withAsyncBody(async(a,s)=>{const e=new O.CancellationTokenSource,n=setTimeout(()=>{e.dispose(!0),s(new Error((0,w.localize)(0,null)))},v);try{a(await y(l,e.token))}catch(t){!(0,p.isCancellationError)(t)&&!e.token.isCancellationRequested?s(new Error((0,w.localize)(1,null,(0,L.toErrorMessage)(t)))):a({})}finally{clearTimeout(n),e.dispose()}})),f)}i.getResolvedShellEnv=m;async function y(l,u){const g=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",g);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",a);const s=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",n);const t=await(0,C.getSystemShell)(c.OS,n);return l.trace("getUnixShellEnvironment#shell",t),new Promise((r,o)=>{if(u.isCancellationRequested)return o((0,p.canceled)());const S=(0,b.basename)(t);let P,I;const k=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(S)?(P=`& '${process.execPath}' ${k} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,I=["-Login","-Command"]):(P=`'${process.execPath}' ${k} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,S==="tcsh"?I=["-ic"]:I=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),P);const V=(0,D.spawn)(t,[...I,P],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});u.onCancellationRequested(()=>(V.kill(),o((0,p.canceled)()))),V.on("error",X=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(X)),o(X)});const G=[];V.stdout.on("data",X=>G.push(X));const Y=[];V.stderr.on("data",X=>Y.push(X)),V.on("close",(X,se)=>{const oe=Buffer.concat(G).toString("utf8");l.trace("getUnixShellEnvironment#raw",oe);const ne=Buffer.concat(Y).toString("utf8");if(ne.trim()&&l.trace("getUnixShellEnvironment#stderr",ne),X||se)return o(new Error((0,w.localize)(2,null,X,se)));const fe=e.exec(oe),le=fe?fe[1]:"{}";try{const ie=JSON.parse(le);g?ie.ELECTRON_RUN_AS_NODE=g:delete ie.ELECTRON_RUN_AS_NODE,a?ie.ELECTRON_NO_ATTACH_CONSOLE=a:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",ie),r(ie)}catch(ie){l.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(ie)),o(ie)}})})}}),define(Q[65],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IStateService=void 0,i.IStateService=(0,D.createDecorator)("stateService")}),define(Q[129],Z([0,1,3,15,5,18,11,9]),function(B,i,D,b,w,O,L,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.StateService=i.FileStorage=void 0;class c{constructor(E,h,v){this.storagePath=E,this.logService=h,this.fileService=v,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new D.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(E){E.fileOperationResult!==1&&this.logService.error(E)}}getItem(E,h){const v=this.storage[E];return(0,w.isUndefinedOrNull)(v)?h:v}setItem(E,h){this.setItems([{key:E,data:h}])}setItems(E){let h=!1;for(const{key:v,data:f}of E)this.storage[v]!==f&&((0,w.isUndefinedOrNull)(f)?(0,w.isUndefined)(this.storage[v])||(this.storage[v]=void 0,h=!0):(this.storage[v]=f,h=!0));h&&this.save()}removeItem(E){(0,w.isUndefined)(this.storage[E])||(this.storage[E]=void 0,this.save())}async save(E){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),E)}async doSave(){if(!this.initializing)return;await this.initializing;const E=JSON.stringify(this.storage,null,4);if(E!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,b.VSBuffer.fromString(E)),this.lastSavedStorageContents=E}catch(h){this.logService.error(h)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}i.FileStorage=c;let d=class{constructor(E,h,v){this.fileStorage=new c(E.stateResource,h,v)}async init(){await this.fileStorage.init()}getItem(E,h){return this.fileStorage.getItem(E,h)}};d=he([ee(0,O.IEnvironmentService),ee(1,p.ILogService),ee(2,L.IFileService)],d),i.StateService=d}),define(Q[66],Z([0,1,13,32,10,30]),function(B,i,D,b,w,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function L(d){if(D.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function p(d,C,E,h,v,f,m,y,l,u){const g=Object.create(null);g["common.machineId"]=m,g.sessionID=(0,O.generateUuid)()+Date.now(),g.commitHash=v,g.version=f,g["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,D.PlatformToString)(D.platform),g["common.nodePlatform"]=b.platform,g["common.nodeArch"]=h,g["common.product"]=u||"desktop",y&&(g["common.msftInternal"]=y);let a=0;const s=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),D.isLinuxSnap&&(g["common.snap"]="true");const e=L(E);e&&(g["common.platformDetail"]=e);try{const n=await d.readFile(w.URI.file(l));g["common.source"]=n.value.toString().slice(0,30)}catch{}return g}i.resolveCommonProperties=p;function c(d){const C=b.env.USERDNSDOMAIN;if(!C)return!1;const E=C.toLowerCase();return d.some(h=>E===h)}i.verifyMicrosoftInternalDomain=c}),define(Q[35],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,D.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var b;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(b=i.TelemetryLevel||(i.TelemetryLevel={}));var w;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(w=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(Q[42],Z([0,1,26,52,5,21,66,35]),function(B,i,D,b,w,O,L,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getPiiPathsFromEnvironment=i.isInternalTelemetry=i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class c{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,b.staticObservableValue)(0)}publicLog(e,n){return Promise.resolve(void 0)}publicLog2(e,n){return this.publicLog(e,n)}publicLogError(e,n){return Promise.resolve(void 0)}publicLogError2(e,n){return this.publicLogError(e,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=c,i.NullTelemetryService=new c;class d{async publicLog(e,n,t){}async publicLogError(e,n,t){}}i.NullEndpointTelemetryService=d,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(s,e){return e.onDidChangeConfiguration(n=>{n.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,O.ConfigurationTargetToString)(n.source),configurationKeys:l(n.sourceConfig)})})}i.configurationTelemetry=C;function E(s,e){return!(e.disableTelemetry||!s.enableTelemetry||e.extensionTestsLocationURI)}i.supportsTelemetry=E;function h(s){const e=s.getValue(p.TELEMETRY_SETTING_ID),n=s.getValue("telemetry.enableCrashReporter");if(s.getValue(p.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(e??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=h;function v(s){const e={},n={},t={};y(s,t);for(let r in t){r=r.length>150?r.substr(r.length-149):r;const o=t[r];typeof o=="number"?n[r]=o:typeof o=="boolean"?n[r]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${o.length}`),e[r]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(e[r]=o)}return{properties:e,measurements:n}}i.validateTelemetryData=v;const f=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function m(s){if(!s)return"none";for(const e of f)if(s.startsWith(`${e}+`))return e;return"other"}i.cleanRemoteAuthority=m;function y(s,e,n=0,t){if(!!s)for(const r of Object.getOwnPropertyNames(s)){const o=s[r],S=t?t+r:r;Array.isArray(o)?e[S]=(0,D.safeStringify)(o):o instanceof Date?e[S]=o.toISOString():(0,w.isObject)(o)?n<2?y(o,e,n+1,S+"."):e[S]=(0,D.safeStringify)(o):e[S]=o}}function l(s){if(!s)return[];const e=[];return u(e,"",s),e}function u(s,e,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(t=>u(s,e?`${e}.${t}`:t,n[t])):s.push(e)}function g(s,e){const n=s.msftInternalDomains||[],t=e.getValue("telemetry.internalTesting");return(0,L.verifyMicrosoftInternalDomain)(n)||t}i.isInternalTelemetry=g;function a(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}i.getPiiPathsFromEnvironment=a}),define(Q[130],Z([0,1,103,42]),function(B,i,D,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=void 0;async function w(O,L,p,c,d,C,E){const h={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${L.nameShort})`},v=await(0,D.getServiceMachineId)(p,d,C),{sessionId:f}=await E.getTelemetryInfo();return(0,b.supportsTelemetry)(L,p)&&(0,b.getTelemetryLevel)(c)===3&&(h["X-Market-User-Id"]=v,h["VSCode-SessionId"]=f),h}i.resolveMarketplaceHeaders=w}),define(Q[131],Z([0,1,12,26,42]),function(B,i,D,b,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractOneDataSystemAppender=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function L(c,d,C){const E=await new Promise((y,l)=>{B(["@microsoft/1ds-core-js"],y,l)}),h=await new Promise((y,l)=>{B(["@microsoft/1ds-post-js"],y,l)}),v=new E.AppInsightsCore,f=new h.PostChannel,m={instrumentationKey:c,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(C){m.extensionConfig={};const y={alwaysUseXhrOverride:!0,httpXHROverride:C};m.extensionConfig[f.identifier]=y}return v.initialize(m,[]),v.addTelemetryInitializer(y=>{d&&(y.ext=y.ext??{},y.ext.utc=y.ext.utc??{},y.ext.utc.flags=8462029)}),v}class p{constructor(d,C,E,h,v){this._isInternalTelemetry=d,this._eventPrefix=C,this._defaultData=E,this._xhrOverride=v,this.endPointUrl=O,this._defaultData||(this._defaultData={}),typeof h=="function"?this._aiCoreOrKey=h():this._aiCoreOrKey=h,this._asyncAiCore=null}_withAIClient(d){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){d(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=L(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(C=>{d(C)},C=>{(0,D.onUnexpectedError)(C),console.error(C)})}}log(d,C){if(!this._aiCoreOrKey)return;C=(0,b.mixin)(C,this._defaultData),C=(0,w.validateTelemetryData)(C);const E=this._eventPrefix+"/"+d;try{this._withAIClient(h=>{h.pluginVersionString=C?.properties.version??"Unknown",h.track({name:E,baseData:{name:E,properties:C?.properties,measurements:C?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(d=>{this._withAIClient(C=>{C.unload(!0,()=>{this._aiCoreOrKey=void 0,d(void 0)})})}):Promise.resolve(void 0)}}i.AbstractOneDataSystemAppender=p}),define(Q[132],Z([0,1,2,26,52,13,27,96,21,40,133,28,33,35,42]),function(B,i,D,b,w,O,L,p,c,d,C,E,h,v,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let m=class{constructor(u,g,a){this._configurationService=g,this._productService=a,this._experimentProperties={},this.telemetryLevel=new w.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(u,g){this._experimentProperties[u]=g}_updateTelemetryLevel(){let u=(0,f.getTelemetryLevel)(this._configurationService);const g=this._productService.enabledTelemetryLevels;if(g){this._sendErrorTelemetry=this.sendErrorTelemetry?g.error:!1;const a=g.usage?3:g.error?2:0;u=Math.min(u,a)}this.telemetryLevel.value=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const u=await this._commonProperties,g=u.sessionID,a=u["common.machineId"],s=u["common.firstSessionDate"],e=u["common.msftInternal"];return{sessionId:g,machineId:a,firstSessionDate:s,msftInternal:e}}dispose(){this._disposables.dispose()}_log(u,g,a,s){return this.telemetryLevel.value<g?Promise.resolve(void 0):this._commonProperties.then(e=>{a=(0,b.mixin)(a,e),a=(0,b.mixin)(a,this._experimentProperties),a=(0,b.cloneAndChange)(a,n=>{if(typeof n=="string")return this._cleanupInfo(n,s)}),this._appenders.forEach(n=>n.log(u,a))},e=>{console.error(e)})}publicLog(u,g,a){return this._log(u,3,g,a)}publicLog2(u,g,a){return this.publicLog(u,g,a)}publicLogError(u,g){return this._sendErrorTelemetry?this._log(u,2,g,!0):Promise.resolve(void 0)}publicLogError2(u,g){return this.publicLogError(u,g)}_anonymizeFilePaths(u){let g=u;const a=[];for(const t of this._cleanupPatterns)for(;;){const r=t.exec(u);if(!r)break;a.push([r.index,t.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,e=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let n=0;for(g="";;){const t=e.exec(u);if(!t)break;!s.test(t[0])&&a.every(([r,o])=>t.index<r||t.index>=o)&&(g+=u.substring(n,t.index)+"<REDACTED: user-file-path>",n=e.lastIndex)}return n<u.length&&(g+=u.substr(n)),g}_removePropertiesWithPossibleUserInfo(u){if(!u)return u;const g=u.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const s of a)if(s.regex.test(g))return`<REDACTED: ${s.label}>`;return u}_cleanupInfo(u,g){let a=u;g&&(a=this._anonymizeFilePaths(a));for(const s of this._cleanupPatterns)a=a.replace(s,"");return a=this._removePropertiesWithPossibleUserInfo(a),a}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=he([ee(1,c.IConfigurationService),ee(2,E.IProductService)],m),i.TelemetryService=m;function y(){const l=(0,p.localize)(0,null,C.default.nameLong),u=C.default.privacyStatementUrl?(0,p.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,p.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=O.isWeb?"":(0,p.localize)(3,null),a=(0,p.localize)(4,null),s=(0,p.localize)(5,null),e=(0,p.localize)(6,null),n=(0,p.localize)(7,null),t=`
|       | ${a} | ${s} | ${e} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,p.localize)(8,null);return`
${l} ${u} ${g}

&nbsp;

${n}
${t}

&nbsp;

${r}
`}h.Registry.as(d.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,p.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,p.localize)(10,null),(0,p.localize)(11,null),(0,p.localize)(12,null),(0,p.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),h.Registry.as(d.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,p.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,p.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,p.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,p.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[134],Z([0,1,156,131]),function(B,i,D,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.OneDataSystemAppender=void 0;class w extends b.AbstractOneDataSystemAppender{constructor(L,p,c,d){const C={sendPOST:(E,h)=>{const v={method:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data)}};try{const f=D.request(E.urlString,v,m=>{m.on("data",function(y){h(m.statusCode??200,m.headers,y.toString())}),m.on("error",function(y){h(0,{})})});f.write(E.data),f.end()}catch{h(0,{})}}};super(L,p,c,d,C)}}i.OneDataSystemAppender=w}),define(Q[135],Z([0,1,14,20]),function(B,i,D,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function w(O,L){const p=Object.create(null),c=(C,E)=>{const h=JSON.parse(C);p[E]=h};if(L){const C=[],E=await b.Promises.readdir(L);for(const v of E)try{(await b.Promises.stat((0,D.join)(L,v))).isDirectory()&&C.push(v)}catch{}const h=[];for(const v of C)(await b.Promises.readdir((0,D.join)(L,v))).filter(m=>m==="telemetry.json").length===1&&h.push(v);for(const v of h){const f=(await b.Promises.readFile((0,D.join)(L,v,"telemetry.json"))).toString();c(f,v)}}let d=(await b.Promises.readFile((0,D.join)(O,"telemetry-core.json"))).toString();return c(d,"vscode-core"),d=(await b.Promises.readFile((0,D.join)(O,"telemetry-extensions.json"))).toString(),c(d,"vscode-extensions"),JSON.stringify(p,null,4)}i.buildTelemetryMessage=w}),define(Q[29],Z([0,1,8]),function(B,i,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(Q[136],Z([0,1,4,2,10,18,23,11,9,29]),function(B,i,D,b,w,O,L,p,c,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let C=class extends b.Disposable{constructor(h,v,f,m,y){super(),this.extensionsManagementService=h,this.logService=m,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(u=>{this.installedExtensions=u.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(u=>this.onInstallExtension(u))),this._register(h.onDidInstallExtensions(u=>this.onDidInstallExtensions(u))),this._register(h.onDidUninstallExtension(u=>this.onDidUninstallExtension(u)));const l=w.URI.file(f.extensionsPath);this._register(v.watch(l)),this._register(D.Event.filter(v.onDidFilesChange,u=>u.rawChanges.some(g=>this.doesChangeAffects(g,l)))(()=>this.onDidChange()))}doesChangeAffects(h,v){return h.type!==1&&h.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h.resource),v)?!1:this.uriIdentityService.extUri.isEqual(h.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(h.resource).startsWith(".")}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const v of h)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(v=>!(0,L.areSameExtensions)(v,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,L.areSameExtensions)(v,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(),v=h.filter(m=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,L.areSameExtensions)(y,m.identifier))?!1:m.installedTimestamp&&m.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",m.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",m.identifier.id),!1)),f=this.installedExtensions.filter(m=>this.installingExtensions.some(y=>(0,L.areSameExtensions)(y,m))?!1:h.every(y=>!(0,L.areSameExtensions)(y.identifier,m))?(this.logService.info("Detected extension removed from another source",m.id),!0):!1);this.installedExtensions=h.map(m=>m.identifier),(v.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:f})}}};C=he([ee(1,p.IFileService),ee(2,O.INativeEnvironmentService),ee(3,c.ILogService),ee(4,d.IUriIdentityService)],C),i.ExtensionsWatcher=C}),define(Q[137],Z([0,1,29,104,11,17,69,4,2]),function(B,i,D,b,w,O,L,p,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class d{constructor(h){this.uri=h,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let C=class{constructor(h){this._fileService=h,this._dispooables=new c.DisposableStore,this._limit=2**16;const v=new Map,f=m=>{let y=v.get(m.scheme);return y===void 0&&(y=h.hasProvider(m)&&!this._fileService.hasCapability(m,1024),v.set(m.scheme,y)),y};this._dispooables.add(p.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(m=>{v.delete(m.scheme)})),this.extUri=new O.ExtUri(f),this._canonicalUris=new L.SkipList((m,y)=>this.extUri.compare(m,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,O.normalizePath)(h));const v=this._canonicalUris.get(h);return v?v.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new d(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((f,m)=>f[1].touch<m[1].touch?1:f[1].touch>m[1].touch?-1:0);d._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let f=0;f<v;f++)this._canonicalUris.set(h[f][0],h[f][1].touch())}};C=he([ee(0,w.IFileService)],C),i.UriIdentityService=C,(0,b.registerSingleton)(D.IUriIdentityService,C,!0)}),define(Q[138],Z([0,1,98,14,36,17,10,8,16]),function(B,i,D,b,w,O,L,p,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.hasWorkspaceFileExtension=i.isSavedWorkspace=i.isTemporaryWorkspace=i.isUntitledWorkspace=i.UNTITLED_WORKSPACE_NAME=i.WORKSPACE_FILTER=i.WORKSPACE_SUFFIX=i.WORKSPACE_EXTENSION=i.toWorkspaceFolder=i.WorkspaceFolder=i.Workspace=i.isWorkspaceFolder=i.isWorkspace=i.WorkbenchState=i.reviveIdentifier=i.isWorkspaceIdentifier=i.toWorkspaceIdentifier=i.isSingleFolderWorkspaceIdentifier=i.IWorkspaceContextService=void 0,i.IWorkspaceContextService=(0,p.createDecorator)("contextService");function d(n){const t=n;return typeof t?.id=="string"&&L.URI.isUri(t.uri)}i.isSingleFolderWorkspaceIdentifier=d;function C(n){if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}i.toWorkspaceIdentifier=C;function E(n){const t=n;return typeof t?.id=="string"&&L.URI.isUri(t.configPath)}i.isWorkspaceIdentifier=E;function h(n){const t=n;if(t?.uri)return{id:t.id,uri:L.URI.revive(t.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:L.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}i.reviveIdentifier=h;var v;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(v=i.WorkbenchState||(i.WorkbenchState={}));function f(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}i.isWorkspace=f;function m(n){const t=n;return!!(t&&typeof t=="object"&&L.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}i.isWorkspaceFolder=m;class y{constructor(t,r,o,S,P){this._id=t,this._transient=o,this._configuration=S,this._ignorePathCasing=P,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(t){this._id=t.id,this._configuration=t.configuration,this._transient=t.transient,this._ignorePathCasing=t._ignorePathCasing,this.folders=t.folders}get folders(){return this._folders}set folders(t){this._folders=t,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(t){this._configuration=t}getFolder(t){return t&&this._foldersMap.findSubstr(t)||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const t of this.folders)this._foldersMap.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}i.Workspace=y;class l{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,O.joinPath)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}i.WorkspaceFolder=l;function u(n){return new l({uri:n,index:0,name:(0,O.basenameOrAuthority)(n)},{uri:n.toString()})}i.toWorkspaceFolder=u,i.WORKSPACE_EXTENSION="code-workspace",i.WORKSPACE_SUFFIX=`.${i.WORKSPACE_EXTENSION}`,i.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[i.WORKSPACE_EXTENSION]}],i.UNTITLED_WORKSPACE_NAME="workspace.json";function g(n,t){return O.extUriBiasedIgnorePathCase.isEqualOrParent(n,t.untitledWorkspacesHome)}i.isUntitledWorkspace=g;function a(n){let t;return L.URI.isUri(n)?t=n:t=n.configuration,t?.scheme===c.Schemas.tmp}i.isTemporaryWorkspace=a;function s(n,t){return!g(n,t)&&!a(n)}i.isSavedWorkspace=s;function e(n){return(typeof n=="string"?(0,b.extname)(n):(0,O.extname)(n))===i.WORKSPACE_SUFFIX}i.hasWorkspaceFileExtension=e}),define(Q[25],Z([0,1,53,4,2,17,5,10,97,18,11,8,9,138,36,29,3,30,27]),function(B,i,D,b,w,O,L,p,c,d,C,E,h,v,f,m,y,l,u){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UserDataProfilesService=i.toUserDataProfile=i.EXTENSIONS_RESOURCE_NAME=i.reviveProfile=i.IUserDataProfilesService=i.PROFILES_ENABLEMENT_CONFIG=i.isUserDataProfile=void 0;function g(n){const t=n;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&p.URI.isUri(t.location)&&p.URI.isUri(t.globalStorageHome)&&p.URI.isUri(t.settingsResource)&&p.URI.isUri(t.keybindingsResource)&&p.URI.isUri(t.tasksResource)&&p.URI.isUri(t.snippetsHome)&&((0,L.isUndefined)(t.extensionsResource)||p.URI.isUri(t.extensionsResource)))}i.isUserDataProfile=g,i.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",i.IUserDataProfilesService=(0,E.createDecorator)("IUserDataProfilesService");function a(n,t){return{id:n.id,isDefault:n.isDefault,name:n.name,location:p.URI.revive(n.location).with({scheme:t}),globalStorageHome:p.URI.revive(n.globalStorageHome).with({scheme:t}),settingsResource:p.URI.revive(n.settingsResource).with({scheme:t}),keybindingsResource:p.URI.revive(n.keybindingsResource).with({scheme:t}),tasksResource:p.URI.revive(n.tasksResource).with({scheme:t}),snippetsHome:p.URI.revive(n.snippetsHome).with({scheme:t}),extensionsResource:p.URI.revive(n.extensionsResource)?.with({scheme:t}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}i.reviveProfile=a,i.EXTENSIONS_RESOURCE_NAME="extensions.json";function s(n,t,r,o){return{id:(0,D.hash)(t.path).toString(16),name:n,location:t,isDefault:!1,globalStorageHome:(0,O.joinPath)(t,"globalStorage"),settingsResource:(0,O.joinPath)(t,"settings.json"),keybindingsResource:(0,O.joinPath)(t,"keybindings.json"),tasksResource:(0,O.joinPath)(t,"tasks.json"),snippetsHome:(0,O.joinPath)(t,"snippets"),extensionsResource:(0,O.joinPath)(t,i.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:r,isTransient:o}}i.toUserDataProfile=s;let e=class extends w.Disposable{constructor(t,r,o,S){super(),this.environmentService=t,this.fileService=r,this.uriIdentityService=o,this.logService=S,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new b.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new b.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new b.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new b.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new f.ResourceMap},this.profilesHome=(0,O.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}setEnablement(t){this.enabled!==t&&(this._profilesObject=void 0,this.enabled=t)}get profilesObject(){if(!this._profilesObject){const t=this.enabled?this.getStoredProfiles().map(P=>s(P.name,P.location,P.useDefaultFlags)):[];let r;const o=new f.ResourceMap,S=s((0,c.localize)(0,null),this.environmentService.userRoamingDataHome);if(t.unshift({...S,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||t.length>0||this.transientProfilesObject.profiles.length>0?S.extensionsResource:void 0}),t.length){const P=this.getStoredProfileAssociations();if(P.workspaces)for(const[I,k]of Object.entries(P.workspaces)){const V=p.URI.parse(I),G=p.URI.parse(k),Y=t.find(X=>this.uriIdentityService.extUri.isEqual(X.location,G));Y&&o.set(V,Y)}if(P.emptyWindow){const I=p.URI.parse(P.emptyWindow);r=t.find(k=>this.uriIdentityService.extUri.isEqual(k.location,I))}}this._profilesObject={profiles:t,workspaces:o,emptyWindow:r}}return this._profilesObject}async createTransientProfile(t){const r="Temp",o=new RegExp(`${(0,u.escapeRegExpCharacters)(r)}\\s(\\d+)`);let S=0;for(const I of this.profiles){const k=o.exec(I.name),V=k?parseInt(k[1]):0;S=V>S?V:S}const P=`${r} ${S+1}`;return this.createProfile(P,void 0,t,!0)}async createProfile(t,r,o,S){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);const P=await this.doCreateProfile(t,r,S);return o&&await this.setProfileForWorkspace(o,P),P}async doCreateProfile(t,r,o){let S=this.profileCreationPromises.get(t);return S||(S=(async()=>{try{const P=this.profiles.find(V=>V.name===t);if(P)return P;const I=s(t,(0,O.joinPath)(this.profilesHome,(0,D.hash)((0,l.generateUuid)()).toString(16)),r,o);await this.fileService.createFolder(I.location);const k=[];return this._onWillCreateProfile.fire({profile:I,join(V){k.push(V)}}),await y.Promises.settled(k),this.updateProfiles([I],[],[]),I}finally{this.profileCreationPromises.delete(t)}})(),this.profileCreationPromises.set(t,S)),S}async updateProfile(t,r,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);let S=this.profiles.find(P=>P.id===t.id);if(!S)throw new Error(`Profile '${t.name}' does not exist`);return S=s(r,S.location,o),this.updateProfiles([],[],[S]),S}async removeProfile(t){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(S=>S.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const o=[];this._onWillRemoveProfile.fire({profile:r,join(S){o.push(S)}}),await y.Promises.settled(o),r.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const S of[...this.profilesObject.workspaces.keys()])r.id===this.profilesObject.workspaces.get(S)?.id&&this.profilesObject.workspaces.delete(S);this.updateStoredProfileAssociations(),this.updateProfiles([],[r],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(r.location,{recursive:!0})}catch(S){this.logService.error(S)}}getOrSetProfileForWorkspace(t,r=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let o=this.getProfileForWorkspace(t);return o||(o=r,this.profiles.length>1&&this.setProfileForWorkspaceSync(t,o)),o}async setProfileForWorkspace(t,r){this.setProfileForWorkspaceSync(t,r)}setProfileForWorkspaceSync(t,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);const o=this.profiles.find(S=>S.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(t,o)}unsetWorkspace(t,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${i.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(t,void 0,r)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const t=await this.fileService.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.uriIdentityService.extUri.isEqual(o.location,r.resource))).map(r=>this.fileService.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const t=this.transientProfilesObject.profiles.filter(r=>!this.isProfileAssociatedToWorkspace(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.getWorkspace(t);return p.URI.isUri(r)?this.transientProfilesObject.workspaces.get(r)??this.profilesObject.workspaces.get(r):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(t){return(0,v.isSingleFolderWorkspaceIdentifier)(t)?t.uri:(0,v.isWorkspaceIdentifier)(t)?t.configPath:"empty-window"}isProfileAssociatedToWorkspace(t){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,t.location)||[...this.transientProfilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,t.location)||[...this.profilesObject.workspaces.values()].some(r=>this.uriIdentityService.extUri.isEqual(r.location,t.location)))}updateProfiles(t,r,o){const S=[...this.profiles,...t],P=[];this.transientProfilesObject.profiles=[];for(let I of S)I.isDefault||r.some(k=>I.id===k.id)||(I=o.find(k=>I.id===k.id)??I,I.isTransient?this.transientProfilesObject.profiles.push(I):P.push({location:I.location,name:I.name,useDefaultFlags:I.useDefaultFlags}));this.saveStoredProfiles(P),this._profilesObject=void 0,this.triggerProfilesChanges(t,r,o)}triggerProfilesChanges(t,r,o){this._onDidChangeProfiles.fire({added:t,removed:r,updated:o,all:this.profiles})}updateWorkspaceAssociation(t,r,o){o=r?.isTransient?!0:o,o||this.updateWorkspaceAssociation(t,void 0,!0);const S=this.getWorkspace(t),P=o?this.transientProfilesObject:this.profilesObject;p.URI.isUri(S)?(P.workspaces.delete(S),r&&P.workspaces.set(S,r)):P.emptyWindow=r,o||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const t={};for(const[o,S]of this.profilesObject.workspaces.entries())t[o.toString()]=S.location.toString();const r=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:t,emptyWindow:r}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(t){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(t){throw new Error("not implemented")}};e.PROFILES_KEY="userDataProfiles",e.PROFILE_ASSOCIATIONS_KEY="profileAssociations",e=he([ee(0,d.IEnvironmentService),ee(1,C.IFileService),ee(2,m.IUriIdentityService),ee(3,h.ILogService)],e),i.UserDataProfilesService=e}),define(Q[139],Z([0,1,19,3,24,12,4,2,13,10,82,22,23,34,9,28,35,25]),function(B,i,D,b,w,O,L,p,c,d,C,E,h,v,f,m,y,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let u=class extends p.Disposable{constructor(t,r,o,S,P){super(),this.galleryService=t,this.telemetryService=r,this.logService=o,this.productService=S,this.userDataProfilesService=P,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,p.toDisposable)(()=>{this.installingExtensions.forEach(({task:I})=>I.cancel()),this.uninstallingExtensions.forEach(I=>I.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,E.isTargetPlatformCompatible)(o,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{if(!this.galleryService.isEnabled())throw new E.ExtensionManagementError(C.localize(0,null),E.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(t,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,r)}catch(o){throw s(this.telemetryService,"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(t),error:o}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(o),a(o)}}async uninstall(t,r={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,r)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const r=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:r,compatible:!0},w.CancellationToken.None);if(!o)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,r,o){const S=Y=>`${h.ExtensionKey.create(Y).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!d.URI.isUri(r)){const Y=this.installingExtensions.get(S(r));if(Y){this.logService.info("Extensions is already requested to install",r.identifier.id);const{local:X}=await Y.task.waitUntilTaskIsFinished();return X}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const P=[],I=[],k=[],V=this.createInstallExtensionTask(t,r,o);d.URI.isUri(r)||this.installingExtensions.set(S(r),{task:V,waitingTasks:[]}),this._onInstallExtension.fire({identifier:V.identifier,source:r,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",V.identifier.id),P.push({task:V,manifest:t});let G=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",V.identifier.id);else try{const X=await this.getAllDepsAndPackExtensions(V.identifier,t,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),se=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:oe,manifest:ne}of X){G=G||!!ne.extensionDependencies?.some(ie=>(0,h.areSameExtensions)({id:ie},V.identifier));const fe=S(oe),le=this.installingExtensions.get(fe);if(le){if(this.canWaitForTask(V,le.task)){this.logService.info("Waiting for already requested installing extension",oe.identifier.id,V.identifier.id),le.waitingTasks.push(V);const ie=le.task.identifier;I.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,W=>W.some(N=>(0,h.areSameExtensions)(N.identifier,ie)))).then(W=>{if(!W.find(F=>(0,h.areSameExtensions)(F.identifier,ie))?.local)throw new Error(`Extension ${ie.id} is not installed`)}))}}else if(!se.some(({identifier:ie})=>(0,h.areSameExtensions)(ie,oe.identifier))){const ie=this.createInstallExtensionTask(ne,oe,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(fe,{task:ie,waitingTasks:[V]}),this._onInstallExtension.fire({identifier:ie.identifier,source:oe,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",ie.identifier.id,V.identifier.id),P.push({task:ie,manifest:ne})}}}catch(X){if(d.URI.isUri(V.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",V.identifier.id,X.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",V.identifier.id,X.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",V.identifier.id),X}const Y=P.reduce((X,{task:se,manifest:oe})=>(X.set(se.identifier.id.toLowerCase(),{task:se,manifest:oe}),X),new Map);for(;Y.size;){let X;const se=[...Y.values()].filter(({manifest:oe})=>!oe.extensionDependencies?.some(ne=>Y.has(ne.toLowerCase())));se.length?X=Y.size===1?se:se.filter(({task:oe})=>!(oe===V&&!G)):(this.logService.info("Found extensions with circular dependencies",se.map(({task:oe})=>oe.identifier.id)),X=[...Y.values()]),await this.joinAllSettled(X.map(async({task:oe})=>{const ne=new Date().getTime();try{const{local:fe}=await oe.run();if(await this.joinAllSettled(this.participants.map(le=>le.postInstall(fe,oe.source,o,w.CancellationToken.None))),!d.URI.isUri(oe.source)){const le=oe.operation===3,ie=le?void 0:(new Date().getTime()-oe.source.lastUpdated)/1e3;if(s(this.telemetryService,le?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(oe.source),duration:new Date().getTime()-ne,durationSinceUpdate:ie}),c.isWeb&&oe.operation!==3)try{await this.galleryService.reportStatistic(fe.manifest.publisher,fe.manifest.name,fe.manifest.version,"install")}catch{}}k.push({local:fe,identifier:oe.identifier,operation:oe.operation,source:oe.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:fe.isApplicationScoped})}catch(fe){throw d.URI.isUri(oe.source)||s(this.telemetryService,oe.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(oe.source),duration:new Date().getTime()-ne,error:fe}),this.logService.error("Error while installing the extension:",oe.identifier.id),fe}finally{Y.delete(oe.identifier.id.toLowerCase())}}))}return I.length&&await this.joinAllSettled(I),k.forEach(({identifier:X})=>this.logService.info("Extension installed successfully:",X.id)),this._onDidInstallExtensions.fire(k),k.filter(({identifier:X})=>(0,h.areSameExtensions)(X,V.identifier))[0].local}catch(Y){if(P.forEach(({task:X})=>X.cancel()),k.length)try{const X=await Promise.allSettled(k.map(({local:se})=>this.createUninstallExtensionTask(se,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let se=0;se<X.length;se++){const oe=X[se],{identifier:ne}=k[se];oe.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ne.id):this.logService.warn("Rollback: Error while uninstalling extension",ne.id,(0,O.getErrorMessage)(oe.reason))}}catch(X){this.logService.warn("Error while rolling back extensions",(0,O.getErrorMessage)(X),k.map(({identifier:se})=>se.id))}throw this._onDidInstallExtensions.fire(P.map(({task:X})=>({identifier:X.identifier,operation:2,source:X.source,context:o.context,profileLocation:o.profileLocation}))),Y}finally{for(const[Y,{task:X,waitingTasks:se}]of this.installingExtensions.entries()){const oe=se.indexOf(V);oe!==-1&&se.splice(oe,1),se.length===0&&(X===V||oe!==-1)&&this.installingExtensions.delete(Y)}}}canWaitForTask(t,r){for(const[,{task:o,waitingTasks:S}]of this.installingExtensions.entries())if(o===t&&(S.includes(r)||S.some(P=>this.canWaitForTask(P,r)))||o===r&&S[0]&&!this.canWaitForTask(t,S[0]))return!1;return!0}async joinAllSettled(t){const r=[],o=[],S=await Promise.allSettled(t);for(const P of S)P.status==="fulfilled"?r.push(P.value):o.push(P.reason);if(o.length)throw g(o);return r}async getAllDepsAndPackExtensions(t,r,o,S,P){if(!this.galleryService.isEnabled())return[];const I=await this.getInstalled(void 0,P),k=[t],V=[],G=async(Y,X)=>{const se=X.extensionDependencies||[],oe=[...se];if(X.extensionPack){const ne=o?I.find(fe=>(0,h.areSameExtensions)(fe.identifier,Y)):void 0;for(const fe of X.extensionPack)ne&&ne.manifest.extensionPack&&ne.manifest.extensionPack.some(le=>(0,h.areSameExtensions)({id:le},{id:fe}))||oe.every(le=>!(0,h.areSameExtensions)({id:le},{id:fe}))&&oe.push(fe)}if(oe.length){const ne=[...k,...V.map(le=>le.gallery.identifier)],fe=oe.filter(le=>ne.every(ie=>!(0,h.areSameExtensions)(ie,{id:le})));if(fe.length){const le=await this.galleryService.getExtensions(fe.map(ie=>({id:ie,preRelease:S})),w.CancellationToken.None);for(const ie of le){if(ne.find(F=>(0,h.areSameExtensions)(F,ie.identifier)))continue;const W=se.some(F=>(0,h.areSameExtensions)({id:F},ie.identifier));let N;try{N=await this.checkAndGetCompatibleVersion(ie,!1,S)}catch(F){if(F instanceof E.ExtensionManagementError&&F.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!W){this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id);continue}else throw F}V.push({gallery:N.extension,manifest:N.manifest}),await G(N.extension.identifier,N.manifest)}}}};return await G(t,r),V}async checkAndGetCompatibleVersion(t,r,o){if((await this.getExtensionsControlManifest()).malicious.some(k=>(0,h.areSameExtensions)(t.identifier,k)))throw new E.ExtensionManagementError(C.localize(3,null,t.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const k=await this.getTargetPlatform();throw new E.ExtensionManagementError(C.localize(4,null,t.identifier.id,this.productService.nameLong,(0,E.TargetPlatformToString)(k)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const P=await this.getCompatibleVersion(t,r,o);if(P){if(o&&!r&&t.hasPreReleaseVersion&&!P.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(C.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],w.CancellationToken.None))[0]?new E.ExtensionManagementError(C.localize(6,null,t.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(C.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),E.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",P.identifier.id);const I=await this.galleryService.getManifest(P,w.CancellationToken.None);if(I===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(I.version!==P.version)throw new E.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:P,manifest:I}}async getCompatibleVersion(t,r,o){const S=await this.getTargetPlatform();let P=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(P=(await this.galleryService.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:S,compatible:!0},w.CancellationToken.None))[0]||null),!P&&await this.galleryService.isExtensionCompatible(t,o,S)&&(P=t),P||(r?P=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:S,compatible:!0},w.CancellationToken.None))[0]||null:P=await this.galleryService.getCompatibleExtension(t,o,S)),P}async uninstallExtension(t,r){const o=G=>`${G.id.toLowerCase()}${r.versionOnly?`-${t.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,S=this.uninstallingExtensions.get(o(t.identifier));if(S)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),S.waitUntilTaskIsFinished();const P=(G,Y)=>{const X=this.createUninstallExtensionTask(G,Y);return this.uninstallingExtensions.set(o(X.extension.identifier),X),r.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${G.identifier.id}@${G.manifest.version}`,r.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${G.identifier.id}@${G.manifest.version}`),this._onUninstallExtension.fire({identifier:G.identifier,profileLocation:r.profileLocation,applicationScoped:G.isApplicationScoped}),X},I=(G,Y)=>{Y?r.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${G.identifier.id}@${G.manifest.version}`,r.profileLocation.toString(),Y.message):this.logService.error("Failed to uninstall extension:",`${G.identifier.id}@${G.manifest.version}`,Y.message):r.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${G.identifier.id}@${G.manifest.version}`,r.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${G.identifier.id}@${G.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,h.getLocalExtensionTelemetryData)(G),error:Y}),this._onDidUninstallExtension.fire({identifier:G.identifier,version:G.manifest.version,error:Y?.code,profileLocation:r.profileLocation,applicationScoped:G.isApplicationScoped})},k=[],V=[];try{k.push(P(t,r));const G=await this.getInstalled(1,r.profileLocation);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const Y=this.getAllPackExtensionsToUninstall(t,G);for(const X of Y)this.uninstallingExtensions.has(o(X.identifier))?this.logService.info("Extensions is already requested to uninstall",X.identifier.id):k.push(P(X,r))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(k.map(Y=>Y.extension),G,t),await this.joinAllSettled(k.map(async Y=>{try{if(await Y.run(),await this.joinAllSettled(this.participants.map(X=>X.postUninstall(Y.extension,r,w.CancellationToken.None))),Y.extension.identifier.uuid)try{await this.galleryService.reportStatistic(Y.extension.manifest.publisher,Y.extension.manifest.name,Y.extension.manifest.version,"uninstall")}catch{}I(Y.extension)}catch(X){const se=X instanceof E.ExtensionManagementError?X:new E.ExtensionManagementError((0,O.getErrorMessage)(X),E.ExtensionManagementErrorCode.Internal);throw I(Y.extension,se),se}finally{V.push(Y)}}))}catch(G){const Y=G instanceof E.ExtensionManagementError?G:new E.ExtensionManagementError((0,O.getErrorMessage)(G),E.ExtensionManagementErrorCode.Internal);for(const X of k){try{X.cancel()}catch{}V.includes(X)||I(X.extension,Y)}throw Y}finally{for(const G of k)this.uninstallingExtensions.delete(o(G.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",G.extension.identifier.id)}}checkForDependents(t,r,o){for(const S of t){const P=this.getDependents(S,r);if(P.length){const I=P.filter(k=>!t.some(V=>(0,h.areSameExtensions)(V.identifier,k.identifier)));if(I.length)throw new Error(this.getDependentsErrorMessage(S,I,o))}}}getDependentsErrorMessage(t,r,o){return o===t?r.length===1?C.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(9,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(10,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?C.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(12,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(13,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(t,r,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const S=t.manifest.extensionPack?t.manifest.extensionPack:[];if(S.length){const P=r.filter(k=>!k.isBuiltin&&S.some(V=>(0,h.areSameExtensions)({id:V},k.identifier))),I=[];for(const k of P)I.push(...this.getAllPackExtensionsToUninstall(k,r,o));return[...P,...I]}return[]}getDependents(t,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(S=>(0,h.areSameExtensions)({id:S},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,r,o){return o.profileLocation&&(0,v.isApplicationScopedExtension)(t)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,r,o)}createUninstallExtensionTask(t,r){return r.profileLocation&&t.isApplicationScoped&&(r={...r,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,r)}};u=he([ee(0,E.IExtensionGalleryService),ee(1,y.ITelemetryService),ee(2,f.ILogService),ee(3,m.IProductService),ee(4,l.IUserDataProfilesService)],u),i.AbstractExtensionManagementService=u;function g(n){const t=Array.isArray(n)?n:[n];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}i.joinErrors=g;function a(n){if(n instanceof E.ExtensionManagementError)return n;const t=new E.ExtensionManagementError(n.message,E.ExtensionManagementErrorCode.Internal);return t.stack=n.stack,t}function s(n,t,{extensionData:r,duration:o,error:S,durationSinceUpdate:P}){const I=S?S instanceof E.ExtensionManagementError?S.code:E.ExtensionManagementErrorCode.Internal:void 0;n.publicLog(t,{...r,success:!S,duration:o,errorcode:I,durationSinceUpdate:P})}i.reportTelemetry=s;class e{constructor(){this.barrier=new b.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(t=>new Promise((r,o)=>{const S=t.onCancellationRequested(()=>{S.dispose(),o(new O.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=e}),define(Q[48],Z([0,1,19,3,26,15,12,50,74,2,16,14,13,17,39,54,5,10,86,18,23,34,45,11,8,9,28,4,44,41,25,29,102]),function(B,i,D,b,w,O,L,p,c,d,C,E,h,v,f,m,y,l,u,g,a,s,e,n,t,r,o,S,P,I,k,V,G){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeExtensionsScannerService=i.toExtensionDescription=i.AbstractExtensionsScannerService=i.IExtensionsScannerService=i.Translations=void 0;var Y;(function(ie){function W(N,F){if(N===F)return!0;const z=Object.keys(N),$=new Set;for(const J of Object.keys(F))$.add(J);if(z.length!==$.size)return!1;for(const J of z){if(N[J]!==F[J])return!1;$.delete(J)}return $.size===0}ie.equals=W})(Y=i.Translations||(i.Translations={})),i.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let X=class extends d.Disposable{constructor(W,N,F,z,$,J,A,U,R,T,M){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=N,this.extensionsControlLocation=F,this.cacheLocation=z,this.userDataProfilesService=$,this.extensionsProfileScannerService=J,this.fileService=A,this.logService=U,this.environmentService=R,this.productService=T,this.instantiationService=M,this._onDidChangeCache=this._register(new S.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ne,(0,v.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ne,(0,v.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(oe,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,a.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(W,N,F){const[z,$]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(N)]),J=F?await this.scanExtensionsUnderDevelopment(W,[...z,...$]):[];return this.dedupExtensions(z,$,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const N=[];N.push(this.scanDefaultSystemExtensions(!!W.useCache,W.language)),N.push(this.scanDevSystemExtensions(W.language,!!W.checkControlFile));const[F,z]=await Promise.all(N);return this.applyScanOptions([...F,...z],0,W,!1)}async scanUserExtensions(W){this.logService.trace("Started scanning user extensions");const N=await this.createExtensionScannerInput(W.profileLocation??this.userExtensionsLocation,!!W.profileLocation,1,!W.includeUninstalled,W.language);let z=await(W.useCache&&!N.devMode&&N.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(N);return z=await this.applyScanOptions(z,1,W,!0),this.logService.trace("Scanned user extensions:",z.length),z}async scanExtensionsUnderDevelopment(W,N){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const F=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(z=>z.scheme===C.Schemas.file).map(async z=>{const $=await this.createExtensionScannerInput(z,!1,1,!0,W.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions($)).map(A=>(A.type=N.find(U=>(0,a.areSameExtensions)(U.identifier,A.identifier))?.type??A.type,this.extensionsScanner.validate(A,$)))}))).flat();return this.applyScanOptions(F,"development",W,!0)}return[]}async scanExistingExtension(W,N,F){const z=await this.createExtensionScannerInput(W,!1,N,!0,F.language),$=await this.extensionsScanner.scanExtension(z);return!$||!F.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(W,N,F){const z=await this.createExtensionScannerInput(W,!1,N,!0,F.language),$=await this.extensionsScanner.scanOneOrMultipleExtensions(z);return this.applyScanOptions($,N,F,!0)}async scanMetadata(W){const N=(0,v.joinPath)(W,"package.json"),F=(await this.fileService.readFile(N)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(W,N){const F=(0,v.joinPath)(W,"package.json"),z=(await this.fileService.readFile(F)).value.toString(),$=JSON.parse(z);N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.installedTimestamp=N.installedTimestamp||void 0,$.__metadata={...$.__metadata,...N},await this.fileService.writeFile((0,v.joinPath)(W,"package.json"),O.VSBuffer.fromString(JSON.stringify($,null,"	")))}async applyScanOptions(W,N,F,z){return F.includeAllVersions||(W=this.dedupExtensions(N===0?W:void 0,N===1?W:void 0,N==="development"?W:void 0,await this.getTargetPlatform(),z)),F.includeInvalid||(W=W.filter($=>$.isValid)),W.sort(($,J)=>{const A=E.basename($.location.fsPath),U=E.basename(J.location.fsPath);return A<U?-1:A>U?1:0})}dedupExtensions(W,N,F,z,$){const J=(U,R,T)=>{if(U.isValid&&!R.isValid)return!1;if(U.isValid===R.isValid){if($&&f.gt(U.manifest.version,R.manifest.version))return this.logService.debug(`Skipping extension ${R.location.path} with lower version ${R.manifest.version} in favour of ${U.location.path} with version ${U.manifest.version}`),!1;if(f.eq(U.manifest.version,R.manifest.version)){if(U.type===0)return this.logService.debug(`Skipping extension ${R.location.path} in favour of system extension ${U.location.path} with same version`),!1;if(U.targetPlatform===z)return this.logService.debug(`Skipping extension ${R.location.path} from different target platform ${R.targetPlatform}`),!1}}return T?this.logService.warn(`Overwriting user extension ${U.location.path} with ${R.location.path}.`):this.logService.debug(`Overwriting user extension ${U.location.path} with ${R.location.path}.`),!0},A=new Map;return W?.forEach(U=>{const R=s.ExtensionIdentifier.toKey(U.identifier.id),T=A.get(R);(!T||J(T,U,!1))&&A.set(R,U)}),N?.forEach(U=>{const R=s.ExtensionIdentifier.toKey(U.identifier.id),T=A.get(R);if(!T&&W&&U.type===0){this.logService.debug(`Skipping obsolete system extension ${U.location.path}.`);return}(!T||J(T,U,!1))&&A.set(R,U)}),F?.forEach(U=>{const R=s.ExtensionIdentifier.toKey(U.identifier.id),T=A.get(R);(!T||J(T,U,!0))&&A.set(R,U),A.set(R,U)}),[...A.values()]}async scanDefaultSystemExtensions(W,N){this.logService.trace("Started scanning system extensions");const F=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,N),$=await(W&&!F.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return this.logService.trace("Scanned system extensions:",$.length),$}async scanDevSystemExtensions(W,N){const F=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!F?.length)return[];this.logService.trace("Started scanning dev system extensions");const z=N?await this.getBuiltInExtensionControl():{},$=[],J=l.URI.file(E.normalize(E.join(C.FileAccess.asFileUri("",B).fsPath,"..",".build","builtInExtensions")));for(const U of F){const R=z[U.name]||"marketplace";switch(R){case"disabled":break;case"marketplace":$.push((0,v.joinPath)(J,U.name));break;default:$.push(l.URI.file(R));break}}const A=await Promise.all($.map(async U=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(U,!1,0,!0,W))));return this.logService.trace("Scanned dev system extensions:",A.length),(0,D.coalesce)(A)}async getBuiltInExtensionControl(){try{const W=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(W.value.toString())}catch{return{}}}async createExtensionScannerInput(W,N,F,z,$,J=!0){const A=await this.getTranslations($??h.language),U=await this.getMtime(W),R=N?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,T=R?await this.getMtime(R):void 0;return new se(W,U,R,T,N,F,z,J,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,$,A)}async getMtime(W){try{const N=await this.fileService.stat(W);if(typeof N.mtime=="number")return N.mtime}catch{}}};X=he([ee(4,k.IUserDataProfilesService),ee(5,I.IExtensionsProfileScannerService),ee(6,n.IFileService),ee(7,r.ILogService),ee(8,g.IEnvironmentService),ee(9,o.IProductService),ee(10,t.IInstantiationService)],X),i.AbstractExtensionsScannerService=X;class se{constructor(W,N,F,z,$,J,A,U,R,T,M,j,_,H){this.location=W,this.mtime=N,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=z,this.profile=$,this.type=J,this.excludeObsolete=A,this.validate=U,this.productVersion=R,this.productDate=T,this.productCommit=M,this.devMode=j,this.language=_,this.translations=H}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,N){return(0,v.isEqual)(W.location,N.location)&&W.mtime===N.mtime&&(0,v.isEqual)(W.applicationExtensionslocation,N.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===N.applicationExtensionslocationMtime&&W.profile===N.profile&&W.type===N.type&&W.excludeObsolete===N.excludeObsolete&&W.validate===N.validate&&W.productVersion===N.productVersion&&W.productDate===N.productDate&&W.productCommit===N.productCommit&&W.devMode===N.devMode&&W.language===N.language&&Y.equals(W.translations,N.translations)}}let oe=class extends d.Disposable{constructor(W,N,F,z,$){super(),this.obsoleteFile=W,this.extensionsProfileScannerService=N,this.uriIdentityService=F,this.fileService=z,this.logService=$}async scanExtensions(W){const N=W.profile?await this.scanExtensionsFromProfile(W):await this.scanExtensionsFromLocation(W);let F={};if(W.excludeObsolete&&W.type===1)try{const z=(await this.fileService.readFile(this.obsoleteFile)).value.toString();F=JSON.parse(z)}catch{}return(0,y.isEmptyObject)(F)?N:N.filter(z=>!F[a.ExtensionKey.create(z).toString()])}async scanExtensionsFromLocation(W){const N=await this.fileService.resolve(W.location);if(!N.children?.length)return[];const F=await Promise.all(N.children.map(async z=>{if(!z.isDirectory||W.type===1&&(0,v.basename)(z.resource).indexOf(".")===0)return null;const $=new se(z.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension($)}));return(0,D.coalesce)(F).sort((z,$)=>z.location.path<$.location.path?-1:1)}async scanExtensionsFromProfile(W){let N=await this.scanExtensionsFromProfileResource(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(W.location,W.applicationExtensionslocation)){N=N.filter(z=>!z.metadata?.isApplicationScoped);const F=await this.scanExtensionsFromProfileResource(W.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,W);N.push(...F)}return N}async scanExtensionsFromProfileResource(W,N,F){const z=await this.extensionsProfileScannerService.scanProfileExtensions(W);if(!z.length)return[];const $=await Promise.all(z.map(async J=>{if(N(J)){const A=new se(J.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(A,J.metadata)}return null}));return(0,D.coalesce)($)}async scanOneOrMultipleExtensions(W){try{if(await this.fileService.exists((0,v.joinPath)(W.location,"package.json"))){const N=await this.scanExtension(W);return N?[N]:[]}else return await this.scanExtensions(W)}catch(N){return this.logService.error(`Error scanning extensions at ${W.location.path}:`,(0,L.getErrorMessage)(N)),[]}}async scanExtension(W,N){try{let F=await this.scanExtensionManifest(W.location);if(F){F.publisher||(F.publisher=s.UNDEFINED_PUBLISHER),N=N??F.__metadata,delete F.__metadata;const z=(0,a.getGalleryExtensionId)(F.publisher,F.name),$=N?.id?{id:z,uuid:N.id}:{id:z},J=N?.isSystem?0:W.type,A=J===0||!!N?.isBuiltin;F=await this.translateManifest(W.location,F,se.createNlsConfiguration(W));const U={type:J,identifier:$,manifest:F,location:W.location,isBuiltin:A,targetPlatform:N?.targetPlatform??"undefined",metadata:N,isValid:!0,validations:[]};return W.validate?this.validate(U,W):U}}catch(F){W.type!==0&&this.logService.error(F)}return null}validate(W,N){let F=!0;const z=(0,e.validateExtensionManifest)(N.productVersion,N.productDate,N.location,W.manifest,W.isBuiltin);for(const[$,J]of z)$===m.default.Error&&(F=!1,this.logService.error(this.formatMessage(N.location,J)));return W.isValid=F,W.validations=z,W}async scanExtensionManifest(W){const N=(0,v.joinPath)(W,"package.json");let F;try{F=(await this.fileService.readFile(N)).value.toString()}catch($){return(0,n.toFileOperationResult)($)!==1&&this.logService.error(this.formatMessage(W,(0,u.localize)(0,null,N.path,$.message))),null}let z;try{z=JSON.parse(F)}catch{const J=[];(0,p.parse)(F,J);for(const A of J)this.logService.error(this.formatMessage(W,(0,u.localize)(1,null,N.path,A.offset,A.length,(0,c.getParseErrorMessage)(A.error))));return null}return(0,p.getNodeType)(z)!=="object"?(this.logService.error(this.formatMessage(W,(0,u.localize)(2,null,N.path))),null):z}async translateManifest(W,N,F){const z=await this.getLocalizedMessages(W,N,F);if(z)try{const $=[],J=await this.resolveOriginalMessageBundle(z.default,$);if($.length>0)return $.forEach(U=>{this.logService.error(this.formatMessage(W,(0,u.localize)(3,null,z.default?.path,(0,c.getParseErrorMessage)(U.error))))}),N;if((0,p.getNodeType)(z)!=="object")return this.logService.error(this.formatMessage(W,(0,u.localize)(4,null,z.default?.path))),N;const A=z.values||Object.create(null);return(0,G.localizeManifest)(N,A,J)}catch{}return N}async getLocalizedMessages(W,N,F){const z=(0,v.joinPath)(W,"package.nls.json"),$=(R,T)=>{T.forEach(M=>{this.logService.error(this.formatMessage(W,(0,u.localize)(5,null,R?.path,(0,c.getParseErrorMessage)(M.error))))})},J=R=>{this.logService.error(this.formatMessage(W,(0,u.localize)(6,null,R?.path)))},A=`${N.publisher}.${N.name}`,U=F.translations[A];if(U)try{const R=l.URI.file(U),T=(await this.fileService.readFile(R)).value.toString(),M=[],j=(0,p.parse)(T,M);return M.length>0?($(R,M),{values:void 0,default:z}):(0,p.getNodeType)(j)!=="object"?(J(R),{values:void 0,default:z}):{values:j.contents?j.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.fileService.exists(z))return;let T;try{T=await this.findMessageBundles(W,F)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const M=(await this.fileService.readFile(T.localized)).value.toString(),j=[],_=(0,p.parse)(M,j);return j.length>0?($(T.localized,j),{values:void 0,default:T.original}):(0,p.getNodeType)(_)!=="object"?(J(T.localized),{values:void 0,default:T.original}):{values:_,default:T.original}}catch{return{values:void 0,default:T.original}}}}async resolveOriginalMessageBundle(W,N){if(W)try{const F=(await this.fileService.readFile(W)).value.toString();return(0,p.parse)(F,N)}catch{}}findMessageBundles(W,N){return new Promise((F,z)=>{const $=J=>{const A=(0,v.joinPath)(W,`package.nls.${J}.json`);this.fileService.exists(A).then(U=>{U&&F({localized:A,original:(0,v.joinPath)(W,"package.nls.json")});const R=J.lastIndexOf("-");R===-1?F({localized:(0,v.joinPath)(W,"package.nls.json"),original:null}):(J=J.substring(0,R),$(J))})};if(N.devMode||N.pseudo||!N.language)return F({localized:(0,v.joinPath)(W,"package.nls.json"),original:null});$(N.language)})}formatMessage(W,N){return`[${W.path}]: ${N}`}};oe=he([ee(1,I.IExtensionsProfileScannerService),ee(2,V.IUriIdentityService),ee(3,n.IFileService),ee(4,r.ILogService)],oe);let ne=class extends oe{constructor(W,N,F,z,$,J){super(N,F,z,$,J),this.cacheFile=W,this.cacheValidatorThrottler=this._register(new b.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new S.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(W){const N=await this.readExtensionCache();if(this.input=W,N&&N.input&&se.equals(N.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),N.result.map(z=>(z.location=l.URI.revive(z.location),z));const F=await super.scanExtensions(W);return await this.writeExtensionCache({input:W,result:F}),F}async readExtensionCache(){try{const W=await this.fileService.readFile(this.cacheFile),N=JSON.parse(W.value.toString());return{result:N.result,input:(0,P.revive)(N.input)}}catch(W){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(W))}return null}async writeExtensionCache(W){try{await this.fileService.writeFile(this.cacheFile,O.VSBuffer.fromString(JSON.stringify(W)))}catch(N){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,L.getErrorMessage)(N))}}async validateCache(){if(!this.input)return;const W=await this.readExtensionCache();if(!W)return;const N=W.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!w.equals(F,N))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(z){this.logService.error(z)}}};ne=he([ee(2,I.IExtensionsProfileScannerService),ee(3,V.IUriIdentityService),ee(4,n.IFileService),ee(5,r.ILogService)],ne);function fe(ie,W){const N=(0,a.getExtensionId)(ie.manifest.publisher,ie.manifest.name);return{id:N,identifier:new s.ExtensionIdentifier(N),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:W,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}i.toExtensionDescription=fe;class le extends X{constructor(W,N,F,z,$,J,A,U,R,T,M){super(W,N,(0,v.joinPath)(F,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(z,s.MANIFEST_CACHE_FOLDER),$,J,A,U,R,T,M),this.translationsPromise=(async()=>{if(h.translationsConfigFile)try{const j=await this.fileService.readFile(l.URI.file(h.translationsConfigFile));return JSON.parse(j.value.toString())}catch{}return Object.create(null)})()}getTranslations(W){return this.translationsPromise}}i.NativeExtensionsScannerService=le}),define(Q[140],Z([0,1,57,3,31,4,2,16,14,20,9,25]),function(B,i,D,b,w,O,L,p,c,d,C,E){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let h=class extends L.Disposable{constructor(f,m){super(),this.userDataProfilesService=f,this.logService=m,this.processesLimiter=new b.Limiter(5)}async postUninstall(f){const m=this.parseScript(f,"uninstall");return m&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(m.script,"uninstall",m.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${y}`)))),d.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(f,m){const y=`vscode:${m}`;if(f.location.scheme===p.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[y]=="string"){const l=f.manifest.scripts[y].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${y} should be a node script`),null):{script:(0,c.join)(f.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}runLifecycleHook(f,m,y,l,u){return new Promise((g,a)=>{const s=this.start(f,m,y,u);let e;const n=t=>{e&&(clearTimeout(e),e=null),t?a(t):g(void 0)};s.on("error",t=>{n((0,w.toErrorMessage)(t)||"Unknown")}),s.on("exit",(t,r)=>{n(t?`post-${m} process exited with code ${t}`:void 0)}),l&&(e=setTimeout(()=>{e=null,s.kill(),a("timed out")},5e3))})}start(f,m,y,l){const u={silent:!0,execArgv:void 0},g=(0,D.fork)(f,[`--type=extension-post-${m}`,...y],u);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const a=O.Event.fromNodeEventEmitter(g.stdout,"data"),s=O.Event.fromNodeEventEmitter(g.stderr,"data");a(t=>this.logService.info(l.identifier.id,l.manifest.version,`post-${m}`,t)),s(t=>this.logService.error(l.identifier.id,l.manifest.version,`post-${m}`,t));const e=O.Event.any(O.Event.map(a,t=>({data:`%c${t}`,format:[""]})),O.Event.map(s,t=>({data:`%c${t}`,format:["color: red"]})));return O.Event.debounce(e,(t,r)=>t?{data:t.data+r.data,format:[...t.format,...r.format]}:{data:r.data,format:r.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),g}getExtensionStoragePath(f){return(0,c.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};h=he([ee(0,E.IUserDataProfilesService),ee(1,C.ILogService)],h),i.ExtensionsLifecycle=h}),define(Q[141],Z([0,1,10,18,41,48,11,8,9,28,25]),function(B,i,D,b,w,O,L,p,c,d,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScannerService=void 0;let E=class extends O.NativeExtensionsScannerService{constructor(v,f,m,y,l,u,g){super(D.URI.file(l.builtinExtensionsPath),D.URI.file(l.extensionsPath),l.userHome,D.URI.file(l.userDataPath),v,f,m,y,l,u,g)}};E=he([ee(0,C.IUserDataProfilesService),ee(1,w.IExtensionsProfileScannerService),ee(2,L.IFileService),ee(3,c.ILogService),ee(4,b.INativeEnvironmentService),ee(5,d.IProductService),ee(6,p.IInstantiationService)],E),i.ExtensionsScannerService=E}),define(Q[142],Z([0,1,3,4,2,112,5,79,8,25]),function(B,i,D,b,w,O,L,p,c,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.isProfileUsingDefaultStorage=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";i.IStorageService=(0,c.createDecorator)("storageService");var E;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(E=i.WillSaveStateReason||(i.WillSaveStateReason={}));var h;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(h=i.StorageScope||(i.StorageScope={}));var v;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(v=i.StorageTarget||(i.StorageTarget={}));class f extends w.Disposable{constructor(g={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super(),this.options=g,this._onDidChangeValue=this._register(new b.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new b.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new b.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,O.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,a){if(a===C){switch(g){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:g})}else this._onDidChangeValue.fire({scope:g,key:a,target:this.getKeyTargets(g)[a]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,a,s){return this.getStorage(a)?.get(g,s)}getBoolean(g,a,s){return this.getStorage(a)?.getBoolean(g,s)}getNumber(g,a,s){return this.getStorage(a)?.getNumber(g,s)}store(g,a,s,e){if((0,L.isUndefinedOrNull)(a)){this.remove(g,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,s,e),this.getStorage(s)?.set(g,a)})}remove(g,a){this.withPausedEmitters(()=>{this.updateKeyTarget(g,a,void 0),this.getStorage(a)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,a){const s=[],e=this.getKeyTargets(g);for(const n of Object.keys(e))e[n]===a&&s.push(n);return s}updateKeyTarget(g,a,s){const e=this.getKeyTargets(a);typeof s=="number"?e[g]!==s&&(e[g]=s,this.getStorage(a)?.set(C,JSON.stringify(e))):typeof e[g]=="number"&&(delete e[g],this.getStorage(a)?.set(C,JSON.stringify(e)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(g){switch(g){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(g){const a=this.get(C,g);if(a)try{return JSON.parse(a)}catch{}return Object.create(null)}isNew(g){return this.getBoolean(i.IS_NEW_KEY,g)===!0}async flush(g=E.NONE){this._onWillSaveState.fire({reason:g});const a=this.getStorage(-1),s=this.getStorage(0),e=this.getStorage(1);switch(g){case E.NONE:await D.Promises.settled([a?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),e?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await D.Promises.settled([a?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),e?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.getStorage(-1)?.items??new Map,a=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return l(g,a,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(g,a){return this.emitWillSaveState(E.NONE),(0,d.isUserDataProfile)(g)?this.switchToProfile(g,a):this.switchToWorkspace(g,a)}canSwitchProfile(g,a){return!(g.id===a.id||m(a)&&m(g))}switchData(g,a,s,e){this.withPausedEmitters(()=>{if(e)for(const[n,t]of g)a.set(n,t);else{const n=new Set;for(const[t,r]of g)n.add(t),a.get(t)!==r&&this.emitDidChangeValue(s,t);for(const[t]of a.items)n.has(t)||this.emitDidChangeValue(s,t)}})}}i.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;function m(u){return u.isDefault||!!u.useDefaultFlags?.uiState}i.isProfileUsingDefaultStorage=m;class y extends f{constructor(){super(),this.applicationStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this.profileStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.profileStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),this._register(this.applicationStorage.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g)))}getStorage(g){switch(g){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}i.InMemoryStorageService=y;async function l(u,g,a,s,e,n){const t=Y=>{try{return JSON.parse(Y)}catch{return Y}},r=new Map,o=new Map;u.forEach((Y,X)=>{r.set(X,Y),o.set(X,t(Y))});const S=new Map,P=new Map;g.forEach((Y,X)=>{S.set(X,Y),P.set(X,t(Y))});const I=new Map,k=new Map;a.forEach((Y,X)=>{I.set(X,Y),k.set(X,t(Y))}),console.group(s!==e?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const V=[];if(r.forEach((Y,X)=>{V.push({key:X,value:Y})}),console.table(V),console.groupEnd(),console.log(o),s!==e){console.group(`Storage: Profile (path: ${e}, profile specific)`);const Y=[];S.forEach((X,se)=>{Y.push({key:se,value:X})}),console.table(Y),console.groupEnd(),console.log(P)}console.group(`Storage: Workspace (path: ${n})`);const G=[];I.forEach((Y,X)=>{G.push({key:X,value:Y})}),console.table(G),console.groupEnd(),console.log(k)}i.logStorage=l}),define(Q[143],Z([0,1,19,24,12,13,32,5,10,21,18,22,23,45,11,9,28,47,130,142,35]),function(B,i,D,b,w,O,L,p,c,d,C,E,h,v,f,m,y,l,u,g,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const s=O.isWeb?"web":(0,E.getTargetPlatform)(O.platform,L.arch);var e;(function(R){R[R.None=0]="None",R[R.IncludeVersions=1]="IncludeVersions",R[R.IncludeFiles=2]="IncludeFiles",R[R.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",R[R.IncludeSharedAccounts=8]="IncludeSharedAccounts",R[R.IncludeVersionProperties=16]="IncludeVersionProperties",R[R.ExcludeNonValidated=32]="ExcludeNonValidated",R[R.IncludeInstallationTargets=64]="IncludeInstallationTargets",R[R.IncludeAssetUri=128]="IncludeAssetUri",R[R.IncludeStatistics=256]="IncludeStatistics",R[R.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",R[R.Unpublished=4096]="Unpublished",R[R.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(e||(e={}));function n(...R){return String(R.reduce((T,M)=>T|M,0))}var t;(function(R){R[R.Tag=1]="Tag",R[R.ExtensionId=4]="ExtensionId",R[R.Category=5]="Category",R[R.ExtensionName=7]="ExtensionName",R[R.Target=8]="Target",R[R.Featured=9]="Featured",R[R.SearchText=10]="SearchText",R[R.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},P={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class I{constructor(T=P){this.state=T}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(T,M=this.state.pageSize){return new I({...this.state,pageNumber:T,pageSize:M})}withFilter(T,...M){const j=[...this.state.criteria,...M.length?M.map(_=>({filterType:T,value:_})):[{filterType:T}]];return new I({...this.state,criteria:j})}withSortBy(T){return new I({...this.state,sortBy:T})}withSortOrder(T){return new I({...this.state,sortOrder:T})}withFlags(...T){return new I({...this.state,flags:T.reduce((M,j)=>M|j,0)})}withAssetTypes(...T){return new I({...this.state,assetTypes:T})}withSource(T){return new I({...this.state,source:T})}get raw(){const{criteria:T,pageNumber:M,pageSize:j,sortBy:_,sortOrder:H,flags:ae,assetTypes:ce}=this.state;return{filters:[{criteria:T,pageNumber:M,pageSize:j,sortBy:_,sortOrder:H}],assetTypes:ce,flags:ae}}get searchText(){const T=this.state.criteria.filter(M=>M.filterType===t.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(T=>String(T.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function k(R,T){const M=(R||[]).filter(j=>j.statisticName===T)[0];return M?M.value:0}function V(R){const T="Microsoft.VisualStudio.Code.Translation.";return R.files.filter(j=>j.assetType.indexOf(T)===0).reduce((j,_)=>{const H=X(R,_.assetType);return H&&j.push([_.assetType.substring(T.length),H]),j},[])}function G(R){if(R.properties){const T=R.properties.filter(_=>_.key===r.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=T.filter(_=>M.test(_.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return X(R,r.Repository)}function Y(R){return{uri:`${R.fallbackAssetUri}/${r.VSIX}?redirect=true${R.targetPlatform?`&targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${r.VSIX}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}}function X(R,T){return R.files.filter(j=>j.assetType===T)[0]?{uri:`${R.assetUri}/${T}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${T}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}:null}function se(R,T){const M=R.properties?R.properties.filter(_=>_.key===T):[],j=M.length>0&&M[0].value;return j?j.split(",").map(_=>(0,h.adoptToGalleryExtensionId)(_)):[]}function oe(R){const T=R.properties?R.properties.filter(M=>M.key===o.Engine):[];return T.length>0&&T[0].value||""}function ne(R){const T=R.properties?R.properties.filter(M=>M.key===o.PreRelease):[];return T.length>0&&T[0].value==="true"}function fe(R){const T=R.properties?R.properties.filter(j=>j.key===o.LocalizedLanguages):[],M=T.length>0&&T[0].value||"";return M?M.split(","):[]}function le(R){return R.properties?.find(T=>T.key===o.SponsorLink)?.value}function ie(R){return R.indexOf("preview")!==-1}function W(R){return R.targetPlatform?(0,E.toTargetPlatform)(R.targetPlatform):"undefined"}function N(R){const T=(0,D.distinct)(R.versions.map(W)),M=!!R.tags?.includes(E.WEB_EXTENSION_TAG),j=T.indexOf("web");return M?j===-1&&T.push("web"):j!==-1&&T.splice(j,1),T}function F(R,T){const M=(0,E.getFallbackTargetPlarforms)(T);for(let j=0;j<R.length;j++){const _=R[j];if(_.version===R[j-1]?.version){let H=j;const ae=W(_);if(ae===T)for(;H>0&&R[H-1].version===_.version;)H--;else if(M.includes(ae))for(;H>0&&R[H-1].version===_.version&&W(R[H-1])!==T;)H--;H!==j&&(R.splice(j,1),R.splice(H,0,_))}}return R}i.sortExtensionVersions=F;function z(R,T,M){R.telemetryData={index:T,querySource:M}}function $(R,T,M){const j=R.versions[0],_={manifest:X(T,r.Manifest),readme:X(T,r.Details),changelog:X(T,r.Changelog),license:X(T,r.License),repository:G(T),download:Y(T),icon:X(T,r.Icon),coreTranslations:V(T)};return{identifier:{id:(0,h.getGalleryExtensionId)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},name:R.extensionName,version:T.version,displayName:R.displayName,publisherId:R.publisher.publisherId,publisher:R.publisher.publisherName,publisherDisplayName:R.publisher.displayName,publisherDomain:R.publisher.domain?{link:R.publisher.domain,verified:!!R.publisher.isDomainVerified}:void 0,publisherSponsorLink:le(j),description:R.shortDescription||"",installCount:k(R.statistics,"install"),rating:k(R.statistics,"averagerating"),ratingCount:k(R.statistics,"ratingcount"),categories:R.categories||[],tags:R.tags||[],releaseDate:Date.parse(R.releaseDate),lastUpdated:Date.parse(R.lastUpdated),allTargetPlatforms:M,assets:_,properties:{dependencies:se(T,o.Dependency),extensionPack:se(T,o.ExtensionPack),engine:oe(T),localizedLanguages:fe(T),targetPlatform:W(T),isPreReleaseVersion:ne(T)},hasPreReleaseVersion:ne(j),hasReleaseVersion:!0,preview:ie(R.flags)}}let J=class{constructor(T,M,j,_,H,ae,ce,pe){this.requestService=M,this.logService=j,this.environmentService=_,this.telemetryService=H,this.fileService=ae,this.productService=ce,this.configurationService=pe;const ve=ce.extensionsGallery;this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=(0,u.resolveMarketplaceHeaders)(ce.version,ce,this.environmentService,this.configurationService,this.fileService,T,this.telemetryService)}api(T=""){return`${this.extensionsGalleryUrl}${T}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(T,M,j){const _=b.CancellationToken.isCancellationToken(M)?{}:M,H=b.CancellationToken.isCancellationToken(M)?M:j,ae=[],ce=[],pe=[],ve=[];let te=!0;for(const ge of T){ge.uuid?ce.push(ge.uuid):ae.push(ge.id);const Se=!!(ge.version||ge.preRelease);pe.push({id:ge.id,uuid:ge.uuid,includePreRelease:Se}),ge.version&&ve.push({id:ge.id,uuid:ge.uuid,version:ge.version}),te=te&&!!ge.hasPreRelease&&!Se}if(!ce.length&&!ae.length)return[];let re=new I().withPage(1,T.length);ce.length&&(re=re.withFilter(t.ExtensionId,...ce)),ae.length&&(re=re.withFilter(t.ExtensionName,...ae)),(_.queryAllVersions||te)&&(re=re.withFlags(re.flags,e.IncludeVersions)),_.source&&(re=re.withSource(_.source));const{extensions:de}=await this.queryGalleryExtensions(re,{targetPlatform:_.targetPlatform??s,includePreRelease:pe,versions:ve,compatible:!!_.compatible},H);return _.source&&de.forEach((ge,Se)=>z(ge,Se,_.source)),de}async getCompatibleExtension(T,M,j){if((0,E.isNotWebExtensionInWebTargetPlatform)(T.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(T,M,j))return T;const _=new I().withFlags(e.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,T.identifier.uuid),{extensions:H}=await this.queryGalleryExtensions(_,{targetPlatform:j,compatible:!0,includePreRelease:M},b.CancellationToken.None);return H[0]||null}async isExtensionCompatible(T,M,j){if(!(0,E.isTargetPlatformCompatible)(T.properties.targetPlatform,T.allTargetPlatforms,j)||!M&&T.properties.isPreReleaseVersion)return!1;let _=T.properties.engine;if(!_){const H=await this.getManifest(T,b.CancellationToken.None);if(!H)throw new Error("Manifest was not found");_=H.engines.vscode}return(0,v.isEngineValid)(_,this.productService.version,this.productService.date)}async isValidVersion(T,M,j,_,H){if(!(0,E.isTargetPlatformCompatible)(W(T),_,H)||M!=="any"&&ne(T)!==(M==="prerelease"))return!1;if(j)try{const ae=await this.getEngine(T);if(!(0,v.isEngineValid)(ae,this.productService.version,this.productService.date))return!1}catch(ae){return this.logService.error(`Error while getting the engine for the version ${T.version}.`,(0,w.getErrorMessage)(ae)),!1}return!0}async query(T,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=T.text||"";const _=T.pageSize??50;let H=new I().withPage(1,_);j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,re,de)=>(H=H.withFilter(t.Category,de||re),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(te,re,de)=>(H=H.withFilter(t.Tag,de||re),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(t.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),H=H.withFilter(t.SearchText,j)),H=H.withSortBy(0)):T.ids?H=H.withFilter(t.ExtensionId,...T.ids):T.names?H=H.withFilter(t.ExtensionName,...T.names):H=H.withSortBy(4),typeof T.sortBy=="number"&&(H=H.withSortBy(T.sortBy)),typeof T.sortOrder=="number"&&(H=H.withSortOrder(T.sortOrder)),T.source&&(H=H.withSource(T.source));const ae=async(te,re)=>{const{extensions:de,total:ge}=await this.queryGalleryExtensions(te,{targetPlatform:s,compatible:!1,includePreRelease:!!T.includePreRelease},re);return de.forEach((Se,Te)=>z(Se,(te.pageNumber-1)*te.pageSize+Te,T.source)),{extensions:de,total:ge}},{extensions:ce,total:pe}=await ae(H,M),ve=async(te,re)=>{if(re.isCancellationRequested)throw new w.CancellationError;const{extensions:de}=await ae(H.withPage(te+1),re);return de};return{firstPage:ce,total:pe,pageSize:H.pageSize,getPage:ve}}async queryGalleryExtensions(T,M,j){const _=T.flags;!!(T.flags&e.IncludeLatestVersionOnly)&&!!(T.flags&e.IncludeVersions)&&(T=T.withFlags(T.flags&~e.IncludeVersions,e.IncludeLatestVersionOnly)),!(T.flags&e.IncludeLatestVersionOnly)&&!(T.flags&e.IncludeVersions)&&(T=T.withFlags(T.flags,e.IncludeLatestVersionOnly)),M.versions?.length&&(T=T.withFlags(T.flags&~e.IncludeLatestVersionOnly,e.IncludeVersions)),T=T.withFlags(T.flags,e.IncludeAssetUri,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeStatistics,e.IncludeVersionProperties);const{galleryExtensions:H,total:ae}=await this.queryRawGalleryExtensions(T,j);if(!(T.flags&e.IncludeLatestVersionOnly)){const te=[];for(const re of H){const de=await this.toGalleryExtensionWithCriteria(re,M);de&&te.push(de)}return{extensions:te,total:ae}}const pe=[],ve=new Map;for(let te=0;te<H.length;te++){const re=H[te],de={id:(0,h.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName),uuid:re.extensionId},ge=(0,p.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Te=>(0,h.areSameExtensions)(Te,de))?.includePreRelease;if(M.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(N(re),M.targetPlatform))continue;const Se=await this.toGalleryExtensionWithCriteria(re,M);!Se||Se.properties.isPreReleaseVersion&&(!ge||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==M.targetPlatform&&Se.hasPreReleaseVersion?ve.set(re.extensionId,te):pe.push([te,Se])}if(ve.size){const te=new Date().getTime(),re=new I().withFlags(_&~e.IncludeLatestVersionOnly,e.IncludeVersions).withPage(1,ve.size).withFilter(t.ExtensionId,...ve.keys()),{extensions:de}=await this.queryGalleryExtensions(re,M,j);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-te,count:ve.size});for(const ge of de){const Se=ve.get(ge.identifier.uuid);pe.push([Se,ge])}}return{extensions:pe.sort((te,re)=>te[0]-re[0]).map(([,te])=>te),total:ae}}async toGalleryExtensionWithCriteria(T,M){const j={id:(0,h.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},_=M.versions?.find(pe=>(0,h.areSameExtensions)(pe,j))?.version,H=(0,p.isBoolean)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(pe=>(0,h.areSameExtensions)(pe,j))?.includePreRelease,ae=N(T),ce=F(T.versions,M.targetPlatform);if(M.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(ae,M.targetPlatform))return null;for(let pe=0;pe<ce.length;pe++){const ve=ce[pe];if(!(_&&ve.version!==_)){if(await this.isValidVersion(ve,H?"any":"release",M.compatible,ae,M.targetPlatform))return $(T,ve,ae);if(_&&ve.version===_)return null}}return _||M.compatible?null:$(T,T.versions[0],ae)}async queryRawGalleryExtensions(T,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,e.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,n(e.Unpublished));const j=await this.commonHeadersPromise,_=JSON.stringify(T.raw),H={...j,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(_.length)},ae=new Date().getTime();let ce,pe,ve=0;try{if(ce=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:_,headers:H},M),ce.res.statusCode&&ce.res.statusCode>=400&&ce.res.statusCode<500)return{galleryExtensions:[],total:ve};const te=await(0,l.asJson)(ce);if(te){const re=te.results[0],de=re.extensions,ge=re.resultMetadata&&re.resultMetadata.filter(Se=>Se.metadataType==="ResultCount")[0];return ve=ge&&ge.metadataItems.filter(Se=>Se.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ve}}return{galleryExtensions:[],total:ve}}catch(te){throw pe=te,te}finally{this.telemetryService.publicLog2("galleryService:query",{...T.telemetryData,requestBodySize:String(_.length),duration:new Date().getTime()-ae,success:!!ce&&(0,l.isSuccess)(ce),responseBodySize:ce?.res.headers["Content-Length"],statusCode:ce?String(ce.res.statusCode):void 0,errorCode:pe?(0,w.isCancellationError)(pe)?"canceled":(0,w.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(T,M,j,_){if(!this.isEnabled())return;const H=O.isWeb?this.api(`/itemName/${T}.${M}/version/${j}/statType/${_==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${T}/extensions/${M}/${j}/stats?statType=${_}`),ae=O.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:ae};try{await this.requestService.request({type:"POST",url:H,headers:pe},b.CancellationToken.None)}catch{}}async download(T,M,j){this.logService.trace("ExtensionGalleryService#download",T.identifier.id);const _=(0,h.getGalleryExtensionTelemetryData)(T),H=new Date().getTime(),ae=te=>this.telemetryService.publicLog("galleryService:downloadVSIX",{..._,duration:te}),ce=j===2?"install":j===3?"update":"",pe=ce?{uri:`${T.assets.download.uri}${c.URI.parse(T.assets.download.uri).query?"&":"?"}${ce}=true`,fallbackUri:`${T.assets.download.fallbackUri}${c.URI.parse(T.assets.download.fallbackUri).query?"&":"?"}${ce}=true`}:T.assets.download,ve=await this.getAsset(pe);await this.fileService.writeFile(M,ve.stream),ae(new Date().getTime()-H)}async getReadme(T,M){if(T.assets.readme){const j=await this.getAsset(T.assets.readme,{},M);return await(0,l.asTextOrError)(j)||""}return""}async getManifest(T,M){if(T.assets.manifest){const j=await this.getAsset(T.assets.manifest,{},M),_=await(0,l.asTextOrError)(j);return _?JSON.parse(_):null}return null}async getManifestFromRawExtensionVersion(T,M){const j=X(T,r.Manifest);if(!j)throw new Error("Manifest was not found");const _={"Accept-Encoding":"gzip"},H=await this.getAsset(j,{headers:_});return await(0,l.asJson)(H)}async getCoreTranslation(T,M){const j=T.assets.coreTranslations.filter(_=>_[0]===M.toUpperCase())[0];if(j){const _=await this.getAsset(j[1]),H=await(0,l.asTextOrError)(_);return H?JSON.parse(H):null}return null}async getChangelog(T,M){if(T.assets.changelog){const j=await this.getAsset(T.assets.changelog,{},M);return await(0,l.asTextOrError)(j)||""}return""}async getAllCompatibleVersions(T,M,j){let _=new I().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);T.identifier.uuid?_=_.withFilter(t.ExtensionId,T.identifier.uuid):_=_.withFilter(t.ExtensionName,T.identifier.id);const{galleryExtensions:H}=await this.queryRawGalleryExtensions(_,b.CancellationToken.None);if(!H.length)return[];const ae=N(H[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(ae,j))return[];const ce=[];await Promise.all(H[0].versions.map(async te=>{try{await this.isValidVersion(te,M?"any":"release",!0,ae,j)&&ce.push(te)}catch{}}));const pe=[],ve=new Set;for(const te of F(ce,j))ve.has(te.version)||(ve.add(te.version),pe.push({version:te.version,date:te.lastUpdated,isPreReleaseVersion:ne(te)}));return pe}async getAsset(T,M={},j=b.CancellationToken.None){const _=await this.commonHeadersPromise,H={type:"GET"},ae={..._,...M.headers||{}};M={...M,...H,headers:ae};const ce=T.uri,pe=T.fallbackUri,ve={...M,url:ce};try{const te=await this.requestService.request(ve,j);if(te.res.statusCode===200)return te;const re=await(0,l.asTextOrError)(te);throw new Error(`Expected 200, got back ${te.res.statusCode} instead.

${re}`)}catch(te){if((0,w.isCancellationError)(te))throw te;const re=(0,w.getErrorMessage)(te);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ce,message:re});const de={...M,url:pe};return this.requestService.request(de,j)}}async getEngine(T){let M=oe(T);if(!M){const j=await this.getManifestFromRawExtensionVersion(T,b.CancellationToken.None);if(!j)throw new Error("Manifest was not found");M=j.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const T=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},b.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,l.asJson)(T),j=[],_={};if(M){for(const H of M.malicious)j.push({id:H});if(M.migrateToPreRelease)for(const[H,ae]of Object.entries(M.migrateToPreRelease))(!ae.engine||(0,v.isEngineValid)(ae.engine,this.productService.version,this.productService.date))&&(_[H.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[H,ae]of Object.entries(M.deprecated))ae&&(_[H.toLowerCase()]=(0,p.isBoolean)(ae)?{}:ae)}return{malicious:j,deprecated:_}}};J=he([ee(1,l.IRequestService),ee(2,m.ILogService),ee(3,C.IEnvironmentService),ee(4,a.ITelemetryService),ee(5,f.IFileService),ee(6,y.IProductService),ee(7,d.IConfigurationService)],J);let A=class extends J{constructor(T,M,j,_,H,ae,ce,pe){super(T,M,j,_,H,ae,ce,pe)}};A=he([ee(0,g.IStorageService),ee(1,l.IRequestService),ee(2,m.ILogService),ee(3,C.IEnvironmentService),ee(4,a.ITelemetryService),ee(5,f.IFileService),ee(6,y.IProductService),ee(7,d.IConfigurationService)],A),i.ExtensionGalleryService=A;let U=class extends J{constructor(T,M,j,_,H,ae,ce){super(void 0,T,M,j,_,H,ae,ce)}};U=he([ee(0,l.IRequestService),ee(1,m.ILogService),ee(2,C.IEnvironmentService),ee(3,a.ITelemetryService),ee(4,f.IFileService),ee(5,y.IProductService),ee(6,d.IConfigurationService)],U),i.ExtensionGalleryServiceWithNoStorageService=U}),define(Q[144],Z([0,1,44,18,11,9,65,29,25]),function(B,i,D,b,w,O,L,p,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UserDataProfilesService=void 0;let d=class Ve extends c.UserDataProfilesService{constructor(E,h,v,f,m){super(v,f,h,m),this.stateService=E}getStoredProfiles(){return(0,D.revive)(this.stateService.getItem(Ve.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,D.revive)(this.stateService.getItem(Ve.PROFILE_ASSOCIATIONS_KEY,{}))}};d=he([ee(0,L.IStateService),ee(1,p.IUriIdentityService),ee(2,b.IEnvironmentService),ee(3,w.IFileService),ee(4,O.ILogService)],d),i.UserDataProfilesService=d}),define(Q[145],Z([0,1,37,3,157,2]),function(B,i,D,b,w,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativePolicyService=void 0;class L extends D.AbstractPolicyService{constructor(c){super(),this.productName=c,this.throttler=new b.Throttler,this.watcher=this._register(new O.MutableDisposable)}async initializePolicies(c){await this.throttler.queue(()=>new Promise((d,C)=>{try{this.watcher.value=(0,w.createWatcher)(this.productName,c,E=>{for(const h in E){const v=E[h];v===void 0?this.policies.delete(h):this.policies.set(h,v)}this._onDidChange.fire(Object.keys(E)),d()})}catch(E){C(E)}}))}}i.NativePolicyService=L}),define(Q[67],Z([0,1,114,3,14,5,20,80,158,159]),function(B,i,D,b,w,O,L,p,c,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class C extends Error{constructor(e,n){let t=n.message;switch(e){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t),this.type=e,this.cause=n}}i.ExtractError=C;function E(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>e&n).reduce((n,t)=>n+t,e&61440)}function h(s){if(s instanceof C)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new C(e,s)}function v(s,e,n,t,r,o){const S=w.dirname(e),P=w.join(t,S);if(!P.startsWith(t))return Promise.reject(new Error(p.localize(0,null,e)));const I=w.join(t,e);let k;return o.onCancellationRequested(()=>{k?.destroy()}),Promise.resolve(L.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((V,G)=>{if(!o.isCancellationRequested)try{k=(0,D.createWriteStream)(I,{mode:n}),k.once("close",()=>V()),k.once("error",G),s.once("error",G),s.pipe(k)}catch(Y){G(Y)}}))}function f(s,e,n,t){let r=(0,b.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((S,P)=>{const I=new b.Sequencer,k=V=>{V.isCancellationRequested||(o++,s.readEntry())};s.once("error",P),s.once("close",()=>r.then(()=>{t.isCancellationRequested||s.entryCount===o?S():P(new C("Incomplete",new Error(p.localize(1,null,o,s.entryCount))))},P)),s.readEntry(),s.on("entry",V=>{if(t.isCancellationRequested)return;if(!n.sourcePathRegex.test(V.fileName)){k(t);return}const G=V.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(G)){const se=w.join(e,G);r=(0,b.createCancelablePromise)(oe=>L.Promises.mkdir(se,{recursive:!0}).then(()=>k(oe)).then(void 0,P));return}const Y=y(s,V),X=E(V);r=(0,b.createCancelablePromise)(se=>I.queue(()=>Y.then(oe=>v(oe,G,X,e,n,se).then(()=>k(se)))).then(null,P))})})}function m(s,e=!1){return new Promise((n,t)=>{(0,c.open)(s,e?{lazyEntries:!0}:void 0,(r,o)=>{r?t(h(r)):n((0,O.assertIsDefined)(o))})})}function y(s,e){return new Promise((n,t)=>{s.openReadStream(e,(r,o)=>{r?t(h(r)):n((0,O.assertIsDefined)(o))})})}function l(s,e){return new Promise((n,t)=>{const r=new d.ZipFile;e.forEach(S=>{S.contents?r.addBuffer(typeof S.contents=="string"?Buffer.from(S.contents,"utf8"):S.contents,S.path):S.localPath&&r.addFile(S.localPath,S.path)}),r.end();const o=(0,D.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>n(s))})}i.zip=l;function u(s,e,n={},t){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=m(s,!0);return n.overwrite&&(o=o.then(S=>L.Promises.rm(e).then(()=>S))),o.then(S=>f(S,e,{sourcePathRegex:r},t))}i.extract=u;function g(s,e){return m(s).then(n=>new Promise((t,r)=>{n.on("entry",o=>{o.fileName===e&&y(n,o).then(S=>t(S),S=>r(S))}),n.once("close",()=>r(new Error(p.localize(2,null,e))))}))}function a(s,e){return g(s,e).then(n=>new Promise((t,r)=>{const o=[];n.once("error",r),n.on("data",S=>o.push(S)),n.on("end",()=>t(Buffer.concat(o)))}))}i.buffer=a}),define(Q[146],Z([0,1,67,88]),function(B,i,D,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function w(O){return(0,D.buffer)(O,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,b.localize)(0,null))}})}i.getManifest=w}),define(Q[147],Z([0,1,3,31,12,2,16,14,13,17,39,5,10,30,20,67,87,58,18,139,22,23,41,48,122,140,146,123,136,34,45,11,8,9,28,35,29,25]),function(B,i,D,b,w,O,L,p,c,d,C,E,h,v,f,m,y,l,u,g,a,s,e,n,t,r,o,S,P,I,k,V,G,Y,X,se,oe,ne){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=i.INativeServerExtensionManagementService=void 0,i.INativeServerExtensionManagementService=(0,G.refineServiceDecorator)(a.IServerExtensionManagementService);let fe=class extends g.AbstractExtensionManagementService{constructor(A,U,R,T,M,j,_,H,ae,ce,pe,ve){super(A,U,R,ce,ve),this.extensionsScannerService=M,this.extensionsProfileScannerService=j,this.downloadService=_,this.fileService=ae,this.installGalleryExtensionsTasks=new Map;const te=this._register(H.createInstance(r.ExtensionsLifecycle));this.extensionsScanner=this._register(H.createInstance(le,de=>te.postUninstall(de))),this.manifestCache=this._register(new S.ExtensionsManifestCache(T,this)),this.extensionsDownloader=this._register(H.createInstance(t.ExtensionsDownloader));const re=this._register(new P.ExtensionsWatcher(this,ae,T,R,pe));this._register(re.onDidChangeExtensionsByAnotherSource(({added:de,removed:ge})=>{de.length&&this._onDidInstallExtensions.fire(de.map(Se=>({identifier:Se.identifier,operation:1,local:Se}))),ge.forEach(Se=>this._onDidUninstallExtension.fire({identifier:Se}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(A){this.logService.trace("ExtensionManagementService#zip",A.identifier.id);const U=await this.collectFiles(A),R=await(0,m.zip)((0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,U);return h.URI.file(R)}async unzip(A){return this.logService.trace("ExtensionManagementService#unzip",A.toString()),(await this.install(A)).identifier}async getManifest(A){const{location:U,cleanup:R}=await this.downloadVsix(A),T=p.resolve(U.fsPath);try{return await(0,o.getManifest)(T)}finally{await R()}}getInstalled(A,U){return this.extensionsScanner.scanExtensions(A??null,U)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(A,U={}){this.logService.trace("ExtensionManagementService#install",A.toString());const{location:R,cleanup:T}=await this.downloadVsix(A);try{const M=await(0,o.getManifest)(p.resolve(R.fsPath));if(M.engines&&M.engines.vscode&&!(0,k.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,s.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return await this.installExtension(M,R,U)}finally{await T()}}getMetadata(A){return this.extensionsScannerService.scanMetadata(A.location)}async updateMetadata(A,U){this.logService.trace("ExtensionManagementService#updateMetadata",A.identifier.id);const R={...U};return U.isPreReleaseVersion&&(R.preRelease=!0),A=await this.extensionsScanner.updateMetadata(A,R),this.manifestCache.invalidate(),A}async updateExtensionScope(A,U){return this.logService.trace("ExtensionManagementService#updateExtensionScope",A.identifier.id),A=await this.extensionsScanner.updateMetadata(A,{isMachineScoped:U}),this.manifestCache.invalidate(),A}removeUninstalledExtensions(A){return this.extensionsScanner.cleanUp(A)}async downloadVsix(A){if(A.scheme===L.Schemas.file)return{location:A,async cleanup(){}};this.logService.trace("Downloading extension from",A.toString());const U=(0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(A,U),this.logService.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.fileService.del(U)}catch(T){this.logService.error(T)}}}}doCreateInstallExtensionTask(A,U,R){let T;if(h.URI.isUri(U))T=new N(A,U,R,this.galleryService,this.extensionsScanner,this.logService);else{const M=s.ExtensionKey.create(U).toString();T=this.installGalleryExtensionsTasks.get(M),T||(this.installGalleryExtensionsTasks.set(M,T=new W(A,U,R,this.extensionsDownloader,this.extensionsScanner,this.logService)),T.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(M)))}return R.profileLocation?new F(T,R.profileLocation,this.extensionsProfileScannerService):T}doCreateUninstallExtensionTask(A,U){return U.profileLocation?new $(A,U.profileLocation,this.extensionsProfileScannerService):new z(A,U,this.extensionsScanner)}async collectFiles(A){const U=async T=>{let M=await f.Promises.readdir(T);M=M.map(H=>p.join(T,H));const j=await Promise.all(M.map(H=>f.Promises.stat(H)));let _=Promise.resolve([]);return j.forEach((H,ae)=>{const ce=M[ae];H.isFile()&&(_=_.then(pe=>[...pe,ce])),H.isDirectory()&&(_=_.then(pe=>U(ce).then(ve=>[...pe,...ve])))}),_};return(await U(A.location.fsPath)).map(T=>({path:`extension/${p.relative(A.location.fsPath,T)}`,localPath:T}))}};fe=he([ee(0,a.IExtensionGalleryService),ee(1,se.ITelemetryService),ee(2,Y.ILogService),ee(3,u.INativeEnvironmentService),ee(4,n.IExtensionsScannerService),ee(5,e.IExtensionsProfileScannerService),ee(6,l.IDownloadService),ee(7,G.IInstantiationService),ee(8,V.IFileService),ee(9,X.IProductService),ee(10,oe.IUriIdentityService),ee(11,ne.IUserDataProfilesService)],fe),i.ExtensionManagementService=fe;let le=class extends O.Disposable{constructor(A,U,R,T){super(),this.beforeRemovingExtension=A,this.fileService=U,this.extensionsScannerService=R,this.logService=T,this.uninstalledPath=(0,d.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(A){await this.removeUninstalledExtensions(),A&&await this.removeOutdatedExtensions()}async scanExtensions(A,U){const R={includeInvalid:!0,profileLocation:U};let T=[];return A===null||A===0?T.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},R,!1)):A===1&&T.push(...await this.extensionsScannerService.scanUserExtensions(R)),T=A!==null?T.filter(M=>M.type===A):T,Promise.all(T.map(M=>this.toLocalExtension(M)))}async scanUserExtensions(A){const U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!A,includeInvalid:!0});return Promise.all(U.map(R=>this.toLocalExtension(R)))}async extractUserExtension(A,U,R,T){const M=A.toString(),j=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),_=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,M);try{await f.Promises.rm(_)}catch{throw new a.ExtensionManagementError(y.localize(1,null,_,A.id),a.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(A,U,j,T),R={...R,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(h.URI.file(j),R);try{await this.rename(A,j,_,Date.now()+2*60*1e3),this.logService.info("Renamed to",_)}catch(H){try{await f.Promises.rm(j)}catch{}if(H.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",A.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(H)}. Deleted from extracted location`,j),H}return this.scanLocalExtension(h.URI.file(_),1)}async updateMetadata(A,U){return await this.extensionsScannerService.updateMetadata(A.location,U),this.scanLocalExtension(A.location,A.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...A){const U=A.map(R=>s.ExtensionKey.create(R));await this.withUninstalledExtensions(R=>{U.forEach(T=>R[T.toString()]=!0)})}async setInstalled(A){await this.withUninstalledExtensions(T=>delete T[A.toString()]);const R=(await this.scanUserExtensions(!0)).find(T=>s.ExtensionKey.create(T).equals(A))||null;return R?this.updateMetadata(R,{installedTimestamp:Date.now()}):null}async removeExtension(A,U){this.logService.trace(`Deleting ${U} extension from disk`,A.identifier.id,A.location.fsPath),await f.Promises.rm(A.location.fsPath),this.logService.info("Deleted from disk",A.identifier.id,A.location.fsPath)}async removeUninstalledExtension(A){await this.removeExtension(A,"uninstalled"),await this.withUninstalledExtensions(U=>delete U[s.ExtensionKey.create(A).toString()])}async withUninstalledExtensions(A){return this.uninstalledFileLimiter.queue(async()=>{let U;try{U=await f.Promises.readFile(this.uninstalledPath,"utf8")}catch(T){if(T.code!=="ENOENT")throw T}let R={};if(U)try{R=JSON.parse(U)}catch{}return A&&(A(R),Object.keys(R).length?await f.Promises.writeFile(this.uninstalledPath,JSON.stringify(R)):await f.Promises.rm(this.uninstalledPath)),R})}async extractAtLocation(A,U,R,T){this.logService.trace(`Started extracting the extension from ${U} to ${R}`);try{await f.Promises.rm(R)}catch(M){throw new a.ExtensionManagementError(this.joinErrors(M).message,a.ExtensionManagementErrorCode.Delete)}try{await(0,m.extract)(U,R,{sourcePath:"extension",overwrite:!0},T),this.logService.info(`Extracted extension to ${R}:`,A.id)}catch(M){try{await f.Promises.rm(R)}catch{}let j=a.ExtensionManagementErrorCode.Extract;throw M instanceof m.ExtractError&&(M.type==="CorruptZip"?j=a.ExtensionManagementErrorCode.CorruptZip:M.type==="Incomplete"&&(j=a.ExtensionManagementErrorCode.IncompleteZip)),new a.ExtensionManagementError(M.message,j)}}async rename(A,U,R,T){try{await f.Promises.rename(U,R)}catch(M){if(c.isWindows&&M&&M.code==="EPERM"&&Date.now()<T)return this.logService.info(`Failed renaming ${U} to ${R} with 'EPERM' error. Trying again...`,A.id),this.rename(A,U,R,T);throw new a.ExtensionManagementError(M.message||y.localize(2,null,U,R),M.code||a.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(A,U){const R=await this.extensionsScannerService.scanExistingExtension(A,U,{includeInvalid:!0});if(R)return this.toLocalExtension(R);throw new Error(y.localize(3,null,A.path))}async toLocalExtension(A){const U=await this.fileService.resolve(A.location);let R,T;return U.children&&(R=U.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,T=U.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:A.identifier,type:A.type,isBuiltin:A.isBuiltin||!!A.metadata?.isBuiltin,location:A.location,manifest:A.manifest,targetPlatform:A.targetPlatform,validations:A.validations,isValid:A.isValid,readmeUrl:R,changelogUrl:T,publisherDisplayName:A.metadata?.publisherDisplayName||null,publisherId:A.metadata?.publisherId||null,isApplicationScoped:!!A.metadata?.isApplicationScoped,isMachineScoped:!!A.metadata?.isMachineScoped,isPreReleaseVersion:!!A.metadata?.isPreReleaseVersion,preRelease:!!A.metadata?.preRelease,installedTimestamp:A.metadata?.installedTimestamp,updated:!!A.metadata?.updated}}async removeUninstalledExtensions(){const A=await this.getUninstalledExtensions(),U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=new Set;for(const j of U)A[s.ExtensionKey.create(j).toString()]||R.add(j.identifier.id.toLowerCase());const T=(0,s.groupByExtension)(U,j=>j.identifier);await D.Promises.settled(T.map(async j=>{const _=j.sort((H,ae)=>C.rcompare(H.manifest.version,ae.manifest.version))[0];R.has(_.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(_))}));const M=U.filter(j=>A[s.ExtensionKey.create(j).toString()]);await D.Promises.settled(M.map(j=>this.removeUninstalledExtension(j)))}async removeOutdatedExtensions(){const A=await this.extensionsScannerService.scanSystemExtensions({}),U=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=[],T=await this.extensionsScannerService.getTargetPlatform(),M=(0,s.groupByExtension)(U,j=>j.identifier);for(const j of M)if(j.length>1&&R.push(...j.sort((_,H)=>{const ae=C.rcompare(_.manifest.version,H.manifest.version);return ae!==0?ae:_.targetPlatform===T?-1:1}).slice(1)),j[0].type===0){const _=A.find(H=>(0,s.areSameExtensions)(H.identifier,j[0].identifier));(!_||C.gte(_.manifest.version,j[0].manifest.version))&&R.push(j[0])}await D.Promises.settled(R.map(j=>this.removeExtension(j,"outdated")))}joinErrors(A){const U=Array.isArray(A)?A:[A];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((R,T)=>new Error(`${R.message}${R.message?",":""}${T instanceof Error?T.message:T}`),new Error(""))}};le=he([ee(1,V.IFileService),ee(2,n.IExtensionsScannerService),ee(3,Y.ILogService)],le);class ie extends g.AbstractExtensionTask{constructor(A,U,R,T,M){super(),this.identifier=A,this.source=U,this.options=R,this.extensionsScanner=T,this.logService=M,this._operation=2}get operation(){return(0,E.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(A,U){try{const R=await this.unsetUninstalledAndGetLocal(A.key);if(R)return A.metadata?this.extensionsScanner.updateMetadata(R,A.metadata):R}catch{throw c.isMacintosh?new a.ExtensionManagementError(y.localize(4,null),a.ExtensionManagementErrorCode.Internal):new a.ExtensionManagementError(y.localize(5,null),a.ExtensionManagementErrorCode.Internal)}return this.extract(A,U)}async unsetUninstalledAndGetLocal(A){if(!await this.isUninstalled(A))return null;this.logService.trace("Removing the extension from uninstalled list:",A.id);const R=await this.extensionsScanner.setInstalled(A);return this.logService.info("Removed the extension from uninstalled list:",A.id),R}async isUninstalled(A){return!!(await this.extensionsScanner.getUninstalledExtensions())[A.toString()]}async extract({zipPath:A,key:U,metadata:R},T){const M=await this.extensionsScanner.extractUserExtension(U,A,R,T);return this.logService.info("Extracting completed.",U.id),M}}class W extends ie{constructor(A,U,R,T,M,j){super(U.identifier,U,R,M,j),this.manifest=A,this.gallery=U,this.extensionsDownloader=T}async doRun(A){const R=(await this.extensionsScanner.scanExtensions(null,void 0)).find(j=>(0,s.areSameExtensions)(j.identifier,this.gallery.identifier));R&&(this._operation=3);const T={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,I.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,isSystem:R?.type===0?!0:void 0,updated:!!R,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,E.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:R?.preRelease)};if(R?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(R,T),metadata:T};const M=await this.downloadExtension(this.gallery,this._operation);try{const j=await this.installExtension({zipPath:M,key:s.ExtensionKey.create(this.gallery),metadata:T},A);return R&&!this.options.profileLocation&&(R.targetPlatform!==j.targetPlatform||C.neq(R.manifest.version,j.manifest.version))&&await this.extensionsScanner.setUninstalled(R),{local:j,metadata:T}}catch(j){throw await this.deleteDownloadedVSIX(M),j}}async deleteDownloadedVSIX(A){try{await this.extensionsDownloader.delete(h.URI.file(A))}catch(U){this.logService.warn("Error while deleting the downloaded vsix",A.toString(),(0,w.getErrorMessage)(U))}}async downloadExtension(A,U){let R;try{this.logService.trace("Started downloading extension:",A.identifier.id),R=(await this.extensionsDownloader.downloadExtension(A,U)).fsPath,this.logService.info("Downloaded extension:",A.identifier.id,R)}catch(T){throw new a.ExtensionManagementError((0,g.joinErrors)(T).message,a.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(R),R}catch(T){throw await this.deleteDownloadedVSIX(R),new a.ExtensionManagementError((0,g.joinErrors)(T).message,a.ExtensionManagementErrorCode.Invalid)}}}class N extends ie{constructor(A,U,R,T,M,j){super({id:(0,s.getGalleryExtensionId)(A.publisher,A.name)},U,R,M,j),this.manifest=A,this.location=U,this.galleryService=T}async doRun(A){const U=new s.ExtensionKey(this.identifier,this.manifest.version),T=(await this.extensionsScanner.scanExtensions(1,void 0)).find(_=>(0,s.areSameExtensions)(this.identifier,_.identifier)),M=await this.getMetadata(this.identifier.id,this.manifest.version,A);if(M.isApplicationScoped=(0,I.isApplicationScopedExtension)(this.manifest),M.isMachineScoped=this.options.isMachineScoped||T?.isMachineScoped,M.isBuiltin=this.options.isBuiltin||T?.isBuiltin,T)if(this._operation=3,U.equals(new s.ExtensionKey(T.identifier,T.manifest.version)))try{await this.extensionsScanner.removeExtension(T,"existing")}catch{throw new Error(y.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&C.gt(T.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(T);else{const _=await this.unsetUninstalledAndGetLocal(U);if(_)try{await this.extensionsScanner.removeExtension(_,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:p.resolve(this.location.fsPath),key:U,metadata:M},A),metadata:M}}async getMetadata(A,U,R){try{let[T]=await this.galleryService.getExtensions([{id:A,version:U}],R);if(T||([T]=await this.galleryService.getExtensions([{id:A}],R)),T)return{id:T.identifier.uuid,publisherDisplayName:T.publisherDisplayName,publisherId:T.publisherId,isPreReleaseVersion:T.properties.isPreReleaseVersion,preRelease:T.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class F{constructor(A,U,R){this.task=A,this.profileLocation=U,this.extensionsProfileScannerService=R,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const A=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[A.local,A.metadata]],this.profileLocation),A}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class z extends g.AbstractExtensionTask{constructor(A,U,R){super(),this.extension=A,this.options=U,this.extensionsScanner=R}async doRun(A){const U=[],R=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const T=s.ExtensionKey.create(this.extension);U.push(...R.filter(M=>T.equals(s.ExtensionKey.create(M))))}else U.push(...R.filter(T=>(0,s.areSameExtensions)(T.identifier,this.extension.identifier)));if(!U.length)throw new Error(y.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...U),this.options.remove)for(const T of U)try{A.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(T)}catch(M){throw new Error(y.localize(9,null,(0,b.toErrorMessage)(M)))}}}class $ extends g.AbstractExtensionTask{constructor(A,U,R){super(),this.extension=A,this.profileLocation=U,this.extensionsProfileScannerService=R}async doRun(A){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(Q[148],Z([0,1,127,3,15,12,2,5,21,18,128,9,126,160]),function(B,i,D,b,w,O,L,p,c,d,C,E,h,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let f=class extends L.Disposable{constructor(y,l,u){super(),this.environmentService=l,this.logService=u,this.configure(y.getValue()),this._register(y.onDidChangeConfiguration(()=>this.configure(y.getValue()),this))}configure(y){this.proxyUrl=y.http&&y.http.proxy,this.strictSSL=!!(y.http&&y.http.proxyStrictSSL),this.authorization=y.http&&y.http.proxyAuthorization}async request(y,l){this.logService.trace("RequestService#request (node) - begin",y.url);const{proxyUrl:u,strictSSL:g}=this;let a;try{a=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...a},e=y.agent?y.agent:await(0,h.getProxyAgent)(y.url||"",s,{proxyUrl:u,strictSSL:g});y.agent=e,y.strictSSL=g,this.authorization&&(y.headers={...y.headers||{},"Proxy-Authorization":this.authorization});try{const n=await this._request(y,l);return this.logService.trace("RequestService#request (node) - success",y.url),n}catch(n){throw this.logService.trace("RequestService#request (node) - error",y.url,n),n}}async getNodeRequest(y){return((0,D.parse)(y.url).protocol==="https:"?await new Promise((g,a)=>{B(["https"],g,a)}):await new Promise((g,a)=>{B(["http"],g,a)})).request}_request(y,l){return b.Promises.withAsyncBody(async(u,g)=>{const a=(0,D.parse)(y.url),s=y.getRawRequest?y.getRawRequest(y):await this.getNodeRequest(y),e={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,p.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(e.auth=y.user+":"+y.password);const n=s(e,t=>{const r=(0,p.isNumber)(y.followRedirects)?y.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&r>0&&t.headers.location)this._request({...y,url:t.headers.location,followRedirects:r-1},l).then(u,g);else{let o=t;t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,v.createGunzip)())),u({res:t,stream:(0,w.streamToBufferReadableStream)(o)})}});n.on("error",g),y.timeout&&n.setTimeout(y.timeout),y.data&&typeof y.data=="string"&&n.write(y.data),n.end(),l.onCancellationRequested(()=>{n.abort(),g(new O.CancellationError)})})}async resolveProxy(y){}};f=he([ee(0,c.IConfigurationService),ee(1,d.INativeEnvironmentService),ee(2,E.ILogService)],f),i.RequestService=f}),define(Q[161],Z([0,1,38,3,15,31,12,2,16,14,13,32,10,20,21,119,58,125,18,101,143,22,121,41,48,147,141,11,111,113,46,109,61,62,124,9,115,116,37,145,133,28,47,148,65,129,66,35,132,42,134,135,29,137,25,144]),function(B,i,D,b,w,O,L,p,c,d,C,E,h,v,f,m,y,l,u,g,a,s,e,n,t,r,o,S,P,I,k,V,G,Y,X,se,oe,ne,fe,le,ie,W,N,F,z,$,J,A,U,R,T,M,j,_,H,ae){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class ce extends p.Disposable{constructor(te){super(),this.argv=te,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[te,re]=await this.initServices();return te.invokeFunction(async de=>{const ge=de.get(se.ILogService),Se=de.get(S.IFileService),Te=de.get(u.INativeEnvironmentService),Fe=de.get(s.IExtensionManagementCLIService);ge.info("CLI main",this.argv),this.registerErrorHandler(ge),await this.doRun(Te,Fe,Se),await Promise.all(re.map(Ue=>{(0,b.raceTimeout)(Ue.flush(),1e3)}))})}async initServices(){const te=new G.ServiceCollection,re={_serviceBrand:void 0,...ie.default};te.set(W.IProductService,re);const de=new g.NativeEnvironmentService(this.argv,re);te.set(u.INativeEnvironmentService,de),await Promise.all([de.appSettingsHome.fsPath,de.extensionsPath].map(we=>we?v.Promises.mkdir(we,{recursive:!0}):void 0));const ge=(0,se.getLogLevel)(de),Se=[];Se.push(new oe.SpdLogLogger("cli",(0,d.join)(de.logsPath,"cli.log"),!0,!1,ge)),ge===se.LogLevel.Trace&&Se.push(new se.ConsoleLogger(ge));const Te=this._register(new se.MultiplexLogService(Se));te.set(se.ILogService,Te);const Fe=this._register(new P.FileService(Te));te.set(S.IFileService,Fe);const Ue=this._register(new I.DiskFileSystemProvider(Te));Fe.registerProvider(c.Schemas.file,Ue);const xe=new $.StateService(de,Te,Fe);te.set(z.IStateService,xe);const x=new _.UriIdentityService(Fe);te.set(j.IUriIdentityService,x);const q=new ae.UserDataProfilesService(xe,x,de,Fe,Te);te.set(H.IUserDataProfilesService,q);const K=C.isWindows&&re.win32RegValueName?this._register(new le.NativePolicyService(re.win32RegValueName)):de.policyFile?this._register(new ne.FilePolicyService(de.policyFile,Fe,Te)):new fe.NullPolicyService;te.set(fe.IPolicyService,K);const ue=this._register(new m.ConfigurationService(q.defaultProfile.settingsResource,Fe,K,Te));te.set(f.IConfigurationService,ue),await Promise.all([xe.init(),ue.initialize()]),q.setEnablement(re.quality!=="stable"||ue.getValue(H.PROFILES_ENABLEMENT_CONFIG)),te.set(j.IUriIdentityService,new _.UriIdentityService(Fe)),te.set(N.IRequestService,new k.SyncDescriptor(F.RequestService)),te.set(y.IDownloadService,new k.SyncDescriptor(l.DownloadService)),te.set(n.IExtensionsProfileScannerService,new k.SyncDescriptor(n.ExtensionsProfileScannerService)),te.set(t.IExtensionsScannerService,new k.SyncDescriptor(o.ExtensionsScannerService)),te.set(r.INativeServerExtensionManagementService,new k.SyncDescriptor(r.ExtensionManagementService)),te.set(s.IExtensionGalleryService,new k.SyncDescriptor(a.ExtensionGalleryServiceWithNoStorageService)),te.set(s.IExtensionManagementCLIService,new k.SyncDescriptor(e.ExtensionManagementCLIService)),te.set(Y.ILanguagePackService,new k.SyncDescriptor(X.NativeLanguagePackService));const me=[],Ce=(0,R.isInternalTelemetry)(re,ue);if((0,R.supportsTelemetry)(re,de)){re.aiConfig&&re.aiConfig.ariaKey&&me.push(new T.OneDataSystemAppender(Ce,"monacoworkbench",null,re.aiConfig.ariaKey));const{installSourcePath:we}=de,Le={appenders:me,sendErrorTelemetry:!1,commonProperties:(async()=>{let be;try{const De=await v.Promises.readFile(de.stateResource.fsPath);be=JSON.parse(De.toString())[A.machineIdKey]}catch(De){De.code!=="ENOENT"&&Te.error(De)}return(0,J.resolveCommonProperties)(Fe,(0,D.release)(),(0,D.hostname)(),process.arch,re.commit,re.version,be,Ce,we)})(),piiPaths:(0,R.getPiiPathsFromEnvironment)(de)};te.set(A.ITelemetryService,new k.SyncDescriptor(U.TelemetryService,[Le]))}else te.set(A.ITelemetryService,R.NullTelemetryService);return[new V.InstantiationService(te),me]}registerErrorHandler(te){(0,L.setUnexpectedErrorHandler)(re=>{const de=(0,O.toErrorMessage)(re,!0);!de||te.error(`[uncaught exception in CLI]: ${de}`)}),process.on("uncaughtException",re=>(0,L.onUnexpectedError)(re)),process.on("unhandledRejection",re=>(0,L.onUnexpectedError)(re))}async doRun(te,re,de){if(this.argv["install-source"])return this.setInstallSource(te,de,this.argv["install-source"]);if(this.argv["list-extensions"])return re.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const ge={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return re.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],ge,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return re.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return re.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(te.appRoot,te.extensionsPath))}}asExtensionIdOrVSIX(te){return te.map(re=>/\.vsix$/i.test(re)?h.URI.file((0,d.isAbsolute)(re)?re:(0,d.join)((0,E.cwd)(),re)):re)}async setInstallSource(te,re,de){await re.writeFile(h.URI.file(te.installSourcePath),w.VSBuffer.fromString(de.slice(0,30)))}}async function pe(ve){const te=new ce(ve);try{await te.run()}finally{te.dispose()}}i.main=pe})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d17726fe4beae5abe87ba9e9429cd298be8b53c4/core/vs/code/node/cliProcessMain.js.map
