/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/buffer","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/assert","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/common/editor","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostTelemetryLogService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ie=function(ie){for(var e=[],a=0,p=ie.length;a<p;a++)e[a]=Ce[ie[a]];return e};define(Ce[72],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(y,A){const b=Object.create(null);for(const P of y){const R=A(P);let S=b[R];S||(S=b[R]=[]),S.push(P)}return b}e.groupBy=a;function p(y,A){const b=[],P=[];for(const R of y)A.has(R)||b.push(R);for(const R of A)y.has(R)||P.push(R);return{removed:b,added:P}}e.diffSets=p;function w(y,A){const b=[],P=[];for(const[R,S]of y)A.has(R)||b.push(S);for(const[R,S]of A)y.has(R)||P.push(S);return{removed:b,added:P}}e.diffMaps=w;class M{constructor(){this.map=new Map}add(A,b){let P=this.map.get(A);P||(P=new Set,this.map.set(A,P)),P.add(b)}delete(A,b){const P=this.map.get(A);!P||(P.delete(b),P.size===0&&this.map.delete(A))}forEach(A,b){const P=this.map.get(A);!P||P.forEach(b)}}e.SetMap=M}),define(Ce[55],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function a(y){return(A,b,P)=>{let R=null,S=null;if(typeof P.value=="function"?(R="value",S=P.value):typeof P.get=="function"&&(R="get",S=P.get),!S)throw new Error("not supported");P[R]=y(S,b)}}e.createDecorator=a;function p(y,A,b){let P=null,R=null;if(typeof b.value=="function"?(P="value",R=b.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(P="get",R=b.get),!R)throw new Error("not supported");const S=`$memoize$${A}`;b[P]=function(...m){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,m)}),this[S]}}e.memoize=p;function w(y,A,b){return a((P,R)=>{const S=`$debounce$${R}`,m=`$debounce$result$${R}`;return function(...k){this[m]||(this[m]=b?b():void 0),clearTimeout(this[S]),A&&(this[m]=A(this[m],...k),k=[this[m]]),this[S]=setTimeout(()=>{P.apply(this,k),this[m]=b?b():void 0},y)}})}e.debounce=w;function M(y,A,b){return a((P,R)=>{const S=`$throttle$timer$${R}`,m=`$throttle$result$${R}`,k=`$throttle$lastRun$${R}`,f=`$throttle$pending$${R}`;return function(...h){if(this[m]||(this[m]=b?b():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),A&&(this[m]=A(this[m],...h)),this[f])return;const d=this[k]+y;d<=Date.now()?(this[k]=Date.now(),P.apply(this,[this[m]]),this[m]=b?b():void 0):(this[f]=!0,this[S]=setTimeout(()=>{this[f]=!1,this[k]=Date.now(),P.apply(this,[this[m]]),this[m]=b?b():void 0},d-Date.now()))}})}e.throttle=M}),define(Ce[73],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(w){this._prefix=w,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(Ce[106],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var p;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(p=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function y(i,u=!1){let n=0;const r=i.length;let s="",t=0,c=16,_=0;function v(B){let F=0,K=0;for(;F<B;){const H=i.charCodeAt(n);if(H>=48&&H<=57)K=K*16+H-48;else if(H>=65&&H<=70)K=K*16+H-65+10;else if(H>=97&&H<=102)K=K*16+H-97+10;else break;n++,F++}return F<B&&(K=-1),K}function T(B){n=B,s="",t=0,c=16,_=0}function U(){const B=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&P(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&P(i.charCodeAt(n)))for(n++;n<i.length&&P(i.charCodeAt(n));)n++;else return _=3,i.substring(B,n);let F=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&P(i.charCodeAt(n))){for(n++;n<i.length&&P(i.charCodeAt(n));)n++;F=n}else _=3;return i.substring(B,F)}function V(){let B="",F=n;for(;;){if(n>=r){B+=i.substring(F,n),_=2;break}const K=i.charCodeAt(n);if(K===34){B+=i.substring(F,n),n++;break}if(K===92){if(B+=i.substring(F,n),n++,n>=r){_=2;break}switch(i.charCodeAt(n++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const O=v(4);O>=0?B+=String.fromCharCode(O):_=4;break}default:_=5}F=n;continue}if(K>=0&&K<=31)if(b(K)){B+=i.substring(F,n),_=2;break}else _=6;n++}return B}function x(){if(s="",_=0,t=n,n>=r)return t=r,c=17;let B=i.charCodeAt(n);if(A(B)){do n++,s+=String.fromCharCode(B),B=i.charCodeAt(n);while(A(B));return c=15}if(b(B))return n++,s+=String.fromCharCode(B),B===13&&i.charCodeAt(n)===10&&(n++,s+=`
`),c=14;switch(B){case 123:return n++,c=1;case 125:return n++,c=2;case 91:return n++,c=3;case 93:return n++,c=4;case 58:return n++,c=6;case 44:return n++,c=5;case 34:return n++,s=V(),c=10;case 47:{const F=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<r&&!b(i.charCodeAt(n));)n++;return s=i.substring(F,n),c=12}if(i.charCodeAt(n+1)===42){n+=2;const K=r-1;let H=!1;for(;n<K;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,H=!0;break}n++}return H||(n++,_=1),s=i.substring(F,n),c=13}return s+=String.fromCharCode(B),n++,c=16}case 45:if(s+=String.fromCharCode(B),n++,n===r||!P(i.charCodeAt(n)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=U(),c=11;default:for(;n<r&&C(B);)n++,B=i.charCodeAt(n);if(t!==n){switch(s=i.substring(t,n),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(B),n++,c=16}}function C(B){if(A(B)||b(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function L(){let B;do B=x();while(B>=12&&B<=15);return B}return{setPosition:T,getPosition:()=>n,scan:u?L:x,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>t,getTokenLength:()=>n-t,getTokenError:()=>_}}e.createScanner=y;function A(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function b(i){return i===10||i===13||i===8232||i===8233}function P(i){return i>=48&&i<=57}var R;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(R||(R={}));function S(i,u){const n=[],r=new Object;let s;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function _(v,T,U,V){t.value=v,t.offset=T,t.length=U,t.type=V,t.colonOffset=void 0,s=t}try{E(i,{onObjectBegin:(v,T)=>{if(u<=v)throw r;s=void 0,c=u>v,n.push("")},onObjectProperty:(v,T,U)=>{if(u<T||(_(v,T,U,"property"),n[n.length-1]=v,u<=T+U))throw r},onObjectEnd:(v,T)=>{if(u<=v)throw r;s=void 0,n.pop()},onArrayBegin:(v,T)=>{if(u<=v)throw r;s=void 0,n.push(0)},onArrayEnd:(v,T)=>{if(u<=v)throw r;s=void 0,n.pop()},onLiteralValue:(v,T,U)=>{if(u<T||(_(v,T,U,D(v)),u<=T+U))throw r},onSeparator:(v,T,U)=>{if(u<=T)throw r;if(v===":"&&s&&s.type==="property")s.colonOffset=T,c=!1,s=void 0;else if(v===","){const V=n[n.length-1];typeof V=="number"?n[n.length-1]=V+1:(c=!0,n[n.length-1]=""),s=void 0}}})}catch(v){if(v!==r)throw v}return{path:n,previousNode:s,isAtPropertyKey:c,matches:v=>{let T=0;for(let U=0;T<v.length&&U<n.length;U++)if(v[T]===n[U]||v[T]==="*")T++;else if(v[T]!=="**")return!1;return T===v.length}}}e.getLocation=S;function m(i,u=[],n=M.DEFAULT){let r=null,s=[];const t=[];function c(v){Array.isArray(s)?s.push(v):r!==null&&(s[r]=v)}return E(i,{onObjectBegin:()=>{const v={};c(v),t.push(s),s=v,r=null},onObjectProperty:v=>{r=v},onObjectEnd:()=>{s=t.pop()},onArrayBegin:()=>{const v=[];c(v),t.push(s),s=v,r=null},onArrayEnd:()=>{s=t.pop()},onLiteralValue:c,onError:(v,T,U)=>{u.push({error:v,offset:T,length:U})}},n),s[0]}e.parse=m;function k(i,u=[],n=M.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(v){r.type==="property"&&(r.length=v-r.offset,r=r.parent)}function t(v){return r.children.push(v),v}E(i,{onObjectBegin:v=>{r=t({type:"object",offset:v,length:-1,parent:r,children:[]})},onObjectProperty:(v,T,U)=>{r=t({type:"property",offset:T,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:v,offset:T,length:U,parent:r})},onObjectEnd:(v,T)=>{r.length=v+T-r.offset,r=r.parent,s(v+T)},onArrayBegin:(v,T)=>{r=t({type:"array",offset:v,length:-1,parent:r,children:[]})},onArrayEnd:(v,T)=>{r.length=v+T-r.offset,r=r.parent,s(v+T)},onLiteralValue:(v,T,U)=>{t({type:D(v),offset:T,length:U,parent:r,value:v}),s(T+U)},onSeparator:(v,T,U)=>{r.type==="property"&&(v===":"?r.colonOffset=T:v===","&&s(T))},onError:(v,T,U)=>{u.push({error:v,offset:T,length:U})}},n);const _=r.children[0];return _&&delete _.parent,_}e.parseTree=k;function f(i,u){if(!i)return;let n=i;for(const r of u)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const t of n.children)if(Array.isArray(t.children)&&t.children[0].value===r){n=t.children[1],s=!0;break}if(!s)return}else{const s=r;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=f;function h(i){if(!i.parent||!i.parent.children)return[];const u=h(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;u.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&u.push(n)}return u}e.getNodePath=h;function d(i){switch(i.type){case"array":return i.children.map(d);case"object":{const u=Object.create(null);for(const n of i.children){const r=n.children[1];r&&(u[n.children[0].value]=d(r))}return u}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=d;function o(i,u,n=!1){return u>=i.offset&&u<i.offset+i.length||n&&u===i.offset+i.length}e.contains=o;function g(i,u,n=!1){if(o(i,u,n)){const r=i.children;if(Array.isArray(r))for(let s=0;s<r.length&&r[s].offset<=u;s++){const t=g(r[s],u,n);if(t)return t}return i}}e.findNodeAtOffset=g;function E(i,u,n=M.DEFAULT){const r=y(i,!1);function s(Ee){return Ee?()=>Ee(r.getTokenOffset(),r.getTokenLength()):()=>!0}function t(Ee){return Ee?be=>Ee(be,r.getTokenOffset(),r.getTokenLength()):()=>!0}const c=s(u.onObjectBegin),_=t(u.onObjectProperty),v=s(u.onObjectEnd),T=s(u.onArrayBegin),U=s(u.onArrayEnd),V=t(u.onLiteralValue),x=t(u.onSeparator),C=s(u.onComment),L=t(u.onError),B=n&&n.disallowComments,F=n&&n.allowTrailingComma;function K(){for(;;){const Ee=r.scan();switch(r.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:B||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(Ee){case 12:case 13:B?H(10):C();break;case 16:H(1);break;case 15:case 14:break;default:return Ee}}}function H(Ee,be=[],ne=[]){if(L(Ee),be.length+ne.length>0){let ve=r.getToken();for(;ve!==17;){if(be.indexOf(ve)!==-1){K();break}else if(ne.indexOf(ve)!==-1)break;ve=K()}}}function O(Ee){const be=r.getTokenValue();return Ee?V(be):_(be),K(),!0}function ee(){switch(r.getToken()){case 11:{let Ee=0;try{Ee=JSON.parse(r.getTokenValue()),typeof Ee!="number"&&(H(2),Ee=0)}catch{H(2)}V(Ee);break}case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return K(),!0}function ue(){return r.getToken()!==10?(H(3,[],[2,5]),!1):(O(!1),r.getToken()===6?(x(":"),K(),te()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function oe(){c(),K();let Ee=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(Ee||H(4,[],[]),x(","),K(),r.getToken()===2&&F)break}else Ee&&H(6,[],[]);ue()||H(4,[],[2,5]),Ee=!0}return v(),r.getToken()!==2?H(7,[2],[]):K(),!0}function le(){T(),K();let Ee=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(Ee||H(4,[],[]),x(","),K(),r.getToken()===4&&F)break}else Ee&&H(6,[],[]);te()||H(4,[],[4,5]),Ee=!0}return U(),r.getToken()!==4?H(8,[4],[]):K(),!0}function te(){switch(r.getToken()){case 3:return le();case 1:return oe();case 10:return O(!0);default:return ee()}}return K(),r.getToken()===17?n.allowEmptyContent?!0:(H(4,[],[]),!1):te()?(r.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=E;function l(i,u){const n=y(i),r=[];let s,t=0,c;do switch(c=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:t!==c&&r.push(i.substring(t,c)),u!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,u)),t=n.getPosition();break}while(s!==17);return r.join("")}e.stripComments=l;function D(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),function(ie,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(Ce[107],Ie([0]),e):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(ke,Se){for(var ye=0;ye<Se.length;ye++){var ae=Se[ye];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(ke,ae.key,ae)}}function a(ke,Se,ye){return Se&&e(ke.prototype,Se),ye&&e(ke,ye),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function p(ke,Se){if(!!ke){if(typeof ke=="string")return w(ke,Se);var ye=Object.prototype.toString.call(ke).slice(8,-1);if(ye==="Object"&&ke.constructor&&(ye=ke.constructor.name),ye==="Map"||ye==="Set")return Array.from(ke);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return w(ke,Se)}}function w(ke,Se){(Se==null||Se>ke.length)&&(Se=ke.length);for(var ye=0,ae=new Array(Se);ye<Se;ye++)ae[ye]=ke[ye];return ae}function M(ke,Se){var ye=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(ye)return(ye=ye.call(ke)).next.bind(ye);if(Array.isArray(ke)||(ye=p(ke))||Se&&ke&&typeof ke.length=="number"){ye&&(ke=ye);var ae=0;return function(){return ae>=ke.length?{done:!0}:{done:!1,value:ke[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=y();function A(ke){ie.defaults=ke}var b=/[&<>"']/,P=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(Se){return m[Se]};function f(ke,Se){if(Se){if(b.test(ke))return ke.replace(P,k)}else if(R.test(ke))return ke.replace(S,k);return ke}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(ke){return ke.replace(h,function(Se,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var o=/(^|[^\[])\^/g;function g(ke,Se){ke=typeof ke=="string"?ke:ke.source,Se=Se||"";var ye={replace:function(ce,Q){return Q=Q.source||Q,Q=Q.replace(o,"$1"),ke=ke.replace(ce,Q),ye},getRegex:function(){return new RegExp(ke,Se)}};return ye}var E=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function D(ke,Se,ye){if(ke){var ae;try{ae=decodeURIComponent(d(ye)).replace(E,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}Se&&!l.test(ye)&&(ye=s(Se,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var i={},u=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(ke,Se){i[" "+ke]||(u.test(ke)?i[" "+ke]=ke+"/":i[" "+ke]=v(ke,"/",!0)),ke=i[" "+ke];var ye=ke.indexOf(":")===-1;return Se.substring(0,2)==="//"?ye?Se:ke.replace(n,"$1")+Se:Se.charAt(0)==="/"?ye?Se:ke.replace(r,"$1")+Se:ke+Se}var t={exec:function(){}};function c(ke){for(var Se=1,ye,ae;Se<arguments.length;Se++){ye=arguments[Se];for(ae in ye)Object.prototype.hasOwnProperty.call(ye,ae)&&(ke[ae]=ye[ae])}return ke}function _(ke,Se){var ye=ke.replace(/\|/g,function(Q,J,I){for(var z=!1,W=J;--W>=0&&I[W]==="\\";)z=!z;return z?"|":" |"}),ae=ye.split(/ \|/),ce=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>Se)ae.splice(Se);else for(;ae.length<Se;)ae.push("");for(;ce<ae.length;ce++)ae[ce]=ae[ce].trim().replace(/\\\|/g,"|");return ae}function v(ke,Se,ye){var ae=ke.length;if(ae===0)return"";for(var ce=0;ce<ae;){var Q=ke.charAt(ae-ce-1);if(Q===Se&&!ye)ce++;else if(Q!==Se&&ye)ce++;else break}return ke.slice(0,ae-ce)}function T(ke,Se){if(ke.indexOf(Se[1])===-1)return-1;for(var ye=ke.length,ae=0,ce=0;ce<ye;ce++)if(ke[ce]==="\\")ce++;else if(ke[ce]===Se[0])ae++;else if(ke[ce]===Se[1]&&(ae--,ae<0))return ce;return-1}function U(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function V(ke,Se){if(Se<1)return"";for(var ye="";Se>1;)Se&1&&(ye+=ke),Se>>=1,ke+=ke;return ye+ke}function x(ke,Se,ye,ae){var ce=Se.href,Q=Se.title?f(Se.title):null,J=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){ae.state.inLink=!0;var I={type:"link",raw:ye,href:ce,title:Q,text:J,tokens:ae.inlineTokens(J)};return ae.state.inLink=!1,I}return{type:"image",raw:ye,href:ce,title:Q,text:f(J)}}function C(ke,Se){var ye=ke.match(/^(\s+)(?:```)/);if(ye===null)return Se;var ae=ye[1];return Se.split(`
`).map(function(ce){var Q=ce.match(/^\s+/);if(Q===null)return ce;var J=Q[0];return J.length>=ae.length?ce.slice(ae.length):ce}).join(`
`)}var L=function(){function ke(ye){this.options=ye||ie.defaults}var Se=ke.prototype;return Se.space=function(ae){var ce=this.rules.block.newline.exec(ae);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},Se.code=function(ae){var ce=this.rules.block.code.exec(ae);if(ce){var Q=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?Q:v(Q,`
`)}}},Se.fences=function(ae){var ce=this.rules.block.fences.exec(ae);if(ce){var Q=ce[0],J=C(Q,ce[3]||"");return{type:"code",raw:Q,lang:ce[2]?ce[2].trim():ce[2],text:J}}},Se.heading=function(ae){var ce=this.rules.block.heading.exec(ae);if(ce){var Q=ce[2].trim();if(/#$/.test(Q)){var J=v(Q,"#");(this.options.pedantic||!J||/ $/.test(J))&&(Q=J.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:Q,tokens:this.lexer.inline(Q)}}},Se.hr=function(ae){var ce=this.rules.block.hr.exec(ae);if(ce)return{type:"hr",raw:ce[0]}},Se.blockquote=function(ae){var ce=this.rules.block.blockquote.exec(ae);if(ce){var Q=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(Q,[]),text:Q}}},Se.list=function(ae){var ce=this.rules.block.list.exec(ae);if(ce){var Q,J,I,z,W,j,re,de,Z,pe,ge,Ne,Be=ce[1].trim(),Ye=Be.length>1,Xe={type:"list",raw:"",ordered:Ye,start:Ye?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Ye?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Ye?Be:"[*+-]");for(var Te=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Ne=!1,!(!(ce=Te.exec(ae))||this.rules.block.hr.test(ae)));){if(Q=ce[0],ae=ae.substring(Q.length),de=ce[2].split(`
`,1)[0],Z=ae.split(`
`,1)[0],this.options.pedantic?(z=2,ge=de.trimLeft()):(z=ce[2].search(/[^ ]/),z=z>4?1:z,ge=de.slice(z),z+=ce[1].length),j=!1,!de&&/^ *$/.test(Z)&&(Q+=Z+`
`,ae=ae.substring(Z.length+1),Ne=!0),!Ne)for(var nt=new RegExp("^ {0,"+Math.min(3,z-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),G=new RegExp("^ {0,"+Math.min(3,z-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),X=new RegExp("^ {0,"+Math.min(3,z-1)+"}(?:```|~~~)"),fe=new RegExp("^ {0,"+Math.min(3,z-1)+"}#");ae&&(pe=ae.split(`
`,1)[0],de=pe,this.options.pedantic&&(de=de.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(X.test(de)||fe.test(de)||nt.test(de)||G.test(ae)));){if(de.search(/[^ ]/)>=z||!de.trim())ge+=`
`+de.slice(z);else if(!j)ge+=`
`+de;else break;!j&&!de.trim()&&(j=!0),Q+=pe+`
`,ae=ae.substring(pe.length+1)}Xe.loose||(re?Xe.loose=!0:/\n *\n *$/.test(Q)&&(re=!0)),this.options.gfm&&(J=/^\[[ xX]\] /.exec(ge),J&&(I=J[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),Xe.items.push({type:"list_item",raw:Q,task:!!J,checked:I,loose:!1,text:ge}),Xe.raw+=Q}Xe.items[Xe.items.length-1].raw=Q.trimRight(),Xe.items[Xe.items.length-1].text=ge.trimRight(),Xe.raw=Xe.raw.trimRight();var Ue=Xe.items.length;for(W=0;W<Ue;W++){this.lexer.state.top=!1,Xe.items[W].tokens=this.lexer.blockTokens(Xe.items[W].text,[]);var He=Xe.items[W].tokens.filter(function(je){return je.type==="space"}),Ze=He.every(function(je){for(var We=je.raw.split(""),it=0,rt=M(We),dt;!(dt=rt()).done;){var at=dt.value;if(at===`
`&&(it+=1),it>1)return!0}return!1});!Xe.loose&&He.length&&Ze&&(Xe.loose=!0,Xe.items[W].loose=!0)}return Xe}},Se.html=function(ae){var ce=this.rules.block.html.exec(ae);if(ce){var Q={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var J=this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]);Q.type="paragraph",Q.text=J,Q.tokens=this.lexer.inline(J)}return Q}},Se.def=function(ae){var ce=this.rules.block.def.exec(ae);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var Q=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Q,raw:ce[0],href:ce[2],title:ce[3]}}},Se.table=function(ae){var ce=this.rules.block.table.exec(ae);if(ce){var Q={type:"table",header:_(ce[1]).map(function(re){return{text:re}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Q.header.length===Q.align.length){Q.raw=ce[0];var J=Q.align.length,I,z,W,j;for(I=0;I<J;I++)/^ *-+: *$/.test(Q.align[I])?Q.align[I]="right":/^ *:-+: *$/.test(Q.align[I])?Q.align[I]="center":/^ *:-+ *$/.test(Q.align[I])?Q.align[I]="left":Q.align[I]=null;for(J=Q.rows.length,I=0;I<J;I++)Q.rows[I]=_(Q.rows[I],Q.header.length).map(function(re){return{text:re}});for(J=Q.header.length,z=0;z<J;z++)Q.header[z].tokens=this.lexer.inline(Q.header[z].text);for(J=Q.rows.length,z=0;z<J;z++)for(j=Q.rows[z],W=0;W<j.length;W++)j[W].tokens=this.lexer.inline(j[W].text);return Q}}},Se.lheading=function(ae){var ce=this.rules.block.lheading.exec(ae);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},Se.paragraph=function(ae){var ce=this.rules.block.paragraph.exec(ae);if(ce){var Q=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:Q,tokens:this.lexer.inline(Q)}}},Se.text=function(ae){var ce=this.rules.block.text.exec(ae);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},Se.escape=function(ae){var ce=this.rules.inline.escape.exec(ae);if(ce)return{type:"escape",raw:ce[0],text:f(ce[1])}},Se.tag=function(ae){var ce=this.rules.inline.tag.exec(ae);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):f(ce[0]):ce[0]}},Se.link=function(ae){var ce=this.rules.inline.link.exec(ae);if(ce){var Q=ce[2].trim();if(!this.options.pedantic&&/^</.test(Q)){if(!/>$/.test(Q))return;var J=v(Q.slice(0,-1),"\\");if((Q.length-J.length)%2===0)return}else{var I=T(ce[2],"()");if(I>-1){var z=ce[0].indexOf("!")===0?5:4,W=z+ce[1].length+I;ce[2]=ce[2].substring(0,I),ce[0]=ce[0].substring(0,W).trim(),ce[3]=""}}var j=ce[2],re="";if(this.options.pedantic){var de=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(j);de&&(j=de[1],re=de[3])}else re=ce[3]?ce[3].slice(1,-1):"";return j=j.trim(),/^</.test(j)&&(this.options.pedantic&&!/>$/.test(Q)?j=j.slice(1):j=j.slice(1,-1)),x(ce,{href:j&&j.replace(this.rules.inline._escapes,"$1"),title:re&&re.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},Se.reflink=function(ae,ce){var Q;if((Q=this.rules.inline.reflink.exec(ae))||(Q=this.rules.inline.nolink.exec(ae))){var J=(Q[2]||Q[1]).replace(/\s+/g," ");if(J=ce[J.toLowerCase()],!J||!J.href){var I=Q[0].charAt(0);return{type:"text",raw:I,text:I}}return x(Q,J,Q[0],this.lexer)}},Se.emStrong=function(ae,ce,Q){Q===void 0&&(Q="");var J=this.rules.inline.emStrong.lDelim.exec(ae);if(!!J&&!(J[3]&&Q.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var I=J[1]||J[2]||"";if(!I||I&&(Q===""||this.rules.inline.punctuation.exec(Q))){var z=J[0].length-1,W,j,re=z,de=0,Z=J[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Z.lastIndex=0,ce=ce.slice(-1*ae.length+z);(J=Z.exec(ce))!=null;)if(W=J[1]||J[2]||J[3]||J[4]||J[5]||J[6],!!W){if(j=W.length,J[3]||J[4]){re+=j;continue}else if((J[5]||J[6])&&z%3&&!((z+j)%3)){de+=j;continue}if(re-=j,!(re>0)){if(j=Math.min(j,j+re+de),Math.min(z,j)%2){var pe=ae.slice(1,z+J.index+j);return{type:"em",raw:ae.slice(0,z+J.index+j+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}var ge=ae.slice(2,z+J.index+j-1);return{type:"strong",raw:ae.slice(0,z+J.index+j+1),text:ge,tokens:this.lexer.inlineTokens(ge)}}}}}},Se.codespan=function(ae){var ce=this.rules.inline.code.exec(ae);if(ce){var Q=ce[2].replace(/\n/g," "),J=/[^ ]/.test(Q),I=/^ /.test(Q)&&/ $/.test(Q);return J&&I&&(Q=Q.substring(1,Q.length-1)),Q=f(Q,!0),{type:"codespan",raw:ce[0],text:Q}}},Se.br=function(ae){var ce=this.rules.inline.br.exec(ae);if(ce)return{type:"br",raw:ce[0]}},Se.del=function(ae){var ce=this.rules.inline.del.exec(ae);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},Se.autolink=function(ae,ce){var Q=this.rules.inline.autolink.exec(ae);if(Q){var J,I;return Q[2]==="@"?(J=f(this.options.mangle?ce(Q[1]):Q[1]),I="mailto:"+J):(J=f(Q[1]),I=J),{type:"link",raw:Q[0],text:J,href:I,tokens:[{type:"text",raw:J,text:J}]}}},Se.url=function(ae,ce){var Q;if(Q=this.rules.inline.url.exec(ae)){var J,I;if(Q[2]==="@")J=f(this.options.mangle?ce(Q[0]):Q[0]),I="mailto:"+J;else{var z;do z=Q[0],Q[0]=this.rules.inline._backpedal.exec(Q[0])[0];while(z!==Q[0]);J=f(Q[0]),Q[1]==="www."?I="http://"+J:I=J}return{type:"link",raw:Q[0],text:J,href:I,tokens:[{type:"text",raw:J,text:J}]}}},Se.inlineText=function(ae,ce){var Q=this.rules.inline.text.exec(ae);if(Q){var J;return this.lexer.state.inRawBlock?J=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):f(Q[0]):Q[0]:J=f(this.options.smartypants?ce(Q[0]):Q[0]),{type:"text",raw:Q[0],text:J}}},ke}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=g(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=g(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=g(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=g(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=g(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=c({},B),B.gfm=c({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=g(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=g(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=c({},B.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:g(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=g(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=g(B._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=g(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=g(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=g(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=g(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=g(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=g(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=g(F.reflink).replace("label",F._label).replace("ref",B._label).getRegex(),F.nolink=g(F.nolink).replace("ref",B._label).getRegex(),F.reflinkSearch=g(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=c({},F),F.pedantic=c({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=c({},F.normal,{escape:g(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=g(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=c({},F.gfm,{br:g(F.br).replace("{2,}","*").getRegex(),text:g(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function H(ke){var Se="",ye,ae,ce=ke.length;for(ye=0;ye<ce;ye++)ae=ke.charCodeAt(ye),Math.random()>.5&&(ae="x"+ae.toString(16)),Se+="&#"+ae+";";return Se}var O=function(){function ke(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||ie.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:B.normal,inline:F.normal};this.options.pedantic?(ae.block=B.pedantic,ae.inline=F.pedantic):this.options.gfm&&(ae.block=B.gfm,this.options.breaks?ae.inline=F.breaks:ae.inline=F.gfm),this.tokenizer.rules=ae}ke.lex=function(ae,ce){var Q=new ke(ce);return Q.lex(ae)},ke.lexInline=function(ae,ce){var Q=new ke(ce);return Q.inlineTokens(ae)};var Se=ke.prototype;return Se.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},Se.blockTokens=function(ae,ce){var Q=this;ce===void 0&&(ce=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(re,de,Z){return de+"    ".repeat(Z.length)});for(var J,I,z,W;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(re){return(J=re.call({lexer:Q},ae,ce))?(ae=ae.substring(J.raw.length),ce.push(J),!0):!1}))){if(J=this.tokenizer.space(ae)){ae=ae.substring(J.raw.length),J.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(J);continue}if(J=this.tokenizer.code(ae)){ae=ae.substring(J.raw.length),I=ce[ce.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+J.raw,I.text+=`
`+J.text,this.inlineQueue[this.inlineQueue.length-1].src=I.text):ce.push(J);continue}if(J=this.tokenizer.fences(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.heading(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.hr(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.blockquote(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.list(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.html(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.def(ae)){ae=ae.substring(J.raw.length),I=ce[ce.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+J.raw,I.text+=`
`+J.raw,this.inlineQueue[this.inlineQueue.length-1].src=I.text):this.tokens.links[J.tag]||(this.tokens.links[J.tag]={href:J.href,title:J.title});continue}if(J=this.tokenizer.table(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.lheading(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(z=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var re=1/0,de=ae.slice(1),Z=void 0;Q.options.extensions.startBlock.forEach(function(pe){Z=pe.call({lexer:this},de),typeof Z=="number"&&Z>=0&&(re=Math.min(re,Z))}),re<1/0&&re>=0&&(z=ae.substring(0,re+1))}(),this.state.top&&(J=this.tokenizer.paragraph(z))){I=ce[ce.length-1],W&&I.type==="paragraph"?(I.raw+=`
`+J.raw,I.text+=`
`+J.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):ce.push(J),W=z.length!==ae.length,ae=ae.substring(J.raw.length);continue}if(J=this.tokenizer.text(ae)){ae=ae.substring(J.raw.length),I=ce[ce.length-1],I&&I.type==="text"?(I.raw+=`
`+J.raw,I.text+=`
`+J.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):ce.push(J);continue}if(ae){var j="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(j);break}else throw new Error(j)}}return this.state.top=!0,ce},Se.inline=function(ae,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:ae,tokens:ce}),ce},Se.inlineTokens=function(ae,ce){var Q=this;ce===void 0&&(ce=[]);var J,I,z,W=ae,j,re,de;if(this.tokens.links){var Z=Object.keys(this.tokens.links);if(Z.length>0)for(;(j=this.tokenizer.rules.inline.reflinkSearch.exec(W))!=null;)Z.includes(j[0].slice(j[0].lastIndexOf("[")+1,-1))&&(W=W.slice(0,j.index)+"["+V("a",j[0].length-2)+"]"+W.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(j=this.tokenizer.rules.inline.blockSkip.exec(W))!=null;)W=W.slice(0,j.index)+"["+V("a",j[0].length-2)+"]"+W.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(j=this.tokenizer.rules.inline.escapedEmSt.exec(W))!=null;)W=W.slice(0,j.index)+"++"+W.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(re||(de=""),re=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ge){return(J=ge.call({lexer:Q},ae,ce))?(ae=ae.substring(J.raw.length),ce.push(J),!0):!1}))){if(J=this.tokenizer.escape(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.tag(ae)){ae=ae.substring(J.raw.length),I=ce[ce.length-1],I&&J.type==="text"&&I.type==="text"?(I.raw+=J.raw,I.text+=J.text):ce.push(J);continue}if(J=this.tokenizer.link(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(J.raw.length),I=ce[ce.length-1],I&&J.type==="text"&&I.type==="text"?(I.raw+=J.raw,I.text+=J.text):ce.push(J);continue}if(J=this.tokenizer.emStrong(ae,W,de)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.codespan(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.br(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.del(ae)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(J=this.tokenizer.autolink(ae,H)){ae=ae.substring(J.raw.length),ce.push(J);continue}if(!this.state.inLink&&(J=this.tokenizer.url(ae,H))){ae=ae.substring(J.raw.length),ce.push(J);continue}if(z=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var ge=1/0,Ne=ae.slice(1),Be=void 0;Q.options.extensions.startInline.forEach(function(Ye){Be=Ye.call({lexer:this},Ne),typeof Be=="number"&&Be>=0&&(ge=Math.min(ge,Be))}),ge<1/0&&ge>=0&&(z=ae.substring(0,ge+1))}(),J=this.tokenizer.inlineText(z,K)){ae=ae.substring(J.raw.length),J.raw.slice(-1)!=="_"&&(de=J.raw.slice(-1)),re=!0,I=ce[ce.length-1],I&&I.type==="text"?(I.raw+=J.raw,I.text+=J.text):ce.push(J);continue}if(ae){var pe="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return ce},a(ke,null,[{key:"rules",get:function(){return{block:B,inline:F}}}]),ke}(),ee=function(){function ke(ye){this.options=ye||ie.defaults}var Se=ke.prototype;return Se.code=function(ae,ce,Q){var J=(ce||"").match(/\S*/)[0];if(this.options.highlight){var I=this.options.highlight(ae,J);I!=null&&I!==ae&&(Q=!0,ae=I)}return ae=ae.replace(/\n$/,"")+`
`,J?'<pre><code class="'+this.options.langPrefix+f(J,!0)+'">'+(Q?ae:f(ae,!0))+`</code></pre>
`:"<pre><code>"+(Q?ae:f(ae,!0))+`</code></pre>
`},Se.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},Se.html=function(ae){return ae},Se.heading=function(ae,ce,Q,J){if(this.options.headerIds){var I=this.options.headerPrefix+J.slug(Q);return"<h"+ce+' id="'+I+'">'+ae+"</h"+ce+`>
`}return"<h"+ce+">"+ae+"</h"+ce+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ae,ce,Q){var J=ce?"ol":"ul",I=ce&&Q!==1?' start="'+Q+'"':"";return"<"+J+I+`>
`+ae+"</"+J+`>
`},Se.listitem=function(ae){return"<li>"+ae+`</li>
`},Se.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ae){return"<p>"+ae+`</p>
`},Se.table=function(ae,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+ce+`</table>
`},Se.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},Se.tablecell=function(ae,ce){var Q=ce.header?"th":"td",J=ce.align?"<"+Q+' align="'+ce.align+'">':"<"+Q+">";return J+ae+("</"+Q+`>
`)},Se.strong=function(ae){return"<strong>"+ae+"</strong>"},Se.em=function(ae){return"<em>"+ae+"</em>"},Se.codespan=function(ae){return"<code>"+ae+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ae){return"<del>"+ae+"</del>"},Se.link=function(ae,ce,Q){if(ae=D(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Q;var J='<a href="'+f(ae)+'"';return ce&&(J+=' title="'+ce+'"'),J+=">"+Q+"</a>",J},Se.image=function(ae,ce,Q){if(ae=D(this.options.sanitize,this.options.baseUrl,ae),ae===null)return Q;var J='<img src="'+ae+'" alt="'+Q+'"';return ce&&(J+=' title="'+ce+'"'),J+=this.options.xhtml?"/>":">",J},Se.text=function(ae){return ae},ke}(),ue=function(){function ke(){}var Se=ke.prototype;return Se.strong=function(ae){return ae},Se.em=function(ae){return ae},Se.codespan=function(ae){return ae},Se.del=function(ae){return ae},Se.html=function(ae){return ae},Se.text=function(ae){return ae},Se.link=function(ae,ce,Q){return""+Q},Se.image=function(ae,ce,Q){return""+Q},Se.br=function(){return""},ke}(),oe=function(){function ke(){this.seen={}}var Se=ke.prototype;return Se.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ae,ce){var Q=ae,J=0;if(this.seen.hasOwnProperty(Q)){J=this.seen[ae];do J++,Q=ae+"-"+J;while(this.seen.hasOwnProperty(Q))}return ce||(this.seen[ae]=J,this.seen[Q]=0),Q},Se.slug=function(ae,ce){ce===void 0&&(ce={});var Q=this.serialize(ae);return this.getNextSafeSlug(Q,ce.dryrun)},ke}(),le=function(){function ke(ye){this.options=ye||ie.defaults,this.options.renderer=this.options.renderer||new ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ue,this.slugger=new oe}ke.parse=function(ae,ce){var Q=new ke(ce);return Q.parse(ae)},ke.parseInline=function(ae,ce){var Q=new ke(ce);return Q.parseInline(ae)};var Se=ke.prototype;return Se.parse=function(ae,ce){ce===void 0&&(ce=!0);var Q="",J,I,z,W,j,re,de,Z,pe,ge,Ne,Be,Ye,Xe,Te,nt,G,X,fe,Ue=ae.length;for(J=0;J<Ue;J++){if(ge=ae[J],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ge.type]&&(fe=this.options.extensions.renderers[ge.type].call({parser:this},ge),fe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ge.type))){Q+=fe||"";continue}switch(ge.type){case"space":continue;case"hr":{Q+=this.renderer.hr();continue}case"heading":{Q+=this.renderer.heading(this.parseInline(ge.tokens),ge.depth,d(this.parseInline(ge.tokens,this.textRenderer)),this.slugger);continue}case"code":{Q+=this.renderer.code(ge.text,ge.lang,ge.escaped);continue}case"table":{for(Z="",de="",W=ge.header.length,I=0;I<W;I++)de+=this.renderer.tablecell(this.parseInline(ge.header[I].tokens),{header:!0,align:ge.align[I]});for(Z+=this.renderer.tablerow(de),pe="",W=ge.rows.length,I=0;I<W;I++){for(re=ge.rows[I],de="",j=re.length,z=0;z<j;z++)de+=this.renderer.tablecell(this.parseInline(re[z].tokens),{header:!1,align:ge.align[z]});pe+=this.renderer.tablerow(de)}Q+=this.renderer.table(Z,pe);continue}case"blockquote":{pe=this.parse(ge.tokens),Q+=this.renderer.blockquote(pe);continue}case"list":{for(Ne=ge.ordered,Be=ge.start,Ye=ge.loose,W=ge.items.length,pe="",I=0;I<W;I++)Te=ge.items[I],nt=Te.checked,G=Te.task,Xe="",Te.task&&(X=this.renderer.checkbox(nt),Ye?Te.tokens.length>0&&Te.tokens[0].type==="paragraph"?(Te.tokens[0].text=X+" "+Te.tokens[0].text,Te.tokens[0].tokens&&Te.tokens[0].tokens.length>0&&Te.tokens[0].tokens[0].type==="text"&&(Te.tokens[0].tokens[0].text=X+" "+Te.tokens[0].tokens[0].text)):Te.tokens.unshift({type:"text",text:X}):Xe+=X),Xe+=this.parse(Te.tokens,Ye),pe+=this.renderer.listitem(Xe,G,nt);Q+=this.renderer.list(pe,Ne,Be);continue}case"html":{Q+=this.renderer.html(ge.text);continue}case"paragraph":{Q+=this.renderer.paragraph(this.parseInline(ge.tokens));continue}case"text":{for(pe=ge.tokens?this.parseInline(ge.tokens):ge.text;J+1<Ue&&ae[J+1].type==="text";)ge=ae[++J],pe+=`
`+(ge.tokens?this.parseInline(ge.tokens):ge.text);Q+=ce?this.renderer.paragraph(pe):pe;continue}default:{var He='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(He);return}else throw new Error(He)}}}return Q},Se.parseInline=function(ae,ce){ce=ce||this.renderer;var Q="",J,I,z,W=ae.length;for(J=0;J<W;J++){if(I=ae[J],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[I.type]&&(z=this.options.extensions.renderers[I.type].call({parser:this},I),z!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(I.type))){Q+=z||"";continue}switch(I.type){case"escape":{Q+=ce.text(I.text);break}case"html":{Q+=ce.html(I.text);break}case"link":{Q+=ce.link(I.href,I.title,this.parseInline(I.tokens,ce));break}case"image":{Q+=ce.image(I.href,I.title,I.text);break}case"strong":{Q+=ce.strong(this.parseInline(I.tokens,ce));break}case"em":{Q+=ce.em(this.parseInline(I.tokens,ce));break}case"codespan":{Q+=ce.codespan(I.text);break}case"br":{Q+=ce.br();break}case"del":{Q+=ce.del(this.parseInline(I.tokens,ce));break}case"text":{Q+=ce.text(I.text);break}default:{var j='Token with "'+I.type+'" type was not found.';if(this.options.silent){console.error(j);return}else throw new Error(j)}}}return Q},ke}();function te(ke,Se,ye){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof Se=="function"&&(ye=Se,Se=null),Se=c({},te.defaults,Se||{}),U(Se),ye){var ae=Se.highlight,ce;try{ce=O.lex(ke,Se)}catch(W){return ye(W)}var Q=function(j){var re;if(!j)try{Se.walkTokens&&te.walkTokens(ce,Se.walkTokens),re=le.parse(ce,Se)}catch(de){j=de}return Se.highlight=ae,j?ye(j):ye(null,re)};if(!ae||ae.length<3||(delete Se.highlight,!ce.length))return Q();var J=0;te.walkTokens(ce,function(W){W.type==="code"&&(J++,setTimeout(function(){ae(W.text,W.lang,function(j,re){if(j)return Q(j);re!=null&&re!==W.text&&(W.text=re,W.escaped=!0),J--,J===0&&Q()})},0))}),J===0&&Q();return}function I(W){if(W.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(W.message+"",!0)+"</pre>";throw W}try{var z=O.lex(ke,Se);if(Se.walkTokens){if(Se.async)return Promise.all(te.walkTokens(z,Se.walkTokens)).then(function(){return le.parse(z,Se)}).catch(I);te.walkTokens(z,Se.walkTokens)}return le.parse(z,Se)}catch(W){I(W)}}te.options=te.setOptions=function(ke){return c(te.defaults,ke),A(te.defaults),te},te.getDefaults=y,te.defaults=ie.defaults,te.use=function(){for(var ke=arguments.length,Se=new Array(ke),ye=0;ye<ke;ye++)Se[ye]=arguments[ye];var ae=c.apply(void 0,[{}].concat(Se)),ce=te.defaults.extensions||{renderers:{},childTokens:{}},Q;Se.forEach(function(J){if(J.extensions&&(Q=!0,J.extensions.forEach(function(z){if(!z.name)throw new Error("extension name required");if(z.renderer){var W=ce.renderers?ce.renderers[z.name]:null;W?ce.renderers[z.name]=function(){for(var j=arguments.length,re=new Array(j),de=0;de<j;de++)re[de]=arguments[de];var Z=z.renderer.apply(this,re);return Z===!1&&(Z=W.apply(this,re)),Z}:ce.renderers[z.name]=z.renderer}if(z.tokenizer){if(!z.level||z.level!=="block"&&z.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[z.level]?ce[z.level].unshift(z.tokenizer):ce[z.level]=[z.tokenizer],z.start&&(z.level==="block"?ce.startBlock?ce.startBlock.push(z.start):ce.startBlock=[z.start]:z.level==="inline"&&(ce.startInline?ce.startInline.push(z.start):ce.startInline=[z.start]))}z.childTokens&&(ce.childTokens[z.name]=z.childTokens)})),J.renderer&&function(){var z=te.defaults.renderer||new ee,W=function(de){var Z=z[de];z[de]=function(){for(var pe=arguments.length,ge=new Array(pe),Ne=0;Ne<pe;Ne++)ge[Ne]=arguments[Ne];var Be=J.renderer[de].apply(z,ge);return Be===!1&&(Be=Z.apply(z,ge)),Be}};for(var j in J.renderer)W(j);ae.renderer=z}(),J.tokenizer&&function(){var z=te.defaults.tokenizer||new L,W=function(de){var Z=z[de];z[de]=function(){for(var pe=arguments.length,ge=new Array(pe),Ne=0;Ne<pe;Ne++)ge[Ne]=arguments[Ne];var Be=J.tokenizer[de].apply(z,ge);return Be===!1&&(Be=Z.apply(z,ge)),Be}};for(var j in J.tokenizer)W(j);ae.tokenizer=z}(),J.walkTokens){var I=te.defaults.walkTokens;ae.walkTokens=function(z){var W=[];return W.push(J.walkTokens.call(this,z)),I&&(W=W.concat(I.call(this,z))),W}}Q&&(ae.extensions=ce),te.setOptions(ae)})},te.walkTokens=function(ke,Se){for(var ye=[],ae=function(){var I=Q.value;switch(ye=ye.concat(Se.call(te,I)),I.type){case"table":{for(var z=M(I.header),W;!(W=z()).done;){var j=W.value;ye=ye.concat(te.walkTokens(j.tokens,Se))}for(var re=M(I.rows),de;!(de=re()).done;)for(var Z=de.value,pe=M(Z),ge;!(ge=pe()).done;){var Ne=ge.value;ye=ye.concat(te.walkTokens(Ne.tokens,Se))}break}case"list":{ye=ye.concat(te.walkTokens(I.items,Se));break}default:te.defaults.extensions&&te.defaults.extensions.childTokens&&te.defaults.extensions.childTokens[I.type]?te.defaults.extensions.childTokens[I.type].forEach(function(Be){ye=ye.concat(te.walkTokens(I[Be],Se))}):I.tokens&&(ye=ye.concat(te.walkTokens(I.tokens,Se)))}},ce=M(ke),Q;!(Q=ce()).done;)ae();return ye},te.parseInline=function(ke,Se){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");Se=c({},te.defaults,Se||{}),U(Se);try{var ye=O.lexInline(ke,Se);return Se.walkTokens&&te.walkTokens(ye,Se.walkTokens),le.parseInline(ye,Se)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(ae.message+"",!0)+"</pre>";throw ae}},te.Parser=le,te.parser=le.parse,te.Renderer=ee,te.TextRenderer=ue,te.Lexer=O,te.lexer=O.lex,te.Tokenizer=L,te.Slugger=oe,te.parse=te;var Ee=te.options,be=te.setOptions,ne=te.use,ve=te.walkTokens,Pe=te.parseInline,Fe=te,xe=le.parse,Qe=O.lex;ie.Lexer=O,ie.Parser=le,ie.Renderer=ee,ie.Slugger=oe,ie.TextRenderer=ue,ie.Tokenizer=L,ie.getDefaults=y,ie.lexer=Qe,ie.marked=te,ie.options=Ee,ie.parse=Fe,ie.parseInline=Pe,ie.parser=xe,ie.setOptions=be,ie.use=ne,ie.walkTokens=ve,Object.defineProperty(ie,"__esModule",{value:!0})}),define(Ce[108],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(A,b,P){return Math.min(Math.max(A,b),P)}e.clamp=a;function p(A,b){return(b+A%b)%b}e.rot=p;class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class M{constructor(){this._n=1,this._val=0}update(b){return this._val=this._val+(b-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class y{constructor(b){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(b),this._values.fill(0,0,b)}update(b){const P=this._values[this._index];return this._values[this._index]=b,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=b,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=y}),function(){function ie(w){const M=[];typeof w=="number"&&M.push("code/timeOrigin",w);function y(b){M.push(b,Date.now())}function A(){const b=[];for(let P=0;P<M.length;P+=2)b.push({name:M[P],startTime:M[P+1]});return b}return{mark:y,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const y of performance.getEntriesByType("mark"))M.push({name:y.name,startTime:Math.round(w+y.startTime)});return M}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function a(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var p;typeof global=="object"?p=global:typeof self=="object"?p=self:p={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(p)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(p):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),p.perf=a(p))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var p in a)(typeof exports=="object"?exports:ie)[p]=a[p]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function a(p){if(e[p])return e[p].exports;var w=e[p]={i:p,l:!1,exports:{}};return ie[p].call(w.exports,w,w.exports,a),w.l=!0,w.exports}return a.m=ie,a.c=e,a.d=function(p,w,M){a.o(p,w)||Object.defineProperty(p,w,{enumerable:!0,get:M})},a.r=function(p){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(p,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(p,"__esModule",{value:!0})},a.t=function(p,w){if(1&w&&(p=a(p)),8&w||4&w&&typeof p=="object"&&p&&p.__esModule)return p;var M=Object.create(null);if(a.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:p}),2&w&&typeof p!="string")for(var y in p)a.d(M,y,function(A){return p[A]}.bind(null,y));return M},a.n=function(p){var w=p&&p.__esModule?function(){return p.default}:function(){return p};return a.d(w,"a",w),w},a.o=function(p,w){return Object.prototype.hasOwnProperty.call(p,w)},a.p="",a(a.s=0)}([function(ie,e,a){(function(p){var w;e=ie.exports=ne,w=typeof p=="object"&&p.env&&p.env.NODE_DEBUG&&/\bsemver\b/i.test(p.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,y=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],b=e.src=[],P=0,R=P++;b[R]="0|[1-9]\\d*";var S=P++;b[S]="[0-9]+";var m=P++;b[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=P++;b[k]="("+b[R]+")\\.("+b[R]+")\\.("+b[R]+")";var f=P++;b[f]="("+b[S]+")\\.("+b[S]+")\\.("+b[S]+")";var h=P++;b[h]="(?:"+b[R]+"|"+b[m]+")";var d=P++;b[d]="(?:"+b[S]+"|"+b[m]+")";var o=P++;b[o]="(?:-("+b[h]+"(?:\\."+b[h]+")*))";var g=P++;b[g]="(?:-?("+b[d]+"(?:\\."+b[d]+")*))";var E=P++;b[E]="[0-9A-Za-z-]+";var l=P++;b[l]="(?:\\+("+b[E]+"(?:\\."+b[E]+")*))";var D=P++,i="v?"+b[k]+b[o]+"?"+b[l]+"?";b[D]="^"+i+"$";var u="[v=\\s]*"+b[f]+b[g]+"?"+b[l]+"?",n=P++;b[n]="^"+u+"$";var r=P++;b[r]="((?:<|>)?=?)";var s=P++;b[s]=b[S]+"|x|X|\\*";var t=P++;b[t]=b[R]+"|x|X|\\*";var c=P++;b[c]="[v=\\s]*("+b[t]+")(?:\\.("+b[t]+")(?:\\.("+b[t]+")(?:"+b[o]+")?"+b[l]+"?)?)?";var _=P++;b[_]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[g]+")?"+b[l]+"?)?)?";var v=P++;b[v]="^"+b[r]+"\\s*"+b[c]+"$";var T=P++;b[T]="^"+b[r]+"\\s*"+b[_]+"$";var U=P++;b[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var V=P++;b[V]="(?:~>?)";var x=P++;b[x]="(\\s*)"+b[V]+"\\s+",A[x]=new RegExp(b[x],"g");var C=P++;b[C]="^"+b[V]+b[c]+"$";var L=P++;b[L]="^"+b[V]+b[_]+"$";var B=P++;b[B]="(?:\\^)";var F=P++;b[F]="(\\s*)"+b[B]+"\\s+",A[F]=new RegExp(b[F],"g");var K=P++;b[K]="^"+b[B]+b[c]+"$";var H=P++;b[H]="^"+b[B]+b[_]+"$";var O=P++;b[O]="^"+b[r]+"\\s*("+u+")$|^$";var ee=P++;b[ee]="^"+b[r]+"\\s*("+i+")$|^$";var ue=P++;b[ue]="(\\s*)"+b[r]+"\\s*("+u+"|"+b[c]+")",A[ue]=new RegExp(b[ue],"g");var oe=P++;b[oe]="^\\s*("+b[c]+")\\s+-\\s+("+b[c]+")\\s*$";var le=P++;b[le]="^\\s*("+b[_]+")\\s+-\\s+("+b[_]+")\\s*$";var te=P++;b[te]="(<|>)?=?\\s*\\*";for(var Ee=0;Ee<35;Ee++)w(Ee,b[Ee]),A[Ee]||(A[Ee]=new RegExp(b[Ee]));function be(Z,pe){if(Z instanceof ne)return Z;if(typeof Z!="string"||Z.length>M||!(pe?A[n]:A[D]).test(Z))return null;try{return new ne(Z,pe)}catch{return null}}function ne(Z,pe){if(Z instanceof ne){if(Z.loose===pe)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ne))return new ne(Z,pe);w("SemVer",Z,pe),this.loose=pe;var ge=Z.trim().match(pe?A[n]:A[D]);if(!ge)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>y||this.major<0)throw new TypeError("Invalid major version");if(this.minor>y||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>y||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Be=+Ne;if(Be>=0&&Be<y)return Be}return Ne}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=be,e.valid=function(Z,pe){var ge=be(Z,pe);return ge?ge.version:null},e.clean=function(Z,pe){var ge=be(Z.trim().replace(/^[=v]+/,""),pe);return ge?ge.version:null},e.SemVer=ne,ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ne.prototype.toString=function(){return this.version},ne.prototype.compare=function(Z){return w("SemVer.compare",this.version,this.loose,Z),Z instanceof ne||(Z=new ne(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},ne.prototype.compareMain=function(Z){return Z instanceof ne||(Z=new ne(Z,this.loose)),Pe(this.major,Z.major)||Pe(this.minor,Z.minor)||Pe(this.patch,Z.patch)},ne.prototype.comparePre=function(Z){if(Z instanceof ne||(Z=new ne(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var pe=0;do{var ge=this.prerelease[pe],Ne=Z.prerelease[pe];if(w("prerelease compare",pe,ge,Ne),ge===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ne)return Pe(ge,Ne)}while(++pe)},ne.prototype.inc=function(Z,pe){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",pe),this.inc("pre",pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",pe),this.inc("pre",pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}pe&&(this.prerelease[0]===pe?isNaN(this.prerelease[1])&&(this.prerelease=[pe,0]):this.prerelease=[pe,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,pe,ge,Ne){typeof ge=="string"&&(Ne=ge,ge=void 0);try{return new ne(Z,ge).inc(pe,Ne).version}catch{return null}},e.diff=function(Z,pe){if(ke(Z,pe))return null;var ge=be(Z),Ne=be(pe);if(ge.prerelease.length||Ne.prerelease.length){for(var Be in ge)if((Be==="major"||Be==="minor"||Be==="patch")&&ge[Be]!==Ne[Be])return"pre"+Be;return"prerelease"}for(var Be in ge)if((Be==="major"||Be==="minor"||Be==="patch")&&ge[Be]!==Ne[Be])return Be},e.compareIdentifiers=Pe;var ve=/^[0-9]+$/;function Pe(Z,pe){var ge=ve.test(Z),Ne=ve.test(pe);return ge&&Ne&&(Z=+Z,pe=+pe),ge&&!Ne?-1:Ne&&!ge?1:Z<pe?-1:Z>pe?1:0}function Fe(Z,pe,ge){return new ne(Z,ge).compare(new ne(pe,ge))}function xe(Z,pe,ge){return Fe(Z,pe,ge)>0}function Qe(Z,pe,ge){return Fe(Z,pe,ge)<0}function ke(Z,pe,ge){return Fe(Z,pe,ge)===0}function Se(Z,pe,ge){return Fe(Z,pe,ge)!==0}function ye(Z,pe,ge){return Fe(Z,pe,ge)>=0}function ae(Z,pe,ge){return Fe(Z,pe,ge)<=0}function ce(Z,pe,ge,Ne){var Be;switch(pe){case"===":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),Be=Z===ge;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),Be=Z!==ge;break;case"":case"=":case"==":Be=ke(Z,ge,Ne);break;case"!=":Be=Se(Z,ge,Ne);break;case">":Be=xe(Z,ge,Ne);break;case">=":Be=ye(Z,ge,Ne);break;case"<":Be=Qe(Z,ge,Ne);break;case"<=":Be=ae(Z,ge,Ne);break;default:throw new TypeError("Invalid operator: "+pe)}return Be}function Q(Z,pe){if(Z instanceof Q){if(Z.loose===pe)return Z;Z=Z.value}if(!(this instanceof Q))return new Q(Z,pe);w("comparator",Z,pe),this.loose=pe,this.parse(Z),this.semver===J?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}e.rcompareIdentifiers=function(Z,pe){return Pe(pe,Z)},e.major=function(Z,pe){return new ne(Z,pe).major},e.minor=function(Z,pe){return new ne(Z,pe).minor},e.patch=function(Z,pe){return new ne(Z,pe).patch},e.compare=Fe,e.compareLoose=function(Z,pe){return Fe(Z,pe,!0)},e.rcompare=function(Z,pe,ge){return Fe(pe,Z,ge)},e.sort=function(Z,pe){return Z.sort(function(ge,Ne){return e.compare(ge,Ne,pe)})},e.rsort=function(Z,pe){return Z.sort(function(ge,Ne){return e.rcompare(ge,Ne,pe)})},e.gt=xe,e.lt=Qe,e.eq=ke,e.neq=Se,e.gte=ye,e.lte=ae,e.cmp=ce,e.Comparator=Q;var J={};function I(Z,pe){if(Z instanceof I)return Z.loose===pe?Z:new I(Z.raw,pe);if(Z instanceof Q)return new I(Z.value,pe);if(!(this instanceof I))return new I(Z,pe);if(this.loose=pe,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function z(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function W(Z,pe,ge,Ne,Be,Ye,Xe,Te,nt,G,X,fe,Ue){return((pe=z(ge)?"":z(Ne)?">="+ge+".0.0":z(Be)?">="+ge+"."+Ne+".0":">="+pe)+" "+(Te=z(nt)?"":z(G)?"<"+(+nt+1)+".0.0":z(X)?"<"+nt+"."+(+G+1)+".0":fe?"<="+nt+"."+G+"."+X+"-"+fe:"<="+Te)).trim()}function j(Z,pe){for(var ge=0;ge<Z.length;ge++)if(!Z[ge].test(pe))return!1;if(pe.prerelease.length){for(ge=0;ge<Z.length;ge++)if(w(Z[ge].semver),Z[ge].semver!==J&&Z[ge].semver.prerelease.length>0){var Ne=Z[ge].semver;if(Ne.major===pe.major&&Ne.minor===pe.minor&&Ne.patch===pe.patch)return!0}return!1}return!0}function re(Z,pe,ge){try{pe=new I(pe,ge)}catch{return!1}return pe.test(Z)}function de(Z,pe,ge,Ne){var Be,Ye,Xe,Te,nt;switch(Z=new ne(Z,Ne),pe=new I(pe,Ne),ge){case">":Be=xe,Ye=ae,Xe=Qe,Te=">",nt=">=";break;case"<":Be=Qe,Ye=ye,Xe=xe,Te="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(re(Z,pe,Ne))return!1;for(var G=0;G<pe.set.length;++G){var X=pe.set[G],fe=null,Ue=null;if(X.forEach(function(He){He.semver===J&&(He=new Q(">=0.0.0")),fe=fe||He,Ue=Ue||He,Be(He.semver,fe.semver,Ne)?fe=He:Xe(He.semver,Ue.semver,Ne)&&(Ue=He)}),fe.operator===Te||fe.operator===nt||(!Ue.operator||Ue.operator===Te)&&Ye(Z,Ue.semver)||Ue.operator===nt&&Xe(Z,Ue.semver))return!1}return!0}Q.prototype.parse=function(Z){var pe=this.loose?A[O]:A[ee],ge=Z.match(pe);if(!ge)throw new TypeError("Invalid comparator: "+Z);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new ne(ge[2],this.loose):this.semver=J},Q.prototype.toString=function(){return this.value},Q.prototype.test=function(Z){return w("Comparator.test",Z,this.loose),this.semver===J||(typeof Z=="string"&&(Z=new ne(Z,this.loose)),ce(Z,this.operator,this.semver,this.loose))},Q.prototype.intersects=function(Z,pe){if(!(Z instanceof Q))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new I(Z.value,pe),re(this.value,ge,pe);if(Z.operator==="")return ge=new I(this.value,pe),re(Z.semver,ge,pe);var Ne=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Ye=this.semver.version===Z.semver.version,Xe=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),Te=ce(this.semver,"<",Z.semver,pe)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),nt=ce(this.semver,">",Z.semver,pe)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return Ne||Be||Ye&&Xe||Te||nt},e.Range=I,I.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},I.prototype.toString=function(){return this.range},I.prototype.parseRange=function(Z){var pe=this.loose;Z=Z.trim(),w("range",Z,pe);var ge=pe?A[le]:A[oe];Z=Z.replace(ge,W),w("hyphen replace",Z),Z=Z.replace(A[ue],"$1$2$3"),w("comparator trim",Z,A[ue]),Z=(Z=(Z=Z.replace(A[x],"$1~")).replace(A[F],"$1^")).split(/\s+/).join(" ");var Ne=pe?A[O]:A[ee],Be=Z.split(" ").map(function(Ye){return function(Xe,Te){return w("comp",Xe),Xe=function(nt,G){return nt.trim().split(/\s+/).map(function(X){return function(fe,Ue){w("caret",fe,Ue);var He=Ue?A[H]:A[K];return fe.replace(He,function(Ze,je,We,it,rt){var dt;return w("caret",fe,Ze,je,We,it,rt),z(je)?dt="":z(We)?dt=">="+je+".0.0 <"+(+je+1)+".0.0":z(it)?dt=je==="0"?">="+je+"."+We+".0 <"+je+"."+(+We+1)+".0":">="+je+"."+We+".0 <"+(+je+1)+".0.0":rt?(w("replaceCaret pr",rt),rt.charAt(0)!=="-"&&(rt="-"+rt),dt=je==="0"?We==="0"?">="+je+"."+We+"."+it+rt+" <"+je+"."+We+"."+(+it+1):">="+je+"."+We+"."+it+rt+" <"+je+"."+(+We+1)+".0":">="+je+"."+We+"."+it+rt+" <"+(+je+1)+".0.0"):(w("no pr"),dt=je==="0"?We==="0"?">="+je+"."+We+"."+it+" <"+je+"."+We+"."+(+it+1):">="+je+"."+We+"."+it+" <"+je+"."+(+We+1)+".0":">="+je+"."+We+"."+it+" <"+(+je+1)+".0.0"),w("caret return",dt),dt})}(X,G)}).join(" ")}(Xe,Te),w("caret",Xe),Xe=function(nt,G){return nt.trim().split(/\s+/).map(function(X){return function(fe,Ue){var He=Ue?A[L]:A[C];return fe.replace(He,function(Ze,je,We,it,rt){var dt;return w("tilde",fe,Ze,je,We,it,rt),z(je)?dt="":z(We)?dt=">="+je+".0.0 <"+(+je+1)+".0.0":z(it)?dt=">="+je+"."+We+".0 <"+je+"."+(+We+1)+".0":rt?(w("replaceTilde pr",rt),rt.charAt(0)!=="-"&&(rt="-"+rt),dt=">="+je+"."+We+"."+it+rt+" <"+je+"."+(+We+1)+".0"):dt=">="+je+"."+We+"."+it+" <"+je+"."+(+We+1)+".0",w("tilde return",dt),dt})}(X,G)}).join(" ")}(Xe,Te),w("tildes",Xe),Xe=function(nt,G){return w("replaceXRanges",nt,G),nt.split(/\s+/).map(function(X){return function(fe,Ue){fe=fe.trim();var He=Ue?A[T]:A[v];return fe.replace(He,function(Ze,je,We,it,rt,dt){w("xRange",fe,Ze,je,We,it,rt,dt);var at=z(We),st=at||z(it),yt=st||z(rt);return je==="="&&yt&&(je=""),at?Ze=je===">"||je==="<"?"<0.0.0":"*":je&&yt?(st&&(it=0),yt&&(rt=0),je===">"?(je=">=",st?(We=+We+1,it=0,rt=0):yt&&(it=+it+1,rt=0)):je==="<="&&(je="<",st?We=+We+1:it=+it+1),Ze=je+We+"."+it+"."+rt):st?Ze=">="+We+".0.0 <"+(+We+1)+".0.0":yt&&(Ze=">="+We+"."+it+".0 <"+We+"."+(+it+1)+".0"),w("xRange return",Ze),Ze})}(X,G)}).join(" ")}(Xe,Te),w("xrange",Xe),Xe=function(nt,G){return w("replaceStars",nt,G),nt.trim().replace(A[te],"")}(Xe,Te),w("stars",Xe),Xe}(Ye,pe)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Ye){return!!Ye.match(Ne)})),Be=Be.map(function(Ye){return new Q(Ye,pe)})},I.prototype.intersects=function(Z,pe){if(!(Z instanceof I))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ne){return Z.set.some(function(Be){return Be.every(function(Ye){return Ne.intersects(Ye,pe)})})})})},e.toComparators=function(Z,pe){return new I(Z,pe).set.map(function(ge){return ge.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},I.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new ne(Z,this.loose));for(var pe=0;pe<this.set.length;pe++)if(j(this.set[pe],Z))return!0;return!1},e.satisfies=re,e.maxSatisfying=function(Z,pe,ge){var Ne=null,Be=null;try{var Ye=new I(pe,ge)}catch{return null}return Z.forEach(function(Xe){Ye.test(Xe)&&(Ne&&Be.compare(Xe)!==-1||(Be=new ne(Ne=Xe,ge)))}),Ne},e.minSatisfying=function(Z,pe,ge){var Ne=null,Be=null;try{var Ye=new I(pe,ge)}catch{return null}return Z.forEach(function(Xe){Ye.test(Xe)&&(Ne&&Be.compare(Xe)!==1||(Be=new ne(Ne=Xe,ge)))}),Ne},e.validRange=function(Z,pe){try{return new I(Z,pe).range||"*"}catch{return null}},e.ltr=function(Z,pe,ge){return de(Z,pe,"<",ge)},e.gtr=function(Z,pe,ge){return de(Z,pe,">",ge)},e.outside=de,e.prerelease=function(Z,pe){var ge=be(Z,pe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Z,pe,ge){return Z=new I(Z,ge),pe=new I(pe,ge),Z.intersects(pe)},e.coerce=function(Z){if(Z instanceof ne)return Z;if(typeof Z!="string")return null;var pe=Z.match(A[U]);return pe==null?null:be((pe[1]||"0")+"."+(pe[2]||"0")+"."+(pe[3]||"0"))}}).call(this,a(1))},function(ie,e){var a,p,w=ie.exports={};function M(){throw new Error("setTimeout has not been defined")}function y(){throw new Error("clearTimeout has not been defined")}function A(d){if(a===setTimeout)return setTimeout(d,0);if((a===M||!a)&&setTimeout)return a=setTimeout,setTimeout(d,0);try{return a(d,0)}catch{try{return a.call(null,d,0)}catch{return a.call(this,d,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:M}catch{a=M}try{p=typeof clearTimeout=="function"?clearTimeout:y}catch{p=y}})();var b,P=[],R=!1,S=-1;function m(){R&&b&&(R=!1,b.length?P=b.concat(P):S=-1,P.length&&k())}function k(){if(!R){var d=A(m);R=!0;for(var o=P.length;o;){for(b=P,P=[];++S<o;)b&&b[S].run();S=-1,o=P.length}b=null,R=!1,function(g){if(p===clearTimeout)return clearTimeout(g);if((p===y||!p)&&clearTimeout)return p=clearTimeout,clearTimeout(g);try{p(g)}catch{try{return p.call(null,g)}catch{return p.call(this,g)}}}(d)}}function f(d,o){this.fun=d,this.array=o}function h(){}w.nextTick=function(d){var o=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)o[g-1]=arguments[g];P.push(new f(d,o)),P.length!==1||R||A(k)},f.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=h,w.addListener=h,w.once=h,w.off=h,w.removeListener=h,w.removeAllListeners=h,w.emit=h,w.prependListener=h,w.prependOnceListener=h,w.listeners=function(d){return[]},w.binding=function(d){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(d){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(Ce[109],Ie([1,0,11,7]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function w(l){const D=l;return D?typeof D.read=="function":!1}e.isReadable=w;function M(l){const D=l;return D?[D.on,D.pause,D.resume,D.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=M;function y(l){const D=l;return D?M(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}e.isReadableBufferedStream=y;function A(l,D){return new b(l,D)}e.newWriteableStream=A;class b{constructor(D,i){this.reducer=D,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(D){if(!this.state.destroyed){if(this.state.flowing)this.emitData(D);else if(this.buffer.data.push(D),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(D){this.state.destroyed||(this.state.flowing?this.emitError(D):this.buffer.error.push(D))}end(D){this.state.destroyed||(typeof D<"u"&&this.write(D),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(D){this.listeners.data.slice(0).forEach(i=>i(D))}emitError(D){this.listeners.error.length===0?(0,a.onUnexpectedError)(D):this.listeners.error.slice(0).forEach(i=>i(D))}emitEnd(){this.listeners.end.slice(0).forEach(D=>D())}on(D,i){if(!this.state.destroyed)switch(D){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(D,i){if(this.state.destroyed)return;let u;switch(D){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const n=u.indexOf(i);n>=0&&u.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const D=this.reducer(this.buffer.data);this.emitData(D),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const D of this.buffer.error)this.emitError(D);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(l,D){const i=[];let u;for(;(u=l.read())!==null;)i.push(u);return D(i)}e.consumeReadable=P;function R(l,D,i){const u=[];let n;for(;(n=l.read())!==null&&u.length<i;)u.push(n);return n===null&&u.length>0?D(u):{read:()=>{if(u.length>0)return u.shift();if(typeof n<"u"){const r=n;return n=void 0,r}return l.read()}}}e.peekReadable=R;function S(l,D){return new Promise((i,u)=>{const n=[];m(l,{onData:r=>{D&&n.push(r)},onError:r=>{D?u(r):i(void 0)},onEnd:()=>{i(D?D(n):void 0)}})})}e.consumeStream=S;function m(l,D){let i=!1;return l.on("error",u=>{i||D.onError(u)}),l.on("end",()=>{i||D.onEnd()}),l.on("data",u=>{i||D.onData(u)}),(0,p.toDisposable)(()=>i=!0)}e.listenStream=m;function k(l,D){return new Promise((i,u)=>{const n=new p.DisposableStore,r=[],s=_=>{if(r.push(_),r.length>D)return n.dispose(),l.pause(),i({stream:l,buffer:r,ended:!1})},t=_=>u(_),c=()=>i({stream:l,buffer:r,ended:!0});n.add((0,p.toDisposable)(()=>l.removeListener("error",t))),l.on("error",t),n.add((0,p.toDisposable)(()=>l.removeListener("end",c))),l.on("end",c),n.add((0,p.toDisposable)(()=>l.removeListener("data",s))),l.on("data",s)})}e.peekStream=k;function f(l,D){const i=A(D);return i.end(l),i}e.toStream=f;function h(){const l=A(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=h;function d(l){let D=!1;return{read:()=>D?null:(D=!0,l)}}e.toReadable=d;function o(l,D,i){const u=A(i);return m(l,{onData:n=>u.write(D.data(n)),onError:n=>u.error(D.error?D.error(n):n),onEnd:()=>u.end()}),u}e.transform=o;function g(l,D,i){let u=!1;return{read:()=>{const n=D.read();return u?n:(u=!0,n!==null?i([l,n]):l)}}}e.prefixedReadable=g;function E(l,D,i){let u=!1;const n=A(i);return m(D,{onData:r=>u?n.write(r):(u=!0,n.write(i([l,r]))),onError:r=>n.error(r),onEnd:()=>{u||(u=!0,n.write(l)),n.end()}}),n}e.prefixedStream=E}),define(Ce[23],Ie([1,0,109]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const p=typeof Buffer<"u";let w,M;class y{constructor(_){this.buffer=_,this.byteLength=this.buffer.byteLength}static alloc(_){return p?new y(Buffer.allocUnsafe(_)):new y(new Uint8Array(_))}static wrap(_){return p&&!Buffer.isBuffer(_)&&(_=Buffer.from(_.buffer,_.byteOffset,_.byteLength)),new y(_)}static fromString(_,v){return!(v?.dontUseNodeBuffer||!1)&&p?new y(Buffer.from(_)):(w||(w=new TextEncoder),new y(w.encode(_)))}static fromByteArray(_){const v=y.alloc(_.length);for(let T=0,U=_.length;T<U;T++)v.buffer[T]=_[T];return v}static concat(_,v){if(typeof v>"u"){v=0;for(let V=0,x=_.length;V<x;V++)v+=_[V].byteLength}const T=y.alloc(v);let U=0;for(let V=0,x=_.length;V<x;V++){const C=_[V];T.set(C,U),U+=C.byteLength}return T}clone(){const _=y.alloc(this.byteLength);return _.set(this),_}toString(){return p?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(_,v){return new y(this.buffer.subarray(_,v))}set(_,v){if(_ instanceof y)this.buffer.set(_.buffer,v);else if(_ instanceof Uint8Array)this.buffer.set(_,v);else if(_ instanceof ArrayBuffer)this.buffer.set(new Uint8Array(_),v);else if(ArrayBuffer.isView(_))this.buffer.set(new Uint8Array(_.buffer,_.byteOffset,_.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(_){return P(this.buffer,_)}writeUInt32BE(_,v){R(this.buffer,_,v)}readUInt32LE(_){return S(this.buffer,_)}writeUInt32LE(_,v){m(this.buffer,_,v)}readUInt8(_){return k(this.buffer,_)}writeUInt8(_,v){f(this.buffer,_,v)}}e.VSBuffer=y;function A(c,_){return c[_+0]<<0>>>0|c[_+1]<<8>>>0}e.readUInt16LE=A;function b(c,_,v){c[v+0]=_&255,_=_>>>8,c[v+1]=_&255}e.writeUInt16LE=b;function P(c,_){return c[_]*2**24+c[_+1]*2**16+c[_+2]*2**8+c[_+3]}e.readUInt32BE=P;function R(c,_,v){c[v+3]=_,_=_>>>8,c[v+2]=_,_=_>>>8,c[v+1]=_,_=_>>>8,c[v]=_}e.writeUInt32BE=R;function S(c,_){return c[_+0]<<0>>>0|c[_+1]<<8>>>0|c[_+2]<<16>>>0|c[_+3]<<24>>>0}e.readUInt32LE=S;function m(c,_,v){c[v+0]=_&255,_=_>>>8,c[v+1]=_&255,_=_>>>8,c[v+2]=_&255,_=_>>>8,c[v+3]=_&255}e.writeUInt32LE=m;function k(c,_){return c[_]}e.readUInt8=k;function f(c,_,v){c[v]=_}e.writeUInt8=f;function h(c){return a.consumeReadable(c,_=>y.concat(_))}e.readableToBuffer=h;function d(c){return a.toReadable(c)}e.bufferToReadable=d;function o(c){return a.consumeStream(c,_=>y.concat(_))}e.streamToBuffer=o;async function g(c){return c.ended?y.concat(c.buffer):y.concat([...c.buffer,await o(c.stream)])}e.bufferedStreamToBuffer=g;function E(c){return a.toStream(c,_=>y.concat(_))}e.bufferToStream=E;function l(c){return a.transform(c,{data:_=>typeof _=="string"?y.fromString(_):y.wrap(_)},_=>y.concat(_))}e.streamToBufferReadableStream=l;function D(c){return a.newWriteableStream(_=>y.concat(_),c)}e.newWriteableBufferStream=D;function i(c,_){return a.prefixedReadable(c,_,v=>y.concat(v))}e.prefixedBufferReadable=i;function u(c,_){return a.prefixedStream(c,_,v=>y.concat(v))}e.prefixedBufferStream=u;function n(c){let _=0,v=0,T=0;const U=new Uint8Array(Math.floor(c.length/4*3)),V=C=>{switch(v){case 3:U[T++]=_|C,v=0;break;case 2:U[T++]=_|C>>>2,_=C<<6,v=3;break;case 1:U[T++]=_|C>>>4,_=C<<4,v=2;break;default:_=C<<2,v=1}};for(let C=0;C<c.length;C++){const L=c.charCodeAt(C);if(L>=65&&L<=90)V(L-65);else if(L>=97&&L<=122)V(L-97+26);else if(L>=48&&L<=57)V(L-48+52);else if(L===43||L===45)V(62);else if(L===47||L===95)V(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${c[C]}`)}}const x=T;for(;v>0;)V(0);return y.wrap(U).slice(0,x)}e.decodeBase64=n;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:c},_=!0,v=!1){const T=v?s:r;let U="";const V=c.byteLength%3;let x=0;for(;x<c.byteLength-V;x+=3){const C=c[x+0],L=c[x+1],B=c[x+2];U+=T[C>>>2],U+=T[(C<<4|L>>>4)&63],U+=T[(L<<2|B>>>6)&63],U+=T[B&63]}if(V===1){const C=c[x+0];U+=T[C>>>2],U+=T[C<<4&63],_&&(U+="==")}else if(V===2){const C=c[x+0],L=c[x+1];U+=T[C>>>2],U+=T[(C<<4|L>>>4)&63],U+=T[L<<2&63],_&&(U+="=")}return U}e.encodeBase64=t}),define(Ce[42],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function p(w){return a.test(w)}e.isUUID=p,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let w;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?w=crypto.getRandomValues.bind(crypto):w=function(A){for(let b=0;b<A.length;b++)A[b]=Math.floor(Math.random()*256);return A};const M=new Uint8Array(16),y=[];for(let A=0;A<256;A++)y.push(A.toString(16).padStart(2,"0"));return function(){w(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let b=0,P="";return P+=y[M[b++]],P+=y[M[b++]],P+=y[M[b++]],P+=y[M[b++]],P+="-",P+=y[M[b++]],P+=y[M[b++]],P+="-",P+=y[M[b++]],P+=y[M[b++]],P+="-",P+=y[M[b++]],P+=y[M[b++]],P+="-",P+=y[M[b++]],P+=y[M[b++]],P+=y[M[b++]],P+=y[M[b++]],P+=y[M[b++]],P+=y[M[b++]],P}}()}),define(Ce[110],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[111],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class p{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let b=0,P=A.notIn.length;b<P;b++)switch(A.notIn[b]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,b){if(A.getTokenCount()===0)return!0;const P=A.findTokenIndexAtOffset(b-2),R=A.getStandardTokenType(P);return this.isOK(R)}_findNeutralCharacterInRange(A,b){for(let P=A;P<=b;P++){const R=String.fromCharCode(P);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=p;class w{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const b of A)M(this.autoClosingPairsOpenByStart,b.open.charAt(0),b),M(this.autoClosingPairsOpenByEnd,b.open.charAt(b.open.length-1),b),M(this.autoClosingPairsCloseByStart,b.close.charAt(0),b),M(this.autoClosingPairsCloseByEnd,b.close.charAt(b.close.length-1),b),b.close.length===1&&b.open.length===1&&M(this.autoClosingPairsCloseSingleChar,b.close,b)}}e.AutoClosingPairs=w;function M(y,A,b){y.has(A)?y.get(A).push(b):y.set(A,[b])}}),define(Ce[112],Ie([17,18]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(Ce[113],Ie([1,0,112]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const p=60,w=p*60,M=w*24,y=M*7,A=M*30,b=M*365;function P(S,m,k){typeof S!="number"&&(S=S.getTime());const f=Math.round((new Date().getTime()-S)/1e3);if(f<-30)return(0,a.localize)(0,null,P(new Date().getTime()+f*1e3,!1));if(f<30)return(0,a.localize)(1,null);let h;return f<p?(h=f,m?h===1?k?(0,a.localize)(2,null,h):(0,a.localize)(3,null,h):k?(0,a.localize)(4,null,h):(0,a.localize)(5,null,h):h===1?k?(0,a.localize)(6,null,h):(0,a.localize)(7,null,h):k?(0,a.localize)(8,null,h):(0,a.localize)(9,null,h)):f<w?(h=Math.floor(f/p),m?h===1?k?(0,a.localize)(10,null,h):(0,a.localize)(11,null,h):k?(0,a.localize)(12,null,h):(0,a.localize)(13,null,h):h===1?k?(0,a.localize)(14,null,h):(0,a.localize)(15,null,h):k?(0,a.localize)(16,null,h):(0,a.localize)(17,null,h)):f<M?(h=Math.floor(f/w),m?h===1?k?(0,a.localize)(18,null,h):(0,a.localize)(19,null,h):k?(0,a.localize)(20,null,h):(0,a.localize)(21,null,h):h===1?k?(0,a.localize)(22,null,h):(0,a.localize)(23,null,h):k?(0,a.localize)(24,null,h):(0,a.localize)(25,null,h)):f<y?(h=Math.floor(f/M),m?h===1?(0,a.localize)(26,null,h):(0,a.localize)(27,null,h):h===1?(0,a.localize)(28,null,h):(0,a.localize)(29,null,h)):f<A?(h=Math.floor(f/y),m?h===1?k?(0,a.localize)(30,null,h):(0,a.localize)(31,null,h):k?(0,a.localize)(32,null,h):(0,a.localize)(33,null,h):h===1?k?(0,a.localize)(34,null,h):(0,a.localize)(35,null,h):k?(0,a.localize)(36,null,h):(0,a.localize)(37,null,h)):f<b?(h=Math.floor(f/A),m?h===1?k?(0,a.localize)(38,null,h):(0,a.localize)(39,null,h):k?(0,a.localize)(40,null,h):(0,a.localize)(41,null,h):h===1?k?(0,a.localize)(42,null,h):(0,a.localize)(43,null,h):k?(0,a.localize)(44,null,h):(0,a.localize)(45,null,h)):(h=Math.floor(f/b),m?h===1?k?(0,a.localize)(46,null,h):(0,a.localize)(47,null,h):k?(0,a.localize)(48,null,h):(0,a.localize)(49,null,h):h===1?k?(0,a.localize)(50,null,h):(0,a.localize)(51,null,h):k?(0,a.localize)(52,null,h):(0,a.localize)(53,null,h))}e.fromNow=P;function R(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(Ce[114],Ie([17,18]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(Ce[43],Ie([1,0,16,10,114]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(S,m){return m&&(S.stack||S.stacktrace)?w.localize(0,null,A(S),y(S.stack)||y(S.stacktrace)):A(S)}function y(S){return Array.isArray(S)?S.join(`
`):S}function A(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?w.localize(1,null,S.message):S.message||w.localize(2,null)}function b(S=null,m=!1){if(!S)return w.localize(3,null);if(Array.isArray(S)){const k=a.coalesce(S),f=b(k[0],m);return k.length>1?w.localize(4,null,f,k.length):f}if(p.isString(S))return S;if(S.detail){const k=S.detail;if(k.error)return M(k.error,m);if(k.exception)return M(k.exception,m)}return S.stack?M(S,m):S.message?S.message:w.localize(5,null)}e.toErrorMessage=b;function P(S){const m=S;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=P;function R(S,m){let k;return typeof S=="string"?k=new Error(S):k=S,k.actions=m,k}e.createErrorWithActions=R}),define(Ce[74],Ie([1,0,19]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const p={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(R){const S=(0,a.extname)(R),m=p[S.toLowerCase()];return m!==void 0?m:y(R)}e.getMediaOrTextMime=M;function y(R){const S=(0,a.extname)(R);return w[S.toLowerCase()]}e.getMediaMime=y;function A(R){for(const S in w)if(w[S]===R)return S}e.getExtensionForMimeType=A;const b=/^(.+)\/(.+?)(;.+)?$/;function P(R,S){const m=b.exec(R);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:S?void 0:R}e.normalizeMimeType=P}),define(Ce[37],Ie([1,0,19,21,9,10]),function(ie,e,a,p,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function y(s){return s===47||s===92}e.isPathSeparator=y;function A(s){return s.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=A;function b(s){return s.indexOf("/")===-1&&(s=A(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=b;function P(s,t=a.posix.sep){if(!s)return"";const c=s.length,_=s.charCodeAt(0);if(y(_)){if(y(s.charCodeAt(1))&&!y(s.charCodeAt(2))){let T=3;const U=T;for(;T<c&&!y(s.charCodeAt(T));T++);if(U!==T&&!y(s.charCodeAt(T+1))){for(T+=1;T<c;T++)if(y(s.charCodeAt(T)))return s.slice(0,T+1).replace(/[\\/]/g,t)}}return t}else if(o(_)&&s.charCodeAt(1)===58)return y(s.charCodeAt(2))?s.slice(0,2)+t:s.slice(0,2);let v=s.indexOf("://");if(v!==-1){for(v+=3;v<c;v++)if(y(s.charCodeAt(v)))return s.slice(0,v+1)}return""}e.getRoot=P;function R(s){if(!p.isWindows||!s||s.length<5)return!1;let t=s.charCodeAt(0);if(t!==92||(t=s.charCodeAt(1),t!==92))return!1;let c=2;const _=c;for(;c<s.length&&(t=s.charCodeAt(c),t!==92);c++);return!(_===c||(t=s.charCodeAt(c+1),isNaN(t)||t===92))}e.isUNC=R;const S=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(s,t=p.isWindows){const c=t?S:m;return!(!s||s.length===0||/^\s+$/.test(s)||(c.lastIndex=0,c.test(s))||t&&k.test(s)||s==="."||s===".."||t&&s[s.length-1]==="."||t&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=f;function h(s,t,c){const _=s===t;return!c||_?_:!s||!t?!1:(0,w.equalsIgnoreCase)(s,t)}e.isEqual=h;function d(s,t,c,_=a.sep){if(s===t)return!0;if(!s||!t||t.length>s.length)return!1;if(c){if(!(0,w.startsWithIgnoreCase)(s,t))return!1;if(t.length===s.length)return!0;let T=t.length;return t.charAt(t.length-1)===_&&T--,s.charAt(T)===_}return t.charAt(t.length-1)!==_&&(t+=_),s.indexOf(t)===0}e.isEqualOrParent=d;function o(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=o;function g(s,t){return p.isWindows&&s.endsWith(":")&&(s+=a.sep),(0,a.isAbsolute)(s)||(s=(0,a.join)(t,s)),s=(0,a.normalize)(s),p.isWindows?(s=(0,w.rtrim)(s,a.sep),s.endsWith(":")&&(s+=a.sep)):(s=(0,w.rtrim)(s,a.sep),s||(s=a.sep)),s}e.sanitizeFilePath=g;function E(s){const t=(0,a.normalize)(s);return p.isWindows?s.length>3?!1:l(t)&&(s.length===2||t.charCodeAt(2)===92):t===a.posix.sep}e.isRootOrDriveLetter=E;function l(s,t=p.isWindows){return t?o(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function D(s){return l(s)?s[0]:void 0}e.getDriveLetter=D;function i(s,t,c){return t.length>s.length?-1:s===t?0:(c&&(s=s.toLowerCase(),t=t.toLowerCase()),s.indexOf(t))}e.indexOfPath=i;function u(s){const t=s.split(":");let c,_,v;for(const T of t){const U=Number(T);(0,M.isNumber)(U)?_===void 0?_=U:v===void 0&&(v=U):c=c?[c,T].join(":"):T}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:_!==void 0?_:void 0,column:v!==void 0?v:_!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(s,t,c=8){let _="";for(let T=0;T<c;T++)_+=n.charAt(Math.floor(Math.random()*n.length));let v;return t?v=`${t}-${_}`:v=_,s?(0,a.join)(s,v):v}e.randomPath=r}),define(Ce[24],Ie([1,0,16,9]),function(ie,e,a,p){"use strict";var w,M,y;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(n,r,s){let t=n.get(r);return t===void 0&&(t=s,n.set(r,t)),t}e.getOrSet=A;function b(n){const r=[];return n.forEach((s,t)=>{r.push(`${t} => ${s}`)}),`Map(${n.size}) {${r.join(", ")}}`}e.mapToString=b;function P(n){const r=[];return n.forEach(s=>{r.push(s)}),`Set(${n.size}) {${r.join(", ")}}`}e.setToString=P;class R{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),t=this._value.charCodeAt(this._pos);return s-t}value(){return this._value[this._pos]}}e.StringIterator=R;class S{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,p.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,p.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=S;class m{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let s=r.length-1;s>=0;s--,this._valueLen--){const t=this._value.charCodeAt(s);if(!(t===47||this._splitOnBackslash&&t===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,p.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,p.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var k;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(k||(k={}));class f{constructor(r,s){this._ignorePathCasing=r,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,p.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,p.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,p.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,p.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(d||(d={}));class o{constructor(r){this._iter=r}static forUris(r=()=>!1,s=()=>!1){return new o(new f(r,s))}static forPaths(r=!1){return new o(new m(void 0,!r))}static forStrings(){return new o(new R)}static forConfigKeys(){return new o(new S)}clear(){this._root=void 0}fill(r,s){if(s){const t=s.slice(0);(0,a.shuffle)(t);for(const c of t)this.set(c,r)}else{const t=r.slice(0);(0,a.shuffle)(t);for(const c of t)this.set(c[0],c[1])}}set(r,s){const t=this._iter.reset(r);let c;this._root||(this._root=new h,this._root.segment=t.value());const _=[];for(c=this._root;;){const T=t.cmp(c.segment);if(T>0)c.left||(c.left=new h,c.left.segment=t.value()),_.push([-1,c]),c=c.left;else if(T<0)c.right||(c.right=new h,c.right.segment=t.value()),_.push([1,c]),c=c.right;else if(t.hasNext())t.next(),c.mid||(c.mid=new h,c.mid.segment=t.value()),_.push([0,c]),c=c.mid;else break}const v=c.value;c.value=s,c.key=r;for(let T=_.length-1;T>=0;T--){const U=_[T][1];U.updateHeight();const V=U.balanceFactor();if(V<-1||V>1){const x=_[T][0],C=_[T+1][0];if(x===1&&C===1)_[T][1]=U.rotateLeft();else if(x===-1&&C===-1)_[T][1]=U.rotateRight();else if(x===1&&C===-1)U.right=_[T+1][1]=_[T+1][1].rotateRight(),_[T][1]=U.rotateLeft();else if(x===-1&&C===1)U.left=_[T+1][1]=_[T+1][1].rotateLeft(),_[T][1]=U.rotateRight();else throw new Error;if(T>0)switch(_[T-1][0]){case-1:_[T-1][1].left=_[T][1];break;case 1:_[T-1][1].right=_[T][1];break;case 0:_[T-1][1].mid=_[T][1];break}else this._root=_[0][1]}}return v}get(r){return this._getNode(r)?.value}_getNode(r){const s=this._iter.reset(r);let t=this._root;for(;t;){const c=s.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(s.hasNext())s.next(),t=t.mid;else break}return t}has(r){const s=this._getNode(r);return!(s?.value===void 0&&s?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const t=this._iter.reset(r),c=[];let _=this._root;for(;_;){const v=t.cmp(_.segment);if(v>0)c.push([-1,_]),_=_.left;else if(v<0)c.push([1,_]),_=_.right;else if(t.hasNext())t.next(),c.push([0,_]),_=_.mid;else break}if(!!_){if(s?(_.left=void 0,_.mid=void 0,_.right=void 0,_.height=1):(_.key=void 0,_.value=void 0),!_.mid&&!_.value)if(_.left&&_.right){const v=this._min(_.right),{key:T,value:U,segment:V}=v;this._delete(v.key,!1),_.key=T,_.value=U,_.segment=V}else{const v=_.left??_.right;if(c.length>0){const[T,U]=c[c.length-1];switch(T){case-1:U.left=v;break;case 0:U.mid=v;break;case 1:U.right=v;break}}else this._root=v}for(let v=c.length-1;v>=0;v--){const T=c[v][1];T.updateHeight();const U=T.balanceFactor();if(U>1?(T.right.balanceFactor()>=0||(T.right=T.right.rotateRight()),c[v][1]=T.rotateLeft()):U<-1&&(T.left.balanceFactor()<=0||(T.left=T.left.rotateLeft()),c[v][1]=T.rotateRight()),v>0)switch(c[v-1][0]){case-1:c[v-1][1].left=c[v][1];break;case 1:c[v-1][1].right=c[v][1];break;case 0:c[v-1][1].mid=c[v][1];break}else this._root=c[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const s=this._iter.reset(r);let t=this._root,c;for(;t;){const _=s.cmp(t.segment);if(_>0)t=t.left;else if(_<0)t=t.right;else if(s.hasNext())s.next(),c=t.value||c,t=t.mid;else break}return t&&t.value||c}findSuperstr(r){const s=this._iter.reset(r);let t=this._root;for(;t;){const c=s.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(s.hasNext())s.next(),t=t.mid;else return t.mid?this._entries(t.mid):void 0}}forEach(r){for(const[s,t]of this)r(t,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const s=[];return this._dfsEntries(r,s),s[Symbol.iterator]()}_dfsEntries(r,s){!r||(r.left&&this._dfsEntries(r.left,s),r.value&&s.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,s),r.right&&this._dfsEntries(r.right,s))}_isBalanced(){const r=s=>{if(!s)return!0;const t=s.balanceFactor();return t<-1||t>1?!1:r(s.left)&&r(s.right)};return r(this._root)}}e.TernarySearchTree=o;class g{constructor(r,s){this.uri=r,this.value=s}}class E{constructor(r,s){this[w]="ResourceMap",r instanceof E?(this.map=new Map(r.map),this.toKey=s??E.defaultToKey):(this.map=new Map,this.toKey=r??E.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),new g(r,s)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[t,c]of this.map)r(c.value,c.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}e.ResourceMap=E,E.defaultToKey=n=>n.toString();class l{constructor(r,s){this[M]="ResourceSet",!r||typeof r=="function"?this._map=new E(r):(this._map=new E(s),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,s){this._map.forEach((t,c)=>r.call(s,c,c,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=l;var D;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class i{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,s=0){const t=this._map.get(r);if(!!t)return s!==0&&this.touch(t,s),t.value}set(r,s,t=0){let c=this._map.get(r);if(c)c.value=s,t!==0&&this.touch(c,t);else{switch(c={key:r,value:s,next:void 0,previous:void 0},t){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(r,c),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const t=this._state;let c=this._head;for(;c;){if(s?r.bind(s)(c.value,c.key,this):r(c.value,c.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const r=this,s=this._state;let t=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const _={value:t.key,done:!1};return t=t.next,_}else return{value:void 0,done:!0}}};return c}values(){const r=this,s=this._state;let t=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const _={value:t.value,done:!1};return t=t.next,_}else return{value:void 0,done:!0}}};return c}entries(){const r=this,s=this._state;let t=this._head;const c={[Symbol.iterator](){return c},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const _={value:[t.key,t.value],done:!1};return t=t.next,_}else return{value:void 0,done:!0}}};return c}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,t=this.size;for(;s&&t>r;)this._map.delete(s.key),s=s.next,t--;this._head=s,this._size=t,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,t=r.previous;if(!s||!t)throw new Error("Invalid list");s.previous=t,t.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const t=r.next,c=r.previous;r===this._tail?(c.next=void 0,this._tail=c):(t.previous=c,c.next=t),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const t=r.next,c=r.previous;r===this._head?(t.previous=void 0,this._head=t):(t.previous=c,c.next=t),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,t)=>{r.push([t,s])}),r}fromJSON(r){this.clear();for(const[s,t]of r)this.set(s,t)}}e.LinkedMap=i;class u extends i{constructor(r,s=1){super(),this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u}),define(Ce[115],Ie([1,0,24,9]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...Q){return function(J,I){for(let z=0,W=Q.length;z<W;z++){const j=Q[z](J,I);if(j)return j}return null}}e.or=w,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(Q,J,I){if(!I||I.length<J.length)return null;let z;return Q?z=p.startsWithIgnoreCase(I,J):z=I.indexOf(J)===0,z?J.length>0?[{start:0,end:J.length}]:[]:null}function y(Q,J){const I=J.toLowerCase().indexOf(Q.toLowerCase());return I===-1?null:[{start:I,end:I+Q.length}]}e.matchesContiguousSubString=y;function A(Q,J){return b(Q.toLowerCase(),J.toLowerCase(),0,0)}e.matchesSubString=A;function b(Q,J,I,z){if(I===Q.length)return[];if(z===J.length)return null;if(Q[I]===J[z]){let W=null;return(W=b(Q,J,I+1,z+1))?o({start:z,end:z+1},W):null}return b(Q,J,I,z+1)}function P(Q){return 97<=Q&&Q<=122}function R(Q){return 65<=Q&&Q<=90}e.isUpper=R;function S(Q){return 48<=Q&&Q<=57}function m(Q){return Q===32||Q===9||Q===10||Q===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Q=>k.add(Q.charCodeAt(0)));function f(Q){return m(Q)||k.has(Q)}function h(Q,J){return Q===J||f(Q)&&f(J)}function d(Q){return P(Q)||R(Q)||S(Q)}function o(Q,J){return J.length===0?J=[Q]:Q.end===J[0].start?J[0].start=Q.start:J.unshift(Q),J}function g(Q,J){for(let I=J;I<Q.length;I++){const z=Q.charCodeAt(I);if(R(z)||S(z)||I>0&&!d(Q.charCodeAt(I-1)))return I}return Q.length}function E(Q,J,I,z){if(I===Q.length)return[];if(z===J.length)return null;if(Q[I]!==J[z].toLowerCase())return null;{let W=null,j=z+1;for(W=E(Q,J,I+1,z+1);!W&&(j=g(J,j))<J.length;)W=E(Q,J,I+1,j),j++;return W===null?null:o({start:z,end:z+1},W)}}function l(Q){let J=0,I=0,z=0,W=0,j=0;for(let ge=0;ge<Q.length;ge++)j=Q.charCodeAt(ge),R(j)&&J++,P(j)&&I++,d(j)&&z++,S(j)&&W++;const re=J/Q.length,de=I/Q.length,Z=z/Q.length,pe=W/Q.length;return{upperPercent:re,lowerPercent:de,alphaPercent:Z,numericPercent:pe}}function D(Q){const{upperPercent:J,lowerPercent:I}=Q;return I===0&&J>.6}function i(Q){const{upperPercent:J,lowerPercent:I,alphaPercent:z,numericPercent:W}=Q;return I>.2&&J<.8&&z>.6&&W<.2}function u(Q){let J=0,I=0,z=0,W=0;for(let j=0;j<Q.length;j++)z=Q.charCodeAt(j),R(z)&&J++,P(z)&&I++,m(z)&&W++;return(J===0||I===0)&&W===0?Q.length<=30:J<=5}function n(Q,J){if(!J||(J=J.trim(),J.length===0)||!u(Q)||J.length>60)return null;const I=l(J);if(!i(I)){if(!D(I))return null;J=J.toLowerCase()}let z=null,W=0;for(Q=Q.toLowerCase();W<J.length&&(z=E(Q,J,0,W))===null;)W=g(J,W+1);return z}e.matchesCamelCase=n;function r(Q,J,I=!1){if(!J||J.length===0)return null;let z=null,W=0;for(Q=Q.toLowerCase(),J=J.toLowerCase();W<J.length&&(z=s(Q,J,0,W,I))===null;)W=t(J,W+1);return z}e.matchesWords=r;function s(Q,J,I,z,W){if(I===Q.length)return[];if(z===J.length)return null;if(h(Q.charCodeAt(I),J.charCodeAt(z))){let j=null,re=z+1;if(j=s(Q,J,I+1,z+1,W),!W)for(;!j&&(re=t(J,re))<J.length;)j=s(Q,J,I+1,re,W),re++;return j?Q.charCodeAt(I)!==J.charCodeAt(z)?j:o({start:z,end:z+1},j):null}else return null}function t(Q,J){for(let I=J;I<Q.length;I++)if(f(Q.charCodeAt(I))||I>0&&f(Q.charCodeAt(I-1)))return I;return Q.length}const c=w(e.matchesPrefix,n,y),_=w(e.matchesPrefix,n,A),v=new a.LRUCache(1e4);function T(Q,J,I=!1){if(typeof Q!="string"||typeof J!="string")return null;let z=v.get(Q);z||(z=new RegExp(p.convertSimple2RegExpPattern(Q),"i"),v.set(Q,z));const W=z.exec(J);return W?[{start:W.index,end:W.index+W[0].length}]:I?_(Q,J):c(Q,J)}e.matchesFuzzy=T;function U(Q,J){const I=xe(Q,Q.toLowerCase(),0,J,J.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return I?x(I):null}e.matchesFuzzy2=U;function V(Q,J,I,z,W,j){const re=Math.min(13,Q.length);for(;I<re;I++){const de=xe(Q,J,I,z,W,j,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(de)return de}return[0,j]}e.anyScore=V;function x(Q){if(typeof Q>"u")return[];const J=[],I=Q[1];for(let z=Q.length-1;z>1;z--){const W=Q[z]+I,j=J[J.length-1];j&&j.end===W?j.end=W+1:J.push({start:W,end:W+1})}return J}e.createMatches=x;const C=128;function L(){const Q=[],J=[];for(let I=0;I<=C;I++)J[I]=0;for(let I=0;I<=C;I++)Q.push(J.slice(0));return Q}function B(Q){const J=[];for(let I=0;I<=Q;I++)J[I]=0;return J}const F=B(2*C),K=B(2*C),H=L(),O=L(),ee=L(),ue=!1;function oe(Q,J,I,z,W){function j(de,Z,pe=" "){for(;de.length<Z;)de=pe+de;return de}let re=` |   |${z.split("").map(de=>j(de,3)).join("|")}
`;for(let de=0;de<=I;de++)de===0?re+=" |":re+=`${J[de-1]}|`,re+=Q[de].slice(0,W+1).map(Z=>j(Z.toString(),3)).join("|")+`
`;return re}function le(Q,J,I,z){Q=Q.substr(J),I=I.substr(z),console.log(oe(O,Q,Q.length,I,I.length)),console.log(oe(ee,Q,Q.length,I,I.length)),console.log(oe(H,Q,Q.length,I,I.length))}function te(Q,J){if(J<0||J>=Q.length)return!1;const I=Q.codePointAt(J);switch(I){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!p.isEmojiImprecise(I)}}function Ee(Q,J){if(J<0||J>=Q.length)return!1;switch(Q.charCodeAt(J)){case 32:case 9:return!0;default:return!1}}function be(Q,J,I){return J[Q]!==I[Q]}function ne(Q,J,I,z,W,j,re=!1){for(;J<I&&W<j;)Q[J]===z[W]&&(re&&(F[J]=W),J+=1),W+=1;return J===I}e.isPatternInWord=ne;var ve;(function(Q){Q[Q.Diag=1]="Diag",Q[Q.Left=2]="Left",Q[Q.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Pe;(function(Q){Q.Default=[-100,0];function J(I){return!I||I.length===2&&I[0]===-100&&I[1]===0}Q.isDefault=J})(Pe=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(J,I){this.firstMatchCanBeWeak=J,this.boostFullMatch=I}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function xe(Q,J,I,z,W,j,re=Fe.default){const de=Q.length>C?C:Q.length,Z=z.length>C?C:z.length;if(I>=de||j>=Z||de-I>Z-j||!ne(J,I,de,W,j,Z,!0))return;Qe(de,Z,I,j,J,W);let pe=1,ge=1,Ne=I,Be=j;const Ye=[!1];for(pe=1,Ne=I;Ne<de;pe++,Ne++){const X=F[Ne],fe=K[Ne],Ue=Ne+1<de?K[Ne+1]:Z;for(ge=X-j+1,Be=X;Be<Ue;ge++,Be++){let He=Number.MIN_SAFE_INTEGER,Ze=!1;Be<=fe&&(He=ke(Q,J,Ne,I,z,W,Be,Z,j,H[pe-1][ge-1]===0,Ye));let je=0;He!==Number.MAX_SAFE_INTEGER&&(Ze=!0,je=He+O[pe-1][ge-1]);const We=Be>X,it=We?O[pe][ge-1]+(H[pe][ge-1]>0?-5:0):0,rt=Be>X+1&&H[pe][ge-1]>0,dt=rt?O[pe][ge-2]+(H[pe][ge-2]>0?-5:0):0;if(rt&&(!We||dt>=it)&&(!Ze||dt>=je))O[pe][ge]=dt,ee[pe][ge]=3,H[pe][ge]=0;else if(We&&(!Ze||it>=je))O[pe][ge]=it,ee[pe][ge]=2,H[pe][ge]=0;else if(Ze)O[pe][ge]=je,ee[pe][ge]=1,H[pe][ge]=H[pe-1][ge-1]+1;else throw new Error("not possible")}}if(ue&&le(Q,I,z,j),!Ye[0]&&!re.firstMatchCanBeWeak)return;pe--,ge--;const Xe=[O[pe][ge],j];let Te=0,nt=0;for(;pe>=1;){let X=ge;do{const fe=ee[pe][X];if(fe===3)X=X-2;else if(fe===2)X=X-1;else break}while(X>=1);Te>1&&J[I+pe-1]===W[j+ge-1]&&!be(X+j-1,z,W)&&Te+1>H[pe][X]&&(X=ge),X===ge?Te++:Te=1,nt||(nt=X),pe--,ge=X-1,Xe.push(ge)}Z===de&&re.boostFullMatch&&(Xe[0]+=2);const G=nt-de;return Xe[0]-=G,Xe}e.fuzzyScore=xe;function Qe(Q,J,I,z,W,j){let re=Q-1,de=J-1;for(;re>=I&&de>=z;)W[re]===j[de]&&(K[re]=de,re--),de--}function ke(Q,J,I,z,W,j,re,de,Z,pe,ge){if(J[I]!==j[re])return Number.MIN_SAFE_INTEGER;let Ne=1,Be=!1;return re===I-z?Ne=Q[I]===W[re]?7:5:be(re,W,j)&&(re===0||!be(re-1,W,j))?(Ne=Q[I]===W[re]?7:5,Be=!0):te(j,re)&&(re===0||!te(j,re-1))?Ne=5:(te(j,re-1)||Ee(j,re-1))&&(Ne=5,Be=!0),Ne>1&&I===z&&(ge[0]=!0),Be||(Be=be(re,W,j)||te(j,re-1)||Ee(j,re-1)),I===z?re>Z&&(Ne-=Be?3:5):pe?Ne+=Be?2:0:Ne+=Be?0:1,re+1===de&&(Ne-=Be?3:5),Ne}function Se(Q,J,I,z,W,j,re){return ae(Q,J,I,z,W,j,!0,re)}e.fuzzyScoreGracefulAggressive=Se;function ye(Q,J,I,z,W,j,re){return ae(Q,J,I,z,W,j,!1,re)}e.fuzzyScoreGraceful=ye;function ae(Q,J,I,z,W,j,re,de){let Z=xe(Q,J,I,z,W,j,de);if(Z&&!re)return Z;if(Q.length>=3){const pe=Math.min(7,Q.length-1);for(let ge=I+1;ge<pe;ge++){const Ne=ce(Q,ge);if(Ne){const Be=xe(Ne,Ne.toLowerCase(),I,z,W,j,de);Be&&(Be[0]-=3,(!Z||Be[0]>Z[0])&&(Z=Be))}}}return Z}function ce(Q,J){if(J+1>=Q.length)return;const I=Q[J],z=Q[J+1];if(I!==z)return Q.slice(0,J)+z+I+Q.slice(J+2)}}),define(Ce[116],Ie([1,0,117,115,9]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const M=new RegExp(`\\$\\(${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(a.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${M.source}`,"g");function b(d){return d.replace(A,(o,g)=>g?o:`\\${o}`)}e.escapeIcons=b;const P=new RegExp(`\\\\${M.source}`,"g");function R(d){return d.replace(P,o=>`\\${o}`)}e.markdownEscapeEscapedIcons=R;const S=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function m(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(S,(o,g,E,l)=>E?o:g||l||"")}e.stripIcons=m;function k(d){const o=d.indexOf(e.iconStartMarker);return o===-1?{text:d}:f(d,o)}e.parseLabelWithIcons=k;function f(d,o){const g=[];let E="";function l(c){if(c){E+=c;for(const _ of c)g.push(u)}}let D=-1,i="",u=0,n,r,s=o;const t=d.length;for(l(d.substr(0,o));s<t;)n=d[s],r=d[s+1],n===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(D=s,l(i),i=e.iconStartMarker,s++):n===")"&&D!==-1?(u+=s-D+1,D=-1,i=""):D!==-1?y.test(n)?i+=n:(l(i),D=-1,i=""):l(n),s++;return l(i),{text:E,iconOffsets:g}}function h(d,o,g=!1){const{text:E,iconOffsets:l}=o;if(!l||l.length===0)return(0,p.matchesFuzzy)(d,E,g);const D=(0,w.ltrim)(E," "),i=E.length-D.length,u=(0,p.matchesFuzzy)(d,D,g);if(u)for(const n of u){const r=l[n.start+i]+i;n.start+=r,n.end+=r}return u}e.matchesFuzzyIconAware=h}),define(Ce[29],Ie([1,0,9]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var p;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(p||(p={})),function(w){const M="error",y="warning",A="warn",b="info",P="ignore";function R(m){return m?a.equalsIgnoreCase(M,m)?w.Error:a.equalsIgnoreCase(y,m)||a.equalsIgnoreCase(A,m)?w.Warning:a.equalsIgnoreCase(b,m)?w.Info:w.Ignore:w.Ignore}w.fromValue=R;function S(m){switch(m){case w.Error:return M;case w.Warning:return y;case w.Info:return b;default:return P}}w.toString=S}(p||(p={})),e.default=p}),define(Ce[56],Ie([1,0,23,9,2]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(P){return JSON.stringify(P,A)}e.stringify=M;function y(P){let R=JSON.parse(P);return R=b(R),R}e.parse=y;function A(P,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,p.regExpFlags)(R)}:R}function b(P,R=0){if(!P||R>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return w.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof a.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let S=0;S<P.length;++S)P[S]=b(P[S],R+1);else for(const S in P)Object.hasOwnProperty.call(P,S)&&(P[S]=b(P[S],R+1))}return P}e.revive=b}),define(Ce[12],Ie([1,0,21,2]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var w;(function(A){A.inMemory="inmemory",A.vscode="vscode",A.internal="private",A.walkThrough="walkThrough",A.walkThroughSnippet="walkThroughSnippet",A.http="http",A.https="https",A.file="file",A.mailto="mailto",A.untitled="untitled",A.data="data",A.command="command",A.vscodeRemote="vscode-remote",A.vscodeRemoteResource="vscode-remote-resource",A.vscodeUserData="vscode-userdata",A.vscodeCustomEditor="vscode-custom-editor",A.vscodeNotebook="vscode-notebook",A.vscodeNotebookCell="vscode-notebook-cell",A.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",A.vscodeNotebookCellOutput="vscode-notebook-cell-output",A.vscodeInteractive="vscode-interactive",A.vscodeInteractiveInput="vscode-interactive-input",A.vscodeSettings="vscode-settings",A.vscodeWorkspaceTrust="vscode-workspace-trust",A.vscodeTerminal="vscode-terminal",A.webviewPanel="webview-panel",A.vscodeWebview="vscode-webview",A.extension="extension",A.vscodeFileResource="vscode-file",A.tmp="tmp",A.vsls="vsls",A.vscodeSourceControl="vscode-scm"})(w=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${w.vscodeRemoteResource}`}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}setServerRootPath(b){this._remoteResourcesPath=`${b}/${w.vscodeRemoteResource}`}set(b,P,R){this._hosts[b]=P,this._ports[b]=R}setConnectionToken(b,P){this._connectionTokens[b]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(b){if(this._delegate)return this._delegate(b);const P=b.authority;let R=this._hosts[P];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const S=this._ports[P],m=this._connectionTokens[P];let k=`path=${encodeURIComponent(b.path)}`;return typeof m=="string"&&(k+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),p.URI.from({scheme:a.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${R}:${S}`,path:this._remoteResourcesPath,query:k})}}e.RemoteAuthorities=new M;class y{asBrowserUri(b,P){const R=this.toUri(b,P);return R.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===w.file&&(a.isNative||a.isWebWorker&&a.globals.origin===`${w.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?R.with({scheme:w.vscodeFileResource,authority:R.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(b,P){const R=this.toUri(b,P);return R.scheme===w.vscodeFileResource?R.with({scheme:w.file,authority:R.authority!==y.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(b,P){return p.URI.isUri(b)?b:p.URI.parse(P.toUrl(b))}}y.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new y}),define(Ce[22],Ie([1,0,37,12,19,21,9,2]),function(ie,e,a,p,w,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(k){return(0,A.uriToFsPath)(k,!0)}e.originalFSPath=b;class P{constructor(f){this._ignorePathCasing=f}compare(f,h,d=!1){return f===h?0:(0,y.compare)(this.getComparisonKey(f,d),this.getComparisonKey(h,d))}isEqual(f,h,d=!1){return f===h?!0:!f||!h?!1:this.getComparisonKey(f,d)===this.getComparisonKey(h,d)}getComparisonKey(f,h=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,h,d=!1){if(f.scheme===h.scheme){if(f.scheme===p.Schemas.file)return a.isEqualOrParent(b(f),b(h),this._ignorePathCasing(f))&&f.query===h.query&&(d||f.fragment===h.fragment);if((0,e.isEqualAuthority)(f.authority,h.authority))return a.isEqualOrParent(f.path,h.path,this._ignorePathCasing(f),"/")&&f.query===h.query&&(d||f.fragment===h.fragment)}return!1}joinPath(f,...h){return A.URI.joinPath(f,...h)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return w.posix.basename(f.path)}extname(f){return w.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let h;return f.scheme===p.Schemas.file?h=A.URI.file(w.dirname(b(f))).path:(h=w.posix.dirname(f.path),f.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),h="/")),f.with({path:h})}normalizePath(f){if(!f.path.length)return f;let h;return f.scheme===p.Schemas.file?h=A.URI.file(w.normalize(b(f))).path:h=w.posix.normalize(f.path),f.with({path:h})}relativePath(f,h){if(f.scheme!==h.scheme||!(0,e.isEqualAuthority)(f.authority,h.authority))return;if(f.scheme===p.Schemas.file){const g=w.relative(b(f),b(h));return M.isWindows?a.toSlashes(g):g}let d=f.path||"/";const o=h.path||"/";if(this._ignorePathCasing(f)){let g=0;for(const E=Math.min(d.length,o.length);g<E&&!(d.charCodeAt(g)!==o.charCodeAt(g)&&d.charAt(g).toLowerCase()!==o.charAt(g).toLowerCase());g++);d=o.substr(0,g)+d.substr(g)}return w.posix.relative(d,o)}resolvePath(f,h){if(f.scheme===p.Schemas.file){const d=A.URI.file(w.resolve(b(f),h));return f.with({authority:d.authority,path:d.path})}return h=a.toPosixPath(h),f.with({path:w.posix.resolve(f.path,h)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,h){return f===h||f!==void 0&&h!==void 0&&(0,y.equalsIgnoreCase)(f,h)}hasTrailingPathSeparator(f,h=w.sep){if(f.scheme===p.Schemas.file){const d=b(f);return d.length>a.getRoot(d).length&&d[d.length-1]===h}else{const d=f.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,h=w.sep){return(0,e.hasTrailingPathSeparator)(f,h)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,h=w.sep){let d=!1;if(f.scheme===p.Schemas.file){const o=b(f);d=o!==void 0&&o.length===a.getRoot(o).length&&o[o.length-1]===h}else{h="/";const o=f.path;d=o.length===1&&o.charCodeAt(o.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(f,h)?f.with({path:f.path+"/"}):f}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(k=>k.scheme===p.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new P(k=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(k,f){const h=[];for(let d=0;d<k.length;d++){const o=f(k[d]);k.some((g,E)=>E===d?!1:(0,e.isEqualOrParent)(o,f(g)))||h.push(k[d])}return h}e.distinctParents=R;var S;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function f(h){const d=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(E=>{const[l,D]=E.split(":");l&&D&&d.set(l,D)});const g=h.path.substring(0,h.path.indexOf(";"));return g&&d.set(k.META_DATA_MIME,g),d}k.parseMetaData=f})(S=e.DataUri||(e.DataUri={}));function m(k,f,h){if(f){let d=k.path;return d&&d[0]!==w.posix.sep&&(d=w.posix.sep+d),k.with({scheme:h,authority:f,path:d})}return k.with({scheme:h})}e.toLocalResource=m}),define(Ce[14],Ie([1,0,20,11,5,7,22,21]),function(ie,e,a,p,w,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(be){return!!be&&typeof be.then=="function"}e.isThenable=b;function P(be){const ne=new a.CancellationTokenSource,ve=be(ne.token),Pe=new Promise((Fe,xe)=>{const Qe=ne.token.onCancellationRequested(()=>{Qe.dispose(),ne.dispose(),xe(new p.CancellationError)});Promise.resolve(ve).then(ke=>{Qe.dispose(),ne.dispose(),Fe(ke)},ke=>{Qe.dispose(),ne.dispose(),xe(ke)})});return new class{cancel(){ne.cancel()}then(Fe,xe){return Pe.then(Fe,xe)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Pe.finally(Fe)}}}e.createCancelablePromise=P;function R(be,ne,ve){return new Promise((Pe,Fe)=>{const xe=ne.onCancellationRequested(()=>{xe.dispose(),Pe(ve)});be.then(Pe,Fe).finally(()=>xe.dispose())})}e.raceCancellation=R;function S(be,ne){return new Promise((ve,Pe)=>{const Fe=ne.onCancellationRequested(()=>{Fe.dispose(),Pe(new p.CancellationError)});be.then(ve,Pe).finally(()=>Fe.dispose())})}e.raceCancellationError=S;async function m(be){let ne=-1;const ve=be.map((Fe,xe)=>Fe.then(Qe=>(ne=xe,Qe))),Pe=await Promise.race(ve);return be.forEach((Fe,xe)=>{xe!==ne&&Fe.cancel()}),Pe}e.raceCancellablePromises=m;function k(be,ne,ve){let Pe;const Fe=setTimeout(()=>{Pe?.(void 0),ve?.()},ne);return Promise.race([be.finally(()=>clearTimeout(Fe)),new Promise(xe=>Pe=xe)])}e.raceTimeout=k;function f(be){return new Promise((ne,ve)=>{const Pe=be();b(Pe)?Pe.then(ne,ve):ne(Pe)})}e.asPromise=f;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ne){if(this.activePromise){if(this.queuedPromiseFactory=ne,!this.queuedPromise){const ve=()=>{this.queuedPromise=null;const Pe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Pe};this.queuedPromise=new Promise(Pe=>{this.activePromise.then(ve,ve).then(Pe)})}return new Promise((ve,Pe)=>{this.queuedPromise.then(ve,Pe)})}return this.activePromise=ne(),new Promise((ve,Pe)=>{this.activePromise.then(Fe=>{this.activePromise=null,ve(Fe)},Fe=>{this.activePromise=null,Pe(Fe)})})}}e.Throttler=h;class d{constructor(){this.current=Promise.resolve(null)}queue(ne){return this.current=this.current.then(()=>ne(),()=>ne())}}e.Sequencer=d;class o{constructor(){this.promiseMap=new Map}queue(ne,ve){const Fe=(this.promiseMap.get(ne)??Promise.resolve()).catch(()=>{}).then(ve).finally(()=>{this.promiseMap.get(ne)===Fe&&this.promiseMap.delete(ne)});return this.promiseMap.set(ne,Fe),Fe}}e.SequencerByKey=o;const g=(be,ne)=>{let ve=!0;const Pe=setTimeout(()=>{ve=!1,ne()},be);return{isTriggered:()=>ve,dispose:()=>{clearTimeout(Pe),ve=!1}}},E=be=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,be())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(ne){this.defaultDelay=ne,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ne,ve=this.defaultDelay){this.task=ne,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,xe)=>{this.doResolve=Fe,this.doReject=xe}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Pe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ve===e.MicrotaskDelay?E(Pe):g(ve,Pe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new p.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class D{constructor(ne){this.delayer=new l(ne),this.throttler=new h}trigger(ne,ve){return this.delayer.trigger(()=>this.throttler.queue(ne),ve)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=D;class i{constructor(){this._isOpen=!1,this._promise=new Promise((ne,ve)=>{this._completePromise=ne})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=i;class u extends i{constructor(ne){super(),this._timeout=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function n(be,ne){return ne?new Promise((ve,Pe)=>{const Fe=setTimeout(()=>{xe.dispose(),ve()},be),xe=ne.onCancellationRequested(()=>{clearTimeout(Fe),xe.dispose(),Pe(new p.CancellationError)})}):P(ve=>n(be,ve))}e.timeout=n;function r(be,ne=0){const ve=setTimeout(be,ne);return(0,M.toDisposable)(()=>clearTimeout(ve))}e.disposableTimeout=r;function s(be){const ne=[];let ve=0;const Pe=be.length;function Fe(){return ve<Pe?be[ve++]():null}function xe(Qe){Qe!=null&&ne.push(Qe);const ke=Fe();return ke?ke.then(xe):Promise.resolve(ne)}return Promise.resolve(null).then(xe)}e.sequence=s;function t(be,ne=Pe=>!!Pe,ve=null){let Pe=0;const Fe=be.length,xe=()=>{if(Pe>=Fe)return Promise.resolve(ve);const Qe=be[Pe++];return Promise.resolve(Qe()).then(Se=>ne(Se)?Promise.resolve(Se):xe())};return xe()}e.first=t;function c(be,ne=Pe=>!!Pe,ve=null){if(be.length===0)return Promise.resolve(ve);let Pe=be.length;const Fe=()=>{Pe=-1;for(const xe of be)xe.cancel?.()};return new Promise((xe,Qe)=>{for(const ke of be)ke.then(Se=>{--Pe>=0&&ne(Se)?(Fe(),xe(Se)):Pe===0&&xe(ve)}).catch(Se=>{--Pe>=0&&(Fe(),Qe(Se))})})}e.firstParallel=c;class _{constructor(ne){this._size=0,this.maxDegreeOfParalellism=ne,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new w.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ne){return this._size++,new Promise((ve,Pe)=>{this.outstandingPromises.push({factory:ne,c:ve,e:Pe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ne=this.outstandingPromises.shift();this.runningPromises++;const ve=ne.factory();ve.then(ne.c,ne.e),ve.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=_;class v extends _{constructor(){super(1)}}e.Queue=v;class T{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ne=new ee;return this.drainers.add(ne),ne.p}isDrained(){for(const[,ne]of this.queues)if(ne.size>0)return!1;return!0}queueFor(ne,ve=y.extUri){const Pe=ve.getComparisonKey(ne);let Fe=this.queues.get(Pe);return Fe||(Fe=new v,w.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(Pe),this.onDidQueueDrain()}),this.queues.set(Pe,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ne of this.drainers)ne.complete();this.drainers.clear()}dispose(){for(const[,ne]of this.queues)ne.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=T;class U{constructor(ne,ve){this._token=-1,typeof ne=="function"&&typeof ve=="number"&&this.setIfNotSet(ne,ve)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ne,ve){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ne()},ve)}setIfNotSet(ne,ve){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ne()},ve))}}e.TimeoutTimer=U;class V{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ne,ve){this.cancel(),this._token=setInterval(()=>{ne()},ve)}}e.IntervalTimer=V;class x{constructor(ne,ve){this.timeoutToken=-1,this.runner=ne,this.timeout=ve,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ne=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ne)}get delay(){return this.timeout}set delay(ne){this.timeout=ne}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=x;class C{constructor(ne,ve){ve%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ve}ms is not a multiple of 1000ms.`),this.runner=ne,this.timeout=ve,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ne=this.timeout){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ne/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=C;class L extends x{constructor(ne,ve){super(ne,ve),this.units=[]}work(ne){this.units.push(ne),this.isScheduled()||this.schedule()}doRun(){const ne=this.units;this.units=[],this.runner?.(ne)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L;class B extends M.Disposable{constructor(ne,ve){super(),this.options=ne,this.handler=ve,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ne){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ne.length>this.options.maxBufferedWork)return!1}else if(this.pending+ne.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ne),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new x(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=be=>{(0,A.setTimeout0)(()=>{if(ne)return;const ve=Date.now()+15;be(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let ne=!1;return{dispose(){ne||(ne=!0)}}}:e.runWhenIdle=(be,ne)=>{const ve=requestIdleCallback(be,typeof ne=="number"?{timeout:ne}:void 0);let Pe=!1;return{dispose(){Pe||(Pe=!0,cancelIdleCallback(ve))}}}}();class F{constructor(ne){this._didRun=!1,this._executor=()=>{try{this._value=ne()}catch(ve){this._error=ve}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=F;async function K(be,ne,ve){let Pe;for(let Fe=0;Fe<ve;Fe++)try{return await be()}catch(xe){Pe=xe,await n(ne)}throw Pe}e.retry=K;class H{hasPending(ne){return this._pending?typeof ne=="number"?this._pending.taskId===ne:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(ne,ve,Pe){return this._pending={taskId:ne,cancel:()=>Pe?.(),promise:ve},ve.then(()=>this.donePending(ne),()=>this.donePending(ne)),ve}donePending(ne){this._pending&&ne===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ne=this._next;this._next=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}setNext(ne){if(this._next)this._next.run=ne;else{let ve,Pe;const Fe=new Promise((xe,Qe)=>{ve=xe,Pe=Qe});this._next={run:ne,promise:Fe,promiseResolve:ve,promiseReject:Pe}}return this._next.promise}}e.TaskSequentializer=H;class O{constructor(ne,ve=()=>Date.now()){this.interval=ne,this.nowFn=ve,this.lastIncrementTime=0,this.value=0}increment(){const ne=this.nowFn();return ne-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ne,this.value=0),this.value++,this.value}}e.IntervalCounter=O;class ee{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ne,ve)=>{this.completeCallback=ne,this.errorCallback=ve})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ne){return new Promise(ve=>{this.completeCallback(ne),this.resolved=!0,ve()})}error(ne){return new Promise(ve=>{this.errorCallback(ne),this.rejected=!0,ve()})}cancel(){new Promise(ne=>{this.errorCallback(new p.CancellationError),this.rejected=!0,ne()})}}e.DeferredPromise=ee;var ue;(function(be){async function ne(Pe){let Fe;const xe=await Promise.all(Pe.map(Qe=>Qe.then(ke=>ke,ke=>{Fe||(Fe=ke)})));if(typeof Fe<"u")throw Fe;return xe}be.settled=ne;function ve(Pe){return new Promise(async(Fe,xe)=>{try{await Pe(Fe,xe)}catch(Qe){xe(Qe)}})}be.withAsyncBody=ve})(ue=e.Promises||(e.Promises={}));var oe;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(oe||(oe={}));class le{constructor(ne){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const ve={emitOne:Pe=>this.emitOne(Pe),emitMany:Pe=>this.emitMany(Pe),reject:Pe=>this.reject(Pe)};try{await Promise.resolve(ne(ve)),this.resolve()}catch(Pe){this.reject(Pe)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}static fromArray(ne){return new le(ve=>{ve.emitMany(ne)})}static fromPromise(ne){return new le(async ve=>{ve.emitMany(await ne)})}static fromPromises(ne){return new le(async ve=>{await Promise.all(ne.map(async Pe=>ve.emitOne(await Pe)))})}static merge(ne){return new le(async ve=>{await Promise.all(ne.map(async Pe=>{for await(const Fe of Pe)ve.emitOne(Fe)}))})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ne<this._results.length)return{done:!1,value:this._results[ne++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ne,ve){return new le(async Pe=>{for await(const Fe of ne)Pe.emitOne(ve(Fe))})}map(ne){return le.map(this,ne)}static filter(ne,ve){return new le(async Pe=>{for await(const Fe of ne)ve(Fe)&&Pe.emitOne(Fe)})}filter(ne){return le.filter(this,ne)}static coalesce(ne){return le.filter(ne,ve=>!!ve)}coalesce(){return le.coalesce(this)}static async toPromise(ne){const ve=[];for await(const Pe of ne)ve.push(Pe);return ve}toPromise(){return le.toPromise(this)}emitOne(ne){this._state===0&&(this._results.push(ne),this._onStateChanged.fire())}emitMany(ne){this._state===0&&(this._results=this._results.concat(ne),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ne){this._state===0&&(this._state=2,this._error=ne,this._onStateChanged.fire())}}e.AsyncIterableObject=le,le.EMPTY=le.fromArray([]);class te extends le{constructor(ne,ve){super(ve),this._source=ne}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=te;function Ee(be){const ne=new a.CancellationTokenSource,ve=be(ne.token);return new te(ne,async Pe=>{const Fe=ne.token.onCancellationRequested(()=>{Fe.dispose(),ne.dispose(),Pe.reject(new p.CancellationError)});try{for await(const xe of ve){if(ne.token.isCancellationRequested)return;Pe.emitOne(xe)}Fe.dispose(),ne.dispose()}catch(xe){Fe.dispose(),ne.dispose(),Pe.reject(xe)}})}e.createCancelableAsyncIterable=Ee}),define(Ce[118],Ie([1,0,14,19]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const w=new a.IdleValue(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),M=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new a.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(v,T,U=!1){const V=v||"",x=T||"",C=w.value.collator.compare(V,x);return w.value.collatorIsNumeric&&C===0&&V!==x?V<x?-1:1:C}e.compareFileNames=A;function b(v,T){const U=M.value.collator;return v=v||"",T=T||"",D(U,v,T)}e.compareFileNamesDefault=b;function P(v,T){const U=M.value.collator;return v=v||"",T=T||"",r(v,T)||D(U,v,T)}e.compareFileNamesUpper=P;function R(v,T){const U=M.value.collator;return v=v||"",T=T||"",n(v,T)||D(U,v,T)}e.compareFileNamesLower=R;function S(v,T){return v=v||"",T=T||"",v===T?0:v<T?-1:1}e.compareFileNamesUnicode=S;function m(v,T,U=!1){U||(v=v&&v.toLowerCase(),T=T&&T.toLowerCase());const[V,x]=E(v),[C,L]=E(T);return V!==C?V<C?-1:1:x===L?0:x<L?-1:1}e.noIntlCompareFileNames=m;function k(v,T){const[U,V]=E(v),[x,C]=E(T);let L=w.value.collator.compare(V,C);if(L===0){if(w.value.collatorIsNumeric&&V!==C)return V<C?-1:1;if(L=w.value.collator.compare(U,x),w.value.collatorIsNumeric&&L===0&&U!==x)return U<x?-1:1}return L}e.compareFileExtensions=k;function f(v,T){v=v||"",T=T||"";const U=l(v),V=l(T),x=M.value.collator,C=y.value.collator;return D(C,U,V)||D(x,v,T)}e.compareFileExtensionsDefault=f;function h(v,T){v=v||"",T=T||"";const U=l(v),V=l(T),x=M.value.collator,C=y.value.collator;return D(C,U,V)||r(v,T)||D(x,v,T)}e.compareFileExtensionsUpper=h;function d(v,T){v=v||"",T=T||"";const U=l(v),V=l(T),x=M.value.collator,C=y.value.collator;return D(C,U,V)||n(v,T)||D(x,v,T)}e.compareFileExtensionsLower=d;function o(v,T){v=v||"",T=T||"";const U=l(v).toLowerCase(),V=l(T).toLowerCase();return U!==V?U<V?-1:1:v!==T?v<T?-1:1:0}e.compareFileExtensionsUnicode=o;const g=/^(.*?)(\.([^.]*))?$/;function E(v,T=!1){const U=v?g.exec(v):[];let V=[U&&U[1]||"",U&&U[3]||""];return T&&(!V[0]&&V[1]||V[0]&&V[0].charAt(0)===".")&&(V=[V[0]+"."+V[1],""]),V}function l(v){const T=v?g.exec(v):[];return T&&T[1]&&T[1].charAt(0)!=="."&&T[3]||""}function D(v,T,U){const V=v.compare(T,U);return V!==0?V:T.length!==U.length?T.length<U.length?-1:1:0}function i(v){const T=v.charAt(0);return T.toLocaleUpperCase()!==T}function u(v){const T=v.charAt(0);return T.toLocaleLowerCase()!==T}function n(v,T){return i(v)&&u(T)?-1:u(v)&&i(T)?1:0}function r(v,T){return u(v)&&i(T)?-1:i(v)&&u(T)?1:0}function s(v,T,U=!1){return U||(v=v&&v.toLowerCase(),T=T&&T.toLowerCase()),v===T?0:v<T?-1:1}function t(v,T,U=!1){const V=v.split(p.sep),x=T.split(p.sep),C=V.length-1,L=x.length-1;let B,F;for(let K=0;;K++){if(B=C===K,F=L===K,B&&F)return A(V[K],x[K],U);if(B)return-1;if(F)return 1;const H=s(V[K],x[K],U);if(H!==0)return H}}e.comparePaths=t;function c(v,T,U){const V=v.toLowerCase(),x=T.toLowerCase(),C=_(v,T,U);if(C)return C;const L=V.endsWith(U),B=x.endsWith(U);if(L!==B)return L?-1:1;const F=A(V,x);return F!==0?F:V.localeCompare(x)}e.compareAnything=c;function _(v,T,U){const V=v.toLowerCase(),x=T.toLowerCase(),C=V.startsWith(U),L=x.startsWith(U);if(C!==L)return C?-1:1;if(C&&L){if(V.length<x.length)return-1;if(V.length>x.length)return 1}return 0}e.compareByPrefix=_}),define(Ce[34],Ie([1,0,16,14,37,24,19,21,9]),function(ie,e,a,p,w,M,y,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",S="[^/\\\\]",m=/\//g;function k(ee,ue){switch(ee){case 0:return"";case 1:return`${S}*?`;default:return`(?:${R}|${S}+${R}${ue?`|${R}${S}+`:""})*?`}}function f(ee,ue){if(!ee)return[];const oe=[];let le=!1,te=!1,Ee="";for(const be of ee){switch(be){case ue:if(!le&&!te){oe.push(Ee),Ee="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":te=!0;break;case"]":te=!1;break}Ee+=be}return Ee&&oe.push(Ee),oe}e.splitGlobAware=f;function h(ee){if(!ee)return"";let ue="";const oe=f(ee,e.GLOB_SPLIT);if(oe.every(le=>le===e.GLOBSTAR))ue=".*";else{let le=!1;oe.forEach((te,Ee)=>{if(te===e.GLOBSTAR){if(le)return;ue+=k(2,Ee===oe.length-1)}else{let be=!1,ne="",ve=!1,Pe="";for(const Fe of te){if(Fe!=="}"&&be){ne+=Fe;continue}if(ve&&(Fe!=="]"||!Pe)){let xe;Fe==="-"?xe=Fe:(Fe==="^"||Fe==="!")&&!Pe?xe="^":Fe===e.GLOB_SPLIT?xe="":xe=(0,b.escapeRegExpCharacters)(Fe),Pe+=xe;continue}switch(Fe){case"{":be=!0;continue;case"[":ve=!0;continue;case"}":{ue+=`(?:${f(ne,",").map(ke=>h(ke)).join("|")})`,be=!1,ne="";break}case"]":{ue+="["+Pe+"]",ve=!1,Pe="";break}case"?":ue+=S;continue;case"*":ue+=k(1);continue;default:ue+=(0,b.escapeRegExpCharacters)(Fe)}}Ee<oe.length-1&&(oe[Ee+1]!==e.GLOBSTAR||Ee+2<oe.length)&&(ue+=R)}le=te===e.GLOBSTAR})}return ue}const d=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,E=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.LRUCache(1e4),u=function(){return!1},n=function(){return null};function r(ee,ue){if(!ee)return n;let oe;typeof ee!="string"?oe=ee.pattern:oe=ee,oe=oe.trim();const le=`${oe}_${!!ue.trimForExclusions}`;let te=i.get(le);if(te)return s(te,ee);let Ee;return d.test(oe)?te=c(oe.substr(4),oe):(Ee=o.exec(t(oe,ue)))?te=_(Ee[1],oe):(ue.trimForExclusions?E:g).test(oe)?te=v(oe,ue):(Ee=l.exec(t(oe,ue)))?te=T(Ee[1].substr(1),oe,!0):(Ee=D.exec(t(oe,ue)))?te=T(Ee[1],oe,!1):te=U(oe),i.set(le,te),s(te,ee)}function s(ee,ue){if(typeof ue=="string")return ee;const oe=function(le,te){return(0,w.isEqualOrParent)(le,ue.base,!A.isLinux)?ee(le.substr(ue.base.length+1),te):null};return oe.allBasenames=ee.allBasenames,oe.allPaths=ee.allPaths,oe.basenames=ee.basenames,oe.patterns=ee.patterns,oe}function t(ee,ue){return ue.trimForExclusions&&ee.endsWith("/**")?ee.substr(0,ee.length-2):ee}function c(ee,ue){return function(oe,le){return typeof oe=="string"&&oe.endsWith(ee)?ue:null}}function _(ee,ue){const oe=`/${ee}`,le=`\\${ee}`,te=function(be,ne){return typeof be!="string"?null:ne?ne===ee?ue:null:be===ee||be.endsWith(oe)||be.endsWith(le)?ue:null},Ee=[ee];return te.basenames=Ee,te.patterns=[ue],te.allBasenames=Ee,te}function v(ee,ue){const oe=H(ee.slice(1,-1).split(",").map(ne=>r(ne,ue)).filter(ne=>ne!==n),ee),le=oe.length;if(!le)return n;if(le===1)return oe[0];const te=function(ne,ve){for(let Pe=0,Fe=oe.length;Pe<Fe;Pe++)if(oe[Pe](ne,ve))return ee;return null},Ee=oe.find(ne=>!!ne.allBasenames);Ee&&(te.allBasenames=Ee.allBasenames);const be=oe.reduce((ne,ve)=>ve.allPaths?ne.concat(ve.allPaths):ne,[]);return be.length&&(te.allPaths=be),te}function T(ee,ue,oe){const le=y.sep===y.posix.sep,te=le?ee:ee.replace(m,y.sep),Ee=y.sep+te,be=y.posix.sep+ee;let ne;return oe?ne=function(ve,Pe){return typeof ve=="string"&&(ve===te||ve.endsWith(Ee)||!le&&(ve===ee||ve.endsWith(be)))?ue:null}:ne=function(ve,Pe){return typeof ve=="string"&&(ve===te||!le&&ve===ee)?ue:null},ne.allPaths=[(oe?"*/":"./")+ee],ne}function U(ee){try{const ue=new RegExp(`^${h(ee)}$`);return function(oe){return ue.lastIndex=0,typeof oe=="string"&&ue.test(oe)?ee:null}}catch{return n}}function V(ee,ue,oe){return!ee||typeof ue!="string"?!1:x(ee)(ue,void 0,oe)}e.match=V;function x(ee,ue={}){if(!ee)return u;if(typeof ee=="string"||C(ee)){const oe=r(ee,ue);if(oe===n)return u;const le=function(te,Ee){return!!oe(te,Ee)};return oe.allBasenames&&(le.allBasenames=oe.allBasenames),oe.allPaths&&(le.allPaths=oe.allPaths),le}return F(ee,ue)}e.parse=x;function C(ee){const ue=ee;return ue?typeof ue.base=="string"&&typeof ue.pattern=="string":!1}e.isRelativePattern=C;function L(ee){return ee.allBasenames||[]}e.getBasenameTerms=L;function B(ee){return ee.allPaths||[]}e.getPathTerms=B;function F(ee,ue){const oe=H(Object.getOwnPropertyNames(ee).map(ne=>K(ne,ee[ne],ue)).filter(ne=>ne!==n)),le=oe.length;if(!le)return n;if(!oe.some(ne=>!!ne.requiresSiblings)){if(le===1)return oe[0];const ne=function(Fe,xe){let Qe;for(let ke=0,Se=oe.length;ke<Se;ke++){const ye=oe[ke](Fe,xe);if(typeof ye=="string")return ye;(0,p.isThenable)(ye)&&(Qe||(Qe=[]),Qe.push(ye))}return Qe?(async()=>{for(const ke of Qe){const Se=await ke;if(typeof Se=="string")return Se}return null})():null},ve=oe.find(Fe=>!!Fe.allBasenames);ve&&(ne.allBasenames=ve.allBasenames);const Pe=oe.reduce((Fe,xe)=>xe.allPaths?Fe.concat(xe.allPaths):Fe,[]);return Pe.length&&(ne.allPaths=Pe),ne}const te=function(ne,ve,Pe){let Fe,xe;for(let Qe=0,ke=oe.length;Qe<ke;Qe++){const Se=oe[Qe];Se.requiresSiblings&&Pe&&(ve||(ve=(0,y.basename)(ne)),Fe||(Fe=ve.substr(0,ve.length-(0,y.extname)(ne).length)));const ye=Se(ne,ve,Fe,Pe);if(typeof ye=="string")return ye;(0,p.isThenable)(ye)&&(xe||(xe=[]),xe.push(ye))}return xe?(async()=>{for(const Qe of xe){const ke=await Qe;if(typeof ke=="string")return ke}return null})():null},Ee=oe.find(ne=>!!ne.allBasenames);Ee&&(te.allBasenames=Ee.allBasenames);const be=oe.reduce((ne,ve)=>ve.allPaths?ne.concat(ve.allPaths):ne,[]);return be.length&&(te.allPaths=be),te}function K(ee,ue,oe){if(ue===!1)return n;const le=r(ee,oe);if(le===n)return n;if(typeof ue=="boolean")return le;if(ue){const te=ue.when;if(typeof te=="string"){const Ee=(be,ne,ve,Pe)=>{if(!Pe||!le(be,ne))return null;const Fe=te.replace("$(basename)",ve),xe=Pe(Fe);return(0,p.isThenable)(xe)?xe.then(Qe=>Qe?ee:null):xe?ee:null};return Ee.requiresSiblings=!0,Ee}}return le}function H(ee,ue){const oe=ee.filter(ne=>!!ne.basenames);if(oe.length<2)return ee;const le=oe.reduce((ne,ve)=>{const Pe=ve.basenames;return Pe?ne.concat(Pe):ne},[]);let te;if(ue){te=[];for(let ne=0,ve=le.length;ne<ve;ne++)te.push(ue)}else te=oe.reduce((ne,ve)=>{const Pe=ve.patterns;return Pe?ne.concat(Pe):ne},[]);const Ee=function(ne,ve){if(typeof ne!="string")return null;if(!ve){let Fe;for(Fe=ne.length;Fe>0;Fe--){const xe=ne.charCodeAt(Fe-1);if(xe===47||xe===92)break}ve=ne.substr(Fe)}const Pe=le.indexOf(ve);return Pe!==-1?te[Pe]:null};Ee.basenames=le,Ee.patterns=te,Ee.allBasenames=le;const be=ee.filter(ne=>!ne.basenames);return be.push(Ee),be}function O(ee,ue){return(0,a.equals)(ee,ue,(oe,le)=>typeof oe=="string"&&typeof le=="string"?oe===le:typeof oe!="string"&&typeof le!="string"?oe.base===le.base&&oe.pattern===le.pattern:!1)}e.patternsEquals=O}),define(Ce[75],Ie([1,0,11,116,22,9,2]),function(ie,e,a,p,w,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class b{constructor(o="",g=!1){if(this.value=o,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(o,g=0){return this.value+=m(this.supportThemeIcons?(0,p.escapeIcons)(o):o).replace(/([ \t]+)/g,(E,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,g){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(o,g,E){return this.value+="[",this.value+=this._escape(g,"]"),this.value+="](",this.value+=this._escape(String(o),")"),E&&(this.value+=` "${this._escape(this._escape(E,'"'),")")}"`),this.value+=")",this}_escape(o,g){const E=new RegExp((0,M.escapeRegExpCharacters)(g),"g");return o.replace(E,(l,D)=>o.charAt(D-1)!=="\\"?`\\${l}`:l)}}e.MarkdownString=b;function P(d){return R(d)?!d.value:Array.isArray(d)?d.every(P):!0}e.isEmptyMarkdownString=P;function R(d){return d instanceof b?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function S(d,o){return d===o?!0:!d||!o?!1:d.value===o.value&&d.isTrusted===o.isTrusted&&d.supportThemeIcons===o.supportThemeIcons&&d.supportHtml===o.supportHtml&&(d.baseUri===o.baseUri||!!d.baseUri&&!!o.baseUri&&(0,w.isEqual)(y.URI.from(d.baseUri),y.URI.from(o.baseUri)))}e.markdownStringEqual=S;function m(d){return d.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function k(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=k;function f(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function h(d){const o=[],g=d.split("|").map(l=>l.trim());d=g[0];const E=g[1];if(E){const l=/height=(\d+)/.exec(E),D=/width=(\d+)/.exec(E),i=l?l[1]:"",u=D?D[1]:"",n=isFinite(parseInt(u)),r=isFinite(parseInt(i));n&&o.push(`width="${u}"`),r&&o.push(`height="${i}"`)}return{href:d,dimensions:o}}e.parseHrefAndDimensions=h}),define(Ce[76],Ie([1,0,16,37,19,21,22,9]),function(ie,e,a,p,w,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function b(n,r){const{os:s,tildify:t,relative:c}=r;if(c){const T=P(n,c,s);if(typeof T=="string")return T}let _=n.fsPath;if(s===1&&!M.isWindows?_=_.replace(/\//g,"\\"):s!==1&&M.isWindows&&(_=_.replace(/\\/g,"/")),s!==1&&t?.userHome){const T=t.userHome.fsPath;let U;n.scheme!==t.userHome.scheme&&n.path.startsWith(w.posix.sep)?U=t.userHome.with({path:n.path}).fsPath:U=n.fsPath,_=m(U,T,s)}return(s===1?w.win32:w.posix).normalize(R(_,s===1))}e.getPathLabel=b;function P(n,r,s){const t=s===1?w.win32:w.posix,c=s===3?y.extUri:y.extUriIgnorePathCase,_=r.getWorkspace(),v=(0,a.firstOrDefault)(_.folders);if(!v)return;n.scheme!==v.uri.scheme&&n.path.startsWith(w.posix.sep)&&(n=v.uri.with({path:n.path}));const T=r.getWorkspaceFolder(n);if(!T)return;let U;if(c.isEqual(T.uri,n)?U="":U=c.relativePath(T.uri,n)??"",U&&(U=t.normalize(U)),_.folders.length>1&&!r.noPrefix){const V=T.name?T.name:c.basenameOrAuthority(T.uri);U=U?`${V} \u2022 ${U}`:V}return U}function R(n,r=M.isWindows){return(0,p.hasDriveLetter)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=R;let S=Object.create(null);function m(n,r,s=M.OS){if(s===1||!n||!r)return n;let t=S.original===r?S.normalized:void 0;t||(t=r,M.isWindows&&(t=(0,p.toSlashes)(t)),t=`${(0,A.rtrim)(t,w.posix.sep)}${w.posix.sep}`,S={original:r,normalized:t});let c=n;return M.isWindows&&(c=(0,p.toSlashes)(c)),(s===3?c.startsWith(t):(0,A.startsWithIgnoreCase)(c,t))?`~/${c.substr(t.length)}`:n}e.tildify=m;function k(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=k;const f="\u2026",h="\\\\",d="~";function o(n,r=w.sep){const s=new Array(n.length);let t=!1;for(let c=0;c<n.length;c++){const _=n[c];if(_===""){s[c]=`.${r}`;continue}if(!_){s[c]=_;continue}t=!0;let v="",T=_;T.indexOf(h)===0?(v=T.substr(0,T.indexOf(h)+h.length),T=T.substr(T.indexOf(h)+h.length)):T.indexOf(r)===0?(v=T.substr(0,T.indexOf(r)+r.length),T=T.substr(T.indexOf(r)+r.length)):T.indexOf(d)===0&&(v=T.substr(0,T.indexOf(d)+d.length),T=T.substr(T.indexOf(d)+d.length));const U=T.split(r);for(let V=1;t&&V<=U.length;V++)for(let x=U.length-V;t&&x>=0;x--){t=!1;let C=U.slice(x,x+V).join(r);for(let L=0;!t&&L<n.length;L++)if(L!==c&&n[L]&&n[L].indexOf(C)>-1){const B=x+V===U.length,F=x>0&&n[L].indexOf(r)>-1?r+C:C,K=n[L].endsWith(F);t=!B||K}if(!t){let L="";(U[0].endsWith(":")||v!=="")&&(x===1&&(x=0,V++,C=U[0]+r+C),x>0&&(L=U[0]+r),L=v+L),x>0&&(L=L+f+r),L=L+C,x+V<U.length&&(L=L+r+f),s[c]=L}}t&&(s[c]=_)}return s}e.shorten=o;var g;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function E(n,r=Object.create(null)){const s=[];let t=!1,c="";for(const _ of n)if(_==="$"||t&&_==="{")c&&s.push({value:c,type:g.TEXT}),c="",t=!0;else if(_==="}"&&t){const v=r[c];if(typeof v=="string")v.length&&s.push({value:v,type:g.VARIABLE});else if(v){const T=s[s.length-1];(!T||T.type!==g.SEPARATOR)&&s.push({value:v.label,type:g.SEPARATOR})}c="",t=!1}else c+=_;return c&&!t&&s.push({value:c,type:g.TEXT}),s.filter((_,v)=>{if(_.type===g.SEPARATOR){const T=s[v-1],U=s[v+1];return[T,U].every(V=>V&&(V.type===g.VARIABLE||V.type===g.TEXT)&&V.value.length>0)}return!0}).map(_=>_.value).join("")}e.template=E;function l(n,r){return M.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):n.replace(/&&|&/g,s=>s==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function D(n,r){return M.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,""):M.isWindows?n.replace(/&&|&/g,s=>s==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=D;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function u(n){const r=n.indexOf("/")!==-1?w.posix:w.win32,s=r.basename(n),t=r.dirname(n);return s.length?{name:s,parentPath:t}:{name:t,parentPath:""}}e.splitName=u}),define(Ce[119],Ie([1,0,2]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function p(R){return R.toJSON()}class w{constructor(S){this._uriTransformer=S}transformIncoming(S){const m=this._uriTransformer.transformIncoming(S);return m===S?S:p(a.URI.from(m))}transformOutgoing(S){const m=this._uriTransformer.transformOutgoing(S);return m===S?S:p(a.URI.from(m))}transformOutgoingURI(S){const m=this._uriTransformer.transformOutgoing(S);return m===S?S:a.URI.from(m)}transformOutgoingScheme(S){return this._uriTransformer.transformOutgoingScheme(S)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function M(R,S,m){if(!R||m>200)return null;if(typeof R=="object"){if(R instanceof a.URI)return S.transformOutgoing(R);for(const k in R)if(Object.hasOwnProperty.call(R,k)){const f=M(R[k],S,m+1);f!==null&&(R[k]=f)}}return null}function y(R,S){const m=M(R,S,0);return m===null?R:m}e.transformOutgoingURIs=y;function A(R,S,m,k){if(!R||k>200)return null;if(typeof R=="object"){if(R.$mid===1)return m?a.URI.revive(S.transformIncoming(R)):S.transformIncoming(R);for(const f in R)if(Object.hasOwnProperty.call(R,f)){const h=A(R[f],S,m,k+1);h!==null&&(R[f]=h)}}return null}function b(R,S){const m=A(R,S,!1,0);return m===null?R:m}e.transformIncomingURIs=b;function P(R,S){const m=A(R,S,!0,0);return m===null?R:m}e.transformAndReviveIncomingURIs=P}),define(Ce[120],Ie([1,0,34,19]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(M,y,A,b,P,R){if(Array.isArray(M)){let S=0;for(const m of M){const k=w(m,y,A,b,P,R);if(k===10)return k;k>S&&(S=k)}return S}else{if(typeof M=="string")return b?M==="*"?5:M===A?10:0:0;if(M){const{language:S,pattern:m,scheme:k,hasAccessToAllModels:f,notebookType:h}=M;if(!b&&!f)return 0;h&&P&&(y=P);let d=0;if(k)if(k===y.scheme)d=10;else if(k==="*")d=5;else return 0;if(S)if(S===A)d=10;else if(S==="*")d=Math.max(d,5);else return 0;if(h)if(h===R)d=10;else if(h==="*"&&R!==void 0)d=Math.max(d,5);else return 0;if(m){let o;if(typeof m=="string"?o=m:o={...m,base:(0,p.normalize)(m.base)},o===y.fsPath||(0,a.match)(o,y.fsPath))d=10;else return 0}return d}else return 0}}e.score=w}),define(Ce[77],Ie([1,0,23,21]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var w;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(w||(w={}));function M(S){for(let m=0,k=S.length;m<k;m+=4){const f=S[m+0],h=S[m+1],d=S[m+2],o=S[m+3];S[m+0]=o,S[m+1]=d,S[m+2]=h,S[m+3]=f}}function y(S){const m=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return p.isLittleEndian()||M(m),a.VSBuffer.wrap(m)}function A(S){const m=S.buffer;if(p.isLittleEndian()||M(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const k=new Uint8Array(m.byteLength);return k.set(m),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function b(S){const m=new Uint32Array(P(S));let k=0;if(m[k++]=S.id,S.type==="full")m[k++]=1,m[k++]=S.data.length,m.set(S.data,k),k+=S.data.length;else{m[k++]=2,m[k++]=S.deltas.length;for(const f of S.deltas)m[k++]=f.start,m[k++]=f.deleteCount,f.data?(m[k++]=f.data.length,m.set(f.data,k),k+=f.data.length):m[k++]=0}return y(m)}e.encodeSemanticTokensDto=b;function P(S){let m=0;if(m+=1+1,S.type==="full")m+=1+S.data.length;else{m+=1,m+=(1+1+1)*S.deltas.length;for(const k of S.deltas)k.data&&(m+=k.data.length)}return m}function R(S){const m=A(S);let k=0;const f=m[k++];if(m[k++]===1){const g=m[k++],E=m.subarray(k,k+g);return k+=g,{id:f,type:"full",data:E}}const d=m[k++],o=[];for(let g=0;g<d;g++){const E=m[k++],l=m[k++],D=m[k++];let i;D>0&&(i=m.subarray(k,k+D),k+=D),o[g]={start:E,deleteCount:l,data:i}}return{id:f,type:"delta",deltas:o}}e.decodeSemanticTokensDto=R}),define(Ce[121],Ie([17,18]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(Ce[122],Ie([1,0,121,21,123,16,25,110]),function(ie,e,a,p,w,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var b;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(b=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(X){this._values=X}hasChanged(X){return this._values[X]}}e.ConfigurationChangedEvent=P;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class S{constructor(X,fe,Ue,He){this.id=X,this.name=fe,this.defaultValue=Ue,this.schema=He}applyUpdate(X,fe){return k(X,fe)}compute(X,fe,Ue){return Ue}}class m{constructor(X,fe){this.newValue=X,this.didChange=fe}}e.ApplyUpdateResult=m;function k(G,X){if(typeof G!="object"||typeof X!="object"||!G||!X)return new m(X,G!==X);if(Array.isArray(G)||Array.isArray(X)){const Ue=Array.isArray(G)&&Array.isArray(X)&&M.equals(G,X);return new m(X,!Ue)}let fe=!1;for(const Ue in X)if(X.hasOwnProperty(Ue)){const He=k(G[Ue],X[Ue]);He.didChange&&(G[Ue]=He.newValue,fe=!0)}return new m(G,fe)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,fe){return k(X,fe)}validate(X){return this.defaultValue}}class h{constructor(X,fe,Ue,He){this.id=X,this.name=fe,this.defaultValue=Ue,this.schema=He}applyUpdate(X,fe){return k(X,fe)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,fe,Ue){return Ue}}function d(G,X){return typeof G>"u"?X:G==="false"?!1:Boolean(G)}e.boolean=d;class o extends h{constructor(X,fe,Ue,He=void 0){typeof He<"u"&&(He.type="boolean",He.default=Ue),super(X,fe,Ue,He)}validate(X){return d(X,this.defaultValue)}}function g(G,X,fe,Ue){if(typeof G>"u")return X;let He=parseInt(G,10);return isNaN(He)?X:(He=Math.max(fe,He),He=Math.min(Ue,He),He|0)}e.clampedInt=g;class E extends h{constructor(X,fe,Ue,He,Ze,je=void 0){typeof je<"u"&&(je.type="integer",je.default=Ue,je.minimum=He,je.maximum=Ze),super(X,fe,Ue,je),this.minimum=He,this.maximum=Ze}static clampedInt(X,fe,Ue,He){return g(X,fe,Ue,He)}validate(X){return E.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}class l extends h{constructor(X,fe,Ue,He,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Ue),super(X,fe,Ue,Ze),this.validationFn=He}static clamp(X,fe,Ue){return X<fe?fe:X>Ue?Ue:X}static float(X,fe){if(typeof X=="number")return X;if(typeof X>"u")return fe;const Ue=parseFloat(X);return isNaN(Ue)?fe:Ue}validate(X){return this.validationFn(l.float(X,this.defaultValue))}}class D extends h{static string(X,fe){return typeof X!="string"?fe:X}constructor(X,fe,Ue,He=void 0){typeof He<"u"&&(He.type="string",He.default=Ue),super(X,fe,Ue,He)}validate(X){return D.string(X,this.defaultValue)}}function i(G,X,fe){return typeof G!="string"||fe.indexOf(G)===-1?X:G}e.stringSet=i;class u extends h{constructor(X,fe,Ue,He,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=He,Ze.default=Ue),super(X,fe,Ue,Ze),this._allowedValues=He}validate(X){return i(X,this.defaultValue,this._allowedValues)}}class n extends S{constructor(X,fe,Ue,He,Ze,je,We=void 0){typeof We<"u"&&(We.type="string",We.enum=Ze,We.default=He),super(X,fe,Ue,We),this._allowedValues=Ze,this._convert=je}validate(X){return typeof X!="string"?this.defaultValue:this._allowedValues.indexOf(X)===-1?this.defaultValue:this._convert(X)}}function r(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class s extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",description:a.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,fe,Ue){return Ue===0?X.accessibilitySupport:Ue}}class t extends S{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:a.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{insertSpace:d(fe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(fe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function _(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function T(G){switch(G){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=T;function U(G){switch(G){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class V extends f{constructor(){super(130)}compute(X,fe,Ue){const He=["monaco-editor"];return fe.get(34)&&He.push(fe.get(34)),X.extraEditorClassName&&He.push(X.extraEditorClassName),fe.get(67)==="default"?He.push("mouse-default"):fe.get(67)==="copy"&&He.push("mouse-copy"),fe.get(101)&&He.push("showUnused"),fe.get(128)&&He.push("showDeprecated"),He.join(" ")}}class x extends o{constructor(){super(33,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(X,fe,Ue){return Ue&&X.emptySelectionClipboard}}class C extends S{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:a.localize(16,null),included:p.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:a.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{cursorMoveOnType:d(fe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":i(fe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":i(fe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(fe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(fe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(fe.loop,this.defaultValue.loop)}}}class L extends S{constructor(){super(46,"fontLigatures",L.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?L.OFF:X==="true"?L.ON:X:Boolean(X)?L.ON:L.OFF}}e.EditorFontLigatures=L,L.OFF='"liga" off, "calt" off',L.ON='"liga" on, "calt" on';class B extends f{constructor(){super(45)}compute(X,fe,Ue){return X.fontInfo}}class F extends h{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(22,null)})}validate(X){const fe=l.float(X,this.defaultValue);return fe===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(fe,6,100)}compute(X,fe,Ue){return X.fontInfo.fontSize}}class K extends S{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:a.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(24,null)})}validate(X){return X==="normal"||X==="bold"?X:String(E.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class H extends S{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},fe={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[a.localize(25,null),a.localize(26,null),a.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(29,null),...fe},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(30,null),...fe},"editor.gotoLocation.multipleDeclarations":{description:a.localize(31,null),...fe},"editor.gotoLocation.multipleImplementations":{description:a.localize(32,null),...fe},"editor.gotoLocation.multipleReferences":{description:a.localize(33,null),...fe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Ue,description:a.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Ue,description:a.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Ue,description:a.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Ue,description:a.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Ue,description:a.localize(38,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{multiple:i(fe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:fe.multipleDefinitions??i(fe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:fe.multipleTypeDefinitions??i(fe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:fe.multipleDeclarations??i(fe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:fe.multipleImplementations??i(fe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:fe.multipleReferences??i(fe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:D.string(fe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:D.string(fe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:D.string(fe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:D.string(fe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:D.string(fe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class O extends S{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:a.localize(39,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:a.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:a.localize(41,null)},"editor.hover.above":{type:"boolean",default:X.above,description:a.localize(42,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:d(fe.enabled,this.defaultValue.enabled),delay:E.clampedInt(fe.delay,this.defaultValue.delay,0,1e4),sticky:d(fe.sticky,this.defaultValue.sticky),above:d(fe.above,this.defaultValue.above)}}}var ee;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(ee=e.RenderMinimap||(e.RenderMinimap={}));class ue extends f{constructor(){super(133)}compute(X,fe,Ue){return ue.computeLayout(fe,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio})}static computeContainedMinimapLineCount(X){const fe=X.height/X.lineHeight,Ue=X.scrollBeyondLastLine?fe-1:0,He=(X.viewLineCount+Ue)/(X.pixelRatio*X.height),Ze=Math.floor(X.viewLineCount/He);return{typicalViewportLineCount:fe,extraLinesBeyondLastLine:Ue,desiredRatio:He,minimapLineCount:Ze}}static _computeMinimapLayout(X,fe){const Ue=X.outerWidth,He=X.outerHeight,Ze=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const je=fe.stableMinimapLayoutInput,We=je&&X.outerHeight===je.outerHeight&&X.lineHeight===je.lineHeight&&X.typicalHalfwidthCharacterWidth===je.typicalHalfwidthCharacterWidth&&X.pixelRatio===je.pixelRatio&&X.scrollBeyondLastLine===je.scrollBeyondLastLine&&X.minimap.enabled===je.minimap.enabled&&X.minimap.side===je.minimap.side&&X.minimap.size===je.minimap.size&&X.minimap.showSlider===je.minimap.showSlider&&X.minimap.renderCharacters===je.minimap.renderCharacters&&X.minimap.maxColumn===je.minimap.maxColumn&&X.minimap.scale===je.minimap.scale&&X.verticalScrollbarWidth===je.verticalScrollbarWidth&&X.isViewportWrapping===je.isViewportWrapping,it=X.lineHeight,rt=X.typicalHalfwidthCharacterWidth,dt=X.scrollBeyondLastLine,at=X.minimap.renderCharacters;let st=Ze>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const yt=X.minimap.maxColumn,Rt=X.minimap.size,Ot=X.minimap.side,mt=X.verticalScrollbarWidth,Dt=X.viewLineCount,Lt=X.remainingWidth,Ft=X.isViewportWrapping,Ve=at?2:3;let Nt=Math.floor(Ze*He);const Tt=Nt/Ze;let Mt=!1,pt=!1,Ct=Ve*st,we=st/Ze,De=1;if(Rt==="fill"||Rt==="fit"){const{typicalViewportLineCount:Ge,extraLinesBeyondLastLine:ct,desiredRatio:It,minimapLineCount:Et}=ue.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:dt,height:He,lineHeight:it,pixelRatio:Ze});if(Dt/Et>1)Mt=!0,pt=!0,st=1,Ct=1,we=st/Ze;else{let _t=!1,gt=st+1;if(Rt==="fit"){const St=Math.ceil((Dt+ct)*Ct);Ft&&We&&Lt<=fe.stableFitRemainingWidth?(_t=!0,gt=fe.stableFitMaxMinimapScale):_t=St>Nt}if(Rt==="fill"||_t){Mt=!0;const St=st;Ct=Math.min(it*Ze,Math.max(1,Math.floor(1/It))),Ft&&We&&Lt<=fe.stableFitRemainingWidth&&(gt=fe.stableFitMaxMinimapScale),st=Math.min(gt,Math.max(1,Math.floor(Ct/Ve))),st>St&&(De=Math.min(2,st/St)),we=st/Ze/De,Nt=Math.ceil(Math.max(Ge,Dt+ct)*Ct),Ft?(fe.stableMinimapLayoutInput=X,fe.stableFitRemainingWidth=Lt,fe.stableFitMaxMinimapScale=st):(fe.stableMinimapLayoutInput=null,fe.stableFitRemainingWidth=0)}}}const me=Math.floor(yt*we),q=Math.min(me,Math.max(0,Math.floor((Lt-mt-2)*we/(rt+we)))+e.MINIMAP_GUTTER_WIDTH);let Ae=Math.floor(Ze*q);const Le=Ae/Ze;Ae=Math.floor(Ae*De);const et=at?1:2,qe=Ot==="left"?0:Ue-q-mt;return{renderMinimap:et,minimapLeft:qe,minimapWidth:q,minimapHeightIsEditorHeight:Mt,minimapIsSampling:pt,minimapScale:st,minimapLineHeight:Ct,minimapCanvasInnerWidth:Ae,minimapCanvasInnerHeight:Nt,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:Tt}}static computeLayout(X,fe){const Ue=fe.outerWidth|0,He=fe.outerHeight|0,Ze=fe.lineHeight|0,je=fe.lineNumbersDigitCount|0,We=fe.typicalHalfwidthCharacterWidth,it=fe.maxDigitWidth,rt=fe.pixelRatio,dt=fe.viewLineCount,at=X.get(125),st=at==="inherit"?X.get(124):at,yt=st==="inherit"?X.get(120):st,Rt=X.get(123),Ot=X.get(2),mt=fe.isDominatedByLongLines,Dt=X.get(51),Lt=X.get(61).renderType!==0,Ft=X.get(62),Ve=X.get(95),Nt=X.get(66),Tt=X.get(93),Mt=Tt.verticalScrollbarSize,pt=Tt.verticalHasArrows,Ct=Tt.arrowSize,we=Tt.horizontalScrollbarSize,De=X.get(59),me=X.get(38),q=X.get(100)!=="never";let Ae;if(typeof De=="string"&&/^\d+(\.\d+)?ch$/.test(De)){const Wt=parseFloat(De.substr(0,De.length-2));Ae=E.clampedInt(Wt*We,0,0,1e3)}else Ae=E.clampedInt(De,0,0,1e3);me&&q&&(Ae+=16);let Le=0;if(Lt){const Wt=Math.max(je,Ft);Le=Math.round(Wt*it)}let et=0;Dt&&(et=Ze);let qe=0,Ge=qe+et,ct=Ge+Le,It=ct+Ae;const Et=Ue-et-Le-Ae;let wt=!1,_t=!1,gt=-1;Ot!==2&&(st==="inherit"&&mt?(wt=!0,_t=!0):yt==="on"||yt==="bounded"?_t=!0:yt==="wordWrapColumn"&&(gt=Rt));const St=ue._computeMinimapLayout({outerWidth:Ue,outerHeight:He,lineHeight:Ze,typicalHalfwidthCharacterWidth:We,pixelRatio:rt,scrollBeyondLastLine:Ve,minimap:Nt,verticalScrollbarWidth:Mt,viewLineCount:dt,remainingWidth:Et,isViewportWrapping:_t},fe.memory||new R);St.renderMinimap!==0&&St.minimapLeft===0&&(qe+=St.minimapWidth,Ge+=St.minimapWidth,ct+=St.minimapWidth,It+=St.minimapWidth);const Qt=Et-St.minimapWidth,vt=Math.max(1,Math.floor((Qt-Mt-2)/We)),qt=pt?Ct:0;return _t&&(gt=Math.max(1,vt),yt==="bounded"&&(gt=Math.min(gt,Rt))),{width:Ue,height:He,glyphMarginLeft:qe,glyphMarginWidth:et,lineNumbersLeft:Ge,lineNumbersWidth:Le,decorationsLeft:ct,decorationsWidth:Ae,contentLeft:It,contentWidth:Qt,minimap:St,viewportColumn:vt,isWordWrapMinified:wt,isViewportWrapping:_t,wrappingColumn:gt,verticalScrollbarWidth:Mt,horizontalScrollbarHeight:we,overviewRuler:{top:qt,width:Mt,height:He-2*qt,right:0}}}}e.EditorLayoutInfoComputer=ue;class oe extends S{constructor(){const X={enabled:!0};super(58,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:a.localize(43,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:d(X.enabled,this.defaultValue.enabled)}}}class le extends S{constructor(){const X={enabled:!1,maxLineCount:5};super(105,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:a.localize(44,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:a.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:d(fe.enabled,this.defaultValue.enabled),maxLineCount:E.clampedInt(fe.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class te extends S{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:a.localize(46,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(47,null),a.localize(48,null,p.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(49,null,p.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(50,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:a.localize(51,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:a.localize(52,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:a.localize(53,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return typeof fe.enabled=="boolean"&&(fe.enabled=fe.enabled?"on":"off"),{enabled:i(fe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:E.clampedInt(fe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:D.string(fe.fontFamily,this.defaultValue.fontFamily),padding:d(fe.padding,this.defaultValue.padding)}}}class Ee extends l{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>l.clamp(X,0,150),{markdownDescription:a.localize(54,null)})}compute(X,fe,Ue){return X.fontInfo.lineHeight}}class be extends S{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:a.localize(55,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:a.localize(56,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(57,null),a.localize(58,null),a.localize(59,null)],default:X.size,description:a.localize(60,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:a.localize(61,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:a.localize(62,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(63,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:a.localize(64,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:a.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:d(fe.enabled,this.defaultValue.enabled),autohide:d(fe.autohide,this.defaultValue.autohide),size:i(fe.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(fe.side,this.defaultValue.side,["right","left"]),showSlider:i(fe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(fe.renderCharacters,this.defaultValue.renderCharacters),scale:E.clampedInt(fe.scale,1,1,3),maxColumn:E.clampedInt(fe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ne(G){return G==="ctrlCmd"?p.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ve extends S{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(66,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(67,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{top:E.clampedInt(fe.top,0,0,1e3),bottom:E.clampedInt(fe.bottom,0,0,1e3)}}}class Pe extends S{constructor(){const X={enabled:!0,cycle:!1};super(77,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:a.localize(68,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:a.localize(69,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:d(fe.enabled,this.defaultValue.enabled),cycle:d(fe.cycle,this.defaultValue.cycle)}}}class Fe extends f{constructor(){super(131)}compute(X,fe,Ue){return X.pixelRatio}}class xe extends S{constructor(){const X={other:"on",comments:"off",strings:"off"},fe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(70,null),a.localize(71,null),a.localize(72,null)]}];super(80,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:fe,default:X.strings,description:a.localize(73,null)},comments:{anyOf:fe,default:X.comments,description:a.localize(74,null)},other:{anyOf:fe,default:X.other,description:a.localize(75,null)}},default:X,markdownDescription:a.localize(76,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const rt=X?"on":"off";return{comments:rt,strings:rt,other:rt}}if(!X||typeof X!="object")return this.defaultValue;const{other:fe,comments:Ue,strings:He}=X,Ze=["on","inline","off"];let je,We,it;return typeof fe=="boolean"?je=fe?"on":"off":je=i(fe,this.defaultValue.other,Ze),typeof Ue=="boolean"?We=Ue?"on":"off":We=i(Ue,this.defaultValue.comments,Ze),typeof He=="boolean"?it=He?"on":"off":it=i(He,this.defaultValue.strings,Ze),{other:je,comments:We,strings:it}}}var Qe;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(Qe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ke extends S{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(77,null),a.localize(78,null),a.localize(79,null),a.localize(80,null)],default:"on",description:a.localize(81,null)})}validate(X){let fe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(fe=4,Ue=X):X==="interval"?fe=3:X==="relative"?fe=2:X==="on"?fe=1:fe=0),{renderType:fe,renderFn:Ue}}}function Se(G){const X=G.get(88);return X==="editable"?G.get(82):X!=="on"}e.filterValidationDecorations=Se;class ye extends S{constructor(){const X=[],fe={type:"number",description:a.localize(82,null)};super(92,"rulers",X,{type:"array",items:{anyOf:[fe,{type:["object"],properties:{column:fe,color:{type:"string",description:a.localize(83,null),format:"color-hex"}}}]},default:X,description:a.localize(84,null)})}validate(X){if(Array.isArray(X)){const fe=[];for(const Ue of X)if(typeof Ue=="number")fe.push({column:E.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const He=Ue;fe.push({column:E.clampedInt(He.column,0,0,1e4),color:He.color})}return fe.sort((Ue,He)=>Ue.column-He.column),fe}return this.defaultValue}}function ae(G,X){if(typeof G!="string")return X;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class ce extends S{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(85,null),a.localize(86,null),a.localize(87,null)],default:"auto",description:a.localize(88,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(89,null),a.localize(90,null),a.localize(91,null)],default:"auto",description:a.localize(92,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:a.localize(93,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:a.localize(94,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:a.localize(95,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X,Ue=E.clampedInt(fe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=E.clampedInt(fe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:E.clampedInt(fe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(fe.vertical,this.defaultValue.vertical),horizontal:ae(fe.horizontal,this.defaultValue.horizontal),useShadows:d(fe.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(fe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(fe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(fe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(fe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:E.clampedInt(fe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:He,verticalSliderSize:E.clampedInt(fe.verticalSliderSize,He,0,1e3),scrollByPage:d(fe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Q extends S{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:a.localize(96,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:a.localize(97,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:a.localize(98,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:a.localize(99,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:a.localize(100,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:a.localize(101,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:a.localize(102,null)}})}applyUpdate(X,fe){let Ue=!1;fe.allowedCharacters&&X&&(y.equals(X.allowedCharacters,fe.allowedCharacters)||(X={...X,allowedCharacters:fe.allowedCharacters},Ue=!0)),fe.allowedLocales&&X&&(y.equals(X.allowedLocales,fe.allowedLocales)||(X={...X,allowedLocales:fe.allowedLocales},Ue=!0));const He=super.applyUpdate(X,fe);return Ue?new m(He.newValue,!0):He}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{nonBasicASCII:W(fe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(fe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(fe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:W(fe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:W(fe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(X.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(X,fe){if(typeof X!="object"||!X)return fe;const Ue={};for(const[He,Ze]of Object.entries(X))Ze===!0&&(Ue[He]=!0);return Ue}}class J extends S{constructor(){const X={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:a.localize(103,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:d(fe.enabled,this.defaultValue.enabled),mode:i(fe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class I extends S{constructor(){const X={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:a.localize(104,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:a.localize(105,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{enabled:d(fe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(fe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class z extends S{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(106,null),a.localize(107,null),a.localize(108,null)],default:X.bracketPairs,description:a.localize(109,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(110,null),a.localize(111,null),a.localize(112,null)],default:X.bracketPairsHorizontal,description:a.localize(113,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:a.localize(114,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:a.localize(115,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(116,null),a.localize(117,null),a.localize(118,null)],default:X.highlightActiveIndentation,description:a.localize(119,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{bracketPairs:W(fe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:W(fe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(fe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(fe.indentation,this.defaultValue.indentation),highlightActiveIndentation:W(fe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function W(G,X,fe){const Ue=fe.indexOf(G);return Ue===-1?X:fe[Ue]}class j extends S{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(120,null),a.localize(121,null)],default:X.insertMode,description:a.localize(122,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:a.localize(123,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:a.localize(124,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:a.localize(125,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:a.localize(126,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:a.localize(127,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:a.localize(128,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:a.localize(129,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:a.localize(130,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(131,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(132,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(133,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(134,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(135,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(136,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(137,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(138,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(139,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(140,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(141,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(142,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(143,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(144,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(145,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(146,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(161,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(162,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const fe=X;return{insertMode:i(fe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(fe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(fe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(fe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(fe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(fe.showIcons,this.defaultValue.showIcons),showStatusBar:d(fe.showStatusBar,this.defaultValue.showStatusBar),preview:d(fe.preview,this.defaultValue.preview),previewMode:i(fe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(fe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(fe.showMethods,this.defaultValue.showMethods),showFunctions:d(fe.showFunctions,this.defaultValue.showFunctions),showConstructors:d(fe.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(fe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(fe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(fe.showFields,this.defaultValue.showFields),showVariables:d(fe.showVariables,this.defaultValue.showVariables),showClasses:d(fe.showClasses,this.defaultValue.showClasses),showStructs:d(fe.showStructs,this.defaultValue.showStructs),showInterfaces:d(fe.showInterfaces,this.defaultValue.showInterfaces),showModules:d(fe.showModules,this.defaultValue.showModules),showProperties:d(fe.showProperties,this.defaultValue.showProperties),showEvents:d(fe.showEvents,this.defaultValue.showEvents),showOperators:d(fe.showOperators,this.defaultValue.showOperators),showUnits:d(fe.showUnits,this.defaultValue.showUnits),showValues:d(fe.showValues,this.defaultValue.showValues),showConstants:d(fe.showConstants,this.defaultValue.showConstants),showEnums:d(fe.showEnums,this.defaultValue.showEnums),showEnumMembers:d(fe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(fe.showKeywords,this.defaultValue.showKeywords),showWords:d(fe.showWords,this.defaultValue.showWords),showColors:d(fe.showColors,this.defaultValue.showColors),showFiles:d(fe.showFiles,this.defaultValue.showFiles),showReferences:d(fe.showReferences,this.defaultValue.showReferences),showFolders:d(fe.showFolders,this.defaultValue.showFolders),showTypeParameters:d(fe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(fe.showSnippets,this.defaultValue.showSnippets),showUsers:d(fe.showUsers,this.defaultValue.showUsers),showIssues:d(fe.showIssues,this.defaultValue.showIssues)}}}class re extends S{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(163,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class de extends f{constructor(){super(132)}compute(X,fe,Ue){return fe.get(82)?!0:X.tabFocusMode}}var Z;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Z=e.WrappingIndent||(e.WrappingIndent={}));function pe(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends f{constructor(){super(134)}compute(X,fe,Ue){const He=fe.get(133);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}class Ne extends S{constructor(){const X={enabled:!0};super(32,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:a.localize(164,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:d(X.enabled,this.defaultValue.enabled)}}}const Be="Consolas, 'Courier New', monospace",Ye="Menlo, Monaco, 'Courier New', monospace",Xe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:p.isMacintosh?Ye:p.isLinux?Xe:Be,fontWeight:"normal",fontSize:p.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Te(G){return e.editorOptionsRegistry[G.id]=G,G}var nt;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.dropIntoEditor=32]="dropIntoEditor",G[G.emptySelectionClipboard=33]="emptySelectionClipboard",G[G.extraEditorClassName=34]="extraEditorClassName",G[G.fastScrollSensitivity=35]="fastScrollSensitivity",G[G.find=36]="find",G[G.fixedOverflowWidgets=37]="fixedOverflowWidgets",G[G.folding=38]="folding",G[G.foldingStrategy=39]="foldingStrategy",G[G.foldingHighlight=40]="foldingHighlight",G[G.foldingImportsByDefault=41]="foldingImportsByDefault",G[G.foldingMaximumRegions=42]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=44]="fontFamily",G[G.fontInfo=45]="fontInfo",G[G.fontLigatures=46]="fontLigatures",G[G.fontSize=47]="fontSize",G[G.fontWeight=48]="fontWeight",G[G.formatOnPaste=49]="formatOnPaste",G[G.formatOnType=50]="formatOnType",G[G.glyphMargin=51]="glyphMargin",G[G.gotoLocation=52]="gotoLocation",G[G.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",G[G.hover=54]="hover",G[G.inDiffEditor=55]="inDiffEditor",G[G.inlineSuggest=56]="inlineSuggest",G[G.letterSpacing=57]="letterSpacing",G[G.lightbulb=58]="lightbulb",G[G.lineDecorationsWidth=59]="lineDecorationsWidth",G[G.lineHeight=60]="lineHeight",G[G.lineNumbers=61]="lineNumbers",G[G.lineNumbersMinChars=62]="lineNumbersMinChars",G[G.linkedEditing=63]="linkedEditing",G[G.links=64]="links",G[G.matchBrackets=65]="matchBrackets",G[G.minimap=66]="minimap",G[G.mouseStyle=67]="mouseStyle",G[G.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=69]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",G[G.multiCursorModifier=71]="multiCursorModifier",G[G.multiCursorPaste=72]="multiCursorPaste",G[G.occurrencesHighlight=73]="occurrencesHighlight",G[G.overviewRulerBorder=74]="overviewRulerBorder",G[G.overviewRulerLanes=75]="overviewRulerLanes",G[G.padding=76]="padding",G[G.parameterHints=77]="parameterHints",G[G.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",G[G.quickSuggestions=80]="quickSuggestions",G[G.quickSuggestionsDelay=81]="quickSuggestionsDelay",G[G.readOnly=82]="readOnly",G[G.renameOnType=83]="renameOnType",G[G.renderControlCharacters=84]="renderControlCharacters",G[G.renderFinalNewline=85]="renderFinalNewline",G[G.renderLineHighlight=86]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=88]="renderValidationDecorations",G[G.renderWhitespace=89]="renderWhitespace",G[G.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",G[G.roundedSelection=91]="roundedSelection",G[G.rulers=92]="rulers",G[G.scrollbar=93]="scrollbar",G[G.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=95]="scrollBeyondLastLine",G[G.scrollPredominantAxis=96]="scrollPredominantAxis",G[G.selectionClipboard=97]="selectionClipboard",G[G.selectionHighlight=98]="selectionHighlight",G[G.selectOnLineNumbers=99]="selectOnLineNumbers",G[G.showFoldingControls=100]="showFoldingControls",G[G.showUnused=101]="showUnused",G[G.snippetSuggestions=102]="snippetSuggestions",G[G.smartSelect=103]="smartSelect",G[G.smoothScrolling=104]="smoothScrolling",G[G.stickyScroll=105]="stickyScroll",G[G.stickyTabStops=106]="stickyTabStops",G[G.stopRenderingLineAfter=107]="stopRenderingLineAfter",G[G.suggest=108]="suggest",G[G.suggestFontSize=109]="suggestFontSize",G[G.suggestLineHeight=110]="suggestLineHeight",G[G.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",G[G.suggestSelection=112]="suggestSelection",G[G.tabCompletion=113]="tabCompletion",G[G.tabIndex=114]="tabIndex",G[G.unicodeHighlighting=115]="unicodeHighlighting",G[G.unusualLineTerminators=116]="unusualLineTerminators",G[G.useShadowDOM=117]="useShadowDOM",G[G.useTabStops=118]="useTabStops",G[G.wordSeparators=119]="wordSeparators",G[G.wordWrap=120]="wordWrap",G[G.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=123]="wordWrapColumn",G[G.wordWrapOverride1=124]="wordWrapOverride1",G[G.wordWrapOverride2=125]="wordWrapOverride2",G[G.wrappingIndent=126]="wrappingIndent",G[G.wrappingStrategy=127]="wrappingStrategy",G[G.showDeprecated=128]="showDeprecated",G[G.inlayHints=129]="inlayHints",G[G.editorClassName=130]="editorClassName",G[G.pixelRatio=131]="pixelRatio",G[G.tabFocusMode=132]="tabFocusMode",G[G.layoutInfo=133]="layoutInfo",G[G.wrappingInfo=134]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Te(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(165,null)})),acceptSuggestionOnEnter:Te(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(166,null),""],markdownDescription:a.localize(167,null)})),accessibilitySupport:Te(new s),accessibilityPageSize:Te(new E(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(168,null)})),ariaLabel:Te(new D(4,"ariaLabel",a.localize(169,null))),autoClosingBrackets:Te(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(170,null),a.localize(171,null),""],description:a.localize(172,null)})),autoClosingDelete:Te(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(173,null),""],description:a.localize(174,null)})),autoClosingOvertype:Te(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(175,null),""],description:a.localize(176,null)})),autoClosingQuotes:Te(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(177,null),a.localize(178,null),""],description:a.localize(179,null)})),autoIndent:Te(new n(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[a.localize(180,null),a.localize(181,null),a.localize(182,null),a.localize(183,null),a.localize(184,null)],description:a.localize(185,null)})),automaticLayout:Te(new o(10,"automaticLayout",!1)),autoSurround:Te(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(186,null),a.localize(187,null),a.localize(188,null),""],description:a.localize(189,null)})),bracketPairColorization:Te(new I),bracketPairGuides:Te(new z),stickyTabStops:Te(new o(106,"stickyTabStops",!1,{description:a.localize(190,null)})),codeLens:Te(new o(14,"codeLens",!0,{description:a.localize(191,null)})),codeLensFontFamily:Te(new D(15,"codeLensFontFamily","",{description:a.localize(192,null)})),codeLensFontSize:Te(new E(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(193,null)})),colorDecorators:Te(new o(17,"colorDecorators",!0,{description:a.localize(194,null)})),columnSelection:Te(new o(18,"columnSelection",!1,{description:a.localize(195,null)})),comments:Te(new t),contextmenu:Te(new o(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Te(new o(21,"copyWithSyntaxHighlighting",!0,{description:a.localize(196,null)})),cursorBlinking:Te(new n(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],_,{description:a.localize(197,null)})),cursorSmoothCaretAnimation:Te(new o(23,"cursorSmoothCaretAnimation",!1,{description:a.localize(198,null)})),cursorStyle:Te(new n(24,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],U,{description:a.localize(199,null)})),cursorSurroundingLines:Te(new E(25,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(200,null)})),cursorSurroundingLinesStyle:Te(new u(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(201,null),a.localize(202,null)],description:a.localize(203,null)})),cursorWidth:Te(new E(27,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(204,null)})),disableLayerHinting:Te(new o(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Te(new o(29,"disableMonospaceOptimizations",!1)),domReadOnly:Te(new o(30,"domReadOnly",!1)),dragAndDrop:Te(new o(31,"dragAndDrop",!0,{description:a.localize(205,null)})),emptySelectionClipboard:Te(new x),dropIntoEditor:Te(new Ne),stickyScroll:Te(new le),extraEditorClassName:Te(new D(34,"extraEditorClassName","")),fastScrollSensitivity:Te(new l(35,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:a.localize(206,null)})),find:Te(new C),fixedOverflowWidgets:Te(new o(37,"fixedOverflowWidgets",!1)),folding:Te(new o(38,"folding",!0,{description:a.localize(207,null)})),foldingStrategy:Te(new u(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(208,null),a.localize(209,null)],description:a.localize(210,null)})),foldingHighlight:Te(new o(40,"foldingHighlight",!0,{description:a.localize(211,null)})),foldingImportsByDefault:Te(new o(41,"foldingImportsByDefault",!1,{description:a.localize(212,null)})),foldingMaximumRegions:Te(new E(42,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(213,null)})),unfoldOnClickAfterEndOfLine:Te(new o(43,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(214,null)})),fontFamily:Te(new D(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(215,null)})),fontInfo:Te(new B),fontLigatures2:Te(new L),fontSize:Te(new F),fontWeight:Te(new K),formatOnPaste:Te(new o(49,"formatOnPaste",!1,{description:a.localize(216,null)})),formatOnType:Te(new o(50,"formatOnType",!1,{description:a.localize(217,null)})),glyphMargin:Te(new o(51,"glyphMargin",!0,{description:a.localize(218,null)})),gotoLocation:Te(new H),hideCursorInOverviewRuler:Te(new o(53,"hideCursorInOverviewRuler",!1,{description:a.localize(219,null)})),hover:Te(new O),inDiffEditor:Te(new o(55,"inDiffEditor",!1)),letterSpacing:Te(new l(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>l.clamp(G,-5,20),{description:a.localize(220,null)})),lightbulb:Te(new oe),lineDecorationsWidth:Te(new h(59,"lineDecorationsWidth",10)),lineHeight:Te(new Ee),lineNumbers:Te(new ke),lineNumbersMinChars:Te(new E(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Te(new o(63,"linkedEditing",!1,{description:a.localize(221,null)})),links:Te(new o(64,"links",!0,{description:a.localize(222,null)})),matchBrackets:Te(new u(65,"matchBrackets","always",["always","near","never"],{description:a.localize(223,null)})),minimap:Te(new be),mouseStyle:Te(new u(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Te(new l(68,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:a.localize(224,null)})),mouseWheelZoom:Te(new o(69,"mouseWheelZoom",!1,{markdownDescription:a.localize(225,null)})),multiCursorMergeOverlapping:Te(new o(70,"multiCursorMergeOverlapping",!0,{description:a.localize(226,null)})),multiCursorModifier:Te(new n(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ne,{markdownEnumDescriptions:[a.localize(227,null),a.localize(228,null)],markdownDescription:a.localize(229,null)})),multiCursorPaste:Te(new u(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(230,null),a.localize(231,null)],markdownDescription:a.localize(232,null)})),occurrencesHighlight:Te(new o(73,"occurrencesHighlight",!0,{description:a.localize(233,null)})),overviewRulerBorder:Te(new o(74,"overviewRulerBorder",!0,{description:a.localize(234,null)})),overviewRulerLanes:Te(new E(75,"overviewRulerLanes",3,0,3)),padding:Te(new ve),parameterHints:Te(new Pe),peekWidgetDefaultFocus:Te(new u(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(235,null),a.localize(236,null)],description:a.localize(237,null)})),definitionLinkOpensInPeek:Te(new o(79,"definitionLinkOpensInPeek",!1,{description:a.localize(238,null)})),quickSuggestions:Te(new xe),quickSuggestionsDelay:Te(new E(81,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(239,null)})),readOnly:Te(new o(82,"readOnly",!1)),renameOnType:Te(new o(83,"renameOnType",!1,{description:a.localize(240,null),markdownDeprecationMessage:a.localize(241,null)})),renderControlCharacters:Te(new o(84,"renderControlCharacters",!0,{description:a.localize(242,null),restricted:!0})),renderFinalNewline:Te(new o(85,"renderFinalNewline",!0,{description:a.localize(243,null)})),renderLineHighlight:Te(new u(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(244,null)],description:a.localize(245,null)})),renderLineHighlightOnlyWhenFocus:Te(new o(87,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(246,null)})),renderValidationDecorations:Te(new u(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Te(new u(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(247,null),a.localize(248,null),a.localize(249,null),""],description:a.localize(250,null)})),revealHorizontalRightPadding:Te(new E(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Te(new o(91,"roundedSelection",!0,{description:a.localize(251,null)})),rulers:Te(new ye),scrollbar:Te(new ce),scrollBeyondLastColumn:Te(new E(94,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(252,null)})),scrollBeyondLastLine:Te(new o(95,"scrollBeyondLastLine",!0,{description:a.localize(253,null)})),scrollPredominantAxis:Te(new o(96,"scrollPredominantAxis",!0,{description:a.localize(254,null)})),selectionClipboard:Te(new o(97,"selectionClipboard",!0,{description:a.localize(255,null),included:p.isLinux})),selectionHighlight:Te(new o(98,"selectionHighlight",!0,{description:a.localize(256,null)})),selectOnLineNumbers:Te(new o(99,"selectOnLineNumbers",!0)),showFoldingControls:Te(new u(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(257,null),a.localize(258,null),a.localize(259,null)],description:a.localize(260,null)})),showUnused:Te(new o(101,"showUnused",!0,{description:a.localize(261,null)})),showDeprecated:Te(new o(128,"showDeprecated",!0,{description:a.localize(262,null)})),inlayHints:Te(new te),snippetSuggestions:Te(new u(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(263,null),a.localize(264,null),a.localize(265,null),a.localize(266,null)],description:a.localize(267,null)})),smartSelect:Te(new re),smoothScrolling:Te(new o(104,"smoothScrolling",!1,{description:a.localize(268,null)})),stopRenderingLineAfter:Te(new E(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Te(new j),inlineSuggest:Te(new J),suggestFontSize:Te(new E(109,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(269,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Te(new E(110,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(270,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Te(new o(111,"suggestOnTriggerCharacters",!0,{description:a.localize(271,null)})),suggestSelection:Te(new u(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(272,null),a.localize(273,null),a.localize(274,null)],description:a.localize(275,null)})),tabCompletion:Te(new u(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(276,null),a.localize(277,null),a.localize(278,null)],description:a.localize(279,null)})),tabIndex:Te(new E(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Te(new Q),unusualLineTerminators:Te(new u(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(280,null),a.localize(281,null),a.localize(282,null)],description:a.localize(283,null)})),useShadowDOM:Te(new o(117,"useShadowDOM",!0)),useTabStops:Te(new o(118,"useTabStops",!0,{description:a.localize(284,null)})),wordSeparators:Te(new D(119,"wordSeparators",w.USUAL_WORD_SEPARATORS,{description:a.localize(285,null)})),wordWrap:Te(new u(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(286,null),a.localize(287,null),a.localize(288,null),a.localize(289,null)],description:a.localize(290,null)})),wordWrapBreakAfterCharacters:Te(new D(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Te(new D(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Te(new E(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(291,null)})),wordWrapOverride1:Te(new u(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Te(new u(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Te(new n(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],pe,{enumDescriptions:[a.localize(292,null),a.localize(293,null),a.localize(294,null),a.localize(295,null)],description:a.localize(296,null)})),wrappingStrategy:Te(new u(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[a.localize(297,null),a.localize(298,null)],description:a.localize(299,null)})),editorClassName:Te(new V),pixelRatio:Te(new Fe),tabFocusMode:Te(new de),layoutInfo:Te(new ue),wrappingInfo:Te(new ge)}}),define(Ce[124],Ie([17,18]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[125],Ie([17,18]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[126],Ie([17,18]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[127],Ie([17,18]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(Ce[128],Ie([17,18]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(Ce[129],Ie([17,18]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(Ce[130],Ie([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[131],Ie([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[132],Ie([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[133],Ie([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[134],Ie([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[135],Ie([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[136],Ie([17,18]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[137],Ie([17,18]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(Ce[138],Ie([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[139],Ie([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[140],Ie([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[141],Ie([17,18]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[142],Ie([17,18]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[143],Ie([17,18]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[144],Ie([17,18]),function(ie,e){return ie.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[145],Ie([1,0,22,29,126,239]),function(ie,e,a,p,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const y=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function b(o){return o=o.trim(),o==="*"||y.test(o)}e.isValidVersionStr=b;function P(o){if(!b(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=o.match(y);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=P;function R(o){if(!o)return null;const g=o.majorBase,E=o.majorMustEqual,l=o.minorBase;let D=o.minorMustEqual;const i=o.patchBase;let u=o.patchMustEqual;o.hasCaret&&(g===0||(D=!1),u=!1);let n=0;if(o.preRelease){const r=A.exec(o.preRelease);if(r){const[,s,t,c]=r;n=Date.UTC(Number(s),Number(t)-1,Number(c))}}return{majorBase:g,majorMustEqual:E,minorBase:l,minorMustEqual:D,patchBase:i,patchMustEqual:u,isMinimum:o.hasGreaterEquals,notBefore:n}}e.normalizeVersion=R;function S(o,g,E){let l;typeof o=="string"?l=R(P(o)):l=o;let D;g instanceof Date?D=g.getTime():typeof g=="string"&&(D=new Date(g).getTime());let i;if(typeof E=="string"?i=R(P(E)):i=E,!l||!i)return!1;const u=l.majorBase,n=l.minorBase,r=l.patchBase;let s=i.majorBase,t=i.minorBase,c=i.patchBase;const _=i.notBefore;let v=i.majorMustEqual,T=i.minorMustEqual,U=i.patchMustEqual;return i.isMinimum?u>s?!0:u<s?!1:n>t?!0:n<t||D&&D<_?!1:r>=c:(u===1&&s===0&&(!v||!T||!U)&&(s=1,t=0,c=0,v=!0,T=!1,U=!1),u<s?!1:u>s?!v:n<t?!1:n>t?!T:r<c?!1:r>c?!U:!(D&&D<_))}e.isValidVersion=S;function m(o,g,E,l,D){const i=[];if(typeof l.publisher<"u"&&typeof l.publisher!="string")return i.push([p.default.Error,w.localize(0,null)]),i;if(typeof l.name!="string")return i.push([p.default.Error,w.localize(1,null,"name")]),i;if(typeof l.version!="string")return i.push([p.default.Error,w.localize(2,null,"version")]),i;if(!l.engines)return i.push([p.default.Error,w.localize(3,null,"engines")]),i;if(typeof l.engines.vscode!="string")return i.push([p.default.Error,w.localize(4,null,"engines.vscode")]),i;if(typeof l.extensionDependencies<"u"&&!d(l.extensionDependencies))return i.push([p.default.Error,w.localize(5,null,"extensionDependencies")]),i;if(typeof l.activationEvents<"u"){if(!d(l.activationEvents))return i.push([p.default.Error,w.localize(6,null,"activationEvents")]),i;if(typeof l.main>"u"&&typeof l.browser>"u")return i.push([p.default.Error,w.localize(7,null,"activationEvents","main")]),i}if(typeof l.extensionKind<"u"&&typeof l.main>"u"&&i.push([p.default.Warning,w.localize(8,null,"extensionKind")]),typeof l.main<"u"){if(typeof l.main!="string")return i.push([p.default.Error,w.localize(9,null,"main")]),i;{const r=(0,a.joinPath)(E,l.main);(0,a.isEqualOrParent)(r,E)||i.push([p.default.Warning,w.localize(10,null,r.path,E.path)])}if(typeof l.activationEvents>"u")return i.push([p.default.Error,w.localize(11,null,"activationEvents","main")]),i}if(typeof l.browser<"u"){if(typeof l.browser!="string")return i.push([p.default.Error,w.localize(12,null,"browser")]),i;{const r=(0,a.joinPath)(E,l.browser);(0,a.isEqualOrParent)(r,E)||i.push([p.default.Warning,w.localize(13,null,r.path,E.path)])}if(typeof l.activationEvents>"u")return i.push([p.default.Error,w.localize(14,null,"activationEvents","browser")]),i}if(!M.valid(l.version))return i.push([p.default.Error,w.localize(15,null)]),i;const u=[];if(!k(o,g,l,D,u))for(const r of u)i.push([p.default.Error,r]);return i}e.validateExtensionManifest=m;function k(o,g,E,l,D){return l||typeof E.main>"u"&&typeof E.browser>"u"?!0:h(o,g,E.engines.vscode,D)}e.isValidExtensionVersion=k;function f(o,g,E){return o==="*"||h(g,E,o)}e.isEngineValid=f;function h(o,g,E,l=[]){const D=R(P(E));if(!D)return l.push(w.localize(16,null,E)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return l.push(w.localize(17,null,E)),!1}else if(!D.majorMustEqual)return l.push(w.localize(18,null,E)),!1;return S(o,g,D)?!0:(l.push(w.localize(19,null,o,E)),!1)}function d(o){if(!Array.isArray(o))return!1;for(let g=0,E=o.length;g<E;g++)if(typeof o[g]!="string")return!1;return!0}}),define(Ce[78],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(w,M=[],y=!1){this.ctor=w,this.staticArguments=M,this.supportsDelayedInstantiation=y}}e.SyncDescriptor=a}),define(Ce[57],Ie([1,0,78]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const p=[];function w(y,A,b){A instanceof a.SyncDescriptor||(A=new a.SyncDescriptor(A,[],b)),p.push([y,A])}e.registerSingleton=w;function M(){return p}e.getSingletonServiceDescriptors=M}),define(Ce[146],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(M,y){this.key=M,this.data=y,this.incoming=new Map,this.outgoing=new Map}}e.Node=a;class p{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(const y of this._nodes.values())y.outgoing.size===0&&M.push(y);return M}insertEdge(M,y){const A=this.lookupOrInsertNode(M),b=this.lookupOrInsertNode(y);A.outgoing.set(b.key,b),b.incoming.set(A.key,A)}removeNode(M){const y=this._hashFn(M);this._nodes.delete(y);for(const A of this._nodes.values())A.outgoing.delete(y),A.incoming.delete(y)}lookupOrInsertNode(M){const y=this._hashFn(M);let A=this._nodes.get(y);return A||(A=new a(y,M),this._nodes.set(y,A)),A}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){const M=[];for(const[y,A]of this._nodes)M.push(`${y}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,y]of this._nodes){const A=new Set([M]),b=this._findCycle(y,A);if(b)return b}}_findCycle(M,y){for(const[A,b]of M.outgoing){if(y.has(A))return[...y,A].join(" -> ");y.add(A);const P=this._findCycle(b,y);if(P)return P;y.delete(A)}}}e.Graph=p}),define(Ce[3],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function A(b){return b[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=A})(a=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function p(y,A,b){A[a.DI_TARGET]===A?A[a.DI_DEPENDENCIES].push({id:y,index:b}):(A[a.DI_DEPENDENCIES]=[{id:y,index:b}],A[a.DI_TARGET]=A)}function w(y){if(a.serviceIds.has(y))return a.serviceIds.get(y);const A=function(b,P,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");p(A,b,R)};return A.toString=()=>y,a.serviceIds.set(y,A),A}e.createDecorator=w;function M(y){return y}e.refineServiceDecorator=M}),define(Ce[58],Ie([1,0,10,2,3]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function M(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof p.URI)}e.isConfigurationOverrides=M;function y(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof p.URI)}e.isConfigurationUpdateOverrides=y;var A;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=b;function P(o,g){const E=Object.create(null);for(const l in o)R(E,l,o[l],g);return E}e.toValuesTree=P;function R(o,g,E,l){const D=g.split("."),i=D.pop();let u=o;for(let n=0;n<D.length;n++){const r=D[n];let s=u[r];switch(typeof s){case"undefined":s=u[r]=Object.create(null);break;case"object":break;default:l(`Ignoring ${g} as ${D.slice(0,n+1).join(".")} is ${JSON.stringify(s)}`);return}u=s}if(typeof u=="object"&&u!==null)try{u[i]=E}catch{l(`Ignoring ${g} as ${D.join(".")} is ${JSON.stringify(u)}`)}else l(`Ignoring ${g} as ${D.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=R;function S(o,g){const E=g.split(".");m(o,E)}e.removeFromValueTree=S;function m(o,g){const E=g.shift();if(g.length===0){delete o[E];return}if(Object.keys(o).indexOf(E)!==-1){const l=o[E];typeof l=="object"&&!Array.isArray(l)&&(m(l,g),Object.keys(l).length===0&&delete o[E])}}function k(o,g,E){function l(u,n){let r=u;for(const s of n){if(typeof r!="object"||r===null)return;r=r[s]}return r}const D=g.split("."),i=l(o,D);return typeof i>"u"?E:i}e.getConfigurationValue=k;function f(o,g,E){Object.keys(g).forEach(l=>{l!=="__proto__"&&(l in o?a.isObject(o[l])&&a.isObject(g[l])?f(o[l],g[l],E):E&&(o[l]=g[l]):o[l]=g[l])})}e.merge=f;function h(o,g,E){const l=o.inspect(g),D=o.inspect(E);return typeof l.userValue<"u"||typeof l.workspaceValue<"u"||typeof l.workspaceFolderValue<"u"?l.value:typeof D.userValue<"u"||typeof D.workspaceValue<"u"||typeof D.workspaceFolderValue<"u"?D.value:l.defaultValue}e.getMigratedSettingValue=h;function d(o){return o.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(Ce[38],Ie([1,0,21,9,3]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",a.isMacintosh),M.set("isLinux",a.isLinux),M.set("isWindows",a.isWindows),M.set("isWeb",a.isWeb),M.set("isMacNative",a.isMacintosh&&!a.isWeb),M.set("isEdge",a.isEdge),M.set("isFirefox",a.isFirefox),M.set("isChrome",a.isChrome),M.set("isSafari",a.isSafari);const y=Object.prototype.hasOwnProperty;var A;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return S.INSTANCE}static true(){return m.INSTANCE}static has(C){return k.create(C)}static equals(C,L){return f.create(C,L)}static notEquals(C,L){return o.create(C,L)}static regex(C,L){return n.create(C,L)}static in(C,L){return h.create(C,L)}static notIn(C,L){return d.create(C,L)}static not(C){return g.create(C)}static and(...C){return t.create(C,null)}static or(...C){return c.create(C,null,!0)}static greater(C,L){return l.create(C,L)}static greaterEquals(C,L){return D.create(C,L)}static smaller(C,L){return i.create(C,L)}static smallerEquals(C,L){return u.create(C,L)}static deserialize(C,L=!1){if(!!C)return this._deserializeOrExpression(C,L)}static _deserializeOrExpression(C,L){const B=C.split("||");return c.create(B.map(F=>this._deserializeAndExpression(F,L)),null,!0)}static _deserializeAndExpression(C,L){const B=C.split("&&");return t.create(B.map(F=>this._deserializeOne(F,L)),null)}static _deserializeOne(C,L){if(C=C.trim(),C.indexOf("!=")>=0){const B=C.split("!=");return o.create(B[0].trim(),this._deserializeValue(B[1],L))}if(C.indexOf("==")>=0){const B=C.split("==");return f.create(B[0].trim(),this._deserializeValue(B[1],L))}if(C.indexOf("=~")>=0){const B=C.split("=~");return n.create(B[0].trim(),this._deserializeRegexValue(B[1],L))}if(C.indexOf(" not in ")>=0){const B=C.split(" not in ");return d.create(B[0].trim(),B[1].trim())}if(C.indexOf(" in ")>=0){const B=C.split(" in ");return h.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(C)){const B=C.split(">=");return D.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(C)){const B=C.split(">");return l.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(C)){const B=C.split("<=");return u.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(C)){const B=C.split("<");return i.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(C)?g.create(C.substr(1).trim()):k.create(C)}static _deserializeValue(C,L){if(C=C.trim(),C==="true")return!0;if(C==="false")return!1;const B=/^'([^']*)'$/.exec(C);return B?B[1].trim():C}static _deserializeRegexValue(C,L){if((0,p.isFalsyOrWhitespace)(C)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const B=C.indexOf("/"),F=C.lastIndexOf("/");if(B===F||B<0){if(L)throw new Error(`bad regexp-value '${C}', missing /-enclosure`);return console.warn(`bad regexp-value '${C}', missing /-enclosure`),null}const K=C.slice(B+1,F),H=C[F+1]==="i"?"i":"";try{return new RegExp(K,H)}catch(O){if(L)throw new Error(`bad regexp-value '${C}', parse error: ${O}`);return console.warn(`bad regexp-value '${C}', parse error: ${O}`),null}}}e.ContextKeyExpr=b;function P(x,C){const L=x?x.substituteConstants():void 0,B=C?C.substituteConstants():void 0;return!L&&!B?!0:!L||!B?!1:L.equals(B)}e.expressionsAreEqualWithConstantSubstitution=P;function R(x,C){return x.cmp(C)}class S{constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=S,S.INSTANCE=new S;class m{constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return S.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class k{constructor(C,L){this.key=C,this.negated=L,this.type=2}static create(C,L=null){const B=M.get(C);return typeof B=="boolean"?B?m.INSTANCE:S.INSTANCE:new k(C,L)}cmp(C){return C.type!==this.type?this.type-C.type:v(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=M.get(this.key);return typeof C=="boolean"?C?m.INSTANCE:S.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=k;class f{constructor(C,L,B){this.key=C,this.value=L,this.negated=B,this.type=4}static create(C,L,B=null){if(typeof L=="boolean")return L?k.create(C,B):g.create(C,B);const F=M.get(C);return typeof F=="boolean"?L===(F?"true":"false")?m.INSTANCE:S.INSTANCE:new f(C,L,B)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=M.get(this.key);if(typeof C=="boolean"){const L=C?"true":"false";return this.value===L?m.INSTANCE:S.INSTANCE}return this}evaluate(C){return C.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(C){return C.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class h{constructor(C,L){this.key=C,this.valueKey=L,this.type=10,this.negated=null}static create(C,L){return new h(C,L)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.valueKey,C.key,C.valueKey)}equals(C){return C.type===this.type?this.key===C.key&&this.valueKey===C.valueKey:!1}substituteConstants(){return this}evaluate(C){const L=C.getValue(this.valueKey),B=C.getValue(this.key);return Array.isArray(L)?L.includes(B):typeof B=="string"&&typeof L=="object"&&L!==null?y.call(L,B):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(C){return C.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=h;class d{constructor(C,L){this.key=C,this.valueKey=L,this.type=11,this._negated=h.create(C,L)}static create(C,L){return new d(C,L)}cmp(C){return C.type!==this.type?this.type-C.type:this._negated.cmp(C._negated)}equals(C){return C.type===this.type?this._negated.equals(C._negated):!1}substituteConstants(){return this}evaluate(C){return!this._negated.evaluate(C)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(C){return C.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=d;class o{constructor(C,L,B){this.key=C,this.value=L,this.negated=B,this.type=5}static create(C,L,B=null){if(typeof L=="boolean")return L?g.create(C,B):k.create(C,B);const F=M.get(C);return typeof F=="boolean"?L===(F?"true":"false")?S.INSTANCE:m.INSTANCE:new o(C,L,B)}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){const C=M.get(this.key);if(typeof C=="boolean"){const L=C?"true":"false";return this.value===L?S.INSTANCE:m.INSTANCE}return this}evaluate(C){return C.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(C){return C.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=o;class g{constructor(C,L){this.key=C,this.negated=L,this.type=3}static create(C,L=null){const B=M.get(C);return typeof B=="boolean"?B?S.INSTANCE:m.INSTANCE:new g(C,L)}cmp(C){return C.type!==this.type?this.type-C.type:v(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=M.get(this.key);return typeof C=="boolean"?C?S.INSTANCE:m.INSTANCE:this}evaluate(C){return!C.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(C){return C.mapNot(this.key)}negate(){return this.negated||(this.negated=k.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function E(x,C){if(typeof x=="string"){const L=parseFloat(x);isNaN(L)||(x=L)}return typeof x=="string"||typeof x=="number"?C(x):S.INSTANCE}class l{constructor(C,L,B){this.key=C,this.value=L,this.negated=B,this.type=12}static create(C,L,B=null){return E(L,F=>new l(C,F,B))}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class D{constructor(C,L,B){this.key=C,this.value=L,this.negated=B,this.type=13}static create(C,L,B=null){return E(L,F=>new D(C,F,B))}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(C){return C.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=D;class i{constructor(C,L,B){this.key=C,this.value=L,this.negated=B,this.type=14}static create(C,L,B=null){return E(L,F=>new i(C,F,B))}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=D.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=i;class u{constructor(C,L,B){this.key=C,this.value=L,this.negated=B,this.type=15}static create(C,L,B=null){return E(L,F=>new u(C,F,B))}cmp(C){return C.type!==this.type?this.type-C.type:T(this.key,this.value,C.key,C.value)}equals(C){return C.type===this.type?this.key===C.key&&this.value===C.value:!1}substituteConstants(){return this}evaluate(C){return typeof this.value=="string"?!1:parseFloat(C.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(C){return C.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=u;class n{constructor(C,L){this.key=C,this.regexp=L,this.type=7,this.negated=null}static create(C,L){return new n(C,L)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.key<C.key)return-1;if(this.key>C.key)return 1;const L=this.regexp?this.regexp.source:"",B=C.regexp?C.regexp.source:"";return L<B?-1:L>B?1:0}equals(C){if(C.type===this.type){const L=this.regexp?this.regexp.source:"",B=C.regexp?C.regexp.source:"";return this.key===C.key&&L===B}return!1}substituteConstants(){return this}evaluate(C){const L=C.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const C=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${C}`}keys(){return[this.key]}map(C){return C.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=r.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class r{constructor(C){this._actual=C,this.type=8}static create(C){return new r(C)}cmp(C){return C.type!==this.type?this.type-C.type:this._actual.cmp(C._actual)}equals(C){return C.type===this.type?this._actual.equals(C._actual):!1}substituteConstants(){return this}evaluate(C){return!this._actual.evaluate(C)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(C){return new r(this._actual.map(C))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;function s(x){let C=null;for(let L=0,B=x.length;L<B;L++){const F=x[L].substituteConstants();if(x[L]!==F&&C===null){C=[];for(let K=0;K<L;K++)C[K]=x[K]}C!==null&&(C[L]=F)}return C===null?x:C}class t{constructor(C,L){this.expr=C,this.negated=L,this.type=6}static create(C,L){return t._normalizeArr(C,L)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let L=0,B=this.expr.length;L<B;L++){const F=R(this.expr[L],C.expr[L]);if(F!==0)return F}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let L=0,B=this.expr.length;L<B;L++)if(!this.expr[L].equals(C.expr[L]))return!1;return!0}return!1}substituteConstants(){const C=s(this.expr);return C===this.expr?this:t.create(C,this.negated)}evaluate(C){for(let L=0,B=this.expr.length;L<B;L++)if(!this.expr[L].evaluate(C))return!1;return!0}static _normalizeArr(C,L){const B=[];let F=!1;for(const K of C)if(!!K){if(K.type===1){F=!0;continue}if(K.type===0)return S.INSTANCE;if(K.type===6){B.push(...K.expr);continue}B.push(K)}if(B.length===0&&F)return m.INSTANCE;if(B.length!==0){if(B.length===1)return B[0];B.sort(R);for(let K=1;K<B.length;K++)B[K-1].equals(B[K])&&(B.splice(K,1),K--);if(B.length===1)return B[0];for(;B.length>1;){const K=B[B.length-1];if(K.type!==9)break;B.pop();const H=B.pop(),O=B.length===0,ee=c.create(K.expr.map(ue=>t.create([ue,H],null)),null,O);ee&&(B.push(ee),B.sort(R))}return B.length===1?B[0]:new t(B,L)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const L of this.expr)C.push(...L.keys());return C}map(C){return new t(this.expr.map(L=>L.map(C)),null)}negate(){if(!this.negated){const C=[];for(const L of this.expr)C.push(L.negate());this.negated=c.create(C,this,!0)}return this.negated}}class c{constructor(C,L){this.expr=C,this.negated=L,this.type=9}static create(C,L,B){return c._normalizeArr(C,L,B)}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let L=0,B=this.expr.length;L<B;L++){const F=R(this.expr[L],C.expr[L]);if(F!==0)return F}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let L=0,B=this.expr.length;L<B;L++)if(!this.expr[L].equals(C.expr[L]))return!1;return!0}return!1}substituteConstants(){const C=s(this.expr);return C===this.expr?this:c.create(C,this.negated,!1)}evaluate(C){for(let L=0,B=this.expr.length;L<B;L++)if(this.expr[L].evaluate(C))return!0;return!1}static _normalizeArr(C,L,B){let F=[],K=!1;if(C){for(let H=0,O=C.length;H<O;H++){const ee=C[H];if(!!ee){if(ee.type===0){K=!0;continue}if(ee.type===1)return m.INSTANCE;if(ee.type===9){F=F.concat(ee.expr);continue}F.push(ee)}}if(F.length===0&&K)return S.INSTANCE;F.sort(R)}if(F.length!==0){if(F.length===1)return F[0];for(let H=1;H<F.length;H++)F[H-1].equals(F[H])&&(F.splice(H,1),H--);if(F.length===1)return F[0];if(B){for(let H=0;H<F.length;H++)for(let O=H+1;O<F.length;O++)U(F[H],F[O])&&(F.splice(O,1),O--);if(F.length===1)return F[0]}return new c(F,L)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const L of this.expr)C.push(...L.keys());return C}map(C){return new c(this.expr.map(L=>L.map(C)),null)}negate(){if(!this.negated){const C=[];for(const L of this.expr)C.push(L.negate());for(;C.length>1;){const L=C.shift(),B=C.shift(),F=[];for(const H of V(L))for(const O of V(B))F.push(t.create([H,O],null));const K=C.length===0;C.unshift(c.create(F,null,K))}this.negated=C[0]}return this.negated}}class _ extends k{constructor(C,L,B){super(C,null),this._defaultValue=L,typeof B=="object"?_._info.push({...B,key:C}):B!==!0&&_._info.push({key:C,description:B,type:L!=null?typeof L:void 0})}static all(){return _._info.values()}bindTo(C){return C.createKey(this.key,this._defaultValue)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return f.create(this.key,C)}notEqualsTo(C){return o.create(this.key,C)}}e.RawContextKey=_,_._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(x,C){return x<C?-1:x>C?1:0}function T(x,C,L,B){return x<L?-1:x>L?1:C<B?-1:C>B?1:0}function U(x,C){if(C.type===6&&x.type!==9&&x.type!==6){for(const F of C.expr)if(x.equals(F))return!0}const L=x.negate(),B=V(L).concat(V(C));B.sort(R);for(let F=0;F<B.length;F++){const H=B[F].negate();for(let O=F+1;O<B.length;O++){const ee=B[O];if(H.equals(ee))return!0}}return!1}e.implies=U;function V(x){return x.type===9?x.expr:[x]}}),define(Ce[147],Ie([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[79],Ie([1,0,125,3]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function w(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=w;function M(o){switch(o){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function y(o,g){switch(o){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=y;function A(o,g){return g==="web"&&!o.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function b(o,g,E){return A(g,E)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===E?!0:P(E).includes(o)}e.isTargetPlatformCompatible=b;function P(o){switch(o){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function R(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.isIExtensionIdentifier=R;var S;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var m;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var k;(function(o){o.Install="install",o.Uninstall="uninstall"})(k=e.StatisticType||(e.StatisticType={}));var f;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,p.createDecorator)("extensionGalleryService");var h;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatiblePreRelease="IncompatiblePreRelease",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Internal="Internal"})(h=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(g,E){super(g),this.code=E,this.name=E}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,p.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,p.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,p.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,p.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,a.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,p.createDecorator)("IExtensionManagementCLIService")}),define(Ce[39],Ie([1,0,24,19,9,10,2,127,3]),function(ie,e,a,p,w,M,y,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function P(H){return H.create===!0}e.isFileOpenForWriteOptions=P;var R;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var S;(function(H){H[H.Readonly=1]="Readonly"})(S=e.FilePermission||(e.FilePermission={}));var m;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function k(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=k;function f(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=f;function h(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=h;function d(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function o(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=o;function g(H){return k(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var E;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(O,ee){super(O),this.code=ee}}e.FileSystemProviderError=l;function D(H,O){const ee=new l(H.toString(),O);return u(ee,O),ee}e.createFileSystemProviderError=D;function i(H){return H||D((0,A.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=i;function u(H,O){return H.name=O?`${O} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=u;function n(H){if(!H)return E.Unknown;if(H instanceof l)return H.code;const O=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!O)return E.Unknown;switch(O[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=n;function r(H){if(H instanceof T)return H.fileOperationResult;switch(n(H)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class t{constructor(O,ee,ue){this.resource=O,this.operation=ee,this.target=ue}isOperation(O){return this.operation===O}}e.FileOperationEvent=t;var c;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class _{constructor(O,ee){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=O;const ue=new Map;for(const oe of O){const le=ue.get(oe.type);switch(le?le.push([oe.resource,oe]):ue.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,le]of ue)switch(oe){case 1:this.added=a.TernarySearchTree.forUris(()=>ee),this.added.fill(le);break;case 0:this.updated=a.TernarySearchTree.forUris(()=>ee),this.updated.fill(le);break;case 2:this.deleted=a.TernarySearchTree.forUris(()=>ee),this.deleted.fill(le);break}}contains(O,...ee){return this.doContains(O,{includeChildren:!1},...ee)}affects(O,...ee){return this.doContains(O,{includeChildren:!0},...ee)}doContains(O,ee,...ue){if(!O)return!1;const oe=ue.length>0;return!!((!oe||ue.includes(1))&&(this.added?.get(O)||ee.includeChildren&&this.added?.findSuperstr(O))||(!oe||ue.includes(0))&&(this.updated?.get(O)||ee.includeChildren&&this.updated?.findSuperstr(O))||(!oe||ue.includes(2))&&(this.deleted?.findSubstr(O)||ee.includeChildren&&this.deleted?.findSuperstr(O)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=_;function v(H,O,ee){return!H||!O||H===O||O.length>H.length?!1:(O.charAt(O.length-1)!==p.sep&&(O+=p.sep),ee?(0,w.startsWithIgnoreCase)(H,O):H.indexOf(O)===0)}e.isParent=v;class T extends Error{constructor(O,ee,ue){super(O),this.fileOperationResult=ee,this.options=ue}}e.FileOperationError=T;class U extends T{constructor(O,ee,ue){super(O,2,ue),this.stat=ee}}e.NotModifiedSinceFileOperationError=U;var V;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(V=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var x;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(x=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function C(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=C;async function L(H,O){if(!O.hasProvider(y.URI.from({scheme:H.scheme})))return new Promise(ee=>{const ue=O.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===H.scheme&&oe.added&&(ue.dispose(),ee())})})}e.whenProviderRegistered=L,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class B{static formatSize(O){return(0,M.isNumber)(O)||(O=0),O<B.KB?(0,A.localize)(1,null,O.toFixed(0)):O<B.MB?(0,A.localize)(2,null,(O/B.KB).toFixed(2)):O<B.GB?(0,A.localize)(3,null,(O/B.MB).toFixed(2)):O<B.TB?(0,A.localize)(4,null,(O/B.GB).toFixed(2)):(0,A.localize)(5,null,(O/B.TB).toFixed(2))}}e.ByteSize=B,B.KB=1024,B.MB=B.KB*B.KB,B.GB=B.MB*B.KB,B.TB=B.GB*B.KB;var F;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(F=e.Arch||(e.Arch={}));function K(H){return{maxFileSize:H===0?300*B.MB:16*B.GB,maxHeapSize:H===0?700*B.MB:2*700*B.MB}}e.getPlatformLimits=K}),define(Ce[59],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...w){this._entries=new Map;for(const[M,y]of w)this.set(M,y)}set(w,M){const y=this._entries.get(w);return this._entries.set(w,M),y}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=a}),define(Ce[148],Ie([1,0,14,11,78,146,3,59]),function(ie,e,a,p,w,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class P extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class R{constructor(f=new A.ServiceCollection,h=!1,d){this._activeInstantiations=new Set,this._services=f,this._strict=h,this._parent=d,this._services.set(y.IInstantiationService,this)}createChild(f){return new R(f,this._strict,this)}invokeFunction(f,...h){const d=m.traceInvocation(f);let o=!1;try{return f({get:E=>{if(o)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(E,d);if(!l)throw new Error(`[invokeFunction] unknown service '${E}'`);return l}},...h)}finally{o=!0,d.stop()}}createInstance(f,...h){let d,o;return f instanceof w.SyncDescriptor?(d=m.traceCreation(f.ctor),o=this._createInstance(f.ctor,f.staticArguments.concat(h),d)):(d=m.traceCreation(f),o=this._createInstance(f,h,d)),d.stop(),o}_createInstance(f,h=[],d){const o=y._util.getServiceDependencies(f).sort((l,D)=>l.index-D.index),g=[];for(const l of o){const D=this._getOrCreateServiceInstance(l.id,d);D||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${l.id}.`,!1),g.push(D)}const E=o.length>0?o[0].index:h.length;if(h.length!==E){console.trace(`[createInstance] First service dependency of ${f.name} at position ${E+1} conflicts with ${h.length} static arguments`);const l=E-h.length;l>0?h=h.concat(new Array(l)):h=h.slice(0,E)}return new f(...h,...g)}_setServiceInstance(f,h){if(this._services.get(f)instanceof w.SyncDescriptor)this._services.set(f,h);else if(this._parent)this._parent._setServiceInstance(f,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const h=this._services.get(f);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):h}_getOrCreateServiceInstance(f,h){const d=this._getServiceInstanceOrDescriptor(f);return d instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,d,h.branch(f,!0)):(h.branch(f,!1),d)}_safeCreateAndCacheServiceInstance(f,h,d){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,h,d)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,h,d){const o=new M.Graph(l=>l.id.toString());let g=0;const E=[{id:f,desc:h,_trace:d}];for(;E.length;){const l=E.pop();if(o.lookupOrInsertNode(l),g++>1e3)throw new P(o);for(const D of y._util.getServiceDependencies(l.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(D.id);if(i||this._throwIfStrict(`[createInstance] ${f} depends on ${D.id} which is NOT registered.`,!0),i instanceof w.SyncDescriptor){const u={id:D.id,desc:i,_trace:l._trace.branch(D.id,!0)};o.insertEdge(l,u),E.push(u)}}}for(;;){const l=o.roots();if(l.length===0){if(!o.isEmpty())throw new P(o);break}for(const{data:D}of l){if(this._getServiceInstanceOrDescriptor(D.id)instanceof w.SyncDescriptor){const u=this._createServiceInstanceWithOwner(D.id,D.desc.ctor,D.desc.staticArguments,D.desc.supportsDelayedInstantiation,D._trace);this._setServiceInstance(D.id,u)}o.removeNode(D)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,h,d=[],o,g){if(this._services.get(f)instanceof w.SyncDescriptor)return this._createServiceInstance(h,d,o,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,h,d,o,g);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(f,h=[],d,o){if(d){const g=new a.IdleValue(()=>this._createInstance(f,h,o));return new Proxy(Object.create(null),{get(E,l){if(l in E)return E[l];const D=g.value;let i=D[l];return typeof i!="function"||(i=i.bind(D),E[l]=i),i},set(E,l,D){return g.value[l]=D,!0}})}else return this._createInstance(f,h,o)}_throwIfStrict(f,h){if(h&&console.warn(f),this._strict)throw new Error(f)}}e.InstantiationService=R;var S;(function(k){k[k.Creation=0]="Creation",k[k.Invocation=1]="Invocation",k[k.Branch=2]="Branch"})(S||(S={}));class m{constructor(f,h){this.type=f,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return b?new m(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(f){return b?new m(0,f.name):m._None}branch(f,h){const d=new m(2,f.toString());return this._dep.push([f,h,d]),d}stop(){const f=Date.now()-this._start;m._totals+=f;let h=!1;function d(g,E){const l=[],D=new Array(g+1).join("	");for(const[i,u,n]of E._dep)if(u&&n){h=!0,l.push(`${D}CREATES -> ${i}`);const r=d(g+1,n);r&&l.push(r)}else l.push(`${D}uses -> ${i}`);return l.join(`
`)}const o=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(f>2||h)&&console.log(o.join(`
`))}}e.Trace=m,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Ce[15],Ie([1,0,43,5,7,21,3]),function(ie,e,a,p,w,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function A(){return new Date().toISOString()}var b;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function P(u,n,r){switch(n){case b.Trace:u.trace(r);break;case b.Debug:u.debug(r);break;case b.Info:u.info(r);break;case b.Warning:u.warn(r);break;case b.Error:u.error(r);break;case b.Critical:u.critical(r);break;default:throw new Error("Invalid log level")}}e.log=P;function R(u){let n="";for(let r=0;r<u.length;r++){let s=u[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}n+=(r>0?" ":"")+s}return n}e.format=R;class S extends w.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new p.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=S;class m extends S{constructor(n){super(),this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...r){this.checkLogLevel(b.Trace)&&this.log(b.Trace,R([n,...r]))}debug(n,...r){this.checkLogLevel(b.Debug)&&this.log(b.Debug,R([n,...r]))}info(n,...r){this.checkLogLevel(b.Info)&&this.log(b.Info,R([n,...r]))}warn(n,...r){this.checkLogLevel(b.Warning)&&this.log(b.Warning,R([n,...r]))}error(n,...r){if(this.checkLogLevel(b.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(b.Error,R(s))}else this.log(b.Error,R([n,...r]))}critical(n,...r){this.checkLogLevel(b.Critical)&&this.log(b.Critical,R([n,...r]))}flush(){}}e.AbstractMessageLogger=m;class k extends S{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n),this.useColors=!M.isWindows}trace(n,...r){this.getLevel()<=b.Trace&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,n,...r):console.log(`[main ${A()}]`,n,...r))}debug(n,...r){this.getLevel()<=b.Debug&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,n,...r):console.log(`[main ${A()}]`,n,...r))}info(n,...r){this.getLevel()<=b.Info&&(this.useColors?console.log(`\x1B[90m[main ${A()}]\x1B[0m`,n,...r):console.log(`[main ${A()}]`,n,...r))}warn(n,...r){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${A()}]\x1B[0m`,n,...r):console.warn(`[main ${A()}]`,n,...r))}error(n,...r){this.getLevel()<=b.Error&&(this.useColors?console.error(`\x1B[91m[main ${A()}]\x1B[0m`,n,...r):console.error(`[main ${A()}]`,n,...r))}critical(n,...r){this.getLevel()<=b.Critical&&(this.useColors?console.error(`\x1B[90m[main ${A()}]\x1B[0m`,n,...r):console.error(`[main ${A()}]`,n,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class f extends S{constructor(n=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(n)}trace(n,...r){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",n,...r)}debug(n,...r){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...r)}info(n,...r){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",n,...r)}warn(n,...r){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",n,...r)}error(n,...r){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",n,...r)}critical(n,...r){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...r)}dispose(){}flush(){}}e.ConsoleLogger=f;class h extends S{constructor(n,r=e.DEFAULT_LOG_LEVEL){super(),this.adapter=n,this.setLevel(r)}trace(n,...r){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(n),...r])}debug(n,...r){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(n),...r])}info(n,...r){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(n),...r])}warn(n,...r){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(n),...r])}error(n,...r){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(n),...r])}critical(n,...r){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(n),...r])}extractMessage(n){return typeof n=="string"?n:(0,a.toErrorMessage)(n,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class d extends S{constructor(n){super(),this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const r of this.logServices)r.setLevel(n);super.setLevel(n)}trace(n,...r){for(const s of this.logServices)s.trace(n,...r)}debug(n,...r){for(const s of this.logServices)s.debug(n,...r)}info(n,...r){for(const s of this.logServices)s.info(n,...r)}warn(n,...r){for(const s of this.logServices)s.warn(n,...r)}error(n,...r){for(const s of this.logServices)s.error(n,...r)}critical(n,...r){for(const s of this.logServices)s.critical(n,...r)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=d;class o extends w.Disposable{constructor(n){super(),this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...r){this.logger.trace(n,...r)}debug(n,...r){this.logger.debug(n,...r)}info(n,...r){this.logger.info(n,...r)}warn(n,...r){this.logger.warn(n,...r)}error(n,...r){this.logger.error(n,...r)}critical(n,...r){this.logger.critical(n,...r)}flush(){this.logger.flush()}}e.LogService=o;class g extends w.Disposable{constructor(n,r){super(),this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,r){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,r?.always?b.Trace:this.logLevel,r),this.loggers.set(n.toString(),s),r?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class E{constructor(){this.onDidChangeLogLevel=new p.Emitter().event}setLevel(n){}getLevel(){return b.Info}trace(n,...r){}debug(n,...r){}info(n,...r){}warn(n,...r){}error(n,...r){}critical(n,...r){}dispose(){}flush(){}}e.NullLogService=E;function l(u){if(u.verbose)return b.Trace;if(typeof u.logLevel=="string"){const n=D(u.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function D(u){switch(u){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=D;function i(u){switch(u){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=i}),define(Ce[80],Ie([1,0,29,128,3]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var y;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(b){function P(f,h){return h-f}b.compare=P;const R=Object.create(null);R[b.Error]=(0,p.localize)(0,null),R[b.Warning]=(0,p.localize)(1,null),R[b.Info]=(0,p.localize)(2,null);function S(f){return R[f]||""}b.toString=S;function m(f){switch(f){case a.default.Error:return b.Error;case a.default.Warning:return b.Warning;case a.default.Info:return b.Info;case a.default.Ignore:return b.Hint}}b.fromSeverity=m;function k(f){switch(f){case b.Error:return a.default.Error;case b.Warning:return a.default.Warning;case b.Info:return a.default.Info;case b.Hint:return a.default.Ignore}}b.toSeverity=k}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(b){const P="";function R(m){return S(m,!0)}b.makeKey=R;function S(m,k){const f=[P];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(P),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(P),m.severity!==void 0&&m.severity!==null?f.push(y.toString(m.severity)):f.push(P),m.message&&k?f.push(m.message.replace("\xA6","\\\xA6")):f.push(P),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(P),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(P),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(P),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(P),f.push(P),f.join("\xA6")}b.makeKeyOptionalMessage=S})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(Ce[149],Ie([1,0,5,29,3]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=p.default,e.INotificationService=(0,w.createDecorator)("notificationService");var M;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new b,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=A;class b{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=b}),define(Ce[81],Ie([1,0,7,9,2,3]),function(ie,e,a,p,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,M.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return a.Disposable.None},registerValidator(){return a.Disposable.None},registerExternalUriResolver(){return a.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return a.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function y(R,S){return w.URI.isUri(R)?(0,p.equalsIgnoreCase)(R.scheme,S):(0,p.startsWithIgnoreCase)(R,S+":")}e.matchesScheme=y;function A(R,...S){return S.some(m=>y(R,m))}e.matchesSomeScheme=A;function b(R,S){return R.with({fragment:`${S.startLineNumber},${S.startColumn}${S.endLineNumber?`-${S.endLineNumber}${S.endColumn?`,${S.endColumn}`:""}`:""}`})}e.withSelection=b;function P(R){let S;const m=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(R.fragment);return m&&(S={startLineNumber:parseInt(m[1]),startColumn:m[2]?parseInt(m[2]):1,endLineNumber:m[4]?parseInt(m[4]):void 0,endColumn:m[4]?m[5]?parseInt(m[5]):1:void 0},R=R.with({fragment:""})),{selection:S,uri:R}}e.extractSelection=P}),define(Ce[150],Ie([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__decorate||function(ie,e,a,p){var w=arguments.length,M=w<3?e:p===null?p=Object.getOwnPropertyDescriptor(e,a):p,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ie,e,a,p);else for(var A=ie.length-1;A>=0;A--)(y=ie[A])&&(M=(w<3?y(M):w>3?y(e,a,M):y(e,a))||M);return w>3&&M&&Object.defineProperty(e,a,M),M},$e=this&&this.__param||function(ie,e){return function(a,p){e(a,p,ie)}};define(Ce[151],Ie([1,0,14,20,7,3]),function(ie,e,a,p,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var y;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{constructor(S){this.callback=S}get value(){return this._value}report(S){this._value=S,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let b=class extends w.Disposable{constructor(S,m){super(),this.deferred=new a.DeferredPromise,m.withProgress(S,k=>(this.reporter=k,this.lastStep&&k.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(S){this.reporter?this.reporter.report(S):this.lastStep=S}};b=ze([$e(1,e.IProgressService)],b),e.UnmanagedProgress=b;class P extends w.Disposable{constructor(S){super(),this.progressIndicator=S,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(S){this.stop();const m=++this.currentOperationId,k=new p.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},S),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>k.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:k.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(S){this.currentOperationId===S&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(Ce[30],Ie([1,0,44,10]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(y,A){a.ok(p.isString(y)),a.ok(p.isObject(A)),a.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,A)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new w}),define(Ce[82],Ie([1,0,5,30]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class M{constructor(){this._onDidChangeSchema=new a.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,P){this.schemasById[w(b)]=P,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new M;p.Registry.add(e.Extensions.JSONContribution,y)}),define(Ce[83],Ie([1,0,16,5,10,124,58,82,30]),function(ie,e,a,p,w,M,y,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(D){D.Multiline="multilineText",D.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=b.Registry.as(A.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new p.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new p.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,u=!0){this.registerConfigurations([i],u)}registerConfigurations(i,u=!0){const n=this.doRegisterConfigurations(i,u);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(i){const u=this.doDeregisterConfigurations(i);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:i,remove:u}){const n=[];n.push(...this.doDeregisterConfigurations(u)),n.push(...this.doRegisterConfigurations(i,!1)),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,a.distinct)(n)})}registerDefaultConfigurations(i){const u=[],n=[];for(const{overrides:r,source:s}of i)for(const t in r)if(u.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const c=this.configurationDefaultsOverrides.get(t),_=c?.valuesSources??new Map;if(s)for(const V of Object.keys(r[t]))_.set(V,s);const v={...c?.value||{},...r[t]};this.configurationDefaultsOverrides.set(t,{source:s,value:v,valuesSources:_});const T=(0,y.getLanguageTagSettingPlainKey)(t),U={type:"object",default:v,description:M.localize(1,null,T),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:w.isString(s)?void 0:s,defaultValueSource:s};n.push(...h(t)),this.configurationProperties[t]=U,this.defaultLanguageConfigurationOverridesNode.properties[t]=U}else{this.configurationDefaultsOverrides.set(t,{value:r[t],source:s});const c=this.configurationProperties[t];c&&(this.updatePropertyDefaultValue(t,c),this.updateSchema(t,c))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const u=[];for(const{overrides:n,source:r}of i)for(const s in n){const t=this.configurationDefaultsOverrides.get(s),c=w.isString(r)?r:r?.id,_=w.isString(t?.source)?t?.source:t?.source?.id;if(c===_)if(u.push(s),this.configurationDefaultsOverrides.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const v=this.configurationProperties[s];v&&(this.updatePropertyDefaultValue(s,v),this.updateSchema(s,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const u of i)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,u){const n=[];return i.forEach(r=>{n.push(...this.validateAndRegisterProperties(r,u,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),n}doDeregisterConfigurations(i){const u=[],n=r=>{if(r.properties)for(const s in r.properties){u.push(s);const t=this.configurationProperties[s];t?.policy?.name&&this.policyConfigurations.delete(t.policy.name),delete this.configurationProperties[s],this.removeFromSchema(s,r.properties[s])}r.allOf?.forEach(s=>n(s))};for(const r of i){n(r);const s=this.configurationContributors.indexOf(r);s!==-1&&this.configurationContributors.splice(s,1)}return u}validateAndRegisterProperties(i,u=!0,n,r,s=3){s=w.isUndefinedOrNull(i.scope)?s:i.scope;const t=[],c=i.properties;if(c)for(const v in c){const T=c[v];if(u&&E(v,T)){delete c[v];continue}if(T.source=n,T.defaultDefaultValue=c[v].default,this.updatePropertyDefaultValue(v,T),e.OVERRIDE_PROPERTY_REGEX.test(v)?T.scope=void 0:(T.scope=w.isUndefinedOrNull(T.scope)?s:T.scope,T.restricted=w.isUndefinedOrNull(T.restricted)?!!r?.includes(v):T.restricted),c[v].hasOwnProperty("included")&&!c[v].included){this.excludedConfigurationProperties[v]=c[v],delete c[v];continue}else this.configurationProperties[v]=c[v],c[v].policy?.name&&this.policyConfigurations.set(c[v].policy.name,v);!c[v].deprecationMessage&&c[v].markdownDeprecationMessage&&(c[v].deprecationMessage=c[v].markdownDeprecationMessage),t.push(v)}const _=i.allOf;if(_)for(const v of _)t.push(...this.validateAndRegisterProperties(v,u,n,r,s));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const u=n=>{const r=n.properties;if(r)for(const t in r)this.updateSchema(t,r[t]);n.allOf?.forEach(u)};u(i)}updateSchema(i,u){switch(e.allSettings.properties[i]=u,u.scope){case 1:e.applicationSettings.properties[i]=u;break;case 2:e.machineSettings.properties[i]=u;break;case 6:e.machineOverridableSettings.properties[i]=u;break;case 3:e.windowSettings.properties[i]=u;break;case 4:e.resourceSettings.properties[i]=u;break;case 5:e.resourceSettings.properties[i]=u,this.resourceLanguageSettingsSchema.properties[i]=u;break}}removeFromSchema(i,u){switch(delete e.allSettings.properties[i],u.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const u=`[${i}]`,n={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,n),e.allSettings.properties[u]=n,e.applicationSettings.properties[u]=n,e.machineSettings.properties[u]=n,e.machineOverridableSettings.properties[u]=n,e.windowSettings.properties[u]=n,e.resourceSettings.properties[u]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,u){const n=this.configurationDefaultsOverrides.get(i);let r=n?.value,s=n?.source;w.isUndefined(r)&&(r=u.defaultDefaultValue,s=void 0),w.isUndefined(r)&&(r=o(u.type)),u.default=r,u.defaultValueSource=s}}const k="\\[([^\\]]+)\\]",f=new RegExp(k,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${k})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(D){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(D)){let u=f.exec(D);for(;u?.length;){const n=u[1].trim();n&&i.push(n),u=f.exec(D)}}return(0,a.distinct)(i)}e.overrideIdentifiersFromKey=h;function d(D){return D.reduce((i,u)=>`${i}[${u}]`,"")}e.keyFromOverrideIdentifiers=d;function o(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const g=new m;b.Registry.add(e.Extensions.Configuration,g);function E(D,i){return D.trim()?e.OVERRIDE_PROPERTY_REGEX.test(D)?M.localize(7,null,D):g.getConfigurationProperties()[D]!==void 0?M.localize(8,null,D):i.policy?.name&&g.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,D,i.policy?.name,g.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.validateProperty=E;function l(){const D=[],i=g.getConfigurationProperties();for(const u of Object.keys(i))D.push([u,i[u].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=l}),define(Ce[152],Ie([1,0,16,5,106,7,24,25,10,2,58,83,30]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class k{constructor(i={},u=[],n=[]){this._contents=i,this._keys=u,this._overrides=n,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(i){return i?(0,R.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,u){const n=this.getContentsForOverrideIdentifer(u);return n?i?(0,R.getConfigurationValue)(n,i):n:void 0}getKeysForOverrideIdentifier(i){const u=[];for(const n of this.overrides)n.identifiers.includes(i)&&u.push(...n.keys);return a.distinct(u)}getAllOverrideIdentifiers(){const i=[];for(const u of this.overrides)i.push(...u.identifiers);return a.distinct(i)}override(i){let u=this.overrideConfigurations.get(i);return u||(u=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,u)),u}merge(...i){const u=A.deepClone(this.contents),n=A.deepClone(this.overrides),r=[...this.keys];for(const s of i)if(!s.isEmpty()){this.mergeContents(u,s.contents);for(const t of s.overrides){const[c]=n.filter(_=>a.equals(_.identifiers,t.identifiers));c?(this.mergeContents(c.contents,t.contents),c.keys.push(...t.keys),c.keys=a.distinct(c.keys)):n.push(A.deepClone(t))}for(const t of s.keys)r.indexOf(t)===-1&&r.push(t)}return new k(u,r,n)}freeze(){return this.frozen=!0,this}clone(){return new k(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}createOverrideConfigurationModel(i){const u=this.getContentsForOverrideIdentifer(i);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const n={};for(const r of a.distinct([...Object.keys(this.contents),...Object.keys(u)])){let s=this.contents[r];const t=u[r];t&&(typeof s=="object"&&typeof t=="object"?(s=A.deepClone(s),this.mergeContents(s,t)):s=t),n[r]=s}return new k(n,this.keys,this.overrides)}mergeContents(i,u){for(const n of Object.keys(u)){if(n in i&&b.isObject(i[n])&&b.isObject(u[n])){this.mergeContents(i[n],u[n]);continue}i[n]=A.deepClone(u[n])}}checkAndFreeze(i){return this.frozen&&!Object.isFrozen(i)?A.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let u=null,n=null;const r=s=>{s&&(n?this.mergeContents(n,s):n=A.deepClone(s))};for(const s of this.overrides)a.equals(s.identifiers,[i])?u=s.contents:s.identifiers.includes(i)&&r(s.contents);return r(u),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,u){this.addKey(i),(0,R.addToValueTree)(this.contents,i,u,n=>{throw new Error(n)})}removeValue(i){this.removeKey(i)&&(0,R.removeFromValueTree)(this.contents,i)}addKey(i){let u=this.keys.length;for(let n=0;n<u;n++)i.indexOf(this.keys[n])===0&&(u=n);this.keys.splice(u,1,i)}removeKey(i){const u=this.keys.indexOf(i);return u!==-1?(this.keys.splice(u,1),!0):!1}}e.ConfigurationModel=k;class f{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new k}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,u){if(!b.isUndefinedOrNull(i)){const n=this.doParseContent(i);this.parseRaw(n,u)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,u){this._raw=i;const{contents:n,keys:r,overrides:s,restricted:t}=this.doParseRaw(i,u);this._configurationModel=new k(n,r,s),this._restrictedConfigurations=t||[]}doParseContent(i){let u={},n=null,r=[];const s=[],t=[];function c(v){Array.isArray(r)?r.push(v):n!==null&&(r[n]=v)}const _={onObjectBegin:()=>{const v={};c(v),s.push(r),r=v,n=null},onObjectProperty:v=>{n=v},onObjectEnd:()=>{r=s.pop()},onArrayBegin:()=>{const v=[];c(v),s.push(r),r=v,n=null},onArrayEnd:()=>{r=s.pop()},onLiteralValue:c,onError:(v,T,U)=>{t.push({error:v,offset:T,length:U})}};if(i)try{w.visit(i,_),u=r[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return u}doParseRaw(i,u){const n=m.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),r=this.filter(i,n,!0,u);i=r.raw;const s=(0,R.toValuesTree)(i,_=>console.error(`Conflict in settings file ${this._name}: ${_}`)),t=Object.keys(i),c=this.toOverrides(i,_=>console.error(`Conflict in settings file ${this._name}: ${_}`));return{contents:s,keys:t,overrides:c,restricted:r.restricted}}filter(i,u,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:i,restricted:[]};const s={},t=[];for(const c in i)if(S.OVERRIDE_PROPERTY_REGEX.test(c)&&n){const _=this.filter(i[c],u,!1,r);s[c]=_.raw,t.push(..._.restricted)}else{const _=u[c],v=_?typeof _.scope<"u"?_.scope:3:void 0;_?.restricted&&t.push(c),(v===void 0||r.scopes===void 0||r.scopes.includes(v))&&(r.skipRestricted&&_?.restricted||(s[c]=i[c]))}return{raw:s,restricted:t}}toOverrides(i,u){const n=[];for(const r of Object.keys(i))if(S.OVERRIDE_PROPERTY_REGEX.test(r)){const s={};for(const t in i[r])s[t]=i[r][t];n.push({identifiers:(0,S.overrideIdentifiersFromKey)(r),keys:Object.keys(s),contents:(0,R.toValuesTree)(s,u)})}return n}}e.ConfigurationModelParser=f;class h extends M.Disposable{constructor(i,u,n,r){super(),this.userSettingsResource=i,this.scopes=u,this.fileService=r,this._onDidChange=this._register(new p.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(p.Event.any(p.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource)),p.Event.filter(this.fileService.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&n.isEqual(s.resource,i)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new k}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class d{constructor(i,u,n,r,s=new k,t=new k,c=new y.ResourceMap,_=new k,v=new y.ResourceMap,T=!0){this._defaultConfiguration=i,this._policyConfiguration=u,this._applicationConfiguration=n,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=t,this._folderConfigurations=c,this._memoryConfiguration=_,this._memoryConfigurationByResource=v,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new y.ResourceMap,this._userConfiguration=null}getValue(i,u,n){return this.getConsolidatedConfigurationModel(i,u,n).getValue(i)}updateValue(i,u,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new k,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,u===void 0?r.removeValue(i):r.setValue(i,u),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,u,n){const r=this.getConsolidatedConfigurationModel(i,u,n),s=this.getFolderConfigurationModelForResource(u.resource,n),t=u.resource?this._memoryConfigurationByResource.get(u.resource)||this._memoryConfiguration:this._memoryConfiguration,c=u.overrideIdentifier?this._defaultConfiguration.freeze().override(u.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),_=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(i),v=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(i),T=u.overrideIdentifier?this.userConfiguration.freeze().override(u.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),U=u.overrideIdentifier?this.localUserConfiguration.freeze().override(u.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),V=u.overrideIdentifier?this.remoteUserConfiguration.freeze().override(u.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),x=n?u.overrideIdentifier?this._workspaceConfiguration.freeze().override(u.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,C=s?u.overrideIdentifier?s.freeze().override(u.overrideIdentifier).getValue(i):s.freeze().getValue(i):void 0,L=u.overrideIdentifier?t.override(u.overrideIdentifier).getValue(i):t.getValue(i),B=r.getValue(i),F=a.distinct(r.overrides.map(K=>K.identifiers).flat()).filter(K=>r.getOverrideValue(i,K)!==void 0);return{defaultValue:c,policyValue:_,applicationValue:v,userValue:T,userLocalValue:U,userRemoteValue:V,workspaceValue:x,workspaceFolderValue:C,memoryValue:L,value:B,default:c!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:u.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,policy:_!==void 0?{value:_}:void 0,application:v!==void 0?{value:v,override:u.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:u.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,userLocal:U!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:u.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,userRemote:V!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:u.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,workspace:x!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:u.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,workspaceFolder:C!==void 0?{value:s?.freeze().getValue(i),override:u.overrideIdentifier?s?.freeze().getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,memory:L!==void 0?{value:t.getValue(i),override:u.overrideIdentifier?t.getOverrideValue(i,u.overrideIdentifier):void 0}:void 0,overrideIdentifiers:F.length?F:void 0}}keys(i){const u=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:u?u.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(i){this._policyConfiguration=i}updateApplicationConfiguration(i){this._applicationConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,u){this._folderConfigurations.set(i,u),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,u){const n=[];if(!u){const{added:r,updated:s,removed:t}=E(this._defaultConfiguration,i);u=[...r,...s,...t]}for(const r of u)for(const s of(0,S.overrideIdentifiersFromKey)(r)){const t=this._defaultConfiguration.getKeysForOverrideIdentifier(s),c=i.getKeysForOverrideIdentifier(s),_=[...c.filter(v=>t.indexOf(v)===-1),...t.filter(v=>c.indexOf(v)===-1),...t.filter(v=>!A.equals(this._defaultConfiguration.override(s).getValue(v),i.override(s).getValue(v)))];n.push([s,_])}return this.updateDefaultConfiguration(i),{keys:u,overrides:n}}compareAndUpdatePolicyConfiguration(i){const{added:u,updated:n,removed:r}=E(this._policyConfiguration,i),s=[...u,...n,...r];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:u,updated:n,removed:r,overrides:s}=E(this.applicationConfiguration,i),t=[...u,...n,...r];return t.length&&this.updateApplicationConfiguration(i),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:u,updated:n,removed:r,overrides:s}=E(this.localUserConfiguration,i),t=[...u,...n,...r];return t.length&&this.updateLocalUserConfiguration(i),{keys:t,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:u,updated:n,removed:r,overrides:s}=E(this.remoteUserConfiguration,i),t=[...u,...n,...r];return t.length&&this.updateRemoteUserConfiguration(i),{keys:t,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:u,updated:n,removed:r,overrides:s}=E(this.workspaceConfiguration,i),t=[...u,...n,...r];return t.length&&this.updateWorkspaceConfiguration(i),{keys:t,overrides:s}}compareAndUpdateFolderConfiguration(i,u){const n=this.folderConfigurations.get(i),{added:r,updated:s,removed:t,overrides:c}=E(n,u),_=[...r,...s,...t];return(_.length||!n)&&this.updateFolderConfiguration(i,u),{keys:_,overrides:c}}compareAndDeleteFolderConfiguration(i){const u=this.folderConfigurations.get(i);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:r,removed:s,overrides:t}=E(u,void 0);return{keys:[...n,...r,...s],overrides:t}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(i,u,n){let r=this.getConsolidatedConfigurationModelForResource(u,n);return u.overrideIdentifier&&(r=r.override(u.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(i)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:i},u){let n=this.getWorkspaceConsolidatedConfiguration();if(u&&i){const r=u.getFolder(i);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const s=this._memoryConfigurationByResource.get(i);s&&(n=n.merge(s))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let u=this._foldersConsolidatedConfigurations.get(i);if(!u){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(i);r?(u=n.merge(r),this._freeze&&(u=u.freeze()),this._foldersConsolidatedConfigurations.set(i,u)):u=n}return u}getFolderConfigurationModelForResource(i,u){if(u&&i){const n=u.getFolder(i);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,u)=>{const{contents:n,overrides:r,keys:s}=this._folderConfigurations.get(u);return i.push([u,{contents:n,overrides:r,keys:s}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(u=>i.add(u)),this.userConfiguration.freeze().keys.forEach(u=>i.add(u)),this._workspaceConfiguration.freeze().keys.forEach(u=>i.add(u)),this._folderConfigurations.forEach(u=>u.freeze().keys.forEach(n=>i.add(n))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>i.add(u)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>i.add(u)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(u=>i.add(u)),this._folderConfigurations.forEach(u=>u.freeze().getAllOverrideIdentifiers().forEach(n=>i.add(n))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const u=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>u.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>u.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>u.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(r=>u.add(r))),[...u.values()]}static parse(i){const u=this.parseConfigurationModel(i.defaults),n=this.parseConfigurationModel(i.policy),r=this.parseConfigurationModel(i.application),s=this.parseConfigurationModel(i.user),t=this.parseConfigurationModel(i.workspace),c=i.folders.reduce((_,v)=>(_.set(P.URI.revive(v[0]),this.parseConfigurationModel(v[1])),_),new y.ResourceMap);return new d(u,n,r,s,new k,t,c,new k,new y.ResourceMap,!1)}static parseConfigurationModel(i){return new k(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=d;function o(...D){if(D.length===0)return{keys:[],overrides:[]};if(D.length===1)return D[0];const i=new Set,u=new Map;for(const r of D)r.keys.forEach(s=>i.add(s)),r.overrides.forEach(([s,t])=>{const c=(0,y.getOrSet)(u,s,new Set);t.forEach(_=>c.add(_))});const n=[];return u.forEach((r,s)=>n.push([s,[...r.values()]])),{keys:[...i.values()],overrides:n}}e.mergeChanges=o;class g{constructor(i,u,n,r){this.change=i,this.previous=u,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const s=new Set;i.keys.forEach(c=>s.add(c)),i.overrides.forEach(([,c])=>c.forEach(_=>s.add(_))),this.affectedKeys=[...s.values()];const t=new k;this.affectedKeys.forEach(c=>t.setValue(c,{})),this.affectedKeysTree=t.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,u){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(u){const n=this.previousConfiguration?this.previousConfiguration.getValue(i,u,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(i,u,this.currentWorkspace);return!A.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(i,u){let n=(0,R.toValuesTree)({[u]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(i=i[r],!i)return!1;n=n[r]}return!0}}e.ConfigurationChangeEvent=g;function E(D,i){const{added:u,removed:n,updated:r}=l(i,D),s=[],t=D?.getAllOverrideIdentifiers()||[],c=i?.getAllOverrideIdentifiers()||[];if(i){const _=c.filter(v=>!t.includes(v));for(const v of _)s.push([v,i.getKeysForOverrideIdentifier(v)])}if(D){const _=t.filter(v=>!c.includes(v));for(const v of _)s.push([v,D.getKeysForOverrideIdentifier(v)])}if(i&&D){for(const _ of t)if(c.includes(_)){const v=l({contents:D.getOverrideValue(void 0,_)||{},keys:D.getKeysForOverrideIdentifier(_)},{contents:i.getOverrideValue(void 0,_)||{},keys:i.getKeysForOverrideIdentifier(_)});s.push([_,[...v.added,...v.removed,...v.updated]])}}return{added:u,removed:n,updated:r,overrides:s}}function l(D,i){const u=D?i?D.keys.filter(s=>i.keys.indexOf(s)===-1):[...D.keys]:[],n=i?D?i.keys.filter(s=>D.keys.indexOf(s)===-1):[...i.keys]:[],r=[];if(D&&i){for(const s of i.keys)if(D.keys.indexOf(s)!==-1){const t=(0,R.getConfigurationValue)(i.contents,s),c=(0,R.getConfigurationValue)(D.contents,s);A.equals(t,c)||r.push(s)}}return{added:u,removed:n,updated:r}}}),define(Ce[84],Ie([1,0,11,3]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var w;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(w=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends a.ErrorNoTelemetry{constructor(A,b=w.Unknown,P){super(A),this._message=A,this._code=b,this._detail=P,this.isHandled=b===w.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static isTemporarilyNotAvailable(A){return A instanceof M&&A._code===w.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof M&&A._code===w.NoResolverFound}static isHandled(A){return A instanceof M&&A.isHandled}}e.RemoteAuthorityResolverError=M}),define(Ce[85],Ie([1,0,12]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function p(P){return P.scheme===a.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=p;function w(P){if(!P)return;const R=P.indexOf("+");return R<0?P:P.substr(0,R)}e.getRemoteName=w;function M(P){return`/${P.quality??"oss"}-${P.commit??"dev"}`}e.getRemoteServerRootPath=M;function y(P){const{host:R,port:S}=b(P);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:S}}e.parseAuthorityWithPort=y;function A(P,R){let{host:S,port:m}=b(P);return typeof m>"u"&&(m=R),{host:S,port:m}}e.parseAuthorityWithOptionalPort=A;function b(P){const R=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const S=P.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const m=P.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:P,port:void 0}}}),define(Ce[26],Ie([1,0,9,3,85]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=M;function y(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=y,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var b;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(b=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,d){if(typeof h>"u"||h===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof h=="string"||typeof d=="string"){const o=typeof h=="string"?h:h.value,g=typeof d=="string"?d:d.value;return a.equalsIgnoreCase(o,g)}return h._lower===d._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.ExtensionIdentifier=P;function R(f){return S(f)}e.isApplicationScopedExtension=R;function S(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function k(f,h){if(h){const d=`onResolveRemoteAuthority:${(0,w.getRemoteName)(h)}`;return f.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=k,e.IBuiltinExtensionsScannerService=(0,p.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[153],Ie([1,0,9,79,26,21,2,11,60]),function(ie,e,a,p,w,M,y,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(u,n){return u.uuid&&n.uuid?u.uuid===n.uuid:u.id===n.id?!0:(0,a.compareIgnoreCase)(u.id,n.id)===0}e.areSameExtensions=P;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class S{constructor(n,r,s="undefined"){this.version=r,this.targetPlatform=s,this.id=n.id}static create(n){const r=n.manifest?n.manifest.version:n.version,s=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new S(n.identifier,r,s)}static parse(n){const r=R.exec(n);return r&&r[1]&&r[2]?new S({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof S?P(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=S;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function k(u){const n=m.exec(u);return n&&n[1]?[h(n[1]),n[2]]:[h(u),void 0]}e.getIdAndVersion=k;function f(u,n){return`${u}.${n}`}e.getExtensionId=f;function h(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function d(u,n){return h(f(u,n))}e.getGalleryExtensionId=d;function o(u,n){const r=[],s=t=>{for(const c of r)if(c.some(_=>P(n(_),n(t))))return c;return null};for(const t of u){const c=s(t);c?c.push(t):r.push([t])}return r}e.groupByExtension=o;function g(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function E(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new w.ExtensionIdentifier("pprice.better-merge");function l(u,n){const r=[],s=n.manifest.extensionDependencies?.slice(0)??[];for(;s.length;){const t=s.shift();if(t&&r.every(c=>!P(c.identifier,{id:t}))){const c=u.filter(_=>P(_.identifier,{id:t}));c.length===1&&(r.push(c[0]),s.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=l;async function D(u,n){if(!M.isLinux)return!1;let r;try{r=(await u.readFile(y.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await u.readFile(y.URI.file("/usr/lib/os-release"))).value.toString()}catch(t){n.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(t))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=D;async function i(u,n){const r=await D(u,n),s=(0,p.getTargetPlatform)(r?"alpine":M.platform,b.arch);return n.debug("ComputeTargetPlatform:",s),s}e.computeTargetPlatform=i}),define(Ce[154],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(w){this._callback=w,this._terminalBufferMap=new Map}dispose(){for(const w of this._terminalBufferMap.values())w.dispose()}startBuffering(w,M,y=5){const A=M(b=>{const P=typeof b=="string"?b:b.data;let R=this._terminalBufferMap.get(w);if(R){R.data.push(P);return}const S=setTimeout(()=>this.flushBuffer(w),y);R={data:[P],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(w),A.dispose()}},this._terminalBufferMap.set(w,R)});return A}stopBuffering(w){this._terminalBufferMap.get(w)?.dispose()}flushBuffer(w){const M=this._terminalBufferMap.get(w);M&&(this._terminalBufferMap.delete(w),this._callback(w,M.data.join("")))}}e.TerminalDataBufferer=a}),define(Ce[155],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var a;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(a=e.ColorScheme||(e.ColorScheme={}));function p(M){return M===a.HIGH_CONTRAST_DARK||M===a.HIGH_CONTRAST_LIGHT}e.isHighContrast=p;function w(M){return M===a.DARK||M===a.HIGH_CONTRAST_DARK}e.isDark=w}),define(Ce[61],Ie([1,0,117,5,7,3,30,155]),function(ie,e,a,p,w,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var b;(function(d){function o(g){return g&&typeof g=="object"&&typeof g.id=="string"}d.isThemeColor=o})(b=e.ThemeColor||(e.ThemeColor={}));function P(d){return{id:d}}e.themeColorFromId=P;var R;(function(d){function o(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||b.isThemeColor(r.color))}d.isThemeIcon=o;const g=new RegExp(`^\\$\\((${a.CSSIcon.iconNameExpression}(?:${a.CSSIcon.iconModifierExpression})?)\\)$`);function E(r){const s=g.exec(r);if(!s)return;const[,t]=s;return{id:t}}d.fromString=E;function l(r){return{id:r}}d.fromId=l;function D(r,s){let t=r.id;const c=t.lastIndexOf("~");return c!==-1&&(t=t.substring(0,c)),s&&(t=`${t}~${s}`),{id:t}}d.modify=D;function i(r){const s=r.id.lastIndexOf("~");if(s!==-1)return r.id.substring(s+1)}d.getModifier=i;function u(r,s){return r.id===s.id&&r.color?.id===s.color?.id}d.isEqual=u;function n(r,s){return{id:r.id,color:s?P(s):void 0}}d.asThemeIcon=n,d.asClassNameArray=a.CSSIcon.asClassNameArray,d.asClassName=a.CSSIcon.asClassName,d.asCSSSelector=a.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=a.Codicon.file,e.FolderThemeIcon=a.Codicon.folder;function S(d){switch(d){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new p.Emitter}onColorThemeChange(o){return this.themingParticipants.push(o),this.onThemingParticipantAddedEmitter.fire(o),(0,w.toDisposable)(()=>{const g=this.themingParticipants.indexOf(o);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const k=new m;y.Registry.add(e.Extensions.ThemingContribution,k);function f(d){return k.onColorThemeChange(d)}e.registerThemingParticipant=f;class h extends w.Disposable{constructor(o){super(),this.themeService=o,this.theme=o.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(o){this.theme=o,this.updateStyles()}updateStyles(){}getColor(o,g){let E=this.theme.getColor(o);return E&&g&&(E=g(E,this.theme)),E?E.toString():null}}e.Themable=h}),define(Ce[156],Ie([1,0,5,21,3,15]),function(ie,e,a,p,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,w.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,w.createDecorator)("sharedTunnelsService");var y;(function(h){h.Http="http",h.Https="https"})(y=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function S(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=S;function m(h,d){return d?d!==1&&h<1024:!p.isWindows&&h<1024}e.isPortPrivileged=m;class k{constructor(d,o,g){this.remoteAddress=d,this.localAddress=o,this._dispose=g,this._onDispose=new a.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=k;let f=class{constructor(d){this.logService=d,this._onTunnelOpened=new a.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new a.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new a.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],o=Array.from(this._tunnels.values());for(const g of o){const E=Array.from(g.values());for(const l of E){const D=await l.value;D&&d.push(D)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:o}of d.values())await o.then(g=>g?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,o,g,E,l=!1,D,i){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${g} on local port ${E}.`),!d)return;if(o||(o="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.retainOrCreateTunnel(d,o,g,E,l,D,i);return u?u.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(o,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(n);return(n.tunnelRemoteHost!==o||n.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const o=this._tunnels.get(d.tunnelRemoteHost);if(o){const g=o.get(d.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,g))}}}}async tryDisposeTunnel(d,o,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${o}.`);const E=g.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(o),E}}async closeTunnel(d,o){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${o} `);const g=this._tunnels.get(d);if(g&&g.has(o)){const E=g.get(o);E.refcount=0,await this.tryDisposeTunnel(d,o,E)}}addTunnelToMap(d,o,g){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(o,{refcount:1,value:g})}async removeEmptyTunnelFromMap(d,o){const g=this._tunnels.get(d);g&&(await g.get(o)||g.delete(o),g.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,o){const g=[d];R(d)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):S(d)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const E=g.map(l=>this._tunnels.get(l));for(const l of E){const D=l?.get(o);if(D)return D}}canTunnel(d){return!!P(d)}createWithProvider(d,o,g,E,l,D,i){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${g} on local port ${E}.`);const u=g;this._factoryInProgress.add(u);const r={elevationRequired:l?m(E===void 0?g:E):!1},s={remoteAddress:{host:o,port:g},localAddressPort:E,privacy:D,public:D?D!==A.Private:void 0,protocol:i},t=d.forwardPort(s,r);return t?(this.addTunnelToMap(o,g,t),t.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),t}};f=ze([$e(0,M.ILogService)],f),e.AbstractTunnelService=f}),define(Ce[157],Ie([1,0,12]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function p(b){return b.scheme!==a.Schemas.file&&b.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=p;function w(b){if(b.folders.length)return b.folders.every(P=>p(P.uri))?b.folders[0].uri:void 0;if(b.configuration&&p(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=w;function M(b){return w(b)?.scheme}e.getVirtualWorkspaceScheme=M;function y(b){return w(b)?.authority}e.getVirtualWorkspaceAuthority=y;function A(b){return w(b)!==void 0}e.isVirtualWorkspace=A}),define(Ce[45],Ie([1,0,129,19,24,22,2,3,12]),function(ie,e,a,p,w,M,y,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function P(u){const n=u;return typeof n?.id=="string"&&y.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=P;function R(u){if(u.configuration)return{id:u.id,configPath:u.configuration};if(u.folders.length===1)return{id:u.id,uri:u.folders[0].uri}}e.toWorkspaceIdentifier=R;function S(u){const n=u;return typeof n?.id=="string"&&y.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=S;function m(u){const n=u;if(n?.uri)return{id:n.id,uri:y.URI.revive(n.uri)};const r=u;if(r?.configPath)return{id:r.id,configPath:y.URI.revive(r.configPath)};if(u?.id)return{id:u.id}}e.reviveIdentifier=m;var k;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function f(u){const n=u;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=f;function h(u){const n=u;return!!(n&&typeof n=="object"&&y.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=h;class d{constructor(n,r,s,t,c){this._id=n,this._transient=s,this._configuration=t,this._ignorePathCasing=c,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class o{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=o;function g(u){return new o({uri:u,index:0,name:(0,M.basenameOrAuthority)(u)},{uri:u.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(u,n){return M.extUriBiasedIgnorePathCase.isEqualOrParent(u,n.untitledWorkspacesHome)}e.isUntitledWorkspace=E;function l(u){let n;return y.URI.isUri(u)?n=u:n=u.configuration,n?.scheme===b.Schemas.tmp}e.isTemporaryWorkspace=l;function D(u,n){return!E(u,n)&&!l(u)}e.isSavedWorkspace=D;function i(u){return(typeof u=="string"?(0,p.extname)(u):(0,M.extname)(u))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(Ce[62],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(w){this.id=w,this._data=new Map,this._idPool=1}add(w){const M=this._idPool++;return this._data.set(M,w),this.logDebugInfo(),M}get(w,M){return this._data.has(w)?this._data.get(w)[M]:void 0}delete(w){this._data.delete(w),this.logDebugInfo()}logDebugInfo(){!a.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=a,a.enableDebugLogging=!1}),define(Ce[35],Ie([1,0,12,22,3]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this._systemSchemes=new Set(Object.keys(a.Schemas)),this._providerInfo=new Map,this.extUri=new p.ExtUri(A=>{const b=this._providerInfo.get(A.scheme);return!(b===void 0||b&1024)})}$acceptProviderInfos(A,b){b===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,b)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,w.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[28],Ie([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(Ce[158],Ie([1,0,14]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class p{constructor(y,A,b){this._deferredPromises=new Map,this._id=y,this._shared=A,this._storage=b,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new a.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of P.values())R.complete()}catch(R){for(const S of P.values())S.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,y])=>y!==void 0).map(([y])=>y)}get whenReady(){return this._init}get(y,A){let b=this._value[y];return typeof b>"u"&&(b=A),b}update(y,A){this._value[y]=A;const b=this._deferredPromises.get(y);if(b!==void 0)return b.p;const P=new a.DeferredPromise;return this._deferredPromises.set(y,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=p;class w extends p{constructor(y,A){super(y.identifier.value,!0,A),this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=w}),define(Ce[159],Ie([1,0,5,2]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class w{constructor(y){this._notebooksAndEditors=y,this._onDidSaveNotebookDocument=new a.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new a.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(y,A,b,P){const S=this._notebooksAndEditors.getNotebookDocument(p.URI.revive(y)).acceptModelChanged(A.value,b,P);this._onDidChangeNotebookDocument.fire(S)}$acceptDirtyStateChanged(y,A){this._notebooksAndEditors.getNotebookDocument(p.URI.revive(y)).acceptDirty(A)}$acceptModelSaved(y){const A=this._notebooksAndEditors.getNotebookDocument(p.URI.revive(y));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=w}),define(Ce[13],Ie([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class p{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=p});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,p,w){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?w.call(ie,a):w?w.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!p:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ie):p?p.value:e.get(ie)};define(Ce[160],Ie([1,0,26,5]),function(ie,e,a,p){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(A,b){w.set(this,void 0),this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._id=a.ExtensionIdentifier.toKey(A.identifier),Je(this,w,b,"f"),Oe(this,w,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(A){return Oe(this,w,"f").get(this._id,A)}store(A,b){return Oe(this,w,"f").store(this._id,A,b)}delete(A){return Oe(this,w,"f").delete(this._id,A)}}e.ExtensionSecrets=M,w=new WeakMap}),define(Ce[86],Ie([1,0,3,5]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class w{constructor(){this._onDidChangeTelemetryEnabled=new p.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new p.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(y,A){this._level=y,this._productConfig=A||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(y){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=y,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=w,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(Ce[63],Ie([1,0,3,156,5,13]),function(ie,e,a,p,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var y;(function(b){function P(S){return{remoteAddress:S.remoteAddress,localAddress:S.localAddress,public:!!S.public,privacy:S.privacy??(S.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:S.protocol}}b.fromApiTunnel=P;function R(S){return{remoteAddress:{host:S.tunnelRemoteHost,port:S.tunnelRemotePort},localAddress:S.localAddress,public:S.privacy!==p.TunnelPrivacyId.ConstantPrivate&&S.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:S.privacy,protocol:S.protocol}}b.fromServiceTunnel=R})(y=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let A=class{constructor(P){this.onDidChangeTunnels=new w.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,R){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,R){return{dispose:()=>{}}}async $providePortAttributes(P,R,S,m,k){return[]}async $forwardPort(P,R){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=ze([$e(0,M.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,p,w){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?w.call(ie,a):w?w.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!p:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ie):p?p.value:e.get(ie)};define(Ce[6],Ie([1,0,16,11,75,24,74,9,10,2,42,39,84]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m){"use strict";var k,f,h,d,o,g,E,l,D,i,u,n,r,s,t,c,_,v,T,U,V,x,C;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function L($){function N(){return Reflect.construct($,arguments,this.constructor)}return Object.defineProperty(N,"name",Object.getOwnPropertyDescriptor($,"name")),Object.setPrototypeOf(N,$),Object.setPrototypeOf(N.prototype,$.prototype),N}let B=g=class{constructor(N){k.set(this,void 0),Je(this,k,N,"f")}static from(...N){let Y=N;return new g(function(){if(Y){for(const _e of Y)_e&&typeof _e.dispose=="function"&&_e.dispose();Y=void 0}})}dispose(){typeof Oe(this,k,"f")=="function"&&(Oe(this,k,"f").call(this),Je(this,k,void 0,"f"))}};k=new WeakMap,B=g=ze([L],B),e.Disposable=B;let F=E=class{constructor(N,Y){if(N<0)throw(0,p.illegalArgument)("line must be non-negative");if(Y<0)throw(0,p.illegalArgument)("character must be non-negative");this._line=N,this._character=Y}static Min(...N){if(N.length===0)throw new TypeError;let Y=N[0];for(let _e=1;_e<N.length;_e++){const Ke=N[_e];Ke.isBefore(Y)&&(Y=Ke)}return Y}static Max(...N){if(N.length===0)throw new TypeError;let Y=N[0];for(let _e=1;_e<N.length;_e++){const Ke=N[_e];Ke.isAfter(Y)&&(Y=Ke)}return Y}static isPosition(N){if(!N)return!1;if(N instanceof E)return!0;const{line:Y,character:_e}=N;return typeof Y=="number"&&typeof _e=="number"}static of(N){if(N instanceof E)return N;if(this.isPosition(N))return new E(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<N._character}isBeforeOrEqual(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<=N._character}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this._line===N._line&&this._character===N._character}compareTo(N){return this._line<N._line?-1:this._line>N.line?1:this._character<N._character?-1:this._character>N._character?1:0}translate(N,Y=0){if(N===null||Y===null)throw(0,p.illegalArgument)();let _e;return typeof N>"u"?_e=0:typeof N=="number"?_e=N:(_e=typeof N.lineDelta=="number"?N.lineDelta:0,Y=typeof N.characterDelta=="number"?N.characterDelta:0),_e===0&&Y===0?this:new E(this.line+_e,this.character+Y)}with(N,Y=this.character){if(N===null||Y===null)throw(0,p.illegalArgument)();let _e;return typeof N>"u"?_e=this.line:typeof N=="number"?_e=N:(_e=typeof N.line=="number"?N.line:this.line,Y=typeof N.character=="number"?N.character:this.character),_e===this.line&&Y===this.character?this:new E(_e,Y)}toJSON(){return{line:this.line,character:this.character}}};F=E=ze([L],F),e.Position=F;let K=l=class{constructor(N,Y,_e,Ke){let tt,lt;if(typeof N=="number"&&typeof Y=="number"&&typeof _e=="number"&&typeof Ke=="number"?(tt=new F(N,Y),lt=new F(_e,Ke)):F.isPosition(N)&&F.isPosition(Y)&&(tt=F.of(N),lt=F.of(Y)),!tt||!lt)throw new Error("Invalid arguments");tt.isBefore(lt)?(this._start=tt,this._end=lt):(this._start=lt,this._end=tt)}static isRange(N){return N instanceof l?!0:N?F.isPosition(N.start)&&F.isPosition(N.end):!1}static of(N){if(N instanceof l)return N;if(this.isRange(N))return new l(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(N){return l.isRange(N)?this.contains(N.start)&&this.contains(N.end):F.isPosition(N)?!(F.of(N).isBefore(this._start)||this._end.isBefore(N)):!1}isEqual(N){return this._start.isEqual(N._start)&&this._end.isEqual(N._end)}intersection(N){const Y=F.Max(N.start,this._start),_e=F.Min(N.end,this._end);if(!Y.isAfter(_e))return new l(Y,_e)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const Y=F.Min(N.start,this._start),_e=F.Max(N.end,this.end);return new l(Y,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(N,Y=this.end){if(N===null||Y===null)throw(0,p.illegalArgument)();let _e;return N?F.isPosition(N)?_e=N:(_e=N.start||this.start,Y=N.end||this.end):_e=this.start,_e.isEqual(this._start)&&Y.isEqual(this.end)?this:new l(_e,Y)}toJSON(){return[this.start,this.end]}};K=l=ze([L],K),e.Range=K;let H=D=class extends K{constructor(N,Y,_e,Ke){let tt,lt;if(typeof N=="number"&&typeof Y=="number"&&typeof _e=="number"&&typeof Ke=="number"?(tt=new F(N,Y),lt=new F(_e,Ke)):F.isPosition(N)&&F.isPosition(Y)&&(tt=F.of(N),lt=F.of(Y)),!tt||!lt)throw new Error("Invalid arguments");super(tt,lt),this._anchor=tt,this._active=lt}static isSelection(N){return N instanceof D?!0:N?K.isRange(N)&&F.isPosition(N.anchor)&&F.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};H=D=ze([L],H),e.Selection=H;class O{constructor(N,Y,_e){if(typeof N!="string"||N.length===0)throw(0,p.illegalArgument)("host");if(typeof Y!="number"||Y===0||Math.round(Y)!==Y)throw(0,p.illegalArgument)("port");if(typeof _e<"u"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,p.illegalArgument)("connectionToken");this.host=N,this.port=Math.round(Y),this.connectionToken=_e}}e.ResolvedAuthority=O;class ee extends Error{constructor(N,Y=m.RemoteAuthorityResolverErrorCode.Unknown,_e){super(N),this._message=N,this._code=Y,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ee.prototype)}static NotAvailable(N,Y){return new ee(N,m.RemoteAuthorityResolverErrorCode.NotAvailable,Y)}static TemporarilyNotAvailable(N){return new ee(N,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ee;var ue;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(ue=e.EndOfLine||(e.EndOfLine={}));var oe;(function($){$[$.Replace=1]="Replace",$[$.Append=2]="Append",$[$.Prepend=3]="Prepend"})(oe=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let le=i=class{constructor(N,Y){this._range=N,this._newText=Y}static isTextEdit(N){return N instanceof i?!0:N?K.isRange(N)&&typeof N.newText=="string":!1}static replace(N,Y){return new i(N,Y)}static insert(N,Y){return i.replace(new K(N,N),Y)}static delete(N){return i.replace(N,"")}static setEndOfLine(N){const Y=new i(new K(new F(0,0),new F(0,0)),"");return Y.newEol=N,Y}get range(){return this._range}set range(N){if(N&&!K.isRange(N))throw(0,p.illegalArgument)("range");this._range=N}get newText(){return this._newText||""}set newText(N){if(N&&typeof N!="string")throw(0,p.illegalArgument)("newText");this._newText=N}get newEol(){return this._newEol}set newEol(N){if(N&&typeof N!="number")throw(0,p.illegalArgument)("newEol");this._newEol=N}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};le=i=ze([L],le),e.TextEdit=le;let te=u=class{constructor(N,Y){this.range=N,this.newCells=Y}static isNotebookCellEdit(N){return N instanceof u?!0:N?Vt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,Y){return new u(N,Y)}static insertCells(N,Y){return new u(new Vt(N,N),Y)}static deleteCells(N){return new u(N,[])}static updateCellMetadata(N,Y){const _e=new u(new Vt(N,N),[]);return _e.newCellMetadata=Y,_e}static updateNotebookMetadata(N){const Y=new u(new Vt(0,0),[]);return Y.newNotebookMetadata=N,Y}};te=u=ze([L],te),e.NotebookEdit=te;var Ee;(function($){$[$.File=1]="File",$[$.Text=2]="Text",$[$.Cell=3]="Cell",$[$.CellReplace=5]="CellReplace",$[$.Snippet=6]="Snippet"})(Ee=e.FileEditType||(e.FileEditType={}));let be=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(N,Y,_e,Ke){this._edits.push({_type:1,from:N,to:Y,options:_e,metadata:Ke})}createFile(N,Y,_e){this._edits.push({_type:1,from:void 0,to:N,options:Y,metadata:_e})}deleteFile(N,Y,_e){this._edits.push({_type:1,from:N,to:void 0,options:Y,metadata:_e})}replaceNotebookMetadata(N,Y,_e){this._edits.push({_type:3,metadata:_e,uri:N,edit:{editType:5,metadata:Y},notebookMetadata:Y})}replaceNotebookCells(N,Y,_e,Ke){const tt=Y.start,lt=Y.end;(tt!==lt||_e.length>0)&&this._edits.push({_type:5,uri:N,index:tt,count:lt-tt,cells:_e,metadata:Ke})}replaceNotebookCellMetadata(N,Y,_e,Ke){this._edits.push({_type:3,metadata:Ke,uri:N,edit:{editType:8,index:Y,metadata:_e}})}replace(N,Y,_e,Ke){typeof _e=="string"?this._edits.push({_type:2,uri:N,edit:new le(Y,_e),metadata:Ke}):this._edits.push({_type:6,uri:N,range:Y,edit:_e,metadata:Ke})}insert(N,Y,_e,Ke){this.replace(N,new K(Y,Y),_e,Ke)}delete(N,Y,_e){this.replace(N,Y,"",_e)}has(N){return this._edits.some(Y=>Y._type===2&&Y.uri.toString()===N.toString())}set(N,Y){if(Y)for(const _e of Y)_e&&(te.isNotebookCellEdit(_e)?_e.newCellMetadata?this.replaceNotebookCellMetadata(N,_e.range.start,_e.newCellMetadata):_e.newNotebookMetadata?this.replaceNotebookMetadata(N,_e.newNotebookMetadata):this.replaceNotebookCells(N,_e.range,_e.newCells):this._edits.push({_type:2,uri:N,edit:_e}));else{for(let _e=0;_e<this._edits.length;_e++){const Ke=this._edits[_e];Ke._type===2&&Ke.uri.toString()===N.toString()&&(this._edits[_e]=void 0)}(0,a.coalesceInPlace)(this._edits)}}get(N){const Y=[];for(const _e of this._edits)_e._type===2&&_e.uri.toString()===N.toString()&&Y.push(_e.edit);return Y}entries(){const N=new M.ResourceMap;for(const Y of this._edits)if(Y._type===2){let _e=N.get(Y.uri);_e||(_e=[Y.uri,[]],N.set(Y.uri,_e)),_e[1].push(Y.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};be=ze([L],be),e.WorkspaceEdit=be;let ne=n=class{constructor(N){this._tabstop=1,this.value=N||""}static isSnippetString(N){return N instanceof n?!0:N?typeof N.value=="string":!1}static _escape(N){return N.replace(/\$|}|\\/g,"\\$&")}appendText(N){return this.value+=n._escape(N),this}appendTabstop(N=this._tabstop++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,Y=this._tabstop++){if(typeof N=="function"){const _e=new n;_e._tabstop=this._tabstop,N(_e),this._tabstop=_e._tabstop,N=_e.value}else N=n._escape(N);return this.value+="${",this.value+=Y,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,Y=this._tabstop++){const _e=N.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Y,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(N,Y){if(typeof Y=="function"){const _e=new n;_e._tabstop=this._tabstop,Y(_e),this._tabstop=_e._tabstop,Y=_e.value}else typeof Y=="string"&&(Y=Y.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,Y&&(this.value+=":",this.value+=Y),this.value+="}",this}};ne=n=ze([L],ne),e.SnippetString=ne;var ve;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(ve=e.DiagnosticTag||(e.DiagnosticTag={}));var Pe;(function($){$[$.Hint=3]="Hint",$[$.Information=2]="Information",$[$.Warning=1]="Warning",$[$.Error=0]="Error"})(Pe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Fe=r=class{constructor(N,Y){if(this.uri=N,Y)if(K.isRange(Y))this.range=K.of(Y);else if(F.isPosition(Y))this.range=new K(Y,Y);else throw new Error("Illegal argument")}static isLocation(N){return N instanceof r?!0:N?K.isRange(N.range)&&P.URI.isUri(N.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Fe=r=ze([L],Fe),e.Location=Fe;let xe=class{constructor(N,Y){this.location=N,this.message=Y}static is(N){return N?typeof N.message=="string"&&N.location&&K.isRange(N.location.range)&&P.URI.isUri(N.location.uri):!1}static isEqual(N,Y){return N===Y?!0:!N||!Y?!1:N.message===Y.message&&N.location.range.isEqual(Y.location.range)&&N.location.uri.toString()===Y.location.uri.toString()}};xe=ze([L],xe),e.DiagnosticRelatedInformation=xe;let Qe=class{constructor(N,Y,_e=Pe.Error){if(!K.isRange(N))throw new TypeError("range must be set");if(!Y)throw new TypeError("message must be set");this.range=N,this.message=Y,this.severity=_e}toJSON(){return{severity:Pe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,Y){return N===Y?!0:!N||!Y?!1:N.message===Y.message&&N.severity===Y.severity&&N.code===Y.code&&N.severity===Y.severity&&N.source===Y.source&&N.range.isEqual(Y.range)&&(0,a.equals)(N.tags,Y.tags)&&(0,a.equals)(N.relatedInformation,Y.relatedInformation,xe.isEqual)}};Qe=ze([L],Qe),e.Diagnostic=Qe;let ke=class{constructor(N,Y){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=Y}};ke=ze([L],ke),e.Hover=ke;var Se;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(Se=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ye=class{constructor(N,Y=Se.Text){this.range=N,this.kind=Y}toJSON(){return{range:this.range,kind:Se[this.kind]}}};ye=ze([L],ye),e.DocumentHighlight=ye;var ae;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(ae=e.SymbolKind||(e.SymbolKind={}));var ce;(function($){$[$.Deprecated=1]="Deprecated"})(ce=e.SymbolTag||(e.SymbolTag={}));let Q=s=class{constructor(N,Y,_e,Ke,tt){this.name=N,this.kind=Y,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),Ke instanceof Fe?this.location=Ke:_e instanceof K&&(this.location=new Fe(Ke,_e)),s.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ae[this.kind],location:this.location,containerName:this.containerName}}};Q=s=ze([L],Q),e.SymbolInformation=Q;let J=t=class{constructor(N,Y,_e,Ke,tt){this.name=N,this.detail=Y,this.kind=_e,this.range=Ke,this.selectionRange=tt,this.children=[],t.validate(this)}static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(t.validate)}};J=t=ze([L],J),e.DocumentSymbol=J;var I;(function($){$[$.Invoke=1]="Invoke",$[$.Automatic=2]="Automatic"})(I=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let z=class{constructor(N,Y){this.title=N,this.kind=Y}};z=ze([L],z),e.CodeAction=z;let W=c=class{constructor(N){this.value=N}append(N){return new c(this.value?this.value+c.sep+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+c.sep)}};W.sep=".",W=c=ze([L],W),e.CodeActionKind=W,W.Empty=new W(""),W.QuickFix=W.Empty.append("quickfix"),W.Refactor=W.Empty.append("refactor"),W.RefactorExtract=W.Refactor.append("extract"),W.RefactorInline=W.Refactor.append("inline"),W.RefactorRewrite=W.Refactor.append("rewrite"),W.Source=W.Empty.append("source"),W.SourceOrganizeImports=W.Source.append("organizeImports"),W.SourceFixAll=W.Source.append("fixAll");let j=class{constructor(N,Y){if(this.range=N,this.parent=Y,Y&&!Y.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};j=ze([L],j),e.SelectionRange=j;class re{constructor(N,Y,_e,Ke,tt,lt){this.kind=N,this.name=Y,this.detail=_e,this.uri=Ke,this.range=tt,this.selectionRange=lt}}e.CallHierarchyItem=re;class de{constructor(N,Y){this.fromRanges=Y,this.from=N}}e.CallHierarchyIncomingCall=de;class Z{constructor(N,Y){this.fromRanges=Y,this.to=N}}e.CallHierarchyOutgoingCall=Z;var pe;(function($){$[$.Information=0]="Information",$[$.Warning=1]="Warning",$[$.Error=2]="Error"})(pe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let ge=class{constructor(N,Y){this.range=N,this.command=Y}get isResolved(){return!!this.command}};ge=ze([L],ge),e.CodeLens=ge;let Ne=_=class{constructor(N,Y=!1){f.set(this,void 0),Je(this,f,new w.MarkdownString(N,{supportThemeIcons:Y}),"f")}static isMarkdownString(N){return N instanceof _?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}get value(){return Oe(this,f,"f").value}set value(N){Oe(this,f,"f").value=N}get isTrusted(){return Oe(this,f,"f").isTrusted}set isTrusted(N){Oe(this,f,"f").isTrusted=N}get supportThemeIcons(){return Oe(this,f,"f").supportThemeIcons}set supportThemeIcons(N){Oe(this,f,"f").supportThemeIcons=N}get supportHtml(){return Oe(this,f,"f").supportHtml}set supportHtml(N){Oe(this,f,"f").supportHtml=N}get baseUri(){return Oe(this,f,"f").baseUri}set baseUri(N){Oe(this,f,"f").baseUri=N}appendText(N){return Oe(this,f,"f").appendText(N),this}appendMarkdown(N){return Oe(this,f,"f").appendMarkdown(N),this}appendCodeblock(N,Y){return Oe(this,f,"f").appendCodeblock(Y??"",N),this}};f=new WeakMap,Ne=_=ze([L],Ne),e.MarkdownString=Ne;let Be=class{constructor(N,Y){this.label=N,this.documentation=Y}};Be=ze([L],Be),e.ParameterInformation=Be;let Ye=class{constructor(N,Y){this.label=N,this.documentation=Y,this.parameters=[]}};Ye=ze([L],Ye),e.SignatureInformation=Ye;let Xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Xe=ze([L],Xe),e.SignatureHelp=Xe;var Te;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})(Te=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var nt;(function($){$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(nt=e.InlayHintKind||(e.InlayHintKind={}));let G=class{constructor(N){this.value=N}};G=ze([L],G),e.InlayHintLabelPart=G;let X=class{constructor(N,Y,_e){this.position=N,this.label=Y,this.kind=_e}};X=ze([L],X),e.InlayHint=X;var fe;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function($){$[$.Text=0]="Text",$[$.Method=1]="Method",$[$.Function=2]="Function",$[$.Constructor=3]="Constructor",$[$.Field=4]="Field",$[$.Variable=5]="Variable",$[$.Class=6]="Class",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Unit=10]="Unit",$[$.Value=11]="Value",$[$.Enum=12]="Enum",$[$.Keyword=13]="Keyword",$[$.Snippet=14]="Snippet",$[$.Color=15]="Color",$[$.File=16]="File",$[$.Reference=17]="Reference",$[$.Folder=18]="Folder",$[$.EnumMember=19]="EnumMember",$[$.Constant=20]="Constant",$[$.Struct=21]="Struct",$[$.Event=22]="Event",$[$.Operator=23]="Operator",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue"})(Ue=e.CompletionItemKind||(e.CompletionItemKind={}));var He;(function($){$[$.Deprecated=1]="Deprecated"})(He=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(N,Y){this.label=N,this.kind=Y}toJSON(){return{label:this.label,kind:this.kind&&Ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=ze([L],Ze),e.CompletionItem=Ze;let je=class{constructor(N=[],Y=!1){this.items=N,this.isIncomplete=Y}};je=ze([L],je),e.CompletionList=je;let We=class{constructor(N,Y,_e){this.insertText=N,this.range=Y,this.command=_e}};We=ze([L],We),e.InlineSuggestion=We;let it=class{constructor(N){this.commands=void 0,this.items=N}};it=ze([L],it),e.InlineSuggestionList=it;let rt=class{constructor(N,Y,_e){this.insertText=N,this.range=Y,this.command=_e}};rt=ze([L],rt),e.InlineSuggestionNew=rt;let dt=class{constructor(N,Y){this.items=N,this.commands=Y}};dt=ze([L],dt),e.InlineSuggestionsNew=dt;var at;(function($){$[$.Active=-1]="Active",$[$.Beside=-2]="Beside",$[$.One=1]="One",$[$.Two=2]="Two",$[$.Three=3]="Three",$[$.Four=4]="Four",$[$.Five=5]="Five",$[$.Six=6]="Six",$[$.Seven=7]="Seven",$[$.Eight=8]="Eight",$[$.Nine=9]="Nine"})(at=e.ViewColumn||(e.ViewColumn={}));var st;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(st=e.StatusBarAlignment||(e.StatusBarAlignment={}));var yt;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative"})(yt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Rt;(function($){$[$.Manual=1]="Manual",$[$.AfterDelay=2]="AfterDelay",$[$.FocusOut=3]="FocusOut"})(Rt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ot;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(Ot=e.TextEditorRevealType||(e.TextEditorRevealType={}));var mt;(function($){$[$.Keyboard=1]="Keyboard",$[$.Mouse=2]="Mouse",$[$.Command=3]="Command"})(mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Dt;(function($){$[$.Undo=1]="Undo",$[$.Redo=2]="Redo"})(Dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Lt;(function($){$[$.OpenOpen=0]="OpenOpen",$[$.ClosedClosed=1]="ClosedClosed",$[$.OpenClosed=2]="OpenClosed",$[$.ClosedOpen=3]="ClosedOpen"})(Lt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function($){function N(Y){switch(Y){case"keyboard":return $.Keyboard;case"mouse":return $.Mouse;case"api":return $.Command}}$.fromValue=N}(mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ft=class{constructor(N,Y){if(Y&&!P.URI.isUri(Y))throw(0,p.illegalArgument)("target");if(!K.isRange(N)||N.isEmpty)throw(0,p.illegalArgument)("range");this.range=N,this.target=Y}};Ft=ze([L],Ft),e.DocumentLink=Ft;let Ve=class{constructor(N,Y,_e,Ke){this.red=N,this.green=Y,this.blue=_e,this.alpha=Ke}};Ve=ze([L],Ve),e.Color=Ve;let Nt=class{constructor(N,Y){if(Y&&!(Y instanceof Ve))throw(0,p.illegalArgument)("color");if(!K.isRange(N)||N.isEmpty)throw(0,p.illegalArgument)("range");this.range=N,this.color=Y}};Nt=ze([L],Nt),e.ColorInformation=Nt;let Tt=class{constructor(N){if(!N||typeof N!="string")throw(0,p.illegalArgument)("label");this.label=N}};Tt=ze([L],Tt),e.ColorPresentation=Tt;var Mt;(function($){$[$.RGB=0]="RGB",$[$.HEX=1]="HEX",$[$.HSL=2]="HSL"})(Mt=e.ColorFormat||(e.ColorFormat={}));var pt;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information"})(pt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Ct;(function($){$[$.Unknown=0]="Unknown",$[$.Shutdown=1]="Shutdown",$[$.Process=2]="Process",$[$.User=3]="User",$[$.Extension=4]="Extension"})(Ct=e.TerminalExitReason||(e.TerminalExitReason={}));class we{constructor(N,Y,_e){if(this.startIndex=N,this.length=Y,this.tooltip=_e,typeof N!="number"||N<0)throw(0,p.illegalArgument)("startIndex");if(typeof Y!="number"||Y<1)throw(0,p.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,p.illegalArgument)("tooltip")}}e.TerminalLink=we;var De;(function($){$[$.Panel=1]="Panel",$[$.Editor=2]="Editor"})(De=e.TerminalLocation||(e.TerminalLocation={}));class me{constructor(N){if(this.options=N,typeof N!="object")throw(0,p.illegalArgument)("options")}}e.TerminalProfile=me;var q;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(q=e.TaskRevealKind||(e.TaskRevealKind={}));var Ae;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(Ae=e.TaskPanelKind||(e.TaskPanelKind={}));let Le=v=class{constructor(N,Y){if(this.label=Y,typeof N!="string"||typeof Y!="string")throw(0,p.illegalArgument)("name");this._id=N}static from(N){switch(N){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}get id(){return this._id}};Le.Clean=new v("clean","Clean"),Le.Build=new v("build","Build"),Le.Rebuild=new v("rebuild","Rebuild"),Le.Test=new v("test","Test"),Le=v=ze([L],Le),e.TaskGroup=Le;function et($){let N="";for(let Y=0;Y<$.length;Y++)N+=$[Y].replace(/,/g,",,")+",";return N}let qe=class{constructor(N,Y,_e){if(typeof N!="string")throw(0,p.illegalArgument)("process");this._args=[],this._process=N,Y!==void 0&&(Array.isArray(Y)?(this._args=Y,this._options=_e):this._options=Y)}get process(){return this._process}set process(N){if(typeof N!="string")throw(0,p.illegalArgument)("process");this._process=N}get args(){return this._args}set args(N){Array.isArray(N)||(N=[]),this._args=N}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("process"),this._process!==void 0&&N.push(this._process),this._args&&this._args.length>0)for(const Y of this._args)N.push(Y);return et(N)}};qe=ze([L],qe),e.ProcessExecution=qe;let Ge=class{constructor(N,Y,_e){if(this._args=[],Array.isArray(Y)){if(!N)throw(0,p.illegalArgument)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,p.illegalArgument)("command");this._command=N,this._args=Y,this._options=_e}else{if(typeof N!="string")throw(0,p.illegalArgument)("commandLine");this._commandLine=N,this._options=Y}}get commandLine(){return this._commandLine}set commandLine(N){if(typeof N!="string")throw(0,p.illegalArgument)("commandLine");this._commandLine=N}get command(){return this._command?this._command:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,p.illegalArgument)("command");this._command=N}get args(){return this._args}set args(N){this._args=N||[]}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("shell"),this._commandLine!==void 0&&N.push(this._commandLine),this._command!==void 0&&N.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const Y of this._args)N.push(typeof Y=="string"?Y:Y.value);return et(N)}};Ge=ze([L],Ge),e.ShellExecution=Ge;var ct;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(ct=e.ShellQuoting||(e.ShellQuoting={}));var It;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace"})(It=e.TaskScope||(e.TaskScope={}));class Et{constructor(N){this._callback=N}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(N){this._callback=N}get callback(){return this._callback}}e.CustomExecution=Et;let wt=T=class{constructor(N,Y,_e,Ke,tt,lt){this.__deprecated=!1,this._definition=this.definition=N;let ht;typeof Y=="string"?(this._name=this.name=Y,this._source=this.source=_e,this.execution=Ke,ht=tt,this.__deprecated=!0):Y===It.Global||Y===It.Workspace?(this.target=Y,this._name=this.name=_e,this._source=this.source=Ke,this.execution=tt,ht=lt):(this.target=Y,this._name=this.name=_e,this._source=this.source=Ke,this.execution=tt,ht=lt),typeof ht=="string"?(this._problemMatchers=[ht],this._hasDefinedMatchers=!0):Array.isArray(ht)?(this._problemMatchers=ht,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(N){this.__id=N}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof qe?this._definition={type:T.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ge?this._definition={type:T.ShellType,id:this._execution.computeId()}:this._execution instanceof Et?this._definition={type:T.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:T.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(N){if(N==null)throw(0,p.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=N}get scope(){return this._scope}set target(N){this.clear(),this._scope=N}get name(){return this._name}set name(N){if(typeof N!="string")throw(0,p.illegalArgument)("name");this.clear(),this._name=N}get execution(){return this._execution}set execution(N){N===null&&(N=void 0),this.clear(),this._execution=N;const Y=this._definition.type;(T.EmptyType===Y||T.ProcessType===Y||T.ShellType===Y||T.ExtensionCallbackType===Y)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(N){if(Array.isArray(N))this.clear(),this._problemMatchers=N,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.clear(),this._isBackground=N}get source(){return this._source}set source(N){if(typeof N!="string"||N.length===0)throw(0,p.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=N}get group(){return this._group}set group(N){N===null&&(N=void 0),this.clear(),this._group=N}get detail(){return this._detail}set detail(N){N===null&&(N=void 0),this._detail=N}get presentationOptions(){return this._presentationOptions}set presentationOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._presentationOptions=N}get runOptions(){return this._runOptions}set runOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._runOptions=N}};wt.ExtensionCallbackType="customExecution",wt.ProcessType="process",wt.ShellType="shell",wt.EmptyType="$empty",wt=T=ze([L],wt),e.Task=wt;var _t;(function($){$[$.SourceControl=1]="SourceControl",$[$.Window=10]="Window",$[$.Notification=15]="Notification"})(_t=e.ProgressLocation||(e.ProgressLocation={}));let gt=U=class{constructor(N,Y=St.None){this.collapsibleState=Y,P.URI.isUri(N)?this.resourceUri=N:this.label=N}static isTreeItem(N){if(N instanceof U)return!0;const Y=N;if(Y.label!==void 0&&!(0,b.isString)(Y.label)&&!Y.label?.label)return console.log("INVALID tree item, invalid label",Y.label),!1;if(Y.id!==void 0&&!(0,b.isString)(Y.id))return console.log("INVALID tree item, invalid id",Y.id),!1;if(Y.iconPath!==void 0&&!(0,b.isString)(Y.iconPath)&&!P.URI.isUri(Y.iconPath)&&(!Y.iconPath||!(0,b.isString)(Y.iconPath.id))){const _e=Y.iconPath;if(!_e||!(0,b.isString)(_e.light)&&!P.URI.isUri(_e.light)&&!(0,b.isString)(_e.dark)&&!P.URI.isUri(_e.dark))return console.log("INVALID tree item, invalid iconPath",Y.iconPath),!1}return Y.description!==void 0&&!(0,b.isString)(Y.description)&&typeof Y.description!="boolean"?(console.log("INVALID tree item, invalid description",Y.description),!1):Y.resourceUri!==void 0&&!P.URI.isUri(Y.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Y.resourceUri),!1):Y.tooltip!==void 0&&!(0,b.isString)(Y.tooltip)&&!(Y.tooltip instanceof Ne)?(console.log("INVALID tree item, invalid tooltip",Y.tooltip),!1):Y.command!==void 0&&!Y.command.command?(console.log("INVALID tree item, invalid command",Y.command),!1):Y.collapsibleState!==void 0&&Y.collapsibleState<St.None&&Y.collapsibleState>St.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Y.collapsibleState),!1):Y.contextValue!==void 0&&!(0,b.isString)(Y.contextValue)?(console.log("INVALID tree item, invalid contextValue",Y.contextValue),!1):Y.accessibilityInformation!==void 0&&!Y.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Y.accessibilityInformation),!1):!0}};gt=U=ze([L],gt),e.TreeItem=gt;var St;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(St=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Qt=class{constructor(N){this.value=N}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};Qt=ze([L],Qt),e.DataTransferItem=Qt;let vt=class{constructor(N){h.set(this,new Map);for(const[Y,_e]of N??[]){const Ke=Oe(this,h,"f").get(Y);Ke?Ke.push(_e):Oe(this,h,"f").set(Y,[_e])}}get(N){return Oe(this,h,"f").get(N)?.[0]}set(N,Y){Oe(this,h,"f").set(N,[Y])}forEach(N,Y){for(const[_e,Ke]of Oe(this,h,"f"))for(const tt of Ke)N.call(Y,tt,_e,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[N,Y]of Oe(this,h,"f"))for(const _e of Y)yield[N,_e]}};vt=ze([L],vt),e.DataTransfer=vt;let qt=class{constructor(N){this.insertText=N}};qt=ze([L],qt),e.DocumentDropEdit=qt;let Wt=class{constructor(N){this.insertText=N}};Wt=ze([L],Wt),e.DocumentPasteEdit=Wt;let zt=class{constructor(N,Y){this.id=N,this.color=Y}};zt=ze([L],zt),e.ThemeIcon=zt,zt.File=new zt("file"),zt.Folder=new zt("folder");let fi=class{constructor(N){this.id=N}};fi=ze([L],fi),e.ThemeColor=fi;var Pt;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ri=class{constructor(N,Y){if(typeof N!="string"&&(!N||!P.URI.isUri(N)&&!P.URI.isUri(N.uri)))throw(0,p.illegalArgument)("base");if(typeof Y!="string")throw(0,p.illegalArgument)("pattern");typeof N=="string"?this.baseUri=P.URI.file(N):P.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=Y}get base(){return this._base}set base(N){this._base=N,this._baseUri=P.URI.file(N)}get baseUri(){return this._baseUri}set baseUri(N){this._baseUri=N,this._base=N.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ri=ze([L],ri),e.RelativePattern=ri;let Yt=class{constructor(N,Y,_e,Ke){this.enabled=typeof N=="boolean"?N:!0,typeof Y=="string"&&(this.condition=Y),typeof _e=="string"&&(this.hitCondition=_e),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};Yt=ze([L],Yt),e.Breakpoint=Yt;let Jt=class extends Yt{constructor(N,Y,_e,Ke,tt){if(super(Y,_e,Ke,tt),N===null)throw(0,p.illegalArgument)("location");this.location=N}};Jt=ze([L],Jt),e.SourceBreakpoint=Jt;let Zt=class extends Yt{constructor(N,Y,_e,Ke,tt){super(Y,_e,Ke,tt),this.functionName=N}};Zt=ze([L],Zt),e.FunctionBreakpoint=Zt;let ut=class extends Yt{constructor(N,Y,_e,Ke,tt,lt,ht){if(super(Ke,tt,lt,ht),!Y)throw(0,p.illegalArgument)("dataId");this.label=N,this.dataId=Y,this.canPersist=_e}};ut=ze([L],ut),e.DataBreakpoint=ut;let mi=class{constructor(N,Y,_e){this.command=N,this.args=Y||[],this.options=_e}};mi=ze([L],mi),e.DebugAdapterExecutable=mi;let xt=class{constructor(N,Y){this.port=N,this.host=Y}};xt=ze([L],xt),e.DebugAdapterServer=xt;let Kt=class{constructor(N){this.path=N}};Kt=ze([L],Kt),e.DebugAdapterNamedPipeServer=Kt;let si=class{constructor(N){this.implementation=N}};si=ze([L],si),e.DebugAdapterInlineImplementation=si;let gi=class{constructor(N,Y){this.range=N,this.expression=Y}};gi=ze([L],gi),e.EvaluatableExpression=gi;var yi;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(yi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var Pi;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(Pi=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let oi=class{constructor(N,Y){this.range=N,this.text=Y}};oi=ze([L],oi),e.InlineValueText=oi;let ei=class{constructor(N,Y,_e=!0){this.range=N,this.variableName=Y,this.caseSensitiveLookup=_e}};ei=ze([L],ei),e.InlineValueVariableLookup=ei;let pi=class{constructor(N,Y){this.range=N,this.expression=Y}};pi=ze([L],pi),e.InlineValueEvaluatableExpression=pi;let ii=class{constructor(N,Y){this.frameId=N,this.stoppedLocation=Y}};ii=ze([L],ii),e.InlineValueContext=ii;var vi;(function($){$[$.Changed=1]="Changed",$[$.Created=2]="Created",$[$.Deleted=3]="Deleted"})(vi=e.FileChangeType||(e.FileChangeType={}));let Ei=V=class extends Error{constructor(N,Y=S.FileSystemProviderErrorCode.Unknown,_e){super(P.URI.isUri(N)?N.toString(!0):N),this.code=_e?.name??"Unknown",(0,S.markAsFileSystemProviderError)(this,Y),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(N){return new V(N,S.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(N){return new V(N,S.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(N){return new V(N,S.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(N){return new V(N,S.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(N){return new V(N,S.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(N){return new V(N,S.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}};Ei=V=ze([L],Ei),e.FileSystemError=Ei;let bi=class{constructor(N,Y,_e){this.start=N,this.end=Y,this.kind=_e}};bi=ze([L],bi),e.FoldingRange=bi;var ni;(function($){$[$.Comment=1]="Comment",$[$.Imports=2]="Imports",$[$.Region=3]="Region"})(ni=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ai;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})(Ai=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Ri;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(Ri=e.CommentMode||(e.CommentMode={}));var Oi;(function($){$[$.Unresolved=0]="Unresolved",$[$.Resolved=1]="Resolved"})(Oi=e.CommentThreadState||(e.CommentThreadState={}));class Fi{constructor(N,Y=[]){this.tokenTypes=N,this.tokenModifiers=Y}}e.SemanticTokensLegend=Fi;function wi($){return typeof $>"u"||(0,b.isStringArray)($)}class ai{constructor(N){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,N){this._hasLegend=!0;for(let Y=0,_e=N.tokenTypes.length;Y<_e;Y++)this._tokenTypeStrToInt.set(N.tokenTypes[Y],Y);for(let Y=0,_e=N.tokenModifiers.length;Y<_e;Y++)this._tokenModifierStrToInt.set(N.tokenModifiers[Y],Y)}}push(N,Y,_e,Ke,tt){if(typeof N=="number"&&typeof Y=="number"&&typeof _e=="number"&&typeof Ke=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this._pushEncoded(N,Y,_e,Ke,tt);if(K.isRange(N)&&typeof Y=="string"&&wi(_e))return this._push(N,Y,_e);throw(0,p.illegalArgument)()}_push(N,Y,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Y))throw new Error("`tokenType` is not in the provided legend");const Ke=N.start.line,tt=N.start.character,lt=N.end.character-N.start.character,ht=this._tokenTypeStrToInt.get(Y);let At=0;if(_e)for(const Bt of _e){if(!this._tokenModifierStrToInt.has(Bt))throw new Error("`tokenModifier` is not in the provided legend");const $t=this._tokenModifierStrToInt.get(Bt);At|=1<<$t>>>0}this._pushEncoded(Ke,tt,lt,ht,At)}_pushEncoded(N,Y,_e,Ke,tt){if(this._dataIsSortedAndDeltaEncoded&&(N<this._prevLine||N===this._prevLine&&Y<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const At=this._data.length/5|0;let Bt=0,$t=0;for(let jt=0;jt<At;jt++){let Gt=this._data[5*jt],_i=this._data[5*jt+1];Gt===0?(Gt=Bt,_i+=$t):Gt+=Bt,this._data[5*jt]=Gt,this._data[5*jt+1]=_i,Bt=Gt,$t=_i}}let lt=N,ht=Y;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(ht-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ht,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=tt,this._prevLine=N,this._prevChar=Y}static _sortAndDeltaEncode(N){const Y=[],_e=N.length/5|0;for(let ht=0;ht<_e;ht++)Y[ht]=ht;Y.sort((ht,At)=>{const Bt=N[5*ht],$t=N[5*At];if(Bt===$t){const jt=N[5*ht+1],Gt=N[5*At+1];return jt-Gt}return Bt-$t});const Ke=new Uint32Array(N.length);let tt=0,lt=0;for(let ht=0;ht<_e;ht++){const At=5*Y[ht],Bt=N[At+0],$t=N[At+1],jt=N[At+2],Gt=N[At+3],_i=N[At+4],Xi=Bt-tt,bn=Xi===0?$t-lt:$t,Si=5*ht;Ke[Si+0]=Xi,Ke[Si+1]=bn,Ke[Si+2]=jt,Ke[Si+3]=Gt,Ke[Si+4]=_i,tt=Bt,lt=$t}return Ke}build(N){return this._dataIsSortedAndDeltaEncoded?new li(new Uint32Array(this._data),N):new li(ai._sortAndDeltaEncode(this._data),N)}}e.SemanticTokensBuilder=ai;class li{constructor(N,Y){this.resultId=Y,this.data=N}}e.SemanticTokens=li;class Me{constructor(N,Y,_e){this.start=N,this.deleteCount=Y,this.data=_e}}e.SemanticTokensEdit=Me;class Ht{constructor(N,Y){this.resultId=Y,this.edits=N}}e.SemanticTokensEdits=Ht;var Di;(function($){$[$.Separate=0]="Separate",$[$.MergeWithParent=1]="MergeWithParent"})(Di=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ft=class{constructor(){}};ft.Back={iconPath:new zt("arrow-left")},ft=ze([L],ft),e.QuickInputButtons=ft;var Ni;(function($){$[$.Separator=-1]="Separator",$[$.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Mi;(function($){$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(Mi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ci;(function($){$[$.UI=1]="UI",$[$.Workspace=2]="Workspace"})(Ci=e.ExtensionKind||(e.ExtensionKind={}));class Li{constructor(N,Y,_e){this.badge=N,this.tooltip=Y,this.color=_e}static validate(N){if(N.badge){let Y=(0,A.nextCharLength)(N.badge,0);if(Y<N.badge.length&&(Y+=(0,A.nextCharLength)(N.badge,Y)),N.badge.length>Y)throw new Error("The 'badge'-property must be undefined or a short character")}if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Li;let ti=class{constructor(N){this.kind=N}};ti=ze([L],ti),e.ColorTheme=ti;var Ui;(function($){$[$.Light=1]="Light",$[$.Dark=2]="Dark",$[$.HighContrast=3]="HighContrast",$[$.HighContrastLight=4]="HighContrastLight"})(Ui=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{constructor(N,Y){if(N<0)throw(0,p.illegalArgument)("start must be positive");if(Y<0)throw(0,p.illegalArgument)("end must be positive");N<=Y?(this._start=N,this._end=Y):(this._start=Y,this._end=N)}static isNotebookRange(N){return N instanceof Vt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(N){let Y=this._start,_e=this._end;return N.start!==void 0&&(Y=N.start),N.end!==void 0&&(_e=N.end),Y===this._start&&_e===this._end?this:new Vt(Y,_e)}}e.NotebookRange=Vt;class ci{constructor(N,Y,_e,Ke,tt,lt,ht){this.kind=N,this.value=Y,this.languageId=_e,this.mime=Ke,this.outputs=tt??[],this.metadata=lt,this.executionSummary=ht,ci.validate(this)}static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(Y=>ci.isNotebookCellData(Y))}static isNotebookCellData(N){return!0}}e.NotebookCellData=ci;class Ii{constructor(N){this.cells=N}}e.NotebookData=Ii;class Ut{constructor(N,Y){this.data=N,this.mime=Y;const _e=(0,y.normalizeMimeType)(Y,!0);if(!_e)throw new Error(`INVALID mime type: ${Y}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(N){return N instanceof Ut?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const Y={name:N.name,message:N.message,stack:N.stack};return Ut.json(Y,"application/vnd.code.notebook.error")}static stdout(N){return Ut.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Ut.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,Y="application/octet-stream"){return new Ut(N,Y)}static text(N,Y=y.Mimes.text){const _e=Oe(Ut,d,"f",o).encode(String(N));return new Ut(_e,Y)}static json(N,Y="text/x-json"){const _e=JSON.stringify(N,void 0,"	");return Ut.text(_e,Y)}}e.NotebookCellOutputItem=Ut,d=Ut,o={value:new TextEncoder};class ui{constructor(N,Y,_e){this.items=ui.ensureUniqueMimeTypes(N,!0),typeof Y=="string"?(this.id=Y,this.metadata=_e):(this.id=(0,R.generateUuid)(),this.metadata=Y??_e)}static isNotebookCellOutput(N){return N instanceof ui?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,Y=!1){const _e=new Set,Ke=new Set;for(let tt=0;tt<N.length;tt++){const lt=N[tt],ht=(0,y.normalizeMimeType)(lt.mime);if(!_e.has(ht)){_e.add(ht);continue}Ke.add(tt),Y&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ke.size===0?N:N.filter((tt,lt)=>!Ke.has(lt))}}e.NotebookCellOutput=ui;var Bi;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(Bi=e.NotebookCellKind||(e.NotebookCellKind={}));var zi;(function($){$[$.Idle=1]="Idle",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(zi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var xi;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(xi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var se;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(se=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class he{constructor(N,Y){this.text=N,this.alignment=Y}}e.NotebookCellStatusBarItem=he;var Re;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred"})(Re=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class ot{constructor(N,Y=[]){this.uri=N,this.provides=(0,a.asArray)(Y)}}e.NotebookRendererScript=ot;let bt=class{constructor(N,Y){this.label=N,this.timestamp=Y}};bt=ze([L],bt),e.TimelineItem=bt;var kt;(function($){$[$.Production=1]="Production",$[$.Development=2]="Development",$[$.Test=3]="Test"})(kt=e.ExtensionMode||(e.ExtensionMode={}));var Zi;(function($){$[$.Node=1]="Node",$[$.Webworker=2]="Webworker"})(Zi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var en;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(en=e.StandardTokenType||(e.StandardTokenType={}));class tn{constructor(N,Y){this.ranges=N,this.wordPattern=Y}}e.LinkedEditingRanges=tn;class nn{constructor(N,Y){this._port=N,this._autoForwardAction=Y}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=nn;var rn;(function($){$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(rn=e.TestResultState||(e.TestResultState={}));var sn;(function($){$[$.Run=1]="Run",$[$.Debug=2]="Debug",$[$.Coverage=3]="Coverage"})(sn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let $i=class{constructor(N=void 0,Y=void 0,_e=void 0){this.include=N,this.exclude=Y,this.profile=_e}};$i=ze([L],$i),e.TestRunRequest=$i;let Wi=x=class{constructor(N){this.message=N}static diff(N,Y,_e){const Ke=new x(N);return Ke.expectedOutput=Y,Ke.actualOutput=_e,Ke}};Wi=x=ze([L],Wi),e.TestMessage=Wi;let Hi=class{constructor(N){this.id=N}};Hi=ze([L],Hi),e.TestTag=Hi;let di=class{constructor(N,Y){this.covered=N,this.total=Y}};di=ze([L],di),e.CoveredCount=di;let Vi=C=class{constructor(N,Y,_e,Ke){this.uri=N,this.statementCoverage=Y,this.branchCoverage=_e,this.functionCoverage=Ke}static fromDetails(N,Y){const _e=new di(0,0),Ke=new di(0,0),tt=new di(0,0);for(const ht of Y)if("branches"in ht){_e.total+=1,_e.covered+=ht.executionCount>0?1:0;for(const At of ht.branches)Ke.total+=1,Ke.covered+=At.executionCount>0?1:0}else tt.total+=1,tt.covered+=ht.executionCount>0?1:0;const lt=new C(N,_e,Ke.total>0?Ke:void 0,tt.total>0?tt:void 0);return lt.detailedCoverage=Y,lt}};Vi=C=ze([L],Vi),e.FileCoverage=Vi;let ji=class{constructor(N,Y,_e=[]){this.executionCount=N,this.location=Y,this.branches=_e}};ji=ze([L],ji),e.StatementCoverage=ji;let qi=class{constructor(N,Y){this.executionCount=N,this.location=Y}};qi=ze([L],qi),e.BranchCoverage=qi;let Ki=class{constructor(N,Y){this.executionCount=N,this.location=Y}};Ki=ze([L],Ki),e.FunctionCoverage=Ki;var on;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(on=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var an;(function($){$[$.Untrusted=0]="Untrusted",$[$.Trusted=1]="Trusted",$[$.Unspecified=2]="Unspecified"})(an=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var ln;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(ln=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class cn{constructor(N,Y,_e,Ke,tt,lt){this.kind=N,this.name=Y,this.detail=_e,this.uri=Ke,this.range=tt,this.selectionRange=lt}}e.TypeHierarchyItem=cn;class un{constructor(N){this.uri=N}}e.TextTabInput=un;class dn{constructor(N,Y){this.original=N,this.modified=Y}}e.TextDiffTabInput=dn;class hn{constructor(N,Y,_e,Ke){this.base=N,this.input1=Y,this.input2=_e,this.result=Ke}}e.TextMergeTabInput=hn;class fn{constructor(N,Y){this.uri=N,this.viewType=Y}}e.CustomEditorTabInput=fn;class mn{constructor(N){this.viewType=N}}e.WebviewEditorTabInput=mn;class gn{constructor(N,Y){this.uri=N,this.notebookType=Y}}e.NotebookEditorTabInput=gn;class pn{constructor(N,Y,_e){this.original=N,this.modified=Y,this.notebookType=_e}}e.NotebookDiffEditorTabInput=pn;class vn{constructor(){}}e.TerminalEditorTabInput=vn;class En{constructor(N,Y){this.uri=N,this.inputBoxUri=Y}}e.InteractiveWindowInput=En}),define(Ce[87],Ie([1,0,44,12,9,240,123,6,16]),function(ie,e,a,p,w,M,y,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function R(f,h){h?P.set(f,h):P.delete(f)}e.setWordDefinitionFor=R;function S(f){return P.get(f)}e.getWordDefinitionFor=S;class m extends M.MirrorTextModel{constructor(h,d,o,g,E,l,D,i){super(d,o,g,E),this._proxy=h,this._languageId=l,this._isDirty=D,this.notebook=i,this._isDisposed=!1}dispose(){(0,a.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,b.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===p.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},save(){return h._save()},getText(d){return d?h._getTextInRange(d):h.getText()},get eol(){return h._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(d){return h._lineAt(d)},offsetAt(d){return h._offsetAt(d)},positionAt(d){return h._positionAt(d)},validateRange(d){return h._validateRange(d)},validatePosition(d){return h._validatePosition(d)},getWordRangeAtPosition(d,o){return h._getWordRangeAtPosition(d,o)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,a.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,a.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const d=this._validateRange(h);if(d.isEmpty)return"";if(d.isSingleLine)return this._lines[d.start.line].substring(d.start.character,d.end.character);const o=this._eol,g=d.start.line,E=d.end.line,l=[];l.push(this._lines[g].substring(d.start.character));for(let D=g+1;D<E;D++)l.push(this._lines[D]);return l.push(this._lines[E].substring(0,d.end.character)),l.join(o)}_lineAt(h){let d;if(h instanceof A.Position?d=h.line:typeof h=="number"&&(d=h),typeof d!="number"||d<0||d>=this._lines.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new k(d,this._lines[d],d===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getPrefixSum(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const d=this._lineStarts.getIndexOf(h),o=this._lines[d.index].length;return new A.Position(d.index,Math.min(d.remainder,o))}_validateRange(h){if(!(h instanceof A.Range))throw new Error("Invalid argument");const d=this._validatePosition(h.start),o=this._validatePosition(h.end);return d===h.start&&o===h.end?h:new A.Range(d.line,d.character,o.line,o.character)}_validatePosition(h){if(!(h instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:d,character:o}=h,g=!1;if(d<0)d=0,o=0,g=!0;else if(d>=this._lines.length)d=this._lines.length-1,o=this._lines[d].length,g=!0;else{const E=this._lines[d].length;o<0?(o=0,g=!0):o>E&&(o=E,g=!0)}return g?new A.Position(d,o):h}_getWordRangeAtPosition(h,d){const o=this._validatePosition(h);if(!d)d=S(this._languageId);else if((0,w.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const g=(0,y.getWordAtText)(o.character+1,(0,y.ensureValidWordDefinition)(d),this._lines[o.line],0);if(g)return new A.Range(o.line,g.startColumn-1,o.line,g.endColumn-1)}}e.ExtHostDocumentData=m;class k{constructor(h,d,o){this._line=h,this._text=d,this._isLastLine=o}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=k}),define(Ce[161],Ie([1,0,6,13,5]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(A){this._actual=new a.ColorTheme(a.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new w.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let b;switch(A){case"light":b=a.ColorThemeKind.Light;break;case"hcDark":b=a.ColorThemeKind.HighContrast;break;case"hcLight":b=a.ColorThemeKind.HighContrastLight;break;default:b=a.ColorThemeKind.Dark}this._actual=new a.ColorTheme(b),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};M=ze([$e(0,p.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(Ce[46],Ie([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class p{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=p}),define(Ce[162],Ie([1,0,23]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class p{constructor(){this.buffers=[]}add(b){let P=this.buffers.indexOf(b);return P<0&&(P=this.buffers.length,this.buffers.push(b)),P}}function w(A,b){if(b.serializeBuffersForPostMessage){const P=new p,R=(k,f)=>{if(f instanceof ArrayBuffer){const h=P.add(f);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(f)){const h=M(f);if(h){const d=P.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:h,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},S=JSON.stringify(A,R),m=P.buffers.map(k=>{const f=new Uint8Array(k);return a.VSBuffer.wrap(f)});return{message:S,buffers:m}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=w;function M(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(A,b){const P=b.map(m=>{const k=new ArrayBuffer(m.byteLength);return new Uint8Array(k).set(m.buffer),k}),R=b.length?(m,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const f=k,{index:h}=f,d=P[h];if(f.view)switch(f.view.type){case 1:return new Int8Array(d,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return k}:void 0;return{message:JSON.parse(A,R),arrayBuffers:P}}e.deserializeWebviewMessage=y}),define(Ce[88],Ie([1,0,137,10,2,7,3,30,39,16,12]),function(ie,e,a,p,w,M,y,A,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var S;(function(O){O[O.PROGRAMMATIC=1]="PROGRAMMATIC",O[O.USER=2]="USER",O[O.EDIT=3]="EDIT",O[O.NAVIGATION=4]="NAVIGATION",O[O.JUMP=5]="JUMP"})(S=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(O){O[O.IDENTICAL=1]="IDENTICAL",O[O.SIMILAR=2]="SIMILAR",O[O.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function k(O){const ee=O;return!!ee&&typeof ee.getSelection=="function"&&!!ee.onDidChangeSelection}e.isEditorPaneWithSelection=k;function f(O,ee,ue){for(const oe of ue.visibleEditorPanes)if(oe.group.id===ee&&O.matches(oe.input))return oe.getViewState()}e.findViewStateForEditor=f;function h(O){if(r(O))return!1;const ee=O;return w.URI.isUri(ee?.resource)}e.isResourceEditorInput=h;function d(O){if(r(O))return!1;const ee=O;return ee?.original!==void 0&&ee.modified!==void 0}e.isResourceDiffEditorInput=d;function o(O){if(r(O)||d(O))return!1;const ee=O;return ee?.primary!==void 0&&ee.secondary!==void 0}e.isResourceSideBySideEditorInput=o;function g(O){if(r(O))return!1;const ee=O;return ee?ee.resource===void 0||ee.resource.scheme===R.Schemas.untitled||ee.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=g;function E(O){if(r(O))return!1;const ee=O;return w.URI.isUri(ee?.base?.resource)&&w.URI.isUri(ee?.input1?.resource)&&w.URI.isUri(ee?.input2?.resource)&&w.URI.isUri(ee?.result?.resource)}e.isResourceMergeEditorInput=E;var l;(function(O){O[O.SHORT=0]="SHORT",O[O.MEDIUM=1]="MEDIUM",O[O.LONG=2]="LONG"})(l=e.Verbosity||(e.Verbosity={}));var D;(function(O){O[O.EXPLICIT=1]="EXPLICIT",O[O.AUTO=2]="AUTO",O[O.FOCUS_CHANGE=3]="FOCUS_CHANGE",O[O.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(D=e.SaveReason||(e.SaveReason={}));class i{constructor(){this.mapIdToSaveSource=new Map}registerSource(ee,ue){let oe=this.mapIdToSaveSource.get(ee);return oe||(oe={source:ee,label:ue},this.mapIdToSaveSource.set(ee,oe)),oe.source}getSourceLabel(ee){return this.mapIdToSaveSource.get(ee)?.label??ee}}e.SaveSourceRegistry=new i;var u;(function(O){O[O.None=0]="None",O[O.Readonly=2]="Readonly",O[O.Untitled=4]="Untitled",O[O.Singleton=8]="Singleton",O[O.RequiresTrust=16]="RequiresTrust",O[O.CanSplitInGroup=32]="CanSplitInGroup",O[O.ForceDescription=64]="ForceDescription",O[O.CanDropIntoEditor=128]="CanDropIntoEditor",O[O.MultipleEditors=256]="MultipleEditors"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends M.Disposable{}e.AbstractEditorInput=n;function r(O){return O instanceof n}e.isEditorInput=r;function s(O){const ee=O;return w.URI.isUri(ee?.preferredResource)}function t(O){const ee=O;return r(ee?.primary)&&r(ee?.secondary)}e.isSideBySideEditorInput=t;function c(O){const ee=O;return r(ee?.modified)&&r(ee?.original)}e.isDiffEditorInput=c;function _(O){return r(O?.editor)}e.isEditorInputWithOptions=_;function v(O){const ee=O;return _(O)&&ee?.group!==void 0}e.isEditorInputWithOptionsAndGroup=v;function T(O){const ee=O;return typeof ee?.groupId=="number"&&r(ee.editor)}e.isEditorIdentifier=T;var U;(function(O){O[O.UNKNOWN=0]="UNKNOWN",O[O.REPLACE=1]="REPLACE",O[O.MOVE=2]="MOVE",O[O.UNPIN=3]="UNPIN"})(U=e.EditorCloseContext||(e.EditorCloseContext={}));var V;(function(O){O[O.GROUP_ACTIVE=0]="GROUP_ACTIVE",O[O.GROUP_INDEX=1]="GROUP_INDEX",O[O.GROUP_LOCKED=2]="GROUP_LOCKED",O[O.EDITOR_OPEN=3]="EDITOR_OPEN",O[O.EDITOR_CLOSE=4]="EDITOR_CLOSE",O[O.EDITOR_MOVE=5]="EDITOR_MOVE",O[O.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",O[O.EDITOR_LABEL=7]="EDITOR_LABEL",O[O.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",O[O.EDITOR_PIN=9]="EDITOR_PIN",O[O.EDITOR_STICKY=10]="EDITOR_STICKY",O[O.EDITOR_DIRTY=11]="EDITOR_DIRTY",O[O.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(V=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var x;(function(O){O[O.PRIMARY=1]="PRIMARY",O[O.SECONDARY=2]="SECONDARY",O[O.BOTH=3]="BOTH",O[O.ANY=4]="ANY"})(x=e.SideBySideEditor||(e.SideBySideEditor={}));class C{getOriginalUri(ee,ue){if(!ee)return;if(E(ee))return e.EditorResourceAccessor.getOriginalUri(ee.result,ue);if(ue?.supportSideBySide){const{primary:le,secondary:te}=this.getSideEditors(ee);if(le&&te){if(ue?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(le,{filterByScheme:ue.filterByScheme}),secondary:this.getOriginalUri(te,{filterByScheme:ue.filterByScheme})};if(ue?.supportSideBySide===x.ANY)return this.getOriginalUri(le,{filterByScheme:ue.filterByScheme})??this.getOriginalUri(te,{filterByScheme:ue.filterByScheme});ee=ue.supportSideBySide===x.PRIMARY?le:te}}if(d(ee)||o(ee)||E(ee))return;const oe=s(ee)?ee.preferredResource:ee.resource;return!oe||!ue||!ue.filterByScheme?oe:this.filterUri(oe,ue.filterByScheme)}getSideEditors(ee){return t(ee)||o(ee)?{primary:ee.primary,secondary:ee.secondary}:c(ee)||d(ee)?{primary:ee.modified,secondary:ee.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ee,ue){if(!ee)return;if(E(ee))return e.EditorResourceAccessor.getCanonicalUri(ee.result,ue);if(ue?.supportSideBySide){const{primary:le,secondary:te}=this.getSideEditors(ee);if(le&&te){if(ue?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(le,{filterByScheme:ue.filterByScheme}),secondary:this.getCanonicalUri(te,{filterByScheme:ue.filterByScheme})};if(ue?.supportSideBySide===x.ANY)return this.getCanonicalUri(le,{filterByScheme:ue.filterByScheme})??this.getCanonicalUri(te,{filterByScheme:ue.filterByScheme});ee=ue.supportSideBySide===x.PRIMARY?le:te}}if(d(ee)||o(ee)||E(ee))return;const oe=ee.resource;return!oe||!ue||!ue.filterByScheme?oe:this.filterUri(oe,ue.filterByScheme)}filterUri(ee,ue){if(Array.isArray(ue)){if(ue.some(oe=>ee.scheme===oe))return ee}else if(ue===ee.scheme)return ee}}e.EditorResourceAccessor=new C;var L;(function(O){O[O.LEFT=0]="LEFT",O[O.RIGHT=1]="RIGHT"})(L=e.CloseDirection||(e.CloseDirection={}));class B{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(ee){const ue=this.instantiationService=ee.get(y.IInstantiationService);for(const[oe,le]of this.editorSerializerConstructors)this.createEditorSerializer(oe,le,ue);this.editorSerializerConstructors.clear()}createEditorSerializer(ee,ue,oe){const le=oe.createInstance(ue);this.editorSerializerInstances.set(ee,le)}registerFileEditorFactory(ee){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=ee}getFileEditorFactory(){return(0,p.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(ee,ue){if(this.editorSerializerConstructors.has(ee)||this.editorSerializerInstances.has(ee))throw new Error(`A editor serializer with type ID '${ee}' was already registered.`);return this.instantiationService?this.createEditorSerializer(ee,ue,this.instantiationService):this.editorSerializerConstructors.set(ee,ue),(0,M.toDisposable)(()=>{this.editorSerializerConstructors.delete(ee),this.editorSerializerInstances.delete(ee)})}getEditorSerializer(ee){return this.editorSerializerInstances.get(typeof ee=="string"?ee:ee.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new B);async function F(O,ee){if(!O||!O.length)return[];const ue=await Promise.all(O.map(async oe=>{const le=w.URI.revive(oe.fileUri);if(!le||!await ee.canHandleResource(le))return;let Ee=oe.exists,be=oe.type;if(typeof Ee!="boolean"||typeof be!="number")try{be=(await ee.stat(le)).isDirectory?b.FileType.Directory:b.FileType.Unknown,Ee=!0}catch{Ee=!1}if(!Ee&&oe.openOnlyIfExists||be===b.FileType.Directory)return;const ne={...oe.options,pinned:!0};let ve;return Ee?ve={resource:le,options:ne}:ve={resource:le,options:ne,forceUntitled:!0},ve}));return(0,P.coalesce)(ue)}e.pathsToEditors=F;var K;(function(O){O[O.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",O[O.SEQUENTIAL=1]="SEQUENTIAL"})(K=e.EditorsOrder||(e.EditorsOrder={}));function H(O){const ee=O;if(!ee)return!1;const ue=ee;if(ue.modified)return H(ue.modified);const oe=ee;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}e.isTextEditorViewState=H}),define(Ce[64],Ie([1,0,12,2]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function w(A,b){return A.scheme===a.Schemas.http||A.scheme===a.Schemas.https?A:(b&&b.authority&&b.isRemote&&A.scheme===a.Schemas.file&&(A=p.URI.from({scheme:a.Schemas.vscodeRemote,authority:b.authority,path:A.path})),p.URI.from({scheme:a.Schemas.https,authority:`${A.scheme}+${M(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=w;function M(A){return A.replace(/./g,b=>{const P=b.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?b:"-"+P.toString(16).padStart(4,"0")})}function y(A){return A.replace(/-([0-9a-f]{4})/g,(b,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=y}),define(Ce[163],Ie([1,0,5,7,64]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(A,b,P){this._proxy=A,this._editors=b,this._remoteInfo=P,this._handlePool=0,this._disposables=new p.DisposableStore,this._insets=new Map,this._disposables.add(b.onDidChangeVisibleTextEditors(()=>{const R=b.getVisibleTextEditors();for(const S of this._insets.values())R.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,b,P,R,S){let m;for(const E of this._editors.getVisibleTextEditors(!0))if(E.value===A){m=E;break}if(!m)throw new Error("not a visible editor");const k=this,f=this._handlePool++,h=new a.Emitter,d=new a.Emitter,o=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(E){return(0,w.asWebviewUri)(E,k._remoteInfo)}get cspSource(){return w.webviewGenericCspSource}set options(E){this._options=E,k._proxy.$setOptions(f,E)}get options(){return this._options}set html(E){this._html=E,k._proxy.$setHtml(f,E)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(E){return k._proxy.$postMessage(f,E)}},g=new class{constructor(){this.editor=A,this.line=b,this.height=P,this.webview=o,this.onDidDispose=d.event}dispose(){k._insets.has(f)&&(k._insets.delete(f),k._proxy.$disposeEditorInset(f),d.fire(),d.dispose(),h.dispose())}};return this._proxy.$createEditorInset(f,m.id,m.value.document.uri,b+1,P,R||{},S.identifier,S.extensionLocation),this._insets.set(f,{editor:A,inset:g,onDidReceiveMessage:h}),g}$onDidDispose(A){const b=this._insets.get(A);b&&b.inset.dispose()}$onDidReceiveMessage(A,b){this._insets.get(A)?.onDidReceiveMessage.fire(b)}}e.ExtHostEditorInsets=M}),define(Ce[164],Ie([1,0,5,14,138]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new a.Emitter,this._onExit=new a.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,b,P,R){const S={command:A};if(b&&Object.keys(b).length>0&&(S.arguments=b),this.internalSend("request",S),typeof R=="number"){const m=setTimeout(()=>{clearTimeout(m);const k=this.pendingRequests.get(S.seq);if(k){this.pendingRequests.delete(S.seq);const f={type:"response",seq:0,request_seq:S.seq,success:!1,command:A,message:(0,w.localize)(0,null,R,A)};k(f)}},R)}return P&&this.pendingRequests.set(S.seq,P),S.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,b){return A.type!=="event"||b.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,p.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const b=A,P=this.pendingRequests.get(b.request_seq);P&&(this.pendingRequests.delete(b.request_seq),P(b));break}}}}internalSend(A,b){b.type=A,b.seq=this.sequence++,this.sendMessage(b)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((b,P)=>A.set(P,b)),await(0,p.timeout)(500),A.forEach((b,P)=>{b({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=M}),define(Ce[165],Ie([1,0,139,38,3]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new p.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new p.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new p.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new p.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new p.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new p.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new p.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new p.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new p.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new p.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new p.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new p.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new p.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new p.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new p.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new p.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new p.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new p.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new p.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new p.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new p.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new p.RawContextKey("breakpointAccessType",void 0,{type:"string",description:a.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new p.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new p.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new p.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new p.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new p.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new p.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new p.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new p.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new p.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new p.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new p.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new p.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:a.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new p.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new p.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new p.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new p.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new p.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new p.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new p.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new p.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new p.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new p.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new p.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new p.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new p.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new p.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new p.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new p.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new p.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(50,null)});const M=m=>a.localize(51,null,m);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(52,null)};var y;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(y=e.State||(e.State={}));function A(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var b;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(b=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var P;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(P=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,w.createDecorator)(e.DEBUG_SERVICE_ID);var S;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(S=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(Ce[166],Ie([1,0,9,2,19,25,12]),function(ie,e,a,p,w,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function b(n,r,s){return n.replace(A,function(t,c){return r&&c.length>0&&c[0]!=="_"?t:s&&s.hasOwnProperty(c)?s[c]:t})}e.formatPII=b;function P(n){const r={};for(const s of Object.keys(n))s.startsWith("!")||(r[s]=n[s]);return r}e.filterExceptionsFromTelemetry=P;function R(n){return n.configuration.request==="attach"&&!S(n)&&(!n.parentSession||R(n.parentSession))}e.isSessionAttach=R;function S(n){let r=n.configuration.type;if(!!r)return r==="vslsShare"&&(r=n.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(r,"extensionhost")||(0,a.equalsIgnoreCase)(r,"pwa-extensionhost")?n:n.parentSession?S(n.parentSession):void 0}e.getExtensionHostDebugSession=S;function m(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=m;function k(n,r,s){let t,c=0;const _=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let v=null;for(;v=_.exec(n);){const T=v.index+1,U=T+v[0].length;if(T<=r&&U>=s){t=v[0],c=T;break}}if(t){const T=/\w+/g;let U=null;for(;(U=T.exec(t))&&!(U.index+1+c+U[0].length>=s););U&&(t=t.substring(0,T.lastIndex))}return t?{start:c,end:c+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=k;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(n){return!!(n&&n.match(f))}e.isUri=h;function d(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(h(n.path))return p.URI.parse(n.path);if((0,w.isAbsolute)(n.path))return p.URI.file(n.path)}return n.path}function o(n){if(typeof n.path=="object"){const r=p.URI.revive(n.path);if(r)return r.scheme===y.Schemas.file?r.fsPath:r.toString()}return n.path}function g(n,r){const s=r?d:o,t=(0,M.deepClone)(n);return l(t,(c,_)=>{c&&_&&(_.path=s(_))}),t}e.convertToDAPaths=g;function E(n,r){const s=r?d:o,t=(0,M.deepClone)(n);return l(t,(c,_)=>{!c&&_&&(_.path=s(_))}),t}e.convertToVSCPaths=E;function l(n,r){switch(n.type){case"event":{const s=n;switch(s.event){case"output":r(!1,s.body.source);break;case"loadedSource":r(!1,s.body.source);break;case"breakpoint":r(!1,s.body.breakpoint.source);break;default:break}break}case"request":{const s=n;switch(s.command){case"setBreakpoints":r(!0,s.arguments.source);break;case"breakpointLocations":r(!0,s.arguments.source);break;case"source":r(!0,s.arguments.source);break;case"gotoTargets":r(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(t=>r(!1,t));break;default:break}break}case"response":{const s=n;if(s.success&&s.body)switch(s.command){case"stackTrace":s.body.stackFrames.forEach(t=>r(!1,t.source));break;case"loadedSources":s.body.sources.forEach(t=>r(!1,t));break;case"scopes":s.body.scopes.forEach(t=>r(!1,t.source));break;case"setFunctionBreakpoints":s.body.breakpoints.forEach(t=>r(!1,t.source));break;case"setBreakpoints":s.body.breakpoints.forEach(t=>r(!1,t.source));break;case"disassemble":s.body?.instructions.forEach(c=>r(!1,c.location));break;default:break}break}}}function D(n){return n.filter(r=>!r.presentation?.hidden).sort((r,s)=>r.presentation?s.presentation?r.presentation.group?s.presentation.group?r.presentation.group!==s.presentation.group?r.presentation.group.localeCompare(s.presentation.group):i(r.presentation.order,s.presentation.order):-1:s.presentation.group?1:i(r.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=D;function i(n,r){return typeof n!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:n-r}async function u(n,r){const s=n.getValue("debug.saveBeforeStart",{overrideIdentifier:r.activeTextEditorLanguageId});if(s!=="none"&&(await r.saveAll(),s==="allEditorsInActiveGroup")){const t=r.activeEditorPane;t&&t.input.resource?.scheme===y.Schemas.untitled&&await r.save({editor:t.input,groupId:t.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(Ce[89],Ie([1,0,23,34,167,74,12,19,21,38]),function(ie,e,a,p,w,M,y,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(t){t[t.Markup=1]="Markup",t[t.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function(t){t[t.Running=1]="Running",t[t.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(t){t[t.Unconfirmed=1]="Unconfirmed",t[t.Pending=2]="Pending",t[t.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(t){t[t.WithHardKernelDependency=0]="WithHardKernelDependency",t[t.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",t[t.Pure=2]="Pure",t[t.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(t){t.Always="always",t.Never="never",t.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(t){t[t.ModelChange=1]="ModelChange",t[t.Move=2]="Move",t[t.ChangeCellLanguage=5]="ChangeCellLanguage",t[t.Initialize=6]="Initialize",t[t.ChangeCellMetadata=7]="ChangeCellMetadata",t[t.Output=8]="Output",t[t.OutputItem=9]="OutputItem",t[t.ChangeCellContent=10]="ChangeCellContent",t[t.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",t[t.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",t[t.ChangeCellMime=13]="ChangeCellMime",t[t.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(t){t[t.Handle=0]="Handle",t[t.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var o;(function(t){t[t.Replace=1]="Replace",t[t.Output=2]="Output",t[t.Metadata=3]="Metadata",t[t.CellLanguage=4]="CellLanguage",t[t.DocumentMetadata=5]="DocumentMetadata",t[t.Move=6]="Move",t[t.OutputItems=7]="OutputItems",t[t.PartialMetadata=8]="PartialMetadata",t[t.PartialInternalMetadata=9]="PartialInternalMetadata"})(o=e.CellEditType||(e.CellEditType={}));var g;(function(t){t.scheme=y.Schemas.vscodeNotebookCell;const c=["W","X","Y","Z","a","b","c","d","e","f"],_=new RegExp(`^[${c.join("")}]+`),v=7;function T(F,K){const H=K.toString(v),ee=`${H.length<c.length?c[H.length-1]:"z"}${H}s${(0,a.encodeBase64)(a.VSBuffer.fromString(F.scheme),!0,!0)}`;return F.with({scheme:t.scheme,fragment:ee})}t.generate=T;function U(F){if(F.scheme!==t.scheme)return;const K=F.fragment.indexOf("s");if(K<0)return;const H=parseInt(F.fragment.substring(0,K).replace(_,""),v),O=(0,a.decodeBase64)(F.fragment.substring(K+1)).toString();if(!isNaN(H))return{handle:H,notebook:F.with({scheme:O,fragment:null})}}t.parse=U;const V=/^(\d{8,})(\w[\w\d+.-]*)$/;function x(F,K){return F.with({scheme:y.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${F.scheme!==y.Schemas.file?F.scheme:""}`})}t.generateCellOutputUri=x;function C(F){if(F.scheme!==y.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(F.fragment);if(!K)return;const H=K[1]&&K[1]!==""?K[1]:void 0,O=K[2];return{outputId:H,notebook:F.with({scheme:O||y.Schemas.file,fragment:null})}}t.parseCellOutputUri=C;function L(F,K,H){return F.with({scheme:H,fragment:`ch${K.toString().padStart(7,"0")}${F.scheme!==y.Schemas.file?F.scheme:""}`})}t.generateCellUri=L;function B(F,K){if(F.scheme!==K)return;const H=V.exec(F.fragment);return H?{handle:Number(H[1]),notebook:F.with({scheme:F.fragment.substring(H[0].length)||y.Schemas.file,fragment:null})}:void 0}t.parseCellUri=B})(g=e.CellUri||(e.CellUri={}));const E=t=>b.isWindows?t.replace(/\//g,"\\"):t;class l{constructor(c=[],_=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=_,this.order=[...new Set(c)].map(v=>({pattern:v,matches:p.parse(E(v))}))}sort(c){const _=new Map(w.Iterable.map(c,T=>[T,E(T)]));let v=[];for(const{matches:T}of this.order)for(const[U,V]of _)if(T(V)){v.push(U),_.delete(U);break}return _.size&&(v=v.concat([..._.keys()].sort((T,U)=>this.defaultOrder.indexOf(T)-this.defaultOrder.indexOf(U)))),v}prioritize(c,_){const v=this.findIndex(c);if(v===-1){this.order.unshift({pattern:c,matches:p.parse(E(c))});return}const T=new Set(_.map(V=>this.findIndex(V,v)));T.delete(-1);const U=Array.from(T).sort();this.order.splice(v+1,0,...U.map(V=>this.order[V]));for(let V=U.length-1;V>=0;V--)this.order.splice(U[V],1)}toArray(){return this.order.map(c=>c.pattern)}findIndex(c,_=this.order.length){const v=E(c);for(let T=0;T<_;T++)if(this.order[T].matches(v))return T;return-1}}e.MimeTypeDisplayOrder=l;function D(t,c,_,v=(T,U)=>T===U){const T=[];function U(C,L,B){if(L===0&&B.length===0)return;const F=T[T.length-1];F&&F.start+F.deleteCount===C?(F.deleteCount+=L,F.toInsert.push(...B)):T.push({start:C,deleteCount:L,toInsert:B})}let V=0,x=0;for(;;){if(V===t.length){U(V,0,c.slice(x));break}if(x===c.length){U(V,t.length-V,[]);break}const C=t[V],L=c[x];if(v(C,L)){V+=1,x+=1;continue}_(L)?(U(V,1,[]),V+=1):(U(V,0,[L]),x+=1)}return T}e.diff=D,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new P.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(t){t.default="default",t.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(t){const c=t;return!!((typeof c.include=="string"||p.isRelativePattern(c.include))&&(typeof c.exclude=="string"||p.isRelativePattern(c.exclude)))}e.isDocumentExcludePattern=u;function n(t,c,_){if(Array.isArray(t.viewType)&&t.viewType.indexOf(c)>=0||t.viewType===c)return!0;if(t.filenamePattern){const v=u(t.filenamePattern)?t.filenamePattern.include:t.filenamePattern,T=u(t.filenamePattern)?t.filenamePattern.exclude:void 0;if(p.match(v,(0,A.basename)(_.fsPath).toLowerCase()))return!(T&&p.match(T,(0,A.basename)(_.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var r;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(r=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class s{static create(c){return`${s._prefix}${c}`}static parse(c){if(c.startsWith(s._prefix))return c.substring(s._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=s,s._prefix="notebook/"}),define(Ce[168],Ie([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var p;(function(w){w[w.Output=1]="Output",w[w.OutputItems=2]="OutputItems",w[w.ExecutionState=3]="ExecutionState"})(p=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(Ce[169],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=a;function p(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=p;function w(y){return Array.from(y.entries()).map(A=>[A[0],a(A[1].map)])}e.serializeEnvironmentVariableCollections=w;function M(y){return new Map(y.map(A=>[A[0],{map:p(A[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(Ce[47],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(M){M.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var p;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(p=e.TestPosition||(e.TestPosition={}));class w{constructor(y,A=y.length){if(this.path=y,this.viewEnd=A,y.length===0||A<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(y,A,b=y.parent){if(y.id===A)return new w([A]);const P=[y.id];for(let R=b;R&&R.id!==A;R=R.parent)P.push(R.id);return P.push(A),new w(P.reverse())}static isRoot(y){return!y.includes("\0")}static root(y){const A=y.indexOf("\0");return A===-1?y:y.slice(0,A)}static fromString(y){return new w(y.split("\0"))}static join(y,A){return new w([...y.path,A])}static joinToString(y,A){return y.toString()+"\0"+A}static compare(y,A){return y===A?0:A.startsWith(y+"\0")?2:y.startsWith(A+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let y=1;y<=this.viewEnd;y++)yield new w(this.path,y)}compare(y){if(typeof y=="string")return w.compare(this.toString(),y);for(let A=0;A<y.viewEnd&&A<this.viewEnd;A++)if(y.path[A]!==this.path[A])return 1;return y.viewEnd>this.viewEnd?2:y.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let y=1;y<this.viewEnd;y++)this.stringifed+="\0",this.stringifed+=this.path[y]}return this.stringifed}}e.TestId=w}),define(Ce[48],Ie([1,0,2,49]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var w;(function(s){s[s.Unset=0]="Unset",s[s.Queued=1]="Queued",s[s.Running=2]="Running",s[s.Passed=3]="Passed",s[s.Failed=4]="Failed",s[s.Skipped=5]="Skipped",s[s.Errored=6]="Errored"})(w=e.TestResultState||(e.TestResultState={}));var M;(function(s){s[s.Run=2]="Run",s[s.Debug=4]="Debug",s[s.Coverage=8]="Coverage",s[s.HasNonDefaultProfile=16]="HasNonDefaultProfile",s[s.HasConfigurable=32]="HasConfigurable"})(M=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var y;(function(s){s.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),s.deserialize=t=>({range:p.Range.lift(t.range),uri:a.URI.revive(t.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var A;(function(s){s[s.Error=0]="Error",s[s.Output=1]="Output"})(A=e.TestMessageType||(e.TestMessageType={}));var b;(function(s){s.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&y.serialize(t.location)}),s.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&y.deserialize(t.location)})})(b=e.ITestErrorMessage||(e.ITestErrorMessage={}));var P;(function(s){s.serialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&y.serialize(t.location)}),s.deserialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&y.deserialize(t.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var R;(function(s){s.serialize=t=>t.type===0?b.serialize(t):P.serialize(t),s.deserialize=t=>t.type===0?b.deserialize(t):P.deserialize(t)})(R=e.ITestMessage||(e.ITestMessage={}));var S;(function(s){s.serializeWithoutMessages=t=>({state:t.state,duration:t.duration,messages:[]}),s.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(R.serialize)}),s.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(R.deserialize)})})(S=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",k=(s,t)=>s+m+t;e.namespaceTestTag=k;const f=s=>{const t=s.indexOf(m);return{ctrlId:s.slice(0,t),tagId:s.slice(t+1)}};e.denamespaceTestTag=f;var h;(function(s){s.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),s.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?a.URI.revive(t.uri):void 0,range:t.range?p.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(h=e.ITestItem||(e.ITestItem={}));var d;(function(s){s[s.NotExpandable=0]="NotExpandable",s[s.Expandable=1]="Expandable",s[s.BusyExpanding=2]="BusyExpanding",s[s.Expanded=3]="Expanded"})(d=e.TestItemExpandState||(e.TestItemExpandState={}));var o;(function(s){s.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:h.serialize(t.item)}),s.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:h.deserialize(t.item)})})(o=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(s){s.serialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.uri!==void 0&&(c.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(c.range=t.item.range?.toJSON()),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c,docv:t.docv}},s.deserialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.range!==void 0&&(c.range=t.item.range?p.Range.lift(t.item.range):null),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c,docv:t.docv}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const E=(s,t)=>{t.expand!==void 0&&(s.expand=t.expand),t.item!==void 0&&(s.item=s.item?Object.assign(s.item,t.item):t.item)};e.applyTestItemUpdate=E;var l;(function(s){s.serializeWithoutMessages=t=>({...o.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(S.serializeWithoutMessages),retired:t.retired}),s.serialize=t=>({...o.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(S.serialize),retired:t.retired})})(l=e.TestResultItem||(e.TestResultItem={}));var D;(function(s){s[s.Function=0]="Function",s[s.Statement=1]="Statement"})(D=e.DetailType||(e.DetailType={}));var i;(function(s){s[s.Add=0]="Add",s[s.Update=1]="Update",s[s.Remove=2]="Remove",s[s.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",s[s.Retire=4]="Retire",s[s.AddTag=5]="AddTag",s[s.RemoveTag=6]="RemoveTag"})(i=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(s){s.deserialize=t=>t.op===0?{op:t.op,item:o.deserialize(t.item)}:t.op===1?{op:t.op,item:g.deserialize(t.item)}:t,s.serialize=t=>t.op===0?{op:t.op,item:o.serialize(t.item)}:t.op===1?{op:t.op,item:g.serialize(t.item)}:t})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class n{add(t){}update(t){}remove(t,c){}complete(){}}e.IncrementalChangeCollector=n;class r{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const c=this.createChangeCollector();for(const _ of t)switch(_.op){case 0:{const v=o.deserialize(_.item);if(v.parent){if(this.items.has(v.parent)){const T=this.items.get(v.parent);T.children.add(v.item.extId);const U=this.createItem(v,T);this.items.set(v.item.extId,U),c.add(U)}}else{const T=this.createItem(v);this.roots.add(T),this.items.set(v.item.extId,T),c.add(T)}v.expand===2&&this.busyControllerCount++;break}case 1:{const v=g.deserialize(_.item),T=this.items.get(v.extId);if(!T)break;v.expand!==void 0&&(T.expand===2&&this.busyControllerCount--,v.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(T,v),c.update(T);break}case 2:{const v=this.items.get(_.itemId);if(!v)break;v.parent?this.items.get(v.parent).children.delete(v.item.extId):this.roots.delete(v);const T=[[_.itemId]];for(;T.length;)for(const U of T.pop()){const V=this.items.get(U);V&&(T.push(V.children),this.items.delete(U),c.remove(V,V!==v),V.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(_.itemId);break;case 3:this.updatePendingRoots(_.amount);break;case 5:this._tags.set(_.tag.id,_.tag);break;case 6:this._tags.delete(_.id);break}c.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new n}}e.AbstractIncrementalTestCollection=r}),define(Ce[65],Ie([1,0,14,5,7,44,48,47]),function(ie,e,a,p,w,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var b;(function(o){o[o.Upsert=0]="Upsert",o[o.SetTags=1]="SetTags",o[o.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",o[o.RemoveChild=3]="RemoveChild",o[o.SetProp=4]="SetProp",o[o.Bulk=5]="Bulk"})(b=e.TestItemEventOp||(e.TestItemEventOp={}));const P=(o,g)=>o===g,R={range:(o,g)=>o===g?!0:!o||!g?!1:o.equalsRange(g),busy:P,label:P,description:P,error:P,tags:(o,g)=>!(o.length!==g.length||o.some(E=>!g.includes(E)))},S=(o,g)=>{let E;for(const[l,D]of Object.entries(R))D(o[l],g[l])||(E?E[l]=g[l]:E={[l]:g[l]});return E};class m extends w.Disposable{constructor(g){super(),this.options=g,this.debounceSendDiff=this._register(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new p.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(g){this._resolveHandler=g;for(const E of this.tree.values())this.updateExpandability(E)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const E=this.diff[this.diff.length-1];if(E&&g.op===1){if(E.op===1&&E.item.extId===g.item.extId){(0,y.applyTestItemUpdate)(E.item,g.item);return}if(E.op===0&&E.item.item.extId===g.item.extId){(0,y.applyTestItemUpdate)(E.item,g.item);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,E){const l=this.tree.get(g);if(!!l){if((l.expandLevels===void 0||E>l.expandLevels)&&(l.expandLevels=E),l.expand===1){const D=this.resolveChildren(l);return D.isOpen()?this.expandChildren(l,E-1):D.wait().then(()=>this.expandChildren(l,E-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,E-1)):this.expandChildren(l,E-1)}}dispose(){for(const g of this.tree.values())this.options.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,E){switch(E.op){case 3:this.removeItem(A.TestId.joinToString(g.fullId,E.id));break;case 0:this.upsertItem(E.item,g);break;case 5:for(const l of E.ops)this.onTestItemEvent(g,l);break;case 1:this.diffTagRefs(E.new,E.old,g.fullId.toString());break;case 2:this.updateExpandability(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:E.update,docv:this.options.getDocumentVersion(g.actual.uri)}});break;default:(0,M.assertNever)(E)}}upsertItem(g,E){const l=A.TestId.fromExtHostTestItem(g,this.root.id,E?.actual),D=this.options.getApiFor(g);D.parent&&D.parent!==E?.actual&&this.options.getChildren(D.parent).delete(g.id);let i=this.tree.get(l.toString());if(!i){i={fullId:l,actual:g,parent:E?l.parentId:null,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(i.fullId.toString(),i),this.setItemParent(g,E),this.pushDiff({op:0,item:{parent:i.parent&&i.parent.toString(),controllerId:this.options.controllerId,expand:i.expand,item:this.options.toITestItem(g)}}),this.connectItemAndChildren(g,i,E);return}if(i.actual===g){this.connectItem(g,i,E);return}const u=this.options.getChildren(i.actual),n=i.actual,r=S(this.options.toITestItem(n),this.options.toITestItem(g));this.options.getApiFor(n).listener=void 0,i.actual=g,i.expand=0,r&&(r.hasOwnProperty("tags")&&(this.diffTagRefs(g.tags,n.tags,l.toString()),delete r.tags),this.onTestItemEvent(i,{op:4,update:r})),this.connectItemAndChildren(g,i,E);for(const[s,t]of u)this.options.getChildren(g).get(t.id)||this.removeItem(A.TestId.joinToString(l,t.id))}diffTagRefs(g,E,l){const D=new Set(E.map(i=>i.id));for(const i of g)D.delete(i.id)||this.incrementTagRefs(i);this.pushDiff({op:1,item:{extId:l,item:{tags:g.map(i=>(0,y.namespaceTestTag)(this.options.controllerId,i.id))}}}),D.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const E=this.tags.get(g.id);E?E.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,y.namespaceTestTag)(this.options.controllerId,g.id)}}))}decrementTagRefs(g){const E=this.tags.get(g);E&&!--E.refCount&&(this.tags.delete(g),this.pushDiff({op:6,id:(0,y.namespaceTestTag)(this.options.controllerId,g)}))}setItemParent(g,E){this.options.getApiFor(g).parent=E&&E.actual!==this.root?E.actual:void 0}connectItem(g,E,l){this.setItemParent(g,l);const D=this.options.getApiFor(g);D.parent=l?.actual,D.listener=i=>this.onTestItemEvent(E,i),this.updateExpandability(E)}connectItemAndChildren(g,E,l){this.connectItem(g,E,l);for(const[D,i]of this.options.getChildren(g))this.upsertItem(i,E)}updateExpandability(g){let E;this._resolveHandler?g.resolveBarrier?E=g.resolveBarrier.isOpen()?3:2:E=g.actual.canResolveChildren?1:0:E=0,E!==g.expand&&(g.expand=E,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:E}}),E===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,E){if(E<0)return;const l=[];for(const[D,i]of this.options.getChildren(g.actual)){const u=this.expand(A.TestId.joinToString(g.fullId,i.id),E);(0,a.isThenable)(u)&&l.push(u)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const i=new a.Barrier;return i.open(),i}g.expand=2,this.pushExpandStateUpdate(g);const E=g.resolveBarrier=new a.Barrier,l=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,i)};let D;try{D=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(i){l(i)}return(0,a.isThenable)(D)?D.catch(l).then(()=>{E.open(),this.updateExpandability(g)}):(E.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const E=this.tree.get(g);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:g});const l=[E];for(;l.length;){const D=l.pop();if(!!D){this.options.getApiFor(D.actual).listener=void 0;for(const i of D.actual.tags)this.decrementTagRefs(i.id);this.tree.delete(D.fullId.toString());for(const[i,u]of this.options.getChildren(D.actual))l.push(this.tree.get(A.TestId.joinToString(D.fullId,u.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.TestItemCollection=m;class k extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.DuplicateTestItemError=k;class f extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class h extends Error{constructor(g,E,l){super(`TestItem with ID "${g}" is from controller "${E}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=h;const d=(o,g,E)=>{let l=new Map;return{get size(){return l.size},forEach(D,i){for(const u of l.values())D.call(i,u,this)},[Symbol.iterator](){return l.entries()},replace(D){const i=new Map,u=new Set(l.keys()),n={op:5,ops:[]};for(const r of D){if(!(r instanceof E))throw new f(r.id);const s=g(r).controllerId;if(s!==o.controllerId)throw new h(r.id,s,o.controllerId);if(i.has(r.id))throw new k(r.id);i.set(r.id,r),u.delete(r.id),n.ops.push({op:0,item:r})}for(const r of u.keys())n.ops.push({op:3,id:r});o.listener?.(n),l=i},add(D){if(!(D instanceof E))throw new f(D.id);l.set(D.id,D),o.listener?.({op:0,item:D})},delete(D){l.delete(D)&&o.listener?.({op:3,id:D})},get(D){return l.get(D)},toJSON(){return Array.from(l.values())}}};e.createTestItemChildren=d}),define(Ce[90],Ie([1,0,65]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const p=new WeakMap,w=(y,A)=>{const b={controllerId:A};return p.set(y,b),b};e.createPrivateApiFor=w;const M=y=>{const A=p.get(y);if(!A)throw new a.InvalidTestItemError(y?.id||"<unknown>");return A};e.getPrivateApiFor=M}),define(Ce[170],Ie([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var p;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(p=e.VariableKind||(e.VariableKind={}));class w extends Error{constructor(y,A){super(A),this.variable=y}}e.VariableError=w}),define(Ce[171],Ie([1,0,19,60,10,25,21,76,142,170,9]),function(ie,e,a,p,w,M,y,A,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class S{constructor(k,f,h,d){this._contributedVariables=new Map,this._context=k,this._labelService=f,this._userHomePromise=h,d&&(this._envVariablesPromise=d.then(o=>this.prepareEnv(o)))}prepareEnv(k){if(y.isWindows){const f=Object.create(null);return Object.keys(k).forEach(h=>{f[h.toLowerCase()]=k[h]}),f}return k}resolveWithEnvironment(k,f,h){return this.recursiveResolve({env:this.prepareEnv(k),userHome:void 0},f?f.uri:void 0,h)}async resolveAsync(k,f){const h={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(h,k?k.uri:void 0,f)}async resolveAnyBase(k,f,h,d){const o=M.deepClone(f);y.isWindows&&o.windows?Object.keys(o.windows).forEach(E=>o[E]=o.windows[E]):y.isMacintosh&&o.osx?Object.keys(o.osx).forEach(E=>o[E]=o.osx[E]):y.isLinux&&o.linux&&Object.keys(o.linux).forEach(E=>o[E]=o.linux[E]),delete o.windows,delete o.osx,delete o.linux;const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,k?k.uri:void 0,o,h,d)}async resolveAnyAsync(k,f,h){return this.resolveAnyBase(k,f,h)}async resolveAnyMap(k,f,h){const d=new Map;return{newConfig:await this.resolveAnyBase(k,f,h,d),resolvedVariables:d}}resolveWithInteractionReplace(k,f,h,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,f,h,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,f){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,f)}async recursiveResolve(k,f,h,d,o){if(w.isString(h))return this.resolveString(k,f,h,d,o);if(Array.isArray(h))return Promise.all(h.map(g=>this.recursiveResolve(k,f,g,d,o)));if(w.isObject(h)){const g=Object.create(null),E=await Promise.all(Object.keys(h).map(async l=>[await this.resolveString(k,f,l,d,o),await this.recursiveResolve(k,f,h[l],d,o)]));for(const[l,D]of E)g[l]=D;return g}return h}resolveString(k,f,h,d,o){return(0,R.replaceAsync)(h,S.VARIABLE_REGEXP,async(g,E)=>{if(E.includes(S.VARIABLE_LHS))return g;let l=await this.evaluateSingleVariable(k,g,E,f,d);return o?.set(E,l),l!==g&&w.isString(l)&&l.match(S.VARIABLE_REGEXP)&&(l=await this.resolveString(k,f,l,d,o)),l})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}async evaluateSingleVariable(k,f,h,d,o){let g;const E=h.split(":");E.length>1&&(h=E[0],g=E[1]);const l=u=>{const n=this._context.getFilePath();if(n)return n;throw new P.VariableError(u,(0,b.localize)(0,null,f))},D=u=>{const n=l(u);if(this._context.getWorkspaceFolderPathForFile){const r=this._context.getWorkspaceFolderPathForFile();if(r)return r}throw new P.VariableError(u,(0,b.localize)(1,null,f,a.basename(n)))},i=u=>{if(g){const n=this._context.getFolderUri(g);if(n)return n;throw new P.VariableError(u,(0,b.localize)(2,null,f,g))}if(d)return d;throw this._context.getWorkspaceFolderCount()>1?new P.VariableError(u,(0,b.localize)(3,null,f)):new P.VariableError(u,(0,b.localize)(4,null,f))};switch(h){case"env":if(g){if(k.env){const u=k.env[y.isWindows?g.toLowerCase():g];if(w.isString(u))return u}return""}throw new P.VariableError(P.VariableKind.Env,(0,b.localize)(5,null,f));case"config":if(g){const u=this._context.getConfigurationValue(d,g);if(w.isUndefinedOrNull(u))throw new P.VariableError(P.VariableKind.Config,(0,b.localize)(6,null,f,g));if(w.isObject(u))throw new P.VariableError(P.VariableKind.Config,(0,b.localize)(7,null,f,g));return u}throw new P.VariableError(P.VariableKind.Config,(0,b.localize)(8,null,f));case"command":return this.resolveFromMap(P.VariableKind.Command,f,g,o,"command");case"input":return this.resolveFromMap(P.VariableKind.Input,f,g,o,"input");case"extensionInstallFolder":if(g){const u=await this._context.getExtension(g);if(!u)throw new P.VariableError(P.VariableKind.ExtensionInstallFolder,(0,b.localize)(9,null,f,g));return this.fsPath(u.extensionLocation)}throw new P.VariableError(P.VariableKind.ExtensionInstallFolder,(0,b.localize)(10,null,f));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(i(P.VariableKind.WorkspaceFolder)));case"cwd":return d||g?(0,A.normalizeDriveLetter)(this.fsPath(i(P.VariableKind.Cwd))):p.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return a.basename(this.fsPath(i(P.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(k.userHome)return k.userHome;throw new P.VariableError(P.VariableKind.UserHome,(0,b.localize)(11,null,f))}case"lineNumber":{const u=this._context.getLineNumber();if(u)return u;throw new P.VariableError(P.VariableKind.LineNumber,(0,b.localize)(12,null,f))}case"selectedText":{const u=this._context.getSelectedText();if(u)return u;throw new P.VariableError(P.VariableKind.SelectedText,(0,b.localize)(13,null,f))}case"file":return l(P.VariableKind.File);case"fileWorkspaceFolder":return D(P.VariableKind.FileWorkspaceFolder);case"relativeFile":return d||g?a.relative(this.fsPath(i(P.VariableKind.RelativeFile)),l(P.VariableKind.RelativeFile)):l(P.VariableKind.RelativeFile);case"relativeFileDirname":{const u=a.dirname(l(P.VariableKind.RelativeFileDirname));if(d||g){const n=a.relative(this.fsPath(i(P.VariableKind.RelativeFileDirname)),u);return n.length===0?".":n}return u}case"fileDirname":return a.dirname(l(P.VariableKind.FileDirname));case"fileExtname":return a.extname(l(P.VariableKind.FileExtname));case"fileBasename":return a.basename(l(P.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=a.basename(l(P.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-a.extname(u).length)}case"fileDirnameBasename":return a.basename(a.dirname(l(P.VariableKind.FileDirnameBasename)));case"execPath":{const u=this._context.getExecPath();return u||f}case"execInstallFolder":{const u=this._context.getAppRoot();return u||f}case"pathSeparator":return a.sep;default:try{const u=g?`${h}:${g}`:h;return this.resolveFromMap(P.VariableKind.Unknown,f,u,o,void 0)}catch{return f}}}}resolveFromMap(k,f,h,d,o){if(h&&d){const g=o===void 0?d[h]:d[o+":"+h];if(typeof g=="string")return g;throw new P.VariableError(k,(0,b.localize)(14,null,f))}return f}}e.AbstractVariableResolverService=S,S.VARIABLE_LHS="${",S.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[91],Ie([1,0,3,88]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var w;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var M;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var y;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(y=e.GroupLocation||(e.GroupLocation={}));var A;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var b;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(b=e.MergeGroupMode||(e.MergeGroupMode={}));function P(f){const h=f;return(0,p.isEditorInput)(h?.editor)&&(0,p.isEditorInput)(h?.replacement)}e.isEditorReplacement=P;var R;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var S;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(S=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const h=f;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.isEditorGroup=m;function k(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(Ce[172],Ie([1,0,3,91]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(M){const y=M;return typeof M=="number"||(0,p.isEditorGroup)(y)}e.isPreferredGroup=w}),define(Ce[8],Ie([1,0,16,23,75,24,107,56,25,10,2,49,66,80,90,88,89,47,48,172,6,173]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f,h,d,o,g,E,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(we){function De(q){const{selectionStartLineNumber:Ae,selectionStartColumn:Le,positionLineNumber:et,positionColumn:qe}=q,Ge=new l.Position(Ae-1,Le-1),ct=new l.Position(et-1,qe-1);return new l.Selection(Ge,ct)}we.to=De;function me(q){const{anchor:Ae,active:Le}=q;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}we.from=me})(i=e.Selection||(e.Selection={}));var u;(function(we){function De(q){if(!q)return;const{start:Ae,end:Le}=q;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}we.from=De;function me(q){if(!q)return;const{startLineNumber:Ae,startColumn:Le,endLineNumber:et,endColumn:qe}=q;return new l.Range(Ae-1,Le-1,et-1,qe-1)}we.to=me})(u=e.Range||(e.Range={}));var n;(function(we){function De(me){switch(me){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}we.to=De})(n=e.TokenType||(e.TokenType={}));var r;(function(we){function De(q){return new l.Position(q.lineNumber-1,q.column-1)}we.to=De;function me(q){return{lineNumber:q.line+1,column:q.character+1}}we.from=me})(r=e.Position||(e.Position={}));var s;(function(we){function De(Ae,Le){return(0,a.coalesce)((0,a.asArray)(Ae).map(et=>me(et,Le)))}we.from=De;function me(Ae,Le){if(typeof Ae=="string")return{$serialized:!0,language:Ae};if(Ae)return{$serialized:!0,language:Ae.language,scheme:q(Ae.scheme,Le),pattern:fe.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType}}function q(Ae,Le){return Le&&typeof Ae=="string"?Le.transformOutgoingScheme(Ae):Ae}})(s=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(we){function De(q){switch(q){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}we.from=De;function me(q){switch(q){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}we.to=me})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(we){function De(q){let Ae;return q.code&&((0,P.isString)(q.code)||(0,P.isNumber)(q.code)?Ae=String(q.code):Ae={value:String(q.code.value),target:q.code.target}),{...u.from(q.range),message:q.message,source:q.source,code:Ae,severity:v.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(_.from),tags:Array.isArray(q.tags)?(0,a.coalesce)(q.tags.map(t.from)):void 0}}we.from=De;function me(q){const Ae=new l.Diagnostic(u.to(q),q.message,v.to(q.severity));return Ae.source=q.source,Ae.code=(0,P.isString)(q.code)?q.code:q.code?.value,Ae.relatedInformation=q.relatedInformation&&q.relatedInformation.map(_.to),Ae.tags=q.tags&&(0,a.coalesce)(q.tags.map(t.to)),Ae}we.to=me})(c=e.Diagnostic||(e.Diagnostic={}));var _;(function(we){function De(q){return{...u.from(q.location.range),message:q.message,resource:q.location.uri}}we.from=De;function me(q){return new l.DiagnosticRelatedInformation(new l.Location(q.resource,u.to(q)),q.message)}we.to=me})(_=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var v;(function(we){function De(q){switch(q){case l.DiagnosticSeverity.Error:return k.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return k.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return k.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return k.MarkerSeverity.Hint}return k.MarkerSeverity.Error}we.from=De;function me(q){switch(q){case k.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case k.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case k.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case k.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}we.to=me})(v=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var T;(function(we){function De(q){return typeof q=="number"&&q>=l.ViewColumn.One?q-1:q===l.ViewColumn.Beside?E.SIDE_GROUP:E.ACTIVE_GROUP}we.from=De;function me(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=me})(T=e.ViewColumn||(e.ViewColumn={}));function U(we){return typeof we.range<"u"}function V(we){return we.length===0?!0:!!U(we[0])}e.isDecorationOptionsArr=V;var x;(function(we){function De(qe){return qe.map(we.from)}we.fromMany=De;function me(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function q(qe){let Ge;if(me(qe)){const{language:wt,value:_t}=qe;Ge={value:"```"+wt+`
`+_t+"\n```\n"}}else l.MarkdownString.isMarkdownString(qe)?Ge={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?Ge={value:qe}:Ge={value:""};const ct=Object.create(null);Ge.uris=ct;const It=wt=>{try{let _t=R.URI.parse(wt,!0);_t=_t.with({query:Ae(_t.query,ct)}),ct[wt]=_t}catch{}return""},Et=new y.marked.Renderer;return Et.link=It,Et.image=wt=>typeof wt=="string"?It(w.parseHrefAndDimensions(wt).href):"",(0,y.marked)(Ge.value,{renderer:Et}),Ge}we.from=q;function Ae(qe,Ge){if(!qe)return qe;let ct;try{ct=(0,A.parse)(qe)}catch{}if(!ct)return qe;let It=!1;return ct=(0,b.cloneAndChange)(ct,Et=>{if(R.URI.isUri(Et)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ge[wt]=Et,It=!0,wt}else return}),It?JSON.stringify(ct):qe}function Le(qe){const Ge=new l.MarkdownString(qe.value,qe.supportThemeIcons);return Ge.isTrusted=qe.isTrusted,Ge.supportHtml=qe.supportHtml,Ge.baseUri=qe.baseUri?R.URI.from(qe.baseUri):void 0,Ge}we.to=Le;function et(qe){if(!!qe)return typeof qe=="string"?qe:we.from(qe)}we.fromStrict=et})(x=e.MarkdownString||(e.MarkdownString={}));function C(we){return V(we)?we.map(De=>({range:u.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?x.fromMany(De.hoverMessage):De.hoverMessage?x.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):we.map(De=>({range:u.from(De)}))}e.fromRangeOrRangeWithMessage=C;function L(we){return typeof we>"u"?we:typeof we=="string"?R.URI.file(we):we}e.pathOrURIToURI=L;var B;(function(we){function De(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?L(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}we.from=De})(B=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(we){function De(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?L(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?B.from(me.before):void 0,after:me.after?B.from(me.after):void 0}}we.from=De})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var K;(function(we){function De(me){if(typeof me>"u")return me;switch(me){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=De})(K=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var H;(function(we){function De(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?K.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?F.from(me.light):void 0,dark:me.dark?F.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?L(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?B.from(me.before):void 0,after:me.after?B.from(me.after):void 0}}we.from=De})(H=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var O;(function(we){function De(q){return{text:q.newText,eol:q.newEol&&Xe.from(q.newEol),range:u.from(q.range)}}we.from=De;function me(q){const Ae=new l.TextEdit(u.to(q.range),q.text);return Ae.newEol=typeof q.eol>"u"?void 0:Xe.to(q.eol),Ae}we.to=me})(O=e.TextEdit||(e.TextEdit={}));var ee;(function(we){function De(q,Ae,Le){const et={edits:[]};if(q instanceof l.WorkspaceEdit){const qe=new M.ResourceSet;for(const Ge of q._allEntries())Ge._type===1&&R.URI.isUri(Ge.to)&&Ge.from===void 0&&qe.add(Ge.to);for(const Ge of q._allEntries())if(Ge._type===1)et.edits.push({oldResource:Ge.from,newResource:Ge.to,options:Ge.options,metadata:Ge.metadata});else if(Ge._type===2)et.edits.push({resource:Ge.uri,textEdit:O.from(Ge.edit),versionId:qe.has(Ge.uri)?void 0:Ae?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata});else if(Ge._type===6){if(!Le){console.warn("DROPPING snippet text edit because proposal IS NOT ENABLED",Ge);continue}et.edits.push({resource:Ge.uri,textEdit:{range:u.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:qe.has(Ge.uri)?void 0:Ae?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata})}else Ge._type===3?et.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&et.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(rt.from)}})}return et}we.from=De;function me(q){const Ae=new l.WorkspaceEdit;for(const Le of q.edits)Le.textEdit?Ae.replace(R.URI.revive(Le.resource),u.to(Le.textEdit.range),Le.textEdit.text):Ae.renameFile(R.URI.revive(Le.oldResource),R.URI.revive(Le.newResource),Le.options);return Ae}we.to=me})(ee=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ue;(function(we){const De=Object.create(null);De[l.SymbolKind.File]=0,De[l.SymbolKind.Module]=1,De[l.SymbolKind.Namespace]=2,De[l.SymbolKind.Package]=3,De[l.SymbolKind.Class]=4,De[l.SymbolKind.Method]=5,De[l.SymbolKind.Property]=6,De[l.SymbolKind.Field]=7,De[l.SymbolKind.Constructor]=8,De[l.SymbolKind.Enum]=9,De[l.SymbolKind.Interface]=10,De[l.SymbolKind.Function]=11,De[l.SymbolKind.Variable]=12,De[l.SymbolKind.Constant]=13,De[l.SymbolKind.String]=14,De[l.SymbolKind.Number]=15,De[l.SymbolKind.Boolean]=16,De[l.SymbolKind.Array]=17,De[l.SymbolKind.Object]=18,De[l.SymbolKind.Key]=19,De[l.SymbolKind.Null]=20,De[l.SymbolKind.EnumMember]=21,De[l.SymbolKind.Struct]=22,De[l.SymbolKind.Event]=23,De[l.SymbolKind.Operator]=24,De[l.SymbolKind.TypeParameter]=25;function me(Ae){return typeof De[Ae]=="number"?De[Ae]:6}we.from=me;function q(Ae){for(const Le in De)if(De[Le]===Ae)return Number(Le);return l.SymbolKind.Property}we.to=q})(ue=e.SymbolKind||(e.SymbolKind={}));var oe;(function(we){function De(q){switch(q){case l.SymbolTag.Deprecated:return 1}}we.from=De;function me(q){switch(q){case 1:return l.SymbolTag.Deprecated}}we.to=me})(oe=e.SymbolTag||(e.SymbolTag={}));var le;(function(we){function De(q){return{name:q.name,kind:ue.from(q.kind),tags:q.tags&&q.tags.map(oe.from),containerName:q.containerName,location:ve.from(q.location)}}we.from=De;function me(q){const Ae=new l.SymbolInformation(q.name,ue.to(q.kind),q.containerName,ve.to(q.location));return Ae.tags=q.tags&&q.tags.map(oe.to),Ae}we.to=me})(le=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var te;(function(we){function De(q){const Ae={name:q.name||"!!MISSING: name!!",detail:q.detail,range:u.from(q.range),selectionRange:u.from(q.selectionRange),kind:ue.from(q.kind),tags:q.tags?.map(oe.from)??[]};return q.children&&(Ae.children=q.children.map(De)),Ae}we.from=De;function me(q){const Ae=new l.DocumentSymbol(q.name,q.detail,ue.to(q.kind),u.to(q.range),u.to(q.selectionRange));return(0,a.isNonEmptyArray)(q.tags)&&(Ae.tags=q.tags.map(oe.to)),q.children&&(Ae.children=q.children.map(me)),Ae}we.to=me})(te=e.DocumentSymbol||(e.DocumentSymbol={}));var Ee;(function(we){function De(q){const Ae=new l.CallHierarchyItem(ue.to(q.kind),q.name,q.detail||"",R.URI.revive(q.uri),u.to(q.range),u.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}we.to=De;function me(q,Ae,Le){if(Ae=Ae??q._sessionId,Le=Le??q._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,name:q.name,detail:q.detail,kind:ue.from(q.kind),uri:q.uri,range:u.from(q.range),selectionRange:u.from(q.selectionRange),tags:q.tags?.map(oe.from)}}we.from=me})(Ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var be;(function(we){function De(me){return new l.CallHierarchyIncomingCall(Ee.to(me.from),me.fromRanges.map(q=>u.to(q)))}we.to=De})(be=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ne;(function(we){function De(me){return new l.CallHierarchyOutgoingCall(Ee.to(me.to),me.fromRanges.map(q=>u.to(q)))}we.to=De})(ne=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(we){function De(q){return{range:q.range&&u.from(q.range),uri:q.uri}}we.from=De;function me(q){return new l.Location(R.URI.revive(q.uri),u.to(q.range))}we.to=me})(ve=e.location||(e.location={}));var Pe;(function(we){function De(q){const Ae=q,Le=q;return{originSelectionRange:Ae.originSelectionRange?u.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:Le.uri,range:u.from(Ae.targetRange?Ae.targetRange:Le.range),targetSelectionRange:Ae.targetSelectionRange?u.from(Ae.targetSelectionRange):void 0}}we.from=De;function me(q){return{targetUri:R.URI.revive(q.uri),targetRange:u.to(q.range),targetSelectionRange:q.targetSelectionRange?u.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?u.to(q.originSelectionRange):void 0}}we.to=me})(Pe=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(we){function De(q){return{range:u.from(q.range),contents:x.fromMany(q.contents)}}we.from=De;function me(q){return new l.Hover(q.contents.map(x.to),u.to(q.range))}we.to=me})(Fe=e.Hover||(e.Hover={}));var xe;(function(we){function De(q){return{range:u.from(q.range),expression:q.expression}}we.from=De;function me(q){return new l.EvaluatableExpression(u.to(q.range),q.expression)}we.to=me})(xe=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Qe;(function(we){function De(q){if(q instanceof l.InlineValueText)return{type:"text",range:u.from(q.range),text:q.text};if(q instanceof l.InlineValueVariableLookup)return{type:"variable",range:u.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}we.from=De;function me(q){switch(q.type){case"text":return{range:u.to(q.range),text:q.text};case"variable":return{range:u.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:u.to(q.range),expression:q.expression}}}we.to=me})(Qe=e.InlineValue||(e.InlineValue={}));var ke;(function(we){function De(q){return{frameId:q.frameId,stoppedLocation:u.from(q.stoppedLocation)}}we.from=De;function me(q){return new l.InlineValueContext(q.frameId,u.to(q.stoppedLocation))}we.to=me})(ke=e.InlineValueContext||(e.InlineValueContext={}));var Se;(function(we){function De(q){return{range:u.from(q.range),kind:q.kind}}we.from=De;function me(q){return new l.DocumentHighlight(u.to(q.range),q.kind)}we.to=me})(Se=e.DocumentHighlight||(e.DocumentHighlight={}));var ye;(function(we){function De(me){switch(me){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}we.to=De})(ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(we){function De(me){return{triggerKind:ye.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}we.to=De})(ae=e.CompletionContext||(e.CompletionContext={}));var ce;(function(we){function De(q){switch(q){case l.CompletionItemTag.Deprecated:return 1}}we.from=De;function me(q){switch(q){case 1:return l.CompletionItemTag.Deprecated}}we.to=me})(ce=e.CompletionItemTag||(e.CompletionItemTag={}));var Q;(function(we){const De=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function me(Le){return De.get(Le)??9}we.from=me;const q=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Ae(Le){return q.get(Le)??l.CompletionItemKind.Property}we.to=Ae})(Q=e.CompletionItemKind||(e.CompletionItemKind={}));var J;(function(we){function De(me,q){const Ae=new l.CompletionItem(me.label);return Ae.insertText=me.insertText,Ae.kind=Q.to(me.kind),Ae.tags=me.tags?.map(ce.to),Ae.detail=me.detail,Ae.documentation=w.isMarkdownString(me.documentation)?x.to(me.documentation):me.documentation,Ae.sortText=me.sortText,Ae.filterText=me.filterText,Ae.preselect=me.preselect,Ae.commitCharacters=me.commitCharacters,S.Range.isIRange(me.range)?Ae.range=u.to(me.range):typeof me.range=="object"&&(Ae.range={inserting:u.to(me.range.insert),replacing:u.to(me.range.replace)}),Ae.keepWhitespace=typeof me.insertTextRules>"u"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Ae.insertText=new l.SnippetString(me.insertText):(Ae.insertText=me.insertText,Ae.textEdit=Ae.range instanceof l.Range?new l.TextEdit(Ae.range,Ae.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Ae.additionalTextEdits=me.additionalTextEdits.map(Le=>O.to(Le))),Ae.command=q&&me.command?q.fromInternal(me.command):void 0,Ae}we.to=De})(J=e.CompletionItem||(e.CompletionItem={}));var I;(function(we){function De(q){return{label:q.label,documentation:x.fromStrict(q.documentation)}}we.from=De;function me(q){return{label:q.label,documentation:w.isMarkdownString(q.documentation)?x.to(q.documentation):q.documentation}}we.to=me})(I=e.ParameterInformation||(e.ParameterInformation={}));var z;(function(we){function De(q){return{label:q.label,documentation:x.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(I.from):[],activeParameter:q.activeParameter}}we.from=De;function me(q){return{label:q.label,documentation:w.isMarkdownString(q.documentation)?x.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(I.to):[],activeParameter:q.activeParameter}}we.to=me})(z=e.SignatureInformation||(e.SignatureInformation={}));var W;(function(we){function De(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(z.from):[]}}we.from=De;function me(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(z.to):[]}}we.to=me})(W=e.SignatureHelp||(e.SignatureHelp={}));var j;(function(we){function De(me,q){const Ae=new l.InlayHint(r.to(q.position),typeof q.label=="string"?q.label:q.label.map(re.to.bind(void 0,me)),q.kind&&de.to(q.kind));return Ae.textEdits=q.textEdits&&q.textEdits.map(O.to),Ae.tooltip=w.isMarkdownString(q.tooltip)?x.to(q.tooltip):q.tooltip,Ae.paddingLeft=q.paddingLeft,Ae.paddingRight=q.paddingRight,Ae}we.to=De})(j=e.InlayHint||(e.InlayHint={}));var re;(function(we){function De(me,q){const Ae=new l.InlayHintLabelPart(q.label);return Ae.tooltip=w.isMarkdownString(q.tooltip)?x.to(q.tooltip):q.tooltip,m.Command.is(q.command)&&(Ae.command=me.fromInternal(q.command)),q.location&&(Ae.location=ve.to(q.location)),Ae}we.to=De})(re=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var de;(function(we){function De(q){return q}we.from=De;function me(q){return q}we.to=me})(de=e.InlayHintKind||(e.InlayHintKind={}));var Z;(function(we){function De(q){return{range:u.from(q.range),url:q.target,tooltip:q.tooltip}}we.from=De;function me(q){let Ae;if(q.url)try{Ae=typeof q.url=="string"?R.URI.parse(q.url,!0):R.URI.revive(q.url)}catch{}return new l.DocumentLink(u.to(q.range),Ae)}we.to=me})(Z=e.DocumentLink||(e.DocumentLink={}));var pe;(function(we){function De(q){const Ae=new l.ColorPresentation(q.label);return q.textEdit&&(Ae.textEdit=O.to(q.textEdit)),q.additionalTextEdits&&(Ae.additionalTextEdits=q.additionalTextEdits.map(Le=>O.to(Le))),Ae}we.to=De;function me(q){return{label:q.label,textEdit:q.textEdit?O.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Ae=>O.from(Ae)):void 0}}we.from=me})(pe=e.ColorPresentation||(e.ColorPresentation={}));var ge;(function(we){function De(q){return new l.Color(q[0],q[1],q[2],q[3])}we.to=De;function me(q){return[q.red,q.green,q.blue,q.alpha]}we.from=me})(ge=e.Color||(e.Color={}));var Ne;(function(we){function De(q){return{range:u.from(q.range)}}we.from=De;function me(q){return new l.SelectionRange(u.to(q.range))}we.to=me})(Ne=e.SelectionRange||(e.SelectionRange={}));var Be;(function(we){function De(me){switch(me){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}we.to=De})(Be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ye;(function(we){function De(q){switch(q){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}we.from=De;function me(q){switch(q){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}we.to=me})(Ye=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Xe;(function(we){function De(q){if(q===l.EndOfLine.CRLF)return 1;if(q===l.EndOfLine.LF)return 0}we.from=De;function me(q){if(q===1)return l.EndOfLine.CRLF;if(q===0)return l.EndOfLine.LF}we.to=me})(Xe=e.EndOfLine||(e.EndOfLine={}));var Te;(function(we){function De(me){if(typeof me=="object")return me.viewId;switch(me){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=De})(Te=e.ProgressLocation||(e.ProgressLocation={}));var nt;(function(we){function De(me){const q={start:me.start+1,end:me.end+1};return me.kind&&(q.kind=G.from(me.kind)),q}we.from=De})(nt=e.FoldingRange||(e.FoldingRange={}));var G;(function(we){function De(me){if(me)switch(me){case l.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}we.from=De})(G=e.FoldingRangeKind||(e.FoldingRangeKind={}));var X;(function(we){function De(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?u.from(me.selection):void 0,override:typeof me.override=="boolean"?h.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}we.from=De})(X=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var fe;(function(we){function De(Le){return Le instanceof l.RelativePattern?Le.toJSON():typeof Le=="string"?Le:me(Le)||q(Le)?new l.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}we.from=De;function me(Le){const et=Le;return et?R.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function q(Le){const et=Le;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function Ae(Le){return typeof Le=="string"?Le:new l.RelativePattern(R.URI.revive(Le.baseUri),Le.pattern)}we.to=Ae})(fe=e.GlobPattern||(e.GlobPattern={}));var Ue;(function(we){function De(me){if(me){if(Array.isArray(me))return me.map(De);if(typeof me=="string")return me;{const q=me;return{language:q.language,scheme:q.scheme,pattern:fe.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}we.from=De})(Ue=e.LanguageSelector||(e.LanguageSelector={}));var He;(function(we){function De(q){return{start:q.start,end:q.end}}we.from=De;function me(q){return new l.NotebookRange(q.start,q.end)}we.to=me})(He=e.NotebookRange||(e.NotebookRange={}));var Ze;(function(we){function De(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}we.to=De;function me(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}we.from=me})(Ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(we){function De(me){if(me===d.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;if(me===d.NotebookCellExecutionState.Pending)return;if(me===d.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}we.to=De})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var We;(function(we){function De(q){switch(q){case l.NotebookCellKind.Markup:return d.CellKind.Markup;case l.NotebookCellKind.Code:default:return d.CellKind.Code}}we.from=De;function me(q){switch(q){case d.CellKind.Markup:return l.NotebookCellKind.Markup;case d.CellKind.Code:default:return l.NotebookCellKind.Code}}we.to=me})(We=e.NotebookCellKind||(e.NotebookCellKind={}));var it;(function(we){function De(q){const Ae={metadata:q.metadata??Object.create(null),cells:[]};for(const Le of q.cells)l.NotebookCellData.validate(Le),Ae.cells.push(rt.from(Le));return Ae}we.from=De;function me(q){const Ae=new l.NotebookData(q.cells.map(rt.to));return(0,P.isEmptyObject)(q.metadata)||(Ae.metadata=q.metadata),Ae}we.to=me})(it=e.NotebookData||(e.NotebookData={}));var rt;(function(we){function De(q){return{cellKind:We.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:Ze.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(at.from):[]}}we.from=De;function me(q){return new l.NotebookCellData(We.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(at.to):void 0,q.metadata,q.internalMetadata?Ze.to(q.internalMetadata):void 0)}we.to=me})(rt=e.NotebookCellData||(e.NotebookCellData={}));var dt;(function(we){function De(q){return{mime:q.mime,valueBytes:p.VSBuffer.wrap(q.data)}}we.from=De;function me(q){return new l.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}we.to=me})(dt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var at;(function(we){function De(q){return{outputId:q.id,items:q.items.map(dt.from),metadata:q.metadata}}we.from=De;function me(q){const Ae=q.items.map(dt.to);return new l.NotebookCellOutput(Ae,q.outputId,q.metadata)}we.to=me})(at=e.NotebookCellOutput||(e.NotebookCellOutput={}));var st;(function(we){function De(Ae){return q(Ae)?{include:(0,P.withNullAsUndefined)(fe.from(Ae.include)),exclude:(0,P.withNullAsUndefined)(fe.from(Ae.exclude))}:(0,P.withNullAsUndefined)(fe.from(Ae))}we.from=De;function me(Ae){return q(Ae)?{include:fe.to(Ae.include),exclude:fe.to(Ae.exclude)}:fe.to(Ae)}we.to=me;function q(Ae){const Le=Ae;return Le?!(0,P.isUndefinedOrNull)(Le.include)&&!(0,P.isUndefinedOrNull)(Le.exclude):!1}})(st=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var yt;(function(we){function De(me,q,Ae){const Le=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Le,Ae),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}we.from=De})(yt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Rt;(function(we){function De(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{}}}we.from=De})(Rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ot;(function(we){function De(q){return{uri:q.uri,provides:q.provides}}we.from=De;function me(q){return new l.NotebookRendererScript(R.URI.revive(q.uri),q.provides)}we.to=me})(Ot=e.NotebookRendererScript||(e.NotebookRendererScript={}));var mt;(function(we){function De(q){return{message:x.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location&&{range:u.from(q.location.range),uri:q.location.uri}}}we.from=De;function me(q){const Ae=new l.TestMessage(typeof q.message=="string"?q.message:x.to(q.message));return Ae.actualOutput=q.actual,Ae.expectedOutput=q.expected,Ae.location=q.location?ve.to(q.location):void 0,Ae}we.to=me})(mt=e.TestMessage||(e.TestMessage={}));var Dt;(function(we){we.namespace=g.namespaceTestTag,we.denamespace=g.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var Lt;(function(we){function De(q){const Ae=(0,f.getPrivateApiFor)(q).controllerId;return{extId:o.TestId.fromExtHostTestItem(q,Ae).toString(),label:q.label,uri:R.URI.revive(q.uri),busy:q.busy,tags:q.tags.map(Le=>Dt.namespace(Ae,Le.id)),range:S.Range.lift(u.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&x.fromStrict(q.error)||null}}we.from=De;function me(q){return{parent:void 0,error:void 0,id:o.TestId.fromString(q.extId).localId,label:q.label,uri:R.URI.revive(q.uri),tags:(q.tags||[]).map(Ae=>{const{tagId:Le}=Dt.denamespace(Ae);return new l.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(q.range||void 0),canResolveChildren:!1,busy:q.busy,description:q.description||void 0,sortText:q.sortText||void 0}}we.toPlain=me})(Lt=e.TestItem||(e.TestItem={})),function(we){function De(q){return{id:q.id}}we.from=De;function me(q){return new l.TestTag(q.id)}we.to=me}(Dt=e.TestTag||(e.TestTag={}));var Ft;(function(we){const De=(q,Ae)=>{const Le=[];for(const[qe,Ge]of Ae)o.TestId.compare(Ge.item.extId,qe)===2&&(Ae.delete(qe),Le.push(Ge));const et={...Lt.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(Ge=>Ge.type===0).map(mt.to)})),children:Le.map(qe=>De(qe,Ae))};for(const qe of et.children)qe.parent=et;return et};function me(q){const Ae=[],Le=new Map;for(const et of q.items)Le.set(et.item.extId,et),q.request.targets.some(qe=>qe.controllerId===et.controllerId&&qe.testIds.includes(et.item.extId))&&Ae.push(et);return{completedAt:q.completedAt,results:Ae.map(et=>De(et,Le))}}we.to=me})(Ft=e.TestResults||(e.TestResults={}));var Ve;(function(we){function De(Le){return{covered:Le.covered,total:Le.covered}}function me(Le){return"line"in Le?r.from(Le):u.from(Le)}function q(Le){return"branches"in Le?{count:Le.executionCount,location:me(Le.location),type:1,branches:Le.branches.length?Le.branches.map(et=>({count:et.executionCount,location:et.location&&me(et.location)})):void 0}:{type:0,count:Le.executionCount,location:me(Le.location)}}we.fromDetailed=q;function Ae(Le){return{uri:Le.uri,statement:De(Le.statementCoverage),branch:Le.branchCoverage&&De(Le.branchCoverage),function:Le.functionCoverage&&De(Le.functionCoverage),details:Le.detailedCoverage?.map(q)}}we.fromFile=Ae})(Ve=e.TestCoverage||(e.TestCoverage={}));var Nt;(function(we){function De(me){switch(me){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}we.to=De})(Nt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Tt;(function(we){function De(q){const Ae=new l.TypeHierarchyItem(ue.to(q.kind),q.name,q.detail||"",R.URI.revive(q.uri),u.to(q.range),u.to(q.selectionRange));return Ae._sessionId=q._sessionId,Ae._itemId=q._itemId,Ae}we.to=De;function me(q,Ae,Le){if(Ae=Ae??q._sessionId,Le=Le??q._itemId,Ae===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:Le,kind:ue.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:u.from(q.range),selectionRange:u.from(q.selectionRange),tags:q.tags?.map(oe.from)}}we.from=me})(Tt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Mt;(function(we){function De(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}we.from=De})(Mt=e.ViewBadge||(e.ViewBadge={}));var pt;(function(we){function De(me,q){const Ae=me.fileData;return Ae?new class extends l.DataTransferItem{asFile(){return{name:Ae.name,uri:R.URI.revive(Ae.uri),data:(0,D.once)(()=>q())}}}(""):new l.DataTransferItem(me.asString)}we.toDataTransferItem=De})(pt=e.DataTransferItem||(e.DataTransferItem={}));var Ct;(function(we){function De(q,Ae){const Le=q.items.map(([et,qe],Ge)=>[et,pt.toDataTransferItem(qe,()=>Ae(Ge))]);return new l.DataTransfer(Le)}we.toDataTransfer=De;async function me(q){const Ae={items:[]},Le=[];return q.forEach((et,qe)=>{Le.push((async()=>{const Ge=await et.asString(),ct=et.asFile();Ae.items.push([qe,{asString:Ge,fileData:ct?{name:ct.name,uri:ct.uri}:void 0}])})())}),await Promise.all(Le),Ae}we.toDataTransferDTO=me})(Ct=e.DataTransfer||(e.DataTransfer={}))}),define(Ce[174],Ie([1,0,2,11,6,8,241]),function(ie,e,a,p,w,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(P,R,S,m={timeout:1500,errors:3}){this._logService=P,this._documents=R,this._mainThreadBulkEdits=S,this._thresholds=m,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(R,S,m)=>{const f={dispose:this._callbacks.push([R,S,P])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(P,R){const S=a.URI.revive(P);let m=!1;const k=setTimeout(()=>m=!0,this._thresholds.timeout),f=[];try{for(const h of[...this._callbacks]){if(m)break;const d=this._documents.getDocument(S),o=await this._deliverEventAsyncAndBlameBadListeners(h,{document:d,reason:M.TextDocumentSaveReason.to(R)});f.push(o)}}finally{clearTimeout(k)}return f}_deliverEventAsyncAndBlameBadListeners([P,R,S],m){const k=this._badListeners.get(P);return typeof k=="number"&&k>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(S,P,R,m).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const h=this._badListeners.get(P);this._badListeners.set(P,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,R,S,m){const k=[],f=Date.now(),{document:h,reason:d}=m,{version:o}=h,g=Object.freeze({document:h,reason:d,waitUntil(E){if(Object.isFrozen(k))throw(0,p.illegalState)("waitUntil can not be called async");k.push(Promise.resolve(E))}});try{R.apply(S,[g])}catch(E){return Promise.reject(E)}return Object.freeze(k),new Promise((E,l)=>{const D=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(k).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(D),E(i)}).catch(i=>{clearTimeout(D),l(i)})}).then(E=>{const l={edits:[]};for(const D of E)if(Array.isArray(D)&&D.every(i=>i instanceof w.TextEdit))for(const{newText:i,newEol:u,range:n}of D)l.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:n&&M.Range.from(n),text:i,eol:u&&M.EndOfLine.from(u)}});if(l.edits.length!==0)return o===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Ce[175],Ie([1,0,12,2,8,6,89]),function(ie,e,a,p,w,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(S,m,k,f){this.start=S,this.deletedCount=m,this.deletedItems=k,this.items=f}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class b{constructor(S,m,k){this.notebook=S,this._extHostDocument=m,this._cellData=k,this.handle=k.handle,this.uri=p.URI.revive(k.uri),this.cellKind=k.cellKind,this._outputs=k.outputs.map(w.NotebookCellOutput.to),this._internalMetadata=k.internalMetadata??{},this._metadata=Object.freeze(k.metadata??{}),this._previousResult=Object.freeze(w.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}static asModelAddData(S,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:S}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const S=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:w.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return S._mime},set mime(f){S._mime=f},get outputs(){return S._outputs.slice(0)},get metadata(){return S._metadata},get executionSummary(){return S._previousResult}};this._apiCell=Object.freeze(k)}return this._apiCell}setOutputs(S){this._outputs=S.map(w.NotebookCellOutput.to)}setOutputItems(S,m,k){const f=k.map(w.NotebookCellOutputItem.to),h=this._outputs.find(d=>d.id===S);h&&(m||(h.items.length=0),h.items.push(...f))}setMetadata(S){this._metadata=Object.freeze(S)}setInternalMetadata(S){this._internalMetadata=S,this._previousResult=Object.freeze(w.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.ExtHostCell=b;class P{constructor(S,m,k,f,h){this._proxy=S,this._textDocumentsAndEditors=m,this._textDocuments=k,this.uri=f,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=h.viewType,this._metadata=Object.freeze(h.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,h.cells]],!0,void 0),this._versionId=h.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const S=this,m={get uri(){return S.uri},get version(){return S._versionId},get notebookType(){return S._notebookType},get isDirty(){return S._isDirty},get isUntitled(){return S.uri.scheme===a.Schemas.untitled},get isClosed(){return S._disposed},get metadata(){return S._metadata},get cellCount(){return S._cells.length},cellAt(k){return k=S._validateIndex(k),S._cells[k].apiCell},getCells(k){return(k?S._getCells(k):S._cells).map(h=>h.apiCell)},save(){return S._save()}};this._notebook=Object.freeze(m)}return this._notebook}updateBackup(S){this._backup?.delete(),this._backup=S}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(S){S.metadata&&(this._metadata=Object.freeze({...this._metadata,...S.metadata}))}acceptDirty(S){this._isDirty=S}acceptModelChanged(S,m,k){this._versionId=S.versionId,this._isDirty=m,this.acceptDocumentPropertiesChanged({metadata:k});const f={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},h=[];for(const o of S.rawEvents)o.kind===y.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1,f.contentChanges):o.kind===y.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx,f.contentChanges):o.kind===y.NotebookCellsChangeType.Output?(this._setCellOutputs(o.index,o.outputs),h.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===y.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems),h.push({cell:this._cells[o.index].apiCell,outputs:this._cells[o.index].apiCell.outputs})):o.kind===y.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(o.index,o.language),h.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document})):o.kind===y.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this._cells[o.index].apiCell,document:this._cells[o.index].apiCell.document}):o.kind===y.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(o.index,o.mime):o.kind===y.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(o.index,o.metadata),h.push({cell:this._cells[o.index].apiCell,metadata:this._cells[o.index].apiCell.metadata})):o.kind===y.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(o.index,o.internalMetadata),h.push({cell:this._cells[o.index].apiCell,executionSummary:this._cells[o.index].apiCell.executionSummary}));const d=new Map;for(let o=0;o<h.length;o++){const g=h[o],E=d.get(g.cell);if(E===void 0){const l=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...g});d.set(g.cell,l-1)}else f.cellChanges[E]={...f.cellChanges[E],...g}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}_validateIndex(S){return S=S|0,S<0?0:S>=this._cells.length?this._cells.length-1:S}_validateRange(S){let m=S.start|0,k=S.end|0;return m<0&&(m=0),k>this._cells.length&&(k=this._cells.length),S.with({start:m,end:k})}_getCells(S){S=this._validateRange(S);const m=[];for(let k=S.start;k<S.end;k++)m.push(this._cells[k]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(S,m,k){if(this._disposed)return;const f=[],h=[],d=[];if(S.reverse().forEach(o=>{const E=o[2].map(i=>{const u=new b(this,this._textDocumentsAndEditors,i);return m||h.push(b.asModelAddData(this.apiNotebook,i)),u}),l=new A(o[0],o[1],[],E),D=this._cells.splice(o[0],o[1],...E);for(const i of D)d.push(i.uri),l.deletedItems.push(i.apiCell);f.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:d}),k)for(const o of f)k.push(o.asApiEvent())}_moveCell(S,m,k){const f=this._cells.splice(S,1);this._cells.splice(m,0,...f);const h=[new A(S,1,f.map(d=>d.apiCell),[]),new A(m,0,[],f)];for(const d of h)k.push(d.asApiEvent())}_setCellOutputs(S,m){this._cells[S].setOutputs(m)}_setCellOutputItems(S,m,k,f){this._cells[S].setOutputItems(m,k,f)}_changeCellLanguage(S,m){const k=this._cells[S];k.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelLanguageChanged(k.uri,m)}_changeCellMime(S,m){const k=this._cells[S];k.apiCell.mime=m}_changeCellMetadata(S,m){this._cells[S].setMetadata(m)}_changeCellInternalMetadata(S,m){this._cells[S].setInternalMetadata(m)}getCellFromApiCell(S){return this._cells.find(m=>m.apiCell===S)}getCellFromIndex(S){return this._cells[S]}getCell(S){return this._cells.find(m=>m.handle===S)}getCellIndex(S){return this._cells.indexOf(S)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(Ce[92],Ie([1,0,11,8,6]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(A,b,P,R,S,m){this.id=A,this._proxy=b,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=S,this._visibleRanges=R,this._viewColumn=m}get apiEditor(){if(!this._editor){const A=this;this._editor={get document(){return A.notebookData.apiNotebook},get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(b){this.selections=[b]},get selections(){return A._selections},set selections(b){if(!Array.isArray(b)||!b.every(w.NotebookRange.isNotebookRange))throw(0,a.illegalArgument)("selections");A._selections=b,A._trySetSelections(b)},get visibleRanges(){return A._visibleRanges},revealRange(b,P){A._proxy.$tryRevealRange(A.id,p.NotebookRange.from(b),P??w.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn}},M.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(p.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}e.ExtHostNotebookEditor=M,M.apiEditorsToExtHost=new WeakMap}),define(Ce[176],Ie([1,0,5,15,8]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(A,b){this._logService=A,this._notebooksAndEditors=b,this._onDidChangeNotebookEditorSelection=new a.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new a.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(A,b){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,b);const P=this._notebooksAndEditors.getEditorById(A);b.visibleRanges&&P._acceptVisibleRanges(b.visibleRanges.ranges.map(w.NotebookRange.to)),b.selections&&P._acceptSelections(b.selections.selections.map(w.NotebookRange.to)),b.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),b.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const b in A)this._notebooksAndEditors.getEditorById(b)._acceptViewColumn(w.ViewColumn.to(A[b]))}};M=ze([$e(0,p.ILogService)],M),e.ExtHostNotebookEditors=M}),define(Ce[177],Ie([1,0,8,151,132,20,55,11]),function(ie,e,a,p,w,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class b{constructor(m){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=m}async withProgress(m,k,f){const h=this._handles++,{title:d,location:o,cancellable:g}=k,E={label:(0,w.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this._proxy.$startProgress(h,{location:a.ProgressLocation.from(o),title:d,source:E,cancellable:g},m.isUnderDevelopment?void 0:m.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(h,f,!!g)}_withProgress(m,k,f){let h;f&&(h=new M.CancellationTokenSource,this._mapHandleToCancellationSource.set(m,h));const d=g=>{this._proxy.$progressEnd(g),this._mapHandleToCancellationSource.delete(g),h?.dispose()};let o;try{o=k(new R(this._proxy,m),f&&h?h.token:M.CancellationToken.None)}catch(g){throw d(m),g}return o.then(g=>d(m),g=>d(m)),o}$acceptProgressCanceled(m){const k=this._mapHandleToCancellationSource.get(m);k&&(k.cancel(),this._mapHandleToCancellationSource.delete(m))}}e.ExtHostProgress=b;function P(S,m){return S.message=m.message,typeof m.increment=="number"&&(typeof S.increment=="number"?S.increment+=m.increment:S.increment=m.increment),S}class R extends p.Progress{constructor(m,k){super(f=>this.throttledReport(f)),this._proxy=m,this._handle=k}throttledReport(m){this._proxy.$progressReport(this._handle,m)}}ze([(0,y.throttle)(100,(S,m)=>P(S,m),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ce[93],Ie([1,0,49,90,47,65,48,8,2]),function(ie,e,a,p,w,M,y,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const P=(E,l,D,i)=>{let u=l;return{enumerable:!0,configurable:!1,get(){return u},set(n){if(!D(u,n)){const r=u;u=n,E.listener?.(i(n,r))}}}},R=(E,l)=>E===l,S={range:(E,l)=>E===l?!0:!E||!l?!1:E.isEqual(l),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(E,l)=>!(E.length!==l.length||E.some(D=>!l.find(i=>D.id===i.id)))},m=E=>l=>({op:4,update:E(l)}),k=(E,l)=>({range:P(E,void 0,S.range,m(D=>({range:a.Range.lift(A.Range.from(D))}))),label:P(E,l,S.label,m(D=>({label:D}))),description:P(E,void 0,S.description,m(D=>({description:D}))),sortText:P(E,void 0,S.sortText,m(D=>({sortText:D}))),canResolveChildren:P(E,!1,S.canResolveChildren,D=>({op:2,state:D})),busy:P(E,!1,S.busy,m(D=>({busy:D}))),error:P(E,void 0,S.error,m(D=>({error:A.MarkdownString.fromStrict(D)||null}))),tags:P(E,[],S.tags,(D,i)=>({op:1,new:D.map(A.TestTag.from),old:i.map(A.TestTag.from)}))}),f=E=>{const l=w.TestId.fromString(E.extId),D=new d(l.controllerId,l.localId,E.label,b.URI.revive(E.uri)||void 0);return D.range=A.Range.to(E.range||void 0),D.description=E.description||void 0,D.sortText=E.sortText||void 0,D.tags=E.tags.map(i=>A.TestTag.to({id:(0,y.denamespaceTestTag)(i).tagId})),D},h=E=>{let l;for(const D of E.tests){const i=f(D.item);(0,p.getPrivateApiFor)(i).parent=l,l=i}return l};e.toItemFromContext=h;class d{constructor(l,D,i,u){if(D.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(D)} symbol`);const n=(0,p.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:D,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof o?void 0:n.parent}},children:{value:(0,M.createTestItemChildren)(n,p.getPrivateApiFor,d),enumerable:!0,writable:!1},...k(n,i)})}}e.TestItemImpl=d;class o extends d{constructor(l,D){super(l,l,D,void 0)}}e.TestItemRootImpl=o;class g extends M.TestItemCollection{constructor(l,D,i){super({controllerId:l,getDocumentVersion:u=>i.getDocument(u)?.version,getApiFor:p.getPrivateApiFor,getChildren:u=>u.children,root:new o(l,D),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(Ce[94],Ie([1,0,44,11,73,8,6]),function(ie,e,a,p,w,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(m,k,f){const h=A._Keys.nextId();m.$registerTextEditorDecorationType(k.identifier,h,M.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:h,dispose(){m.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=A,A._Keys=new w.IdGenerator("TextEditorDecorationType");class b{constructor(m,k){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=k.undoStopBefore,this._undoStopAfter=k.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,k){this._throwIfFinalized();let f=null;if(m instanceof y.Position)f=new y.Range(m,m);else if(m instanceof y.Range)f=m;else throw new Error("Unrecognized location");this._pushEdit(f,k,!1)}insert(m,k){this._throwIfFinalized(),this._pushEdit(new y.Range(m,m),k,!0)}delete(m){this._throwIfFinalized();let k=null;if(m instanceof y.Range)k=m;else throw new Error("Unrecognized location");this._pushEdit(k,null,!0)}_pushEdit(m,k,f){const h=this._document.validateRange(m);this._collectedEdits.push({range:h,text:k,forceMoveMarkers:f})}setEndOfLine(m){if(this._throwIfFinalized(),m!==y.EndOfLine.LF&&m!==y.EndOfLine.CRLF)throw(0,p.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=b;class P{constructor(m,k,f,h){this._proxy=m,this._id=k,this._accept(f),this._logService=h;const d=this;this.value={get tabSize(){return d._tabSize},set tabSize(o){d._setTabSize(o)},get insertSpaces(){return d._insertSpaces},set insertSpaces(o){d._setInsertSpaces(o)},get cursorStyle(){return d._cursorStyle},set cursorStyle(o){d._setCursorStyle(o)},get lineNumbers(){return d._lineNumbers},set lineNumbers(o){d._setLineNumbers(o)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=M.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const k=Math.floor(m);return k>0?k:null}if(typeof m=="string"){const k=parseInt(m,10);return isNaN(k)?null:k>0?k:null}return null}_setTabSize(m){const k=this._validateTabSize(m);if(k!==null){if(typeof k=="number"){if(this._tabSize===k)return;this._tabSize=k}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:k}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const k=this._validateInsertSpaces(m);if(typeof k=="boolean"){if(this._insertSpaces===k)return;this._insertSpaces=k}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:k}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:M.TextEditorLineNumbersStyle.from(m)})))}assign(m){const k={};let f=!1;if(typeof m.tabSize<"u"){const h=this._validateTabSize(m.tabSize);h==="auto"?(f=!0,k.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,f=!0,k.tabSize=h)}if(typeof m.insertSpaces<"u"){const h=this._validateInsertSpaces(m.insertSpaces);h==="auto"?(f=!0,k.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,f=!0,k.insertSpaces=h)}typeof m.cursorStyle<"u"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,f=!0,k.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,f=!0,k.lineNumbers=M.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,k))}_warnOnError(m,k){k.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=P;class R{constructor(m,k,f,h,d,o,g,E){this.id=m,this._proxy=k,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._options=new P(this._proxy,this.id,o,f),this._visibleRanges=g,this._viewColumn=E;const l=this;this.value=Object.freeze({get document(){return h.getValue()},set document(D){throw(0,p.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(D){if(!(D instanceof y.Selection))throw(0,p.illegalArgument)("selection");l._selections=[D],l._trySetSelection()},get selections(){return l._selections},set selections(D){if(!Array.isArray(D)||D.some(i=>!(i instanceof y.Selection)))throw(0,p.illegalArgument)("selections");l._selections=D,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(D){throw(0,p.readonly)("visibleRanges")},get options(){return l._options.value},set options(D){l._disposed||l._options.assign(D)},get viewColumn(){return l._viewColumn},set viewColumn(D){throw(0,p.readonly)("viewColumn")},edit(D,i={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new b(h.getValue(),i);return D(u),l._applyEdit(u)},insertSnippet(D,i,u={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!i||Array.isArray(i)&&i.length===0)n=l._selections.map(r=>M.Range.from(r));else if(i instanceof y.Position){const{lineNumber:r,column:s}=M.Position.from(i);n=[{startLineNumber:r,startColumn:s,endLineNumber:r,endColumn:s}]}else if(i instanceof y.Range)n=[M.Range.from(i)];else{n=[];for(const r of i)if(r instanceof y.Range)n.push(M.Range.from(r));else{const{lineNumber:s,column:t}=M.Position.from(r);n.push({startLineNumber:s,startColumn:t,endLineNumber:s,endColumn:t})}}return k.$tryInsertSnippet(m,h.getValue().version,D.value,n,u)},setDecorations(D,i){const u=i.length===0;u&&!l._hasDecorationsForKey.has(D.key)||(u?l._hasDecorationsForKey.delete(D.key):l._hasDecorationsForKey.add(D.key),l._runOnProxy(()=>{if(M.isDecorationOptionsArr(i))return k.$trySetDecorations(m,D.key,M.fromRangeOrRangeWithMessage(i));{const n=new Array(4*i.length);for(let r=0,s=i.length;r<s;r++){const t=i[r];n[4*r]=t.start.line+1,n[4*r+1]=t.start.character+1,n[4*r+2]=t.end.line+1,n[4*r+3]=t.end.character+1}return k.$trySetDecorationsFast(m,D.key,n)}}))},revealRange(D,i){l._runOnProxy(()=>k.$tryRevealRange(m,M.Range.from(D),i||y.TextEditorRevealType.Default))},show(D){k.$tryShowEditor(m,M.ViewColumn.from(D))},hide(){k.$tryHideEditor(m)}})}dispose(){(0,a.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,a.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,a.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,a.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,a.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(M.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const k=m.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const f=k.edits.map(d=>d.range);f.sort((d,o)=>d.end.line===o.end.line?d.end.character===o.end.character?d.start.line===o.start.line?d.start.character-o.start.character:d.start.line-o.start.line:d.end.character-o.end.character:d.end.line-o.end.line);for(let d=0,o=f.length-1;d<o;d++){const g=f[d].end;if(f[d+1].start.isBefore(g))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=k.edits.map(d=>({range:M.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,k.documentVersionId,h,{setEndOfLine:typeof k.setEndOfLine=="number"?M.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this._logService.warn(k),null))}}e.ExtHostTextEditor=R}),define(Ce[178],Ie([1,0,3,147]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(p.IEnvironmentService)}),define(Ce[179],Ie([1,0,26,5,19]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(S){this.removedDueToLooping=S}}e.DeltaExtensionsResult=M;class y{constructor(S){this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=S,this._initialize()}_initialize(){this._extensionDescriptions.sort(b),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const S of this._extensionDescriptions){if(this._extensionsMap.has(a.ExtensionIdentifier.toKey(S.identifier))){console.error("Extension `"+S.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(a.ExtensionIdentifier.toKey(S.identifier),S),this._extensionsArr.push(S),Array.isArray(S.activationEvents))for(let m of S.activationEvents)m==="onUri"&&(m=`onUri:${a.ExtensionIdentifier.toKey(S.identifier)}`),this._activationMap.has(m)||this._activationMap.set(m,[]),this._activationMap.get(m).push(S)}}set(S){this._extensionDescriptions=S,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(S,m){this._extensionDescriptions=P(this._extensionDescriptions,m),this._extensionDescriptions=this._extensionDescriptions.concat(S);const k=y._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=P(this._extensionDescriptions,k.map(f=>f.identifier)),this._initialize(),this._onDidChange.fire(void 0),new M(k)}static _findLoopingExtensions(S){const m=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(o){this._nodesSet.has(o)||(this._nodesSet.add(o),this._nodesArr.push(o))}addArc(o,g){this.addNode(o),this.addNode(g),this._arcs.has(o)?this._arcs.get(o).push(g):this._arcs.set(o,[g])}getArcs(o){return this._arcs.has(o)?this._arcs.get(o):[]}hasOnlyGoodArcs(o,g){const E=m.getArcs(o);for(let l=0;l<E.length;l++)if(!g.has(E[l]))return!1;return!0}getNodes(){return this._nodesArr}},k=new Map;for(const o of S){const g=a.ExtensionIdentifier.toKey(o.identifier);if(k.set(g,o),o.extensionDependencies)for(const E of o.extensionDependencies){const l=a.ExtensionIdentifier.toKey(E);m.addArc(g,l)}}const f=new Set;m.getNodes().filter(o=>m.getArcs(o).length===0).forEach(o=>f.add(o));const h=m.getNodes().filter(o=>!f.has(o));let d;do{d=!1;for(let o=0;o<h.length;o++){const g=h[o];m.hasOnlyGoodArcs(g,f)&&(h.splice(o,1),o--,f.add(g),d=!0)}}while(d);return h.map(o=>k.get(o))}containsActivationEvent(S){return this._activationMap.has(S)}containsExtension(S){return this._extensionsMap.has(a.ExtensionIdentifier.toKey(S))}getExtensionDescriptionsForActivationEvent(S){const m=this._activationMap.get(S);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(S){const m=this._extensionsMap.get(a.ExtensionIdentifier.toKey(S));return m||void 0}getExtensionDescriptionByUUID(S){for(const m of this._extensionsArr)if(m.uuid===S)return m}getExtensionDescriptionByIdOrUUID(S,m){return this.getExtensionDescription(S)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=y;var A;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(A||(A={}));function b(R,S){const m=R.isBuiltin?0:R.isUnderDevelopment?2:1,k=S.isBuiltin?0:S.isUnderDevelopment?2:1;if(m!==k)return m-k;const f=w.posix.basename(R.extensionLocation.path),h=w.posix.basename(S.extensionLocation.path);return f<h?-1:f>h?1:0}function P(R,S){const m=new Set;return S.forEach(k=>m.add(a.ExtensionIdentifier.toKey(k))),R.filter(k=>!m.has(a.ExtensionIdentifier.toKey(k.identifier)))}}),define(Ce[95],Ie([1,0,23]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var p;(function(P){P[P.Desktop=1]="Desktop",P[P.Web=2]="Web"})(p=e.UIKind||(e.UIKind={}));var w;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(w=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function y(P){const R=a.VSBuffer.alloc(1);switch(P){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=y;function A(P,R){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=A;var b;(function(P){P.Start="START_NATIVE_LOG",P.End="END_NATIVE_LOG"})(b=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(Ce[27],Ie([1,0,5,2,3,26,153]),function(ie,e,a,p,w,M,y){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:p.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");class b{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=b;class P{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=P;class R{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class S{constructor(t){this.dependency=t}}e.MissingExtensionDependency=S;var m;(function(s){s[s.LocalProcess=1]="LocalProcess",s[s.LocalWebWorker=2]="LocalWebWorker",s[s.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function k(s){if(s===null)return"None";switch(s){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=k;class f{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,c){const _=[],v=[],T=[],U=[],V=o(this._allExtensions),x=o(t),C=(K,H)=>K.extensionLocation.toString()===H.extensionLocation.toString()||K.isBuiltin===H.isBuiltin||K.isUserBuiltin===H.isUserBuiltin||K.isUnderDevelopment===H.isUnderDevelopment;for(const K of this._allExtensions){const H=x.get(M.ExtensionIdentifier.toKey(K.identifier));if(!H){_.push(K.identifier),V.delete(M.ExtensionIdentifier.toKey(K.identifier));continue}if(!C(K,H)){_.push(K.identifier),V.delete(M.ExtensionIdentifier.toKey(K.identifier));continue}}for(const K of t){const H=V.get(M.ExtensionIdentifier.toKey(K.identifier));if(!H){v.push(K);continue}if(!C(H,K)){_.push(H.identifier),V.delete(M.ExtensionIdentifier.toKey(H.identifier));continue}}const L=d(this._myExtensions),B=d(c);for(const K of this._myExtensions)B.has(M.ExtensionIdentifier.toKey(K))||T.push(K);for(const K of c)L.has(M.ExtensionIdentifier.toKey(K))||U.push(K);const F={toRemove:_,toAdd:v,myToRemove:T,myToAdd:U};return this.delta(F),F}delta(t){const{toRemove:c,toAdd:_,myToRemove:v,myToAdd:T}=t,U=d(c),V=d(v);for(let x=0;x<this._allExtensions.length;x++)U.has(M.ExtensionIdentifier.toKey(this._allExtensions[x].identifier))&&(this._allExtensions.splice(x,1),x--);for(let x=0;x<this._myExtensions.length;x++)V.has(M.ExtensionIdentifier.toKey(this._myExtensions[x]))&&(this._myExtensions.splice(x,1),x--);for(const x of _)this._allExtensions.push(x);for(const x of T)this._myExtensions.push(x)}containsExtension(t){for(const c of this._myExtensions)if(M.ExtensionIdentifier.equals(c,t))return!0;return!1}}e.ExtensionHostExtensions=f;class h{constructor(t){if(this[A]="ExtensionIdentifierSet",this._map=new Map,this._toKey=M.ExtensionIdentifier.toKey,t)for(const c of t)this.add(c)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,c){this._map.forEach(_=>t.call(c,_,_,this))}*entries(){for(const[t,c]of this._map)yield[c,c]}keys(){return this._map.values()}values(){return this._map.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=h;function d(s){const t=new Set;for(const c of s)t.add(M.ExtensionIdentifier.toKey(c));return t}e.extensionIdentifiersArrayToSet=d;function o(s){const t=new Map;for(const c of s)t.set(M.ExtensionIdentifier.toKey(c.identifier),c);return t}function g(s,t){return s.enabledApiProposals?s.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=g;function E(s,t){if(!g(s,t))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}e.checkProposedApiEnabled=E;class l{constructor(t,c,_,v){this.codeLoadingTime=t,this.activateCallTime=c,this.activateResolvedTime=_,this.activationReason=v}}e.ActivationTimes=l;class D{constructor(t,c){this.description=t,this.value=c}}e.ExtensionPointContribution=D,e.ExtensionHostLogFileName="exthost";var i;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function u(s){return{type:s.isBuiltin?0:1,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}e.toExtension=u;function n(s,t){return{identifier:new M.ExtensionIdentifier((0,y.getExtensionId)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===0,isUserBuiltin:s.type===1&&s.isBuiltin,isUnderDevelopment:!!t,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,browserNlsBundleUris:s.browserNlsBundleUris}}e.toExtensionDescription=n;class r{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,c){return Promise.resolve(0)}getInspectPorts(t,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,c){return Promise.resolve()}}e.NullExtensionService=r}),define(Ce[180],Ie([1,0,11,26,27,15,14]),function(ie,e,a,p,w,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class A{constructor(d,o,g,E){this.startup=d,this.codeLoadingTime=o,this.activateCallTime=g,this.activateResolvedTime=E}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class b{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,o){return d===-1||o===-1?-1:o-d}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=b;class P{constructor(d,o,g,E,l,D){this.activationFailed=d,this.activationFailedError=o,this.activationTimes=g,this.module=E,this.exports=l,this.subscriptions=D}}e.ActivatedExtension=P;class R extends P{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class S extends P{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=S;class m extends P{constructor(d){super(!0,d,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=m;let k=class{constructor(d,o,g,E,l){this._logService=l,this._registry=d,this._resolvedExtensionsSet=new Set,o.forEach(D=>this._resolvedExtensionsSet.add(p.ExtensionIdentifier.toKey(D))),this._externalExtensionsMap=new Map,g.forEach(D=>this._externalExtensionsMap.set(p.ExtensionIdentifier.toKey(D),D)),this._host=E,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[d,o]of this._operations)o.dispose()}isActivated(d){const o=this._operations.get(p.ExtensionIdentifier.toKey(d));return Boolean(o&&o.value)}getActivatedExtension(d){const o=this._operations.get(p.ExtensionIdentifier.toKey(d));if(!o||!o.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return o.value}async activateByEvent(d,o){if(this._alreadyActivatedEvents[d])return;const g=this._registry.getExtensionDescriptionsForActivationEvent(d);await this._activateExtensions(g.map(E=>({id:E.identifier,reason:{startup:o,extensionId:E.identifier,activationEvent:d}}))),this._alreadyActivatedEvents[d]=!0}activateById(d,o){const g=this._registry.getExtensionDescription(d);if(!g)throw new Error(`Extension '${d}' is not known`);return this._activateExtensions([{id:g.identifier,reason:o}])}async _activateExtensions(d){const o=d.filter(g=>!this.isActivated(g.id)).map(g=>this._handleActivationRequest(g));await Promise.all(o.map(g=>g.wait()))}_handleActivationRequest(d){if(this._operations.has(p.ExtensionIdentifier.toKey(d.id)))return this._operations.get(p.ExtensionIdentifier.toKey(d.id));if(this._externalExtensionsMap.has(p.ExtensionIdentifier.toKey(d.id)))return this._createAndSaveOperation(d,null,[],null);const o=this._registry.getExtensionDescription(d.id);if(!o){const l=new Error(`Cannot activate unknown extension '${d.id.value}'`),D=this._createAndSaveOperation(d,null,[],new m(l));return this._host.onExtensionActivationError(d.id,l,new w.MissingExtensionDependency(d.id.value)),D}const g=[],E=typeof o.extensionDependencies>"u"?[]:o.extensionDependencies;for(const l of E){if(this._resolvedExtensionsSet.has(p.ExtensionIdentifier.toKey(l)))continue;const D=this._operations.get(p.ExtensionIdentifier.toKey(l));if(D){g.push(D);continue}if(this._externalExtensionsMap.has(p.ExtensionIdentifier.toKey(l))){g.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(p.ExtensionIdentifier.toKey(l)),reason:d.reason}));continue}const i=this._registry.getExtensionDescription(l);if(i){if(!i.main&&!i.browser)continue;g.push(this._handleActivationRequest({id:i.identifier,reason:d.reason}));continue}const u=o.displayName||o.identifier.value,n=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${l}'`),r=this._createAndSaveOperation(d,o.displayName,[],new m(n));return this._host.onExtensionActivationError(o.identifier,n,new w.MissingExtensionDependency(l)),r}return this._createAndSaveOperation(d,o.displayName,g,null)}_createAndSaveOperation(d,o,g,E){const l=new f(d.id,o,d.reason,g,E,this._host,this._logService);return this._operations.set(p.ExtensionIdentifier.toKey(d.id),l),l}};k=ze([$e(4,M.ILogService)],k),e.ExtensionsActivator=k;let f=class{constructor(d,o,g,E,l,D,i){this._id=d,this._displayName=o,this._reason=g,this._deps=E,this._value=l,this._host=D,this._logService=i,this._barrier=new y.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let d=0;d<this._deps.length;d++){const o=this._deps[d];if(o.value&&!o.value.activationFailed){this._deps.splice(d,1),d--;continue}if(o.value&&o.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${o.friendlyName}' failed to activate`);g.detail=o.value.activationFailedError,this._value=new m(g),this._host.onExtensionActivationError(this._id,g,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(d=>d.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(d){const o=new Error;if(d&&d.name&&(o.name=d.name),d&&d.message?o.message=`Activating extension '${this._id.value}' failed: ${d.message}.`:o.message=`Activating extension '${this._id.value}' failed: ${d}.`,d&&d.stack&&(o.stack=d.stack),this._value=new m(o),this._isDisposed&&a.isCancellationError(d))return;this._host.onExtensionActivationError(this._id,o,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(d)}}};f=ze([$e(6,M.ILogService)],f)}),define(Ce[181],Ie([1,0,15,28,27]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends a.LogService{constructor(A,b){super(A.createLogger(b.logFile,{name:w.ExtensionHostLogFileName}))}};M=ze([$e(0,a.ILoggerService),$e(1,p.IExtHostInitDataService)],M),e.ExtHostLogService=M}),define(Ce[182],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewSize.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",contribWebviewContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribWebviewContext.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",snippetWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.snippetWorkspaceEdit.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLog.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[183],Ie([1,0,143,11,29,79,82,30,26,182,150]),function(ie,e,a,p,w,M,y,A,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const S=A.Registry.as(y.Extensions.JSONContribution);class m{constructor(l,D,i){this._messageHandler=l,this._extension=D,this._extensionPointId=i}_msg(l,D){this._messageHandler({type:l,message:D,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(l){this._msg(w.default.Error,l)}warn(l){this._msg(w.default.Warning,l)}info(l){this._msg(w.default.Info,l)}}e.ExtensionMessageCollector=m;class k{constructor(l,D){this.added=l,this.removed=D}static _toSet(l){const D=new Set;for(let i=0,u=l.length;i<u;i++)D.add(b.ExtensionIdentifier.toKey(l[i].description.identifier));return D}static compute(l,D){if(!l||!l.length)return new k(D,[]);if(!D||!D.length)return new k([],l);const i=this._toSet(l),u=this._toSet(D),n=D.filter(s=>!i.has(b.ExtensionIdentifier.toKey(s.description.identifier))),r=l.filter(s=>!u.has(b.ExtensionIdentifier.toKey(s.description.identifier)));return new k(n,r)}}e.ExtensionPointUserDelta=k;class f{constructor(l,D){this.name=l,this.defaultExtensionKind=D,this._handler=null,this._users=null,this._delta=null}setHandler(l){if(this._handler!==null)throw new Error("Handler already set!");this._handler=l,this._handle()}acceptUsers(l){this._delta=k.compute(this._users,l),this._users=l,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(l){(0,p.onUnexpectedError)(l)}}}e.ExtensionPoint=f;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:b.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}},activationEvents:{description:a.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:a.localize(31,null)},{label:"onUri",body:"onUri",description:a.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(36,null)},{label:"onRenderer",description:a.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(39,null)},{label:"*",description:a.localize(40,null),body:"*"}]}},badges:{type:"array",description:a.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(42,null)},href:{type:"string",description:a.localize(43,null)},description:{type:"string",description:a.localize(44,null)}}}},markdown:{type:"string",description:a.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(49,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(50,null)},{body:["workspace"],description:a.localize(51,null)},{body:["ui","workspace"],description:a.localize(52,null)},{body:["workspace","ui"],description:a.localize(53,null)},{body:[],description:a.localize(54,null)}]},capabilities:{description:a.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(58,null),a.localize(59,null),a.localize(60,null)]},description:{type:"string",markdownDescription:a.localize(61,null)}}},untrustedWorkspaces:{description:a.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(64,null),a.localize(65,null),a.localize(66,null)]},restrictedConfigurations:{description:a.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(68,null)}}}}},sponsor:{description:a.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(71,null),type:"string"},"vscode:uninstall":{description:a.localize(72,null),type:"string"}}},icon:{type:"string",description:a.localize(73,null)}}};class o{constructor(){this._extensionPoints=new Map}registerExtensionPoint(l){if(this._extensionPoints.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const D=new f(l.extensionPoint,l.defaultExtensionKind);return this._extensionPoints.set(l.extensionPoint,D),e.schema.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,S.registerSchema(d,e.schema),D}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=o;const g={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(g.ExtensionsRegistry,new o),e.ExtensionsRegistry=A.Registry.as(g.ExtensionsRegistry),S.registerSchema(d,e.schema),S.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(74,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}}]}}}})}),define(Ce[184],Ie([1,0,140,10,25,183,38,5]),function(ie,e,a,p,w,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const b={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var P;(function(m){function k(f,h,d){if(!f)return;const o=p.isString(f.type)?f.type:void 0;if(!o||o.length===0){d.error(a.localize(3,null));return}const g=[];if(Array.isArray(f.required))for(const E of f.required)p.isString(E)&&g.push(E);return{extensionId:h.value,taskType:o,required:g,properties:f.properties?w.deepClone(f.properties):{},when:f.when?y.ContextKeyExpr.deserialize(f.when):void 0}}m.from=k})(P||(P={}));const R=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:a.localize(4,null),type:"array",items:b}});class S{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((k,f)=>{R.setHandler((h,d)=>{this._schema=void 0;try{for(const o of d.removed){const g=o.value;for(const E of g)this.taskTypes&&E.type&&this.taskTypes[E.type]&&delete this.taskTypes[E.type]}for(const o of d.added){const g=o.value;for(const E of g){const l=P.from(E,o.description.identifier,o.collector);l&&(this.taskTypes[l.taskType]=l)}}(d.removed.length>0||d.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}k(void 0)})})}onReady(){return this.readyPromise}get(k){return this.taskTypes[k]}all(){return Object.keys(this.taskTypes).map(k=>this.taskTypes[k])}getJsonSchema(){if(this._schema===void 0){const k=[];for(const f of this.all()){const h={type:"object",additionalProperties:!1};f.required.length>0&&(h.required=f.required.slice(0)),f.properties!==void 0?h.properties=w.deepClone(f.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[f.taskType]},k.push(h)}this._schema={oneOf:k}}return this._schema}}e.TaskDefinitionRegistryImpl=S,e.TaskDefinitionRegistry=new S}),define(Ce[185],Ie([1,0,141,10,22,25,38,184]),function(ie,e,a,p,w,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new y.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var b;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(b=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(F){function K(H){if(!H)return F.Strong;switch(H.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=K}(b=e.ShellQuoting||(e.ShellQuoting={}));var P;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(P=e.CommandOptions||(e.CommandOptions={}));var R;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(F){function K(H){switch(H.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=K}(R=e.RevealKind||(e.RevealKind={}));var S;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(S=e.RevealProblemKind||(e.RevealProblemKind={})),function(F){function K(H){switch(H.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=K}(S=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(F){function K(H){switch(H.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=K}(m=e.PanelKind||(e.PanelKind={}));var k;(function(F){F.defaults={echo:!0,reveal:R.Always,revealProblems:S.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(k=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(F){function K(O){switch(O.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=K;function H(O){switch(O){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=H}(f=e.RuntimeType||(e.RuntimeType={}));var h;(function(F){function K(H){return p.isString(H)?H:H.value}F.value=K})(h=e.CommandString||(e.CommandString={}));var d;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function K(O){return O===F.Clean._id||O===F.Build._id||O===F.Rebuild._id||O===F.Test._id}F.is=K;function H(O){if(O!==void 0)return p.isString(O)?K(O)?{_id:O,isDefault:!1}:void 0:O}F.from=H})(d=e.TaskGroup||(e.TaskGroup={}));var o;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(o=e.TaskScope||(e.TaskScope={}));var g;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function K(H){switch(H){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=K})(g=e.TaskSourceKind||(e.TaskSourceKind={}));var E;(function(F){F.parallel="parallel",F.sequence="sequence"})(E=e.DependsOrder||(e.DependsOrder={}));var l;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(l=e.RunOnOptions||(e.RunOnOptions={}));var D;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:l.default,instanceLimit:1}})(D=e.RunOptions||(e.RunOptions={}));class i{constructor(K,H,O,ee,ue,oe){this._label="",this._id=K,H&&(this._label=H),O&&(this.type=O),this.runOptions=ee,this.configurationProperties=ue,this._source=oe}getDefinition(K){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const K={folder:this.getFolderId(),id:this._id};return JSON.stringify(K)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(K,H=!1){if(K===void 0)return!1;if(p.isString(K))return K===this._label||K===this.configurationProperties.identifier||H&&K===this._id;const O=this.getDefinition(!0);return O!==void 0&&O._key===K._key}getQualifiedLabel(){const K=this.getWorkspaceFolder();return K?`${this._label} (${K.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(K){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),K&&(this._taskLoadMessages=this._taskLoadMessages.concat(K))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=i;class u extends i{constructor(K,H,O,ee,ue,oe,le,te){super(K,O,void 0,le,te,H),this.command={},this._source=H,this.hasDefinedMatchers=oe,ue&&(this.command=ue)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(K=!1){if(K&&this._source.customizes!==void 0)return this._source.customizes;{let H;switch(this.command?this.command.runtime:void 0){case f.Shell:H="shell";break;case f.Process:H="process";break;case f.CustomExecution:H="customExecution";break;case void 0:H="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:H,_key:this._id,id:this._id}}}static is(K){return K instanceof u}getMapKey(){const K=this._source.config.workspaceFolder;return K?`${K.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let H=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(H+=this._source.kind);const O={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:H};return JSON.stringify(O)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?w.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(K){return new u(K._id,K._source,K._label,K.type,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.CustomTask=u;class n extends i{constructor(K,H,O,ee,ue,oe,le){super(K,O,ee,oe,le,H),this._source=H,this.configures=ue}static is(K){return K instanceof n}fromObject(K){return K}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?w.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===g.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let H=this.configurationProperties.identifier;this._source.kind!==g.Workspace&&(H+=this._source.kind);const O={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:H};return JSON.stringify(O)}}e.ConfiguringTask=n;class r extends i{constructor(K,H,O,ee,ue,oe,le,te,Ee){super(K,O,ee,te,Ee,H),this.defines=ue,this.hasDefinedMatchers=le,this.command=oe,this.icon=Ee.icon,this.hide=Ee.hide}clone(){return new r(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(K){return K instanceof r}getMapKey(){const K=this._source.workspaceFolder;return K?`${this._source.scope.toString()}|${K.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const K={type:"contributed",scope:this._source.scope,id:this._id};return K.folder=this.getFolderId(),JSON.stringify(K)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(K){return new r(K._id,K._source,K._label,K.type,K.defines,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.ContributedTask=r;class s extends i{constructor(K,H,O,ee,ue,oe){super(K,O,ee,ue,oe,H),this._source=H}clone(){return new s(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(K){return K instanceof s}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(K){return new s(K._id,K._source,K._label,K.type,K.runOptions,K.configurationProperties)}}e.InMemoryTask=s;var t;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(t=e.ExecutionEngine||(e.ExecutionEngine={})),function(F){F._default=F.Terminal}(t=e.ExecutionEngine||(e.ExecutionEngine={}));var c;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(c=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class _{constructor(K){this._order=new Map;for(let H=0;H<K.length;H++)this._order.set(K[H].uri.toString(),H)}compare(K,H){const O=K.getWorkspaceFolder(),ee=H.getWorkspaceFolder();if(O&&ee){let ue=this._order.get(O.uri.toString());ue=ue===void 0?0:ue+1;let oe=this._order.get(ee.uri.toString());return oe=oe===void 0?0:oe+1,ue===oe?K._label.localeCompare(H._label):ue-oe}else return!O&&ee?-1:O&&!ee?1:0}}e.TaskSorter=_;var v;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(v=e.TaskEventKind||(e.TaskEventKind={}));var T;(function(F){F.SingleRun="singleRun",F.Background="background"})(T=e.TaskRunType||(e.TaskRunType={}));var U;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(U=e.TaskRunSource||(e.TaskRunSource={}));var V;(function(F){function K(H,O,ee,ue,oe){if(O){const le={kind:H,taskId:O._id,taskName:O.configurationProperties.name,runType:O.configurationProperties.isBackground?"background":"singleRun",group:O.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:O};return H==="start"?(le.terminalId=ee,le.resolvedVariables=ue):H==="processStarted"?le.processId=ee:H==="processEnded"&&(le.exitCode=ee),Object.freeze(le)}else return Object.freeze({kind:"changed"})}F.create=K})(V=e.TaskEvent||(e.TaskEvent={}));var x;(function(F){function K(O){const ee=Object.keys(O).sort();let ue="";for(const oe of ee){let le=O[oe];le instanceof Object?le=K(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),ue+=oe+","+le+","}return ue}function H(O){const ue={_key:K(O),type:O.taskType};return Object.assign(ue,O),ue}F.create=H})(x=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var C;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(C=e.TaskSettingId||(e.TaskSettingId={}));var L;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(L=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var B;(function(F){function K(H,O){const ee=A.TaskDefinitionRegistry.get(H.type);if(ee===void 0){const te=M.deepClone(H);return delete te._key,x.create(te)}const ue=Object.create(null);ue.type=ee.taskType;const oe=new Set;ee.required.forEach(te=>oe.add(te));const le=ee.properties;for(const te of Object.keys(le)){const Ee=H[te];if(Ee!=null)ue[te]=Ee;else if(oe.has(te)){const be=le[te];if(be.default!==void 0)ue[te]=M.deepClone(be.default);else switch(be.type){case"boolean":ue[te]=!1;break;case"number":case"integer":ue[te]=0;break;case"string":ue[te]="";break;default:O.error(a.localize(2,null,JSON.stringify(H,void 0,0),te));return}}}return x.create(ue)}F.createTaskIdentifier=K})(B=e.TaskDefinition||(e.TaskDefinition={}))}),define(Ce[186],Ie([1,0,11]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class p{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((y,A)=>{this._actualOk=y,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(y){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=y,this._actual&&this._actualOk(y))}resolveErr(y){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=y,this._actual?this._actualErr(y):(0,a.onUnexpectedError)(y))}then(y,A){return this._ensureActual().then(y,A)}catch(y){return this._ensureActual().then(void 0,y)}finally(y){return this._ensureActual().finally(y)}}e.LazyPromise=p;class w extends p{constructor(){super(),this._hasErr=!0,this._err=new a.CancellationError}}e.CanceledLazyPromise=w}),define(Ce[40],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++a.count}}e.ProxyIdentifier=a,a.count=0;const p=[];function w(A){const b=new a(A);return p[b.nid]=b,b}e.createProxyIdentifier=w;function M(A){return p[A].sid}e.getStringIdentifierForProxy=M;class y{constructor(b){this.value=b}}e.SerializableObjectWithBuffers=y}),define(Ce[4],Ie([1,0,56,40]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var w;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(w=e.TextEditorRevealType||(e.TextEditorRevealType={}));var M;(function(o){o[o.UnknownInput=0]="UnknownInput",o[o.TextInput=1]="TextInput",o[o.TextDiffInput=2]="TextDiffInput",o[o.TextMergeInput=3]="TextMergeInput",o[o.NotebookInput=4]="NotebookInput",o[o.NotebookDiffInput=5]="NotebookDiffInput",o[o.CustomEditorInput=6]="CustomEditorInput",o[o.WebviewEditorInput=7]="WebviewEditorInput",o[o.TerminalEditorInput=8]="TerminalEditorInput",o[o.InteractiveEditorInput=9]="InteractiveEditorInput"})(M=e.TabInputKind||(e.TabInputKind={}));var y;(function(o){o[o.TAB_OPEN=0]="TAB_OPEN",o[o.TAB_CLOSE=1]="TAB_CLOSE",o[o.TAB_UPDATE=2]="TAB_UPDATE",o[o.TAB_MOVE=3]="TAB_MOVE"})(y=e.TabModelOperationKind||(e.TabModelOperationKind={}));var A;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(A=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var b;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(b=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var S;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(S=e.CandidatePortSource||(e.CandidatePortSource={}));class m{static mixin(g){return g._id=m._n++,g}}e.IdObject=m,m._n=0;var k;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n"})(k=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var f;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(f=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));function h(o){return o&&o.edits&&(0,a.revive)(o),o}e.reviveWorkspaceEditDto=h;var d;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(d=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,p.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,p.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,p.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,p.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,p.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,p.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,p.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,p.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,p.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,p.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,p.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,p.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,p.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,p.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,p.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,p.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,p.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,p.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,p.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,p.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,p.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,p.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,p.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,p.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,p.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,p.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,p.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,p.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,p.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,p.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,p.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,p.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,p.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,p.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,p.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,p.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,p.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,p.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,p.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,p.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,p.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,p.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,p.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,p.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,p.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,p.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,p.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,p.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,p.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,p.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,p.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,p.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,p.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,p.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,p.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,p.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,p.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,p.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,p.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,p.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,p.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,p.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,p.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,p.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,p.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,p.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,p.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,p.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,p.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,p.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,p.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,p.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,p.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,p.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,p.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,p.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,p.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,p.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,p.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,p.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,p.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,p.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,p.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,p.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,p.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,p.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,p.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,p.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,p.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,p.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,p.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,p.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,p.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,p.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,p.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,p.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,p.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,p.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,p.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,p.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,p.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,p.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,p.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,p.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,p.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,p.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,p.createProxyIdentifier)("ExtHostTelemetry")}}),define(Ce[67],Ie([1,0,3,15,4,13]),function(ie,e,a,p,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(b,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=b.getProxy(w.MainContext.MainThreadTelemetry)}report(b,P,R){const S=this.getUsageKey(b,P);this._reportedUsages.has(S)||(this._reportedUsages.add(S),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${b}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:b}))}getUsageKey(b,P){return`${b}-${P.identifier.value}`}};y=ze([$e(0,M.IExtHostRpcService),$e(1,p.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(A,b,P){}})}),define(Ce[187],Ie([1,0,5,4,6,26]),function(ie,e,a,p,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(b){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new a.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=b.getProxy(p.MainContext.MainThreadAuthentication)}$setProviders(b){return this._providers=b,Promise.resolve()}async getSession(b,P,R,S={}){const m=M.ExtensionIdentifier.toKey(b.identifier),k=this._inFlightRequests.get(m)||[],f=[...R].sort().join(" ");let h=k.find(d=>d.providerId===P&&d.scopes===f);if(h)return h.result;{const d=this._getSession(b,m,P,R,S);h={providerId:P,scopes:f,result:d},k.push(h),this._inFlightRequests.set(m,k);try{await d}finally{const o=k.findIndex(g=>g.providerId===P&&g.scopes===f);o>-1&&(k.splice(o),this._inFlightRequests.set(m,k))}return d}}async _getSession(b,P,R,S,m={}){await this._proxy.$ensureProvider(R);const k=b.displayName||b.name;return this._proxy.$getSession(R,S,P,k,m)}async removeSession(b,P){const R=this._authenticationProviders.get(b);return R?R.provider.removeSession(P):this._proxy.$removeSession(b,P)}registerAuthenticationProvider(b,P,R,S){if(this._authenticationProviders.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this._authenticationProviders.set(b,{label:P,provider:R,options:S??{supportsMultipleAccounts:!1}}),this._providers.find(k=>k.id===b)||this._providers.push({id:b,label:P});const m=R.onDidChangeSessions(k=>{this._proxy.$sendDidChangeSessions(b,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this._proxy.$registerAuthenticationProvider(b,P,S?.supportsMultipleAccounts??!1),new w.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(b);const k=this._providers.findIndex(f=>f.id===b);k>-1&&this._providers.splice(k),this._proxy.$unregisterAuthenticationProvider(b)})}$createSession(b,P){const R=this._authenticationProviders.get(b);if(R)return Promise.resolve(R.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,P){const R=this._authenticationProviders.get(b);if(R)return Promise.resolve(R.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,P){const R=this._authenticationProviders.get(b);if(R)return Promise.resolve(R.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,P){return this._onDidChangeSessions.fire({provider:{id:b,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(Ce[188],Ie([1,0,4,13,8,27]),function(ie,e,a,p,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let y=class{constructor(b,P){this._proxy=b.getProxy(a.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>P.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,P){const R=(0,M.isProposedApiEnabled)(P,"snippetWorkspaceEdit"),S=w.WorkspaceEdit.from(b,this._versionInformationProvider,R);return this._proxy.$tryApplyWorkspaceEdit(S)}};y=ze([$e(0,p.IExtHostRpcService)],y),e.ExtHostBulkEdits=y}),define(Ce[189],Ie([1,0,4]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class p{constructor(M){const y=M.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(A){return y.$writeText(A)}})}}e.ExtHostClipboard=p});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,p,w){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?w.call(ie,a):w?w.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!p:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ie):p?p.value:e.get(ie)};define(Ce[36],Ie([1,0,10,6,8,25,4,16,15,56,49,242,2,7,3,13,93,23,40,43]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f,h,d,o,g,E){"use strict";var l,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let i=class{constructor(c,_){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,D.set(this,void 0),Je(this,l,c.getProxy(y.MainContext.MainThreadCommands),"f"),this._logService=_,Je(this,D,c.getProxy(y.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,v=>{const T=this._apiCommands.get(v);return T?.result===r.Void?T:void 0},_),this._argumentProcessors=[{processArgument(v){return(0,P.revive)(v)}},{processArgument(v){return(0,M.cloneAndChange)(v,function(T){if(R.Range.isIRange(T))return w.Range.to(T);if(S.Position.isIPosition(T))return w.Position.to(T);if(R.Range.isIRange(T.range)&&m.URI.isUri(T.uri))return w.location.to(T);if(T instanceof o.VSBuffer)return T.buffer.buffer;if(!Array.isArray(T))return T})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const _=this.registerCommand(!1,c.id,async(...v)=>{const T=c.args.map((V,x)=>{if(!V.validate(v[x]))throw new Error(`Invalid argument '${V.name}' when running '${c.id}', received: ${v[x]}`);return V.convert(v[x])}),U=await this.executeCommand(c.internalId,...T);return c.result.convert(U,v,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new p.Disposable(()=>{_.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,_,v,T,U,V){if(this._logService.trace("ExtHostCommands#registerCommand",_),!_.trim().length)throw new Error("invalid id");if(this._commands.has(_))throw new Error(`command '${_}' already exists`);return this._commands.set(_,{callback:v,thisArg:T,description:U,extension:V}),c&&Oe(this,l,"f").$registerCommand(_),new p.Disposable(()=>{this._commands.delete(_)&&c&&Oe(this,l,"f").$unregisterCommand(_)})}executeCommand(c,..._){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,_,!0)}async _doExecuteCommand(c,_,v){if(this._commands.has(c))return Oe(this,l,"f").$fireCommandActivationEvent(c),this._executeContributedCommand(c,_,!1);{let T=!1;const U=(0,M.cloneAndChange)(_,function(V){if(V instanceof p.Position)return w.Position.from(V);if(V instanceof p.Range)return w.Range.from(V);if(V instanceof p.Location)return w.location.from(V);if(p.NotebookRange.isNotebookRange(V))return w.NotebookRange.from(V);if(V instanceof ArrayBuffer)return T=!0,o.VSBuffer.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return T=!0,o.VSBuffer.wrap(V);if(V instanceof o.VSBuffer)return T=!0,V;if(!Array.isArray(V))return V});try{const V=await Oe(this,l,"f").$executeCommand(c,T?new g.SerializableObjectWithBuffers(U):U,v);return(0,P.revive)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this._doExecuteCommand(c,_,!1);throw V}}}async _executeContributedCommand(c,_,v){const T=this._commands.get(c);if(!T)throw new Error("Unknown command");this._reportTelemetry(T,c);const{callback:U,thisArg:V,description:x}=T;if(x)for(let C=0;C<x.args.length;C++)try{(0,a.validateConstraint)(_[C],x.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${x.args[C].name}' - ${x.args[C].description}`)}try{return await U.apply(V,_)}catch(C){if(c===this.converter.delegatingCommandId){const L=this.converter.getActualCommand(..._);L&&(c=L.command)}throw this._logService.error(C,c,T.extension?.identifier),v?new class extends Error{constructor(){super((0,E.toErrorMessage)(C)),this.id=c,this.source=T.extension?.displayName??T.extension?.name}}:C}}_reportTelemetry(c,_){!c.extension||c.extension.isBuiltin||Oe(this,D,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:_})}$executeContributedCommand(c,..._){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(_=_.map(v=>this._argumentProcessors.reduce((T,U)=>U.processArgument(T),v)),this._executeContributedCommand(c,_,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),Oe(this,l,"f").$getCommands().then(_=>(c&&(_=_.filter(v=>v[0]!=="_")),_))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(const[_,v]of this._commands){const{description:T}=v;T&&(c[_]=T)}return Promise.resolve(c)}};l=new WeakMap,D=new WeakMap,i=ze([$e(0,h.IExtHostRpcService),$e(1,b.ILogService)],i),e.ExtHostCommands=i,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class u{constructor(c,_,v){this._commands=c,this._lookupApiCommand=_,this._logService=v,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,_){if(!c)return;const v={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return v;const T=this._lookupApiCommand(c.command);if(T)v.id=T.internalId,v.arguments=T.args.map((U,V)=>U.convert(c.arguments&&c.arguments[V]));else if((0,A.isNonEmptyArray)(c.arguments)){const U=++this._cachIdPool;this._cache.set(U,c),_.add((0,k.toDisposable)(()=>{this._cache.delete(U),this._logService.trace("CommandsConverter#DISPOSE",U)})),v.$ident=U,v.id=this.delegatingCommandId,v.arguments=[U],this._logService.trace("CommandsConverter#CREATE",c.command,U)}return v}fromInternal(c){return typeof c.$ident=="number"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const _=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],_?_.command:"MISSING"),_?this._commands.executeCommand(_.command,..._.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=u;class n{constructor(c,_,v,T){this.name=c,this.description=_,this.validate=v,this.convert=T}optional(){return new n(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,_){return new n(c??this.name,_??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",t=>m.URI.isUri(t),t=>t),n.Position=new n("position","A position in a text document",t=>p.Position.isPosition(t),w.Position.from),n.Range=new n("range","A range in a text document",t=>p.Range.isRange(t),w.Range.from),n.Selection=new n("selection","A selection in a text document",t=>p.Selection.isSelection(t),w.Selection.from),n.Number=new n("number","",t=>typeof t=="number",t=>t),n.String=new n("string","",t=>typeof t=="string",t=>t),n.CallHierarchyItem=new n("item","A call hierarchy item",t=>t instanceof p.CallHierarchyItem,w.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",t=>t instanceof p.TypeHierarchyItem,w.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",t=>t instanceof d.TestItemImpl,w.TestItem.from);class r{constructor(c,_){this.description=c,this.convert=_}}e.ApiCommandResult=r,r.Void=new r("no result",t=>t);class s{constructor(c,_,v,T,U){this.id=c,this.internalId=_,this.description=v,this.args=T,this.result=U}}e.ApiCommand=s}),define(Ce[190],Ie([1,0,2,8,6,66,36,16,77,81,12]),function(ie,e,a,p,w,M,y,A,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const S=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",k(p.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,d)=>{if((0,A.isFalsyOrEmpty)(h))return;class o extends w.SymbolInformation{static to(E){const l=new o(E.name,p.SymbolKind.to(E.kind),E.containerName||"",new w.Location(d[0],p.Range.to(E.range)));return l.detail=E.detail,l.range=l.location.range,l.selectionRange=p.Range.to(E.selectionRange),l.children=E.children?E.children.map(o.to):[],l}}return h.map(o.to)})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(p.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(p.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",h=>typeof h=="string",h=>h),new y.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(p.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",k(p.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",k(p.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",h=>Array.isArray(h)&&h.every(d=>w.Position.isPosition(d)),h=>h.map(p.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",h=>h.map(d=>{let o;for(const g of d.reverse())o=new w.SelectionRange(p.Range.to(g),o);return o}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(p.WorkspaceSymbol.to))),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(p.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(p.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(p.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to a range and placeholder text.",h=>{if(!!h)return{range:p.Range.to(h.range),placeholder:h.text}})),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",h=>{if(!!h){if(h.rejectReason)throw new Error(h.rejectReason);return p.WorkspaceEdit.to(h)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(p.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new w.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const d=(0,b.decodeSemanticTokensDto)(h);if(d.type==="full")return new w.SemanticTokens(d.data,void 0)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range.optional()],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new w.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const d=(0,b.decodeSemanticTokensDto)(h);if(d.type==="full")return new w.SemanticTokens(d.data,void 0)})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(h,d,o)=>{if(!h)return new w.CompletionList([]);const g=h.suggestions.map(E=>p.CompletionItem.to(E,o));return new w.CompletionList(g,h.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",h=>{if(h)return p.SignatureHelp.to(h)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(h,d,o)=>k(g=>new w.CodeLens(p.Range.to(g.range),g.command&&o.fromInternal(g.command)))(h))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>w.Range.isRange(h),h=>w.Selection.isSelection(h)?p.Selection.from(h):p.Range.from(h)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(h,d,o)=>k(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(g.command)}else{const E=new w.CodeAction(g.title,g.kind?new w.CodeActionKind(g.kind):void 0);return g.edit&&(E.edit=p.WorkspaceEdit.to(g.edit)),g.command&&(E.command=o.fromInternal(g.command)),E.isPreferred=g.isPreferred,E}})(h))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(d=>new w.ColorInformation(p.Range.to(d.range),p.Color.to(d.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",h=>h instanceof w.Color,p.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:p.Range.from(h.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(p.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",(h,d,o)=>h.map(p.InlayHint.to.bind(void 0,o)))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",k(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(d=>p.NotebookExclusiveDocumentPattern.to(d))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",h=>h.map(p.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new y.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",h=>a.URI.isUri(h)||typeof h=="string"&&(0,P.matchesSomeScheme)(h,R.Schemas.http,R.Schemas.https),h=>h),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[p.ViewColumn.from(h),void 0]:[p.ViewColumn.from(h.viewColumn),p.TextEditorOpenOptions.from(h)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[p.ViewColumn.from(h),void 0]:[p.ViewColumn.from(h.viewColumn),p.TextEditorOpenOptions.from(h)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[p.ViewColumn.from(h.viewColumn),p.TextEditorOpenOptions.from(h)]).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(p.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(p.TypeHierarchyItem.to))),new y.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[y.ApiCommandArgument.TypeHierarchyItem],new y.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(p.TypeHierarchyItem.to))),new y.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[y.ApiCommandArgument.TestItem],y.ApiCommandResult.Void),new y.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[y.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],y.ApiCommandResult.Void)];class m{static register(d){S.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=m;function k(h){return d=>{if(Array.isArray(d))return d.map(h)}}function f(h){if(!Array.isArray(h))return;const d=[];for(const o of h)M.isLocationLink(o)?d.push(p.DefinitionLink.to(o)):d.push(p.location.to(o));return d}}),define(Ce[191],Ie([1,0,14,55,5,7,2,66,26,8,6,27,4]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function k(f,h,d){const o=f.getProxy(m.MainContext.MainThreadComments);class g{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const c=this._commentControllers.get(t.handle);return c?c.value:t}else if(t&&t.$mid===7){const c=this._commentControllers.get(t.commentControlHandle);if(!c)return t;const _=c.getCommentThread(t.commentThreadHandle);return _?_.value:t}else if(t&&t.$mid===8){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const _=c.getCommentThread(t.thread.commentThreadHandle);return _?{thread:_.value,text:t.text}:t}else if(t&&t.$mid===9){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const _=c.getCommentThread(t.thread.commentThreadHandle);if(!_)return t;const v=t.commentUniqueId,T=_.getCommentByUniqueId(v);return T||t}else if(t&&t.$mid===10){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const _=c.getCommentThread(t.thread.commentThreadHandle);if(!_)return t;const v=t.text,T=t.commentUniqueId,U=_.getCommentByUniqueId(T);return U?(typeof U.body=="string"?U.body=v:U.body.value=v,U):t}return t}})}createCommentController(t,c,_){const v=g.handlePool++,T=new l(t,v,c,_);this._commentControllers.set(T.handle,T);const U=this._commentControllersByExtension.get(b.ExtensionIdentifier.toKey(t.identifier))||[];return U.push(T),this._commentControllersByExtension.set(b.ExtensionIdentifier.toKey(t.identifier),U),T.value}$createCommentThreadTemplate(t,c,_){const v=this._commentControllers.get(t);!v||v.$createCommentThreadTemplate(c,_)}async $updateCommentThreadTemplate(t,c,_){const v=this._commentControllers.get(t);!v||v.$updateCommentThreadTemplate(c,_)}$deleteCommentThread(t,c){this._commentControllers.get(t)?.$deleteCommentThread(c)}$provideCommentingRanges(t,c,_){const v=this._commentControllers.get(t);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const T=d.getDocument(y.URI.revive(c));return(0,a.asPromise)(()=>v.commentingRangeProvider.provideCommentingRanges(T,_)).then(U=>U?U.map(V=>P.Range.from(V)):void 0)}$toggleReaction(t,c,_,v,T){const U=this._commentControllers.get(t);return!U||!U.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const V=U.getCommentThread(c);if(V){const x=V.getCommentByUniqueId(v.uniqueIdInThread);if(U!==void 0&&x&&U.reactionHandler)return U.reactionHandler(x,u(T))}return Promise.resolve(void 0)})}dispose(){}}g.handlePool=0;class E{constructor(t,c,_,v,T,U,V,x){this._commentControllerHandle=c,this._id=_,this._uri=v,this._range=T,this._comments=U,this.extensionDescription=V,this._isTemplate=x,this.handle=E._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new w.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputDisposables.value=new M.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),o.$createCommentThread(c,this.handle,this._id,this._uri,P.Range.from(this._range),V.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=U,this._localDisposables.push({dispose:()=>{o.$deleteCommentThread(c,this.handle)}});const C=this;this.value={get uri(){return C.uri},get range(){return C.range},set range(L){C.range=L},get comments(){return C.comments},set comments(L){C.comments=L},get collapsibleState(){return C.collapsibleState},set collapsibleState(L){C.collapsibleState=L},get canReply(){return C.canReply},set canReply(L){C.canReply=L},get contextValue(){return C.contextValue},set contextValue(L){C.contextValue=L},get label(){return C.label},set label(L){C.label=L},get state(){return C.state},set state(L){C.state=L},dispose:()=>{C.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,S.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,S.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new M.DisposableStore);const t=_=>Object.prototype.hasOwnProperty.call(this.modifications,_),c={};t("range")&&(c.range=P.Range.from(this._range)),t("label")&&(c.label=this.label),t("contextValue")&&(c.contextValue=this.contextValue??null),t("comments")&&(c.comments=this._comments.map(_=>D(this,_,this._commentsMap))),t("collapsibleState")&&(c.collapseState=n(this._collapseState)),t("canReply")&&(c.canReply=this.canReply),t("state")&&(c.state=r(this._state)),t("isTemplate")&&(c.isTemplate=this._isTemplate),this.modifications={},o.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(t){for(const c of this._commentsMap){const _=c[0],v=c[1];if(t===v)return _}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}E._handlePool=0,ze([(0,p.debounce)(100)],E.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(t,c,_,v){this._extension=t,this._handle=c,this._id=_,this._label=v,this._threads=new Map,o.$registerCommentController(this.handle,_,v);const T=this;this.value=Object.freeze({id:T.id,label:T.label,get options(){return T.options},set options(U){T.options=U},get commentingRangeProvider(){return T.commentingRangeProvider},set commentingRangeProvider(U){T.commentingRangeProvider=U},get reactionHandler(){return T.reactionHandler},set reactionHandler(U){T.reactionHandler=U},createCommentThread(U,V,x){return T.createCommentThread(U,V,x).value},dispose:()=>{T.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,o.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,c,_,v){if(typeof t=="string"){const T=new E(this.id,this.handle,t,c,_,v,this._extension,!1);return this._threads.set(T.handle,T),T}else{const T=new E(this.id,this.handle,void 0,t,c,_,this._extension,!1);return this._threads.set(T.handle,T),T}}$createCommentThreadTemplate(t,c){const _=new E(this.id,this.handle,void 0,y.URI.revive(t),P.Range.to(c),[],this._extension,!0);return _.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(_.handle,_),_}$updateCommentThreadTemplate(t,c){const _=this._threads.get(t);_&&(_.range=P.Range.to(c))}$deleteCommentThread(t){this._threads.get(t)?.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function D(s,t,c){let _=c.get(t);_||(_=++s.commentHandle,c.set(t,_));const v=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:_,body:typeof t.body=="string"?t.body:P.MarkdownString.from(t.body),userName:t.author.name,userIconPath:v,label:t.label,commentReactions:t.reactions?t.reactions.map(T=>i(T)):void 0,timestamp:t.timestamp?.toJSON()}}function i(s){return{label:s.label,iconPath:s.iconPath?P.pathOrURIToURI(s.iconPath):void 0,count:s.count,hasReacted:s.authorHasReacted}}function u(s){return{label:s.label||"",count:s.count||0,iconPath:s.iconPath?y.URI.revive(s.iconPath):"",authorHasReacted:s.hasReacted||!1}}function n(s){if(s!==void 0)switch(s){case R.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function r(s){if(s!==void 0)switch(s){case R.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new g}e.createExtHostComments=k}),define(Ce[192],Ie([1,0,25,4,28,13]),function(ie,e,a,p,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let y=class{constructor(R,S){this._mainThreadConsole=R.getProxy(p.MainContext.MainThreadConsole),this._includeStack=S.consoleForward.includeStack,this._logNative=S.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,S){const m=this,k=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){m._handleConsoleCall(R,S,k,arguments)}})}_handleConsoleCall(R,S,m,k){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:S,arguments:b(k,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,m,k)}};y=ze([$e(0,M.IExtHostRpcService),$e(1,w.IExtHostInitDataService)],y),e.AbstractExtHostConsoleForwarder=y;const A=1e5;function b(P,R){const S=[];if(P.length)for(let m=0;m<P.length;m++){let k=P[m];if(typeof k>"u")k="undefined";else if(k instanceof Error){const f=k;f.stack?k=f.stack:k=f.toString()}S.push(k)}if(R){const m=new Error().stack;m&&S.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,a.safeStringify)(S);return m.length>A?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ce[96],Ie([1,0,2,4,6,3,13,15,16,9,19]),function(ie,e,a,p,w,M,y,A,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let S=class ki{constructor(k,f){this._logService=f,this._provider=new Map,this._proxy=k.getProxy(p.MainContext.MainThreadDecorations)}registerFileDecorationProvider(k,f){const h=ki._handlePool++;this._provider.set(h,{provider:k,extensionId:f}),this._proxy.$registerDecorationProvider(h,f.value);const d=k.onDidChangeFileDecorations&&k.onDidChangeFileDecorations(o=>{if(!o){this._proxy.$onDidChange(h,null);return}const g=(0,b.asArray)(o);if(g.length<=ki._maxEventSize){this._proxy.$onDidChange(h,g);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,g.length);const E=g.map(i=>({uri:i,rank:(0,P.count)(i.path,"/")})),l=(0,b.groupBy)(E,(i,u)=>i.rank-u.rank||(0,P.compare)(i.uri.path,u.uri.path)),D=[];e:for(const i of l){let u;for(const n of i){const r=(0,R.dirname)(n.uri.path);if(u!==r&&(u=r,D.push(n.uri)>=ki._maxEventSize))break e}}this._proxy.$onDidChange(h,D)});return new w.Disposable(()=>{d?.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(k,f,h){if(!this._provider.has(k))return Object.create(null);const d=Object.create(null),{provider:o,extensionId:g}=this._provider.get(k);return await Promise.all(f.map(async E=>{try{const{uri:l,id:D}=E,i=await Promise.resolve(o.provideFileDecoration(a.URI.revive(l),h));if(!i)return;try{w.FileDecoration.validate(i),d[D]=[i.propagate,i.tooltip,i.badge,i.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${g.value}': ${u}`)}}catch(l){this._logService.error(l)}})),d}};S._handlePool=0,S._maxEventSize=250,S=ze([$e(0,y.IExtHostRpcService),$e(1,A.ILogService)],S),e.ExtHostDecorations=S,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,p,w){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?w.call(ie,a):w?w.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!p:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ie):p?p.value:e.get(ie)};define(Ce[193],Ie([1,0,130,80,2,4,6,8,5,15,24,35]),function(ie,e,a,p,w,M,y,A,b,P,R,S){"use strict";var m,k,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class h{constructor(g,E,l,D,i,u){this._name=g,this._owner=E,this._maxDiagnosticsPerFile=l,m.set(this,void 0),k.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,Je(this,f,new R.ResourceMap(n=>D.getComparisonKey(n)),"f"),Je(this,m,i,"f"),Je(this,k,u,"f")}dispose(){this._isDisposed||(Oe(this,k,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,m,"f")?.$clear(this._owner),Oe(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(g,E){if(!g){this.clear();return}this._checkDisposed();let l=[];if(w.URI.isUri(g)){if(!E){this.delete(g);return}Oe(this,f,"f").set(g,E.slice()),l=[g]}else if(Array.isArray(g)){l=[];let i;g=[...g].sort(h._compareIndexedTuplesByUri);for(const u of g){const[n,r]=u;if((!i||n.toString()!==i.toString())&&(i&&Oe(this,f,"f").get(i).length===0&&Oe(this,f,"f").delete(i),i=n,l.push(n),Oe(this,f,"f").set(n,[])),r)Oe(this,f,"f").get(n)?.push(...r);else{const s=Oe(this,f,"f").get(n);s&&(s.length=0)}}}if(Oe(this,k,"f").fire(l),!Oe(this,m,"f"))return;const D=[];for(const i of l){let u=[];const n=Oe(this,f,"f").get(i);if(n)if(n.length>this._maxDiagnosticsPerFile){u=[];const r=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const t of n)if(t.severity===r[s]&&u.push(A.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;u.push({severity:p.MarkerSeverity.Info,message:(0,a.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=n.map(r=>A.Diagnostic.from(r));D.push([i,u])}Oe(this,m,"f").$changeMany(this._owner,D)}delete(g){this._checkDisposed(),Oe(this,k,"f").fire([g]),Oe(this,f,"f").delete(g),Oe(this,m,"f")?.$changeMany(this._owner,[[g,void 0]])}clear(){this._checkDisposed(),Oe(this,k,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,m,"f")?.$clear(this._owner)}forEach(g,E){this._checkDisposed();for(const[l,D]of this)g.call(E,l,D,this)}*[(m=new WeakMap,k=new WeakMap,f=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const g of Oe(this,f,"f").keys())yield[g,this.get(g)]}get(g){this._checkDisposed();const E=Oe(this,f,"f").get(g);return Array.isArray(E)?Object.freeze(E.slice(0)):[]}has(g){return this._checkDisposed(),Array.isArray(Oe(this,f,"f").get(g))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(g,E){return g[0].toString()<E[0].toString()?-1:g[0].toString()>E[0].toString()?1:0}}e.DiagnosticCollection=h;let d=class hi{constructor(g,E,l){this._logService=E,this._fileSystemInfoService=l,this._collections=new Map,this._onDidChangeDiagnostics=new b.DebounceEmitter({merge:D=>D.flat(),delay:50}),this.onDidChangeDiagnostics=b.Event.map(this._onDidChangeDiagnostics.event,hi._mapper),this._proxy=g.getProxy(M.MainContext.MainThreadDiagnostics)}static _mapper(g){const E=new R.ResourceMap;for(const l of g)E.set(l,l);return{uris:Object.freeze(Array.from(E.values()))}}createDiagnosticCollection(g,E){const{_collections:l,_proxy:D,_onDidChangeDiagnostics:i,_logService:u,_fileSystemInfoService:n}=this,r=new class{$changeMany(c,_){D.$changeMany(c,_),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,c,_.length===0?"CLEARING":_)}$clear(c){D.$clear(c),u.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,c)}dispose(){D.dispose()}};let s;if(!E)E="_generated_diagnostic_collection_name_#"+hi._idPool++,s=E;else if(!l.has(E))s=E;else{this._logService.warn(`DiagnosticCollection with name '${E}' does already exist.`);do s=E+hi._idPool++;while(l.has(s))}return new class extends h{constructor(){super(E,s,hi._maxDiagnosticsPerFile,n.extUri,r,i),l.set(s,this)}dispose(){super.dispose(),l.delete(s)}}}getDiagnostics(g){if(g)return this._getDiagnostics(g);{const E=new Map,l=[];for(const D of this._collections.values())D.forEach((i,u)=>{let n=E.get(i.toString());typeof n>"u"&&(n=l.length,E.set(i.toString(),n),l.push([i,[]])),l[n][1]=l[n][1].concat(...u)});return l}}_getDiagnostics(g){let E=[];for(const l of this._collections.values())l.has(g)&&(E=E.concat(l.get(g)));return E}$acceptMarkersChange(g){if(!this._mirrorCollection){const E="_generated_mirror",l=new h(E,E,hi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(E,l),this._mirrorCollection=l}for(const[E,l]of g)this._mirrorCollection.set(w.URI.revive(E),l.map(A.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=ze([$e(1,P.ILogService),$e(2,S.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(Ce[194],Ie([1,0,2,4]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class w{constructor(y){this._proxy=y.getProxy(p.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(A=>A?A.map(b=>a.URI.revive(b)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(A=>A?a.URI.revive(A):void 0)}}e.ExtHostDialogs=w}),define(Ce[195],Ie([1,0,11,2,6,4,12,20,9]),function(ie,e,a,p,w,M,y,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(S,m,k){this._documentsAndEditors=m,this._logService=k,this._documentContentProviders=new Map,this._proxy=S.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,m){if(Object.keys(y.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const k=P._handlePool++;this._documentContentProviders.set(k,m),this._proxy.$registerTextContentProvider(k,S);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(h=>{if(h.scheme!==S){this._logService.warn(`Provider for scheme '${S}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(k,h).then(d=>{if(!d&&typeof d!="string")return;const o=this._documentsAndEditors.getDocument(h);if(!o)return;const g=(0,b.splitLines)(d);if(!o.equalLines(g))return this._proxy.$onVirtualDocumentChange(h,d)},a.onUnexpectedError)})),new w.Disposable(()=>{this._documentContentProviders.delete(k)&&this._proxy.$unregisterTextContentProvider(k),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(S,m){const k=this._documentContentProviders.get(S);return k?Promise.resolve(k.provideTextDocumentContent(p.URI.revive(m),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(Ce[196],Ie([1,0,5,7,2,4,87,8,10,25,6]),function(ie,e,a,p,w,M,y,A,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class S{constructor(k,f){this._onDidAddDocument=new a.Emitter,this._onDidRemoveDocument=new a.Emitter,this._onDidChangeDocument=new a.Emitter,this._onDidSaveDocument=new a.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new p.DisposableStore,this._documentLoader=new Map,this._proxy=k.getProxy(M.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(h=>{for(const d of h)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(h=>{for(const d of h)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(k){if(!k)return;const f=this._documentsAndEditors.getDocument(k);if(f)return f}getDocument(k){const f=this.getDocumentData(k);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return f.document}ensureDocumentData(k){const f=this._documentsAndEditors.getDocument(k);if(f)return Promise.resolve(f);let h=this._documentLoader.get(k.toString());return h||(h=this._proxy.$tryOpenDocument(k).then(d=>{this._documentLoader.delete(k.toString());const o=w.URI.revive(d);return(0,b.assertIsDefined)(this._documentsAndEditors.getDocument(o))},d=>(this._documentLoader.delete(k.toString()),Promise.reject(d))),this._documentLoader.set(k.toString(),h)),h}createDocumentData(k){return this._proxy.$tryCreateDocument(k).then(f=>w.URI.revive(f))}$acceptModelLanguageChanged(k,f){const h=w.URI.revive(k),d=this._documentsAndEditors.getDocument(h);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(f),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(k){const f=w.URI.revive(k),h=this._documentsAndEditors.getDocument(f);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this._onDidSaveDocument.fire(h.document)}$acceptDirtyStateChanged(k,f){const h=w.URI.revive(k),d=this._documentsAndEditors.getDocument(h);if(!d)throw new Error("unknown document");d._acceptIsDirty(f),this._onDidChangeDocument.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,f,h){const d=w.URI.revive(k),o=this._documentsAndEditors.getDocument(d);if(!o)throw new Error("unknown document");o._acceptIsDirty(h),o.onEvents(f);let g;f.isUndoing?g=R.TextDocumentChangeReason.Undo:f.isRedoing&&(g=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:o.document,contentChanges:f.changes.map(E=>({range:A.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:g}))}setWordDefinitionFor(k,f){(0,y.setWordDefinitionFor)(k,f)}}e.ExtHostDocuments=S}),define(Ce[50],Ie([1,0,44,5,7,2,3,4,87,13,94,8,15,24,12,167,197]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class o{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let g=class{constructor(l,D){this._extHostRpc=l,this._logService=D,this._activeEditorId=null,this._editors=new Map,this._documents=new k.ResourceMap,this._onDidAddDocuments=new p.Emitter,this._onDidRemoveDocuments=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const D=[],i=[],u=[];if(l.removedDocuments)for(const n of l.removedDocuments){const r=M.URI.revive(n),s=this._documents.get(r);s?.unref()&&(this._documents.delete(r),D.push(s.value))}if(l.addedDocuments)for(const n of l.addedDocuments){const r=M.URI.revive(n.uri);let s=this._documents.get(r);if(s&&r.scheme!==f.Schemas.vscodeNotebookCell&&r.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${r} already exists!'`);s||(s=new o(new b.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),r,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(r,s),i.push(s.value)),s.ref()}if(l.removedEditors)for(const n of l.removedEditors){const r=this._editors.get(n);this._editors.delete(n),r&&u.push(r)}if(l.addedEditors)for(const n of l.addedEditors){const r=M.URI.revive(n.documentUri);a.ok(this._documents.has(r),`document '${r}' does not exist`),a.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const s=this._documents.get(r).value,t=new R.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new d.Lazy(()=>s.document),n.selections.map(S.Selection.to),n.options,n.visibleRanges.map(c=>S.Range.to(c)),typeof n.editorPosition=="number"?S.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,t)}l.newActiveEditor!==void 0&&(a.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,w.dispose)(D),(0,w.dispose)(u),l.removedDocuments&&this._onDidRemoveDocuments.fire(D),l.addedDocuments&&this._onDidAddDocuments.fire(i),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){return this._documents.get(l)?.value}allDocuments(){return h.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!this._activeEditorId)return;const D=this._editors.get(this._activeEditorId);return l?D:D?.value}allEditors(){return[...this._editors.values()]}};g=ze([$e(0,P.IExtHostRpcService),$e(1,m.ILogService)],g),e.ExtHostDocumentsAndEditors=g,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[51],Ie([1,0,8,4,2,5,3,6,13,10,72]),function(ie,e,a,p,w,M,y,A,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,y.createDecorator)("IExtHostEditorTabs");class S{constructor(d,o,g){this._activeTabIdGetter=g,this._parentGroup=o,this.acceptDtoUpdate(d)}get apiObject(){if(!this._apiObject){const d=this,o={get isActive(){return d._dto.id===d._activeTabIdGetter()},get label(){return d._dto.label},get input(){return d._input},get isDirty(){return d._dto.isDirty},get isPinned(){return d._dto.isPinned},get isPreview(){return d._dto.isPreview},get group(){return d._parentGroup.apiObject}};this._apiObject=Object.freeze(o)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(d){this._dto=d,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(w.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(w.URI.revive(this._dto.input.original),w.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(w.URI.revive(this._dto.input.base),w.URI.revive(this._dto.input.input1),w.URI.revive(this._dto.input.input2),w.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(w.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(w.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(w.URI.revive(this._dto.input.original),w.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(w.URI.revive(this._dto.input.uri),w.URI.revive(this._dto.input.inputBoxUri));default:return}}}class m{constructor(d,o){this._tabs=[],this._activeTabId="",this._dto=d,this._activeGroupIdGetter=o;for(const g of d.tabs)g.isActive&&(this._activeTabId=g.id),this._tabs.push(new S(g,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const d=this,o={get isActive(){return d._dto.groupId===d._activeGroupIdGetter()},get viewColumn(){return a.ViewColumn.to(d._dto.viewColumn)},get activeTab(){return d._tabs.find(g=>g.tabId===d._activeTabId)?.apiObject},get tabs(){return Object.freeze(d._tabs.map(g=>g.apiObject))}};this._apiObject=Object.freeze(o)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(d){this._dto=d}acceptTabOperation(d){if(d.kind===0){const g=new S(d.tabDto,this,()=>this.activeTabId());return this._tabs.splice(d.index,0,g),d.tabDto.isActive&&(this._activeTabId=g.tabId),g}else if(d.kind===1){const g=this._tabs.splice(d.index,1)[0];if(!g)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return g.tabId===this._activeTabId&&(this._activeTabId=""),g}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const g=this._tabs.splice(d.oldIndex,1)[0];if(!g)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this._tabs.splice(d.index,0,g),g}const o=this._tabs.find(g=>g.tabId===d.tabDto.id);if(!o)throw new Error("INVALID tab");return d.tabDto.isActive?this._activeTabId=d.tabDto.id:this._activeTabId===d.tabDto.id&&!d.tabDto.isActive&&(this._activeTabId=""),o.acceptDtoUpdate(d.tabDto),o}activeTabId(){return this._activeTabId}}let k=class{constructor(d){this._onDidChangeTabs=new M.Emitter,this._onDidChangeTabGroups=new M.Emitter,this._extHostTabGroups=[],this._proxy=d.getProxy(p.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const d=this,o={onDidChangeTabGroups:d._onDidChangeTabGroups.event,onDidChangeTabs:d._onDidChangeTabs.event,get all(){return Object.freeze(d._extHostTabGroups.map(g=>g.apiObject))},get activeTabGroup(){const g=d._activeGroupId;return(0,P.assertIsDefined)(d._extHostTabGroups.find(l=>l.groupId===g)?.apiObject)},close:async(g,E)=>{const l=Array.isArray(g)?g:[g];return l.length?f(l[0])?this._closeGroups(l,E):this._closeTabs(l,E):!0}};this._apiObject=Object.freeze(o)}return this._apiObject}$acceptEditorTabModel(d){const o=new Set(this._extHostTabGroups.map(n=>n.groupId)),g=new Set(d.map(n=>n.groupId)),E=(0,R.diffSets)(o,g),l=this._extHostTabGroups.filter(n=>E.removed.includes(n.groupId)).map(n=>n.apiObject),D=[],i=[];this._extHostTabGroups=d.map(n=>{const r=new m(n,()=>this._activeGroupId);return E.added.includes(r.groupId)?D.push(r.apiObject):i.push(r.apiObject),r});const u=(0,P.assertIsDefined)(d.find(n=>n.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:D,closed:l,changed:i}))}$acceptTabGroupUpdate(d){const o=this._extHostTabGroups.find(g=>g.groupId===d.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(d),d.isActive&&(this._activeGroupId=d.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const o=this._extHostTabGroups.find(E=>E.groupId===d.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const g=o.acceptTabOperation(d);switch(d.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[g.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[g.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[g.apiObject]}));return}}_findExtHostTabFromApi(d){for(const o of this._extHostTabGroups)for(const g of o.tabs)if(g.apiObject===d)return g}_findExtHostTabGroupFromApi(d){return this._extHostTabGroups.find(o=>o.apiObject===d)}async _closeTabs(d,o){const g=[];for(const E of d){const l=this._findExtHostTabFromApi(E);if(!l)throw new Error("Tab close: Invalid tab not found!");g.push(l.tabId)}return this._proxy.$closeTab(g,o)}async _closeGroups(d,o){const g=[];for(const E of d){const l=this._findExtHostTabGroupFromApi(E);if(!l)throw new Error("Group close: Invalid group not found!");g.push(l.groupId)}return this._proxy.$closeGroup(g,o)}};k=ze([$e(0,b.IExtHostRpcService)],k),e.ExtHostEditorTabs=k;function f(h){return h.tabs!==void 0}}),define(Ce[198],Ie([1,0,2,4,7,6,8,243,9,23,27]),function(ie,e,a,p,w,M,y,A,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class S{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const h=this._schemes.indexOf(f);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),h=[];let d,o,g=14,E=14;for(const l of f){let D=d?(0,b.commonPrefixLength)(d,l):0;for(D===0?o=1:o=E;D<l.length;D++)D+1===l.length?(g=E,E=9):E+=1,h.push([o,l.toUpperCase().charCodeAt(D),E]),h.push([o,l.toLowerCase().charCodeAt(D),E]),o=E;d=l,E=g}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new A.StateMachine(h)}}provideDocumentLinks(f){this._initStateMachine();const h=[],d=A.LinkComputer.computeLinks({getLineContent(o){return f.lineAt(o-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const o of d){const g=y.DocumentLink.to(o);g.target&&h.push(g)}return h}}class m{constructor(f,h){this._extHostLanguageFeatures=h,this._linkProvider=new S,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(p.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,h,d,o={}){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const g=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(g,d);let E=2;o.isCaseSensitive&&(E+=1024),o.isReadonly&&(E+=2048),typeof d.copy=="function"&&(E+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,R.checkProposedApiEnabled)(f,"fsChunks"),E+=4),this._proxy.$registerFileSystemProvider(g,h,E).catch(D=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${h}`),console.error(D)});const l=d.onDidChangeFile(D=>{const i=[];for(const u of D){const{uri:n,type:r}=u;if(n.scheme!==h)continue;let s;switch(r){case M.FileChangeType.Changed:s=0;break;case M.FileChangeType.Created:s=1;break;case M.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:n,type:s})}this._proxy.$onFileSystemChange(g,i)});return(0,w.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(g),this._proxy.$unregisterProvider(g)})}static _asIStat(f){const{type:h,ctime:d,mtime:o,size:g,permissions:E}=f;return{type:h,ctime:d,mtime:o,size:g,permissions:E}}$stat(f,h){return Promise.resolve(this._getFsProvider(f).stat(a.URI.revive(h))).then(d=>m._asIStat(d))}$readdir(f,h){return Promise.resolve(this._getFsProvider(f).readDirectory(a.URI.revive(h)))}$readFile(f,h){return Promise.resolve(this._getFsProvider(f).readFile(a.URI.revive(h))).then(d=>P.VSBuffer.wrap(d))}$writeFile(f,h,d,o){return Promise.resolve(this._getFsProvider(f).writeFile(a.URI.revive(h),d.buffer,o))}$delete(f,h,d){return Promise.resolve(this._getFsProvider(f).delete(a.URI.revive(h),d))}$rename(f,h,d,o){return Promise.resolve(this._getFsProvider(f).rename(a.URI.revive(h),a.URI.revive(d),o))}$copy(f,h,d,o){const g=this._getFsProvider(f);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(a.URI.revive(h),a.URI.revive(d),o))}$mkdir(f,h){return Promise.resolve(this._getFsProvider(f).createDirectory(a.URI.revive(h)))}$watch(f,h,d,o){const g=this._getFsProvider(f).watch(a.URI.revive(d),o);this._watches.set(h,g)}$unwatch(f,h){const d=this._watches.get(h);d&&(d.dispose(),this._watches.delete(h))}$open(f,h,d){const o=this._getFsProvider(f);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(a.URI.revive(h),d))}$close(f,h){const d=this._getFsProvider(f);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(h))}$read(f,h,d,o){const g=this._getFsProvider(f);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const E=P.VSBuffer.alloc(o);return Promise.resolve(g.read(h,d,E.buffer,0,o)).then(l=>E.slice(0,l))}$write(f,h,d,o){const g=this._getFsProvider(f);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(h,d,o.buffer,0,o.byteLength))}_getFsProvider(f){const h=this._fsProvider.get(f);if(!h){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return h}}e.ExtHostFileSystem=m}),define(Ce[52],Ie([1,0,4,39,6,23,3,13,35,7]),function(ie,e,a,p,w,M,y,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Xt{constructor(m,k){this._fileSystemProvider=new Map,this._proxy=m.getProxy(a.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(h){try{const d=f._fileSystemProvider.get(h.scheme);if(!d)return await f._proxy.$stat(h);await f._proxy.$ensureActivation(h.scheme);const o=await d.stat(h);return{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions}}catch(d){Xt._handleError(d)}},async readDirectory(h){try{const d=f._fileSystemProvider.get(h.scheme);return d?(await f._proxy.$ensureActivation(h.scheme),(await d.readDirectory(h)).slice()):await f._proxy.$readdir(h)}catch(d){return Xt._handleError(d)}},async createDirectory(h){try{return await f._proxy.$mkdir(h)}catch(d){return Xt._handleError(d)}},async readFile(h){try{const d=f._fileSystemProvider.get(h.scheme);return d?(await f._proxy.$ensureActivation(h.scheme),(await d.readFile(h)).slice()):(await f._proxy.$readFile(h)).buffer}catch(d){return Xt._handleError(d)}},async writeFile(h,d){try{return await f._proxy.$writeFile(h,M.VSBuffer.wrap(d))}catch(o){return Xt._handleError(o)}},async delete(h,d){try{const o=f._fileSystemProvider.get(h.scheme);return o?(await f._proxy.$ensureActivation(h.scheme),await o.delete(h,{recursive:!1,...d})):await f._proxy.$delete(h,{recursive:!1,useTrash:!1,...d})}catch(o){return Xt._handleError(o)}},async rename(h,d,o){try{return await f._proxy.$rename(h,d,{overwrite:!1,...o})}catch(g){return Xt._handleError(g)}},async copy(h,d,o){try{return await f._proxy.$copy(h,d,{overwrite:!1,...o})}catch(g){return Xt._handleError(g)}},isWritableFileSystem(h){const d=k.getCapabilities(h);if(typeof d=="number")return!(d&2048)}})}static _handleError(m){if(m instanceof w.FileSystemError)throw m;if(!(m instanceof Error))throw new w.FileSystemError(String(m));if(m.name==="ENOPRO")throw w.FileSystemError.Unavailable(m.message);switch(m.name){case p.FileSystemProviderErrorCode.FileExists:throw w.FileSystemError.FileExists(m.message);case p.FileSystemProviderErrorCode.FileNotFound:throw w.FileSystemError.FileNotFound(m.message);case p.FileSystemProviderErrorCode.FileNotADirectory:throw w.FileSystemError.FileNotADirectory(m.message);case p.FileSystemProviderErrorCode.FileIsADirectory:throw w.FileSystemError.FileIsADirectory(m.message);case p.FileSystemProviderErrorCode.NoPermissions:throw w.FileSystemError.NoPermissions(m.message);case p.FileSystemProviderErrorCode.Unavailable:throw w.FileSystemError.Unavailable(m.message);default:throw new w.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,k){return this._fileSystemProvider.set(m,k),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(m))}};R=ze([$e(0,A.IExtHostRpcService),$e(1,b.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[199],Ie([1,0,5,34,2,4,8,6,27]),function(ie,e,a,p,w,M,y,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class P{constructor(m,k,f,h,d,o,g,E){this._onDidCreate=new a.Emitter,this._onDidChange=new a.Emitter,this._onDidDelete=new a.Emitter;const l=this.ensureWatching(m,f,d);this._config=0,o&&(this._config+=1),g&&(this._config+=2),E&&(this._config+=4);const D=(0,p.parse)(d),i=typeof d=="string",u=h(n=>{if(!o)for(const r of n.created){const s=w.URI.revive(r);D(s.fsPath)&&(!i||k.getWorkspaceFolder(s))&&this._onDidCreate.fire(s)}if(!g)for(const r of n.changed){const s=w.URI.revive(r);D(s.fsPath)&&(!i||k.getWorkspaceFolder(s))&&this._onDidChange.fire(s)}if(!E)for(const r of n.deleted){const s=w.URI.revive(r);D(s.fsPath)&&(!i||k.getWorkspaceFolder(s))&&this._onDidDelete.fire(s)}});this._disposable=A.Disposable.from(l,this._onDidCreate,this._onDidChange,this._onDidDelete,u)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(m,k,f){const h=A.Disposable.from();if(typeof f=="string")return h;const d=m.getProxy(M.MainContext.MainThreadFileSystem);let o=!1;(f.pattern.includes(p.GLOBSTAR)||f.pattern.includes(p.GLOB_SPLIT))&&(o=!0);const g=Math.random();return d.$watch(k.identifier.value,g,f.baseUri,{recursive:o,excludes:[]}),A.Disposable.from({dispose:()=>d.$unwatch(g)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(m,k,f){this._mainContext=m,this._logService=k,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new a.Emitter,this._onDidRenameFile=new a.Emitter,this._onDidCreateFile=new a.Emitter,this._onDidDeleteFile=new a.Emitter,this._onWillRenameFile=new a.AsyncEmitter,this._onWillCreateFile=new a.AsyncEmitter,this._onWillDeleteFile=new a.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(m,k,f,h,d,o){return new P(this._mainContext,m,k,this._onFileSystemEvent.event,y.GlobPattern.from(f),h,d,o)}$onFileEvent(m){this._onFileSystemEvent.fire(m)}$onDidRunFileOperation(m,k){switch(m){case 2:this._onDidRenameFile.fire(Object.freeze({files:k.map(f=>({oldUri:w.URI.revive(f.source),newUri:w.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:k.map(f=>w.URI.revive(f.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:k.map(f=>w.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(m){return this._createWillExecuteEvent(m,this._onWillRenameFile)}getOnWillCreateFileEvent(m){return this._createWillExecuteEvent(m,this._onWillCreateFile)}getOnWillDeleteFileEvent(m){return this._createWillExecuteEvent(m,this._onWillDeleteFile)}_createWillExecuteEvent(m,k){return(f,h,d)=>{const o=function(E){f.call(h,E)};return o.extension=m,k.event(o,void 0,d)}}async $onWillRunFileOperation(m,k,f,h){switch(m){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:k.map(d=>({oldUri:w.URI.revive(d.source),newUri:w.URI.revive(d.target)}))},f,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:k.map(d=>w.URI.revive(d.target))},f,h);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:k.map(d=>w.URI.revive(d.target))},f,h)}}async _fireWillEvent(m,k,f,h){const d=new Set,o=[];if(await m.fireAsync(k,h,async(E,l)=>{const D=Date.now(),i=await Promise.resolve(E);i instanceof A.WorkspaceEdit&&(o.push([l.extension,i]),d.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-D>f&&this._logService.warn("SLOW file-participant",l.extension.identifier)}),h.isCancellationRequested||o.length===0)return;const g={edits:[]};for(const[E,l]of o){const{edits:D}=y.WorkspaceEdit.from(l,{getTextDocumentVersion:i=>this._extHostDocumentsAndEditors.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}},(0,b.isProposedApiEnabled)(E,"snippetWorkspaceEdit"));g.edits=g.edits.concat(D)}return{edit:g,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=R}),define(Ce[200],Ie([1,0,2,36]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class w{constructor(y,A,b,P,R){this._extHostNotebooks=A,this._textDocumentsAndEditors=b,this._commands=P;const S=new p.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new p.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new p.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new p.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new p.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new p.ApiCommandResult("Notebook and input URI",m=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const k=this._extHostNotebooks.getEditorById(m.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:a.URI.revive(m.notebookUri),inputUri:a.URI.revive(m.inputUri),notebookEditor:k.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:a.URI.revive(m.notebookUri),inputUri:a.URI.revive(m.inputUri)}}));this._commands.registerApiCommand(S)}$willAddInteractiveDocument(y,A,b,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:b,uri:y,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(a.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(y,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[y]})}}e.ExtHostInteractive=w}),define(Ce[201],Ie([1,0,7,4]),function(ie,e,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class w{constructor(y){this._handlePool=0,this._proxy=y.getProxy(p.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,y),(0,a.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=w}),define(Ce[202],Ie([1,0,2,25,8,6,66,4,9,49,16,10,244,20,7,77,73,62,203,11,14,27]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f,h,d,o,g,E,l,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class i{constructor(I,z){this._documents=I,this._provider=z}async provideDocumentSymbols(I,z){const W=this._documents.getDocument(I),j=await this._provider.provideDocumentSymbols(W,z);if(!(0,R.isFalsyOrEmpty)(j))return j[0]instanceof M.DocumentSymbol?j.map(w.DocumentSymbol.from):i._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(I){I=I.slice(0).sort((j,re)=>{let de=j.location.range.start.compareTo(re.location.range.start);return de===0&&(de=re.location.range.end.compareTo(j.location.range.end)),de});const z=[],W=[];for(const j of I){const re={name:j.name||"!!MISSING: name!!",kind:w.SymbolKind.from(j.kind),tags:j.tags?.map(w.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:w.Range.from(j.location.range),selectionRange:w.Range.from(j.location.range),children:[]};for(;;){if(W.length===0){W.push(re),z.push(re);break}const de=W[W.length-1];if(P.Range.containsRange(de.range,re.range)&&!P.Range.equalsRange(de.range,re.range)){de.children?.push(re),W.push(re);break}W.pop()}}return z}}class u{constructor(I,z,W){this._documents=I,this._commands=z,this._provider=W,this._cache=new o.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(I,z){const W=this._documents.getDocument(I),j=await this._provider.provideCodeLenses(W,z);if(!j||z.isCancellationRequested)return;const re=this._cache.add(j),de=new f.DisposableStore;this._disposables.set(re,de);const Z={cacheId:re,lenses:[]};for(let pe=0;pe<j.length;pe++)Z.lenses.push({cacheId:[re,pe],range:w.Range.from(j[pe].range),command:this._commands.toInternal(j[pe].command,de)});return Z}async resolveCodeLens(I,z){const W=I.cacheId&&this._cache.get(...I.cacheId);if(!W)return;let j;if(typeof this._provider.resolveCodeLens!="function"||W.isResolved?j=W:j=await this._provider.resolveCodeLens(W,z),j||(j=W),z.isCancellationRequested)return;const re=I.cacheId&&this._disposables.get(I.cacheId[0]);if(!!re)return I.command=this._commands.toInternal(j.command??u._badCmd,re),I}releaseCodeLenses(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function n(J){return Array.isArray(J)?J.map(w.DefinitionLink.from):J?[w.DefinitionLink.from(J)]:[]}class r{constructor(I,z){this._documents=I,this._provider=z}async provideDefinition(I,z,W){const j=this._documents.getDocument(I),re=w.Position.to(z),de=await this._provider.provideDefinition(j,re,W);return n(de)}}class s{constructor(I,z){this._documents=I,this._provider=z}async provideDeclaration(I,z,W){const j=this._documents.getDocument(I),re=w.Position.to(z),de=await this._provider.provideDeclaration(j,re,W);return n(de)}}class t{constructor(I,z){this._documents=I,this._provider=z}async provideImplementation(I,z,W){const j=this._documents.getDocument(I),re=w.Position.to(z),de=await this._provider.provideImplementation(j,re,W);return n(de)}}class c{constructor(I,z){this._documents=I,this._provider=z}async provideTypeDefinition(I,z,W){const j=this._documents.getDocument(I),re=w.Position.to(z),de=await this._provider.provideTypeDefinition(j,re,W);return n(de)}}class _{constructor(I,z){this._documents=I,this._provider=z}async provideHover(I,z,W){const j=this._documents.getDocument(I),re=w.Position.to(z),de=await this._provider.provideHover(j,re,W);if(!(!de||(0,R.isFalsyOrEmpty)(de.contents)))return de.range||(de.range=j.getWordRangeAtPosition(re)),de.range||(de.range=new M.Range(re,re)),w.Hover.from(de)}}class v{constructor(I,z){this._documents=I,this._provider=z}async provideEvaluatableExpression(I,z,W){const j=this._documents.getDocument(I),re=w.Position.to(z),de=await this._provider.provideEvaluatableExpression(j,re,W);if(de)return w.EvaluatableExpression.from(de)}}class T{constructor(I,z){this._documents=I,this._provider=z}async provideInlineValues(I,z,W,j){const re=this._documents.getDocument(I),de=await this._provider.provideInlineValues(re,w.Range.to(z),w.InlineValueContext.to(W),j);if(Array.isArray(de))return de.map(Z=>w.InlineValue.from(Z))}}class U{constructor(I,z){this._documents=I,this._provider=z}async provideDocumentHighlights(I,z,W){const j=this._documents.getDocument(I),re=w.Position.to(z),de=await this._provider.provideDocumentHighlights(j,re,W);if(Array.isArray(de))return de.map(w.DocumentHighlight.from)}}class V{constructor(I,z){this._documents=I,this._provider=z}async provideLinkedEditingRanges(I,z,W){const j=this._documents.getDocument(I),re=w.Position.to(z),de=await this._provider.provideLinkedEditingRanges(j,re,W);if(de&&Array.isArray(de.ranges))return{ranges:(0,R.coalesce)(de.ranges.map(w.Range.from)),wordPattern:de.wordPattern}}}class x{constructor(I,z){this._documents=I,this._provider=z}async provideReferences(I,z,W,j){const re=this._documents.getDocument(I),de=w.Position.to(z),Z=await this._provider.provideReferences(re,de,W,j);if(Array.isArray(Z))return Z.map(w.location.from)}}class C{constructor(I,z,W,j,re,de,Z){this._documents=I,this._commands=z,this._diagnostics=W,this._provider=j,this._logService=re,this._extension=de,this._apiDeprecation=Z,this._cache=new o.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(I,z,W,j){const re=this._documents.getDocument(I),de=m.Selection.isISelection(z)?w.Selection.to(z):w.Range.to(z),Z=[];for(const Xe of this._diagnostics.getDiagnostics(I))if(de.intersection(Xe.range)&&Z.push(Xe)>C._maxCodeActionsPerFile)break;const pe={diagnostics:Z,only:W.only?new M.CodeActionKind(W.only):void 0,triggerKind:w.CodeActionTriggerKind.to(W.trigger)},ge=await this._provider.provideCodeActions(re,de,pe,j);if(!(0,R.isNonEmptyArray)(ge)||j.isCancellationRequested)return;const Ne=this._cache.add(ge),Be=new f.DisposableStore;this._disposables.set(Ne,Be);const Ye=[];for(let Xe=0;Xe<ge.length;Xe++){const Te=ge[Xe];!Te||(C._isCommand(Te)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ye.push({_isSynthetic:!0,title:Te.title,command:this._commands.toInternal(Te,Be)})):(pe.only&&(Te.kind?pe.only.contains(Te.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${Te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ye.push({cacheId:[Ne,Xe],title:Te.title,command:Te.command&&this._commands.toInternal(Te.command,Be),diagnostics:Te.diagnostics&&Te.diagnostics.map(w.Diagnostic.from),edit:Te.edit&&w.WorkspaceEdit.from(Te.edit,void 0,(0,D.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")),kind:Te.kind&&Te.kind.value,isPreferred:Te.isPreferred,disabled:Te.disabled?.reason})))}return{cacheId:Ne,actions:Ye}}async resolveCodeAction(I,z){const[W,j]=I,re=this._cache.get(W,j);if(!re||C._isCommand(re)||!this._provider.resolveCodeAction)return;const de=await this._provider.resolveCodeAction(re,z)??re;return de?.edit?w.WorkspaceEdit.from(de.edit,void 0,(0,D.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")):void 0}releaseCodeActions(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}static _isCommand(I){return typeof I.command=="string"&&typeof I.title=="string"}}C._maxCodeActionsPerFile=1e3;class L{constructor(I,z,W,j){this._proxy=I,this._documents=z,this._provider=W,this._handle=j}async prepareDocumentPaste(I,z,W,j){if(!this._provider.prepareDocumentPaste)return;const re=this._documents.getDocument(I),de=z.map(pe=>w.Range.to(pe)),Z=w.DataTransfer.toDataTransfer(W,()=>{throw new E.NotImplementedError});return await this._provider.prepareDocumentPaste(re,de,Z,j),w.DataTransfer.toDataTransferDTO(Z)}async providePasteEdits(I,z,W,j,re){const de=this._documents.getDocument(z),Z=W.map(Ne=>w.Range.to(Ne)),pe=w.DataTransfer.toDataTransfer(j,async Ne=>(await this._proxy.$resolvePasteFileData(this._handle,I,Ne)).buffer),ge=await this._provider.provideDocumentPasteEdits(de,Z,pe,re);if(!!ge)return{insertText:typeof ge.insertText=="string"?ge.insertText:{snippet:ge.insertText.value},additionalEdit:ge.additionalEdit?w.WorkspaceEdit.from(ge.additionalEdit,void 0,!0):void 0}}}class B{constructor(I,z){this._documents=I,this._provider=z}async provideDocumentFormattingEdits(I,z,W){const j=this._documents.getDocument(I),re=await this._provider.provideDocumentFormattingEdits(j,z,W);if(Array.isArray(re))return re.map(w.TextEdit.from)}}class F{constructor(I,z){this._documents=I,this._provider=z}async provideDocumentRangeFormattingEdits(I,z,W,j){const re=this._documents.getDocument(I),de=w.Range.to(z),Z=await this._provider.provideDocumentRangeFormattingEdits(re,de,W,j);if(Array.isArray(Z))return Z.map(w.TextEdit.from)}}class K{constructor(I,z){this._documents=I,this._provider=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(I,z,W,j,re){const de=this._documents.getDocument(I),Z=w.Position.to(z),pe=await this._provider.provideOnTypeFormattingEdits(de,Z,W,j,re);if(Array.isArray(pe))return pe.map(w.TextEdit.from)}}class H{constructor(I,z){this._provider=I,this._logService=z,this._cache=new o.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(I,z){const W=await this._provider.provideWorkspaceSymbols(I,z);if(!(0,R.isNonEmptyArray)(W))return{symbols:[]};const j=this._cache.add(W),re={cacheId:j,symbols:[]};for(let de=0;de<W.length;de++){const Z=W[de];if(!Z||!Z.name){this._logService.warn("INVALID SymbolInformation",Z);continue}re.symbols.push({...w.WorkspaceSymbol.from(Z),cacheId:[j,de]})}return re}async resolveWorkspaceSymbol(I,z){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!I.cacheId)return I;const W=this._cache.get(...I.cacheId);if(W){const j=await this._provider.resolveWorkspaceSymbol(W,z);return j&&(0,p.mixin)(I,w.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(I){this._cache.delete(I)}}class O{constructor(I,z,W){this._documents=I,this._provider=z,this._logService=W}static supportsResolving(I){return typeof I.prepareRename=="function"}async provideRenameEdits(I,z,W,j){const re=this._documents.getDocument(I),de=w.Position.to(z);try{const Z=await this._provider.provideRenameEdits(re,de,W,j);return Z?w.WorkspaceEdit.from(Z):void 0}catch(Z){const pe=O._asMessage(Z);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Z)}}async resolveRenameLocation(I,z,W){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(I),re=w.Position.to(z);try{const de=await this._provider.prepareRename(j,re,W);let Z,pe;if(M.Range.isRange(de)?(Z=de,pe=j.getText(de)):(0,S.isObject)(de)&&(Z=de.range,pe=de.placeholder),!Z||!pe)return;if(Z.start.line>re.line||Z.end.line<re.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:w.Range.from(Z),text:pe}}catch(de){const Z=O._asMessage(de);return Z?{rejectReason:Z,range:void 0,text:void 0}:Promise.reject(de)}}static _asMessage(I){return typeof I=="string"?I:I instanceof Error&&typeof I.message=="string"?I.message:void 0}}class ee{constructor(I,z){this.resultId=I,this.tokens=z}}class ue{constructor(I,z){this._documents=I,this._provider=z,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(I,z,W){const j=this._documents.getDocument(I),re=z!==0?this._previousResults.get(z):null;let de=typeof re?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,re.resultId,W):await this._provider.provideDocumentSemanticTokens(j,W);return re&&this._previousResults.delete(z),de?(de=ue._fixProvidedSemanticTokens(de),this._send(ue._convertToEdits(re,de),de)):null}async releaseDocumentSemanticColoring(I){this._previousResults.delete(I)}static _fixProvidedSemanticTokens(I){return ue._isSemanticTokens(I)?ue._isCorrectSemanticTokens(I)?I:new M.SemanticTokens(new Uint32Array(I.data),I.resultId):ue._isSemanticTokensEdits(I)?ue._isCorrectSemanticTokensEdits(I)?I:new M.SemanticTokensEdits(I.edits.map(z=>new M.SemanticTokensEdit(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),I.resultId):I}static _isSemanticTokens(I){return I&&!!I.data}static _isCorrectSemanticTokens(I){return I.data instanceof Uint32Array}static _isSemanticTokensEdits(I){return I&&Array.isArray(I.edits)}static _isCorrectSemanticTokensEdits(I){for(const z of I.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(I,z){if(!ue._isSemanticTokens(z)||!I||!I.tokens)return z;const W=I.tokens,j=W.length,re=z.data,de=re.length;let Z=0;const pe=Math.min(j,de);for(;Z<pe&&W[Z]===re[Z];)Z++;if(Z===j&&Z===de)return new M.SemanticTokensEdits([],z.resultId);let ge=0;const Ne=pe-Z;for(;ge<Ne&&W[j-ge-1]===re[de-ge-1];)ge++;return new M.SemanticTokensEdits([{start:Z,deleteCount:j-Z-ge,data:re.subarray(Z,de-ge)}],z.resultId)}_send(I,z){if(ue._isSemanticTokens(I)){const W=this._nextResultId++;return this._previousResults.set(W,new ee(I.resultId,I.data)),(0,h.encodeSemanticTokensDto)({id:W,type:"full",data:I.data})}if(ue._isSemanticTokensEdits(I)){const W=this._nextResultId++;return ue._isSemanticTokens(z)?this._previousResults.set(W,new ee(z.resultId,z.data)):this._previousResults.set(W,new ee(I.resultId)),(0,h.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(I.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}e.DocumentSemanticTokensAdapter=ue;class oe{constructor(I,z){this._documents=I,this._provider=z}async provideDocumentRangeSemanticTokens(I,z,W){const j=this._documents.getDocument(I),re=await this._provider.provideDocumentRangeSemanticTokens(j,w.Range.to(z),W);return re?this._send(re):null}_send(I){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:I.data})}}e.DocumentRangeSemanticTokensAdapter=oe;class le{constructor(I,z,W,j,re){this._documents=I,this._commands=z,this._provider=W,this._apiDeprecation=j,this._extension=re,this._cache=new o.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(I){return typeof I.resolveCompletionItem=="function"}async provideCompletionItems(I,z,W,j){const re=this._documents.getDocument(I),de=w.Position.to(z),Z=re.getWordRangeAtPosition(de)||new M.Range(de,de),pe=Z.with({end:de}),ge=new g.StopWatch(!0),Ne=await this._provider.provideCompletionItems(re,de,j,w.CompletionContext.to(W));if(!Ne||j.isCancellationRequested)return;const Be=Array.isArray(Ne)?new M.CompletionList(Ne):Ne,Ye=le.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),Xe=new f.DisposableStore;this._disposables.set(Ye,Xe);const Te=[],nt={x:Ye,b:Te,a:{replace:w.Range.from(Z),insert:w.Range.from(pe)},c:Be.isIncomplete||void 0,d:ge.elapsed()};for(let G=0;G<Be.items.length;G++){const X=Be.items[G],fe=this._convertCompletionItem(X,[Ye,G],pe,Z);Te.push(fe)}return nt}async resolveCompletionItem(I,z){if(typeof this._provider.resolveCompletionItem!="function")return;const W=this._cache.get(...I);if(!W)return;const j=await this._provider.resolveCompletionItem(W,z);if(!!j)return this._convertCompletionItem(j,I)}releaseCompletionItems(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}_convertCompletionItem(I,z,W,j){const re=this._disposables.get(z[0]);if(!re)throw Error("DisposableStore is missing...");const de={x:z,a:I.label,b:I.kind!==void 0?w.CompletionItemKind.from(I.kind):void 0,n:I.tags&&I.tags.map(w.CompletionItemTag.from),c:I.detail,d:typeof I.documentation>"u"?void 0:w.MarkdownString.fromStrict(I.documentation),e:I.sortText!==I.label?I.sortText:void 0,f:I.filterText!==I.label?I.filterText:void 0,g:I.preselect||void 0,i:I.keepWhitespace?1:0,k:I.commitCharacters,l:I.additionalTextEdits&&I.additionalTextEdits.map(w.TextEdit.from),m:this._commands.toInternal(I.command,re)};I.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),de.h=I.textEdit.newText):typeof I.insertText=="string"?de.h=I.insertText:I.insertText instanceof M.SnippetString&&(de.h=I.insertText.value,de.i|=4);let Z;return I.textEdit?Z=I.textEdit.range:I.range&&(Z=I.range),M.Range.isRange(Z)?de.j=w.Range.from(Z):Z&&(!W?.isEqual(Z.inserting)||!j?.isEqual(Z.replacing))&&(de.j={insert:w.Range.from(Z.inserting),replace:w.Range.from(Z.replacing)}),de}}class te{async provideInlineCompletions(I,z,W,j){}disposeCompletions(I){}handleDidShowCompletionItem(I,z){}}class Ee extends te{constructor(I,z,W,j){super(),this._extension=I,this._documents=z,this._provider=W,this._commands=j,this._references=new ne,this._isAdditionsProposedApiEnabled=(0,D.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[y.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,D.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(I,z,W,j){const re=this._documents.getDocument(I),de=w.Position.to(z),Z=await this._provider.provideInlineCompletionItems(re,de,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:w.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[W.triggerKind]},j);if(!Z||j.isCancellationRequested)return;const pe=Array.isArray(Z)?Z:Z.items,ge=this._isAdditionsProposedApiEnabled?Array.isArray(Z)?[]:Z.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:pe}),items:pe.map((Ye,Xe)=>{let Te;Ye.command&&(Ne||(Ne=new f.DisposableStore),Te=this._commands.toInternal(Ye.command,Ne));const nt=Ye.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ye.filterText,range:Ye.range?w.Range.from(Ye.range):void 0,command:Te,idx:Xe,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:ge.map(Ye=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Ye,Ne)))}}disposeCompletions(I){this._references.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,z){const W=this._references.get(I)?.items[z];W&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(W)}}class be extends te{constructor(I,z,W,j){super(),this.extension=I,this._documents=z,this._provider=W,this._commands=j,this._references=new ne,this.isAdditionProposedApiEnabled=(0,D.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[y.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKindNew.Automatic,[y.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(I,z,W,j){const re=this._documents.getDocument(I),de=w.Position.to(z),Z=await this._provider.provideInlineCompletionItems(re,de,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:w.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[W.triggerKind]},j);if(!Z||j.isCancellationRequested)return;const pe=Array.isArray(Z)?Z:Z.items,ge=Array.isArray(Z)?[]:Z.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:pe}),items:pe.map((Ye,Xe)=>{let Te;Ye.command&&(Ne||(Ne=new f.DisposableStore),Te=this._commands.toInternal(Ye.command,Ne));const nt=Ye.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ye.filterText,range:Ye.range?w.Range.from(Ye.range):void 0,command:Te,idx:Xe,completeBracketPairs:this.isAdditionProposedApiEnabled?Ye.completeBracketPairs:!1}}),commands:ge.map(Ye=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Ye,Ne)))}}disposeCompletions(I){this._references.disposeReferenceId(I)?.dispose()}handleDidShowCompletionItem(I,z){const W=this._references.get(I)?.items[z];W&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(W)}}class ne{constructor(){this._references=new Map,this._idPool=1}createReferenceId(I){const z=this._idPool++;return this._references.set(z,I),z}disposeReferenceId(I){const z=this._references.get(I);return this._references.delete(I),z}get(I){return this._references.get(I)}}class ve{constructor(I,z){this._documents=I,this._provider=z,this._cache=new o.Cache("SignatureHelp")}async provideSignatureHelp(I,z,W,j){const re=this._documents.getDocument(I),de=w.Position.to(z),Z=this.reviveContext(W),pe=await this._provider.provideSignatureHelp(re,de,j,Z);if(pe){const ge=this._cache.add([pe]);return{...w.SignatureHelp.from(pe),id:ge}}}reviveContext(I){let z;if(I.activeSignatureHelp){const W=w.SignatureHelp.to(I.activeSignatureHelp),j=this._cache.get(I.activeSignatureHelp.id,0);j?(z=j,z.activeSignature=W.activeSignature,z.activeParameter=W.activeParameter):z=W}return{...I,activeSignatureHelp:z}}releaseSignatureHelp(I){this._cache.delete(I)}}class Pe{constructor(I,z,W,j,re){this._documents=I,this._commands=z,this._provider=W,this._logService=j,this._extension=re,this._cache=new o.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(I,z,W){const j=this._documents.getDocument(I),re=w.Range.to(z),de=await this._provider.provideInlayHints(j,re,W);if(!Array.isArray(de)||de.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${z}`);return}if(W.isCancellationRequested)return;const Z=this._cache.add(de);this._disposables.set(Z,new f.DisposableStore);const pe={hints:[],cacheId:Z};for(let ge=0;ge<de.length;ge++)this._isValidInlayHint(de[ge],re)&&pe.hints.push(this._convertInlayHint(de[ge],[Z,ge]));return this._logService.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${z}`),pe}async resolveInlayHint(I,z){if(typeof this._provider.resolveInlayHint!="function")return;const W=this._cache.get(...I);if(!W)return;const j=await this._provider.resolveInlayHint(W,z);if(!!j&&!!this._isValidInlayHint(j))return this._convertInlayHint(j,I)}releaseHints(I){this._disposables.get(I)?.dispose(),this._disposables.delete(I),this._cache.delete(I)}_isValidInlayHint(I,z){return I.label.length===0||Array.isArray(I.label)&&I.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",I),!1):!(z&&!z.contains(I.position))}_convertInlayHint(I,z){const W=this._disposables.get(z[0]);if(!W)throw Error("DisposableStore is missing...");const j={label:"",cacheId:z,tooltip:w.MarkdownString.fromStrict(I.tooltip),position:w.Position.from(I.position),textEdits:I.textEdits&&I.textEdits.map(w.TextEdit.from),kind:I.kind&&w.InlayHintKind.from(I.kind),paddingLeft:I.paddingLeft,paddingRight:I.paddingRight};return typeof I.label=="string"?j.label=I.label:j.label=I.label.map(re=>{const de={label:re.value};return de.tooltip=w.MarkdownString.fromStrict(re.tooltip),M.Location.isLocation(re.location)&&(de.location=w.location.from(re.location)),re.command&&(de.command=this._commands.toInternal(re.command,W)),de}),j}}class Fe{constructor(I,z){this._documents=I,this._provider=z,this._cache=new o.Cache("DocumentLink")}async provideLinks(I,z){const W=this._documents.getDocument(I),j=await this._provider.provideDocumentLinks(W,z);if(!(!Array.isArray(j)||j.length===0)&&!z.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(Fe._validateLink).map(w.DocumentLink.from)};{const re=this._cache.add(j),de={links:[],cacheId:re};for(let Z=0;Z<j.length;Z++){if(!Fe._validateLink(j[Z]))continue;const pe=w.DocumentLink.from(j[Z]);pe.cacheId=[re,Z],de.links.push(pe)}return de}}}static _validateLink(I){return I.target&&I.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(I,z){if(typeof this._provider.resolveDocumentLink!="function")return;const W=this._cache.get(...I);if(!W)return;const j=await this._provider.resolveDocumentLink(W,z);if(!(!j||!Fe._validateLink(j)))return w.DocumentLink.from(j)}releaseLinks(I){this._cache.delete(I)}}class xe{constructor(I,z){this._documents=I,this._provider=z}async provideColors(I,z){const W=this._documents.getDocument(I),j=await this._provider.provideDocumentColors(W,z);return Array.isArray(j)?j.map(de=>({color:w.Color.from(de.color),range:w.Range.from(de.range)})):[]}async provideColorPresentations(I,z,W){const j=this._documents.getDocument(I),re=w.Range.to(z.range),de=w.Color.to(z.color),Z=await this._provider.provideColorPresentations(de,{document:j,range:re},W);if(!!Array.isArray(Z))return Z.map(w.ColorPresentation.from)}}class Qe{constructor(I,z){this._documents=I,this._provider=z}async provideFoldingRanges(I,z,W){const j=this._documents.getDocument(I),re=await this._provider.provideFoldingRanges(j,z,W);if(!!Array.isArray(re))return re.map(w.FoldingRange.from)}}class ke{constructor(I,z,W){this._documents=I,this._provider=z,this._logService=W}async provideSelectionRanges(I,z,W){const j=this._documents.getDocument(I),re=z.map(w.Position.to),de=await this._provider.provideSelectionRanges(j,re,W);if(!(0,R.isNonEmptyArray)(de))return[];if(de.length!==re.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Z=[];for(let pe=0;pe<re.length;pe++){const ge=[];Z.push(ge);let Ne=re[pe],Be=de[pe];for(;;){if(!Be.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(ge.push(w.SelectionRange.from(Be)),!Be.parent)break;Ne=Be.range,Be=Be.parent}}return Z}}class Se{constructor(I,z){this._documents=I,this._provider=z,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(I,z,W){const j=this._documents.getDocument(I),re=w.Position.to(z),de=await this._provider.prepareCallHierarchy(j,re,W);if(!de)return;const Z=this._idPool.nextId();return this._cache.set(Z,new Map),Array.isArray(de)?de.map(pe=>this._cacheAndConvertItem(Z,pe)):[this._cacheAndConvertItem(Z,de)]}async provideCallsTo(I,z,W){const j=this._itemFromCache(I,z);if(!j)throw new Error("missing call hierarchy item");const re=await this._provider.provideCallHierarchyIncomingCalls(j,W);if(!!re)return re.map(de=>({from:this._cacheAndConvertItem(I,de.from),fromRanges:de.fromRanges.map(Z=>w.Range.from(Z))}))}async provideCallsFrom(I,z,W){const j=this._itemFromCache(I,z);if(!j)throw new Error("missing call hierarchy item");const re=await this._provider.provideCallHierarchyOutgoingCalls(j,W);if(!!re)return re.map(de=>({to:this._cacheAndConvertItem(I,de.to),fromRanges:de.fromRanges.map(Z=>w.Range.from(Z))}))}releaseSession(I){this._cache.delete(I)}_cacheAndConvertItem(I,z){const W=this._cache.get(I),j=w.CallHierarchyItem.from(z,I,W.size.toString(36));return W.set(j._itemId,z),j}_itemFromCache(I,z){return this._cache.get(I)?.get(z)}}class ye{constructor(I,z){this._documents=I,this._provider=z,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(I,z,W){const j=this._documents.getDocument(I),re=w.Position.to(z),de=await this._provider.prepareTypeHierarchy(j,re,W);if(!de)return;const Z=this._idPool.nextId();return this._cache.set(Z,new Map),Array.isArray(de)?de.map(pe=>this._cacheAndConvertItem(Z,pe)):[this._cacheAndConvertItem(Z,de)]}async provideSupertypes(I,z,W){const j=this._itemFromCache(I,z);if(!j)throw new Error("missing type hierarchy item");const re=await this._provider.provideTypeHierarchySupertypes(j,W);if(!!re)return re.map(de=>this._cacheAndConvertItem(I,de))}async provideSubtypes(I,z,W){const j=this._itemFromCache(I,z);if(!j)throw new Error("missing type hierarchy item");const re=await this._provider.provideTypeHierarchySubtypes(j,W);if(!!re)return re.map(de=>this._cacheAndConvertItem(I,de))}releaseSession(I){this._cache.delete(I)}_cacheAndConvertItem(I,z){const W=this._cache.get(I),j=w.TypeHierarchyItem.from(z,I,W.size.toString(36));return W.set(j._itemId,z),j}_itemFromCache(I,z){return this._cache.get(I)?.get(z)}}class ae{constructor(I,z,W,j){this._proxy=I,this._documents=z,this._provider=W,this._handle=j}async provideDocumentOnDropEdits(I,z,W,j,re){const de=this._documents.getDocument(z),Z=w.Position.to(W),pe=w.DataTransfer.toDataTransfer(j,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,I,Ne)).buffer),ge=await this._provider.provideDocumentDropEdits(de,Z,pe,re);if(!!ge)return{insertText:typeof ge.insertText=="string"?ge.insertText:{snippet:ge.insertText.value},additionalEdit:ge.additionalEdit?w.WorkspaceEdit.from(ge.additionalEdit,void 0,!0):void 0}}}class ce{constructor(I,z){this.adapter=I,this.extension=z}}class Q{constructor(I,z,W,j,re,de,Z){this._adapter=new Map,this._uriTransformer=z,this._proxy=I.getProxy(A.MainContext.MainThreadLanguageFeatures),this._documents=W,this._commands=j,this._diagnostics=re,this._logService=de,this._apiDeprecation=Z}_transformDocumentSelector(I){return w.DocumentSelector.from(I,this._uriTransformer)}_createDisposable(I){return new M.Disposable(()=>{this._adapter.delete(I),this._proxy.$unregister(I)})}_nextHandle(){return Q._handlePool++}async _withAdapter(I,z,W,j,re,de=!1){const Z=this._adapter.get(I);if(!Z||!(Z.adapter instanceof z))return j;const pe=Date.now();de||this._logService.trace(`[${Z.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const ge=W(Z.adapter,Z.extension);return Promise.resolve(ge).catch(Ne=>{(0,E.isCancellationError)(Ne)||(this._logService.error(`[${Z.extension.identifier.value}] provider FAILED`),this._logService.error(Ne))}).finally(()=>{de||this._logService.trace(`[${Z.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),k.CancellationToken.isCancellationToken(re)?(0,l.raceCancellationError)(ge,re):ge}_addNewAdapter(I,z){const W=this._nextHandle();return this._adapter.set(W,new ce(I,z)),W}static _extLabel(I){return I.displayName||I.name}registerDocumentSymbolProvider(I,z,W,j){const re=this._addNewAdapter(new i(this._documents,W),I),de=j&&j.label||Q._extLabel(I);return this._proxy.$registerDocumentSymbolProvider(re,this._transformDocumentSelector(z),de),this._createDisposable(re)}$provideDocumentSymbols(I,z,W){return this._withAdapter(I,i,j=>j.provideDocumentSymbols(a.URI.revive(z),W),void 0,W)}registerCodeLensProvider(I,z,W){const j=this._nextHandle(),re=typeof W.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new ce(new u(this._documents,this._commands.converter,W),I)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(z),re);let de=this._createDisposable(j);if(re!==void 0){const Z=W.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(re));de=M.Disposable.from(de,Z)}return de}$provideCodeLenses(I,z,W){return this._withAdapter(I,u,j=>j.provideCodeLenses(a.URI.revive(z),W),void 0,W)}$resolveCodeLens(I,z,W){return this._withAdapter(I,u,j=>j.resolveCodeLens(z,W),void 0,void 0)}$releaseCodeLenses(I,z){this._withAdapter(I,u,W=>Promise.resolve(W.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(I,z,W){const j=this._addNewAdapter(new r(this._documents,W),I);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideDefinition(I,z,W,j){return this._withAdapter(I,r,re=>re.provideDefinition(a.URI.revive(z),W,j),[],j)}registerDeclarationProvider(I,z,W){const j=this._addNewAdapter(new s(this._documents,W),I);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideDeclaration(I,z,W,j){return this._withAdapter(I,s,re=>re.provideDeclaration(a.URI.revive(z),W,j),[],j)}registerImplementationProvider(I,z,W){const j=this._addNewAdapter(new t(this._documents,W),I);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideImplementation(I,z,W,j){return this._withAdapter(I,t,re=>re.provideImplementation(a.URI.revive(z),W,j),[],j)}registerTypeDefinitionProvider(I,z,W){const j=this._addNewAdapter(new c(this._documents,W),I);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideTypeDefinition(I,z,W,j){return this._withAdapter(I,c,re=>re.provideTypeDefinition(a.URI.revive(z),W,j),[],j)}registerHoverProvider(I,z,W,j){const re=this._addNewAdapter(new _(this._documents,W),I);return this._proxy.$registerHoverProvider(re,this._transformDocumentSelector(z)),this._createDisposable(re)}$provideHover(I,z,W,j){return this._withAdapter(I,_,re=>re.provideHover(a.URI.revive(z),W,j),void 0,j)}registerEvaluatableExpressionProvider(I,z,W,j){const re=this._addNewAdapter(new v(this._documents,W),I);return this._proxy.$registerEvaluatableExpressionProvider(re,this._transformDocumentSelector(z)),this._createDisposable(re)}$provideEvaluatableExpression(I,z,W,j){return this._withAdapter(I,v,re=>re.provideEvaluatableExpression(a.URI.revive(z),W,j),void 0,j)}registerInlineValuesProvider(I,z,W,j){const re=typeof W.onDidChangeInlineValues=="function"?this._nextHandle():void 0,de=this._addNewAdapter(new T(this._documents,W),I);this._proxy.$registerInlineValuesProvider(de,this._transformDocumentSelector(z),re);let Z=this._createDisposable(de);if(re!==void 0){const pe=W.onDidChangeInlineValues(ge=>this._proxy.$emitInlineValuesEvent(re));Z=M.Disposable.from(Z,pe)}return Z}$provideInlineValues(I,z,W,j,re){return this._withAdapter(I,T,de=>de.provideInlineValues(a.URI.revive(z),W,j,re),void 0,re)}registerDocumentHighlightProvider(I,z,W){const j=this._addNewAdapter(new U(this._documents,W),I);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideDocumentHighlights(I,z,W,j){return this._withAdapter(I,U,re=>re.provideDocumentHighlights(a.URI.revive(z),W,j),void 0,j)}registerLinkedEditingRangeProvider(I,z,W){const j=this._addNewAdapter(new V(this._documents,W),I);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideLinkedEditingRanges(I,z,W,j){return this._withAdapter(I,V,async re=>{const de=await re.provideLinkedEditingRanges(a.URI.revive(z),W,j);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?Q._serializeRegExp(de.wordPattern):void 0}},void 0,j)}registerReferenceProvider(I,z,W){const j=this._addNewAdapter(new x(this._documents,W),I);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideReferences(I,z,W,j,re){return this._withAdapter(I,x,de=>de.provideReferences(a.URI.revive(z),W,j,re),void 0,re)}registerCodeActionProvider(I,z,W,j){const re=new f.DisposableStore,de=this._addNewAdapter(new C(this._documents,this._commands.converter,this._diagnostics,W,this._logService,I,this._apiDeprecation),I);return this._proxy.$registerQuickFixSupport(de,this._transformDocumentSelector(z),{providedKinds:j?.providedCodeActionKinds?.map(Z=>Z.value),documentation:j?.documentation?.map(Z=>({kind:Z.kind.value,command:this._commands.converter.toInternal(Z.command,re)}))},Q._extLabel(I),Boolean(W.resolveCodeAction)),re.add(this._createDisposable(de)),re}$provideCodeActions(I,z,W,j,re){return this._withAdapter(I,C,de=>de.provideCodeActions(a.URI.revive(z),W,j,re),void 0,re)}$resolveCodeAction(I,z,W){return this._withAdapter(I,C,j=>j.resolveCodeAction(z,W),void 0,void 0)}$releaseCodeActions(I,z){this._withAdapter(I,C,W=>Promise.resolve(W.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(I,z,W){const j=this._addNewAdapter(new B(this._documents,W),I);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(z),I.identifier,I.displayName||I.name),this._createDisposable(j)}$provideDocumentFormattingEdits(I,z,W,j){return this._withAdapter(I,B,re=>re.provideDocumentFormattingEdits(a.URI.revive(z),W,j),void 0,j)}registerDocumentRangeFormattingEditProvider(I,z,W){const j=this._addNewAdapter(new F(this._documents,W),I);return this._proxy.$registerRangeFormattingSupport(j,this._transformDocumentSelector(z),I.identifier,I.displayName||I.name),this._createDisposable(j)}$provideDocumentRangeFormattingEdits(I,z,W,j,re){return this._withAdapter(I,F,de=>de.provideDocumentRangeFormattingEdits(a.URI.revive(z),W,j,re),void 0,re)}registerOnTypeFormattingEditProvider(I,z,W,j){const re=this._addNewAdapter(new K(this._documents,W),I);return this._proxy.$registerOnTypeFormattingSupport(re,this._transformDocumentSelector(z),j,I.identifier),this._createDisposable(re)}$provideOnTypeFormattingEdits(I,z,W,j,re,de){return this._withAdapter(I,K,Z=>Z.provideOnTypeFormattingEdits(a.URI.revive(z),W,j,re,de),void 0,de)}registerWorkspaceSymbolProvider(I,z){const W=this._addNewAdapter(new H(z,this._logService),I);return this._proxy.$registerNavigateTypeSupport(W,typeof z.resolveWorkspaceSymbol=="function"),this._createDisposable(W)}$provideWorkspaceSymbols(I,z,W){return this._withAdapter(I,H,j=>j.provideWorkspaceSymbols(z,W),{symbols:[]},W)}$resolveWorkspaceSymbol(I,z,W){return this._withAdapter(I,H,j=>j.resolveWorkspaceSymbol(z,W),void 0,void 0)}$releaseWorkspaceSymbols(I,z){this._withAdapter(I,H,W=>W.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(I,z,W){const j=this._addNewAdapter(new O(this._documents,W,this._logService),I);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(z),O.supportsResolving(W)),this._createDisposable(j)}$provideRenameEdits(I,z,W,j,re){return this._withAdapter(I,O,de=>de.provideRenameEdits(a.URI.revive(z),W,j,re),void 0,re)}$resolveRenameLocation(I,z,W,j){return this._withAdapter(I,O,re=>re.resolveRenameLocation(a.URI.revive(z),W,j),void 0,j)}registerDocumentSemanticTokensProvider(I,z,W,j){const re=this._addNewAdapter(new ue(this._documents,W),I),de=typeof W.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(re,this._transformDocumentSelector(z),j,de);let Z=this._createDisposable(re);if(de){const pe=W.onDidChangeSemanticTokens(ge=>this._proxy.$emitDocumentSemanticTokensEvent(de));Z=M.Disposable.from(Z,pe)}return Z}$provideDocumentSemanticTokens(I,z,W,j){return this._withAdapter(I,ue,re=>re.provideDocumentSemanticTokens(a.URI.revive(z),W,j),null,j)}$releaseDocumentSemanticTokens(I,z){this._withAdapter(I,ue,W=>W.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(I,z,W,j){const re=this._addNewAdapter(new oe(this._documents,W),I);return this._proxy.$registerDocumentRangeSemanticTokensProvider(re,this._transformDocumentSelector(z),j),this._createDisposable(re)}$provideDocumentRangeSemanticTokens(I,z,W,j){return this._withAdapter(I,oe,re=>re.provideDocumentRangeSemanticTokens(a.URI.revive(z),W,j),null,j)}registerCompletionItemProvider(I,z,W,j){const re=this._addNewAdapter(new le(this._documents,this._commands.converter,W,this._apiDeprecation,I),I);return this._proxy.$registerCompletionsProvider(re,this._transformDocumentSelector(z),j,le.supportsResolving(W),`${I.identifier.value}(${j.join("")})`),this._createDisposable(re)}$provideCompletionItems(I,z,W,j,re){return this._withAdapter(I,le,de=>de.provideCompletionItems(a.URI.revive(z),W,j,re),void 0,re)}$resolveCompletionItem(I,z,W){return this._withAdapter(I,le,j=>j.resolveCompletionItem(z,W),void 0,W)}$releaseCompletionItems(I,z){this._withAdapter(I,le,W=>W.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(I,z,W){const j=new Ee(I,this._documents,W,this._commands.converter),re=this._addNewAdapter(j,I);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(z),j.supportsHandleDidShowCompletionItem),this._createDisposable(re)}registerInlineCompletionsProviderNew(I,z,W){const j=this._addNewAdapter(new be(I,this._documents,W,this._commands.converter),I);return this._proxy.$registerInlineCompletionsSupport(j,this._transformDocumentSelector(z),!0),this._createDisposable(j)}$provideInlineCompletions(I,z,W,j,re){return this._withAdapter(I,te,de=>de.provideInlineCompletions(a.URI.revive(z),W,j,re),void 0,re)}$handleInlineCompletionDidShow(I,z,W){this._withAdapter(I,te,async j=>{j.handleDidShowCompletionItem(z,W)},void 0,void 0)}$freeInlineCompletionsList(I,z){this._withAdapter(I,te,async W=>{W.disposeCompletions(z)},void 0,void 0)}registerSignatureHelpProvider(I,z,W,j){const re=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,de=this._addNewAdapter(new ve(this._documents,W),I);return this._proxy.$registerSignatureHelpProvider(de,this._transformDocumentSelector(z),re),this._createDisposable(de)}$provideSignatureHelp(I,z,W,j,re){return this._withAdapter(I,ve,de=>de.provideSignatureHelp(a.URI.revive(z),W,j,re),void 0,re)}$releaseSignatureHelp(I,z){this._withAdapter(I,ve,W=>W.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(I,z,W){const j=typeof W.onDidChangeInlayHints=="function"?this._nextHandle():void 0,re=this._addNewAdapter(new Pe(this._documents,this._commands.converter,W,this._logService,I),I);this._proxy.$registerInlayHintsProvider(re,this._transformDocumentSelector(z),typeof W.resolveInlayHint=="function",j,Q._extLabel(I));let de=this._createDisposable(re);if(j!==void 0){const Z=W.onDidChangeInlayHints(pe=>this._proxy.$emitInlayHintsEvent(j));de=M.Disposable.from(de,Z)}return de}$provideInlayHints(I,z,W,j){return this._withAdapter(I,Pe,re=>re.provideInlayHints(a.URI.revive(z),W,j),void 0,j)}$resolveInlayHint(I,z,W){return this._withAdapter(I,Pe,j=>j.resolveInlayHint(z,W),void 0,W)}$releaseInlayHints(I,z){this._withAdapter(I,Pe,W=>W.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(I,z,W){const j=this._addNewAdapter(new Fe(this._documents,W),I);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(z),typeof W.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(I,z,W){return this._withAdapter(I,Fe,j=>j.provideLinks(a.URI.revive(z),W),void 0,W,z.scheme==="output")}$resolveDocumentLink(I,z,W){return this._withAdapter(I,Fe,j=>j.resolveLink(z,W),void 0,void 0,!0)}$releaseDocumentLinks(I,z){this._withAdapter(I,Fe,W=>W.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(I,z,W){const j=this._addNewAdapter(new xe(this._documents,W),I);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideDocumentColors(I,z,W){return this._withAdapter(I,xe,j=>j.provideColors(a.URI.revive(z),W),[],W)}$provideColorPresentations(I,z,W,j){return this._withAdapter(I,xe,re=>re.provideColorPresentations(a.URI.revive(z),W,j),void 0,j)}registerFoldingRangeProvider(I,z,W){const j=this._nextHandle(),re=typeof W.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new ce(new Qe(this._documents,W),I)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(z),re);let de=this._createDisposable(j);if(re!==void 0){const Z=W.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(re));de=M.Disposable.from(de,Z)}return de}$provideFoldingRanges(I,z,W,j){return this._withAdapter(I,Qe,re=>re.provideFoldingRanges(a.URI.revive(z),W,j),void 0,j)}registerSelectionRangeProvider(I,z,W){const j=this._addNewAdapter(new ke(this._documents,W,this._logService),I);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideSelectionRanges(I,z,W,j){return this._withAdapter(I,ke,re=>re.provideSelectionRanges(a.URI.revive(z),W,j),[],j)}registerCallHierarchyProvider(I,z,W){const j=this._addNewAdapter(new Se(this._documents,W),I);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$prepareCallHierarchy(I,z,W,j){return this._withAdapter(I,Se,re=>Promise.resolve(re.prepareSession(a.URI.revive(z),W,j)),void 0,j)}$provideCallHierarchyIncomingCalls(I,z,W,j){return this._withAdapter(I,Se,re=>re.provideCallsTo(z,W,j),void 0,j)}$provideCallHierarchyOutgoingCalls(I,z,W,j){return this._withAdapter(I,Se,re=>re.provideCallsFrom(z,W,j),void 0,j)}$releaseCallHierarchy(I,z){this._withAdapter(I,Se,W=>Promise.resolve(W.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(I,z,W){const j=this._addNewAdapter(new ye(this._documents,W),I);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$prepareTypeHierarchy(I,z,W,j){return this._withAdapter(I,ye,re=>Promise.resolve(re.prepareSession(a.URI.revive(z),W,j)),void 0,j)}$provideTypeHierarchySupertypes(I,z,W,j){return this._withAdapter(I,ye,re=>re.provideSupertypes(z,W,j),void 0,j)}$provideTypeHierarchySubtypes(I,z,W,j){return this._withAdapter(I,ye,re=>re.provideSubtypes(z,W,j),void 0,j)}$releaseTypeHierarchy(I,z){this._withAdapter(I,ye,W=>Promise.resolve(W.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(I,z,W){const j=this._nextHandle();return this._adapter.set(j,new ce(new ae(this._proxy,this._documents,W,j),I)),this._proxy.$registerDocumentOnDropEditProvider(j,this._transformDocumentSelector(z)),this._createDisposable(j)}$provideDocumentOnDropEdits(I,z,W,j,re,de){return this._withAdapter(I,ae,Z=>Promise.resolve(Z.provideDocumentOnDropEdits(z,a.URI.revive(W),j,re,de)),void 0,void 0)}registerDocumentPasteEditProvider(I,z,W,j){const re=this._nextHandle();return this._adapter.set(re,new ce(new L(this._proxy,this._documents,W,re),I)),this._proxy.$registerPasteEditProvider(re,this._transformDocumentSelector(z),!!W.prepareDocumentPaste,j.pasteMimeTypes),this._createDisposable(re)}$prepareDocumentPaste(I,z,W,j,re){return this._withAdapter(I,L,de=>de.prepareDocumentPaste(a.URI.revive(z),W,j,re),void 0,re)}$providePasteEdits(I,z,W,j,re,de){return this._withAdapter(I,L,Z=>Z.providePasteEdits(z,a.URI.revive(W),j,re,de),void 0,de)}static _serializeRegExp(I){return{pattern:I.source,flags:(0,b.regExpFlags)(I)}}static _serializeIndentationRule(I){return{decreaseIndentPattern:Q._serializeRegExp(I.decreaseIndentPattern),increaseIndentPattern:Q._serializeRegExp(I.increaseIndentPattern),indentNextLinePattern:I.indentNextLinePattern?Q._serializeRegExp(I.indentNextLinePattern):void 0,unIndentedLinePattern:I.unIndentedLinePattern?Q._serializeRegExp(I.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(I){return{beforeText:Q._serializeRegExp(I.beforeText),afterText:I.afterText?Q._serializeRegExp(I.afterText):void 0,previousLineText:I.previousLineText?Q._serializeRegExp(I.previousLineText):void 0,action:I.action}}static _serializeOnEnterRules(I){return I.map(Q._serializeOnEnterRule)}setLanguageConfiguration(I,z,W){const{wordPattern:j}=W;if(j&&(0,b.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(z,j):this._documents.setWordDefinitionFor(z,void 0),W.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",I,"Do not use."),W.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",I,"Do not use.");const re=this._nextHandle(),de={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?Q._serializeRegExp(W.wordPattern):void 0,indentationRules:W.indentationRules?Q._serializeIndentationRule(W.indentationRules):void 0,onEnterRules:W.onEnterRules?Q._serializeOnEnterRules(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this._proxy.$setLanguageConfiguration(re,z,de),this._createDisposable(re)}$setWordDefinitions(I){for(const z of I)this._documents.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.ExtHostLanguageFeatures=Q,Q._handlePool=0}),define(Ce[204],Ie([1,0,4,8,6,29,14,7]),function(ie,e,a,p,w,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class b{constructor(R,S,m,k){this._documents=S,this._commands=m,this._uriTransformer=k,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,S){await this._proxy.$changeLanguage(R,S);const m=this._documents.getDocumentData(R);if(!m)throw new Error(`document '${R.toString()}' NOT found`);return m.document}async tokenAtPosition(R,S){const m=R.version,k=p.Position.from(S),f=await this._proxy.$tokensAtPosition(R.uri,k),h={type:w.StandardTokenType.Other,range:R.getWordRangeAtPosition(S)??new w.Range(S.line,S.character,S.line,S.character)};if(!f)return h;const d={range:p.Range.to(f.range),type:p.TokenType.to(f.type)};return!d.range.contains(S)||m!==R.version?h:d}createLanguageStatusItem(R,S,m){const k=this._handlePool++,f=this._proxy,h=this._ids,d=`${R.identifier.value}/${S}`;if(h.has(d))throw new Error(`LanguageStatusItem with id '${S}' ALREADY exists`);h.add(d);const o={selector:m,id:S,name:R.displayName??R.name,severity:w.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let g;const E=new A.DisposableStore,l=()=>{g?.dispose(),g=(0,y.disposableTimeout)(()=>{E.clear(),this._proxy.$setLanguageStatus(k,{id:d,name:o.name??R.displayName??R.name,source:R.displayName??R.name,selector:p.DocumentSelector.from(o.selector,this._uriTransformer),label:o.text,detail:o.detail??"",severity:o.severity===w.LanguageStatusSeverity.Error?M.default.Error:o.severity===w.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:o.command&&this._commands.toInternal(o.command,E),accessibilityInfo:o.accessibilityInformation,busy:o.busy})},0)},D={dispose(){E.dispose(),g?.dispose(),f.$removeLanguageStatus(k),h.delete(d)},get id(){return o.id},get name(){return o.name},set name(i){o.name=i,l()},get selector(){return o.selector},set selector(i){o.selector=i,l()},get text(){return o.text},set text(i){o.text=i,l()},get detail(){return o.detail},set detail(i){o.detail=i,l()},get severity(){return o.severity},set severity(i){o.severity=i,l()},get accessibilityInformation(){return o.accessibilityInformation},set accessibilityInformation(i){o.accessibilityInformation=i,l()},get command(){return o.command},set command(i){o.command=i,l()},get busy(){return o.busy},set busy(i){o.busy=i,l()}};return l(),D}}e.ExtHostLanguages=b}),define(Ce[205],Ie([1,0,15,4,28,13,5]),function(ie,e,a,p,w,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let A=class extends a.AbstractLoggerService{constructor(R,S){const m=new y.Emitter;super(S.logLevel,m.event),this._proxy=R.getProxy(p.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(m)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,S,m){return new b(this._proxy,R,S,m)}};A=ze([$e(0,M.IExtHostRpcService),$e(1,w.IExtHostInitDataService)],A),e.ExtHostLoggerService=A;class b extends a.AbstractMessageLogger{constructor(R,S,m,k){super(k?.always),this.proxy=R,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.proxy.$createLogger(S,k).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,S){const m=[[R,S]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(R){this.proxy.$log(this.file,R)}}}),define(Ce[206],Ie([1,0,4,15,27]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(A){return A&&A.title}let y=class{constructor(b,P){this._logService=P,this._proxy=b.getProxy(a.MainContext.MainThreadMessageService)}showMessage(b,P,R,S,m){const k={source:{identifier:b.identifier,label:b.displayName||b.name}};let f;typeof S=="string"||M(S)?f=[S,...m]:(k.modal=S?.modal,k.useCustom=S?.useCustom,k.detail=S?.detail,f=m),k.useCustom&&(0,w.checkProposedApiEnabled)(b,"resolvers");const h=[];for(let d=0;d<f.length;d++){const o=f[d];if(typeof o=="string")h.push({title:o,handle:d,isCloseAffordance:!1});else if(typeof o=="object"){const{title:g,isCloseAffordance:E}=o;h.push({title:g,isCloseAffordance:!!E,handle:d})}else this._logService.warn("Invalid message item:",o)}return this._proxy.$showMessage(P,R,k,h).then(d=>{if(typeof d=="number")return f[d]})}};y=ze([$e(1,p.ILogService)],y),e.ExtHostMessageService=y}),define(Ce[207],Ie([1,0,23,5,97,7,24,9,10,2,62,4,36,8,6,40,175,92]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f,h,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class g{constructor(l,D,i,u,n){this._textDocumentsAndEditors=i,this._textDocuments=u,this._extensionStoragePaths=n,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new y.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new p.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new p.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new p.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new p.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(S.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(S.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(S.MainContext.MainThreadNotebookEditors),this._commandsConverter=D.converter,D.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const s=r.notebookEditor?.notebookUri,t=r.cell.handle,_=this._documents.get(s)?.getCell(t);if(_)return _.apiCell}return r}}),g._registerApiCommands(D)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const D=this._editors.get(l);if(!D)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return D}getIdByEditor(l){for(const[D,i]of this._editors)if(i.apiEditor===l)return D}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,D){const i=this._documents.get(l);if(!i&&!D)throw new Error(`NO notebook document for '${l}'`);return i}_getProviderData(l){const D=this._notebookContentProviders.get(l);if(!D)throw new Error(`NO provider for '${l}'`);return D}registerNotebookContentProvider(l,D,i,u,n){if((0,A.isFalsyOrWhitespace)(D))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(D))throw new Error(`Notebook provider for '${D}' already registered`);this._notebookContentProviders.set(D,{extension:l,provider:i});let r;return i.onDidChangeNotebookContentOptions&&(r=i.onDidChangeNotebookContentOptions(()=>{const s=k.NotebookDocumentContentOptions.from(i.options);this._notebookProxy.$updateNotebookProviderOptions(D,s)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},D,k.NotebookDocumentContentOptions.from(u),g._convertNotebookRegistrationData(l,n)),new f.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(D),this._notebookProxy.$unregisterNotebookProvider(D)})}static _convertNotebookRegistrationData(l,D){if(!D)return;const i=D.filenamePattern.map(u=>k.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(D.filenamePattern&&!i){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:D.displayName,filenamePattern:i,exclusive:D.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,D,i){const u=g._notebookStatusBarItemProviderHandlePool++,n=typeof i.onDidChangeCellStatusBarItems=="function"?g._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(u,i),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(u,n,D);let r;return n!==void 0&&(r=i.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(n))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(u),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(u,n),r?.dispose()})}async createNotebookDocument(l){const D=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&k.NotebookData.from(l.content)});return P.URI.revive(D)}async openNotebookDocument(l){const D=this._documents.get(l);if(D)return D.apiNotebook;const i=await this._notebookDocumentsProxy.$tryOpenNotebook(l),u=this._documents.get(P.URI.revive(i));return(0,b.assertIsDefined)(u?.apiNotebook)}async showNotebookDocument(l,D){P.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let i;typeof D=="object"?i={position:k.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(k.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:i={preserveFocus:!1};const u=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,i),n=u&&this._editors.get(u)?.apiEditor;if(n)return n;throw u?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,D,i,u){const n=this._notebookStatusBarItemProviders.get(l),r=P.URI.revive(D),s=this._documents.get(r);if(!s||!n)return;const t=s.getCellFromIndex(i);if(!t)return;const c=await n.provideCellStatusBarItems(t.apiCell,u);if(!c)return;const _=new M.DisposableStore,v=this._statusBarCache.add([_]),U=(Array.isArray(c)?c:[c]).map(V=>k.NotebookStatusBarItem.from(V,this._commandsConverter,_));return{cacheId:v,items:U}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,D,i,u,n){if((0,A.isFalsyOrWhitespace)(D))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,i),this._notebookProxy.$registerNotebookSerializer(r,{id:l.identifier,location:l.extensionLocation},D,k.NotebookDocumentContentOptions.from(u),g._convertNotebookRegistrationData(l,n)),(0,M.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(l,D,i){const u=this._notebookSerializer.get(l);if(!u)throw new Error("NO serializer found");const n=await u.deserializeNotebook(D.buffer,i);return new h.SerializableObjectWithBuffers(k.NotebookData.from(n))}async $notebookToData(l,D,i){const u=this._notebookSerializer.get(l);if(!u)throw new Error("NO serializer found");const n=await u.serializeNotebook(k.NotebookData.to(D.value),i);return a.VSBuffer.wrap(n)}async $openNotebook(l,D,i,u,n){const{provider:r}=this._getProviderData(l),s=await r.openNotebook(P.URI.revive(D),{backupId:i,untitledDocumentData:u?.buffer},n);return new h.SerializableObjectWithBuffers({metadata:s.metadata??Object.create(null),cells:s.cells.map(k.NotebookCellData.from)})}async $saveNotebook(l,D,i){const u=this.getNotebookDocument(P.URI.revive(D)),{provider:n}=this._getProviderData(l);return await n.saveNotebook(u.apiNotebook,i),!0}async $saveNotebookAs(l,D,i,u){const n=this.getNotebookDocument(P.URI.revive(D)),{provider:r}=this._getProviderData(l);return await r.saveNotebookAs(P.URI.revive(i),n.apiNotebook,u),!0}async $backupNotebook(l,D,i){const u=this.getNotebookDocument(P.URI.revive(D)),n=this._getProviderData(l),r=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension),s=String((0,w.hash)([u.uri.toString(),this._backupIdPool++])),t=P.URI.joinPath(r,s),c=await n.provider.backupNotebook(u.apiNotebook,{destination:t},i);return u.updateBackup(c),c.id}_createExtHostEditor(l,D,i){if(this._editors.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const u=new o.ExtHostNotebookEditor(D,this._notebookEditorsProxy,l,i.visibleRanges.map(k.NotebookRange.to),i.selections.map(k.NotebookRange.to),typeof i.viewColumn=="number"?k.ViewColumn.to(i.viewColumn):void 0);this._editors.set(D,u)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const i of l.value.removedDocuments){const u=P.URI.revive(i),n=this._documents.get(u);n&&(n.dispose(),this._documents.delete(u),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:n.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(n.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===u.toString()&&this._editors.delete(r.id)}if(l.value.addedDocuments){const i=[];for(const u of l.value.addedDocuments){const n=P.URI.revive(u.uri);if(this._documents.has(n))throw new Error(`adding EXISTING notebook ${n} `);const r=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,n,u);i.push(...u.cells.map(s=>d.ExtHostCell.asModelAddData(r.apiNotebook,s))),this._documents.get(n)?.dispose(),this._documents.set(n,r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this._onDidOpenNotebookDocument.fire(r.apiNotebook)}}if(l.value.addedEditors)for(const i of l.value.addedEditors){if(this._editors.has(i.id))return;const u=P.URI.revive(i.documentUri),n=this._documents.get(u);n&&this._createExtHostEditor(n,i.id,i)}const D=[];if(l.value.removedEditors)for(const i of l.value.removedEditors){const u=this._editors.get(i);u&&(this._editors.delete(i),this._activeNotebookEditor?.id===u.id&&(this._activeNotebookEditor=void 0),D.push(u))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(u=>this._editors.get(u)).filter(u=>!!u);const i=new Set;this._visibleNotebookEditors.forEach(u=>i.add(u.id));for(const u of this._editors.values()){const n=i.has(u.id);u._acceptVisibility(n)}this._visibleNotebookEditors=[...this._editors.values()].map(u=>u).filter(u=>u.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(l){const D=m.ApiCommandArgument.String.with("notebookType","A notebook type"),i=new m.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new m.ApiCommandArgument("data","Bytes to convert to data",n=>n instanceof Uint8Array,n=>a.VSBuffer.wrap(n))],new m.ApiCommandResult("Notebook Data",n=>k.NotebookData.to(n.value))),u=new m.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new m.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",n=>!0,n=>new h.SerializableObjectWithBuffers(k.NotebookData.from(n)))],new m.ApiCommandResult("Bytes",n=>n.buffer));l.registerApiCommand(i),l.registerApiCommand(u)}}e.ExtHostNotebookController=g,g._notebookStatusBarItemProviderHandlePool=0}),define(Ce[208],Ie([1,0,16,14,20,5,7,24,2,26,15,4,36,8,6,64,168,27,40]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f,h,d,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let E=class{constructor(r,s,t,c,_){this._initData=s,this._extHostNotebook=t,this._commands=c,this._logService=_,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=r.getProxy(S.MainContext.MainThreadNotebookKernels);const v=new m.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.ApiCommandArgument("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const U=this._extHostNotebook.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:U}}else if(T&&"notebookEditor"in T){const U=this._extHostNotebook.getIdByEditor(T.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.document.uri.toString()}`);return{notebookEditorId:U}}return T})],m.ApiCommandResult.Void);this._commands.registerApiCommand(v)}createNotebookController(r,s,t,c,_,v){for(const le of this._kernelData.values())if(le.controller.id===s&&P.ExtensionIdentifier.equals(r.identifier,le.extensionId))throw new Error(`notebook controller with id '${s}' ALREADY exist`);const T=this._handlePool++,U=this;this._logService.trace(`NotebookController[${T}], CREATED by ${r.identifier.value}, ${s}`);const V=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${r.identifier}'`);let x=!1;const C=new y.DisposableStore,L=new M.Emitter,B=new M.Emitter,F={id:u(r.identifier,s),notebookType:t,extensionId:r.identifier,extensionLocation:r.extensionLocation,label:c||r.identifier.value,preloads:v?v.map(k.NotebookRendererScript.from):[]};let K=_??V,H;this._proxy.$addKernel(T,F).catch(le=>{console.log(le),x=!0});let O=0;const ee=()=>{if(x)return;const le=++O;Promise.resolve().then(()=>{le===O&&this._proxy.$updateKernel(T,F)})},ue=new A.ResourceMap,oe={get id(){return s},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return F.label},set label(le){F.label=le??r.displayName??r.name,ee()},get detail(){return F.detail??""},set detail(le){F.detail=le,ee()},get description(){return F.description??""},set description(le){F.description=le,ee()},get kind(){return(0,o.checkProposedApiEnabled)(r,"notebookControllerKind"),F.kind??""},set kind(le){(0,o.checkProposedApiEnabled)(r,"notebookControllerKind"),F.kind=le,ee()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(le){F.supportedLanguages=le,ee()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(le){F.supportsExecutionOrder=le,ee()},get rendererScripts(){return F.preloads?F.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(le){K=le??V},get interruptHandler(){return H},set interruptHandler(le){H=le,F.supportsInterrupt=Boolean(le),ee()},createNotebookCellExecution(le){if(x)throw new Error("notebook controller is DISPOSED");if(!ue.has(le.notebook.uri))throw U._logService.trace(`NotebookController[${T}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${le.notebook.uri.toString()}`);return U._createNotebookCellExecution(le,u(r.identifier,this.id))},dispose:()=>{x||(this._logService.trace(`NotebookController[${T}], DISPOSED`),x=!0,this._kernelData.delete(T),C.dispose(),L.dispose(),B.dispose(),this._proxy.$removeKernel(T))},updateNotebookAffinity(le,te){U._proxy.$updateNotebookPriority(T,le.uri,te)},onDidReceiveMessage:B.event,postMessage(le,te){return(0,o.checkProposedApiEnabled)(r,"notebookMessaging"),U._proxy.$postMessage(T,te&&U._extHostNotebook.getIdByEditor(te),le)},asWebviewUri(le){return(0,o.checkProposedApiEnabled)(r,"notebookMessaging"),(0,h.asWebviewUri)(le,U._initData.remote)}};return this._kernelData.set(T,{extensionId:r.identifier,controller:oe,onDidReceiveMessage:B,onDidChangeSelection:L,associatedNotebooks:ue}),oe}getIdByController(r){for(const[s,t]of this._kernelData)if(t.controller===r)return u(t.extensionId,r.id);return null}$acceptNotebookAssociation(r,s,t){const c=this._kernelData.get(r);if(c){const _=this._extHostNotebook.getNotebookDocument(b.URI.revive(s));t?c.associatedNotebooks.set(_.uri,!0):c.associatedNotebooks.delete(_.uri),this._logService.trace(`NotebookController[${r}] ASSOCIATE notebook`,_.uri.toString(),t),c.onDidChangeSelection.fire({selected:t,notebook:_.apiNotebook})}}async $executeCells(r,s,t){const c=this._kernelData.get(r);if(!c)return;const _=this._extHostNotebook.getNotebookDocument(b.URI.revive(s)),v=[];for(const T of t){const U=_.getCell(T);U&&v.push(U.apiCell)}try{this._logService.trace(`NotebookController[${r}] EXECUTE cells`,_.uri.toString(),v.length),await c.controller.executeHandler.call(c.controller,v,_.apiNotebook,c.controller)}catch(T){this._logService.error(`NotebookController[${r}] execute cells FAILED`,T),console.error(T)}}async $cancelCells(r,s,t){const c=this._kernelData.get(r);if(!c)return;const _=this._extHostNotebook.getNotebookDocument(b.URI.revive(s));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,_.apiNotebook);else for(const v of t){const T=_.getCell(v);T&&this._activeExecutions.get(T.uri)?.cancel()}}$acceptKernelMessageFromRenderer(r,s,t){const c=this._kernelData.get(r);if(!c)return;const _=this._extHostNotebook.getEditorById(s);c.onDidReceiveMessage.fire(Object.freeze({editor:_.apiEditor,message:t}))}$cellExecutionChanged(r,s,t){const _=this._extHostNotebook.getNotebookDocument(b.URI.revive(r)).getCell(s);if(_){const v=t?k.NotebookCellExecutionState.to(t):f.NotebookCellExecutionState.Idle;v!==void 0&&this._onDidChangeCellExecutionState.fire({cell:_.apiCell,state:v})}}_createNotebookCellExecution(r,s){if(r.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(r.notebook.uri).getCellFromApiCell(r);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const _=new D(s,c,this._proxy);this._activeExecutions.set(c.uri,_);const v=_.onDidChangeState(()=>{_.state===l.Resolved&&(_.dispose(),v.dispose(),this._activeExecutions.delete(c.uri))});return _.asApiObject()}};E=ze([$e(4,R.ILogService)],E),e.ExtHostNotebookKernels=E;var l;(function(n){n[n.Init=0]="Init",n[n.Started=1]="Started",n[n.Resolved=2]="Resolved"})(l||(l={}));class D extends y.Disposable{constructor(r,s,t){super(),this._cell=s,this._proxy=t,this._handle=D.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._collector=new i(10,c=>this.update(c)),this._executionOrder=s.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,r,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(r){await this._collector.addItem(r)}async update(r){const s=Array.isArray(r)?r:[r];return this._proxy.$updateExecution(this._handle,new g.SerializableObjectWithBuffers(s))}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(r){let s=this._cell;if(r&&(s=this._cell.notebook.getCellFromApiCell(r)),!s)throw new Error("INVALID cell");return s.handle}validateAndConvertOutputs(r){return r.map(s=>{const t=f.NotebookCellOutput.ensureUniqueMimeTypes(s.items,!0);return t===s.items?k.NotebookCellOutput.from(s):k.NotebookCellOutput.from({items:t,id:s.id,metadata:s.metadata})})}async updateOutputs(r,s,t){const c=this.cellIndexToHandle(s),_=this.validateAndConvertOutputs((0,a.asArray)(r));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,cellHandle:c,append:t,outputs:_})}async updateOutputItems(r,s,t){return r=f.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(r),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,items:r.map(k.NotebookCellOutputItem.from),outputId:s.id,append:t})}asApiObject(){const r=this;return Object.freeze({get token(){return r._tokenSource.token},get cell(){return r._cell.apiCell},get executionOrder(){return r._executionOrder},set executionOrder(t){r._executionOrder=t,r.update([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:r._executionOrder}])},start(t){if(r._state===l.Resolved||r._state===l.Started)throw new Error("Cannot call start again");r._state=l.Started,r._onDidChangeState.fire(),r.update({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,c){if(r._state===l.Resolved)throw new Error("Cannot call resolve twice");r._state=l.Resolved,r._onDidChangeState.fire(),r._collector.flush(),r._proxy.$completeExecution(r._handle,new g.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:t}))},clearOutput(t){return r.verifyStateForOutput(),r.updateOutputs([],t,!1)},appendOutput(t,c){return r.verifyStateForOutput(),r.updateOutputs(t,c,!0)},replaceOutput(t,c){return r.verifyStateForOutput(),r.updateOutputs(t,c,!1)},appendOutputItems(t,c){return r.verifyStateForOutput(),r.updateOutputItems(t,c,!0)},replaceOutputItems(t,c){return r.verifyStateForOutput(),r.updateOutputItems(t,c,!1)}})}}D.HANDLE=0;class i{constructor(r,s){this.delay=r,this.callback=s,this.batch=[],this.startedTimer=Date.now()}addItem(r){return this.batch.push(r),this.currentDeferred||(this.currentDeferred=new p.DeferredPromise,this.startedTimer=Date.now(),(0,p.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const r=this.currentDeferred;this.currentDeferred=void 0;const s=this.batch;return this.batch=[],this.callback(s).finally(()=>r.complete())}}function u(n,r){return`${n.value}/${r}`}e.createKernelId=u}),define(Ce[209],Ie([1,0,5,4,92]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(A,b){this._extHostNotebook=b,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(p.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,b,P){const R=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(b)?.fire({editor:R.apiEditor,message:P})}createRendererMessaging(A,b){if(!A.contributes?.notebookRenderer?.some(R=>R.id===b))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${b})`);return{onDidReceiveMessage:(R,S,m)=>this.getOrCreateEmitterFor(b).event(R,S,m),postMessage:(R,S)=>{w.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,S]=[S,R]);const m=S&&w.ExtHostNotebookEditor.apiEditorsToExtHost.get(S);return this.proxy.$postMessage(m?.id,b,R)}}}getOrCreateEmitterFor(A){let b=this._rendererMessageEmitters.get(A);return b||(b=new a.Emitter({onLastListenerRemove:()=>{b?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,b),b)}}e.ExtHostNotebookRenderers=M}),define(Ce[210],Ie([1,0,20,5,7,4,2,6,11,16,29,61]),function(ie,e,a,p,w,M,y,A,b,P,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(k,f,h){const d=k.getProxy(M.MainContext.MainThreadQuickOpen);class o{constructor(s,t){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=t}showQuickPick(s,t,c=a.CancellationToken.None){this._onDidSelectItem=void 0;const _=Promise.resolve(s),v=++this._instances,T=d.$show(v,{title:t?.title,placeHolder:t?.placeHolder,matchOnDescription:t?.matchOnDescription,matchOnDetail:t?.matchOnDetail,ignoreFocusLost:t?.ignoreFocusOut,canPickMany:t?.canPickMany},c),U={},V=T.then(()=>U);return Promise.race([V,_]).then(x=>{if(x!==U)return _.then(C=>{const L=[];for(let B=0;B<C.length;B++){const F=C[B];typeof F=="string"?L.push({label:F,handle:B}):F.kind===A.QuickPickItemKind.Separator?L.push({type:"separator",label:F.label}):L.push({label:F.label,description:F.description,detail:F.detail,picked:F.picked,alwaysShow:F.alwaysShow,handle:B})}return t&&typeof t.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{t.onDidSelectItem(C[B])}),d.$setItems(v,L),T.then(B=>{if(typeof B=="number")return C[B];if(Array.isArray(B))return B.map(F=>C[F])})})}).then(void 0,x=>{if(!(0,b.isCancellationError)(x))return d.$setError(v,x),Promise.reject(x)})}$onItemSelected(s){this._onDidSelectItem?.(s)}showInput(s,t=a.CancellationToken.None){return this._validateInput=s?.validateInput,d.$input(s,typeof this._validateInput=="function",t).then(void 0,c=>{if(!(0,b.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(s){if(!this._validateInput)return;const t=await this._validateInput(s);if(!t||typeof t=="string")return t;let c;switch(t.severity){case A.InputBoxValidationSeverity.Info:c=R.default.Info;break;case A.InputBoxValidationSeverity.Warning:c=R.default.Warning;break;case A.InputBoxValidationSeverity.Error:c=R.default.Error;break;default:c=t.message?R.default.Error:R.default.Ignore;break}return{content:t.message,severity:c}}async showWorkspaceFolderPick(s,t=a.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!c)return;const _=await this._workspace.getWorkspaceFolders2();if(!!_)return _.find(v=>v.uri.toString()===c.uri.toString())}createQuickPick(s){const t=new u(s,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}createInputBox(s){const t=new n(s,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(s,t){this._sessions.get(s)?._fireDidChangeValue(t)}$onDidAccept(s){this._sessions.get(s)?._fireDidAccept()}$onDidChangeActive(s,t){const c=this._sessions.get(s);c instanceof u&&c._fireDidChangeActive(t)}$onDidChangeSelection(s,t){const c=this._sessions.get(s);c instanceof u&&c._fireDidChangeSelection(t)}$onDidTriggerButton(s,t){this._sessions.get(s)?._fireDidTriggerButton(t)}$onDidTriggerItemButton(s,t,c){const _=this._sessions.get(s);_ instanceof u&&_._fireDidTriggerItemButton(t,c)}$onDidHide(s){this._sessions.get(s)?._fireDidHide()}}class g{constructor(s,t){this._extensionId=s,this._onDidDispose=t,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new p.Emitter,this._onDidChangeValueEmitter=new p.Emitter,this._onDidTriggerButtonEmitter=new p.Emitter,this._onDidHideEmitter=new p.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((t,c)=>{const _=t===A.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(_,t)}),this.update({buttons:s.map((t,c)=>({...i(t),tooltip:t.tooltip,handle:t===A.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const t=this._handlesToButtons.get(s);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,w.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),d.$dispose(this._id))}update(s){if(!this._disposed){for(const t of Object.keys(s)){const c=s[t];this._pendingUpdate[t]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){d.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}g._nextId=1;function E(r){if(r instanceof A.ThemeIcon)return{id:r.id};const s=D(r),t=l(r);return{dark:typeof s=="string"?y.URI.file(s):s,light:typeof t=="string"?y.URI.file(t):t}}function l(r){return typeof r=="object"&&"light"in r?r.light:r}function D(r){return typeof r=="object"&&"dark"in r?r.dark:r}function i(r){const s=E(r.iconPath);let t,c;return"id"in s?c=S.ThemeIcon.asClassName(s):t=s,{iconPath:t,iconClass:c}}class u extends g{constructor(s,t){super(s.identifier,t),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new p.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new p.Emitter,this._onDidTriggerItemButtonEmitter=new p.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((c,_)=>{this._handlesToItems.set(_,c),this._itemsToHandles.set(c,_)});const t=[];for(let c=0;c<s.length;c++){const _=s[c];_.kind===A.QuickPickItemKind.Separator?t.push({type:"separator",label:_.label}):t.push({handle:c,label:_.label,description:_.description,detail:_.detail,picked:_.picked,alwaysShow:_.alwaysShow,buttons:_.buttons?.map((v,T)=>({...i(v),tooltip:v.tooltip,handle:T}))})}this.update({items:t})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(s){this._keepScrollPosition=s,this.update({keepScrollPosition:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(t=>this._itemsToHandles.has(t)),this.update({activeItems:this._activeItems.map(t=>this._itemsToHandles.get(t))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(t=>this._itemsToHandles.has(t)),this.update({selectedItems:this._selectedItems.map(t=>this._itemsToHandles.get(t))})}_fireDidChangeActive(s){const t=(0,P.coalesce)(s.map(c=>this._handlesToItems.get(c)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(s){const t=(0,P.coalesce)(s.map(c=>this._handlesToItems.get(c)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}_fireDidTriggerItemButton(s,t){const c=this._handlesToItems.get(s);if(!c||!c.buttons||!c.buttons.length)return;const _=c.buttons[t];_&&this._onDidTriggerItemButtonEmitter.fire({button:_,item:c})}}class n extends g{constructor(s,t){super(s.identifier,t),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,s?typeof s=="string"?this.update({validationMessage:s,severity:R.default.Error}):this.update({validationMessage:s.message,severity:s.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new o(f,h)}e.createExtHostQuickOpen=m});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,p,w){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?w.call(ie,a):w?w.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!p:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ie):p?p.value:e.get(ie)};define(Ce[211],Ie([1,0,2,5,55,7,14,4,16,118,15,26,61,8,27]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f){"use strict";var h,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function o(_){if(_)return typeof _.iconPath=="string"?a.URI.file(_.iconPath):a.URI.isUri(_.iconPath)||m.ThemeIcon.isThemeIcon(_.iconPath)?_.iconPath:void 0}function g(_,v){if(!_.iconPath&&!v.iconPath)return 0;if(_.iconPath){if(!v.iconPath)return 1}else return-1;const T=typeof _.iconPath=="string"?_.iconPath:a.URI.isUri(_.iconPath)?_.iconPath.fsPath:_.iconPath.id,U=typeof v.iconPath=="string"?v.iconPath:a.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,P.comparePaths)(T,U)}function E(_,v){let T=0;if(_.strikeThrough!==v.strikeThrough)return _.strikeThrough?1:-1;if(_.faded!==v.faded)return _.faded?1:-1;if(_.tooltip!==v.tooltip)return(_.tooltip||"").localeCompare(v.tooltip||"");if(T=g(_,v),T!==0)return T;if(_.light&&v.light)T=g(_.light,v.light);else{if(_.light)return 1;if(v.light)return-1}if(T!==0)return T;if(_.dark&&v.dark)T=g(_.dark,v.dark);else{if(_.dark)return 1;if(v.dark)return-1}return T}function l(_,v){if(_.command!==v.command)return _.command<v.command?-1:1;if(_.title!==v.title)return _.title<v.title?-1:1;if(_.tooltip!==v.tooltip){if(_.tooltip!==void 0&&v.tooltip!==void 0)return _.tooltip<v.tooltip?-1:1;if(_.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(_.arguments===v.arguments)return 0;if(_.arguments)if(v.arguments){if(_.arguments.length!==v.arguments.length)return _.arguments.length-v.arguments.length}else return 1;else return-1;for(let T=0;T<_.arguments.length;T++){const U=_.arguments[T],V=v.arguments[T];if(U!==V)return U<V?-1:1}return 0}function D(_,v){let T=(0,P.comparePaths)(_.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(T!==0)return T;if(_.command&&v.command)T=l(_.command,v.command);else{if(_.command)return 1;if(v.command)return-1}if(T!==0)return T;if(_.decorations&&v.decorations)T=E(_.decorations,v.decorations);else{if(_.decorations)return 1;if(v.decorations)return-1}return T}function i(_,v){for(let T=0;T<_.length;T++)if(_[T]!==v[T])return!1;return!0}function u(_,v){return _.command===v.command&&_.title===v.title&&_.tooltip===v.tooltip&&(_.arguments&&v.arguments?i(_.arguments,v.arguments):_.arguments===v.arguments)}function n(_,v){return(0,b.equals)(_,v,u)}class r{constructor(v,T,U){this._extension=v,this._sourceControlHandle=U,h.set(this,void 0),this._value="",this._onDidChange=new p.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,h,T,"f")}get value(){return this._value}set value(v){v=v??"",Oe(this,h,"f").$setInputBoxValue(this._sourceControlHandle,v),this.updateValue(v)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(v){Oe(this,h,"f").$setInputBoxPlaceholder(this._sourceControlHandle,v),this._placeholder=v}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(v){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),v&&typeof v!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=v,Oe(this,h,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!v)}get enabled(){return this._enabled}set enabled(v){v=!!v,this._enabled!==v&&(this._enabled=v,Oe(this,h,"f").$setInputBoxEnablement(this._sourceControlHandle,v))}get visible(){return this._visible}set visible(v){v=!!v,this._visible!==v&&(this._visible=v,Oe(this,h,"f").$setInputBoxVisibility(this._sourceControlHandle,v))}showValidationMessage(v,T){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,h,"f").$showValidationMessage(this._sourceControlHandle,v,T)}$onInputBoxValueChange(v){this.updateValue(v)}updateValue(v){this._value=v,this._onDidChange.fire(v)}}e.ExtHostSCMInputBox=r,h=new WeakMap;class s{constructor(v,T,U,V,x){this._proxy=v,this._commands=T,this._sourceControlHandle=U,this._id=V,this._label=x,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new p.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new p.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=s._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(v){this._label=v,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,v)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(v){this._hideWhenEmpty=v,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(v){this._resourceStates=[...v],this._onDidUpdateResourceStates.fire()}getResourceState(v){return this._resourceStatesMap.get(v)}$executeResourceCommand(v,T){const U=this._resourceStatesCommandsMap.get(v);return U?(0,y.asPromise)(()=>this._commands.executeCommand(U.command,...U.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this._resourceStates].sort(D),U=(0,b.sortedDiff)(this._resourceSnapshot,v,D).map(C=>{const L=C.toInsert.map(B=>{const F=this._resourceHandlePool++;this._resourceStatesMap.set(F,B);const K=B.resourceUri;let H;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const ve=new M.DisposableStore;H=this._commands.converter.toInternal(B.command,ve),this._resourceStatesDisposablesMap.set(F,ve)}else this._resourceStatesCommandsMap.set(F,B.command);const O=o(B.decorations),ee=B.decorations&&o(B.decorations.light)||O,ue=B.decorations&&o(B.decorations.dark)||O,oe=[ee,ue],le=B.decorations&&B.decorations.tooltip||"",te=B.decorations&&!!B.decorations.strikeThrough,Ee=B.decorations&&!!B.decorations.faded,be=B.contextValue||"";return{rawResource:[F,K,oe,le,te,Ee,be,H],handle:F}});return{start:C.start,deleteCount:C.deleteCount,toInsert:L}}),V=U.map(({start:C,deleteCount:L,toInsert:B})=>[C,L,B.map(F=>F.rawResource)]),x=U.reverse();for(const{start:C,deleteCount:L,toInsert:B}of x){const F=B.map(H=>H.handle),K=this._handlesSnapshot.splice(C,L,...F);for(const H of K)this._resourceStatesMap.delete(H),this._resourceStatesCommandsMap.delete(H),this._resourceStatesDisposablesMap.get(H)?.dispose(),this._resourceStatesDisposablesMap.delete(H)}return this._resourceSnapshot=v,V}dispose(){this._disposed=!0,this._onDidDispose.fire()}}s._handlePool=0;class t{constructor(v,T,U,V,x,C){this._extension=v,this._commands=U,this._id=V,this._label=x,this._rootUri=C,d.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new M.MutableDisposable,this._statusBarDisposables=new M.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new p.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,d,T,"f"),this._inputBox=new r(v,Oe(this,d,"f"),this.handle),Oe(this,d,"f").$registerSourceControl(this.handle,V,x,C)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(v){this._count!==v&&(this._count=v,Oe(this,d,"f").$updateSourceControl(this.handle,{count:v}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(v){this._quickDiffProvider=v,Oe(this,d,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!v})}get commitTemplate(){return this._commitTemplate}set commitTemplate(v){v!==this._commitTemplate&&(this._commitTemplate=v,Oe(this,d,"f").$updateSourceControl(this.handle,{commitTemplate:v}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(v){this._acceptInputDisposables.value=new M.DisposableStore,this._acceptInputCommand=v;const T=this._commands.converter.toInternal(v,this._acceptInputDisposables.value);Oe(this,d,"f").$updateSourceControl(this.handle,{acceptInputCommand:T})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(v){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new M.DisposableStore,this._actionButton=v;const T=v!==void 0?{command:this._commands.converter.toInternal(v.command,this._actionButtonDisposables.value),secondaryCommands:v.secondaryCommands?.map(U=>U.map(V=>this._commands.converter.toInternal(V,this._actionButtonDisposables.value))),description:v.description,enabled:v.enabled}:void 0;Oe(this,d,"f").$updateSourceControl(this.handle,{actionButton:T??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(v){if(this._statusBarCommands&&v&&n(this._statusBarCommands,v))return;this._statusBarDisposables.value=new M.DisposableStore,this._statusBarCommands=v;const T=(v||[]).map(U=>this._commands.converter.toInternal(U,this._statusBarDisposables.value));Oe(this,d,"f").$updateSourceControl(this.handle,{statusBarCommands:T})}get selected(){return this._selected}createResourceGroup(v,T){const U=new s(Oe(this,d,"f"),this._commands,this.handle,v,T),V=p.Event.once(U.onDidDispose)(()=>this.createdResourceGroups.delete(U));return this.createdResourceGroups.set(U,V),this.eventuallyAddResourceGroups(),U}eventuallyAddResourceGroups(){const v=[],T=[];for(const[U,V]of this.createdResourceGroups){V.dispose();const x=U.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(U),this.eventuallyUpdateResourceStates()});p.Event.once(U.onDidDispose)(()=>{this.updatedResourceGroups.delete(U),x.dispose(),this._groups.delete(U.handle),Oe(this,d,"f").$unregisterGroup(this.handle,U.handle)}),v.push([U.handle,U.id,U.label,U.features]);const C=U._takeResourceStateSnapshot();C.length>0&&T.push([U.handle,C]),this._groups.set(U.handle,U)}Oe(this,d,"f").$registerGroups(this.handle,v,T),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const v=[];this.updatedResourceGroups.forEach(T=>{const U=T._takeResourceStateSnapshot();U.length!==0&&v.push([T.handle,U])}),v.length>0&&Oe(this,d,"f").$spliceResourceStates(this.handle,v),this.updatedResourceGroups.clear()}getResourceGroup(v){return this._groups.get(v)}setSelectionState(v){this._selected=v,this._onDidChangeSelection.fire(v)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(v=>v.dispose()),Oe(this,d,"f").$unregisterSourceControl(this.handle)}}d=new WeakMap,t._handlePool=0,ze([(0,w.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),ze([(0,w.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let c=class Qi{constructor(v,T,U){this._commands=T,this.logService=U,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new p.Emitter,this._proxy=v.getProxy(A.MainContext.MainThreadSCM),this._telemetry=v.getProxy(A.MainContext.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===3){const x=this._sourceControls.get(V.sourceControlHandle);if(!x)return V;const C=x.getResourceGroup(V.groupHandle);return C?C.getResourceState(V.handle):V}else if(V&&V.$mid===4){const x=this._sourceControls.get(V.sourceControlHandle);return x?x.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===5){const x=this._sourceControls.get(V.handle);return x||V}return V}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(v,T,U,V){this.logService.trace("ExtHostSCM#createSourceControl",v.identifier.value,T,U,V),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const x=Qi._handlePool++,C=new t(v,this._proxy,this._commands,T,U,V);this._sourceControls.set(x,C);const L=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(v.identifier))||[];return L.push(C),this._sourceControlsByExtension.set(S.ExtensionIdentifier.toKey(v.identifier),L),C}getLastInputBox(v){this.logService.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const T=this._sourceControlsByExtension.get(S.ExtensionIdentifier.toKey(v.identifier)),U=T&&T[T.length-1];return U&&U.inputBox}$provideOriginalResource(v,T,U){const V=a.URI.revive(T);this.logService.trace("ExtHostSCM#$provideOriginalResource",v,V.toString());const x=this._sourceControls.get(v);return!x||!x.quickDiffProvider||!x.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>x.quickDiffProvider.provideOriginalResource(V,U)).then(C=>C||null)}$onInputBoxValueChange(v,T){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",v);const U=this._sourceControls.get(v);return U&&U.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(v,T,U,V){this.logService.trace("ExtHostSCM#$executeResourceCommand",v,T,U);const x=this._sourceControls.get(v);if(!x)return Promise.resolve(void 0);const C=x.getResourceGroup(T);return C?C.$executeResourceCommand(U,V):Promise.resolve(void 0)}$validateInput(v,T,U){this.logService.trace("ExtHostSCM#$validateInput",v);const V=this._sourceControls.get(v);return!V||!V.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>V.inputBox.validateInput(T,U)).then(x=>{if(!x)return Promise.resolve(void 0);const C=k.MarkdownString.fromStrict(x.message);return C?Promise.resolve([C,x.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this._sourceControls.get(v)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=v,Promise.resolve(void 0)}};c._handlePool=0,c=ze([$e(2,R.ILogService)],c),e.ExtHostSCM=c}),define(Ce[68],Ie([1,0,4,5,3]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(A){this._onDidChangePassword=new p.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,b){return this._proxy.$getPassword(A,b)}store(A,b,P){return this._proxy.$setPassword(A,b,P)}delete(A,b){return this._proxy.$deletePassword(A,b)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,w.createDecorator)("IExtHostSecretState")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,p,w){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?w.call(ie,a):w?w.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!p:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ie):p?p.value:e.get(ie)};define(Ce[212],Ie([1,0,6,4,133,7,8,10]),function(ie,e,a,p,w,M,y,A){"use strict";var b,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(f,h,d,o,g=a.StatusBarAlignment.Left,E){b.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new M.DisposableStore,Je(this,b,f,"f"),Je(this,P,h,"f"),this._entryId=R.ID_GEN++,this._extension=d,this._id=o,this._alignment=g,this._priority=this.validatePriority(E)}validatePriority(f){if(!!(0,A.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!R.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Oe(this,P,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Oe(this,P,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,b,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let h;this._name?h=this._name:h=(0,w.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const o=y.MarkdownString.fromStrict(this._tooltip);Oe(this,b,"f").$setEntry(this._entryId,f,h,this._text,o,this._command?.internal,d,this._backgroundColor,this._alignment===a.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,b=new WeakMap,P=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]);class S{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,w.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const h={message:f};return this._messages.unshift(h),this._update(),new a.Disposable(()=>{const d=this._messages.indexOf(h);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class m{constructor(f,h){this._proxy=f.getProxy(p.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new S(this)}createStatusBarEntry(f,h,d,o){return new R(this._proxy,this._commands,f,h,d,o)}setStatusBarMessage(f,h){const d=this._statusMessage.setMessage(f);let o;return typeof h=="number"?o=setTimeout(()=>d.dispose(),h):typeof h<"u"&&h.then(()=>d.dispose(),()=>d.dispose()),new a.Disposable(()=>{d.dispose(),clearTimeout(o)})}}e.ExtHostStatusBar=m}),define(Ce[69],Ie([1,0,4,5,3]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(A){this._onDidChangeStorage=new p.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,b){this._proxy.$registerExtensionStorageKeysToSync(A,b)}initializeExtensionStorage(A,b,P){return this._proxy.$initializeExtensionStorage(A,b).then(R=>R||P)}setValue(A,b,P){return this._proxy.$setValue(A,b,P)}$acceptValue(A,b,P){this._onDidChangeStorage.fire({shared:A,key:b,value:P})}}e.ExtHostStorage=M,e.IExtHostStorage=(0,w.createDecorator)("IExtHostStorage")}),define(Ce[70],Ie([1,0,3,28,15,52,2]),function(ie,e,a,p,w,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let A=class{constructor(P,R,S){this._logService=R,this._extHostFileSystem=S,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getWorkspaceStorageURI(P){return y.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,R=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:y.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(S){this._logService.error("[ExtHostStorage]",S);return}}workspaceValue(P){if(this._value)return y.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return y.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=ze([$e(0,p.IExtHostInitDataService),$e(1,w.ILogService),$e(2,M.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(Ce[98],Ie([1,0,3,4,13]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTelemetryLogService=e.IExtHostTelemetryLogService=void 0,e.IExtHostTelemetryLogService=(0,a.createDecorator)("IExtHostTelemetryLogService");let M=class{constructor(A){this._telemetryShape=A.getProxy(p.MainContext.MainThreadTelemetry)}logToTelemetryOutputChannel(A,b,P){this._telemetryShape.$logTelemetryToOutputChannel(`${A.identifier.value}/${b}`,P)}};M=ze([$e(0,w.IExtHostRpcService)],M),e.ExtHostTelemetryLogService=M}),define(Ce[53],Ie([1,0,5,4,3,2,13,7,6,134,11,169,20,42,154,61,10,14]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f,h,d,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,w.createDecorator)("IExtHostTerminalService");class g{constructor(t,c,_,v){this._proxy=t,this._id=c,this._creationOptions=_,this._name=v,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(U=>this._pidPromiseComplete=U);const T=this;this.value={get name(){return T._name||""},get processId(){return T._pidPromise},get creationOptions(){return T._creationOptions},get exitStatus(){return T._exitStatus},get state(){return T._state},sendText(U,V=!0){T._checkDisposed(),T._proxy.$sendText(T._id,U,V)},show(U){T._checkDisposed(),T._proxy.$show(T._id,U)},hide(){T._checkDisposed(),T._proxy.$hide(T._id)},dispose(){T._disposed||(T._disposed=!0,T._proxy.$dispose(T._id))},get dimensions(){if(!(T._cols===void 0||T._rows===void 0))return{columns:T._cols,rows:T._rows}}}}async create(t,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,d.withNullAsUndefined)(t.shellPath),shellArgs:(0,d.withNullAsUndefined)(t.shellArgs),cwd:(0,d.withNullAsUndefined)(t.cwd),env:(0,d.withNullAsUndefined)(t.env),icon:(0,d.withNullAsUndefined)(n(t.iconPath)),color:h.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,d.withNullAsUndefined)(t.message),strictEnv:(0,d.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(t.location,c?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,c,_,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:_,color:h.ThemeColor.isThemeColor(v)?v.id:void 0,location:this._serializeParentTerminal(t,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,c){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitStatus(t,c){this._exitStatus=Object.freeze({code:t,reason:c})}setDimensions(t,c){return t===this._cols&&c===this._rows||t===0||c===0?!1:(this._cols=t,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=g;class E{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new a.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new a.Emitter,this._onDidChangeProperty=new a.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new a.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,c){this._pty.setDimensions?.({columns:t,rows:c})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let l=1,D=class extends A.Disposable{constructor(t,c){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new a.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new a.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new a.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new a.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new a.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(p.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new a.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[_,v]of this._terminalProcesses)v.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,c){const _=new g(this._proxy,(0,k.generateUuid)(),t,t.name),v=new E(t.pty);return _.createExtensionTerminal(t.location,this._serializeParentTerminal(t,c).resolvedExtHostIdentifier,n(t.iconPath),r(t.color)).then(T=>{const U=this._setupExtHostProcessListeners(T,v);this._terminalProcessDisposables[T]=U}),this._terminals.push(_),_.value}_serializeParentTerminal(t,c){if(c=c||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const _=t.location.parentTerminal;if(_){const v=this._terminals.find(T=>T.value===_);v&&(c.resolvedExtHostIdentifier=v._id)}}else t.location&&typeof t.location!="object"?c.location=t.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(t,c){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const v=new E(c),T=this._setupExtHostProcessListeners(t,v);this._terminalProcessDisposables[t]=T}async $acceptActiveTerminalChanged(t){const c=this._activeTerminal;if(t===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const _=this._getTerminalById(t);_&&(this._activeTerminal=_,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,c){const _=this._getTerminalById(t);_&&this._onDidWriteTerminalData.fire({terminal:_.value,data:c})}async $acceptTerminalDimensions(t,c,_){const v=this._getTerminalById(t);v&&v.setDimensions(c,_)&&this._onDidChangeTerminalDimensions.fire({terminal:v.value,dimensions:v.value.dimensions})}async $acceptTerminalMaximumDimensions(t,c,_){this._terminalProcesses.get(t)?.resize(c,_)}async $acceptTerminalTitleChange(t,c){const _=this._getTerminalById(t);_&&(_.name=c)}async $acceptTerminalClosed(t,c,_){const v=this._getTerminalObjectIndexById(this._terminals,t);if(v!==null){const T=this._terminals.splice(v,1)[0];T.setExitStatus(c,_),this._onDidCloseTerminal.fire(T.value)}}$acceptTerminalOpened(t,c,_,v){if(c){const V=this._getTerminalObjectIndexById(this._terminals,c);if(V!==null){this._terminals[V]._id=t,this._onDidOpenTerminal.fire(this.terminals[V]),this._terminals[V].isOpen=!0;return}}const T={name:v.name,shellPath:v.executable,shellArgs:v.args,cwd:typeof v.cwd=="string"?v.cwd:M.URI.revive(v.cwd),env:v.env,hideFromUser:v.hideFromUser},U=new g(this._proxy,t,T,_);this._terminals.push(U),this._onDidOpenTerminal.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(t,c){this._getTerminalById(t)?._setProcessId(c)}async $startExtensionTerminal(t,c){const _=this._getTerminalById(t);if(!_)return{message:(0,P.localize)(0,null,t)};_.isOpen||await new Promise(T=>{const U=this.onDidOpenTerminal(async V=>{V===_.value&&(U.dispose(),T())})});const v=this._terminalProcesses.get(t);v?v.startSendingEvents(c):this._extensionTerminalAwaitingStart[t]={initialDimensions:c}}_setupExtHostProcessListeners(t,c){const _=new A.DisposableStore;_.add(c.onProcessReady(T=>this._proxy.$sendProcessReady(t,T.pid,T.cwd))),_.add(c.onDidChangeProperty(T=>this._proxy.$sendProcessProperty(t,T))),this._bufferer.startBuffering(t,c.onProcessData),_.add(c.onProcessExit(T=>this._onProcessExit(t,T))),this._terminalProcesses.set(t,c);const v=this._extensionTerminalAwaitingStart[t];return v&&c instanceof E&&(c.startSendingEvents(v.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),_}$acceptProcessAckDataEvent(t,c){this._terminalProcesses.get(t)?.acknowledgeDataEvent(c)}$acceptProcessInput(t,c){this._terminalProcesses.get(t)?.input(c)}$acceptTerminalInteraction(t){const c=this._getTerminalById(t);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(t,c,_){try{this._terminalProcesses.get(t)?.resize(c,_)}catch(v){if(v.code!=="EPIPE"&&v.code!=="ERR_IPC_CHANNEL_CLOSED")throw v}}$acceptProcessShutdown(t,c){this._terminalProcesses.get(t)?.shutdown(c)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:c}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new b.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,c,_){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,_),this._proxy.$registerProfileProvider(c,t.identifier.value),new b.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(t,c){const _=new m.CancellationTokenSource().token;let v=await this._profileProviders.get(t)?.provideTerminalProfile(_);if(!_.isCancellationRequested){if(v&&!("options"in v)&&(v={options:v}),!v||!("options"in v))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in v.options){this.createExtensionTerminal(v.options,c);return}this.createTerminalFromOptions(v.options,c)}}async $provideLinks(t,c){const _=this._getTerminalById(t);if(!_)return[];this._terminalLinkCache.delete(t),this._terminalLinkCancellationSource.get(t)?.dispose(!0);const T=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,T);const U=[],V={terminal:_.value,line:c},x=[];for(const B of this._linkProviders)x.push(o.Promises.withAsyncBody(async F=>{T.token.onCancellationRequested(()=>F({provider:B,links:[]}));const K=await B.provideTerminalLinks(V,T.token)||[];T.token.isCancellationRequested||F({provider:B,links:K})}));const C=await Promise.all(x);if(T.token.isCancellationRequested)return[];const L=new Map;for(const B of C)B&&B.links.length>0&&U.push(...B.links.map(F=>{const K={id:l++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return L.set(K.id,{provider:B.provider,link:F}),K}));return this._terminalLinkCache.set(t,L),U}$activateLink(t,c){const _=this._terminalLinkCache.get(t)?.get(c);!_||_.provider.handleTerminalLink(_.link)}_onProcessExit(t,c){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const _=this._terminalProcessDisposables[t];_&&(_.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,c)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,c){const _=this._getTerminalObjectIndexById(t,c);return _!==null?t[_]:null}_getTerminalObjectIndexById(t,c){let _=null;return t.some((v,T)=>v._id===c?(_=T,!0):!1),_}getEnvironmentVariableCollection(t){let c=this._environmentVariableCollections.get(t.identifier.value);return c||(c=new i,this._setEnvironmentVariableCollection(t.identifier.value,c)),c}_syncEnvironmentVariableCollection(t,c){const _=(0,S.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(t,c.persistent,_.length===0?void 0:_)}$initEnvironmentVariableCollections(t){t.forEach(c=>{const _=c[0],v=new i(c[1]);this._setEnvironmentVariableCollection(_,v)})}$acceptDefaultProfile(t,c){this._defaultProfile=t,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(t,c){this._environmentVariableCollections.set(t,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,c)})}};D=ze([$e(1,y.IExtHostRpcService)],D),e.BaseExtHostTerminalService=D;class i{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new a.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,c){this._setIfDiffers(t,{value:c,type:b.EnvironmentVariableMutatorType.Replace})}append(t,c){this._setIfDiffers(t,{value:c,type:b.EnvironmentVariableMutatorType.Append})}prepend(t,c){this._setIfDiffers(t,{value:c,type:b.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,c){const _=this.map.get(t);(!_||_.value!==c.value||_.type!==c.type)&&(this.map.set(t,c),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,c){this.map.forEach((_,v)=>t.call(c,v,_,this))}[Symbol.iterator](){return this.map.entries()}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=i;let u=class extends D{constructor(t){super(!1,t)}createTerminal(t,c,_){throw new R.NotSupportedError}createTerminalFromOptions(t,c){throw new R.NotSupportedError}};u=ze([$e(0,y.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u;function n(s){if(!(!s||typeof s=="string"))return"id"in s?{id:s.id,color:s.color}:s}function r(s){return h.ThemeColor.isThemeColor(s)?s:void 0}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,p,w){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?w.call(ie,a):w?w.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!p:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ie):p?p.value:e.get(ie)};define(Ce[213],Ie([1,0,16,23,20,5,173,97,7,25,10,42,4,13,93,8,6,47,65,48]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f,h,d,o,g,E){"use strict";var l,D;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let i=class{constructor(x,C,L){this.editors=L,this.resultsChangedEmitter=new M.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=x.getProxy(m.MainContext.MainThreadTesting),this.observer=new v(this.proxy),this.runTracker=new n(this.proxy),C.registerArgumentProcessor({processArgument:B=>B?.$mid===13?(0,f.toItemFromContext)(B):B})}createTestController(x,C,L){if(this.controllers.has(x))throw new Error(`Attempt to insert a duplicate controller with ID "${x}"`);const B=new b.DisposableStore,F=B.add(new f.ExtHostTestItemCollection(x,C,this.editors));F.root.label=C;const K=new Map,H=this.proxy,O={items:F.root.children,get label(){return C},set label(ue){C=ue,F.root.label=ue,H.$updateController(x,{label:C})},get refreshHandler(){return L},set refreshHandler(ue){L=ue,H.$updateController(x,{canRefresh:!!ue})},get id(){return x},createRunProfile:(ue,oe,le,te,Ee)=>{let be=(0,A.hash)(ue);for(;K.has(be);)be++;return new T(this.proxy,K,x,be,ue,oe,le,te,Ee)},createTestItem(ue,oe,le){return new f.TestItemImpl(x,ue,oe,le)},createTestRun:(ue,oe,le=!0)=>this.runTracker.createTestRun(x,F,ue,oe,le),set resolveHandler(ue){F.resolveHandler=ue},get resolveHandler(){return F.resolveHandler},dispose:()=>{B.dispose()}};H.$registerTestController(x,C,!!L),B.add((0,b.toDisposable)(()=>H.$unregisterTestController(x)));const ee={controller:O,collection:F,profiles:K};return this.controllers.set(x,ee),B.add((0,b.toDisposable)(()=>this.controllers.delete(x))),B.add(F.onDidGenerateDiff(ue=>H.$publishDiff(x,ue.map(E.TestsDiffOp.serialize)))),O}createTestObserver(){return this.observer.checkout()}async runTests(x,C=w.CancellationToken.None){const L=r(x);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.controllers.get(L.controllerId);if(!B)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:x.include?.map(F=>o.TestId.fromExtHostTestItem(F,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:U[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:x.exclude?.map(F=>F.id)},C)}$provideFileCoverage(x,C,L){return(0,a.mapFind)(this.runTracker.trackers,F=>F.id===x?F.getCoverage(C):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(x,C,L,B){return(0,a.mapFind)(this.runTracker.trackers,K=>K.id===x?K.getCoverage(C):void 0)?.resolveFileCoverage(L,B)??Promise.resolve([])}$configureRunProfile(x,C){this.controllers.get(x)?.profiles.get(C)?.configureHandler?.()}async $refreshTests(x,C){await this.controllers.get(x)?.controller.refreshHandler?.(C)}$publishTestResults(x){this.results=Object.freeze(x.map(C=>(0,P.deepFreeze)(h.TestResults.to(C))).concat(this.results).sort((C,L)=>L.completedAt-C.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(x,C){const L=this.controllers.get(o.TestId.fromString(x).controllerId)?.collection;L&&(await L.expand(x,C<0?1/0:C),L.flushDiff())}$acceptDiff(x){this.observer.applyDiff(x.map(E.TestsDiffOp.deserialize))}async $runControllerTests(x,C){return Promise.all(x.map(L=>this.runControllerTestRequest(L,C)))}async runControllerTestRequest(x,C){const L=this.controllers.get(x.controllerId);if(!L)return{};const{collection:B,profiles:F}=L,K=F.get(x.profileId);if(!K)return{};const H=x.testIds.map(oe=>B.tree.get(oe)).filter(R.isDefined),O=x.excludeExtIds.map(oe=>L.collection.tree.get(oe)).filter(R.isDefined).filter(oe=>H.some(le=>le.fullId.compare(oe.fullId)===2));if(!H.length)return{};const ee=new d.TestRunRequest(H.some(oe=>oe.actual instanceof f.TestItemRootImpl)?void 0:H.map(oe=>oe.actual),O.map(oe=>oe.actual),K),ue=this.runTracker.prepareForMainThreadTestRun(ee,s.fromInternal(x,L.collection),C);try{return await K.runHandler(ee,C),{}}catch(oe){return{error:String(oe)}}finally{ue.isRunning&&!C.isCancellationRequested&&await M.Event.toPromise(ue.onEnd),ue.dispose()}}$cancelExtensionTestRun(x){x===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(x)}};i=ze([$e(0,k.IExtHostRpcService)],i),e.ExtHostTesting=i;class u extends b.Disposable{constructor(x,C,L){super(),this.dto=x,this.proxy=C,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new M.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new w.CancellationTokenSource(L)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:B}of this.tasks.values())B.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(x){return this.tasks.get(x)?.coverage}createRun(x){const C=this.dto.id,L=this.dto.controllerId,B=(0,S.generateUuid)(),F=new t(this.proxy,C,B),K=ue=>(oe,...le)=>{if(O){console.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(oe)||(this.ensureTestIsKnown(oe),ue(oe,...le))},H=(ue,oe)=>{const le=oe instanceof Array?oe.map(h.TestMessage.from):[h.TestMessage.from(oe)];if(ue.uri&&ue.range){const te={range:h.Range.from(ue.range),uri:ue.uri};for(const Ee of le)Ee.location=Ee.location||te}this.proxy.$appendTestMessagesInRun(C,B,o.TestId.fromExtHostTestItem(ue,L).toString(),le)};let O=!1;const ee={isPersisted:this.dto.isPersisted,token:this.cts.token,name:x,get coverageProvider(){return F.coverageProvider},set coverageProvider(ue){F.coverageProvider=ue},enqueued:K(ue=>{this.proxy.$updateTestStateInRun(C,B,o.TestId.fromExtHostTestItem(ue,L).toString(),1)}),skipped:K(ue=>{this.proxy.$updateTestStateInRun(C,B,o.TestId.fromExtHostTestItem(ue,L).toString(),5)}),started:K(ue=>{this.proxy.$updateTestStateInRun(C,B,o.TestId.fromExtHostTestItem(ue,L).toString(),2)}),errored:K((ue,oe,le)=>{H(ue,oe),this.proxy.$updateTestStateInRun(C,B,o.TestId.fromExtHostTestItem(ue,L).toString(),6,le)}),failed:K((ue,oe,le)=>{H(ue,oe),this.proxy.$updateTestStateInRun(C,B,o.TestId.fromExtHostTestItem(ue,L).toString(),4,le)}),passed:K((ue,oe)=>{this.proxy.$updateTestStateInRun(C,B,o.TestId.fromExtHostTestItem(ue,this.dto.controllerId).toString(),3,oe)}),appendOutput:(ue,oe,le)=>{O||(le&&(this.dto.isIncluded(le)?this.ensureTestIsKnown(le):le=void 0),this.proxy.$appendOutputToRun(C,B,p.VSBuffer.fromString(ue),oe&&h.location.from(oe),le&&o.TestId.fromExtHostTestItem(le,L).toString()))},end:()=>{O||(O=!0,this.proxy.$finishedTestRunTask(C,B),this.tasks.delete(B),this.isRunning||this.dispose())}};return this.tasks.set(B,{run:ee,coverage:F}),this.proxy.$startedTestRunTask(C,{id:B,name:x,running:!0}),ee}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(x){if(!(x instanceof f.TestItemImpl))throw new g.InvalidTestItemError(x.id);if(this.sharedTestIds.has(o.TestId.fromExtHostTestItem(x,this.dto.controllerId).toString()))return;const C=[],L=this.dto.colllection.root;for(;;){const B=h.TestItem.from(x);if(C.unshift(B),this.sharedTestIds.has(B.extId)||(this.sharedTestIds.add(B.extId),x===L))break;x=x.parent||L}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,C)}}class n{constructor(x){this.proxy=x,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(x,C,L){return this.getTracker(x,C,L)}cancelRunById(x){for(const C of this.tracked.values())if(C.id===x){C.dispose();return}}cancelAllRuns(){for(const x of this.tracked.values())x.dispose()}createTestRun(x,C,L,B,F){const K=this.tracked.get(L);if(K)return K.createRun(B);const H=s.fromPublic(x,C,L,F),O=r(L);this.proxy.$startedExtensionTestRun({controllerId:x,profile:O&&{group:U[O.kind],id:O.profileId},exclude:L.exclude?.map(ue=>o.TestId.fromExtHostTestItem(ue,C.root.id).toString())??[],id:H.id,include:L.include?.map(ue=>o.TestId.fromExtHostTestItem(ue,C.root.id).toString())??[C.root.id],persist:F});const ee=this.getTracker(L,H);return ee.onEnd(()=>this.proxy.$finishedExtensionTestRun(H.id)),ee.createRun(B)}getTracker(x,C,L){const B=new u(C,this.proxy,L);return this.tracked.set(x,B),B.onEnd(()=>this.tracked.delete(x)),B}}e.TestRunCoordinator=n;const r=V=>{if(!!V.profile){if(!(V.profile instanceof T))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class s{constructor(x,C,L,B,F,K){this.controllerId=x,this.id=C,this.isPersisted=F,this.colllection=K,this.includePrefix=L.map(H=>H+"\0"),this.excludePrefix=B.map(H=>H+"\0")}static fromPublic(x,C,L,B){return new s(x,(0,S.generateUuid)(),L.include?.map(F=>o.TestId.fromExtHostTestItem(F,x).toString())??[x],L.exclude?.map(F=>o.TestId.fromExtHostTestItem(F,x).toString())??[],B,C)}static fromInternal(x,C){return new s(x.controllerId,x.runId,x.testIds,x.excludeExtIds,!0,C)}isIncluded(x){const C=o.TestId.fromExtHostTestItem(x,this.controllerId).toString()+"\0";for(const L of this.excludePrefix)if(C===L||C.startsWith(L))return!1;for(const L of this.includePrefix)if(C===L||C.startsWith(L))return!0;return!1}}e.TestRunDto=s;class t{constructor(x,C,L){this.proxy=x,this.runId=C,this.taskId=L}set coverageProvider(x){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!x||(this._coverageProvider=x,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(x){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(x))());try{return(await this.fileCoverage)?.map(h.TestCoverage.fromFile)??[]}catch(C){throw this.fileCoverage=void 0,C}}async resolveFileCoverage(x,C){const L=await this.fileCoverage;let B=L?.[x];return!this._coverageProvider||!L||!B?[]:(B.detailedCoverage||(B=L[x]=await this._coverageProvider.resolveFileCoverage?.(B,C)??B),B.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class c extends E.IncrementalChangeCollector{constructor(x){super(),this.emitter=x,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(x){this.added.add(x)}update(x){Object.assign(x.revived,h.TestItem.toPlain(x.item)),this.added.has(x)||this.updated.add(x)}remove(x){if(this.added.has(x)){this.added.delete(x);return}if(this.updated.delete(x),x.parent&&this.alreadyRemoved.has(x.parent)){this.alreadyRemoved.add(x.item.extId);return}this.removed.add(x)}getChangeEvent(){const{added:x,updated:C,removed:L}=this;return{get added(){return[...x].map(B=>B.revived)},get updated(){return[...C].map(B=>B.revived)},get removed(){return[...L].map(B=>B.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class _ extends E.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new M.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(x){return this.items.get(x)}getMirroredTestDataByReference(x){return this.items.get(x.id)}createItem(x,C){return{...x,revived:h.TestItem.toPlain(x.item),depth:C?C.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=_;class v{constructor(x){this.proxy=x}checkout(){this.current||(this.current=this.createObserverData());const x=this.current;return x.observers++,{onDidChangeTest:x.tests.onDidChangeTests,get tests(){return[...x.tests.rootTests].map(C=>C.revived)},dispose:(0,y.once)(()=>{--x.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(x){return this.current?.tests.getMirroredTestDataByReference(x)}applyDiff(x){this.current?.tests.apply(x)}createObserverData(){const x=new _;return this.proxy.$subscribeToDiffs(),{observers:0,tests:x}}}class T{constructor(x,C,L,B,F,K,H,O=!1,ee=void 0){this.controllerId=L,this.profileId=B,this._label=F,this.kind=K,this.runHandler=H,this._isDefault=O,this._tag=ee,l.set(this,void 0),D.set(this,void 0),Je(this,l,x,"f"),Je(this,D,C,"f"),C.set(B,this);const ue=U[K];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Oe(this,l,"f").$publishTestRunProfile({profileId:B,controllerId:L,tag:ee?h.TestTag.namespace(this.controllerId,ee.id):null,label:F,group:ue,isDefault:O,hasConfigurationHandler:!1})}get label(){return this._label}set label(x){x!==this._label&&(this._label=x,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:x}))}get isDefault(){return this._isDefault}set isDefault(x){x!==this._isDefault&&(this._isDefault=x,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:x}))}get tag(){return this._tag}set tag(x){x?.id!==this._tag?.id&&(this._tag=x,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:x?h.TestTag.namespace(this.controllerId,x.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(x){x!==this._configureHandler&&(this._configureHandler=x,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!x}))}dispose(){Oe(this,D,"f")?.delete(this.profileId)&&(Je(this,D,void 0,"f"),Oe(this,l,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=T,l=new WeakMap,D=new WeakMap;const U={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(Ce[214],Ie([1,0,16,5,4,94,8,6]),function(ie,e,a,p,w,M,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class b{constructor(R,S){this._extHostDocumentsAndEditors=S,this._onDidChangeTextEditorSelection=new p.Emitter,this._onDidChangeTextEditorOptions=new p.Emitter,this._onDidChangeTextEditorVisibleRanges=new p.Emitter,this._onDidChangeTextEditorViewColumn=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(w.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const S=this._extHostDocumentsAndEditors.allEditors();return R?S:S.map(m=>m.value)}async showTextDocument(R,S,m){let k;typeof S=="number"?k={position:y.ViewColumn.from(S),preserveFocus:m}:typeof S=="object"?k={position:y.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?y.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:k={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(R.uri,k),h=f&&this._extHostDocumentsAndEditors.getEditor(f);if(h)return h.value;throw f?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,S){return new M.TextEditorDecorationType(this._proxy,R,S).value}$acceptEditorPropertiesChanged(R,S){const m=this._extHostDocumentsAndEditors.getEditor(R);if(!m)throw new Error("unknown text editor");if(S.options&&m._acceptOptions(S.options),S.selections){const k=S.selections.selections.map(y.Selection.to);m._acceptSelections(k)}if(S.visibleRanges){const k=a.coalesce(S.visibleRanges.map(y.Range.to));m._acceptVisibleRanges(k)}if(S.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:{...S.options,lineNumbers:y.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const k=A.TextEditorSelectionChangeKind.fromValue(S.selections.source),f=S.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:f,kind:k})}if(S.visibleRanges){const k=a.coalesce(S.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:k})}}$acceptEditorPositionData(R){for(const S in R){const m=this._extHostDocumentsAndEditors.getEditor(S);if(!m)throw new Error("Unknown text editor");const k=y.ViewColumn.to(R[S]);m.value.viewColumn!==k&&(m._acceptViewColumn(k),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:k}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=b}),define(Ce[215],Ie([1,0,2,3,4,7,6,8,10]),function(ie,e,a,p,w,M,y,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,p.createDecorator)("IExtHostTimeline");class P{constructor(m,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=m.getProxy(w.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===11){const h=f.uri===void 0?void 0:a.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(R(h))?.get(f.handle)}return f}})}async $getTimeline(m,k,f,h){return this._providers.get(m)?.provideTimeline(a.URI.revive(k),f,h)}registerTimelineProvider(m,k,f,h){const d=new M.DisposableStore,o=this.convertTimelineItem(k.id,h,d).bind(this);let g;k.onDidChange&&(g=k.onDidChange(l=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:k.id}),this));const E=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...k,scheme:m,onDidChange:void 0,async provideTimeline(l,D,i){D?.resetCache&&(d.clear(),E.get(k.id)?.clear());const u=await k.provideTimeline(l,D,i);if(u==null)return;const n=o(l,D);return{...u,source:k.id,items:u.items.map(n)}},dispose(){for(const l of E.values())l.get(k.id)?.clear();g?.dispose(),d.dispose()}})}convertTimelineItem(m,k,f){return(h,d)=>{let o;if(d?.cacheResults){let g=this._itemsBySourceAndUriMap.get(m);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(m,g));const E=R(h);o=g.get(E),o===void 0&&(o=new Map,g.set(E,o))}return g=>{const{iconPath:E,...l}=g,D=`${m}|${g.id??g.timestamp}`;o?.set(D,g);let i,u,n;g.iconPath&&(E instanceof y.ThemeIcon?n={id:E.id,color:E.color}:a.URI.isUri(E)?(i=E,u=E):{light:i,dark:u}=E);let r;return y.MarkdownString.isMarkdownString(l.tooltip)?r=A.MarkdownString.from(l.tooltip):(0,b.isString)(l.tooltip)?r=l.tooltip:y.MarkdownString.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=A.MarkdownString.from(l.detail)):(0,b.isString)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=l.detail),{...l,id:l.id??void 0,handle:D,source:m,command:g.command?k.toInternal(g.command,f):void 0,icon:i,iconDark:u,themeIcon:n,tooltip:r,accessibilityInformation:g.accessibilityInformation}}}}registerTimelineProviderCore(m){if(this._providers.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this._proxy.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this._providers.set(m.id,m),(0,M.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(m.id)?.clear();this._providers.delete(m.id),this._proxy.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=P;function R(S){return S?.toString()}}),define(Ce[216],Ie([1,0,7,12,2,4]),function(ie,e,a,p,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(b){this._openers=new Map,this._proxy=b.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(b,P,R,S){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const m=S.schemes.find(k=>!y.supportedSchemes.has(k));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,R),this._proxy.$registerUriOpener(P,S.schemes,b,S.label),(0,a.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(b,P,R){const S=this._openers.get(b);if(!S)throw new Error(`Unknown opener with id: ${b}`);const m=w.URI.revive(P);return S.canOpenExternalUri(m,R)}async $openUri(b,P,R){const S=this._openers.get(b);if(!S)throw new Error(`Unknown opener id: '${b}'`);return S.openExternalUri(w.URI.revive(P.resolvedUri),{sourceUri:w.URI.revive(P.sourceUri)},R)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([p.Schemas.http,p.Schemas.https])}),define(Ce[217],Ie([1,0,4,2,7,11,26]),function(ie,e,a,p,w,M,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(P,R){if(this.handles.has(y.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const S=A.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(P)),this.handlers.set(S,R),this._proxy.$registerUriHandler(S,P),(0,w.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(P)),this.handlers.delete(S),this._proxy.$unregisterUriHandler(S)})}$handleExternalUri(P,R){const S=this.handlers.get(P);if(!S)return Promise.resolve(void 0);try{S.handleUri(p.URI.revive(R))}catch(m){(0,M.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(P){return p.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=A,A.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,p,w){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?w.call(ie,a):w?w.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!p:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ie):p?p.value:e.get(ie)};define(Ce[54],Ie([1,0,5,12,2,145,162,64,4]),function(ie,e,a,p,w,M,y,A,b){"use strict";var P,R,S,m,k,f,h,d,o,g,E,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class D{constructor(_,v,T,U,V,x,C){P.set(this,void 0),R.set(this,void 0),S.set(this,void 0),m.set(this,void 0),k.set(this,void 0),f.set(this,void 0),h.set(this,""),d.set(this,void 0),o.set(this,!1),g.set(this,!1),E.set(this,!1),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new a.Emitter),this._onDidDispose=Oe(this,l,"f").event,Je(this,P,_,"f"),Je(this,R,v,"f"),Je(this,d,T,"f"),Je(this,m,U,"f"),Je(this,k,V,"f"),Je(this,f,x,"f"),Je(this,E,i(x),"f"),Je(this,S,C,"f")}dispose(){Je(this,o,!0,"f"),Oe(this,l,"f").fire(),Oe(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(_){return Je(this,g,!0,"f"),(0,A.asWebviewUri)(_,Oe(this,m,"f"))}get cspSource(){const _=Oe(this,f,"f").extensionLocation;if(_.scheme===p.Schemas.https||_.scheme===p.Schemas.http){let v=_.toString();return v.endsWith("/")||(v+="/"),v+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,h,"f")}set html(_){this.assertNotDisposed(),Oe(this,h,"f")!==_&&(Je(this,h,_,"f"),!Oe(this,g,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(_)&&(Je(this,g,!0,"f"),Oe(this,S,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,R,"f").$setHtml(Oe(this,P,"f"),_))}get options(){return this.assertNotDisposed(),Oe(this,d,"f")}set options(_){this.assertNotDisposed(),Oe(this,R,"f").$setOptions(Oe(this,P,"f"),r(Oe(this,f,"f"),Oe(this,k,"f"),_)),Je(this,d,_,"f")}async postMessage(_){if(Oe(this,o,"f"))return!1;const v=(0,y.serializeWebviewMessage)(_,{serializeBuffersForPostMessage:Oe(this,E,"f")});return Oe(this,R,"f").$postMessage(Oe(this,P,"f"),v.message,...v.buffers)}assertNotDisposed(){if(Oe(this,o,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=D,P=new WeakMap,R=new WeakMap,S=new WeakMap,m=new WeakMap,k=new WeakMap,f=new WeakMap,h=new WeakMap,d=new WeakMap,o=new WeakMap,g=new WeakMap,E=new WeakMap,l=new WeakMap;function i(c){try{const _=(0,M.normalizeVersion)((0,M.parseVersion)(c.engines.vscode));return!!_&&_.majorBase>=1&&_.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=i;class u{constructor(_,v,T,U,V){this.remoteInfo=v,this.workspace=T,this._logService=U,this._deprecationService=V,this._webviews=new Map,this._webviewProxy=_.getProxy(b.MainContext.MainThreadWebviews)}$onMessage(_,v,T){const U=this.getWebview(_);if(U){const{message:V}=(0,y.deserializeWebviewMessage)(v,T.value);U._onMessageEmitter.fire(V)}}$onMissingCsp(_,v){this._logService.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(_,v,T){const U=new D(_,this._webviewProxy,s(v),this.remoteInfo,this.workspace,T,this._deprecationService);return this._webviews.set(_,U),U._onDidDispose(()=>{this._webviews.delete(_)}),U}deleteWebview(_){this._webviews.delete(_)}getWebview(_){return this._webviews.get(_)}}e.ExtHostWebviews=u;function n(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=n;function r(c,_,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||t(c,_)}}e.serializeWebviewOptions=r;function s(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(_=>w.URI.from(_))}}e.reviveOptions=s;function t(c,_){return[...(_?.getWorkspaceFolders()||[]).map(v=>v.uri),c.extensionLocation]}}),define(Ce[218],Ie([1,0,20,97,7,12,22,2,8,54,62,4,6]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class k{constructor(i,u){this.document=i,this._storagePath=u,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,u){await this.getEdit(i).undo(),u||this.disposeBackup()}async redo(i,u){await this.getEdit(i).redo(),u||this.disposeBackup()}disposeEdits(i){for(const u of i)this._edits.delete(u)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=l(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const u=this._edits.get(i,0);if(!u)throw new Error("No edit found");return u}}class f{constructor(){this._documents=new Map}get(i,u){return this._documents.get(this.key(i,u))}add(i,u,n){const r=this.key(i,u.uri);if(this._documents.has(r))throw new Error(`Document already exists for viewType:${i} resource:${u.uri}`);const s=new k(u,n);return this._documents.set(r,s),s}delete(i,u){const n=this.key(i,u.uri);this._documents.delete(n)}key(i,u){return`${i}@@@${u}`}}var h;(function(D){D[D.Text=0]="Text",D[D.Custom=1]="Custom"})(h||(h={}));class d{constructor(){this._providers=new Map}addTextProvider(i,u,n){return this.add(0,i,u,n)}addCustomProvider(i,u,n){return this.add(1,i,u,n)}get(i){return this._providers.get(i)}add(i,u,n,r){if(this._providers.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this._providers.set(u,{type:i,extension:n,provider:r}),new m.Disposable(()=>this._providers.delete(u))}}class o{constructor(i,u,n,r,s){this._extHostDocuments=u,this._extensionStoragePaths=n,this._extHostWebview=r,this._extHostWebviewPanels=s,this._editorProviders=new d,this._documents=new f,this._proxy=i.getProxy(S.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,u,n,r){const s=new w.DisposableStore;return g(n)?(s.add(this._editorProviders.addTextProvider(u,i,n)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(i),u,r.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(i))):(s.add(this._editorProviders.addCustomProvider(u,i,n)),this.supportEditing(n)&&s.add(n.onDidChangeCustomDocument(t=>{const c=this.getCustomDocumentEntry(u,t.document.uri);if(E(t)){const _=c.addEdit(t);this._proxy.$onDidEdit(t.document.uri,u,_,t.label)}else this._proxy.$onContentChange(t.document.uri,u)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(i),u,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(i))),m.Disposable.from(s,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(u)}))}async $createCustomDocument(i,u,n,r,s){const t=this._editorProviders.get(u);if(!t)throw new Error(`No provider found for '${u}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${u}'`);const c=A.URI.revive(i),_=await t.provider.openCustomDocument(c,{backupId:n,untitledDocumentData:r?.buffer},s);let v;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(v=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(u,_,v),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(i,u){const n=this._editorProviders.get(u);if(!n)throw new Error(`No provider found for '${u}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${u}'`);const r=A.URI.revive(i),{document:s}=this.getCustomDocumentEntry(u,r);this._documents.delete(u,s),s.dispose()}async $resolveWebviewEditor(i,u,n,r,s,t){const c=this._editorProviders.get(n);if(!c)throw new Error(`No provider found for '${n}'`);const _=b.ViewColumn.to(s),v=this._extHostWebview.createNewWebview(u,r.webviewOptions,c.extension),T=this._extHostWebviewPanels.createNewWebviewPanel(u,n,r.title,_,r.panelOptions,v,!0),U=A.URI.revive(i);switch(c.type){case 1:{const{document:V}=this.getCustomDocumentEntry(n,U);return c.provider.resolveCustomEditor(V,T,t)}case 0:{const V=this._extHostDocuments.getDocument(U);return c.provider.resolveCustomTextEditor(V,T,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,u,n){this.getCustomDocumentEntry(u,i).disposeEdits(n)}async $onMoveCustomEditor(i,u,n){const r=this._editorProviders.get(n);if(!r)throw new Error(`No provider found for '${n}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const s=this._extHostWebviewPanels.getWebviewPanel(i);if(!s)throw new Error("No webview found");const t=A.URI.revive(u),c=this._extHostDocuments.getDocument(t);await r.provider.moveCustomTextEditor(c,s,a.CancellationToken.None)}async $undo(i,u,n,r){return this.getCustomDocumentEntry(u,i).undo(n,r)}async $redo(i,u,n,r){return this.getCustomDocumentEntry(u,i).redo(n,r)}async $revert(i,u,n){const r=this.getCustomDocumentEntry(u,i);await this.getCustomEditorProvider(u).revertCustomDocument(r.document,n),r.disposeBackup()}async $onSave(i,u,n){const r=this.getCustomDocumentEntry(u,i);await this.getCustomEditorProvider(u).saveCustomDocument(r.document,n),r.disposeBackup()}async $onSaveAs(i,u,n,r){const s=this.getCustomDocumentEntry(u,i);return this.getCustomEditorProvider(u).saveCustomDocumentAs(s.document,A.URI.revive(n),r)}async $backup(i,u,n){const r=this.getCustomDocumentEntry(u,i),t=await this.getCustomEditorProvider(u).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},n);return r.updateBackup(t),t.id}getCustomDocumentEntry(i,u){const n=this._documents.get(i,A.URI.revive(u));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(i){const n=this._editorProviders.get(i)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=o;function g(D){return typeof D.resolveCustomTextEditor=="function"}function E(D){return typeof D.undo=="function"&&typeof D.redo=="function"}function l(D){const i=D.scheme===M.Schemas.file||D.scheme===M.Schemas.untitled?D.fsPath:D.toString();return(0,p.hash)(i)+""}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,p,w){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?w.call(ie,a):w?w.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!p:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ie):p?p.value:e.get(ie)};define(Ce[219],Ie([1,0,5,7,2,42,8,54,4,6]),function(ie,e,a,p,w,M,y,A,b,P){"use strict";var R,S,m,k,f,h,d,o,g,E,l,D,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends p.Disposable{constructor(t,c,_,v){super(),R.set(this,void 0),S.set(this,void 0),m.set(this,void 0),k.set(this,void 0),f.set(this,void 0),h.set(this,void 0),d.set(this,void 0),o.set(this,void 0),g.set(this,!0),E.set(this,void 0),l.set(this,!1),D.set(this,this._register(new a.Emitter)),this.onDidDispose=Oe(this,D,"f").event,i.set(this,this._register(new a.Emitter)),this.onDidChangeViewState=Oe(this,i,"f").event,Je(this,R,t,"f"),Je(this,S,c,"f"),Je(this,k,_,"f"),Je(this,m,v.viewType,"f"),Je(this,f,v.panelOptions,"f"),Je(this,o,v.viewColumn,"f"),Je(this,h,v.title,"f"),Je(this,E,v.active,"f")}dispose(){Oe(this,l,"f")||(Je(this,l,!0,"f"),Oe(this,D,"f").fire(),Oe(this,S,"f").$disposeWebview(Oe(this,R,"f")),Oe(this,k,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,k,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,m,"f")}get title(){return this.assertNotDisposed(),Oe(this,h,"f")}set title(t){this.assertNotDisposed(),Oe(this,h,"f")!==t&&(Je(this,h,t,"f"),Oe(this,S,"f").$setTitle(Oe(this,R,"f"),t))}get iconPath(){return this.assertNotDisposed(),Oe(this,d,"f")}set iconPath(t){this.assertNotDisposed(),Oe(this,d,"f")!==t&&(Je(this,d,t,"f"),Oe(this,S,"f").$setIconPath(Oe(this,R,"f"),w.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,o,"f")=="number"&&Oe(this,o,"f")<0))return Oe(this,o,"f")}get active(){return this.assertNotDisposed(),Oe(this,E,"f")}get visible(){return this.assertNotDisposed(),Oe(this,g,"f")}_updateViewState(t){Oe(this,l,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(Je(this,E,t.active,"f"),Je(this,g,t.visible,"f"),Je(this,o,t.viewColumn,"f"),Oe(this,i,"f").fire({webviewPanel:this}))}reveal(t,c){this.assertNotDisposed(),Oe(this,S,"f").$reveal(Oe(this,R,"f"),{viewColumn:typeof t>"u"?void 0:y.ViewColumn.from(t),preserveFocus:!!c})}assertNotDisposed(){if(Oe(this,l,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,S=new WeakMap,m=new WeakMap,k=new WeakMap,f=new WeakMap,h=new WeakMap,d=new WeakMap,o=new WeakMap,g=new WeakMap,E=new WeakMap,l=new WeakMap,D=new WeakMap,i=new WeakMap;class n{constructor(t,c,_){this.webviews=c,this.workspace=_,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(b.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,M.generateUuid)()}createWebviewPanel(t,c,_,v,T={}){const U=typeof v=="object"?v.viewColumn:v,V={viewColumn:y.ViewColumn.from(U),preserveFocus:typeof v=="object"&&!!v.preserveFocus},x=(0,A.shouldSerializeBuffersForPostMessage)(t),C=n.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(t),C,c,{title:_,panelOptions:r(T),webviewOptions:(0,A.serializeWebviewOptions)(t,this.workspace,T),serializeBuffersForPostMessage:x},V);const L=this.webviews.createNewWebview(C,T,t);return this.createNewWebviewPanel(C,c,_,U,T,L,!0)}$onDidChangeWebviewPanelViewStates(t){const c=Object.keys(t);c.sort((_,v)=>{const T=t[_],U=t[v];return T.active?1:U.active?-1:+T.visible-+U.visible});for(const _ of c){const v=this.getWebviewPanel(_);if(!v)continue;const T=t[_];v._updateViewState({active:T.active,visible:T.visible,viewColumn:y.ViewColumn.to(T.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,c,_){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:_,extension:t}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(t)}),new P.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(t,c,_,v){const T=this._serializers.get(c);if(!T)throw new Error(`No serializer found for '${c}'`);const{serializer:U,extension:V}=T,x=this.webviews.createNewWebview(t,_.webviewOptions,V),C=this.createNewWebviewPanel(t,c,_.title,v,_.panelOptions,x,_.active);await U.deserializeWebviewPanel(C,_.state)}createNewWebviewPanel(t,c,_,v,T,U,V){const x=new u(t,this._proxy,U,{viewType:c,title:_,viewColumn:v,panelOptions:T,active:V});return this._webviewPanels.set(t,x),x}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=n;function r(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,p,w){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?w.call(ie,a):w?w.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!p:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ie):p?p.value:e.get(ie)};define(Ce[220],Ie([1,0,5,7,54,8,4,6]),function(ie,e,a,p,w,M,y,A){"use strict";var b,P,R,S,m,k,f,h,d,o,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class E extends p.Disposable{constructor(i,u,n,r,s,t,c){super(),b.set(this,void 0),P.set(this,void 0),R.set(this,void 0),S.set(this,void 0),m.set(this,!1),k.set(this,void 0),f.set(this,void 0),h.set(this,void 0),d.set(this,void 0),o.set(this,this._register(new a.Emitter)),this.onDidChangeVisibility=Oe(this,o,"f").event,g.set(this,this._register(new a.Emitter)),this.onDidDispose=Oe(this,g,"f").event,Je(this,R,n,"f"),Je(this,f,r,"f"),Je(this,b,i,"f"),Je(this,P,u,"f"),Je(this,S,s,"f"),Je(this,k,c,"f")}dispose(){Oe(this,m,"f")||(Je(this,m,!0,"f"),Oe(this,g,"f").fire(),Oe(this,S,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,f,"f")}set title(i){this.assertNotDisposed(),Oe(this,f,"f")!==i&&(Je(this,f,i,"f"),Oe(this,P,"f").$setWebviewViewTitle(Oe(this,b,"f"),i))}get description(){return this.assertNotDisposed(),Oe(this,h,"f")}set description(i){this.assertNotDisposed(),Oe(this,h,"f")!==i&&(Je(this,h,i,"f"),Oe(this,P,"f").$setWebviewViewDescription(Oe(this,b,"f"),i))}get visible(){return Oe(this,k,"f")}get webview(){return Oe(this,S,"f")}get viewType(){return Oe(this,R,"f")}_setVisible(i){i===Oe(this,k,"f")||Oe(this,m,"f")||(Je(this,k,i,"f"),Oe(this,o,"f").fire())}get badge(){return this.assertNotDisposed(),Oe(this,d,"f")}set badge(i){this.assertNotDisposed(),!(i?.value===Oe(this,d,"f")?.value&&i?.tooltip===Oe(this,d,"f")?.tooltip)&&(Je(this,d,M.ViewBadge.from(i),"f"),Oe(this,P,"f").$setWebviewViewBadge(Oe(this,b,"f"),i))}show(i){this.assertNotDisposed(),Oe(this,P,"f").$show(Oe(this,b,"f"),!!i)}assertNotDisposed(){if(Oe(this,m,"f"))throw new Error("Webview is disposed")}}b=new WeakMap,P=new WeakMap,R=new WeakMap,S=new WeakMap,m=new WeakMap,k=new WeakMap,f=new WeakMap,h=new WeakMap,d=new WeakMap,o=new WeakMap,g=new WeakMap;class l{constructor(i,u){this._extHostWebview=u,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=i.getProxy(y.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,u,n,r){if(this._viewProviders.has(u))throw new Error(`View provider for '${u}' already registered`);return this._viewProviders.set(u,{provider:n,extension:i}),this._proxy.$registerWebviewViewProvider((0,w.toExtensionData)(i),u,{retainContextWhenHidden:r?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,w.shouldSerializeBuffersForPostMessage)(i)}),new A.Disposable(()=>{this._viewProviders.delete(u),this._proxy.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(i,u,n,r,s){const t=this._viewProviders.get(u);if(!t)throw new Error(`No view provider found for '${u}'`);const{provider:c,extension:_}=t,v=this._extHostWebview.createNewWebview(i,{},_),T=new E(i,this._proxy,u,n,v,_,!0);this._webviewViews.set(i,T),await c.resolveWebviewView(T,{state:r},s)}async $onDidChangeWebviewViewVisibility(i,u){this.getWebviewView(i)._setVisible(u)}async $disposeWebviewView(i){const u=this.getWebviewView(i);this._webviewViews.delete(i),u.dispose(),this._extHostWebview.deleteWebview(i)}getWebviewView(i){const u=this._webviewViews.get(i);if(!u)throw new Error("No webview found");return u}}e.ExtHostWebviewViews=l}),define(Ce[99],Ie([1,0,5,4,2,12,9,3,13]),function(ie,e,a,p,w,M,y,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Yi{constructor(S){this._onDidChangeWindowState=new a.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Yi.InitialState,this._proxy=S.getProxy(p.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}get state(){return this._state}$onDidChangeWindowFocus(S){S!==this._state.focused&&(this._state={...this._state,focused:S},this._onDidChangeWindowState.fire(this._state))}openUri(S,m){let k;if(typeof S=="string"){k=S;try{S=w.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,y.isFalsyOrWhitespace)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this._proxy.$openUri(S,k,m)}async asExternalUri(S,m){if((0,y.isFalsyOrWhitespace)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const k=await this._proxy.$asExternalUri(S,m);return w.URI.from(k)}};P.InitialState={focused:!0},P=ze([$e(0,b.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Ce[221],Ie([1,0,192,28,13]),function(ie,e,a,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends a.AbstractExtHostConsoleForwarder{constructor(A,b){super(A,b)}_nativeConsoleLogMessage(A,b,P){b.apply(console,P)}};M=ze([$e(0,w.IExtHostRpcService),$e(1,p.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(Ce[222],Ie([1,0,14,23,20,11,5,7,119,186,40]),function(ie,e,a,p,w,M,y,A,b,P,R){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(T,U){try{return JSON.stringify(T,U)}catch{return"null"}}const k="$$ref$$",f={[k]:-1};class h{constructor(U,V){this.jsonString=U,this.referencedBuffers=V}}function d(T,U=null,V=!1){const x=[];return{jsonString:(V?m:JSON.stringify)(T,(L,B)=>{if(typeof B>"u")return f;if(typeof B=="object"){if(B instanceof p.VSBuffer){const F=x.push(B)-1;return{[k]:F}}if(U)return U(L,B)}return B}),referencedBuffers:x}}e.stringifyJsonWithBufferRefs=d;function o(T,U,V){return JSON.parse(T,(x,C)=>{if(C){const L=C[k];if(typeof L=="number")return U[L];if(V&&C.$mid===1)return V.transformIncoming(C)}return C})}e.parseJsonAndRestoreBufferRefs=o;function g(T,U){return JSON.stringify(T,U)}function E(T){return T?(U,V)=>V&&V.$mid===1?T.transformOutgoing(V):V:null}var l;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var D;(function(T){T[T.Responsive=0]="Responsive",T[T.Unresponsive=1]="Unresponsive"})(D=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},u=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class r extends A.Disposable{constructor(U,V=null,x=null){super(),this[S]=!0,this._onDidChangeResponsiveState=this._register(new y.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=U,this._logger=V,this._uriTransformer=x,this._uriReplacer=E(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let C=0,L=R.ProxyIdentifier.count;C<L;C++)this._locals[C]=null,this._proxies[C]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new a.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(C=>this._receiveOneMessage(C))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(U=>{this._pendingRPCReplies[U].resolveErr(M.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(U){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(U){this._unresponsiveTime=Date.now()+r.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(U){this._responsiveState!==U&&(this._responsiveState=U,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(U){return this._uriTransformer?(0,b.transformIncomingURIs)(U,this._uriTransformer):U}getProxy(U){const{nid:V,sid:x}=U;return this._proxies[V]||(this._proxies[V]=this._createProxy(V,x)),this._proxies[V]}_createProxy(U,V){const x={get:(C,L)=>(typeof L=="string"&&!C[L]&&L.charCodeAt(0)===36&&(C[L]=(...B)=>this._remoteCall(U,L,B)),L===n?V:C[L])};return new Proxy(Object.create(null),x)}set(U,V){return this._locals[U.nid]=V,V}assertRegistered(U){for(let V=0,x=U.length;V<x;V++){const C=U[V];if(!this._locals[C.nid])throw new Error(`Missing proxy instance ${C.sid}`)}}_receiveOneMessage(U){if(this._isDisposed)return;const V=U.byteLength,x=s.read(U,0),C=x.readUInt8(),L=x.readUInt32();switch(C){case 1:case 2:{let{rpcId:B,method:F,args:K}=c.deserializeRequestJSONArgs(x);this._uriTransformer&&(K=(0,b.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(V,L,B,F,K,C===2);break}case 3:case 4:{let{rpcId:B,method:F,args:K}=c.deserializeRequestMixedArgs(x);this._uriTransformer&&(K=(0,b.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(V,L,B,F,K,C===4);break}case 5:{this._logger?.logIncoming(V,L,0,"ack"),this._onDidReceiveAcknowledge(L);break}case 6:{this._receiveCancel(V,L);break}case 7:{this._receiveReply(V,L,void 0);break}case 9:{let B=c.deserializeReplyOKJSON(x);this._uriTransformer&&(B=(0,b.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReply(V,L,B);break}case 10:{const B=c.deserializeReplyOKJSONWithBuffers(x,this._uriTransformer);this._receiveReply(V,L,B);break}case 8:{const B=c.deserializeReplyOKVSBuffer(x);this._receiveReply(V,L,B);break}case 11:{let B=c.deserializeReplyErrError(x);this._uriTransformer&&(B=(0,b.transformIncomingURIs)(B,this._uriTransformer)),this._receiveReplyErr(V,L,B);break}case 12:{this._receiveReplyErr(V,L,void 0);break}default:console.error("received unexpected message"),console.error(U)}}_receiveRequest(U,V,x,C,L,B){this._logger?.logIncoming(U,V,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(x)}.${C}(`,L);const F=String(V);let K,H;if(B){const ee=new w.CancellationTokenSource;L.push(ee.token),K=this._invokeHandler(x,C,L),H=()=>ee.cancel()}else K=this._invokeHandler(x,C,L),H=i;this._cancelInvokedHandlers[F]=H;const O=c.serializeAcknowledged(V);this._logger?.logOutgoing(O.byteLength,V,1,"ack"),this._protocol.send(O),K.then(ee=>{delete this._cancelInvokedHandlers[F];const ue=c.serializeReplyOK(V,ee,this._uriReplacer);this._logger?.logOutgoing(ue.byteLength,V,1,"reply:",ee),this._protocol.send(ue)},ee=>{delete this._cancelInvokedHandlers[F];const ue=c.serializeReplyErr(V,ee);this._logger?.logOutgoing(ue.byteLength,V,1,"replyErr:",ee),this._protocol.send(ue)})}_receiveCancel(U,V){this._logger?.logIncoming(U,V,1,"receiveCancel");const x=String(V);this._cancelInvokedHandlers[x]?.()}_receiveReply(U,V,x){this._logger?.logIncoming(U,V,0,"receiveReply:",x);const C=String(V);if(!this._pendingRPCReplies.hasOwnProperty(C))return;const L=this._pendingRPCReplies[C];delete this._pendingRPCReplies[C],L.resolveOk(x)}_receiveReplyErr(U,V,x){this._logger?.logIncoming(U,V,0,"receiveReplyErr:",x);const C=String(V);if(!this._pendingRPCReplies.hasOwnProperty(C))return;const L=this._pendingRPCReplies[C];delete this._pendingRPCReplies[C];let B;x&&(x.$isError?(B=new Error,B.name=x.name,B.message=x.message,B.stack=x.stack):B=x),L.resolveErr(B)}_invokeHandler(U,V,x){try{return Promise.resolve(this._doInvokeHandler(U,V,x))}catch(C){return Promise.reject(C)}}_doInvokeHandler(U,V,x){const C=this._locals[U];if(!C)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(U));const L=C[V];if(typeof L!="function")throw new Error("Unknown method "+V+" on actor "+(0,R.getStringIdentifierForProxy)(U));return L.apply(C,x)}_remoteCall(U,V,x){if(this._isDisposed)return new P.CanceledLazyPromise;let C=null;if(x.length>0&&w.CancellationToken.isCancellationToken(x[x.length-1])&&(C=x.pop()),C&&C.isCancellationRequested)return Promise.reject(M.canceled());const L=c.serializeRequestArguments(x,this._uriReplacer),B=++this._lastMessageId,F=String(B),K=new P.LazyPromise;C&&C.onCancellationRequested(()=>{const O=c.serializeCancel(B);this._logger?.logOutgoing(O.byteLength,B,0,"cancel"),this._protocol.send(c.serializeCancel(B))}),this._pendingRPCReplies[F]=K,this._onWillSendRequest(B);const H=c.serializeRequest(B,U,V,L,!!C);return this._logger?.logOutgoing(H.byteLength,B,0,`request: ${(0,R.getStringIdentifierForProxy)(U)}.${V}(`,x),this._protocol.send(H),K}}e.RPCProtocol=r,S=u,r.UNRESPONSIVE_TIME=3*1e3;class s{constructor(U,V){this._buff=U,this._offset=V}static alloc(U,V,x){const C=new s(p.VSBuffer.alloc(x+1+4),0);return C.writeUInt8(U),C.writeUInt32(V),C}static read(U,V){return new s(U,V)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(U){this._buff.writeUInt8(U,this._offset),this._offset+=1}readUInt8(){const U=this._buff.readUInt8(this._offset);return this._offset+=1,U}writeUInt32(U){this._buff.writeUInt32BE(U,this._offset),this._offset+=4}readUInt32(){const U=this._buff.readUInt32BE(this._offset);return this._offset+=4,U}static sizeShortString(U){return 1+U.byteLength}writeShortString(U){this._buff.writeUInt8(U.byteLength,this._offset),this._offset+=1,this._buff.set(U,this._offset),this._offset+=U.byteLength}readShortString(){const U=this._buff.readUInt8(this._offset);this._offset+=1;const x=this._buff.slice(this._offset,this._offset+U).toString();return this._offset+=U,x}static sizeLongString(U){return 4+U.byteLength}writeLongString(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}readLongString(){const U=this._buff.readUInt32BE(this._offset);this._offset+=4;const x=this._buff.slice(this._offset,this._offset+U).toString();return this._offset+=U,x}writeBuffer(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}static sizeVSBuffer(U){return 4+U.byteLength}writeVSBuffer(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}readVSBuffer(){const U=this._buff.readUInt32BE(this._offset);this._offset+=4;const V=this._buff.slice(this._offset,this._offset+U);return this._offset+=U,V}static sizeMixedArray(U){let V=0;V+=1;for(let x=0,C=U.length;x<C;x++){const L=U[x];switch(V+=1,L.type){case 1:V+=this.sizeLongString(L.value);break;case 2:V+=this.sizeVSBuffer(L.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(L.value);for(let B=0;B<L.buffers.length;++B)V+=this.sizeVSBuffer(L.buffers[B]);break;case 4:break}}return V}writeMixedArray(U){this._buff.writeUInt8(U.length,this._offset),this._offset+=1;for(let V=0,x=U.length;V<x;V++){const C=U[V];switch(C.type){case 1:this.writeUInt8(1),this.writeLongString(C.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(C.value);break;case 3:this.writeUInt8(3),this.writeUInt32(C.buffers.length),this.writeLongString(C.value);for(let L=0;L<C.buffers.length;++L)this.writeBuffer(C.buffers[L]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const U=this._buff.readUInt8(this._offset);this._offset+=1;const V=new Array(U);for(let x=0;x<U;x++)switch(this.readUInt8()){case 1:V[x]=this.readLongString();break;case 2:V[x]=this.readVSBuffer();break;case 3:{const L=this.readUInt32(),B=this.readLongString(),F=[];for(let K=0;K<L;++K)F.push(this.readVSBuffer());V[x]=new R.SerializableObjectWithBuffers(o(B,F,null));break}case 4:V[x]=void 0;break}return V}}s.sizeUInt32=4;var t;(function(T){T[T.Simple=0]="Simple",T[T.Mixed=1]="Mixed"})(t||(t={}));class c{static _useMixedArgSerialization(U){for(let V=0,x=U.length;V<x;V++)if(U[V]instanceof p.VSBuffer||U[V]instanceof R.SerializableObjectWithBuffers||typeof U[V]>"u")return!0;return!1}static serializeRequestArguments(U,V){if(this._useMixedArgSerialization(U)){const x=[];for(let C=0,L=U.length;C<L;C++){const B=U[C];if(B instanceof p.VSBuffer)x[C]={type:2,value:B};else if(typeof B>"u")x[C]={type:4};else if(B instanceof R.SerializableObjectWithBuffers){const{jsonString:F,referencedBuffers:K}=d(B.value,V);x[C]={type:3,value:p.VSBuffer.fromString(F),buffers:K}}else x[C]={type:1,value:p.VSBuffer.fromString(g(B,V))}}return{type:1,args:x}}return{type:0,args:g(U,V)}}static serializeRequest(U,V,x,C,L){switch(C.type){case 0:return this._requestJSONArgs(U,V,x,C.args,L);case 1:return this._requestMixedArgs(U,V,x,C.args,L)}}static _requestJSONArgs(U,V,x,C,L){const B=p.VSBuffer.fromString(x),F=p.VSBuffer.fromString(C);let K=0;K+=s.sizeUInt8(),K+=s.sizeShortString(B),K+=s.sizeLongString(F);const H=s.alloc(L?2:1,U,K);return H.writeUInt8(V),H.writeShortString(B),H.writeLongString(F),H.buffer}static deserializeRequestJSONArgs(U){const V=U.readUInt8(),x=U.readShortString(),C=U.readLongString();return{rpcId:V,method:x,args:JSON.parse(C)}}static _requestMixedArgs(U,V,x,C,L){const B=p.VSBuffer.fromString(x);let F=0;F+=s.sizeUInt8(),F+=s.sizeShortString(B),F+=s.sizeMixedArray(C);const K=s.alloc(L?4:3,U,F);return K.writeUInt8(V),K.writeShortString(B),K.writeMixedArray(C),K.buffer}static deserializeRequestMixedArgs(U){const V=U.readUInt8(),x=U.readShortString(),C=U.readMixedArray(),L=new Array(C.length);for(let B=0,F=C.length;B<F;B++){const K=C[B];typeof K=="string"?L[B]=JSON.parse(K):L[B]=K}return{rpcId:V,method:x,args:L}}static serializeAcknowledged(U){return s.alloc(5,U,0).buffer}static serializeCancel(U){return s.alloc(6,U,0).buffer}static serializeReplyOK(U,V,x){if(typeof V>"u")return this._serializeReplyOKEmpty(U);if(V instanceof p.VSBuffer)return this._serializeReplyOKVSBuffer(U,V);if(V instanceof R.SerializableObjectWithBuffers){const{jsonString:C,referencedBuffers:L}=d(V.value,x,!0);return this._serializeReplyOKJSONWithBuffers(U,C,L)}else return this._serializeReplyOKJSON(U,m(V,x))}static _serializeReplyOKEmpty(U){return s.alloc(7,U,0).buffer}static _serializeReplyOKVSBuffer(U,V){let x=0;x+=s.sizeVSBuffer(V);const C=s.alloc(8,U,x);return C.writeVSBuffer(V),C.buffer}static deserializeReplyOKVSBuffer(U){return U.readVSBuffer()}static _serializeReplyOKJSON(U,V){const x=p.VSBuffer.fromString(V);let C=0;C+=s.sizeLongString(x);const L=s.alloc(9,U,C);return L.writeLongString(x),L.buffer}static _serializeReplyOKJSONWithBuffers(U,V,x){const C=p.VSBuffer.fromString(V);let L=0;L+=s.sizeUInt32,L+=s.sizeLongString(C);for(const F of x)L+=s.sizeVSBuffer(F);const B=s.alloc(10,U,L);B.writeUInt32(x.length),B.writeLongString(C);for(const F of x)B.writeBuffer(F);return B.buffer}static deserializeReplyOKJSON(U){const V=U.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(U,V){const x=U.readUInt32(),C=U.readLongString(),L=[];for(let B=0;B<x;++B)L.push(U.readVSBuffer());return new R.SerializableObjectWithBuffers(o(C,L,V))}static serializeReplyErr(U,V){const x=V?m(M.transformErrorForSerialization(V),null):void 0;if(typeof x!="string")return this._serializeReplyErrEmpty(U);const C=p.VSBuffer.fromString(x);let L=0;L+=s.sizeLongString(C);const B=s.alloc(11,U,L);return B.writeLongString(C),B.buffer}static deserializeReplyErrError(U){const V=U.readLongString();return JSON.parse(V)}static _serializeReplyErrEmpty(U){return s.alloc(12,U,0).buffer}}var _;(function(T){T[T.RequestJSONArgs=1]="RequestJSONArgs",T[T.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",T[T.RequestMixedArgs=3]="RequestMixedArgs",T[T.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",T[T.Acknowledged=5]="Acknowledged",T[T.Cancel=6]="Cancel",T[T.ReplyOKEmpty=7]="ReplyOKEmpty",T[T.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",T[T.ReplyOKJSON=9]="ReplyOKJSON",T[T.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",T[T.ReplyErrError=11]="ReplyErrError",T[T.ReplyErrEmpty=12]="ReplyErrEmpty"})(_||(_={}));var v;(function(T){T[T.String=1]="String",T[T.VSBuffer=2]="VSBuffer",T[T.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",T[T.Undefined=4]="Undefined"})(v||(v={}))}),define(Ce[223],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const a=function(M){const y=A=>{self.removeEventListener("message",y);const b=A.data;Object.defineProperties(self,{postMessage:{value(P,R){b.postMessage(P,R)}},onmessage:{get(){return b.onmessage},set(P){b.onmessage=P}}}),b.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),b.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",y)}.toString();class p extends EventTarget{constructor(M,y,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const b=`((${a})('${y}'))`,P=new Blob([b],{type:"application/javascript"}),R=URL.createObjectURL(P),S=new MessageChannel,m=R,k={type:"_newWorker",id:m,port:S.port2,url:R,options:A};M(k,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{M({type:"_terminateWorker",id:m}),URL.revokeObjectURL(R),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(f){S.port1.onmessage=f}},onmessageerror:{get(){return S.port1.onmessageerror},set(f){S.port1.onmessageerror=f}}}),S.port1.addEventListener("messageerror",f=>{const h=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(h)}),S.port1.addEventListener("message",f=>{const h=new MessageEvent("message",{data:f.data});this.dispatchEvent(h)}),S.port1.start()}}e.NestedWorker=p}),define(Ce[224],Ie([1,0,5,30,38,3,39,11,14]),function(ie,e,a,p,w,M,y,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new w.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new w.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new w.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)(e.OUTPUT_SERVICE_ID);var P;(function(k){k[k.Append=1]="Append",k[k.Replace=2]="Replace",k[k.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new a.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new a.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(f){this.channels.has(f.id)||(this.channels.set(f.id,f),this._onDidRegisterChannel.fire(f.id))}getChannels(){const f=[];return this.channels.forEach(h=>f.push(h)),f}getChannel(f){return this.channels.get(f)}removeChannel(f){this.channels.delete(f),this._onDidRemoveChannel.fire(f)}}p.Registry.add(e.Extensions.OutputChannels,new R);function S(k,f,h,d,o){return(0,b.createCancelablePromise)(async g=>{await(0,y.whenProviderRegistered)(h,d);const E=p.Registry.as(e.Extensions.OutputChannels);try{await m(h,1,d,o,g),E.registerChannel({id:k,label:f,file:h,log:!0})}catch(l){(0,A.isCancellationError)(l)||o.error("Error while registering log channel",h.toString(),(0,A.getErrorMessage)(l))}})}e.registerLogChannel=S;async function m(k,f,h,d,o){if(!await h.exists(k)){if(o.isCancellationRequested)throw new A.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");d.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",k.toString()),await(0,b.timeout)(1e3,o),await m(k,f+1,h,d,o)}}}),define(Ce[100],Ie([1,0,4,7,3,13,15,224,52,28,35,113,23,10]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class f extends p.Disposable{constructor(o,g,E,l){super(),this.id=o,this.name=g,this.logger=E,this.proxy=l,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(o){this.append(o+`
`)}append(o){this.write(o),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}clear(){const o=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,o)}replace(o){const g=this.offset;this.write(o),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,g),this.visible&&this.logger.flush()}show(o,g){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof o=="boolean"?o:g))}hide(){this.proxy.$close(this.id)}write(o){this.offset+=m.VSBuffer.fromString(o).byteLength,this.logger.info(o)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=f;let h=class{constructor(o,g,E,l,D){this.extHostFileSystem=E,this.extHostFileSystemInfo=l,this.loggerService=D,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=o.getProxy(a.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(g.logsLocation,`output_logging_${(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(o){this.visibleChannelId=o;for(const[g,E]of this.channels)E.visible=g===this.visibleChannelId}createOutputChannel(o,g,E){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");if((0,k.isString)(g)&&!g.trim())throw new Error("illegal argument `languageId`. must not be empty");const l=this.doCreateOutputChannel(o,g,E);return l.then(D=>{this.channels.set(D.id,D),D.visible=D.id===this.visibleChannelId}),this.createExtHostOutputChannel(o,l)}async doCreateOutputChannel(o,g,E){const l=await this.createOutputDirectory(),D=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${o.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),i=this.loggerService.createLogger(D,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.proxy.$register(o,!1,D,g,E.identifier.value);return new f(u,o,i,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(o,g){let E=!1;const l=()=>{if(E)throw new Error("Channel has been closed")};return{get name(){return o},append(D){l(),g.then(i=>i.append(D))},appendLine(D){l(),g.then(i=>i.appendLine(D))},clear(){l(),g.then(D=>D.clear())},replace(D){l(),g.then(i=>i.replace(D))},show(D,i){l(),g.then(u=>u.show(D,i))},hide(){l(),g.then(D=>D.hide())},dispose(){E=!0,g.then(D=>D.dispose())}}}};h=ze([$e(0,M.IExtHostRpcService),$e(1,P.IExtHostInitDataService),$e(2,b.IExtHostConsumerFileSystem),$e(3,R.IExtHostFileSystemInfo),$e(4,y.ILoggerService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,w.createDecorator)("IExtHostOutputService")}),define(Ce[225],Ie([1,0,3]),function(ie,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(Ce[226],Ie([1,0,37,12,19,21,22,2,3,157,45,178,225]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,b.createDecorator)("pathService");let k=class Ji{constructor(h,d,o,g){this.localUserHome=h,this.remoteAgentService=d,this.environmentService=o,this.contextService=g,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||M.OS)(),this.resolveUserHome=(async()=>{const E=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=E?.userHome??h})()}hasValidBasename(h,d,o){return typeof d=="string"||typeof d>"u"?this.resolveOS.then(g=>this.doHasValidBasename(h,g,d)):this.doHasValidBasename(h,d,o)}doHasValidBasename(h,d,o){return h.scheme===p.Schemas.file||h.scheme===p.Schemas.vscodeRemote?(0,a.isValidBasename)(o??(0,y.basename)(h),d===1):!0}get defaultUriScheme(){return Ji.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,d){if(h.remoteAuthority)return p.Schemas.vscodeRemote;const o=(0,P.getVirtualWorkspaceScheme)(d.getWorkspace());if(o)return o;const g=d.getWorkspace().folders[0];if(g)return g.uri.scheme;const E=d.getWorkspace().configuration;return E?E.scheme:p.Schemas.file}userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?w.win32:w.posix)}async fileURI(h){let d="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const g=h.indexOf("/",2);g===-1?(d=h.substring(2),h="/"):(d=h.substring(2,g),h=h.substring(g)||"/")}return A.URI.from({scheme:p.Schemas.file,authority:d,path:h,query:"",fragment:""})}};k=ze([$e(1,m.IRemoteAgentService),$e(2,S.IWorkbenchEnvironmentService),$e(3,R.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(Ce[101],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(y,A){this.line=y,this.character=A}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,A){return new a(0,0)}with(y){return new a(0,0)}}e.Position=a;class p{constructor(y,A,b,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(y,A),this.end=new a(b,P)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new p(0,0,0,0)}with(y){return new p(0,0,0,0)}}e.Range=p;var w;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(w=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(Ce[41],Ie([1,0,16,34,25,37,9,3,19,11,101,14]),function(ie,e,a,p,w,M,y,A,b,P,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",k=" characters skipped \u27EB",f=(m.length+k.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var h;(function(oe){oe[oe.file=0]="file",oe[oe.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(oe){oe[oe.File=1]="File",oe[oe.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function o(oe){return!!oe.preview}e.resultIsMatch=o;function g(oe){return!!oe.resource}e.isFileMatch=g;function E(oe){return!!oe.message}e.isProgressMessage=E;var l;(function(oe){oe[oe.Normal=0]="Normal",oe[oe.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class D{constructor(le){this.resource=le,this.results=[]}}e.FileMatch=D;class i{constructor(le,te,Ee){this.ranges=te;const be=Array.isArray(te)?te:[te];if(Ee&&Ee.matchLines===1&&u(be)){le=(0,y.getNLines)(le,Ee.matchLines);let ne="",ve=0,Pe=0;const Fe=Math.floor(Ee.charsPerLine/5),xe=[];for(const Qe of be){const ke=Math.max(Qe.startColumn-Fe,0),Se=Qe.startColumn+Ee.charsPerLine;if(ke>Pe+Fe+f){const ye=m+(ke-Pe)+k;ne+=ye+le.slice(ke,Se),ve+=ke-(Pe+ye.length)}else ne+=le.slice(Pe,Se);xe.push(new r(0,Qe.startColumn-ve,Qe.endColumn-ve)),Pe=Se}this.preview={text:ne,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const ne=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:le,matches:(0,a.mapArrayOrNot)(te,ve=>new n(ve.startLineNumber-ne,ve.startColumn,ve.endLineNumber-ne,ve.endColumn))}}}}e.TextSearchMatch=i;function u(oe){const le=oe[0].startLineNumber;for(const te of oe)if(te.startLineNumber!==le||te.endLineNumber!==le)return!1;return!0}class n{constructor(le,te,Ee,be){this.startLineNumber=le,this.startColumn=te,this.endLineNumber=Ee,this.endColumn=be}}e.SearchRange=n;class r extends n{constructor(le,te,Ee){super(le,te,le,Ee)}}e.OneLineRange=r;var s;(function(oe){oe.Default="default",oe.FileNames="fileNames",oe.Type="type",oe.Modified="modified",oe.CountDescending="countDescending",oe.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function t(oe,le=!0){const te=oe&&oe.files&&oe.files.exclude,Ee=le&&oe&&oe.search&&oe.search.exclude;if(!te&&!Ee)return;if(!te||!Ee)return te||Ee;let be=Object.create(null);return be=w.mixin(be,w.deepClone(te)),be=w.mixin(be,w.deepClone(Ee),!0),be}e.getExcludes=t;function c(oe,le){return oe.excludePattern&&p.match(oe.excludePattern,le)?!1:oe.includePattern||oe.usingSearchPaths?oe.includePattern&&p.match(oe.includePattern,le)?!0:oe.usingSearchPaths?!!oe.folderQueries&&oe.folderQueries.some(te=>{const Ee=te.folder.fsPath;if(M.isEqualOrParent(le,Ee)){const be=b.relative(Ee,le);return!te.includePattern||!!p.match(te.includePattern,be)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var _;(function(oe){oe[oe.unknownEncoding=1]="unknownEncoding",oe[oe.regexParseError=2]="regexParseError",oe[oe.globParseError=3]="globParseError",oe[oe.invalidLiteral=4]="invalidLiteral",oe[oe.rgProcessError=5]="rgProcessError",oe[oe.other=6]="other",oe[oe.canceled=7]="canceled"})(_=e.SearchErrorCode||(e.SearchErrorCode={}));class v extends Error{constructor(le,te){super(le),this.code=te}}e.SearchError=v;function T(oe){const le=oe.message;if((0,P.isCancellationError)(oe))return new v(le,_.canceled);try{const te=JSON.parse(le);return new v(te.message,te.code)}catch{return new v(le,_.other)}}e.deserializeSearchError=T;function U(oe){const le={message:oe.message,code:oe.code};return new Error(JSON.stringify(le))}e.serializeSearchError=U;function V(oe){return oe.type==="error"?!0:oe.type==="success"}e.isSerializedSearchComplete=V;function x(oe){return oe.type==="success"}e.isSerializedSearchSuccess=x;function C(oe){return!!oe.path}e.isSerializedFileMatch=C;function L(oe,le){const te=oe.searchPath?oe.searchPath:oe.relativePath;return(0,y.fuzzyContains)(te,le)}e.isFilePatternMatch=L;class B{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=B;function F(oe,le){const te={...oe||{},...le||{}};return Object.keys(te).filter(Ee=>{const be=te[Ee];return typeof be=="boolean"&&be})}e.resolvePatternsForProvider=F;class K{constructor(le,te){this._parsedIncludeExpression=null,this._excludeExpression={...le.excludePattern||{},...te.excludePattern||{}},this._parsedExcludeExpression=p.parse(this._excludeExpression);let Ee=le.includePattern;te.includePattern&&(Ee?Ee={...Ee,...te.includePattern}:Ee=te.includePattern),Ee&&(this._parsedIncludeExpression=p.parse(Ee))}matchesExcludesSync(le,te,Ee){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(le,te,Ee))}includedInQuerySync(le,te,Ee){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(le,te,Ee)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(le,te,Ee))}includedInQuery(le,te,Ee){const be=this._parsedExcludeExpression(le,te,Ee),ne=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(le,te,Ee):!0;return(0,S.isThenable)(be)?be.then(ve=>ve?!1:ne()):ne()}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=K;function H(oe){for(const le in oe)if(typeof oe[le]!="boolean")return!0;return!1}function O(oe){if(!oe)return;let le;return te=>(le||(le=(oe()||Promise.resolve([])).then(Ee=>Ee?ue(Ee):{})),le.then(Ee=>!!Ee[te]))}e.hasSiblingPromiseFn=O;function ee(oe){if(!oe)return;let le;return te=>{if(!le){const Ee=oe();le=Ee?ue(Ee):{}}return!!le[te]}}e.hasSiblingFn=ee;function ue(oe){const le={};for(const te of oe)le[te]=!0;return le}}),define(Ce[31],Ie([1,0,16,14,20,5,7,24,12,108,22,9,10,2,136,3,15,149,45,35,28,13,8,6,46,41,4]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f,h,d,o,g,E,l,D,i,u,n,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function t(C,L,B){return new R.ExtUri(F=>T(F,B)).isEqual(C,L)}function c(C,L,B){return t(C.uri,L.uri,B)?0:(0,S.compare)(C.uri.toString(),L.uri.toString())}function _(C,L,B){return C.index!==L.index?C.index<L.index?-1:1:t(C.uri,L.uri,B)?(0,S.compare)(C.name,L.name):(0,S.compare)(C.uri.toString(),L.uri.toString())}function v(C,L,B,F){const K=C.slice(0).sort((O,ee)=>B(O,ee,F)),H=L.slice(0).sort((O,ee)=>B(O,ee,F));return(0,a.delta)(K,H,(O,ee)=>B(O,ee,F))}function T(C,L){const B=L.getCapabilities(C.scheme);return!(B&&B&1024)}class U extends g.Workspace{constructor(L,B,F,K,H,O,ee){super(L,F.map(ue=>new g.WorkspaceFolder(ue)),K,H,ee),this._name=B,this._isUntitled=O,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(ee),F.forEach(ue=>{this._workspaceFolders.push(ue),this._structure.set(ue.uri,ue)})}static toExtHostWorkspace(L,B,F,K){if(!L)return{workspace:null,added:[],removed:[]};const{id:H,name:O,folders:ee,configuration:ue,transient:oe,isUntitled:le}=L,te=[],Ee=B;B?ee.forEach((Pe,Fe)=>{const xe=k.URI.revive(Pe.uri),Qe=U._findFolder(F||B,xe,K);Qe?(Qe.name=Pe.name,Qe.index=Pe.index,te.push(Qe)):te.push({uri:xe,name:Pe.name,index:Fe})}):te.push(...ee.map(({uri:Pe,name:Fe,index:xe})=>({uri:k.URI.revive(Pe),name:Fe,index:xe}))),te.sort((Pe,Fe)=>Pe.index<Fe.index?-1:1);const be=new U(H,O,te,!!oe,ue?k.URI.revive(ue):null,!!le,Pe=>T(Pe,K)),{added:ne,removed:ve}=v(Ee?Ee.workspaceFolders:[],be.workspaceFolders,c,K);return{workspace:be,added:ne,removed:ve}}static _findFolder(L,B,F){for(let K=0;K<L.folders.length;K++){const H=L.workspaceFolders[K];if(t(H.uri,B,F))return H}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,B){return B&&this._structure.get(L)&&(L=(0,R.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let V=class{constructor(L,B,F,K,H){this._onDidChangeWorkspace=new M.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new M.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=K,this._extHostFileSystemInfo=F,this._uriTransformerService=H,this._requestIdProvider=new P.Counter,this._barrier=new p.Barrier,this._proxy=L.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(s.MainContext.MainThreadMessageService);const O=B.workspace;this._confirmedWorkspace=O?new U(O.id,O.name,[],!!O.transient,O.configuration?k.URI.revive(O.configuration):null,!!O.isUntitled,ee=>T(ee,F)):void 0}$initializeWorkspace(L,B){this._trusted=B,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?k.URI.from({scheme:b.Schemas.untitled,path:(0,R.basename)((0,R.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,B,F,...K){const H=[];if(Array.isArray(K)&&K.forEach(le=>{k.URI.isUri(le.uri)&&!H.some(te=>t(te.uri,le.uri,this._extHostFileSystemInfo))&&H.push({uri:le.uri,name:le.name||(0,R.basenameOrAuthority)(le.uri)})}),this._unconfirmedWorkspace||[B,F].some(le=>typeof le!="number"||le<0)||F===0&&H.length===0)return!1;const O=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(B+F>O.length)return!1;const ee=O.slice(0);ee.splice(B,F,...H.map(le=>({uri:le.uri,name:le.name||(0,R.basenameOrAuthority)(le.uri),index:void 0})));for(let le=0;le<ee.length;le++){const te=ee[le];if(ee.some((Ee,be)=>be!==le&&t(te.uri,Ee.uri,this._extHostFileSystemInfo)))return!1}ee.forEach((le,te)=>le.index=te);const{added:ue,removed:oe}=v(O,ee,_,this._extHostFileSystemInfo);if(ue.length===0&&oe.length===0)return!1;if(this._proxy){const le=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(le,B,F,H).then(void 0,te=>{this._unconfirmedWorkspace=void 0;const Ee={source:{identifier:L.identifier,label:L.displayName||L.name}};this._messageService.$showMessage(o.Severity.Error,(0,f.localize)(0,null,le,te.toString()),Ee,[])})}return this.trySetWorkspaceFolders(ee),!0}getWorkspaceFolder(L,B){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async getWorkspaceFolder2(L,B){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,B)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,B){let F,K="";if(typeof L=="string"?(F=k.URI.file(L),K=L):typeof L<"u"&&(F=L,K=L.fsPath),!F)return K;const H=this.getWorkspaceFolder(F,!0);if(!H)return K;typeof B>"u"&&this._actualWorkspace&&(B=this._actualWorkspace.folders.length>1);let O=(0,R.relativePath)(H.uri,F);return B&&H.name&&(O=`${H.name}/${O}`),O}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=U.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:B,added:F,removed:K}=U.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=B||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:F,removed:K}))}findFiles(L,B,F,K,H=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let O;if(B===null?O=!1:B&&(typeof B=="string"?O=B:O=B.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:ee,folder:ue}=x(i.GlobPattern.from(L));return this._proxy.$startFileSearch((0,m.withUndefinedAsNull)(ee),(0,m.withUndefinedAsNull)(ue),(0,m.withUndefinedAsNull)(O),(0,m.withUndefinedAsNull)(F),H).then(oe=>Array.isArray(oe)?oe.map(le=>k.URI.revive(le)):[])}async findTextInFiles(L,B,F,K,H=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const O=this._requestIdProvider.getNext(),ee=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:ue,folder:oe}=x(i.GlobPattern.from(B.include)),le=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,te={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:ee,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:ue,excludePattern:le},Ee=!1;if(this._activeSearchCallbacks[O]=be=>{if(Ee)return;const ne=k.URI.revive(be.resource);be.results.forEach(ve=>{(0,r.resultIsMatch)(ve)?F({uri:ne,preview:{text:ve.preview.text,matches:(0,a.mapArrayOrNot)(ve.preview.matches,Pe=>new u.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))},ranges:(0,a.mapArrayOrNot)(ve.ranges,Pe=>new u.Range(Pe.startLineNumber,Pe.startColumn,Pe.endLineNumber,Pe.endColumn))}):F({uri:ne,text:ve.text,lineNumber:ve.lineNumber})})},H.isCancellationRequested)return{};try{const be=await this._proxy.$startTextSearch(L,(0,m.withUndefinedAsNull)(oe),te,O,H);return delete this._activeSearchCallbacks[O],be||{}}catch(be){throw delete this._activeSearchCallbacks[O],be}}$handleTextSearchResult(L,B){this._activeSearchCallbacks[B]?.(L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(L,B){if(this._editSessionIdentityProviders.has(L))throw new Error(`A provider has already been registered for scheme ${L}`);this._editSessionIdentityProviders.set(L,B);const F=this._uriTransformerService.transformOutgoingScheme(L),K=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(K,F),(0,y.toDisposable)(()=>{this._editSessionIdentityProviders.delete(L),this._proxy.$unregisterEditSessionIdentityProvider(K)})}async $getEditSessionIdentifier(L,B){this._logService.info("Getting edit session identifier for workspaceFolder",L);const F=await this.resolveWorkspaceFolder(k.URI.revive(L));if(!F){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const K=this._editSessionIdentityProviders.get(F.uri.scheme);if(this._logService.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!K),!K)return;const H=await K.provideEditSessionIdentity(F,B);if(this._logService.info("Provider returned edit session identifier: ",H),!!H)return H}};V=ze([$e(0,D.IExtHostRpcService),$e(1,l.IExtHostInitDataService),$e(2,E.IExtHostFileSystemInfo),$e(3,d.ILogService),$e(4,n.IURITransformerService)],V),e.ExtHostWorkspace=V,e.IExtHostWorkspace=(0,h.createDecorator)("IExtHostWorkspace");function x(C){let L,B;return C&&(typeof C=="string"?L=C:(L=C.pattern,B=k.URI.revive(C.baseUri))),{includePattern:L,folder:B}}}),define(Ce[32],Ie([1,0,25,5,31,4,6,152,83,10,14,3,13,15,2]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(u,n){if(n){const r=n.split(".");let s=u;for(let t=0;s&&t<r.length;t++)s=s[r[t]];return s}}function d(u){return u instanceof f.URI}function o(u){return u&&u.uri instanceof f.URI&&u.languageId&&typeof u.languageId=="string"}function g(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function E(u){return u&&u.uri instanceof f.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function l(u){if(d(u))return{resource:u};if(o(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(g(u))return{overrideIdentifier:u.languageId};if(E(u))return{resource:u.uri};if(u===null)return{resource:null}}let D=class{constructor(n,r,s){this._proxy=n.getProxy(M.MainContext.MainThreadConfiguration),this._extHostWorkspace=r,this._logService=s,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new i(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,r){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(n,r))}};D=ze([$e(0,m.IExtHostRpcService),$e(1,w.IExtHostWorkspace),$e(2,k.ILogService)],D),e.ExtHostConfiguration=D;class i{constructor(n,r,s,t){this._onDidChangeConfiguration=new p.Emitter,this._proxy=n,this._logService=t,this._extHostWorkspace=r,this._configuration=A.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,r){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(r,s))}getConfiguration(n,r,s){const t=l(r)||{},c=this._toReadonlyValue(n?h(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,t,s?.identifier);function _(T){if(T==null)return null;if(typeof T=="boolean")return T?2:5;switch(T){case y.ConfigurationTarget.Global:return 2;case y.ConfigurationTarget.Workspace:return 5;case y.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(T){return typeof h(c,T)<"u"},get:(T,U)=>{this._validateConfigurationAccess(n?`${n}.${T}`:T,t,s?.identifier);let V=h(c,T);if(typeof V>"u")V=U;else{let x;const C=(L,B)=>{let F;const K=()=>{x=x||(0,a.deepClone)(c),F=F||h(x,B)};return(0,P.isObject)(L)?new Proxy(L,{get:(H,O)=>{if(typeof O=="string"&&O.toLowerCase()==="tojson")return K(),()=>F;if(x)return F=F||h(x,B),F[O];const ee=H[O];return typeof O=="string"?C(ee,`${B}.${O}`):ee},set:(H,O,ee)=>(K(),F&&(F[O]=ee),!0),deleteProperty:(H,O)=>(K(),F&&delete F[O],!0),defineProperty:(H,O,ee)=>(K(),F&&Object.defineProperty(F,O,ee),!0)}):L};V=C(V,T)}return V},update:(T,U,V,x)=>{T=n?`${n}.${T}`:T;const C=_(V);return U!==void 0?this._proxy.$updateConfigurationOption(C,T,U,t,x):this._proxy.$removeConfigurationOption(C,T,t,x)},inspect:T=>{T=n?`${n}.${T}`:T;const U=(0,a.deepClone)(this._configuration.inspect(T,t,this._extHostWorkspace.workspace));if(U)return{key:T,defaultValue:U.policy?.value??U.default?.value,globalValue:U.user?.value??U.application?.value,workspaceValue:U.workspace?.value,workspaceFolderValue:U.workspaceFolder?.value,defaultLanguageValue:U.default?.override,globalLanguageValue:U.user?.override??U.application?.override,workspaceLanguageValue:U.workspace?.override,workspaceFolderLanguageValue:U.workspaceFolder?.override,languageIds:U.overrideIdentifiers}}};return typeof c=="object"&&(0,a.mixin)(v,c,!1),Object.freeze(v)}_toReadonlyValue(n){const r=s=>(0,P.isObject)(s)?new Proxy(s,{get:(t,c)=>r(t[c]),set:(t,c,_)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(t,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(t,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return r(n)}_validateConfigurationAccess(n,r,s){const t=b.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),c=s?`[${s.value}] `:"";if(t===4){typeof r?.resource>"u"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){r?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,r){const s=new A.ConfigurationChangeEvent(n,r,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,c)=>s.affectsConfiguration(t,l(c))})}_toMap(n){return n.reduce((r,s)=>(r.set(s[0],s[1]),r),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,S.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,p,w){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?w.call(ie,a):w?w.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!p:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ie):p?p.value:e.get(ie)};define(Ce[102],Ie([1,0,2,14,5,4,6,31,50,32,20,53,13,28,3,12,21,15,67,185,11]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f,h,d,o,g,E,l){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var i;(function(B){function F(H){if(H!=null)return H}B.from=F;function K(H){if(H!=null)return H}B.to=K})(i=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function(B){function F(H){if(H!=null)return H}B.from=F;function K(H){if(H!=null)return H}B.to=K})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(B){function F(H){if(H!=null)return H}B.from=F;function K(H){if(H!=null)return H}B.to=K})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var r;(function(B){function F(O){if(O){const ee=O;return ee&&!!ee.process}else return!1}B.is=F;function K(O){if(O==null)return;const ee={process:O.process,args:O.args};return O.options&&(ee.options=n.from(O.options)),ee}B.from=K;function H(O){if(O!=null)return new y.ProcessExecution(O.process,O.args,O.options)}B.to=H})(r=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(B){function F(H){if(H!=null)return H}B.from=F;function K(H){if(H!=null)return H}B.to=K})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(B){function F(O){if(O){const ee=O;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}B.is=F;function K(O){if(O==null)return;const ee={};return O.commandLine!==void 0?ee.commandLine=O.commandLine:(ee.command=O.command,ee.args=O.args),O.options&&(ee.options=s.from(O.options)),ee}B.from=K;function H(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new y.ShellExecution(O.commandLine,O.options):new y.ShellExecution(O.command,O.args?O.args:[],O.options)}B.to=H})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(B){function F(O){if(O){const ee=O;return ee&&ee.customExecution==="customExecution"}else return!1}B.is=F;function K(O){return{customExecution:"customExecution"}}B.from=K;function H(O,ee){return ee.get(O)}B.to=H})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var _;(function(B){function F(K,H){let O;return K.scope!==void 0&&typeof K.scope!="number"?O=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===y.TaskScope.Workspace&&H&&H.workspaceFile?O=H.workspaceFile:O=E.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:O}}B.from=F})(_=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(B){function F(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}B.from=F})(v=e.TaskGroupDTO||(e.TaskGroupDTO={}));var T;(function(B){function F(O,ee){if(O==null)return[];const ue=[];for(const oe of O){const le=K(oe,ee);le&&ue.push(le)}return ue}B.fromMany=F;function K(O,ee){if(O==null)return;let ue;O.execution instanceof y.ProcessExecution?ue=r.from(O.execution):O.execution instanceof y.ShellExecution?ue=t.from(O.execution):O.execution&&O.execution instanceof y.CustomExecution&&(ue=c.from(O.execution));const oe=i.from(O.definition);let le;return O.scope?typeof O.scope=="number"?le=O.scope:le=O.scope.uri:le=y.TaskScope.Workspace,!oe||!le?void 0:{_id:O._id,definition:oe,name:O.name,source:{extensionId:ee.identifier.value,label:O.source,scope:le},execution:ue,isBackground:O.isBackground,group:v.from(O.group),presentationOptions:u.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}B.from=K;async function H(O,ee,ue){if(O==null)return;let oe;r.is(O.execution)?oe=r.to(O.execution):t.is(O.execution)?oe=t.to(O.execution):c.is(O.execution)&&(oe=c.to(O._id,ue));const le=i.to(O.definition);let te;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?te=O.source.scope:te=await ee.resolveWorkspaceFolder(a.URI.revive(O.source.scope)):te=y.TaskScope.Workspace),!le||!te)return;const Ee=new y.Task(le,te,O.name,O.source.label,oe,O.problemMatchers);return O.isBackground!==void 0&&(Ee.isBackground=O.isBackground),O.group!==void 0&&(Ee.group=y.TaskGroup.from(O.group._id),Ee.group&&O.group.isDefault&&(Ee.group=new y.TaskGroup(Ee.group.id,Ee.group.label),O.group.isDefault===!0&&(Ee.group.isDefault=O.group.isDefault))),O.presentationOptions&&(Ee.presentationOptions=u.to(O.presentationOptions)),O._id&&(Ee._id=O._id),O.detail&&(Ee.detail=O.detail),Ee}B.to=H})(T=e.TaskDTO||(e.TaskDTO={}));var U;(function(B){function F(H){return H}B.from=F;function K(H){if(!!H)return Object.assign(Object.create(null),H)}B.to=K})(U=e.TaskFilterDTO||(e.TaskFilterDTO={}));class V{constructor(F,K,H){this._id=K,this._task=H,D.set(this,void 0),Je(this,D,F,"f")}get task(){return this._task}terminate(){Oe(this,D,"f").terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}D=new WeakMap;var x;(function(B){function F(K){return{id:K._id,task:void 0}}B.from=F})(x=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let C=class{constructor(F,K,H,O,ee,ue,oe,le){this._onDidExecuteTask=new w.Emitter,this._onDidTerminateTask=new w.Emitter,this._onDidTaskProcessStarted=new w.Emitter,this._onDidTaskProcessEnded=new w.Emitter,this._proxy=F.getProxy(M.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=O,this._configurationService=ee,this._terminalService=ue,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=oe,this._deprecationService=le,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(F,K,H){if(!H)return new y.Disposable(()=>{});const O=this.nextHandle();return this._handlers.set(O,{type:K,provider:H,extension:F}),this._proxy.$registerTaskProvider(O,K),new y.Disposable(()=>{this._handlers.delete(O),this._proxy.$unregisterTaskProvider(O)})}registerTaskSystem(F,K){this._proxy.$registerTaskSystem(F,K)}fetchTasks(F){return this._proxy.$fetchTasks(U.from(F)).then(async K=>{const H=[];for(const O of K){const ee=await T.to(O,this._workspaceProvider,this._providedCustomExecutions2);ee&&H.push(ee)}return H})}get taskExecutions(){const F=[];return this._taskExecutions.forEach(K=>F.push(K)),F}terminateTask(F){if(!(F instanceof V))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(F._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(F,K,H){const O=this._providedCustomExecutions2.get(F.id);O&&(this._activeCustomExecutions2.set(F.id,O),this._terminalService.attachPtyToTerminal(K,await O.callback(H))),this._lastStartedTask=F.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(F)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(F){const K=await this.getTaskExecution(F);this._taskExecutionPromises.delete(F.id),this._taskExecutions.delete(F.id),this.customExecutionComplete(F),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(F){const K=await this.getTaskExecution(F.id);this._onDidTaskProcessStarted.fire({execution:K,processId:F.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(F){const K=await this.getTaskExecution(F.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:F.exitCode})}$provideTasks(F,K){const H=this._handlers.get(F);if(!H)return Promise.reject(new Error("no handler found"));const O=[],ee=(0,p.asPromise)(()=>H.provider.provideTasks(R.CancellationToken.None)).then(ue=>this.provideTasksInternal(K,O,H,ue));return new Promise(ue=>{ee.then(oe=>{Promise.all(O).then(()=>{ue(oe)})})})}async $resolveTask(F,K){const H=this._handlers.get(F);if(!H)return Promise.reject(new Error("no handler found"));if(K.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${H.type}].`);const O=await T.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const ee=await H.provider.resolveTask(O,R.CancellationToken.None);if(!ee)return;this.checkDeprecation(ee,H);const ue=T.from(ee,H.extension);if(!ue)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(ue.execution)&&await this.addCustomExecution(ue,ee,!0),await this.resolveTaskInternal(ue)}nextHandle(){return this._handleCounter++}async addCustomExecution(F,K,H){const O=await this._proxy.$createTaskId(F);!H&&!this._providedCustomExecutions2.has(O)&&(this._notProvidedCustomExecutions.add(O),this._activeCustomExecutions2.set(O,K.execution)),this._providedCustomExecutions2.set(O,K.execution)}async getTaskExecution(F,K){if(typeof F=="string"){const ee=this._taskExecutionPromises.get(F);if(!ee)throw new Error("Unexpected: The specified task is missing an execution");return ee}const H=this._taskExecutionPromises.get(F.id);if(H)return H;const O=new Promise((ee,ue)=>{function oe(le,te,Ee){Ee?ee(new V(le,te.id,Ee)):ue("Unexpected: Task does not exist.")}K?oe(this,F,K):T.to(F.task,this._workspaceProvider,this._providedCustomExecutions2).then(le=>oe(this,F,le))});return this._taskExecutionPromises.set(F.id,O),O.then(ee=>(this._taskExecutions.set(F.id,ee),ee),ee=>Promise.reject(ee))}checkDeprecation(F,K){F._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(F){this._activeCustomExecutions2.get(F.id)&&this._activeCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.has(F.id)&&this._lastStartedTask!==F.id&&(this._providedCustomExecutions2.delete(F.id),this._notProvidedCustomExecutions.delete(F.id));const H=this._notProvidedCustomExecutions.values();let O=H.next();for(;!O.done;)!this._activeCustomExecutions2.has(O.value)&&this._lastStartedTask!==O.value&&(this._providedCustomExecutions2.delete(O.value),this._notProvidedCustomExecutions.delete(O.value)),O=H.next()}};C=ze([$e(0,m.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,b.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,S.IExtHostTerminalService),$e(6,o.ILogService),$e(7,g.IExtHostApiDeprecationService)],C),e.ExtHostTaskBase=C;let L=class extends C{constructor(F,K,H,O,ee,ue,oe,le){super(F,K,H,O,ee,ue,oe,le),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(F,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const H=T.from(K,F);if(H===void 0)throw new Error("Task is not valid");if(c.is(H.execution))await this.addCustomExecution(H,K,!1);else throw new l.NotSupportedError;const O=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),K);return this._proxy.$executeTask(H).catch(ee=>{throw new Error(ee)}),O}provideTasksInternal(F,K,H,O){const ee=[];if(O)for(const ue of O){this.checkDeprecation(ue,H),(!ue.definition||!F[ue.definition.type])&&this._logService.warn(`The task [${ue.source}, ${ue.name}] uses an undefined task type. The task will be ignored in the future.`);const oe=T.from(ue,H.extension);oe&&c.is(oe.execution)?(ee.push(oe),K.push(this.addCustomExecution(oe,ue,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:H.extension}}async resolveTaskInternal(F){if(c.is(F.execution))return F;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(F,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,K,H){}};L=ze([$e(0,m.IExtHostRpcService),$e(1,k.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,b.IExtHostDocumentsAndEditors),$e(4,P.IExtHostConfiguration),$e(5,S.IExtHostTerminalService),$e(6,o.ILogService),$e(7,g.IExtHostApiDeprecationService)],L),e.WorkerExtHostTask=L,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(Ce[227],Ie([1,0,19,20,43,34,22,203,41]),function(ie,e,a,p,w,M,y,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(m,k,f){this.config=m,this.provider=k,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&M.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&M.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const k=this.config.folderQueries||[];return new Promise((f,h)=>{const d=o=>{this.resultCount++,m(o)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(o=>{const g=o.toString(),E=a.basename(g);this.globalExcludePattern&&this.globalExcludePattern(g,E)||this.matchFile(d,{base:o,basename:E})}),Promise.all(k.map(o=>this.searchInFolder(o,d))).then(o=>{f({limitHit:this.isLimitHit,stats:o[0]||void 0})},o=>{h(new Error((0,w.toErrorMessage)(o)))})})}async searchInFolder(m,k){const f=new p.CancellationTokenSource,h=this.getSearchOptionsForFolder(m),d=this.initDirectoryTree(),o=new b.QueryGlobTester(this.config,m),g=!o.hasSiblingExcludeClauses();let E;try{this.activeCancellationTokens.add(f),E=A.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,f.token),D=E.elapsed(),i=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(u=>{const n=a.posix.relative(m.folder.path,u.path);if(g){const r=a.basename(u.path);this.matchFile(k,{base:m.folder,relativePath:n,basename:r});return}this.addDirectoryEntries(d,m.folder,n,k)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,o,k),{providerTime:D,postProcessTime:i.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(m){const k=(0,b.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),f=(0,b.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:k,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},k,f,h){if(f===this.filePattern){const o=a.basename(this.filePattern);this.matchFile(h,{base:k,relativePath:this.filePattern,basename:o})}function d(o){const g=a.basename(o),E=a.dirname(o);let l=m[E];l||(l=m[E]=[],d(E)),l.push({base:k,relativePath:o,basename:g})}d(f)}matchDirectoryTree({rootEntries:m,pathToEntries:k},f,h){const d=this,o=this.filePattern;function g(E){const l=(0,b.hasSiblingFn)(()=>E.map(D=>D.basename));for(let D=0,i=E.length;D<i;D++){const u=E[D],{relativePath:n,basename:r}=u;if(f.matchesExcludesSync(n,r,o!==r?l:void 0))continue;const s=k[n];if(s)g(s);else{if(n===o)continue;d.matchFile(h,u)}if(d.isLimitHit)break}}g(m)}matchFile(m,k){(!this.includePattern||k.relativePath&&this.includePattern(k.relativePath,k.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(k))}}class R{constructor(){this.sessions=new Map}fileSearch(m,k,f,h){const d=this.getSessionTokenSource(m.cacheKey),o=new P(m,k,d&&d.token);let g=0;const E=l=>{g+=l.length,f(l.map(D=>this.rawMatchToSearchItem(D)))};return this.doSearch(o,R.BATCH_SIZE,E,h).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:g,detailStats:l.stats}}))}clearCache(m){this.getSessionTokenSource(m)?.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new p.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:y.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,k,f,h){h.onCancellationRequested(()=>{m.cancel()});const d=g=>{g&&(o.push(g),k>0&&o.length>=k&&(f(o),o=[]))};let o=[];return m.search(d).then(g=>(o.length&&f(o),g),g=>(o.length&&f(o),Promise.reject(g)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(Ce[228],Ie([1,0,16,72,34,76,24,12,19,22,9,10,2,245,144,58,15,45,91,226,41]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f,h,d,o,g,E,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let D=class{constructor(v,T,U,V,x){this.configurationService=v,this.workspaceContextService=T,this.editorGroupsService=U,this.logService=V,this.pathService=x}text(v,T,U={}){v=this.getContentPattern(v,U);const V=this.configurationService.getValue(),x=T&&T.some(L=>!this.configurationService.getValue({resource:L}).search.useRipgrep);return{...this.commonQuery(T?.map(o.toWorkspaceFolder),U),type:2,contentPattern:v,previewOptions:U.previewOptions,maxFileSize:U.maxFileSize,usePCRE2:V.search.usePCRE2||x||!1,beforeContext:U.beforeContext,afterContext:U.afterContext,userDisabledExcludesAndIgnoreFiles:U.disregardExcludeSettings&&U.disregardIgnoreFiles}}getContentPattern(v,T){const U=this.configurationService.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const V={...v,wordSeparators:U.editor.wordSeparators};return this.isCaseSensitive(v,T)&&(V.isCaseSensitive=!0),this.isMultiline(v)&&(V.isMultiline=!0),V}file(v,T={}){return{...this.commonQuery(v,T),type:1,filePattern:T.filePattern?T.filePattern.trim():T.filePattern,exists:T.exists,sortByScore:T.sortByScore,cacheKey:T.cacheKey}}handleIncludeExclude(v,T){return v?(v=Array.isArray(v)?v.map(s):s(v),T?this.parseSearchPaths(v):{pattern:u(...Array.isArray(v)?v:[v])}):{}}commonQuery(v=[],T={}){const U=this.handleIncludeExclude(T.includePattern,T.expandPatterns),V=this.handleIncludeExclude(T.excludePattern,T.expandPatterns),x=v.length>1,C=(U.searchPaths&&U.searchPaths.length?U.searchPaths.map(F=>this.getFolderQueryForSearchPath(F,T,V)):v.map(F=>this.getFolderQueryForRoot(F,T,V,x))).filter(F=>!!F),L={_reason:T._reason,folderQueries:C,usingSearchPaths:!!(U.searchPaths&&U.searchPaths.length),extraFileResources:T.extraFileResources,excludePattern:V.pattern,includePattern:U.pattern,onlyOpenEditors:T.onlyOpenEditors,maxResults:T.maxResults};if(T.onlyOpenEditors){const F=a.coalesce(a.flatten(this.editorGroupsService.groups.map(O=>O.editors.map(ee=>ee.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const K=F.filter(O=>(0,l.pathIncludedInQuery)(L,O.fsPath)),H=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(H)),{...L,...H}}const B=T.extraFileResources&&T.extraFileResources.filter(F=>(0,l.pathIncludedInQuery)(L,F.fsPath));return L.extraFileResources=B&&B.length?B:void 0,L}commonQueryFromFileList(v){const T=[],U=new y.ResourceMap,V={};let x=!1;return v.forEach(C=>{if(C.scheme===A.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(C)){const B=this.workspaceContextService.getWorkspaceFolder(C)?.uri??C.with({path:b.dirname(C.fsPath)});let F=U.get(B);F||(x=!0,F={folder:B,includePattern:{}},T.push(F),U.set(B,F));const K=b.relative(B.fsPath,C.fsPath);(0,S.assertIsDefined)(F.includePattern)[K.replace(/\\/g,"/")]=!0}else C.fsPath&&(x=!0,V[C.fsPath]=!0)}),{folderQueries:T,includePattern:V,usingSearchPaths:!0,excludePattern:x?void 0:{"**/*":!0}}}isCaseSensitive(v,T){if(T.isSmartCase){if(v.isRegExp){if(R.containsUppercaseCharacter(v.pattern,!0))return!0}else if(R.containsUppercaseCharacter(v.pattern))return!0}return!!v.isCaseSensitive}isMultiline(v){return v.isMultiline||v.isRegExp&&(0,k.isMultilineRegexSource)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const T=H=>b.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),V=(Array.isArray(v)?v:n(v)).map(H=>{const O=this.pathService.resolvedUserHome;return O?(0,M.untildify)(H,O.scheme===A.Schemas.file?O.fsPath:O.path):H}),x=p.groupBy(V,H=>T(H)?"searchPaths":"exprSegments"),C=(x.exprSegments||[]).map(H=>R.rtrim(H,"/")).map(H=>R.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),r(H))),L={},B=this.expandSearchPathPatterns(x.searchPaths||[]);B&&B.length&&(L.searchPaths=B);const F=a.flatten(C),K=u(...F);return K&&(L.pattern=K),L}getExcludesForFolder(v,T){return T.disregardExcludeSettings?void 0:(0,l.getExcludes)(v,!T.disregardSearchExcludeSettings)}expandSearchPathPatterns(v){if(!v||!v.length)return[];const T=a.flatten(v.map(V=>{let{pathPortion:x,globPortion:C}=i(V);C&&(C=t(C));const L=this.expandOneSearchPath(x);return a.flatten(L.map(B=>this.resolveOneSearchPathPattern(B,C)))})),U=new Map;return T.forEach(V=>{const x=V.searchPath.toString(),C=U.get(x);C?V.pattern&&(C.pattern=C.pattern||{},C.pattern[V.pattern]=!0):U.set(x,{searchPath:V.searchPath,pattern:V.pattern?u(V.pattern):void 0})}),Array.from(U.values())}expandOneSearchPath(v){if(b.isAbsolute(v)){const T=this.workspaceContextService.getWorkspace().folders;return T[0]&&T[0].uri.scheme!==A.Schemas.file?[{searchPath:T[0].uri.with({path:v})}]:[{searchPath:m.URI.file(b.normalize(v))}]}if(this.workspaceContextService.getWorkbenchState()===2){const T=this.workspaceContextService.getWorkspace().folders[0].uri;if(v=s(v),v.startsWith("../")||v===".."){const V=b.posix.resolve(T.path,v);return[{searchPath:T.with({path:V})}]}const U=t(v);return[{searchPath:T,pattern:U}]}else{if(v==="./"||v===".\\")return[];{const T=v.replace(/^\.[\/\\]/,""),V=this.workspaceContextService.getWorkspace().folders.map(x=>{const C=T.match(new RegExp(`^${R.escapeRegExpCharacters(x.name)}(?:/(.*)|$)`));return C?{match:C,folder:x}:null}).filter(S.isDefined);if(V.length)return V.map(x=>{const C=x.match[1];return{searchPath:x.folder.uri,pattern:C&&t(C)}});{const x=v.match(/\.[\/\\](.+)[\/\\]?/),C=x?x[1]:v,L=f.localize(0,null,C);throw new Error(L)}}}}resolveOneSearchPathPattern(v,T){const U=v.pattern&&T?`${v.pattern}/${T}`:v.pattern||T,V=[{searchPath:v.searchPath,pattern:U}];return U&&!U.endsWith("**")&&V.push({searchPath:v.searchPath,pattern:U+"/**"}),V}getFolderQueryForSearchPath(v,T,U){const V=this.getFolderQueryForRoot((0,o.toWorkspaceFolder)(v.searchPath),T,U,!1);return V?{...V,includePattern:v.pattern}:null}getFolderQueryForRoot(v,T,U,V){let x;const C=m.URI.isUri(v)?v:v.uri;if(U.searchPaths){const H=U.searchPaths.filter(O=>(0,P.isEqual)(O.searchPath,C))[0];if(H&&!H.pattern)return null;H&&(x=H.pattern)}const L=this.configurationService.getValue({resource:C}),F={...this.getExcludesForFolder(L,T)||{},...x||{}},K=m.URI.isUri(v)?(0,P.basename)(v):v.name;return{folder:C,folderName:V?K:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:L.files&&L.files.encoding,disregardIgnoreFiles:typeof T.disregardIgnoreFiles=="boolean"?T.disregardIgnoreFiles:!L.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof T.disregardGlobalIgnoreFiles=="boolean"?T.disregardGlobalIgnoreFiles:!L.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof T.disregardParentIgnoreFiles=="boolean"?T.disregardParentIgnoreFiles:!L.search.useParentIgnoreFiles,ignoreSymlinks:typeof T.ignoreSymlinks=="boolean"?T.ignoreSymlinks:!L.search.followSymlinks}}};D=ze([$e(0,h.IConfigurationService),$e(1,o.IWorkspaceContextService),$e(2,g.IEditorGroupsService),$e(3,d.ILogService),$e(4,E.IPathService)],D),e.QueryBuilder=D;function i(_){const v=_.match(/[\*\{\}\(\)\[\]\?]/);if(v){const T=v.index,U=_.substr(0,T).match(/[/|\\][^/\\]*$/);if(U){let V=_.substr(0,U.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:_.substr((U.index||0)+1)}}}return{pathPortion:_}}function u(..._){return _.length?_.reduce((v,T)=>(v[T]=!0,v),Object.create(null)):void 0}function n(_){return w.splitGlobAware(_,",").map(v=>v.trim()).filter(v=>!!v.length)}function r(_){return[`**/${_}/**`,`**/${_}`].map(T=>T.replace(/\*\*\/\*\*/g,"**"))}function s(_){return _.replace(/\\/g,"/")}function t(_){return s(_).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(_,v){_=a.distinct(_,V=>V.toString());const T=[],U=v.getWorkspace();return _&&_.forEach(V=>{let x;if(v.getWorkbenchState()===2)x=(0,P.relativePath)(U.folders[0].uri,V),x&&x!=="."&&(x="./"+x);else{const C=v.getWorkspaceFolder(V);if(C){const L=C.name;if(U.folders.filter(F=>F.name===L).length===1){const F=(0,P.relativePath)(C.uri,V);F===""?x=`./${C.name}`:x=`./${C.name}/${F}`}else x=V.fsPath}}x&&T.push(x)}),T}e.resolveResourcesForSearchIncludes=c}),define(Ce[229],Ie([1,0,22,2,20,11,3,228,41,45]),function(ie,e,a,p,w,M,y,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function S(h,d){const o=d.activationEvents;if(!o)return Promise.resolve(void 0);const g=[],E=[];for(const r of o)if(/^workspaceContains:/.test(r)){const s=r.substr(18);s.indexOf("*")>=0||s.indexOf("?")>=0||h.forceUsingSearch?E.push(s):g.push(s)}if(g.length===0&&E.length===0)return Promise.resolve(void 0);let l;const D=new Promise((r,s)=>{l=r}),i=r=>l({activationEvent:r}),u=Promise.all(g.map(r=>m(h,r,i))).then(()=>{}),n=k(h,d.identifier,E,i);return Promise.all([u,n]).then(()=>{l(void 0)}),D}e.checkActivateWorkspaceContainsExtension=S;async function m(h,d,o){for(const g of h.folders)if(await h.exists(a.joinPath(p.URI.revive(g),d))){o(`workspaceContains:${d}`);return}}async function k(h,d,o,g){if(o.length===0)return Promise.resolve(void 0);const E=new w.CancellationTokenSource,l=h.checkExists(h.folders,o,E.token),D=setTimeout(async()=>{E.cancel(),h.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},R);let i=!1;try{i=await l}catch(u){M.isCancellationError(u)||M.onUnexpectedError(u)}E.dispose(),clearTimeout(D),i&&g(`workspaceContains:${o.join(",")}`)}function f(h,d,o,g){const E=h.get(y.IInstantiationService),l=h.get(b.ISearchService),i=E.createInstance(A.QueryBuilder).file(d.map(u=>(0,P.toWorkspaceFolder)(p.URI.revive(u))),{_reason:"checkExists",includePattern:o,exists:!0});return l.fileSearch(i,g).then(u=>!!u.limitHit,u=>M.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=f});var Je=this&&this.__classPrivateFieldSet||function(ie,e,a,p,w){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?w.call(ie,a):w?w.value=a:e.set(ie,a),a},Oe=this&&this.__classPrivateFieldGet||function(ie,e,a,p){if(a==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!p:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?p:a==="a"?p.call(ie):p?p.value:e.get(ie)};define(Ce[33],Ie([1,0,131,19,71,22,14,7,24,2,15,4,32,180,69,31,27,179,11,26,23,158,6,84,3,28,70,13,59,63,53,5,229,68,160,12]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f,h,d,o,g,E,l,D,i,u,n,r,s,t,c,_,v,T,U,V,x,C){"use strict";var L,B,F;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let K=class Ti extends A.Disposable{constructor(te,Ee,be,ne,ve,Pe,Fe,xe,Qe,ke){super(),this._onDidChangeRemoteConnectionData=this._register(new T.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=Ee,this._extHostContext=be,this._initData=Fe,this._extHostWorkspace=ne,this._extHostConfiguration=ve,this._logService=Pe,this._extHostTunnelService=Qe,this._extHostTerminalService=ke,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(S.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(S.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(S.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._globalRegistry=new o.ExtensionDescriptionRegistry(this._initData.allExtensions);const Se=(0,d.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new o.ExtensionDescriptionRegistry(ee(this._globalRegistry,Se)),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new V.ExtHostSecretState(this._extHostContext),this._storagePath=xe,this._instaService=te.createChild(new c.ServiceCollection([f.IExtHostStorage,this._storage],[V.IExtHostSecretState,this._secretState]));let ye=[],ae=[];this._initData.remote.isRemote&&(ye=this._initData.allExtensions.filter(Q=>!Q.main&&!Q.browser).map(Q=>Q.identifier),ae=this._initData.allExtensions.filter(Q=>!Se.has(E.ExtensionIdentifier.toKey(Q.identifier.value))).filter(Q=>(Q.main||Q.browser)&&Q.api==="none").map(Q=>Q.identifier));const ce=(0,d.extensionIdentifiersArrayToSet)(ae);this._activator=this._register(new k.ExtensionsActivator(this._myRegistry,ye,ae,{onExtensionActivationError:(Q,J,I)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Q,g.transformErrorForSerialization(J),I)},actualActivateExtension:async(Q,J)=>{if(ce.has(E.ExtensionIdentifier.toKey(Q)))return await this._mainThreadExtensionsProxy.$activateExtension(Q,J),new k.HostExtension;const I=this._myRegistry.getExtensionDescription(Q);return this._activateExtension(I,J)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),w.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(te){g.onUnexpectedError(te)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let te=[];try{te=this._myRegistry.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this._deactivate(ve))}catch{}await Promise.all(te)}terminate(te,Ee=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${te}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),g.setUnexpectedErrorHandler(ne=>{this._logService.error(ne)}),this._extHostContext.dispose();const be=this._deactivateAll();Promise.race([(0,y.timeout)(5e3),be]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${Ee}`):this._logService.info(`Extension host exiting with code ${Ee}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(Ee)})}isActivated(te){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(te):!1}async getExtension(te){const Ee=await this._mainThreadExtensionsProxy.$getExtension(te);let be;if(Ee?.browserNlsBundleUris){be={};for(const ne of Object.keys(Ee.browserNlsBundleUris))be[ne]=P.URI.revive(Ee.browserNlsBundleUris[ne])}return Ee&&{...Ee,identifier:new E.ExtensionIdentifier(Ee.identifier.value),extensionLocation:P.URI.revive(Ee.extensionLocation),browserNlsBundleUris:be}}_activateByEvent(te,Ee){return this._activator.activateByEvent(te,Ee)}_activateById(te,Ee){return this._activator.activateById(te,Ee)}activateByIdWithErrors(te,Ee){return this._activateById(te,Ee).then(()=>{const be=this._activator.getActivatedExtension(te);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(te=>this._myRegistry)}getExtensionExports(te){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(te).exports:null}async _realPathExtensionUri(te){if(te.scheme!==C.Schemas.file)return te;const Ee=await this._hostUtils.realpath(te.fsPath);return P.URI.file(Ee)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(te=>new oe(te))),this._extensionPathIndex}async _createExtensionPathIndex(te){const Ee=b.TernarySearchTree.forUris(be=>M.extUriBiasedIgnorePathCase.ignorePathCasing(be));return await Promise.all(te.map(async be=>{if(this._getEntryPoint(be)){const ne=await this._realPathExtensionUri(be.extensionLocation);Ee.set(ne,be)}})),Ee}_deactivate(te){let Ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(te))return Ee;const be=this._activator.getActivatedExtension(te);if(!be)return Ee;try{typeof be.module.deactivate=="function"&&(Ee=Promise.resolve(be.module.deactivate()).then(void 0,ne=>(this._logService.error(ne),Promise.resolve(void 0))))}catch(ne){this._logService.error(`An error occurred when deactivating the extension '${te.value}':`),this._logService.error(ne)}try{(0,A.dispose)(be.subscriptions)}catch(ne){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this._logService.error(ne)}return Ee}async _activateExtension(te,Ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(te.identifier),this._doActivateExtension(te,Ee).then(be=>{const ne=be.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(te.identifier,ne.codeLoadingTime,ne.activateCallTime,ne.activateResolvedTime,Ee),this._logExtensionActivationTimes(te,Ee,"success",ne),be},be=>{throw this._logExtensionActivationTimes(te,Ee,"failure"),be})}_logExtensionActivationTimes(te,Ee,be,ne){const ve=H(te,Ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ve,...ne||{},outcome:be})}_doActivateExtension(te,Ee){const be=H(te,Ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",be);const ne=this._getEntryPoint(te);if(!ne)return Promise.resolve(new k.EmptyExtension(k.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${Ee.startup}, activationEvent: '${Ee.activationEvent}'${te.identifier.value!==Ee.extensionId.value?`, root cause: ${Ee.extensionId.value}`:""}`),this._logService.flush();const ve=new k.ExtensionActivationTimesBuilder(Ee.startup);return Promise.all([this._loadCommonJSModule(te,(0,M.joinPath)(te.extensionLocation,ne),ve),this._loadExtensionContext(te)]).then(Pe=>(w.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),Ti._callActivate(this._logService,te.identifier,Pe[0],Pe[1],ve))).then(Pe=>(w.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),Pe))}_loadExtensionContext(te){const Ee=new D.ExtensionGlobalMemento(te,this._storage),be=new D.ExtensionMemento(te.identifier.value,!1,this._storage),ne=new x.ExtensionSecrets(te,this._secretState),ve=te.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Pe=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([Ee.whenReady,be.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let xe,Qe;const ke=(0,d.isProposedApiEnabled)(te,"ipc")?this._initData.messagePorts?.get(E.ExtensionIdentifier.toKey(te.identifier)):void 0;return Object.freeze({globalState:Ee,workspaceState:be,secrets:ne,subscriptions:[],get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(Se){return p.join(te.extensionLocation.fsPath,Se)},get storagePath(){return Fe._storagePath.workspaceValue(te)?.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(te).fsPath},get logPath(){return p.join(Fe._initData.logsLocation.fsPath,te.identifier.value)},get logUri(){return P.URI.joinPath(Fe._initData.logsLocation,te.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(te)},get globalStorageUri(){return Fe._storagePath.globalValue(te)},get extensionMode(){return ve},get extension(){return xe===void 0&&(xe=new O(Fe,te.identifier,te,Pe,!1)),xe},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(te,"extensionRuntime"),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!Qe){if(!ke)return;const Se=T.Event.buffer(T.Event.fromDOMEventEmitter(ke,"message",ye=>ye.data));ke.start(),Qe={onDidReceiveMessage:Se,postMessage:ke.postMessage.bind(ke)}}return Qe}})})}static _callActivate(te,Ee,be,ne,ve){return be=be||{activate:void 0,deactivate:void 0},this._callActivateOptional(te,Ee,be,ne,ve).then(Pe=>new k.ActivatedExtension(!1,null,ve.build(),be,Pe,ne.subscriptions))}static _callActivateOptional(te,Ee,be,ne,ve){if(typeof be.activate=="function")try{ve.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${Ee.value}`);const Pe=typeof global=="object"?global:self,Fe=be.activate.apply(Pe,[ne]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Fe).then(xe=>(ve.activateResolveStop(),xe))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(be)}_activateOneStartupFinished(te,Ee){this._activateById(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:Ee}).then(void 0,be=>{this._logService.error(be)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(w.getMarks());for(const te of this._myRegistry.getAllExtensionDescriptions())if(te.activationEvents)for(const Ee of te.activationEvents)Ee==="onStartupFinished"&&this._activateOneStartupFinished(te,Ee)}_handleEagerExtensions(){const te=this._activateByEvent("*",!0).then(void 0,ve=>{this._logService.error(ve)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ve=>this._handleWorkspaceContainsEagerExtensions(ve.added)));const Ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],be=this._handleWorkspaceContainsEagerExtensions(Ee),ne=Promise.all([te,be]).then(()=>{});return Promise.race([ne,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ne}_handleWorkspaceContainsEagerExtensions(te){return te.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(Ee=>this._handleWorkspaceContainsEagerExtension(te,Ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(te,Ee){if(this.isActivated(Ee.identifier))return;const be=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ne={logService:this._logService,folders:te.map(Pe=>Pe.uri),forceUsingSearch:be,exists:Pe=>this._hostUtils.exists(Pe.fsPath),checkExists:(Pe,Fe,xe)=>this._mainThreadWorkspaceProxy.$checkExists(Pe,Fe,xe)},ve=await(0,U.checkActivateWorkspaceContainsExtension)(ne,Ee);if(!!ve)return this._activateById(Ee.identifier,{startup:!0,extensionId:Ee.identifier,activationEvent:ve.activationEvent}).then(void 0,Pe=>this._logService.error(Pe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(te){throw console.error(te),te}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:Ee}=this._initData.environment;if(!te||!Ee)throw new Error(a.localize(0,null));const be=await this._loadCommonJSModule(null,Ee,new k.ExtensionActivationTimesBuilder(!1));if(!be||typeof be.run!="function")throw new Error(a.localize(1,null,Ee.toString()));return new Promise((ne,ve)=>{const Pe=(Qe,ke)=>{Qe?ve(Qe):ne(typeof ke=="number"&&ke>0?1:0)},Fe=(0,M.originalFSPath)(Ee),xe=be.run(Fe,Pe);xe&&xe.then&&xe.then(()=>{ne(0)}).catch(Qe=>{ve(Qe instanceof Error&&Qe.stack?Qe.stack:String(Qe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,Ee){return this._resolvers[te]=Ee,(0,A.toDisposable)(()=>{delete this._resolvers[te]})}async _activateAndGetResolver(te){const Ee=te.indexOf("+");if(Ee===-1)throw new Error("Not an authority that can be resolved!");const be=te.substr(0,Ee);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this._resolvers[be]}}async $resolveAuthority(te,Ee){this._logService.info(`$resolveAuthority invoked for authority (${ue(te)})`);const{authorityPrefix:be,resolver:ne}=await this._activateAndGetResolver(te);if(!ne)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${be}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ne)),w.mark(`code/extHost/willResolveAuthority/${be}`);const ve=await ne.resolve(te,{resolveAttempt:Ee});w.mark(`code/extHost/didResolveAuthorityOK/${be}`);const Pe={authority:te,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},Fe={extensionHostEnv:ve.extensionHostEnv,isTrusted:ve.isTrusted,authenticationSession:ve.authenticationSessionForInitializingExtensions?{id:ve.authenticationSessionForInitializingExtensions.id,providerId:ve.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Pe,options:Fe,tunnelInformation:{environmentTunnels:ve.environmentTunnels,features:ve.tunnelFeatures}}}}catch(ve){if(w.mark(`code/extHost/didResolveAuthorityError/${be}`),ve instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}async $getCanonicalURI(te,Ee){this._logService.info(`$getCanonicalURI invoked for authority (${ue(te)})`);const{resolver:be}=await this._activateAndGetResolver(te);if(!be)return null;const ne=P.URI.revive(Ee);if(typeof be.getCanonicalURI>"u")return ne;const ve=await(0,y.asPromise)(()=>be.getCanonicalURI(ne));return ve||ne}static _applyExtensionsDelta(te,Ee,be){const ne=new o.ExtensionDescriptionRegistry(te.getAllExtensionDescriptions());ne.deltaExtensions(be.toAdd,be.toRemove);const ve=(0,d.extensionIdentifiersArrayToSet)(Ee.getAllExtensionDescriptions().map(Fe=>Fe.identifier));for(const Fe of be.myToRemove)ve.delete(E.ExtensionIdentifier.toKey(Fe));for(const Fe of be.myToAdd)ve.add(E.ExtensionIdentifier.toKey(Fe));const Pe=ee(ne,ve);return{globalRegistry:ne,myExtensions:Pe}}$startExtensionHost(te){te.toAdd.forEach(ne=>ne.extensionLocation=P.URI.revive(ne.extensionLocation));const{globalRegistry:Ee,myExtensions:be}=Ti._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te);return this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(be),this._startExtensionHost()}$activateByEvent(te,Ee){return Ee===1?this._activateByEvent(te,!1):this._readyToRunExtensions.wait().then(be=>this._activateByEvent(te,!1))}async $activate(te,Ee){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(te)?(await this._activateById(te,Ee),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(Pe=>Pe.extensionLocation=P.URI.revive(Pe.extensionLocation));const{globalRegistry:Ee,myExtensions:be}=Ti._applyExtensionsDelta(this._globalRegistry,this._myRegistry,te),ne=await this._createExtensionPathIndex(be);return(await this.getExtensionPathIndex()).setSearchTree(ne),this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(be),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const Ee=l.VSBuffer.alloc(te),be=Math.random()%256;for(let ne=0;ne<te;ne++)Ee.writeUInt8(be,ne);return Ee}async $updateRemoteConnectionData(te){this._remoteConnectionData=te,this._onDidChangeRemoteConnectionData.fire()}};K=ze([$e(0,n.IInstantiationService),$e(1,e.IHostUtils),$e(2,t.IExtHostRpcService),$e(3,h.IExtHostWorkspace),$e(4,m.IExtHostConfiguration),$e(5,R.ILogService),$e(6,r.IExtHostInitDataService),$e(7,s.IExtensionStoragePaths),$e(8,_.IExtHostTunnelService),$e(9,v.IExtHostTerminalService)],K),e.AbstractExtHostExtensionService=K;function H(le,te){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class O{constructor(te,Ee,be,ne,ve){L.set(this,void 0),B.set(this,void 0),F.set(this,void 0),Je(this,L,te,"f"),Je(this,B,Ee,"f"),Je(this,F,be.identifier,"f"),this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=p.normalize((0,M.originalFSPath)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=ne,this.isFromDifferentExtensionHost=ve}get isActive(){return Oe(this,L,"f").isActivated(Oe(this,F,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,L,"f").getExtensionExports(Oe(this,F,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,L,"f").activateByIdWithErrors(Oe(this,F,"f"),{startup:!1,extensionId:Oe(this,B,"f"),activationEvent:"api"}),this.exports}}e.Extension=O,L=new WeakMap,B=new WeakMap,F=new WeakMap;function ee(le,te){return le.getAllExtensionDescriptions().filter(Ee=>te.has(E.ExtensionIdentifier.toKey(Ee.identifier)))}function ue(le){const te=le.indexOf("+");return te===-1?le:le.substring(0,te)}class oe{constructor(te){this._searchTree=te}setSearchTree(te){this._searchTree=te}findSubstr(te){return this._searchTree.findSubstr(te)}forEach(te){return this._searchTree.forEach(te)}}e.ExtensionPaths=oe}),define(Ce[230],Ie([1,0,71,2,4,32,27,26,13,28,3,33,60,15,9]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(D,i,u,n,r,s,t){this._apiFactory=D,this._extensionRegistry=i,this._instaService=u,this._extHostConfiguration=n,this._extHostExtensionService=r,this._initData=s,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),a.mark("code/extHost/willWaitForConfig");const D=await this._extHostConfiguration.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const i=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,i,this._extensionRegistry,D,this._logService)),this.register(this._instaService.createInstance(g,i)),this.register(this._instaService.createInstance(d)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(E,i,this._initData.environment.appUriScheme))}register(D){if("nodeModuleName"in D)if(Array.isArray(D.nodeModuleName))for(const i of D.nodeModuleName)this._factories.set(i,D);else this._factories.set(D.nodeModuleName,D);typeof D.alternativeModuleName=="function"&&this._alternatives.push(i=>D.alternativeModuleName(i))}};h=ze([$e(2,R.IInstantiationService),$e(3,M.IExtHostConfiguration),$e(4,S.IExtHostExtensionService),$e(5,P.IExtHostInitDataService),$e(6,k.ILogService)],h),e.RequireInterceptor=h;let d=class Gi{constructor(D){if(D.environment.appRoot&&Gi.aliased.size){const i=(0,f.escapeRegExpCharacters)(this.forceForwardSlashes(D.environment.appRoot.fsPath)),u="[a-z0-9_.-]",n=`@${u}+\\/${u}+|${u}+`,r="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${i}/${r}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(D){if(!this.re)return;const i=this.re.exec(this.forceForwardSlashes(D));if(!i)return;const[,u,n,r]=i,s=Gi.aliased.get(n);if(s!==void 0)return console.warn(`${n} as been renamed to ${s}, please update your imports`),u+s+r}forceForwardSlashes(D){return D.replace(/\\/g,"/")}};d.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=ze([$e(0,P.IExtHostInitDataService)],d);class o{constructor(D,i,u,n,r){this._apiFactory=D,this._extensionPaths=i,this._extensionRegistry=u,this._configProvider=n,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(D,i){const u=this._extensionPaths.findSubstr(i);if(u){let n=this._extApiImpl.get(A.ExtensionIdentifier.toKey(u.identifier));return n||(n=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(u.identifier),n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((r,s)=>n+=`	${s} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(D,i,u){this._extensionPaths=D,this.nodeModuleName="keytar",this._mainThreadTelemetry=i.getProxy(w.MainContext.MainThreadTelemetry);const{environment:n}=u,r=i.getProxy(w.MainContext.MainThreadKeytar);if(n.appRoot){let s=n.appRoot.fsPath;m.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,t)=>r.$getPassword(s,t),setPassword:(s,t,c)=>r.$setPassword(s,t,c),deletePassword:(s,t)=>r.$deletePassword(s,t),findPassword:s=>r.$findPassword(s),findCredentials(s){return r.$findCredentials(s)}}}load(D,i){const u=this._extensionPaths.findSubstr(i);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(D){const i=D.length;if(i<=7||!this.alternativeNames)return;const u=i-7;if((D.charAt(u)==="/"||D.charAt(u)==="\\")&&D.endsWith("keytar")&&(D=D.replace(/\\/g,"/"),this.alternativeNames.has(D)))return"keytar"}};g=ze([$e(1,b.IExtHostRpcService),$e(2,P.IExtHostInitDataService)],g);let E=class{constructor(D,i,u){this._extensionPaths=D,this._appUriScheme=i,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(w.MainContext.MainThreadTelemetry);const n=u.getProxy(w.MainContext.MainThreadWindow);this._impl=(r,s)=>{const t=p.URI.parse(r);return s?this.callOriginal(r,s):t.scheme==="http"||t.scheme==="https"?n.$openUri(t,r,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?n.$openUri(t,r,{}):this.callOriginal(r,s)}}load(D,i,u){const n=this._extensionPaths.findSubstr(i);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=u(D),this._impl}callOriginal(D,i){return this.sendNoForwardTelemetry(),this._original(D,i)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};E=ze([$e(2,b.IExtHostRpcService)],E)}),define(Ce[103],Ie([1,0,197,7,19,60,3,50,51,33,6,31,171,32]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,y.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(o,g,E,l,D,i,u){function n(){if(E){const r=E.activeEditor();if(r)return r.document.uri;const s=l.tabGroups.all.find(t=>t.isActive)?.activeTab;if(s!==void 0){if(s.input instanceof R.TextDiffTabInput||s.input instanceof R.NotebookDiffEditorTabInput)return s.input.modified;if(s.input instanceof R.TextTabInput||s.input instanceof R.NotebookEditorTabInput||s.input instanceof R.CustomEditorTabInput)return s.input.uri}}}super({getFolderUri:r=>{const s=i.folders.filter(t=>t.name===r);if(s&&s.length>0)return s[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(r,s)=>D.getConfiguration(void 0,r).get(s),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const r=n();if(r)return w.normalize(r.fsPath)},getWorkspaceFolderPathForFile:()=>{if(g){const r=n();if(r){const s=g.getWorkspaceFolder(r);if(s)return w.normalize(s.uri.fsPath)}}},getSelectedText:()=>{if(E){const r=E.activeEditor();if(r&&!r.selection.isEmpty)return r.document.getText(r.selection)}},getLineNumber:()=>{if(E){const r=E.activeEditor();if(r)return String(r.selection.end.line+1)}},getExtension:r=>o.getExtension(r)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(M.env))}}let h=class extends p.Disposable{constructor(o,g,E,l,D){super(),this.extensionService=o,this.workspaceService=g,this.editorService=E,this.configurationService=l,this.editorTabs=D,this._resolver=new a.Lazy(async()=>{const i=await this.configurationService.getConfigProvider(),n={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async r=>{n.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new f(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,i,n,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};h=ze([$e(0,P.IExtHostExtensionService),$e(1,S.IExtHostWorkspace),$e(2,A.IExtHostDocumentsAndEditors),$e(3,k.IExtHostConfiguration),$e(4,b.IExtHostEditorTabs)],h),e.ExtHostVariableResolverProviderService=h}),define(Ce[104],Ie([1,0,14,5,10,2,3,4,51,33,13,6,31,164,166,32,103]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,y.createDecorator)("IExtHostDebugService");let o=class{constructor(n,r,s,t,c,_){this._workspaceService=r,this._extensionService=s,this._configurationService=t,this._editorTabs=c,this._variableResolver=_,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new p.Emitter,this._onDidTerminateDebugSession=new p.Emitter,this._onDidChangeActiveDebugSession=new p.Emitter,this._onDidReceiveDebugSessionCustomEvent=new p.Emitter,this._debugServiceProxy=n.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new p.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new E(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(v=>{v.onDidChange(T=>{this.registerAllDebugTypes(v)}),this.registerAllDebugTypes(v)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(n,r){const s=n;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let t=`debug:${encodeURIComponent(s.path||"")}`,c="?";return r&&(t+=`${c}session=${encodeURIComponent(r.id)}`,c="&"),t+=`${c}ref=${s.sourceReference}`,M.URI.parse(t)}else{if(s.path)return M.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const r=[];for(const s of n.getAllExtensionDescriptions())if(s.contributes){const t=s.contributes.debuggers;if(t&&t.length>0)for(const c of t)(0,f.isDebuggerMainContribution)(c)&&r.push(c.type)}this._debugServiceProxy.$registerDebugTypes(r)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const n=[];return this._breakpoints.forEach(r=>n.push(r)),n}addBreakpoints(n){this.startBreakpoints();const r=n.filter(c=>{const _=c.id;return this._breakpoints.has(_)?!1:(this._breakpoints.set(_,c),!0)});this.fireBreakpointChanges(r,[],[]);const s=[],t=new Map;for(const c of r)if(c instanceof S.SourceBreakpoint){let _=t.get(c.location.uri.toString());_||(_={type:"sourceMulti",uri:c.location.uri,lines:[]},t.set(c.location.uri.toString(),_),s.push(_)),_.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof S.FunctionBreakpoint&&s.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this._debugServiceProxy.$registerBreakpoints(s)}removeBreakpoints(n){this.startBreakpoints();const r=n.filter(_=>this._breakpoints.delete(_.id));this.fireBreakpointChanges([],r,[]);const s=r.filter(_=>_ instanceof S.SourceBreakpoint).map(_=>_.id),t=r.filter(_=>_ instanceof S.FunctionBreakpoint).map(_=>_.id),c=r.filter(_=>_ instanceof S.DataBreakpoint).map(_=>_.id);return this._debugServiceProxy.$unregisterBreakpoints(s,t,c)}startDebugging(n,r,s){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,r,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,debugUI:s.debugUI,suppressSaveBeforeStart:s.suppressSaveBeforeStart})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,r,s){if(!r)return new S.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:t,provider:r}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,s,!!r.provideDebugConfigurations,!!r.resolveDebugConfiguration,!!r.resolveDebugConfigurationWithSubstitutedVariables,t),new S.Disposable(()=>{this._configProviders=this._configProviders.filter(c=>c.provider!==r),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(n,r,s){if(!s)return new S.Disposable(()=>{});if(!this.definesDebugType(n,r))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${r}' debugger.`);if(this.getAdapterDescriptorFactoryByType(r))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:r,handle:t,factory:s}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(r,t),new S.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(c=>c.factory!==s),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(n,r){if(!r)return new S.Disposable(()=>{});const s=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:s,factory:r}),new S.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==r)})}async $runInTerminal(n,r){return Promise.resolve(void 0)}async $substituteVariables(n,r){let s;const t=await this.getFolder(n);return t&&(s={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(s,r)}createDebugAdapter(n,r){if(n.type==="implementation")return new D(n.implementation)}createSignService(){}async $startDASession(n,r){const s=this,t=await this.getSession(r);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const _=this.convertToDto(c),v=this.createDebugAdapter(_,t);if(!v)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const T=v;return this._debugAdapters.set(n,T),this.getDebugAdapterTrackers(t).then(U=>(U&&this._debugAdaptersTrackers.set(n,U),T.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const x=V,C={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(x.arguments.value);C.body={signature:L},T.sendResponse(C)}else throw new Error("no signer")}catch(L){C.success=!1,C.message=L.message,T.sendResponse(C)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(V),V=(0,f.convertToVSCPaths)(V,!0),s._debugServiceProxy.$acceptDAMessage(n,V)}),T.onError(V=>{U&&U.onError&&U.onError(V),this._debugServiceProxy.$acceptDAError(n,V.name,V.message,V.stack)}),T.onExit(V=>{U&&U.onExit&&U.onExit((0,w.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(n,(0,w.withNullAsUndefined)(V),void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),T.startSession()))})}$sendDAMessage(n,r){r=(0,f.convertToDAPaths)(r,!1);const s=this._debugAdaptersTrackers.get(n);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(r),this._debugAdapters.get(n)?.sendMessage(r)}$stopDASession(n){const r=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),r&&r.onWillStopSession&&r.onWillStopSession();const s=this._debugAdapters.get(n);return this._debugAdapters.delete(n),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const r=[],s=[],t=[];if(n.added)for(const c of n.added){const _=c.id;if(_&&!this._breakpoints.has(_)){let v;if(c.type==="function")v=new S.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")v=new S.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const T=M.URI.revive(c.uri);v=new S.SourceBreakpoint(new S.Location(T,new S.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}v._id=_,this._breakpoints.set(_,v),r.push(v)}}if(n.removed)for(const c of n.removed){const _=this._breakpoints.get(c);_&&(this._breakpoints.delete(c),s.push(_))}if(n.changed){for(const c of n.changed)if(c.id){const _=this._breakpoints.get(c.id);if(_){if(_ instanceof S.FunctionBreakpoint&&c.type==="function"){const v=_;v.enabled=c.enabled,v.condition=c.condition,v.hitCondition=c.hitCondition,v.logMessage=c.logMessage,v.functionName=c.functionName}else if(_ instanceof S.SourceBreakpoint&&c.type==="source"){const v=_;v.enabled=c.enabled,v.condition=c.condition,v.hitCondition=c.hitCondition,v.logMessage=c.logMessage,v.location=new S.Location(M.URI.revive(c.uri),new S.Position(c.line,c.character))}t.push(_)}}}this.fireBreakpointChanges(r,s,t)}$provideDebugConfigurations(n,r,s){return(0,a.asPromise)(async()=>{const t=this.getConfigProviderByHandle(n);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.getFolder(r);return t.provideDebugConfigurations(c,s)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(n,r,s,t){return(0,a.asPromise)(async()=>{const c=this.getConfigProviderByHandle(n);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const _=await this.getFolder(r);return c.resolveDebugConfiguration(_,s,t)})}$resolveDebugConfigurationWithSubstitutedVariables(n,r,s,t){return(0,a.asPromise)(async()=>{const c=this.getConfigProviderByHandle(n);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const _=await this.getFolder(r);return c.resolveDebugConfigurationWithSubstitutedVariables(_,s,t)})}async $provideDebugAdapter(n,r){const s=this.getAdapterDescriptorFactoryByHandle(n);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(r);return this.getAdapterDescriptor(s,t).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(c)})}async $acceptDebugSessionStarted(n){const r=await this.getSession(n);this._onDidStartDebugSession.fire(r)}async $acceptDebugSessionTerminated(n){const r=await this.getSession(n);r&&(this._onDidTerminateDebugSession.fire(r),this._debugSessions.delete(r.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,r){(await this.getSession(n))?._acceptNameChanged(r)}async $acceptDebugSessionCustomEvent(n,r){const t={session:await this.getSession(n),event:r.event,body:r.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(n){if(n instanceof S.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof S.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof S.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof S.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const r=this._adapterFactories.filter(s=>s.type===n);if(r.length>0)return r[0].factory}getAdapterDescriptorFactoryByHandle(n){const r=this._adapterFactories.filter(s=>s.handle===n);if(r.length>0)return r[0].factory}getConfigProviderByHandle(n){const r=this._configProviders.filter(s=>s.handle===n);if(r.length>0)return r[0].provider}definesDebugType(n,r){if(n.contributes){const s=n.contributes.debuggers;if(s&&s.length>0){for(const t of s)if(t.label&&t.type&&t.type===r)return!0}}return!1}getDebugAdapterTrackers(n){const s=n.configuration.type,t=this._trackerFactories.filter(c=>c.type===s||c.type==="*").map(c=>(0,a.asPromise)(()=>c.factory.createDebugAdapterTracker(n)).then(_=>_,_=>null));return Promise.race([Promise.all(t).then(c=>{const _=c.filter(v=>!!v);if(_.length>0)return new l(_)}),new Promise((c,_)=>{const v=setTimeout(()=>{clearTimeout(v),_(new Error("timeout"))},1e3)})]).catch(c=>{})}async getAdapterDescriptor(n,r){const s=r.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new S.DebugAdapterServer(s));if(n){const c=await this._extensionService.getExtensionRegistry();return(0,a.asPromise)(()=>n.createDebugAdapterDescriptor(r,this.daExecutableFromPackage(r,c))).then(_=>{if(_)return _})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(r,t))}daExecutableFromPackage(n,r){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(n,r,s){(n.length>0||r.length>0||s.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:r,changed:s}))}async getSession(n){if(n)if(typeof n=="string"){const r=this._debugSessions.get(n);if(r)return r}else{let r=this._debugSessions.get(n.id);if(!r){const s=await this.getFolder(n.folderUri),t=n.parent?this._debugSessions.get(n.parent):void 0;r=new g(this._debugServiceProxy,n.id,n.type,n.name,s,n.configuration,t),this._debugSessions.set(r.id,r),this._debugServiceProxy.$sessionCached(r.id)}return r}throw new Error("cannot find session")}getFolder(n){if(n){const r=M.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(r)}return Promise.resolve(void 0)}};o=ze([$e(0,R.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,h.IExtHostConfiguration),$e(4,b.IExtHostEditorTabs),$e(5,d.IExtHostVariableResolverProvider)],o),e.ExtHostDebugServiceBase=o;class g{constructor(n,r,s,t,c,_,v){this._debugServiceProxy=n,this._id=r,this._type=s,this._name=t,this._workspaceFolder=c,this._configuration=_,this._parentSession=v}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}get parentSession(){return this._parentSession}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,r){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,r)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=g;class E{constructor(n){this.value=Object.freeze({append(r){n.$appendDebugConsole(r)},appendLine(r){this.append(r+`
`)}})}}e.ExtHostDebugConsole=E;class l{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(r=>r.onWillReceiveMessage?r.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(r=>r.onDidSendMessage?r.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(r=>r.onError?r.onError(n):void 0)}onExit(n,r){this.trackers.forEach(s=>s.onExit?s.onExit(n,r):void 0)}}class D extends k.AbstractDebugAdapter{constructor(n){super(),this.implementation=n,n.onDidSendMessage(r=>{this.acceptMessage(r)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=class extends o{constructor(n,r,s,t,c,_){super(n,r,s,t,c,_)}};i=ze([$e(0,R.IExtHostRpcService),$e(1,m.IExtHostWorkspace),$e(2,P.IExtHostExtensionService),$e(3,h.IExtHostConfiguration),$e(4,b.IExtHostEditorTabs),$e(5,d.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(Ce[231],Ie([1,0,11,71,2,4,222,15,57,59,28,148,13,46,33]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class h{constructor(o,g,E,l,D){this._hostUtils=E,this._rpcProtocol=new y.RPCProtocol(o,null,l),g=h._transform(g,this._rpcProtocol);const i=new P.ServiceCollection(...(0,b.getSingletonServiceDescriptors)());i.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...g,messagePorts:D}),i.set(m.IExtHostRpcService,new m.ExtHostRpcService(this._rpcProtocol)),i.set(k.IURITransformerService,new k.URITransformerService(l)),i.set(f.IHostUtils,E);const u=new S.InstantiationService(i,!0);this._logService=u.invokeFunction(t=>t.get(A.ILogService)),p.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",g),this._extensionService=u.invokeFunction(t=>t.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const n=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(c,_)=>{let v="",T,U;for(const V of _)v+=`
	at ${V.toString()}`,U=V.getFileName(),!T&&U&&(T=t.findSubstr(w.URI.file(U)));return n.set(c,T),`${c.name||"Error"}: ${c.message||""}${v}`}});const r=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService),s=this._rpcProtocol.getProxy(M.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(t=>{const c=a.transformErrorForSerialization(t),_=n.get(t);_?r.$onExtensionRuntimeError(_.identifier,c):s.$onUnexpectedError(c)})}async asBrowserUri(o){const g=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService);return w.URI.revive(await g.$asBrowserUri(o))}terminate(o){this._extensionService.terminate(o)}static _transform(o,g){o.allExtensions.forEach(l=>{l.extensionLocation=w.URI.revive(g.transformIncomingURIs(l.extensionLocation));const D={};l.browserNlsBundleUris&&(Object.keys(l.browserNlsBundleUris).forEach(i=>D[i]=w.URI.revive(g.transformIncomingURIs(l.browserNlsBundleUris[i]))),l.browserNlsBundleUris=D)}),o.environment.appRoot=w.URI.revive(g.transformIncomingURIs(o.environment.appRoot));const E=o.environment.extensionDevelopmentLocationURI;return E&&(o.environment.extensionDevelopmentLocationURI=E.map(l=>w.URI.revive(g.transformIncomingURIs(l)))),o.environment.extensionTestsLocationURI=w.URI.revive(g.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=w.URI.revive(g.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=w.URI.revive(g.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=w.URI.revive(g.transformIncomingURIs(o.logsLocation)),o.logFile=w.URI.revive(g.transformIncomingURIs(o.logFile)),o.workspace=g.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=h}),define(Ce[232],Ie([1,0,16,14,20,43,12,19,22,2,41]),function(ie,e,a,p,w,M,y,A,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class S{constructor(g,E,l,D){this.query=g,this.provider=E,this.fileUtils=l,this.processType=D,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(g,E){const l=this.query.folderQueries||[],D=new w.CancellationTokenSource;return E.onCancellationRequested(()=>D.cancel()),new Promise((i,u)=>{this.collector=new k(g);let n=!1;const r=(s,t)=>{if(!n&&!this.isLimitHit){const c=this.resultSize(s);h(s)&&typeof this.query.maxResults=="number"&&this.resultCount+c>this.query.maxResults&&(this.isLimitHit=!0,n=!0,D.cancel(),s=this.trimResultToSize(s,this.query.maxResults-this.resultCount));const _=this.resultSize(s);this.resultCount+=_,(_>0||!h(s))&&this.collector.add(s,t)}};Promise.all(l.map((s,t)=>this.searchInFolder(s,c=>r(c,t),D.token))).then(s=>{D.dispose(),this.collector.flush();const t=s.some(c=>!!c&&!!c.limitHit);i({limitHit:this.isLimitHit||t,messages:(0,a.flatten)(s.map(c=>c?.message?Array.isArray(c.message)?c.message:[c.message]:[])),stats:{type:this.processType}})},s=>{D.dispose();const t=(0,M.toErrorMessage)(s);u(new Error(t))})})}resultSize(g){return h(g)?Array.isArray(g.ranges)?g.ranges.length:1:0}trimResultToSize(g,E){const l=Array.isArray(g.ranges)?g.ranges:[g.ranges],D=Array.isArray(g.preview.matches)?g.preview.matches:[g.preview.matches];return{ranges:l.slice(0,E),preview:{matches:D.slice(0,E),text:g.preview.text},uri:g.uri}}async searchInFolder(g,E,l){const D=new R.QueryGlobTester(this.query,g),i=[],u={report:s=>{if(!this.validateProviderResult(s))return;const t=g.folder.scheme===y.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(b.dirname(s.uri))):void 0,c=b.relativePath(g.folder,s.uri);if(c){const _=D.includedInQuery(c,A.basename(c),t);(0,p.isThenable)(_)?i.push(_.then(v=>{v&&E(s)})):_&&E(s)}}},n=this.getSearchOptionsForFolder(g),r=await this.provider.provideTextSearchResults(m(this.query.contentPattern),n,u,l);return i.length&&await Promise.all(i),r}validateProviderResult(g){if(h(g)){if(Array.isArray(g.ranges)){if(!Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(g.preview.matches.length!==g.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(g.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(g){const E=(0,R.resolvePatternsForProvider)(this.query.includePattern,g.includePattern),l=(0,R.resolvePatternsForProvider)(this.query.excludePattern,g.excludePattern),D={folder:P.URI.from(g.folder),excludes:l,includes:E,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,encoding:g.fileEncoding&&this.fileUtils.toCanonicalName(g.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return D.usePCRE2=this.query.usePCRE2,D}}e.TextSearchManager=S;function m(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class k{constructor(g){this._onResult=g,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new d(512,E=>this.sendItems(E))}add(g,E){this._currentFileMatch&&(this._currentFolderIdx!==E||!b.isEqual(this._currentUri,g.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=E,this._currentFileMatch={resource:g.uri,results:[]}),this._currentFileMatch.results.push(f(g))}pushToCollector(){const g=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,g)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(g){this._onResult(g)}}e.TextSearchResultsCollector=k;function f(o){return h(o)?{preview:{matches:(0,a.mapArrayOrNot)(o.preview.matches,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character})),text:o.preview.text},ranges:(0,a.mapArrayOrNot)(o.ranges,g=>({startLineNumber:g.start.line,startColumn:g.start.character,endLineNumber:g.end.line,endColumn:g.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function h(o){return!!o.preview}e.extensionResultIsMatch=h;class d{constructor(g,E){this.maxBatchSize=g,this.cb=E,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(g,E){!g||this.addItemToBatch(g,E)}addItems(g,E){!g||this.addItemsToBatch(g,E)}addItemToBatch(g,E){this.batch.push(g),this.batchSize+=E,this.onUpdate()}addItemsToBatch(g,E){this.batch=this.batch.concat(g),this.batchSize+=E,this.onUpdate()}onUpdate(){this.totalNumberCompleted<d.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},d.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=d,d.TIMEOUT=4e3,d.START_BATCH_AFTER_COUNT=50}),define(Ce[105],Ie([1,0,7,4,3,227,13,46,15,2,232]),function(ie,e,a,p,w,M,y,A,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,w.createDecorator)("IExtHostSearch");let S=class{constructor(h,d,o){this.extHostRpc=h,this._uriTransformer=d,this._logService=o,this._proxy=this.extHostRpc.getProxy(p.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new M.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,d){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const o=this._handlePool++;return this._textSearchProvider.set(o,d),this._proxy.$registerTextSearchProvider(o,this._transformScheme(h)),(0,a.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}registerFileSearchProvider(h,d){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const o=this._handlePool++;return this._fileSearchProvider.set(o,d),this._proxy.$registerFileSearchProvider(o,this._transformScheme(h)),(0,a.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(o),this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(h,d,o,g){const E=m(o),l=this._fileSearchProvider.get(h);if(l)return this._fileSearchManager.fileSearch(E,l,D=>{this._proxy.$handleFileMatch(h,d,D.map(i=>i.resource))},g);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,d,o,g){const E=this._textSearchProvider.get(h);if(!E||!E.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const l=m(o);return this.createTextSearchManager(l,E).search(i=>this._proxy.$handleTextMatch(h,d,i),g)}$enableExtensionHostSearch(){}createTextSearchManager(h,d){return new R.TextSearchManager(h,d,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};S=ze([$e(0,y.IExtHostRpcService),$e(1,A.IURITransformerService),$e(2,b.ILogService)],S),e.ExtHostSearch=S;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(k),extraFileResources:f.extraFileResources&&f.extraFileResources.map(h=>P.URI.revive(h))}}e.reviveQuery=m;function k(f){return{...f,folder:P.URI.revive(f.folder)}}}),define(Ce[233],Ie([1,0,57,100,31,96,32,36,50,53,102,104,105,69,63,67,99,52,35,68,86,51,205,15,181,103,98]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f,h,d,o,g,E,l,D,i,u,n,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(u.ILoggerService,i.ExtHostLoggerService,!0),(0,a.registerSingleton)(u.ILogService,n.ExtHostLogService,!0),(0,a.registerSingleton)(h.IExtHostApiDeprecationService,h.ExtHostApiDeprecationService,!1),(0,a.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,!1),(0,a.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration,!1),(0,a.registerSingleton)(o.IExtHostConsumerFileSystem,o.ExtHostConsumerFileSystem,!1),(0,a.registerSingleton)(S.IExtHostDebugService,S.WorkerExtHostDebugService,!1),(0,a.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,!1),(0,a.registerSingleton)(b.IExtHostDocumentsAndEditors,b.ExtHostDocumentsAndEditors,!1),(0,a.registerSingleton)(g.IExtHostFileSystemInfo,g.ExtHostFileSystemInfo,!1),(0,a.registerSingleton)(p.IExtHostOutputService,p.ExtHostOutputService,!0),(0,a.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch,!1),(0,a.registerSingleton)(k.IExtHostStorage,k.ExtHostStorage,!1),(0,a.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask,!1),(0,a.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService,!1),(0,a.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService,!1),(0,a.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow,!1),(0,a.registerSingleton)(w.IExtHostWorkspace,w.ExtHostWorkspace,!1),(0,a.registerSingleton)(E.IExtHostSecretState,E.ExtHostSecretState,!1),(0,a.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry,!1),(0,a.registerSingleton)(s.IExtHostTelemetryLogService,s.ExtHostTelemetryLogService,!1),(0,a.registerSingleton)(D.IExtHostEditorTabs,D.ExtHostEditorTabs,!1),(0,a.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,!1)}),define(Ce[234],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(w){if(w&&this._dragOperations.has(w)){const M=this._dragOperations.get(w);return this._dragOperations.delete(w),M}}addDragOperationTransfer(w,M){this._dragOperations.set(w,M)}getRenderedTreeElement(w){if(this._renderedElements.has(w))return this._renderedElements.get(w)}addRenderedTreeItemElement(w,M){this._renderedElements.set(w,M)}removeRenderedTreeItemElement(w){this._renderedElements.has(w)&&this._renderedElements.delete(w)}}e.TreeviewsService=a}),define(Ce[235],Ie([1,0,135,6,22,2,5,7,14,6,10,16,8,20,234]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(g,E){if((0,R.isString)(g))return{label:g};if(g&&typeof g=="object"&&typeof g.label=="string"){let l;return Array.isArray(g.highlights)&&(l=g.highlights.filter(D=>D.length===2&&typeof D[0]=="number"&&typeof D[1]=="number"),l=l.length?l:void 0),{label:g.label,highlights:l}}}class d{constructor(E,l,D){this._proxy=E,this.commands=l,this.logService=D,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeviewsService;function i(u){return u&&u.$treeViewId&&u.$treeItemHandle}l.registerArgumentProcessor({processArgument:u=>i(u)?this.convertArgument(u):Array.isArray(u)&&u.length>0?u.map(n=>i(n)?this.convertArgument(n):n):u})}registerTreeDataProvider(E,l,D){const i=this.createTreeView(E,{treeDataProvider:l},D);return{dispose:()=>i.dispose()}}createTreeView(E,l,D){if(!l||!l.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=l.dragAndDropController?.dropMimeTypes??[],u=l.dragAndDropController?.dragMimeTypes??[],n=!!l.dragAndDropController?.handleDrag,r=!!l.dragAndDropController?.handleDrop,s=this._proxy.$registerTreeViewDataProvider(E,{showCollapseAll:!!l.showCollapseAll,canSelectMany:!!l.canSelectMany,dropMimeTypes:i,dragMimeTypes:u,hasHandleDrag:n,hasHandleDrop:r}),t=this.createExtHostTreeView(E,l,D);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(c){t.message=c},get title(){return t.title},set title(c){t.title=c},get description(){return t.description},set description(c){t.description=c},get badge(){return t.badge},set badge(c){t.badge=c},reveal:(c,_)=>t.reveal(c,_),dispose:async()=>{await s,this.treeViews.delete(E),t.dispose()}}}$getChildren(E,l){const D=this.treeViews.get(E);return D?D.getChildren(l):Promise.reject(new Error((0,a.localize)(0,null,E)))}async $handleDrop(E,l,D,i,u,n,r,s){const t=this.treeViews.get(E);if(!t)return Promise.reject(new Error((0,a.localize)(1,null,E)));const c=m.DataTransfer.toDataTransfer(D,async _=>(await this._proxy.$resolveDropFileData(E,l,_)).buffer);return r===E&&s&&await this.addAdditionalTransferItems(c,t,s,u,n),t.onDrop(c,i,u)}async addAdditionalTransferItems(E,l,D,i,u){const n=this.treeDragAndDropService.removeDragOperationTransfer(u);if(n)(await n)?.forEach((r,s)=>{r&&E.set(s,r)});else if(u&&l.handleDrag){const r=l.handleDrag(D,E,i);this.treeDragAndDropService.addDragOperationTransfer(u,r),await r}return E}async $handleDrag(E,l,D,i){const u=this.treeViews.get(E);if(!u)return Promise.reject(new Error((0,a.localize)(2,null,E)));const n=await this.addAdditionalTransferItems(new p.DataTransfer,u,l,i,D);if(!!n)return m.DataTransfer.toDataTransferDTO(n)}async $hasResolve(E){const l=this.treeViews.get(E);if(!l)throw new Error((0,a.localize)(3,null,E));return l.hasResolve}$resolve(E,l,D){const i=this.treeViews.get(E);if(!i)throw new Error((0,a.localize)(4,null,E));return i.resolveTreeItem(l,D)}$setExpanded(E,l,D){const i=this.treeViews.get(E);if(!i)throw new Error((0,a.localize)(5,null,E));i.setExpanded(l,D)}$setSelection(E,l){const D=this.treeViews.get(E);if(!D)throw new Error((0,a.localize)(6,null,E));D.setSelection(l)}$setVisible(E,l){const D=this.treeViews.get(E);if(!D)throw new Error((0,a.localize)(7,null,E));D.setVisible(l)}createExtHostTreeView(E,l,D){const i=new o(E,l,this._proxy,this.commands.converter,this.logService,D);return this.treeViews.set(E,i),i}convertArgument(E){const l=this.treeViews.get(E.$treeViewId);return l?l.getExtensionElement(E.$treeItemHandle):null}}e.ExtHostTreeViews=d;class o extends A.Disposable{constructor(E,l,D,i,u,n){if(super(),this.viewId=E,this.proxy=D,this.commands=i,this.logService=u,this.extension=n,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new y.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new y.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new y.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new y.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new y.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new k.CancellationTokenSource,n.contributes&&n.contributes.views)for(const t in n.contributes.views)for(const c of n.contributes.views[t])c.id===E&&(this._title=c.name);this.dataProvider=l.treeDataProvider,this.dndController=l.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(t=>this._onDidChangeData.fire({message:!1,element:t})));let r,s;this._register(y.Event.debounce(this._onDidChangeData.event,(t,c)=>(t||(t={message:!1,elements:[]}),c.element!==!1&&(r||(r=new Promise(_=>s=_),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(c.element)?t.elements.push(...c.element):t.elements.push(c.element)),c.message&&(t.message=!0),t),200,!0)(({message:t,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const _=s;return r=null,this.refresh(c).then(()=>_())})),t&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(E=>this.getExtensionElement(E)).filter(E=>!(0,R.isUndefinedOrNull)(E))}async getChildren(E){const l=E?this.getExtensionElement(E):void 0;if(E&&!l)return this.logService.error(`No tree item with id '${E}' found.`),Promise.resolve([]);let D=this.getChildrenNodes(E);return D||(D=await this.fetchChildrenNodes(l)),D?D.map(i=>i.item):void 0}getExtensionElement(E){return this.elements.get(E)}reveal(E,l){l=l||{select:!0,focus:!1};const D=(0,R.isUndefinedOrNull)(l.select)?!0:l.select,i=(0,R.isUndefinedOrNull)(l.focus)?!1:l.focus,u=(0,R.isUndefinedOrNull)(l.expand)?!1:l.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):E?this.refreshPromise.then(()=>this.resolveUnknownParentChain(E)).then(n=>this.resolveTreeNode(E,n[n.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:n.map(s=>s.item)},{select:D,focus:i,expand:u})),n=>this.logService.error(n)):this.proxy.$reveal(this.viewId,void 0,{select:D,focus:i,expand:u})}get message(){return this._message}set message(E){this._message=E,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(E){this._title=E,this.proxy.$setTitle(this.viewId,E,this._description)}get description(){return this._description}set description(E){this._description=E,this.proxy.$setTitle(this.viewId,this._title,E)}get badge(){return this._badge}set badge(E){this._badge?.value===E?.value&&this._badge?.tooltip===E?.tooltip||(this._badge=m.ViewBadge.from(E),this.proxy.$setBadge(this.viewId,E))}setExpanded(E,l){const D=this.getExtensionElement(E);D&&(l?this._onDidExpandElement.fire(Object.freeze({element:D})):this._onDidCollapseElement.fire(Object.freeze({element:D})))}setSelection(E){(0,S.equals)(this._selectedHandles,E)||(this._selectedHandles=E,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(E){E!==this._visible&&(this._visible=E,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(E,l,D){const i=[];for(const u of E){const n=this.getExtensionElement(u);n&&i.push(n)}if(!(!this.dndController?.handleDrag||i.length===0))return await this.dndController.handleDrag(i,l,D),l}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(E,l,D){const i=l?this.getExtensionElement(l):void 0;if(!(!i&&l||!this.dndController?.handleDrop))return(0,b.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(i,E,D):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(E,l){if(!this.dataProvider.resolveTreeItem)return;const D=this.elements.get(E);if(D){const i=this.nodes.get(D);if(i){const u=await this.dataProvider.resolveTreeItem(i.extensionItem,D,l)??i.extensionItem;return this.validateTreeItem(u),i.item.tooltip=this.getTooltip(u.tooltip),i.item.command=this.getCommand(i.disposableStore,u.command),i.item}}}resolveUnknownParentChain(E){return this.resolveParent(E).then(l=>l?this.resolveUnknownParentChain(l).then(D=>this.resolveTreeNode(l,D[D.length-1]).then(i=>(D.push(i),D))):Promise.resolve([]))}resolveParent(E){const l=this.nodes.get(E);return l?Promise.resolve(l.parent?this.elements.get(l.parent.item.handle):void 0):(0,b.asPromise)(()=>this.dataProvider.getParent(E))}resolveTreeNode(E,l){const D=this.nodes.get(E);return D?Promise.resolve(D):(0,b.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(i=>this.createHandle(E,i,l,!0)).then(i=>this.getChildren(l?l.item.handle:void 0).then(()=>{const u=this.getExtensionElement(i);if(u){const n=this.nodes.get(u);if(n)return Promise.resolve(n)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(E){if(E){let l;if(typeof E=="string"){const D=this.getExtensionElement(E);l=D?this.nodes.get(D):void 0}else l=E;return l&&l.children||void 0}return this.roots}async fetchChildrenNodes(E){this.clearChildren(E);const l=new k.CancellationTokenSource(this._refreshCancellationSource.token);try{const D=E?this.nodes.get(E):void 0,i=await this.dataProvider.getChildren(E);if(l.token.isCancellationRequested)return;const u=await Promise.all((0,S.coalesce)(i||[]).map(async n=>{const r=await this.dataProvider.getTreeItem(n);return r&&!l.token.isCancellationRequested?this.createAndRegisterTreeNode(n,r,D):null}));return l.token.isCancellationRequested?void 0:(0,S.coalesce)(u)}finally{l.dispose()}}refresh(E){if(E.some(D=>!D))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new k.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const D=this.getHandlesToRefresh(E);if(D.length)return this.refreshHandles(D)}return Promise.resolve(void 0)}getHandlesToRefresh(E){const l=new Set,D=E.map(u=>this.nodes.get(u));for(const u of D)if(u&&!l.has(u.item.handle)){let n=u;for(;n&&n.parent&&D.findIndex(r=>n&&n.parent&&r&&r.item.handle===n.parent.item.handle)===-1;){const r=this.elements.get(n.parent.item.handle);n=r?this.nodes.get(r):void 0}n&&!n.parent&&l.add(u.item.handle)}const i=[];return l.forEach(u=>{const n=this.elements.get(u);if(n){const r=this.nodes.get(n);r&&(!r.parent||!l.has(r.parent.item.handle))&&i.push(u)}}),i}refreshHandles(E){const l={};return Promise.all(E.map(D=>this.refreshNode(D).then(i=>{i&&(l[D]=i.item)}))).then(()=>Object.keys(l).length?this.proxy.$refresh(this.viewId,l):void 0)}refreshNode(E){const l=this.getExtensionElement(E);if(l){const D=this.nodes.get(l);if(D)return this.clearChildren(l),(0,b.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(i=>{if(i){const u=this.createTreeNode(l,i,D.parent);return this.updateNodeCache(l,u,D,D.parent),D.dispose(),u}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(E,l,D){const i=this.createTreeNode(E,l,D);if(l.id&&this.elements.has(i.item.handle))throw new Error((0,a.localize)(8,null,l.id));return this.addNodeToCache(E,i),this.addNodeToParentCache(i,D),i}getTooltip(E){return P.MarkdownString.isMarkdownString(E)?m.MarkdownString.from(E):E}getCommand(E,l){return l?{...this.commands.toInternal(l,E),originalId:l.command}:void 0}validateTreeItem(E){if(!P.TreeItem.isTreeItem(E))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(E,l,D){this.validateTreeItem(l);const i=new A.DisposableStore,u=this.createHandle(E,l,D),n=this.getLightIconPath(l);return{item:{handle:u,parentHandle:D?D.item.handle:void 0,label:h(l.label,this.extension),description:l.description,resourceUri:l.resourceUri,tooltip:this.getTooltip(l.tooltip),command:this.getCommand(i,l.command),contextValue:l.contextValue,icon:n,iconDark:this.getDarkIconPath(l)||n,themeIcon:this.getThemeIcon(l),collapsibleState:(0,R.isUndefinedOrNull)(l.collapsibleState)?P.TreeItemCollapsibleState.None:l.collapsibleState,accessibilityInformation:l.accessibilityInformation},extensionItem:l,parent:D,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(E){return E.iconPath instanceof P.ThemeIcon?E.iconPath:void 0}createHandle(E,{id:l,label:D,resourceUri:i},u,n){if(l)return`${o.ID_HANDLE_PREFIX}/${l}`;const r=h(D,this.extension),s=u?u.item.handle:o.LABEL_HANDLE_PREFIX;let t=r?r.label:i?(0,w.basename)(i):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const c=this.nodes.has(E)?this.nodes.get(E).item.handle:void 0,_=this.getChildrenNodes(u)||[];let v,T=0;do{if(v=`${s}/${T}:${t}`,n||!this.elements.has(v)||c===v)break;T++}while(T<=_.length);return v}getLightIconPath(E){if(E.iconPath&&!(E.iconPath instanceof P.ThemeIcon))return typeof E.iconPath=="string"||M.URI.isUri(E.iconPath)?this.getIconPath(E.iconPath):this.getIconPath(E.iconPath.light)}getDarkIconPath(E){if(E.iconPath&&!(E.iconPath instanceof P.ThemeIcon)&&E.iconPath.dark)return this.getIconPath(E.iconPath.dark)}getIconPath(E){return M.URI.isUri(E)?E:M.URI.file(E)}addNodeToCache(E,l){this.elements.set(l.item.handle,E),this.nodes.set(E,l)}updateNodeCache(E,l,D,i){this.elements.delete(l.item.handle),this.nodes.delete(E),l.item.handle!==D.item.handle&&this.elements.delete(D.item.handle),this.addNodeToCache(E,l);const u=this.getChildrenNodes(i)||[],n=u.filter(r=>r.item.handle===D.item.handle)[0];n&&u.splice(u.indexOf(n),1,l)}addNodeToParentCache(E,l){l?(l.children||(l.children=[]),l.children.push(E)):(this.roots||(this.roots=[]),this.roots.push(E))}clearChildren(E){if(E){const l=this.nodes.get(E);if(l){if(l.children)for(const D of l.children){const i=this.elements.get(D.item.handle);i&&this.clear(i)}l.children=void 0}}else this.clearAll()}clear(E){const l=this.nodes.get(E);if(l){if(l.children)for(const D of l.children){const i=this.elements.get(D.item.handle);i&&this.clear(i)}this.nodes.delete(E),this.elements.delete(l.item.handle),l.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(E=>E.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}o.LABEL_HANDLE_PREFIX="0",o.ID_HANDLE_PREFIX="1"}),define(Ce[236],Ie([1,0,20,11,5,29,2,122,246,111,120,39,4,95,190,189,36,191,32,193,194,195,174,196,50,33,198,199,202,204,206,100,177,210,211,212,69,53,214,235,8,6,217,54,99,31,163,201,85,96,102,104,105,15,46,13,28,207,161,63,67,187,215,70,52,220,218,219,188,35,213,216,68,51,86,208,101,209,12,81,176,159,200,7,27,165,98]),function(ie,e,a,p,w,M,y,A,b,P,R,S,m,k,f,h,d,o,g,E,l,D,i,u,n,r,s,t,c,_,v,T,U,V,x,C,L,B,F,K,H,O,ee,ue,oe,le,te,Ee,be,ne,ve,Pe,Fe,xe,Qe,ke,Se,ye,ae,ce,Q,J,I,z,W,j,re,de,Z,pe,ge,Ne,Be,Ye,Xe,Te,nt,G,X,fe,Ue,He,Ze,je,We,it,rt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function dt(at){const st=at.get(Se.IExtHostInitDataService),yt=at.get(pe.IExtHostFileSystemInfo),Rt=at.get(W.IExtHostConsumerFileSystem),Ot=at.get(r.IExtHostExtensionService),mt=at.get(le.IExtHostWorkspace),Dt=at.get(Xe.IExtHostTelemetry),Lt=at.get(g.IExtHostConfiguration),Ft=at.get(Qe.IURITransformerService),Ve=at.get(ke.IExtHostRpcService),Nt=at.get(L.IExtHostStorage),Tt=at.get(z.IExtensionStoragePaths),Mt=at.get(xe.ILoggerService),pt=at.get(xe.ILogService),Ct=at.get(ce.IExtHostTunnelService),we=at.get(rt.IExtHostTelemetryLogService),De=at.get(Q.IExtHostApiDeprecationService),me=at.get(oe.IExtHostWindow),q=at.get(Be.IExtHostSecretState),Ae=at.get(Ye.IExtHostEditorTabs);Ve.set(m.ExtHostContext.ExtHostFileSystemInfo,yt),Ve.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Mt),Ve.set(m.ExtHostContext.ExtHostWorkspace,mt),Ve.set(m.ExtHostContext.ExtHostConfiguration,Lt),Ve.set(m.ExtHostContext.ExtHostExtensionService,Ot),Ve.set(m.ExtHostContext.ExtHostStorage,Nt),Ve.set(m.ExtHostContext.ExtHostTunnelService,Ct),Ve.set(m.ExtHostContext.ExtHostWindow,me),Ve.set(m.ExtHostContext.ExtHostSecretState,q),Ve.set(m.ExtHostContext.ExtHostTelemetry,Dt),Ve.set(m.ExtHostContext.ExtHostEditorTabs,Ae);const Le=Ve.set(m.ExtHostContext.ExtHostDecorations,at.get(ne.IExtHostDecorations)),et=Ve.set(m.ExtHostContext.ExtHostDocumentsAndEditors,at.get(n.IExtHostDocumentsAndEditors)),qe=Ve.set(m.ExtHostContext.ExtHostCommands,at.get(d.IExtHostCommands)),Ge=Ve.set(m.ExtHostContext.ExtHostTerminalService,at.get(B.IExtHostTerminalService)),ct=Ve.set(m.ExtHostContext.ExtHostDebugService,at.get(Pe.IExtHostDebugService)),It=Ve.set(m.ExtHostContext.ExtHostSearch,at.get(Fe.IExtHostSearch)),Et=Ve.set(m.ExtHostContext.ExtHostTask,at.get(ve.IExtHostTask)),wt=Ve.set(m.ExtHostContext.ExtHostOutputService,at.get(T.IExtHostOutputService)),_t=Ve.set(m.ExtHostContext.ExtHostUrls,new ee.ExtHostUrls(Ve)),gt=Ve.set(m.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(Ve,et)),St=Ve.set(m.ExtHostContext.ExtHostDocumentContentProviders,new D.ExtHostDocumentContentProvider(Ve,et,pt)),Qt=Ve.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(pt,gt,Ve.getProxy(m.MainContext.MainThreadBulkEdits))),vt=Ve.set(m.ExtHostContext.ExtHostNotebook,new ye.ExtHostNotebookController(Ve,qe,et,gt,Tt)),qt=Ve.set(m.ExtHostContext.ExtHostNotebookDocuments,new He.ExtHostNotebookDocuments(vt)),Wt=Ve.set(m.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(pt,vt)),zt=Ve.set(m.ExtHostContext.ExtHostNotebookKernels,new Te.ExtHostNotebookKernels(Ve,st,vt,qe,pt)),fi=Ve.set(m.ExtHostContext.ExtHostNotebookRenderers,new G.ExtHostNotebookRenderers(Ve,vt)),Pt=Ve.set(m.ExtHostContext.ExtHostEditors,new F.ExtHostEditors(Ve,et)),ri=Ve.set(m.ExtHostContext.ExtHostTreeViews,new K.ExtHostTreeViews(Ve.getProxy(m.MainContext.MainThreadTreeViews),qe,pt)),Yt=Ve.set(m.ExtHostContext.ExtHostEditorInsets,new te.ExtHostEditorInsets(Ve.getProxy(m.MainContext.MainThreadEditorInsets),Pt,st.remote)),Jt=Ve.set(m.ExtHostContext.ExtHostDiagnostics,new E.ExtHostDiagnostics(Ve,pt,yt)),Zt=Ve.set(m.ExtHostContext.ExtHostLanguages,new _.ExtHostLanguages(Ve,gt,qe.converter,Ft)),ut=Ve.set(m.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ve,Ft,gt,qe,Jt,pt,De)),mi=Ve.set(m.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(Ve,ut)),xt=Ve.set(m.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Ve,pt,et)),Kt=Ve.set(m.ExtHostContext.ExtHostQuickOpen,(0,V.createExtHostQuickOpen)(Ve,mt,qe)),si=Ve.set(m.ExtHostContext.ExtHostSCM,new x.ExtHostSCM(Ve,qe,pt)),gi=Ve.set(m.ExtHostContext.ExtHostComments,(0,o.createExtHostComments)(Ve,qe,gt)),yi=Ve.set(m.ExtHostContext.ExtHostProgress,new U.ExtHostProgress(Ve.getProxy(m.MainContext.MainThreadProgress))),Pi=Ve.set(m.ExtHostContext.ExtHosLabelService,new Ee.ExtHostLabelService(Ve)),oi=Ve.set(m.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Ve)),ei=Ve.set(m.ExtHostContext.ExtHostAuthentication,new J.ExtHostAuthentication(Ve)),pi=Ve.set(m.ExtHostContext.ExtHostTimeline,new I.ExtHostTimeline(Ve,qe)),ii=Ve.set(m.ExtHostContext.ExtHostWebviews,new ue.ExtHostWebviews(Ve,st.remote,mt,pt,De)),vi=Ve.set(m.ExtHostContext.ExtHostWebviewPanels,new de.ExtHostWebviewPanels(Ve,ii,mt)),Ei=Ve.set(m.ExtHostContext.ExtHostCustomEditors,new re.ExtHostCustomEditors(Ve,gt,Tt,ii,vi)),bi=Ve.set(m.ExtHostContext.ExtHostWebviewViews,new j.ExtHostWebviewViews(Ve,ii)),ni=Ve.set(m.ExtHostContext.ExtHostTesting,new ge.ExtHostTesting(Ve,qe,et)),Ai=Ve.set(m.ExtHostContext.ExtHostUriOpeners,new Ne.ExtHostUriOpeners(Ve));Ve.set(m.ExtHostContext.ExtHostInteractive,new Ze.ExtHostInteractive(Ve,vt,et,qe,pt));const Ri=Object.values(m.ExtHostContext);Ve.assertRegistered(Ri);const Oi=new Z.ExtHostBulkEdits(Ve,et),Fi=new h.ExtHostClipboard(Ve),wi=new v.ExtHostMessageService(Ve,pt),ai=new l.ExtHostDialogs(Ve),li=new C.ExtHostStatusBar(Ve,qe.converter);return f.ExtHostApiCommands.register(qe),function(Me,Ht,Di){const ft=function(){let se=!Me.isUnderDevelopment;function he(){se||(pt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Re(ot){if(Array.isArray(ot))ot.forEach(Re);else if(typeof ot=="string")he();else{const bt=ot;typeof bt.scheme>"u"&&he(),typeof bt.exclusive=="boolean"&&(0,We.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return ot}}(),Ni={getSession(se,he,Re){return ei.getSession(Me,se,he,Re)},async hasSession(se,he){return(0,We.checkProposedApiEnabled)(Me,"authSession"),!!await ei.getSession(Me,se,he,{silent:!0})},get onDidChangeSessions(){return ei.onDidChangeSessions},registerAuthenticationProvider(se,he,Re,ot){return ei.registerAuthenticationProvider(se,he,Re,ot)}},Mi={registerCommand(se,he,Re){return qe.registerCommand(!0,se,he,Re,void 0,Me)},registerTextEditorCommand(se,he,Re){return qe.registerCommand(!0,se,(...ot)=>{const bt=Pt.getActiveTextEditor();if(!bt){pt.warn("Cannot execute "+se+" because there is no active text editor.");return}return bt.edit(kt=>{he.apply(Re,[bt,kt,...ot])}).then(kt=>{kt||pt.warn("Edits from command "+se+" were not applied.")},kt=>{pt.warn("An error occurred while running command "+se,kt)})},void 0,void 0,Me)},registerDiffInformationCommand:(se,he,Re)=>((0,We.checkProposedApiEnabled)(Me,"diffCommand"),qe.registerCommand(!0,se,async(...ot)=>{const bt=et.activeEditor(!0);if(!bt){pt.warn("Cannot execute "+se+" because there is no active text editor.");return}const kt=await Pt.getDiffInformation(bt.id);he.apply(Re,[kt,...ot])},void 0,void 0,Me)),executeCommand(se,...he){return qe.executeCommand(se,...he)},getCommands(se=!1){return qe.getCommands(se)}},Ci={get machineId(){return st.telemetryInfo.machineId},get sessionId(){return st.telemetryInfo.sessionId},get language(){return st.environment.appLanguage},get appName(){return st.environment.appName},get appRoot(){return st.environment.appRoot?.fsPath??""},get appHost(){return st.environment.appHost},get uriScheme(){return st.environment.appUriScheme},get clipboard(){return Fi.value},get shell(){return Ge.getDefaultShell(!1)},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Me,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Me,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const se=Date.now()-new Date(st.telemetryInfo.firstSessionDate).getTime();return isNaN(se)?!1:se<1e3*60*60*24},openExternal(se,he){return me.openUri(se,{allowTunneling:!!st.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===st.environment.appUriScheme)return _t.createAppUri(se);try{return await me.asExternalUri(se,{allowTunneling:!!st.remote.authority})}catch(he){if((0,fe.matchesScheme)(se,X.Schemas.http)||(0,fe.matchesScheme)(se,X.Schemas.https))return se;throw he}},get remoteName(){return(0,be.getRemoteName)(st.remote.authority)},get remoteAuthority(){return(0,We.checkProposedApiEnabled)(Me,"resolvers"),st.remote.authority},get uiKind(){return st.uiKind}};st.environment.extensionTestsLocationURI||Object.freeze(Ci);const Li={createTestController(se,he,Re){return ni.createTestController(se,he,Re)},createTestObserver(){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ni.createTestObserver()},runTests(se){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ni.runTests(se)},get onDidChangeTestResults(){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ni.onResultsChanged},get testResults(){return(0,We.checkProposedApiEnabled)(Me,"testObserver"),ni.results}},ti=st.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,Ui={getExtension(se,he){(0,We.isProposedApiEnabled)(Me,"extensionsAny")||(he=!1);const Re=Ht.mine.getExtensionDescription(se);if(Re)return new r.Extension(Ot,Me.identifier,Re,ti,!1);if(he){const ot=Ht.all.getExtensionDescription(se);if(ot)return new r.Extension(Ot,Me.identifier,ot,ti,!0)}},get all(){const se=[];for(const he of Ht.mine.getAllExtensionDescriptions())se.push(new r.Extension(Ot,Me.identifier,he,ti,!1));return se},get allAcrossExtensionHosts(){(0,We.checkProposedApiEnabled)(Me,"extensionsAny");const se=new We.ExtensionIdentifierSet(Ht.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),he=[];for(const Re of Ht.all.getAllExtensionDescriptions()){const ot=!se.has(Re.identifier);he.push(new r.Extension(Ot,Me.identifier,Re,ti,ot))}return he},get onDidChange(){return(0,We.isProposedApiEnabled)(Me,"extensionsAny")?w.Event.any(Ht.mine.onDidChange,Ht.all.onDidChange):Ht.mine.onDidChange}},Vt={createDiagnosticCollection(se){return Jt.createDiagnosticCollection(Me.identifier,se)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:se=>Jt.getDiagnostics(se),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(se,he){return Zt.changeLanguage(se.uri,he)},match(se,he){const Re=gt.getDocumentData(he.uri)?.notebook;return(0,R.score)(H.LanguageSelector.from(se),he.uri,he.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(se,he,Re){return ut.registerCodeActionProvider(Me,ft(se),he,Re)},registerDocumentPasteEditProvider(se,he,Re){return(0,We.checkProposedApiEnabled)(Me,"documentPaste"),ut.registerDocumentPasteEditProvider(Me,ft(se),he,Re)},registerCodeLensProvider(se,he){return ut.registerCodeLensProvider(Me,ft(se),he)},registerDefinitionProvider(se,he){return ut.registerDefinitionProvider(Me,ft(se),he)},registerDeclarationProvider(se,he){return ut.registerDeclarationProvider(Me,ft(se),he)},registerImplementationProvider(se,he){return ut.registerImplementationProvider(Me,ft(se),he)},registerTypeDefinitionProvider(se,he){return ut.registerTypeDefinitionProvider(Me,ft(se),he)},registerHoverProvider(se,he){return ut.registerHoverProvider(Me,ft(se),he,Me.identifier)},registerEvaluatableExpressionProvider(se,he){return ut.registerEvaluatableExpressionProvider(Me,ft(se),he,Me.identifier)},registerInlineValuesProvider(se,he){return ut.registerInlineValuesProvider(Me,ft(se),he,Me.identifier)},registerDocumentHighlightProvider(se,he){return ut.registerDocumentHighlightProvider(Me,ft(se),he)},registerLinkedEditingRangeProvider(se,he){return ut.registerLinkedEditingRangeProvider(Me,ft(se),he)},registerReferenceProvider(se,he){return ut.registerReferenceProvider(Me,ft(se),he)},registerRenameProvider(se,he){return ut.registerRenameProvider(Me,ft(se),he)},registerDocumentSymbolProvider(se,he,Re){return ut.registerDocumentSymbolProvider(Me,ft(se),he,Re)},registerWorkspaceSymbolProvider(se){return ut.registerWorkspaceSymbolProvider(Me,se)},registerDocumentFormattingEditProvider(se,he){return ut.registerDocumentFormattingEditProvider(Me,ft(se),he)},registerDocumentRangeFormattingEditProvider(se,he){return ut.registerDocumentRangeFormattingEditProvider(Me,ft(se),he)},registerOnTypeFormattingEditProvider(se,he,Re,...ot){return ut.registerOnTypeFormattingEditProvider(Me,ft(se),he,[Re].concat(ot))},registerDocumentSemanticTokensProvider(se,he,Re){return ut.registerDocumentSemanticTokensProvider(Me,ft(se),he,Re)},registerDocumentRangeSemanticTokensProvider(se,he,Re){return ut.registerDocumentRangeSemanticTokensProvider(Me,ft(se),he,Re)},registerSignatureHelpProvider(se,he,Re,...ot){return typeof Re=="object"?ut.registerSignatureHelpProvider(Me,ft(se),he,Re):ut.registerSignatureHelpProvider(Me,ft(se),he,typeof Re>"u"?[]:[Re,...ot])},registerCompletionItemProvider(se,he,...Re){return ut.registerCompletionItemProvider(Me,ft(se),he,Re)},registerInlineCompletionItemProvider(se,he){return he.handleDidShowCompletionItem&&(0,We.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Me,ft(se),he)},registerInlineCompletionItemProviderNew(se,he){if((0,We.checkProposedApiEnabled)(Me,"inlineCompletionsNew"),he.handleDidShowCompletionItem&&!(0,We.isProposedApiEnabled)(Me,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return ut.registerInlineCompletionsProviderNew(Me,ft(se),he)},registerDocumentLinkProvider(se,he){return ut.registerDocumentLinkProvider(Me,ft(se),he)},registerColorProvider(se,he){return ut.registerColorProvider(Me,ft(se),he)},registerFoldingRangeProvider(se,he){return ut.registerFoldingRangeProvider(Me,ft(se),he)},registerSelectionRangeProvider(se,he){return ut.registerSelectionRangeProvider(Me,se,he)},registerCallHierarchyProvider(se,he){return ut.registerCallHierarchyProvider(Me,se,he)},registerTypeHierarchyProvider(se,he){return ut.registerTypeHierarchyProvider(Me,se,he)},setLanguageConfiguration:(se,he)=>ut.setLanguageConfiguration(Me,se,he),getTokenInformationAtPosition(se,he){return(0,We.checkProposedApiEnabled)(Me,"tokenInformation"),Zt.tokenAtPosition(se,he)},registerInlayHintsProvider(se,he){return ut.registerInlayHintsProvider(Me,se,he)},createLanguageStatusItem(se,he){return Zt.createLanguageStatusItem(Me,se,he)},registerDocumentDropEditProvider(se,he){return ut.registerDocumentOnDropEditProvider(Me,se,he)}},ci={get activeTextEditor(){return Pt.getActiveTextEditor()},get visibleTextEditors(){return Pt.getVisibleTextEditors()},get activeTerminal(){return Ge.activeTerminal},get terminals(){return Ge.terminals},async showTextDocument(se,he,Re){const ot=await(y.URI.isUri(se)?Promise.resolve(Ii.openTextDocument(se)):Promise.resolve(se));return Pt.showTextDocument(ot,he,Re)},createTextEditorDecorationType(se){return Pt.createTextEditorDecorationType(Me,se)},onDidChangeActiveTextEditor(se,he,Re){return Pt.onDidChangeActiveTextEditor(se,he,Re)},onDidChangeVisibleTextEditors(se,he,Re){return Pt.onDidChangeVisibleTextEditors(se,he,Re)},onDidChangeTextEditorSelection(se,he,Re){return Pt.onDidChangeTextEditorSelection(se,he,Re)},onDidChangeTextEditorOptions(se,he,Re){return Pt.onDidChangeTextEditorOptions(se,he,Re)},onDidChangeTextEditorVisibleRanges(se,he,Re){return Pt.onDidChangeTextEditorVisibleRanges(se,he,Re)},onDidChangeTextEditorViewColumn(se,he,Re){return Pt.onDidChangeTextEditorViewColumn(se,he,Re)},onDidCloseTerminal(se,he,Re){return Ge.onDidCloseTerminal(se,he,Re)},onDidOpenTerminal(se,he,Re){return Ge.onDidOpenTerminal(se,he,Re)},onDidChangeActiveTerminal(se,he,Re){return Ge.onDidChangeActiveTerminal(se,he,Re)},onDidChangeTerminalDimensions(se,he,Re){return(0,We.checkProposedApiEnabled)(Me,"terminalDimensions"),Ge.onDidChangeTerminalDimensions(se,he,Re)},onDidChangeTerminalState(se,he,Re){return Ge.onDidChangeTerminalState(se,he,Re)},onDidWriteTerminalData(se,he,Re){return(0,We.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),Ge.onDidWriteTerminalData(se,he,Re)},get state(){return me.state},onDidChangeWindowState(se,he,Re){return me.onDidChangeWindowState(se,he,Re)},showInformationMessage(se,...he){return wi.showMessage(Me,M.default.Info,se,he[0],he.slice(1))},showWarningMessage(se,...he){return wi.showMessage(Me,M.default.Warning,se,he[0],he.slice(1))},showErrorMessage(se,...he){return wi.showMessage(Me,M.default.Error,se,he[0],he.slice(1))},showQuickPick(se,he,Re){return Kt.showQuickPick(se,he,Re)},showWorkspaceFolderPick(se){return Kt.showWorkspaceFolderPick(se)},showInputBox(se,he){return Kt.showInput(se,he)},showOpenDialog(se){return ai.showOpenDialog(se)},showSaveDialog(se){return ai.showSaveDialog(se)},createStatusBarItem(se,he,Re){let ot,bt,kt;return typeof se=="string"?(ot=se,bt=he,kt=Re):(bt=se,kt=he),li.createStatusBarEntry(Me,ot,bt,kt)},setStatusBarMessage(se,he){return li.setStatusBarMessage(se,he)},withScmProgress(se){return De.report("window.withScmProgress",Me,"Use 'withProgress' instead."),yi.withProgress(Me,{location:O.ProgressLocation.SourceControl},(he,Re)=>se({report(ot){}}))},withProgress(se,he){return yi.withProgress(Me,se,he)},createOutputChannel(se,he){return wt.createOutputChannel(se,he,Me)},createWebviewPanel(se,he,Re,ot){return vi.createWebviewPanel(Me,se,he,Re,ot)},createWebviewTextEditorInset(se,he,Re,ot){return(0,We.checkProposedApiEnabled)(Me,"editorInsets"),Yt.createWebviewEditorInset(se,he,Re,ot,Me)},createTerminal(se,he,Re){return typeof se=="object"?"pty"in se?Ge.createExtensionTerminal(se):Ge.createTerminalFromOptions(se):Ge.createTerminal(se,he,Re)},registerTerminalLinkProvider(se){return Ge.registerLinkProvider(se)},registerTerminalProfileProvider(se,he){return Ge.registerProfileProvider(Me,se,he)},registerTreeDataProvider(se,he){return ri.registerTreeDataProvider(se,he,Me)},createTreeView(se,he){return ri.createTreeView(se,he,Me)},registerWebviewPanelSerializer:(se,he)=>vi.registerWebviewPanelSerializer(Me,se,he),registerCustomEditorProvider:(se,he,Re={})=>Ei.registerCustomEditorProvider(Me,se,he,Re),registerFileDecorationProvider(se){return Le.registerFileDecorationProvider(se,Me.identifier)},registerUriHandler(se){return _t.registerUriHandler(Me.identifier,se)},createQuickPick(){return Kt.createQuickPick(Me)},createInputBox(){return Kt.createInputBox(Me)},get activeColorTheme(){return oi.activeColorTheme},onDidChangeActiveColorTheme(se,he,Re){return oi.onDidChangeActiveColorTheme(se,he,Re)},registerWebviewViewProvider(se,he,Re){return bi.registerWebviewViewProvider(Me,se,he,Re?.webviewOptions)},get activeNotebookEditor(){return vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,he,Re){return vt.onDidChangeActiveNotebookEditor(se,he,Re)},get visibleNotebookEditors(){return vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,he,Re){return Wt.onDidChangeNotebookEditorSelection(se,he,Re)},onDidChangeNotebookEditorVisibleRanges(se,he,Re){return Wt.onDidChangeNotebookEditorVisibleRanges(se,he,Re)},showNotebookDocument(se,he){return y.URI.isUri(se)&&De.report("window.showNotebookDocument(uri)",Me,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),vt.showNotebookDocument(se,he)},registerExternalUriOpener(se,he,Re){return(0,We.checkProposedApiEnabled)(Me,"externalUriOpener"),Ai.registerExternalUriOpener(Me.identifier,se,he,Re)},get tabGroups(){return Ae.tabGroups},logTelemetryToOutputChannel(se,he){(0,We.checkProposedApiEnabled)(Me,"telemetryLog"),we.logToTelemetryOutputChannel(Me,se,he)}},Ii={get rootPath(){return De.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(se){throw p.readonly()},getWorkspaceFolder(se){return mt.getWorkspaceFolder(se)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(se){throw p.readonly()},get workspaceFile(){return mt.workspaceFile},set workspaceFile(se){throw p.readonly()},updateWorkspaceFolders:(se,he,...Re)=>mt.updateWorkspaceFolders(Me,se,he||0,...Re),onDidChangeWorkspaceFolders:function(se,he,Re){return mt.onDidChangeWorkspace(se,he,Re)},asRelativePath:(se,he)=>mt.getRelativePath(se,he),findFiles:(se,he,Re,ot)=>mt.findFiles(se,he,Re,Me.identifier,ot),findTextInFiles:(se,he,Re,ot)=>{(0,We.checkProposedApiEnabled)(Me,"findTextInFiles");let bt,kt;return typeof he=="object"?(bt=he,kt=Re):(bt={},kt=he,ot=Re),mt.findTextInFiles(se,bt||{},kt,Me.identifier,ot)},saveAll:se=>mt.saveAll(se),applyEdit(se){return Oi.applyWorkspaceEdit(se,Me)},createFileSystemWatcher:(se,he,Re,ot)=>xt.createFileSystemWatcher(mt,Me,se,he,Re,ot),get textDocuments(){return gt.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw p.readonly()},openTextDocument(se){let he;const Re=se;if(typeof se=="string")he=Promise.resolve(y.URI.file(se));else if(y.URI.isUri(se))he=Promise.resolve(se);else if(!Re||typeof Re=="object")he=gt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(ot=>gt.ensureDocumentData(ot).then(bt=>bt.document))},onDidOpenTextDocument:(se,he,Re)=>gt.onDidAddDocument(se,he,Re),onDidCloseTextDocument:(se,he,Re)=>gt.onDidRemoveDocument(se,he,Re),onDidChangeTextDocument:(se,he,Re)=>gt.onDidChangeDocument(se,he,Re),onDidSaveTextDocument:(se,he,Re)=>gt.onDidSaveDocument(se,he,Re),onWillSaveTextDocument:(se,he,Re)=>Qt.getOnWillSaveTextDocumentEvent(Me)(se,he,Re),get notebookDocuments(){return vt.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,he){let Re;if(y.URI.isUri(se))Re=se,await vt.openNotebookDocument(se);else if(typeof se=="string")Re=y.URI.revive(await vt.createNotebookDocument({viewType:se,content:he}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(se,he,Re){return qt.onDidSaveNotebookDocument(se,he,Re)},onDidChangeNotebookDocument(se,he,Re){return qt.onDidChangeNotebookDocument(se,he,Re)},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(se,he,Re,ot){return vt.registerNotebookSerializer(Me,se,he,Re,(0,We.isProposedApiEnabled)(Me,"notebookLiveShare")?ot:void 0)},registerNotebookContentProvider:(se,he,Re,ot)=>((0,We.checkProposedApiEnabled)(Me,"notebookContentProvider"),De.report("workspace.registerNotebookContentProvider",Me,"The notebookContentProvider API is not on track for finalization and will be removed."),vt.registerNotebookContentProvider(Me,se,he,Re,(0,We.isProposedApiEnabled)(Me,"notebookLiveShare")?ot:void 0)),onDidChangeConfiguration:(se,he,Re)=>Di.onDidChangeConfiguration(se,he,Re),getConfiguration(se,he){return he=arguments.length===1?void 0:he,Di.getConfiguration(se,he,Me)},registerTextDocumentContentProvider(se,he){return St.registerTextDocumentContentProvider(se,he)},registerTaskProvider:(se,he)=>(De.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Me,se,he)),registerFileSystemProvider(se,he,Re){return(0,je.combinedDisposable)(mi.registerFileSystemProvider(Me,se,he,Re),Rt.addFileSystemProvider(se,he))},get fs(){return Rt.value},registerFileSearchProvider:(se,he)=>((0,We.checkProposedApiEnabled)(Me,"fileSearchProvider"),It.registerFileSearchProvider(se,he)),registerTextSearchProvider:(se,he)=>((0,We.checkProposedApiEnabled)(Me,"textSearchProvider"),It.registerTextSearchProvider(se,he)),registerRemoteAuthorityResolver:(se,he)=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),Ot.registerRemoteAuthorityResolver(se,he)),registerResourceLabelFormatter:se=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),Pi.$registerResourceLabelFormatter(se)),onDidCreateFiles:(se,he,Re)=>xt.onDidCreateFile(se,he,Re),onDidDeleteFiles:(se,he,Re)=>xt.onDidDeleteFile(se,he,Re),onDidRenameFiles:(se,he,Re)=>xt.onDidRenameFile(se,he,Re),onWillCreateFiles:(se,he,Re)=>xt.getOnWillCreateFileEvent(Me)(se,he,Re),onWillDeleteFiles:(se,he,Re)=>xt.getOnWillDeleteFileEvent(Me)(se,he,Re),onWillRenameFiles:(se,he,Re)=>xt.getOnWillRenameFileEvent(Me)(se,he,Re),openTunnel:se=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),Ct.openTunnel(Me,se).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,We.checkProposedApiEnabled)(Me,"resolvers"),Ct.getTunnels()},onDidChangeTunnels:(se,he,Re)=>((0,We.checkProposedApiEnabled)(Me,"resolvers"),Ct.onDidChangeTunnels(se,he,Re)),registerPortAttributesProvider:(se,he)=>((0,We.checkProposedApiEnabled)(Me,"portsAttributes"),Ct.registerPortsAttributesProvider(se,he)),registerTimelineProvider:(se,he)=>((0,We.checkProposedApiEnabled)(Me,"timeline"),pi.registerTimelineProvider(se,he,Me.identifier,qe.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:se=>((0,We.checkProposedApiEnabled)(Me,"workspaceTrust"),mt.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,he,Re)=>mt.onDidGrantWorkspaceTrust(se,he,Re),registerEditSessionIdentityProvider:(se,he)=>((0,We.checkProposedApiEnabled)(Me,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(se,he))},Ut={get inputBox(){return De.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),si.getLastInputBox(Me)},createSourceControl(se,he,Re){return si.createSourceControl(Me,se,he,Re)}},ui={createCommentController(se,he){return gi.createCommentController(Me,se,he)}},Bi={get activeDebugSession(){return ct.activeDebugSession},get activeDebugConsole(){return ct.activeDebugConsole},get breakpoints(){return ct.breakpoints},onDidStartDebugSession(se,he,Re){return ct.onDidStartDebugSession(se,he,Re)},onDidTerminateDebugSession(se,he,Re){return ct.onDidTerminateDebugSession(se,he,Re)},onDidChangeActiveDebugSession(se,he,Re){return ct.onDidChangeActiveDebugSession(se,he,Re)},onDidReceiveDebugSessionCustomEvent(se,he,Re){return ct.onDidReceiveDebugSessionCustomEvent(se,he,Re)},onDidChangeBreakpoints(se,he,Re){return ct.onDidChangeBreakpoints(se,he,Re)},registerDebugConfigurationProvider(se,he,Re){return ct.registerDebugConfigurationProvider(se,he,Re||it.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,he){return ct.registerDebugAdapterDescriptorFactory(Me,se,he)},registerDebugAdapterTrackerFactory(se,he){return ct.registerDebugAdapterTrackerFactory(se,he)},startDebugging(se,he,Re){return!Re||typeof Re=="object"&&"configuration"in Re?ct.startDebugging(se,he,{parentSession:Re}):ct.startDebugging(se,he,Re||{})},stopDebugging(se){return ct.stopDebugging(se)},addBreakpoints(se){return ct.addBreakpoints(se)},removeBreakpoints(se){return ct.removeBreakpoints(se)},asDebugSourceUri(se,he){return ct.asDebugSourceUri(se,he)}},zi={registerTaskProvider:(se,he)=>Et.registerTaskProvider(Me,se,he),fetchTasks:se=>Et.fetchTasks(se),executeTask:se=>Et.executeTask(Me,se),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(se,he,Re)=>Et.onDidStartTask(se,he,Re),onDidEndTask:(se,he,Re)=>Et.onDidEndTask(se,he,Re),onDidStartTaskProcess:(se,he,Re)=>Et.onDidStartTaskProcess(se,he,Re),onDidEndTaskProcess:(se,he,Re)=>Et.onDidEndTaskProcess(se,he,Re)},xi={createNotebookController(se,he,Re,ot,bt){return zt.createNotebookController(Me,se,he,Re,ot,(0,We.isProposedApiEnabled)(Me,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(se,he)=>vt.registerNotebookCellStatusBarItemProvider(Me,se,he),createRendererMessaging(se){return fi.createRendererMessaging(Me,se)},onDidChangeNotebookCellExecutionState(se,he,Re){return(0,We.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),zt.onDidChangeNotebookCellExecutionState(se,he,Re)}};return{version:st.version,authentication:Ni,commands:Mi,comments:ui,debug:Bi,env:Ci,extensions:Ui,languages:Vt,notebooks:xi,scm:Ut,tasks:zi,tests:Li,window:ci,workspace:Ii,Breakpoint:O.Breakpoint,CallHierarchyIncomingCall:O.CallHierarchyIncomingCall,CallHierarchyItem:O.CallHierarchyItem,CallHierarchyOutgoingCall:O.CallHierarchyOutgoingCall,CancellationError:p.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:O.CodeAction,CodeActionKind:O.CodeActionKind,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.CodeLens,Color:O.Color,ColorInformation:O.ColorInformation,ColorPresentation:O.ColorPresentation,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CommentThreadState:O.CommentThreadState,CompletionItem:O.CompletionItem,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.CompletionList,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.CustomExecution,DebugAdapterExecutable:O.DebugAdapterExecutable,DebugAdapterInlineImplementation:O.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:O.DebugAdapterNamedPipeServer,DebugAdapterServer:O.DebugAdapterServer,DebugConfigurationProviderTriggerKind:it.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.Diagnostic,DiagnosticRelatedInformation:O.DiagnosticRelatedInformation,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.Disposable,DocumentHighlight:O.DocumentHighlight,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.DocumentLink,DocumentSymbol:O.DocumentSymbol,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.EvaluatableExpression,InlineValueText:O.InlineValueText,InlineValueVariableLookup:O.InlineValueVariableLookup,InlineValueEvaluatableExpression:O.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:O.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:O.InlineCompletionTriggerKindNew,EventEmitter:w.Emitter,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.FileDecoration,FileSystemError:O.FileSystemError,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:O.FoldingRange,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.FunctionBreakpoint,InlineCompletionItem:O.InlineSuggestion,InlineCompletionItemNew:O.InlineSuggestionNew,InlineCompletionList:O.InlineSuggestionList,InlineCompletionListNew:O.InlineSuggestionsNew,Hover:O.Hover,IndentAction:P.IndentAction,Location:O.Location,MarkdownString:O.MarkdownString,OverviewRulerLane:b.OverviewRulerLane,ParameterInformation:O.ParameterInformation,PortAutoForwardAction:O.PortAutoForwardAction,Position:O.Position,ProcessExecution:O.ProcessExecution,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.QuickInputButtons,Range:O.Range,RelativePattern:O.RelativePattern,Selection:O.Selection,SelectionRange:O.SelectionRange,SemanticTokens:O.SemanticTokens,SemanticTokensBuilder:O.SemanticTokensBuilder,SemanticTokensEdit:O.SemanticTokensEdit,SemanticTokensEdits:O.SemanticTokensEdits,SemanticTokensLegend:O.SemanticTokensLegend,ShellExecution:O.ShellExecution,ShellQuoting:O.ShellQuoting,SignatureHelp:O.SignatureHelp,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.SignatureInformation,SnippetString:O.SnippetString,SourceBreakpoint:O.SourceBreakpoint,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.SymbolInformation,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.Task,TaskGroup:O.TaskGroup,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TerminalLink:O.TerminalLink,TerminalLocation:O.TerminalLocation,TerminalProfile:O.TerminalProfile,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.TextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,TextDocumentChangeReason:O.TextDocumentChangeReason,ThemeColor:O.ThemeColor,ThemeIcon:O.ThemeIcon,TreeItem:O.TreeItem,TreeItemCollapsibleState:O.TreeItemCollapsibleState,TypeHierarchyItem:O.TypeHierarchyItem,UIKind:k.UIKind,Uri:y.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.WorkspaceEdit,DocumentDropEdit:O.DocumentDropEdit,DocumentPasteEdit:O.DocumentPasteEdit,InlayHint:O.InlayHint,InlayHintLabelPart:O.InlayHintLabelPart,InlayHintKind:O.InlayHintKind,RemoteAuthorityResolverError:O.RemoteAuthorityResolverError,ResolvedAuthority:O.ResolvedAuthority,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.TimelineItem,NotebookRange:O.NotebookRange,NotebookCellKind:O.NotebookCellKind,NotebookCellExecutionState:O.NotebookCellExecutionState,NotebookCellData:O.NotebookCellData,NotebookData:O.NotebookData,NotebookRendererScript:O.NotebookRendererScript,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.NotebookCellOutput,NotebookCellOutputItem:O.NotebookCellOutputItem,NotebookCellStatusBarItem:O.NotebookCellStatusBarItem,NotebookControllerAffinity:O.NotebookControllerAffinity,NotebookEdit:O.NotebookEdit,PortAttributes:O.PortAttributes,LinkedEditingRanges:O.LinkedEditingRanges,TestResultState:O.TestResultState,TestRunRequest:O.TestRunRequest,TestMessage:O.TestMessage,TestTag:O.TestTag,TestRunProfileKind:O.TestRunProfileKind,TextSearchCompleteMessageType:nt.TextSearchCompleteMessageType,DataTransfer:O.DataTransfer,DataTransferItem:O.DataTransferItem,CoveredCount:O.CoveredCount,FileCoverage:O.FileCoverage,StatementCoverage:O.StatementCoverage,BranchCoverage:O.BranchCoverage,FunctionCoverage:O.FunctionCoverage,WorkspaceTrustState:O.WorkspaceTrustState,LanguageStatusSeverity:O.LanguageStatusSeverity,QuickPickItemKind:O.QuickPickItemKind,InputBoxValidationSeverity:O.InputBoxValidationSeverity,TabInputText:O.TextTabInput,TabInputTextDiff:O.TextDiffTabInput,TabInputTextMerge:O.TextMergeTabInput,TabInputCustom:O.CustomEditorTabInput,TabInputNotebook:O.NotebookEditorTabInput,TabInputNotebookDiff:O.NotebookDiffEditorTabInput,TabInputWebview:O.WebviewEditorTabInput,TabInputTerminal:O.TerminalEditorTabInput,TabInputInteractiveWindow:O.InteractiveWindowInput,TerminalExitReason:O.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=dt}),define(Ce[237],Ie([1,0,236,33,2,230,6,14,221,21]),function(ie,e,a,p,w,M,y,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class R extends M.RequireInterceptor{_installInterceptor(){}getModule(f,h){for(const d of this._alternatives){const o=d(f);if(o){f=o;break}}if(this._factories.has(f))return this._factories.get(f).load(f,h,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class S extends p.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=y.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(b.ExtHostConsoleForwarder);const f=this._instaService.invokeFunction(a.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(R,f,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(f){return f.browser}async _loadCommonJSModule(f,h,d){h=h.with({path:m(h.path,".js")});const o=f?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const g=w.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(h)),E=await fetch(g.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),E.status!==200)throw new Error(E.statusText);const l=await E.text(),D=`${h.toString(!0)}#vscode-extension`,i=`${l}
//# sourceURL=${D}`;let u;try{u=new Function("module","exports","require",i)}catch(c){throw console.error(o?`Loading code for extension ${o} failed: ${c.message}`:`Loading code failed: ${c.message}`),console.error(`${h.toString(!0)}${typeof c.line=="number"?` line ${c.line}`:""}${typeof c.column=="number"?` column ${c.column}`:""}`),console.error(c),c}const n=await this.fetchTranslatedStrings(f),r={},s={exports:r},t=c=>{if(c==="vscode-nls-web-data")return n;const _=this._fakeModules.getModule(c,h);if(_===void 0)throw new Error(`Cannot load module '${c}'`);return _};try{return d.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),u(s,r,t),s.exports!==r?s.exports:r}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),d.codeLoadingStop()}}async $setRemoteEnvironment(f){}async _waitForDebuggerAttachment(f=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const h=Date.now()+f;for(;Date.now()<h&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}async fetchTranslatedStrings(f){let h={};if(!f)return{};const d=P.Language.isDefaultVariant()?f.browserNlsBundleUris?.en:f.browserNlsBundleUris?.[P.Language.value()]??f.browserNlsBundleUris?.en;if(f&&d)try{const o=await fetch(d.toString(!0));if(!o.ok)throw new Error(await o.text());h=await o.json()}catch(o){try{console.error(`Failed to load translations for ${f.identifier.value} from ${d}: ${o.message}`);const g=f.browserNlsBundleUris?.en;if(g){const E=await fetch(g.toString(!0));if(!E.ok)throw new Error(await E.text());h=await E.json()}throw new Error("No English strings found")}catch(g){console.error(g)}}return h}}e.ExtHostExtensionService=S;function m(k,f){return k.endsWith(f)?k:k+f}}),define(Ce[238],Ie([1,0,57,33,70,237]),function(ie,e,a,p,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(p.IExtHostExtensionService,M.ExtHostExtensionService,!1),(0,a.registerSingleton)(w.IExtensionStoragePaths,w.ExtensionStoragePaths,!1)}),define(Ce[247],Ie([1,0,23,5,95,231,223,19,71,12,2,233,238]),function(ie,e,a,p,w,M,y,A,b,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function k(i){return/^(file|vscode-remote):/i.test(i)}const f=fetch.bind(self);function h(i){self.fetch=async function(u,n){return u instanceof Request||k(String(u))&&(u=(await i(R.URI.parse(String(u)))).toString(!0)),f(u,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,n,r,s,t){(async()=>(k(n.toString())&&(n=(await i(R.URI.parse(n.toString()))).toString(!0)),super.open(u,n,r??!0,s,t)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(u,n){if(/^file:/i.test(u.toString()))u=P.FileAccess.asBrowserUri(R.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const s=`(${function(v){function T(x){return typeof x=="string"||x instanceof URL?String(x).replace(/^file:\/\//i,"vscode-file://vscode-app"):x}const U=fetch.bind(self);self.fetch=function(x,C){return x instanceof Request?U(x,C):U(T(x),C)},self.XMLHttpRequest=class extends XMLHttpRequest{open(x,C,L,B,F){return super.open(x,T(C),L??!0,B,F)}};const V=importScripts.bind(self);self.importScripts=(...x)=>{V(...x.map(T))},V(v)}.toString()}('${u}'))`;n=n||{},n.name=n.name||A.basename(u.toString());const t=new Blob([s],{type:"application/javascript"}),c=URL.createObjectURL(t);return new i(c,n)}}else self.Worker=class extends y.NestedWorker{constructor(i,u){super(m,i,{name:A.basename(i.toString()),...u})}};const d=new class{constructor(){this.pid=void 0}exit(i){S()}async exists(i){return!0}async realpath(i){return i}};class o{constructor(){const u=new MessageChannel,n=new p.Emitter;let r=!1;m(u.port2,[u.port2]),u.port1.onmessage=s=>{const{data:t}=s;if(!(t instanceof ArrayBuffer)){console.warn("UNKNOWN data received",t);return}const c=a.VSBuffer.wrap(new Uint8Array(t,0,t.byteLength));if((0,w.isMessageOfType)(c,2)){r=!0,E("received terminate message from renderer");return}n.fire(c)},this.protocol={onMessage:n.event,send:s=>{if(!r){const t=s.buffer.buffer.slice(s.buffer.byteOffset,s.buffer.byteOffset+s.buffer.byteLength);u.port1.postMessage(t,[t])}}}}}function g(i){return new Promise(u=>{const n=i.onMessage(r=>{n.dispose();const s=JSON.parse(r.toString());i.send((0,w.createMessageOfType)(0)),u({protocol:i,initData:s})});i.send((0,w.createMessageOfType)(1))})}let E=i=>S();function l(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function D(){b.mark("code/extHost/willConnectToRenderer");const i=new o;return{onmessage(u){!l(u)||g(i.protocol).then(n=>{b.mark("code/extHost/didWaitForInitData");const r=new M.ExtensionHostMain(n.protocol,n.initData,d,null,u.data);h(s=>r.asBrowserUri(s)),E=s=>r.terminate(s)})}}}e.create=D})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d17726fe4beae5abe87ba9e9429cd298be8b53c4/core/vs/workbench/api/worker/extensionHostWorker.js.map
